/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var X=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/base/common/types","vs/nls","vs/base/common/network","electron","vs/platform/files/common/files","vs/base/common/resources","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/errors","vs/platform/product/common/productService","vs/base/common/cancellation","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/platform/workspace/common/workspace","vs/base/common/arrays","vs/platform/environment/electron-main/environmentMainService","vs/base/common/uuid","fs","os","vs/base/common/strings","vs/base/common/extpath","vs/platform/windows/electron-main/windows","vs/base/common/map","vs/base/common/labels","vs/platform/telemetry/common/telemetry","vs/base/common/process","vs/platform/policy/common/policy","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/platform/state/electron-main/state","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/functional","vs/base/common/json","child_process","vs/base/common/decorators","vs/base/common/objects","vs/platform/product/common/product","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/iterator","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/theme/electron-main/themeMainService","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/workspaces/electron-main/workspacesHistoryMainService","crypto","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/base/node/ports","vs/base/common/observableValue","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationModels","vs/platform/shell/node/shellEnv","vs/platform/telemetry/common/commonProperties","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/storage/common/storage","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/codicons","vs/base/common/color","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/skipList","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/backup/electron-main/backupMainService","vs/platform/storage/electron-main/storageIpc","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/electron-main/defaultExtensionsProfileInit","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","path","graceful-fs","string_decoder","vscode-policy-watcher","zlib","vs/code/electron-main/main"],J=function(z){for(var e=[],S=0,t=z.length;S<t;S++)e[S]=X[z[S]];return e};define(X[116],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.ok=void 0;function S(M,R){if(!M)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=S;function t(M,R="Unreachable"){throw new Error(R)}e.assertNever=t}),define(X[117],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function S(D){return D?D.replace(/\$\((.*?)\)/g,(b,h)=>` ${h} `).trim():""}e.getCodiconAriaLabel=S;class t{constructor(b,h,w){this.id=b,this.definition=h,this.description=w,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.terminalDecorationSuccess=new t("terminal-decoration-success",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.terminalDecorationIncomplete=new t("terminal-decoration-incomplete",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.terminalDecorationMark=new t("terminal-decoration-mark",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.terminalDecorationError=new t("terminal-decoration-error",t.errorSmall.definition),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function M(D,b){const h=["codicon","codicon-"+D];return b&&h.push("codicon-modifier-"+b),h}e.getClassNamesArray=M;var R;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function h(C){if(C instanceof t)return["codicon","codicon-"+C.id];const p=b.exec(C.id);if(!p)return h(t.error);const[,g,d]=p,P=["codicon","codicon-"+g];return d&&P.push("codicon-modifier-"+d.substr(1)),P}D.asClassNameArray=h;function w(C){return h(C).join(" ")}D.asClassName=w;function E(C){return"."+h(C).join(".")}D.asCSSSelector=E})(R=e.CSSIcon||(e.CSSIcon={}))}),define(X[118],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function S(b,h){const w=Math.pow(10,h);return Math.round(b*w)/w}class t{constructor(h,w,E,C=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,w))|0,this.b=Math.min(255,Math.max(0,E))|0,this.a=S(Math.max(Math.min(1,C),0),3)}static equals(h,w){return h.r===w.r&&h.g===w.g&&h.b===w.b&&h.a===w.a}}e.RGBA=t;class M{constructor(h,w,E,C){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=S(Math.max(Math.min(1,w),0),3),this.l=S(Math.max(Math.min(1,E),0),3),this.a=S(Math.max(Math.min(1,C),0),3)}static equals(h,w){return h.h===w.h&&h.s===w.s&&h.l===w.l&&h.a===w.a}static fromRGBA(h){const w=h.r/255,E=h.g/255,C=h.b/255,p=h.a,g=Math.max(w,E,C),d=Math.min(w,E,C);let P=0,y=0;const m=(d+g)/2,v=g-d;if(v>0){switch(y=Math.min(m<=.5?v/(2*m):v/(2-2*m),1),g){case w:P=(E-C)/v+(E<C?6:0);break;case E:P=(C-w)/v+2;break;case C:P=(w-E)/v+4;break}P*=60,P=Math.round(P)}return new M(P,y,m,p)}static _hue2rgb(h,w,E){return E<0&&(E+=1),E>1&&(E-=1),E<1/6?h+(w-h)*6*E:E<1/2?w:E<2/3?h+(w-h)*(2/3-E)*6:h}static toRGBA(h){const w=h.h/360,{s:E,l:C,a:p}=h;let g,d,P;if(E===0)g=d=P=C;else{const y=C<.5?C*(1+E):C+E-C*E,m=2*C-y;g=M._hue2rgb(m,y,w+1/3),d=M._hue2rgb(m,y,w),P=M._hue2rgb(m,y,w-1/3)}return new t(Math.round(g*255),Math.round(d*255),Math.round(P*255),p)}}e.HSLA=M;class R{constructor(h,w,E,C){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=S(Math.max(Math.min(1,w),0),3),this.v=S(Math.max(Math.min(1,E),0),3),this.a=S(Math.max(Math.min(1,C),0),3)}static equals(h,w){return h.h===w.h&&h.s===w.s&&h.v===w.v&&h.a===w.a}static fromRGBA(h){const w=h.r/255,E=h.g/255,C=h.b/255,p=Math.max(w,E,C),g=Math.min(w,E,C),d=p-g,P=p===0?0:d/p;let y;return d===0?y=0:p===w?y=((E-C)/d%6+6)%6:p===E?y=(C-w)/d+2:y=(w-E)/d+4,new R(Math.round(y*60),P,p,h.a)}static toRGBA(h){const{h:w,s:E,v:C,a:p}=h,g=C*E,d=g*(1-Math.abs(w/60%2-1)),P=C-g;let[y,m,v]=[0,0,0];return w<60?(y=g,m=d):w<120?(y=d,m=g):w<180?(m=g,v=d):w<240?(m=d,v=g):w<300?(y=d,v=g):w<=360&&(y=g,v=d),y=Math.round((y+P)*255),m=Math.round((m+P)*255),v=Math.round((v+P)*255),new t(y,m,v,p)}}e.HSVA=R;class D{constructor(h){if(h)if(h instanceof t)this.rgba=h;else if(h instanceof M)this._hsla=h,this.rgba=M.toRGBA(h);else if(h instanceof R)this._hsva=h,this.rgba=R.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}static fromHex(h){return D.Format.CSS.parseHex(h)||D.red}get hsla(){return this._hsla?this._hsla:M.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:R.fromRGBA(this.rgba)}equals(h){return!!h&&t.equals(this.rgba,h.rgba)&&M.equals(this.hsla,h.hsla)&&R.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=D._relativeLuminanceForComponent(this.rgba.r),w=D._relativeLuminanceForComponent(this.rgba.g),E=D._relativeLuminanceForComponent(this.rgba.b),C=.2126*h+.7152*w+.0722*E;return S(C,4)}static _relativeLuminanceForComponent(h){const w=h/255;return w<=.03928?w/12.92:Math.pow((w+.055)/1.055,2.4)}getContrastRatio(h){const w=this.getRelativeLuminance(),E=h.getRelativeLuminance();return w>E?(w+.05)/(E+.05):(E+.05)/(w+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const w=this.getRelativeLuminance(),E=h.getRelativeLuminance();return w>E}isDarkerThan(h){const w=this.getRelativeLuminance(),E=h.getRelativeLuminance();return w<E}lighten(h){return new D(new M(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new D(new M(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:w,g:E,b:C,a:p}=this.rgba;return new D(new t(w,E,C,p*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new t(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(h){const w=h.rgba,E=this.rgba.a,C=w.a,p=E+C*(1-E);if(p<1e-6)return D.transparent;const g=this.rgba.r*E/p+w.r*C*(1-E)/p,d=this.rgba.g*E/p+w.g*C*(1-E)/p,P=this.rgba.b*E/p+w.b*C*(1-E)/p;return new D(new t(g,d,P,p))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:w,g:E,b:C,a:p}=this.rgba;return new D(new t(h.rgba.r-p*(h.rgba.r-w),h.rgba.g-p*(h.rgba.g-E),h.rgba.b-p*(h.rgba.b-C),1))}flatten(...h){const w=h.reduceRight((E,C)=>D._flatten(C,E));return D._flatten(this,w)}static _flatten(h,w){const E=1-h.rgba.a;return new D(new t(E*w.rgba.r+h.rgba.a*h.rgba.r,E*w.rgba.g+h.rgba.a*h.rgba.g,E*w.rgba.b+h.rgba.a*h.rgba.b))}toString(){return this._toString||(this._toString=D.Format.CSS.format(this)),this._toString}static getLighterColor(h,w,E){if(h.isLighterThan(w))return h;E=E||.5;const C=h.getRelativeLuminance(),p=w.getRelativeLuminance();return E=E*(p-C)/p,h.lighten(E)}static getDarkerColor(h,w,E){if(h.isDarkerThan(w))return h;E=E||.5;const C=h.getRelativeLuminance(),p=w.getRelativeLuminance();return E=E*(C-p)/C,h.darken(E)}}e.Color=D,D.white=new D(new t(255,255,255,1)),D.black=new D(new t(0,0,0,1)),D.red=new D(new t(255,0,0,1)),D.blue=new D(new t(0,0,255,1)),D.green=new D(new t(0,255,0,1)),D.cyan=new D(new t(0,255,255,1)),D.lightgrey=new D(new t(211,211,211,1)),D.transparent=new D(new t(0,0,0,0)),function(b){let h;(function(w){let E;(function(C){function p(o){return o.rgba.a===1?`rgb(${o.rgba.r}, ${o.rgba.g}, ${o.rgba.b})`:b.Format.CSS.formatRGBA(o)}C.formatRGB=p;function g(o){return`rgba(${o.rgba.r}, ${o.rgba.g}, ${o.rgba.b}, ${+o.rgba.a.toFixed(2)})`}C.formatRGBA=g;function d(o){return o.hsla.a===1?`hsl(${o.hsla.h}, ${(o.hsla.s*100).toFixed(2)}%, ${(o.hsla.l*100).toFixed(2)}%)`:b.Format.CSS.formatHSLA(o)}C.formatHSL=d;function P(o){return`hsla(${o.hsla.h}, ${(o.hsla.s*100).toFixed(2)}%, ${(o.hsla.l*100).toFixed(2)}%, ${o.hsla.a.toFixed(2)})`}C.formatHSLA=P;function y(o){const r=o.toString(16);return r.length!==2?"0"+r:r}function m(o){return`#${y(o.rgba.r)}${y(o.rgba.g)}${y(o.rgba.b)}`}C.formatHex=m;function v(o,r=!1){return r&&o.rgba.a===1?b.Format.CSS.formatHex(o):`#${y(o.rgba.r)}${y(o.rgba.g)}${y(o.rgba.b)}${y(Math.round(o.rgba.a*255))}`}C.formatHexA=v;function f(o){return o.isOpaque()?b.Format.CSS.formatHex(o):b.Format.CSS.formatRGBA(o)}C.format=f;function u(o){const r=o.length;if(r===0||o.charCodeAt(0)!==35)return null;if(r===7){const i=16*c(o.charCodeAt(1))+c(o.charCodeAt(2)),n=16*c(o.charCodeAt(3))+c(o.charCodeAt(4)),s=16*c(o.charCodeAt(5))+c(o.charCodeAt(6));return new b(new t(i,n,s,1))}if(r===9){const i=16*c(o.charCodeAt(1))+c(o.charCodeAt(2)),n=16*c(o.charCodeAt(3))+c(o.charCodeAt(4)),s=16*c(o.charCodeAt(5))+c(o.charCodeAt(6)),a=16*c(o.charCodeAt(7))+c(o.charCodeAt(8));return new b(new t(i,n,s,a/255))}if(r===4){const i=c(o.charCodeAt(1)),n=c(o.charCodeAt(2)),s=c(o.charCodeAt(3));return new b(new t(16*i+i,16*n+n,16*s+s))}if(r===5){const i=c(o.charCodeAt(1)),n=c(o.charCodeAt(2)),s=c(o.charCodeAt(3)),a=c(o.charCodeAt(4));return new b(new t(16*i+i,16*n+n,16*s+s,(16*a+a)/255))}return null}C.parseHex=u;function c(o){switch(o){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(E=w.CSS||(w.CSS={}))})(h=b.Format||(b.Format={}))}(D=e.Color||(e.Color={}))}),define(X[50],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function S(D){return(b,h,w)=>{let E=null,C=null;if(typeof w.value=="function"?(E="value",C=w.value):typeof w.get=="function"&&(E="get",C=w.get),!C)throw new Error("not supported");w[E]=D(C,h)}}e.createDecorator=S;function t(D,b,h){let w=null,E=null;if(typeof h.value=="function"?(w="value",E=h.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(w="get",E=h.get),!E)throw new Error("not supported");const C=`$memoize$${b}`;h[w]=function(...p){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:E.apply(this,p)}),this[C]}}e.memoize=t;function M(D,b,h){return S((w,E)=>{const C=`$debounce$${E}`,p=`$debounce$result$${E}`;return function(...g){this[p]||(this[p]=h?h():void 0),clearTimeout(this[C]),b&&(this[p]=b(this[p],...g),g=[this[p]]),this[C]=setTimeout(()=>{w.apply(this,g),this[p]=h?h():void 0},D)}})}e.debounce=M;function R(D,b,h){return S((w,E)=>{const C=`$throttle$timer$${E}`,p=`$throttle$result$${E}`,g=`$throttle$lastRun$${E}`,d=`$throttle$pending$${E}`;return function(...P){if(this[p]||(this[p]=h?h():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),b&&(this[p]=b(this[p],...P)),this[d])return;const y=this[g]+D;y<=Date.now()?(this[g]=Date.now(),w.apply(this,[this[p]]),this[p]=h?h():void 0):(this[d]=!0,this[C]=setTimeout(()=>{this[d]=!1,this[g]=Date.now(),w.apply(this,[this[p]]),this[p]=h?h():void 0},y-Date.now()))}})}e.throttle=R}),define(X[19],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class S{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(o){setTimeout(()=>{throw o.stack?f.isErrorNoTelemetry(o)?new f(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.listeners.push(o),()=>{this._removeListener(o)}}emit(o){this.listeners.forEach(r=>{r(o)})}_removeListener(o){this.listeners.splice(this.listeners.indexOf(o),1)}setUnexpectedErrorHandler(o){this.unexpectedErrorHandler=o}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(o){this.unexpectedErrorHandler(o),this.emit(o)}onUnexpectedExternalError(o){this.unexpectedErrorHandler(o)}}e.ErrorHandler=S,e.errorHandler=new S;function t(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=t;function M(c){h(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=M;function R(c){h(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=R;function D(c){if(c instanceof Error){const{name:o,message:r}=c,i=c.stacktrace||c.stack;return{$isError:!0,name:o,message:r,stack:i,noTelemetry:f.isErrorNoTelemetry(c)}}return c}e.transformErrorForSerialization=D;const b="Canceled";function h(c){return c instanceof w?!0:c instanceof Error&&c.name===b&&c.message===b}e.isCancellationError=h;class w extends Error{constructor(){super(b);this.name=this.message}}e.CancellationError=w;function E(){const c=new Error(b);return c.name=c.message,c}e.canceled=E;function C(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=C;function p(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=p;function g(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=g;function d(c){const o=new Error(`${c} has been disposed`);return o.name="DISPOSED",o}e.disposed=d;function P(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=P;class y extends Error{constructor(o){super("NotImplemented");o&&(this.message=o)}}e.NotImplementedError=y;class m extends Error{constructor(o){super("NotSupported");o&&(this.message=o)}}e.NotSupportedError=m;class v extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=v;class f extends Error{constructor(o){super(o);this.name="ErrorNoTelemetry"}static fromError(o){if(o instanceof f)return o;const r=new f;return r.message=o.message,r.stack=o.stack,r}static isErrorNoTelemetry(o){return o.name==="ErrorNoTelemetry"}}e.ErrorNoTelemetry=f;class u extends Error{constructor(o){super(o||"An unexpected bug occurred.");Object.setPrototypeOf(this,u.prototype);debugger}}e.BugIndicatingError=u}),define(X[25],J([0,1,19]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(U,Y=0){return U[U.length-(1+Y)]}e.tail=t;function M(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}e.tail2=M;function R(U,Y,x=(re,ce)=>re===ce){if(U===Y)return!0;if(!U||!Y||U.length!==Y.length)return!1;for(let re=0,ce=U.length;re<ce;re++)if(!x(U[re],Y[re]))return!1;return!0}e.equals=R;function D(U,Y){const x=U.length-1;Y<x&&(U[Y]=U[x]),U.pop()}e.removeFastWithoutKeepingOrder=D;function b(U,Y,x){return h(U.length,re=>x(U[re],Y))}e.binarySearch=b;function h(U,Y){let x=0,re=U-1;for(;x<=re;){const ce=(x+re)/2|0,Ee=Y(ce);if(Ee<0)x=ce+1;else if(Ee>0)re=ce-1;else return ce}return-(x+1)}e.binarySearch2=h;function w(U,Y){let x=0,re=U.length;if(re===0)return 0;for(;x<re;){const ce=Math.floor((x+re)/2);Y(U[ce])?re=ce:x=ce+1}return x}e.findFirstInSorted=w;function E(U,Y,x){if(U=U|0,U>=Y.length)throw new TypeError("invalid index");const re=Y[Math.floor(Y.length*Math.random())],ce=[],Ee=[],Ce=[];for(const Pe of Y){const Me=x(Pe,re);Me<0?ce.push(Pe):Me>0?Ee.push(Pe):Ce.push(Pe)}return U<ce.length?E(U,ce,x):U<ce.length+Ce.length?Ce[0]:E(U-(ce.length+Ce.length),Ee,x)}e.quickSelect=E;function C(U,Y){const x=[];let re;for(const ce of U.slice(0).sort(Y))!re||Y(re[0],ce)!==0?(re=[ce],x.push(re)):re.push(ce);return x}e.groupBy=C;function p(U,Y,x){const re=[];function ce(Pe,Me,Be){if(Me===0&&Be.length===0)return;const de=re[re.length-1];de&&de.start+de.deleteCount===Pe?(de.deleteCount+=Me,de.toInsert.push(...Be)):re.push({start:Pe,deleteCount:Me,toInsert:Be})}let Ee=0,Ce=0;for(;;){if(Ee===U.length){ce(Ee,0,Y.slice(Ce));break}if(Ce===Y.length){ce(Ee,U.length-Ee,[]);break}const Pe=U[Ee],Me=Y[Ce],Be=x(Pe,Me);Be===0?(Ee+=1,Ce+=1):Be<0?(ce(Ee,1,[]),Ee+=1):Be>0&&(ce(Ee,0,[Me]),Ce+=1)}return re}e.sortedDiff=p;function g(U,Y,x){const re=p(U,Y,x),ce=[],Ee=[];for(const Ce of re)ce.push(...U.slice(Ce.start,Ce.start+Ce.deleteCount)),Ee.push(...Ce.toInsert);return{removed:ce,added:Ee}}e.delta=g;function d(U,Y,x){if(x===0)return[];const re=U.slice(0,x).sort(Y);return y(U,Y,re,x,U.length),re}e.top=d;function P(U,Y,x,re,ce){return x===0?Promise.resolve([]):new Promise((Ee,Ce)=>{(async()=>{const Pe=U.length,Me=U.slice(0,x).sort(Y);for(let Be=x,de=Math.min(x+re,Pe);Be<Pe;Be=de,de=Math.min(de+re,Pe)){if(Be>x&&await new Promise(fe=>setTimeout(fe)),ce&&ce.isCancellationRequested)throw new S.CancellationError;y(U,Y,Me,Be,de)}return Me})().then(Ee,Ce)})}e.topAsync=P;function y(U,Y,x,re,ce){for(const Ee=x.length;re<ce;re++){const Ce=U[re];if(Y(Ce,x[Ee-1])<0){x.pop();const Pe=w(x,Me=>Y(Ce,Me)<0);x.splice(Pe,0,Ce)}}}function m(U){return U.filter(Y=>!!Y)}e.coalesce=m;function v(U){let Y=0;for(let x=0;x<U.length;x++)U[x]&&(U[Y]=U[x],Y+=1);U.length=Y}e.coalesceInPlace=v;function f(U,Y,x){U.splice(x,0,U.splice(Y,1)[0])}e.move=f;function u(U){return!Array.isArray(U)||U.length===0}e.isFalsyOrEmpty=u;function c(U){return Array.isArray(U)&&U.length>0}e.isNonEmptyArray=c;function o(U,Y=x=>x){const x=new Set;return U.filter(re=>{const ce=Y(re);return x.has(ce)?!1:(x.add(ce),!0)})}e.distinct=o;function r(U){const Y=new Set;return x=>{const re=U(x);return Y.has(re)?!1:(Y.add(re),!0)}}e.uniqueFilter=r;function i(U,Y){const x=n(U,Y);if(x!==-1)return U[x]}e.findLast=i;function n(U,Y){for(let x=U.length-1;x>=0;x--){const re=U[x];if(Y(re))return x}return-1}e.lastIndex=n;function s(U,Y){return U.length>0?U[0]:Y}e.firstOrDefault=s;function a(U,Y){return U.length>0?U[U.length-1]:Y}e.lastOrDefault=a;function l(U,Y,x=(re,ce)=>re===ce){let re=0;for(let ce=0,Ee=Math.min(U.length,Y.length);ce<Ee&&x(U[ce],Y[ce]);ce++)re++;return re}e.commonPrefixLength=l;function I(U){return[].concat(...U)}e.flatten=I;function k(U,Y){let x=typeof Y=="number"?U:0;typeof Y=="number"?x=U:(x=0,Y=U);const re=[];if(x<=Y)for(let ce=x;ce<Y;ce++)re.push(ce);else for(let ce=x;ce>Y;ce--)re.push(ce);return re}e.range=k;function A(U,Y,x){return U.reduce((re,ce)=>(re[Y(ce)]=x?x(ce):ce,re),Object.create(null))}e.index=A;function W(U,Y){return U.push(Y),()=>F(U,Y)}e.insert=W;function F(U,Y){const x=U.indexOf(Y);if(x>-1)return U.splice(x,1),Y}e.remove=F;function K(U,Y,x){const re=U.slice(0,Y),ce=U.slice(Y);return re.concat(x,ce)}e.arrayInsert=K;function ie(U,Y){let x;if(typeof Y=="number"){let re=Y;x=()=>{const ce=Math.sin(re++)*179426549;return ce-Math.floor(ce)}}else x=Math.random;for(let re=U.length-1;re>0;re-=1){const ce=Math.floor(x()*(re+1)),Ee=U[re];U[re]=U[ce],U[ce]=Ee}}e.shuffle=ie;function oe(U,Y){const x=U.indexOf(Y);x>-1&&(U.splice(x,1),U.unshift(Y))}e.pushToStart=oe;function ue(U,Y){const x=U.indexOf(Y);x>-1&&(U.splice(x,1),U.push(Y))}e.pushToEnd=ue;function ne(U,Y){for(const x of Y)U.push(x)}e.pushMany=ne;function ae(U,Y){return Array.isArray(U)?U.map(Y):Y(U)}e.mapArrayOrNot=ae;function le(U){return Array.isArray(U)?U:[U]}e.asArray=le;function G(U){return U[Math.floor(Math.random()*U.length)]}e.getRandomElement=G;function B(U,Y){for(const x of U){const re=Y(x);if(re!==void 0)return re}}e.mapFind=B;function N(U,Y,x){const re=H(U,Y),ce=U.length,Ee=x.length;U.length=ce+Ee;for(let Ce=ce-1;Ce>=re;Ce--)U[Ce+Ee]=U[Ce];for(let Ce=0;Ce<Ee;Ce++)U[Ce+re]=x[Ce]}e.insertInto=N;function O(U,Y,x,re){const ce=H(U,Y),Ee=U.splice(ce,x);return N(U,ce,re),Ee}e.splice=O;function H(U,Y){return Y<0?Math.max(Y+U.length,0):Math.min(Y,U.length)}var Z;(function(U){function Y(ce){return ce<0}U.isLessThan=Y;function x(ce){return ce>0}U.isGreaterThan=x;function re(ce){return ce===0}U.isNeitherLessOrGreaterThan=re,U.greaterThan=1,U.lessThan=-1,U.neitherLessOrGreaterThan=0})(Z=e.CompareResult||(e.CompareResult={}));function $(U,Y){return(x,re)=>Y(U(x),U(re))}e.compareBy=$;function j(...U){return(Y,x)=>{for(const re of U){const ce=re(Y,x);if(!Z.isNeitherLessOrGreaterThan(ce))return ce}return Z.neitherLessOrGreaterThan}}e.tieBreakComparators=j;const L=(U,Y)=>U-Y;e.numberComparator=L;function T(U,Y){if(U.length===0)return;let x=U[0];for(let re=1;re<U.length;re++){const ce=U[re];Y(ce,x)>0&&(x=ce)}return x}e.findMaxBy=T;function _(U,Y){if(U.length===0)return;let x=U[0];for(let re=1;re<U.length;re++){const ce=U[re];Y(ce,x)>=0&&(x=ce)}return x}e.findLastMaxBy=_;function q(U,Y){return T(U,(x,re)=>-Y(x,re))}e.findMinBy=q;class Q{constructor(Y){this.items=Y,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(Y){let x=this.firstIdx;for(;x<this.items.length&&Y(this.items[x]);)x++;const re=x===this.firstIdx?null:this.items.slice(this.firstIdx,x);return this.firstIdx=x,re}takeFromEndWhile(Y){let x=this.lastIdx;for(;x>=0&&Y(this.items[x]);)x--;const re=x===this.lastIdx?null:this.items.slice(x+1,this.lastIdx+1);return this.lastIdx=x,re}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const Y=this.items[this.firstIdx];return this.firstIdx++,Y}removeLast(){const Y=this.items[this.lastIdx];return this.lastIdx--,Y}takeCount(Y){const x=this.items.slice(this.firstIdx,this.firstIdx+Y);return this.firstIdx+=Y,x}}e.ArrayQueue=Q;class te{constructor(Y){this.iterate=Y}forEach(Y){this.iterate(x=>(Y(x),!0))}toArray(){const Y=[];return this.iterate(x=>(Y.push(x),!0)),Y}filter(Y){return new te(x=>this.iterate(re=>Y(re)?x(re):!0))}map(Y){return new te(x=>this.iterate(re=>x(Y(re))))}some(Y){let x=!1;return this.iterate(re=>(x=Y(re),!x)),x}findFirst(Y){let x;return this.iterate(re=>Y(re)?(x=re,!1):!0),x}findLast(Y){let x;return this.iterate(re=>(Y(re)&&(x=re),!0)),x}findLastMaxBy(Y){let x,re=!0;return this.iterate(ce=>((re||Z.isGreaterThan(Y(ce,x)))&&(re=!1,x=ce),!0)),x}}e.CallbackIterable=te,te.empty=new te(U=>{})}),define(X[47],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function S(t){const M=this;let R=!1,D;return function(){return R||(R=!0,D=t.apply(M,arguments)),D}}e.once=S}),define(X[55],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var S;(function(t){function M(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}t.is=M;const R=Object.freeze([]);function D(){return R}t.empty=D;function*b(r){yield r}t.single=b;function h(r){return r||R}t.from=h;function w(r){return!r||r[Symbol.iterator]().next().done===!0}t.isEmpty=w;function E(r){return r[Symbol.iterator]().next().value}t.first=E;function C(r,i){for(const n of r)if(i(n))return!0;return!1}t.some=C;function p(r,i){for(const n of r)if(i(n))return n}t.find=p;function*g(r,i){for(const n of r)i(n)&&(yield n)}t.filter=g;function*d(r,i){let n=0;for(const s of r)yield i(s,n++)}t.map=d;function*P(...r){for(const i of r)for(const n of i)yield n}t.concat=P;function*y(r){for(const i of r)for(const n of i)yield n}t.concatNested=y;function m(r,i,n){let s=n;for(const a of r)s=i(s,a);return s}t.reduce=m;function v(r,i){let n=0;for(const s of r)i(s,n++)}t.forEach=v;function*f(r,i,n=r.length){for(i<0&&(i+=r.length),n<0?n+=r.length:n>r.length&&(n=r.length);i<n;i++)yield r[i]}t.slice=f;function u(r,i=Number.POSITIVE_INFINITY){const n=[];if(i===0)return[n,r];const s=r[Symbol.iterator]();for(let a=0;a<i;a++){const l=s.next();if(l.done)return[n,t.empty()];n.push(l.value)}return[n,{[Symbol.iterator](){return s}}]}t.consume=u;function c(r){return u(r)[0]}t.collect=c;function o(r,i,n=(s,a)=>s===a){const s=r[Symbol.iterator](),a=i[Symbol.iterator]();for(;;){const l=s.next(),I=a.next();if(l.done!==I.done)return!1;if(l.done)return!0;if(!n(l.value,I.value))return!1}}t.equals=o})(S=e.Iterable||(e.Iterable={}))}),define(X[48],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(o){o[o.None=0]="None",o[o.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=2]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",o[o.InvalidUnicode=4]="InvalidUnicode",o[o.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",o[o.InvalidCharacter=6]="InvalidCharacter"})(S=e.ScanError||(e.ScanError={}));var t;(function(o){o[o.OpenBraceToken=1]="OpenBraceToken",o[o.CloseBraceToken=2]="CloseBraceToken",o[o.OpenBracketToken=3]="OpenBracketToken",o[o.CloseBracketToken=4]="CloseBracketToken",o[o.CommaToken=5]="CommaToken",o[o.ColonToken=6]="ColonToken",o[o.NullKeyword=7]="NullKeyword",o[o.TrueKeyword=8]="TrueKeyword",o[o.FalseKeyword=9]="FalseKeyword",o[o.StringLiteral=10]="StringLiteral",o[o.NumericLiteral=11]="NumericLiteral",o[o.LineCommentTrivia=12]="LineCommentTrivia",o[o.BlockCommentTrivia=13]="BlockCommentTrivia",o[o.LineBreakTrivia=14]="LineBreakTrivia",o[o.Trivia=15]="Trivia",o[o.Unknown=16]="Unknown",o[o.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var M;(function(o){o[o.InvalidSymbol=1]="InvalidSymbol",o[o.InvalidNumberFormat=2]="InvalidNumberFormat",o[o.PropertyNameExpected=3]="PropertyNameExpected",o[o.ValueExpected=4]="ValueExpected",o[o.ColonExpected=5]="ColonExpected",o[o.CommaExpected=6]="CommaExpected",o[o.CloseBraceExpected=7]="CloseBraceExpected",o[o.CloseBracketExpected=8]="CloseBracketExpected",o[o.EndOfFileExpected=9]="EndOfFileExpected",o[o.InvalidCommentToken=10]="InvalidCommentToken",o[o.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=12]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",o[o.InvalidUnicode=14]="InvalidUnicode",o[o.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",o[o.InvalidCharacter=16]="InvalidCharacter"})(M=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(o){o.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function D(o,r=!1){let i=0;const n=o.length;let s="",a=0,l=16,I=0;function k(ue){let ne=0,ae=0;for(;ne<ue;){const le=o.charCodeAt(i);if(le>=48&&le<=57)ae=ae*16+le-48;else if(le>=65&&le<=70)ae=ae*16+le-65+10;else if(le>=97&&le<=102)ae=ae*16+le-97+10;else break;i++,ne++}return ne<ue&&(ae=-1),ae}function A(ue){i=ue,s="",a=0,l=16,I=0}function W(){const ue=i;if(o.charCodeAt(i)===48)i++;else for(i++;i<o.length&&w(o.charCodeAt(i));)i++;if(i<o.length&&o.charCodeAt(i)===46)if(i++,i<o.length&&w(o.charCodeAt(i)))for(i++;i<o.length&&w(o.charCodeAt(i));)i++;else return I=3,o.substring(ue,i);let ne=i;if(i<o.length&&(o.charCodeAt(i)===69||o.charCodeAt(i)===101))if(i++,(i<o.length&&o.charCodeAt(i)===43||o.charCodeAt(i)===45)&&i++,i<o.length&&w(o.charCodeAt(i))){for(i++;i<o.length&&w(o.charCodeAt(i));)i++;ne=i}else I=3;return o.substring(ue,ne)}function F(){let ue="",ne=i;for(;;){if(i>=n){ue+=o.substring(ne,i),I=2;break}const ae=o.charCodeAt(i);if(ae===34){ue+=o.substring(ne,i),i++;break}if(ae===92){if(ue+=o.substring(ne,i),i++,i>=n){I=2;break}switch(o.charCodeAt(i++)){case 34:ue+='"';break;case 92:ue+="\\";break;case 47:ue+="/";break;case 98:ue+="\b";break;case 102:ue+="\f";break;case 110:ue+=`
`;break;case 114:ue+="\r";break;case 116:ue+="	";break;case 117:{const G=k(4);G>=0?ue+=String.fromCharCode(G):I=4;break}default:I=5}ne=i;continue}if(ae>=0&&ae<=31)if(h(ae)){ue+=o.substring(ne,i),I=2;break}else I=6;i++}return ue}function K(){if(s="",I=0,a=i,i>=n)return a=n,l=17;let ue=o.charCodeAt(i);if(b(ue)){do i++,s+=String.fromCharCode(ue),ue=o.charCodeAt(i);while(b(ue));return l=15}if(h(ue))return i++,s+=String.fromCharCode(ue),ue===13&&o.charCodeAt(i)===10&&(i++,s+=`
`),l=14;switch(ue){case 123:return i++,l=1;case 125:return i++,l=2;case 91:return i++,l=3;case 93:return i++,l=4;case 58:return i++,l=6;case 44:return i++,l=5;case 34:return i++,s=F(),l=10;case 47:{const ne=i-1;if(o.charCodeAt(i+1)===47){for(i+=2;i<n&&!h(o.charCodeAt(i));)i++;return s=o.substring(ne,i),l=12}if(o.charCodeAt(i+1)===42){i+=2;const ae=n-1;let le=!1;for(;i<ae;){if(o.charCodeAt(i)===42&&o.charCodeAt(i+1)===47){i+=2,le=!0;break}i++}return le||(i++,I=1),s=o.substring(ne,i),l=13}return s+=String.fromCharCode(ue),i++,l=16}case 45:if(s+=String.fromCharCode(ue),i++,i===n||!w(o.charCodeAt(i)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=W(),l=11;default:for(;i<n&&ie(ue);)i++,ue=o.charCodeAt(i);if(a!==i){switch(s=o.substring(a,i),s){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return s+=String.fromCharCode(ue),i++,l=16}}function ie(ue){if(b(ue)||h(ue))return!1;switch(ue){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let ue;do ue=K();while(ue>=12&&ue<=15);return ue}return{setPosition:A,getPosition:()=>i,scan:r?oe:K,getToken:()=>l,getTokenValue:()=>s,getTokenOffset:()=>a,getTokenLength:()=>i-a,getTokenError:()=>I}}e.createScanner=D;function b(o){return o===32||o===9||o===11||o===12||o===160||o===5760||o>=8192&&o<=8203||o===8239||o===8287||o===12288||o===65279}function h(o){return o===10||o===13||o===8232||o===8233}function w(o){return o>=48&&o<=57}var E;(function(o){o[o.nullCharacter=0]="nullCharacter",o[o.maxAsciiCharacter=127]="maxAsciiCharacter",o[o.lineFeed=10]="lineFeed",o[o.carriageReturn=13]="carriageReturn",o[o.lineSeparator=8232]="lineSeparator",o[o.paragraphSeparator=8233]="paragraphSeparator",o[o.nextLine=133]="nextLine",o[o.space=32]="space",o[o.nonBreakingSpace=160]="nonBreakingSpace",o[o.enQuad=8192]="enQuad",o[o.emQuad=8193]="emQuad",o[o.enSpace=8194]="enSpace",o[o.emSpace=8195]="emSpace",o[o.threePerEmSpace=8196]="threePerEmSpace",o[o.fourPerEmSpace=8197]="fourPerEmSpace",o[o.sixPerEmSpace=8198]="sixPerEmSpace",o[o.figureSpace=8199]="figureSpace",o[o.punctuationSpace=8200]="punctuationSpace",o[o.thinSpace=8201]="thinSpace",o[o.hairSpace=8202]="hairSpace",o[o.zeroWidthSpace=8203]="zeroWidthSpace",o[o.narrowNoBreakSpace=8239]="narrowNoBreakSpace",o[o.ideographicSpace=12288]="ideographicSpace",o[o.mathematicalSpace=8287]="mathematicalSpace",o[o.ogham=5760]="ogham",o[o._=95]="_",o[o.$=36]="$",o[o._0=48]="_0",o[o._1=49]="_1",o[o._2=50]="_2",o[o._3=51]="_3",o[o._4=52]="_4",o[o._5=53]="_5",o[o._6=54]="_6",o[o._7=55]="_7",o[o._8=56]="_8",o[o._9=57]="_9",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.ampersand=38]="ampersand",o[o.asterisk=42]="asterisk",o[o.at=64]="at",o[o.backslash=92]="backslash",o[o.bar=124]="bar",o[o.caret=94]="caret",o[o.closeBrace=125]="closeBrace",o[o.closeBracket=93]="closeBracket",o[o.closeParen=41]="closeParen",o[o.colon=58]="colon",o[o.comma=44]="comma",o[o.dot=46]="dot",o[o.doubleQuote=34]="doubleQuote",o[o.equals=61]="equals",o[o.exclamation=33]="exclamation",o[o.greaterThan=62]="greaterThan",o[o.lessThan=60]="lessThan",o[o.minus=45]="minus",o[o.openBrace=123]="openBrace",o[o.openBracket=91]="openBracket",o[o.openParen=40]="openParen",o[o.percent=37]="percent",o[o.plus=43]="plus",o[o.question=63]="question",o[o.semicolon=59]="semicolon",o[o.singleQuote=39]="singleQuote",o[o.slash=47]="slash",o[o.tilde=126]="tilde",o[o.backspace=8]="backspace",o[o.formFeed=12]="formFeed",o[o.byteOrderMark=65279]="byteOrderMark",o[o.tab=9]="tab",o[o.verticalTab=11]="verticalTab"})(E||(E={}));function C(o,r){const i=[],n=new Object;let s;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function I(k,A,W,F){a.value=k,a.offset=A,a.length=W,a.type=F,a.colonOffset=void 0,s=a}try{f(o,{onObjectBegin:(k,A)=>{if(r<=k)throw n;s=void 0,l=r>k,i.push("")},onObjectProperty:(k,A,W)=>{if(r<A||(I(k,A,W,"property"),i[i.length-1]=k,r<=A+W))throw n},onObjectEnd:(k,A)=>{if(r<=k)throw n;s=void 0,i.pop()},onArrayBegin:(k,A)=>{if(r<=k)throw n;s=void 0,i.push(0)},onArrayEnd:(k,A)=>{if(r<=k)throw n;s=void 0,i.pop()},onLiteralValue:(k,A,W)=>{if(r<A||(I(k,A,W,c(k)),r<=A+W))throw n},onSeparator:(k,A,W)=>{if(r<=A)throw n;if(k===":"&&s&&s.type==="property")s.colonOffset=A,l=!1,s=void 0;else if(k===","){const F=i[i.length-1];typeof F=="number"?i[i.length-1]=F+1:(l=!0,i[i.length-1]=""),s=void 0}}})}catch(k){if(k!==n)throw k}return{path:i,previousNode:s,isAtPropertyKey:l,matches:k=>{let A=0;for(let W=0;A<k.length&&W<i.length;W++)if(k[A]===i[W]||k[A]==="*")A++;else if(k[A]!=="**")return!1;return A===k.length}}}e.getLocation=C;function p(o,r=[],i=R.DEFAULT){let n=null,s=[];const a=[];function l(k){Array.isArray(s)?s.push(k):n!==null&&(s[n]=k)}return f(o,{onObjectBegin:()=>{const k={};l(k),a.push(s),s=k,n=null},onObjectProperty:k=>{n=k},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const k=[];l(k),a.push(s),s=k,n=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:l,onError:(k,A,W)=>{r.push({error:k,offset:A,length:W})}},i),s[0]}e.parse=p;function g(o,r=[],i=R.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(k){n.type==="property"&&(n.length=k-n.offset,n=n.parent)}function a(k){return n.children.push(k),k}f(o,{onObjectBegin:k=>{n=a({type:"object",offset:k,length:-1,parent:n,children:[]})},onObjectProperty:(k,A,W)=>{n=a({type:"property",offset:A,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:k,offset:A,length:W,parent:n})},onObjectEnd:(k,A)=>{n.length=k+A-n.offset,n=n.parent,s(k+A)},onArrayBegin:(k,A)=>{n=a({type:"array",offset:k,length:-1,parent:n,children:[]})},onArrayEnd:(k,A)=>{n.length=k+A-n.offset,n=n.parent,s(k+A)},onLiteralValue:(k,A,W)=>{a({type:c(k),offset:A,length:W,parent:n,value:k}),s(A+W)},onSeparator:(k,A,W)=>{n.type==="property"&&(k===":"?n.colonOffset=A:k===","&&s(A))},onError:(k,A,W)=>{r.push({error:k,offset:A,length:W})}},i);const I=n.children[0];return I&&delete I.parent,I}e.parseTree=g;function d(o,r){if(!o)return;let i=o;for(const n of r)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const a of i.children)if(Array.isArray(a.children)&&a.children[0].value===n){i=a.children[1],s=!0;break}if(!s)return}else{const s=n;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}e.findNodeAtLocation=d;function P(o){if(!o.parent||!o.parent.children)return[];const r=P(o.parent);if(o.parent.type==="property"){const i=o.parent.children[0].value;r.push(i)}else if(o.parent.type==="array"){const i=o.parent.children.indexOf(o);i!==-1&&r.push(i)}return r}e.getNodePath=P;function y(o){switch(o.type){case"array":return o.children.map(y);case"object":{const r=Object.create(null);for(const i of o.children){const n=i.children[1];n&&(r[i.children[0].value]=y(n))}return r}case"null":case"string":case"number":case"boolean":return o.value;default:return}}e.getNodeValue=y;function m(o,r,i=!1){return r>=o.offset&&r<o.offset+o.length||i&&r===o.offset+o.length}e.contains=m;function v(o,r,i=!1){if(m(o,r,i)){const n=o.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=r;s++){const a=v(n[s],r,i);if(a)return a}return o}}e.findNodeAtOffset=v;function f(o,r,i=R.DEFAULT){const n=D(o,!1);function s($){return $?()=>$(n.getTokenOffset(),n.getTokenLength()):()=>!0}function a($){return $?j=>$(j,n.getTokenOffset(),n.getTokenLength()):()=>!0}const l=s(r.onObjectBegin),I=a(r.onObjectProperty),k=s(r.onObjectEnd),A=s(r.onArrayBegin),W=s(r.onArrayEnd),F=a(r.onLiteralValue),K=a(r.onSeparator),ie=s(r.onComment),oe=a(r.onError),ue=i&&i.disallowComments,ne=i&&i.allowTrailingComma;function ae(){for(;;){const $=n.scan();switch(n.getTokenError()){case 4:le(14);break;case 5:le(15);break;case 3:le(13);break;case 1:ue||le(11);break;case 2:le(12);break;case 6:le(16);break}switch($){case 12:case 13:ue?le(10):ie();break;case 16:le(1);break;case 15:case 14:break;default:return $}}}function le($,j=[],L=[]){if(oe($),j.length+L.length>0){let T=n.getToken();for(;T!==17;){if(j.indexOf(T)!==-1){ae();break}else if(L.indexOf(T)!==-1)break;T=ae()}}}function G($){const j=n.getTokenValue();return $?F(j):I(j),ae(),!0}function B(){switch(n.getToken()){case 11:{let $=0;try{$=JSON.parse(n.getTokenValue()),typeof $!="number"&&(le(2),$=0)}catch{le(2)}F($);break}case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return ae(),!0}function N(){return n.getToken()!==10?(le(3,[],[2,5]),!1):(G(!1),n.getToken()===6?(K(":"),ae(),Z()||le(4,[],[2,5])):le(5,[],[2,5]),!0)}function O(){l(),ae();let $=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if($||le(4,[],[]),K(","),ae(),n.getToken()===2&&ne)break}else $&&le(6,[],[]);N()||le(4,[],[2,5]),$=!0}return k(),n.getToken()!==2?le(7,[2],[]):ae(),!0}function H(){A(),ae();let $=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if($||le(4,[],[]),K(","),ae(),n.getToken()===4&&ne)break}else $&&le(6,[],[]);Z()||le(4,[],[4,5]),$=!0}return W(),n.getToken()!==4?le(8,[4],[]):ae(),!0}function Z(){switch(n.getToken()){case 3:return H();case 1:return O();case 10:return G(!0);default:return B()}}return ae(),n.getToken()===17?i.allowEmptyContent?!0:(le(4,[],[]),!1):Z()?(n.getToken()!==17&&le(9,[],[]),!0):(le(4,[],[]),!1)}e.visit=f;function u(o,r){const i=D(o),n=[];let s,a=0,l;do switch(l=i.getPosition(),s=i.scan(),s){case 12:case 13:case 17:a!==l&&n.push(o.substring(a,l)),r!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,r)),a=i.getPosition();break}while(s!==17);return n.join("")}e.stripComments=u;function c(o){switch(typeof o){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(o){if(Array.isArray(o))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(X[119],J([0,1,48]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(w,E,C){let p,g,d,P,y;if(E){for(P=E.offset,y=P+E.length,d=P;d>0&&!h(w,d-1);)d--;let l=y;for(;l<w.length&&!h(w,l);)l++;g=w.substring(d,l),p=D(g,C)}else g=w,p=0,d=0,P=0,y=w.length;const m=b(C,w);let v=!1,f=0,u;C.insertSpaces?u=R(" ",C.tabSize||4):u="	";const c=(0,S.createScanner)(g,!1);let o=!1;function r(){return m+R(u,p+f)}function i(){let l=c.scan();for(v=!1;l===15||l===14;)v=v||l===14,l=c.scan();return o=l===16||c.getTokenError()!==0,l}const n=[];function s(l,I,k){!o&&I<y&&k>P&&w.substring(I,k)!==l&&n.push({offset:I,length:k-I,content:l})}let a=i();if(a!==17){const l=c.getTokenOffset()+d,I=R(u,p);s(I,d,l)}for(;a!==17;){let l=c.getTokenOffset()+c.getTokenLength()+d,I=i(),k="";for(;!v&&(I===12||I===13);){const W=c.getTokenOffset()+d;s(" ",l,W),l=c.getTokenOffset()+c.getTokenLength()+d,k=I===12?r():"",I=i()}if(I===2)a!==1&&(f--,k=r());else if(I===4)a!==3&&(f--,k=r());else{switch(a){case 3:case 1:f++,k=r();break;case 5:case 12:k=r();break;case 13:v?k=r():k=" ";break;case 6:k=" ";break;case 10:if(I===6){k="";break}case 7:case 8:case 9:case 11:case 2:case 4:I===12||I===13?k=" ":I!==5&&I!==17&&(o=!0);break;case 16:o=!0;break}v&&(I===12||I===13)&&(k=r())}const A=c.getTokenOffset()+d;s(k,l,A),a=I}return n}e.format=t;function M(w,E){const C=JSON.stringify(w,void 0,E.insertSpaces?E.tabSize||4:"	");return E.eol!==void 0?C.replace(/\r\n|\r|\n/g,E.eol):C}e.toFormattedString=M;function R(w,E){let C="";for(let p=0;p<E;p++)C+=w;return C}function D(w,E){let C=0,p=0;const g=E.tabSize||4;for(;C<w.length;){const d=w.charAt(C);if(d===" ")p++;else if(d==="	")p+=g;else break;C++}return Math.floor(p/g)}function b(w,E){for(let C=0;C<E.length;C++){const p=E.charAt(C);if(p==="\r")return C+1<E.length&&E.charAt(C+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return w&&w.eol||`
`}e.getEOL=b;function h(w,E){return`\r
`.indexOf(w.charAt(E))!==-1}e.isEOL=h}),define(X[120],J([0,1,48,119]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function M(w,E,C){return R(w,E,void 0,C)}e.removeProperty=M;function R(w,E,C,p,g){const d=E.slice(),P=[],y=(0,S.parseTree)(w,P);let m,v;for(;d.length>0&&(v=d.pop(),m=(0,S.findNodeAtLocation)(y,d),m===void 0&&C!==void 0);)typeof v=="string"?C={[v]:C}:C=[C];if(m)if(m.type==="object"&&typeof v=="string"&&Array.isArray(m.children)){const f=(0,S.findNodeAtLocation)(m,[v]);if(f!==void 0)if(C===void 0){if(!f.parent)throw new Error("Malformed AST");const u=m.children.indexOf(f.parent);let c,o=f.parent.offset+f.parent.length;if(u>0){const r=m.children[u-1];c=r.offset+r.length}else c=m.offset+1,m.children.length>1&&(o=m.children[1].offset);return D(w,{offset:c,length:o-c,content:""},p)}else return D(w,{offset:f.offset,length:f.length,content:JSON.stringify(C)},p);else{if(C===void 0)return[];const u=`${JSON.stringify(v)}: ${JSON.stringify(C)}`,c=g?g(m.children.map(r=>r.children[0].value)):m.children.length;let o;if(c>0){const r=m.children[c-1];o={offset:r.offset+r.length,length:0,content:","+u}}else m.children.length===0?o={offset:m.offset+1,length:0,content:u}:o={offset:m.offset+1,length:0,content:u+","};return D(w,o,p)}}else if(m.type==="array"&&typeof v=="number"&&Array.isArray(m.children))if(C!==void 0){const f=`${JSON.stringify(C)}`;let u;if(m.children.length===0||v===0)u={offset:m.offset+1,length:0,content:m.children.length===0?f:f+","};else{const c=v===-1||v>m.children.length?m.children.length:v,o=m.children[c-1];u={offset:o.offset+o.length,length:0,content:","+f}}return D(w,u,p)}else{const f=v,u=m.children[f];let c;if(m.children.length===1)c={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===f){const o=m.children[f-1],r=o.offset+o.length,i=m.offset+m.length;c={offset:r,length:i-2-r,content:""}}else c={offset:u.offset,length:m.children[f+1].offset-u.offset,content:""};return D(w,c,p)}else throw new Error(`Can not add ${typeof v!="number"?"index":"property"} to parent of type ${m.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return D(w,{offset:y?y.offset:0,length:y?y.length:0,content:JSON.stringify(C)},p)}}e.setProperty=R;function D(w,E,C){let p=b(w,E),g=E.offset,d=E.offset+E.content.length;if(E.length===0||E.content.length===0){for(;g>0&&!(0,t.isEOL)(p,g-1);)g--;for(;d<p.length&&!(0,t.isEOL)(p,d);)d++}const P=(0,t.format)(p,{offset:g,length:d-g},C);for(let m=P.length-1;m>=0;m--){const v=P[m];p=b(p,v),g=Math.min(g,v.offset),d=Math.max(d,v.offset+v.length),d+=v.content.length-v.length}const y=w.length-(p.length-d)-g;return[{offset:g,length:y,content:p.substring(g,d)}]}e.withFormatting=D;function b(w,E){return w.substring(0,E.offset)+E.content+w.substring(E.offset+E.length)}e.applyEdit=b;function h(w,E){const C=E.slice(0).sort((g,d)=>{const P=g.offset-d.offset;return P===0?g.length-d.length:P});let p=w.length;for(let g=C.length-1;g>=0;g--){const d=C[g];if(d.offset+d.length<=p)w=b(w,d);else throw new Error("Overlapping edit");p=d.offset}return w}e.applyEdits=h}),define(X[121],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class S{constructor(M){this.executor=M,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(M){this._error=M}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(M){return new S(()=>M(this.getValue()))}}e.Lazy=S}),define(X[2],J([0,1,47,55]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const M=!1;let R=null;function D(s){R=s}if(e.setDisposableTracker=D,M){const s="__is_disposable_tracked__";D(new class{trackDisposable(a){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[s]||console.log(l)},3e3)}setParent(a,l){if(a&&a!==v.None)try{a[s]=!0}catch{}}markAsDisposed(a){if(a&&a!==v.None)try{a[s]=!0}catch{}}markAsSingleton(a){}})}function b(s){return R?.trackDisposable(s),s}function h(s){R?.markAsDisposed(s)}function w(s,a){R?.setParent(s,a)}function E(s,a){if(!!R)for(const l of s)R.setParent(l,a)}function C(s){return R?.markAsSingleton(s),s}e.markAsSingleton=C;class p extends Error{constructor(a){super(`Encountered errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}e.MultiDisposeError=p;function g(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=g;function d(s){if(t.Iterable.is(s)){const a=[];for(const l of s)if(l)try{l.dispose()}catch(I){a.push(I)}if(a.length===1)throw a[0];if(a.length>1)throw new p(a);return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}e.dispose=d;function P(...s){const a=y(()=>d(s));return E(s,a),a}e.combinedDisposable=P;function y(s){const a=b({dispose:(0,S.once)(()=>{h(a),s()})});return a}e.toDisposable=y;class m{constructor(){this._toDispose=new Set,this._isDisposed=!1,b(this)}dispose(){this._isDisposed||(h(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return w(a,this),this._isDisposed?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=m,m.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this._store=new m,b(this),w(this._store,this)}dispose(){h(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=v,v.None=Object.freeze({dispose(){}});class f{constructor(){this._isDisposed=!1,b(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&w(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,h(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&w(a,null),a}}e.MutableDisposable=f;class u{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=u;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(a){let l=a;return this.unset=()=>l=void 0,this.isset=()=>l!==void 0,this.dispose=()=>{l&&(l(),l=void 0,h(this))},this}}e.SafeDisposable=c;class o{constructor(){this.references=new Map}acquire(a,...l){let I=this.references.get(a);I||(I={counter:0,object:this.createReferencedObject(a,...l)},this.references.set(a,I));const{object:k}=I,A=(0,S.once)(()=>{--I.counter==0&&(this.destroyReferencedObject(a,I.object),this.references.delete(a))});return I.counter++,{object:k,dispose:A}}}e.ReferenceCollection=o;class r{constructor(a){this.referenceCollection=a}async acquire(a,...l){const I=this.referenceCollection.acquire(a,...l);try{return{object:await I.object,dispose:()=>I.dispose()}}catch(k){throw I.dispose(),k}}}e.AsyncReferenceCollection=r;class i{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=i;function n(s){const a=new m;try{s(a)}finally{a.dispose()}}e.disposeOnReturn=n}),define(X[122],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class S{constructor(R){this.element=R,this.next=S.Undefined,this.prev=S.Undefined}}S.Undefined=new S(void 0);class t{constructor(){this._first=S.Undefined,this._last=S.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===S.Undefined}clear(){let R=this._first;for(;R!==S.Undefined;){const D=R.next;R.prev=S.Undefined,R.next=S.Undefined,R=D}this._first=S.Undefined,this._last=S.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,D){const b=new S(R);if(this._first===S.Undefined)this._first=b,this._last=b;else if(D){const w=this._last;this._last=b,b.prev=w,w.next=b}else{const w=this._first;this._first=b,b.next=w,w.prev=b}this._size+=1;let h=!1;return()=>{h||(h=!0,this._remove(b))}}shift(){if(this._first!==S.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==S.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==S.Undefined&&R.next!==S.Undefined){const D=R.prev;D.next=R.next,R.next.prev=D}else R.prev===S.Undefined&&R.next===S.Undefined?(this._first=S.Undefined,this._last=S.Undefined):R.next===S.Undefined?(this._last=this._last.prev,this._last.next=S.Undefined):R.prev===S.Undefined&&(this._first=this._first.next,this._first.prev=S.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==S.Undefined;)yield R.element,R=R.next}}e.LinkedList=t}),function(){function z(M){const R=[];typeof M=="number"&&R.push("code/timeOrigin",M);function D(h){R.push(h,Date.now())}function b(){const h=[];for(let w=0;w<R.length;w+=2)h.push({name:R[w],startTime:R[w+1]});return h}return{mark:D,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?z():{mark(M){performance.mark(M)},getMarks(){let M=performance.timeOrigin;typeof M!="number"&&(M=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(M)}];for(const D of performance.getEntriesByType("mark"))R.push({name:D.name,startTime:Math.round(M+D.startTime)});return R}};if(typeof process=="object"){const M=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return z(M)}else return console.trace("perf-util loaded in UNKNOWN environment"),z()}function S(M){return M.MonacoPerformanceMarks||(M.MonacoPerformanceMarks=e()),M.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=S(t))}(),define(X[123],J([0,1]),function(z,e){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(b,h,w){this.level=b,this.key=h,this.value=w,this.forward=[]}}const M=void 0;class R{constructor(b,h=2**16){this.comparator=b,this[S]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(h)|0),this._header=new t(this._maxLevel,M,M)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,M,M)}has(b){return Boolean(R._search(this,b,this.comparator))}get(b){return R._search(this,b,this.comparator)?.value}set(b,h){return R._insert(this,b,h,this.comparator)&&(this._size+=1),this}delete(b){const h=R._delete(this,b,this.comparator);return h&&(this._size-=1),h}forEach(b,h){let w=this._header.forward[0];for(;w;)b.call(h,w.value,w.key,this),w=w.forward[0]}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let b=this._header.forward[0];for(;b;)yield[b.key,b.value],b=b.forward[0]}*keys(){let b=this._header.forward[0];for(;b;)yield b.key,b=b.forward[0]}*values(){let b=this._header.forward[0];for(;b;)yield b.value,b=b.forward[0]}toString(){let b="[SkipList]:",h=this._header.forward[0];for(;h;)b+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return b}static _search(b,h,w){let E=b._header;for(let C=b._level-1;C>=0;C--)for(;E.forward[C]&&w(E.forward[C].key,h)<0;)E=E.forward[C];if(E=E.forward[0],E&&w(E.key,h)===0)return E}static _insert(b,h,w,E){const C=[];let p=b._header;for(let g=b._level-1;g>=0;g--){for(;p.forward[g]&&E(p.forward[g].key,h)<0;)p=p.forward[g];C[g]=p}if(p=p.forward[0],p&&E(p.key,h)===0)return p.value=w,!1;{const g=R._randomLevel(b);if(g>b._level){for(let d=b._level;d<g;d++)C[d]=b._header;b._level=g}p=new t(g,h,w);for(let d=0;d<g;d++)p.forward[d]=C[d].forward[d],C[d].forward[d]=p;return!0}}static _randomLevel(b,h=.5){let w=1;for(;Math.random()<h&&w<b._maxLevel;)w+=1;return w}static _delete(b,h,w){const E=[];let C=b._header;for(let p=b._level-1;p>=0;p--){for(;C.forward[p]&&w(C.forward[p].key,h)<0;)C=C.forward[p];E[p]=C}if(C=C.forward[0],!C||w(C.key,h)!==0)return!1;for(let p=0;p<b._level&&E[p].forward[p]===C;p++)E[p].forward[p]=C.forward[p];for(;b._level>0&&b._header.forward[b._level-1]===M;)b._level-=1;return!0}}e.SkipList=R}),define(X[56],J([0,1,19,2]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function M(u){const c=u;return c?typeof c.read=="function":!1}e.isReadable=M;function R(u){const c=u;return c?[c.on,c.pause,c.resume,c.destroy].every(o=>typeof o=="function"):!1}e.isReadableStream=R;function D(u){const c=u;return c?R(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=D;function b(u,c){return new h(u,c)}e.newWriteableStream=b;class h{constructor(c,o){this.reducer=c,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(o=>this.pendingWritePromises.push(o))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(o=>o(c))}emitError(c){this.listeners.error.length===0?(0,S.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(o=>o(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,o){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(c,o){if(this.state.destroyed)return;let r;switch(c){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const i=r.indexOf(o);i>=0&&r.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function w(u,c){const o=[];let r;for(;(r=u.read())!==null;)o.push(r);return c(o)}e.consumeReadable=w;function E(u,c,o){const r=[];let i;for(;(i=u.read())!==null&&r.length<o;)r.push(i);return i===null&&r.length>0?c(r):{read:()=>{if(r.length>0)return r.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return u.read()}}}e.peekReadable=E;function C(u,c){return new Promise((o,r)=>{const i=[];p(u,{onData:n=>{c&&i.push(n)},onError:n=>{c?r(n):o(void 0)},onEnd:()=>{o(c?c(i):void 0)}})})}e.consumeStream=C;function p(u,c){let o=!1;return u.on("error",r=>{o||c.onError(r)}),u.on("end",()=>{o||c.onEnd()}),u.on("data",r=>{o||c.onData(r)}),(0,t.toDisposable)(()=>o=!0)}e.listenStream=p;function g(u,c){return new Promise((o,r)=>{const i=new t.DisposableStore,n=[],s=I=>{if(n.push(I),n.length>c)return i.dispose(),u.pause(),o({stream:u,buffer:n,ended:!1})},a=I=>r(I),l=()=>o({stream:u,buffer:n,ended:!0});i.add((0,t.toDisposable)(()=>u.removeListener("error",a))),u.on("error",a),i.add((0,t.toDisposable)(()=>u.removeListener("end",l))),u.on("end",l),i.add((0,t.toDisposable)(()=>u.removeListener("data",s))),u.on("data",s)})}e.peekStream=g;function d(u,c){const o=b(c);return o.end(u),o}e.toStream=d;function P(){const u=b(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=P;function y(u){let c=!1;return{read:()=>c?null:(c=!0,u)}}e.toReadable=y;function m(u,c,o){const r=b(o);return p(u,{onData:i=>r.write(c.data(i)),onError:i=>r.error(c.error?c.error(i):i),onEnd:()=>r.end()}),r}e.transform=m;function v(u,c,o){let r=!1;return{read:()=>{const i=c.read();return r?i:(r=!0,i!==null?o([u,i]):u)}}}e.prefixedReadable=v;function f(u,c,o){let r=!1;const i=b(o);return p(c,{onData:n=>r?i.write(n):(r=!0,i.write(o([u,n]))),onError:n=>i.error(n),onEnd:()=>{r||(r=!0,i.write(u)),i.end()}}),i}e.prefixedStream=f}),define(X[17],J([0,1,56]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let M,R;class D{constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}static alloc(I){return t?new D(Buffer.allocUnsafe(I)):new D(new Uint8Array(I))}static wrap(I){return t&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new D(I)}static fromString(I,k){return!(k?.dontUseNodeBuffer||!1)&&t?new D(Buffer.from(I)):(M||(M=new TextEncoder),new D(M.encode(I)))}static fromByteArray(I){const k=D.alloc(I.length);for(let A=0,W=I.length;A<W;A++)k.buffer[A]=I[A];return k}static concat(I,k){if(typeof k=="undefined"){k=0;for(let F=0,K=I.length;F<K;F++)k+=I[F].byteLength}const A=D.alloc(k);let W=0;for(let F=0,K=I.length;F<K;F++){const ie=I[F];A.set(ie,W),W+=ie.byteLength}return A}clone(){const I=D.alloc(this.byteLength);return I.set(this),I}toString(){return t?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(I,k){return new D(this.buffer.subarray(I,k))}set(I,k){if(I instanceof D)this.buffer.set(I.buffer,k);else if(I instanceof Uint8Array)this.buffer.set(I,k);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),k);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),k);else throw new Error("Unknown argument 'array'")}readUInt32BE(I){return w(this.buffer,I)}writeUInt32BE(I,k){E(this.buffer,I,k)}readUInt32LE(I){return C(this.buffer,I)}writeUInt32LE(I,k){p(this.buffer,I,k)}readUInt8(I){return g(this.buffer,I)}writeUInt8(I,k){d(this.buffer,I,k)}}e.VSBuffer=D;function b(l,I){return l[I+0]<<0>>>0|l[I+1]<<8>>>0}e.readUInt16LE=b;function h(l,I,k){l[k+0]=I&255,I=I>>>8,l[k+1]=I&255}e.writeUInt16LE=h;function w(l,I){return l[I]*2**24+l[I+1]*2**16+l[I+2]*2**8+l[I+3]}e.readUInt32BE=w;function E(l,I,k){l[k+3]=I,I=I>>>8,l[k+2]=I,I=I>>>8,l[k+1]=I,I=I>>>8,l[k]=I}e.writeUInt32BE=E;function C(l,I){return l[I+0]<<0>>>0|l[I+1]<<8>>>0|l[I+2]<<16>>>0|l[I+3]<<24>>>0}e.readUInt32LE=C;function p(l,I,k){l[k+0]=I&255,I=I>>>8,l[k+1]=I&255,I=I>>>8,l[k+2]=I&255,I=I>>>8,l[k+3]=I&255}e.writeUInt32LE=p;function g(l,I){return l[I]}e.readUInt8=g;function d(l,I,k){l[k]=I}e.writeUInt8=d;function P(l){return S.consumeReadable(l,I=>D.concat(I))}e.readableToBuffer=P;function y(l){return S.toReadable(l)}e.bufferToReadable=y;function m(l){return S.consumeStream(l,I=>D.concat(I))}e.streamToBuffer=m;async function v(l){return l.ended?D.concat(l.buffer):D.concat([...l.buffer,await m(l.stream)])}e.bufferedStreamToBuffer=v;function f(l){return S.toStream(l,I=>D.concat(I))}e.bufferToStream=f;function u(l){return S.transform(l,{data:I=>typeof I=="string"?D.fromString(I):D.wrap(I)},I=>D.concat(I))}e.streamToBufferReadableStream=u;function c(l){return S.newWriteableStream(I=>D.concat(I),l)}e.newWriteableBufferStream=c;function o(l,I){return S.prefixedReadable(l,I,k=>D.concat(k))}e.prefixedBufferReadable=o;function r(l,I){return S.prefixedStream(l,I,k=>D.concat(k))}e.prefixedBufferStream=r;function i(l){let I=0,k=0,A=0;const W=new Uint8Array(Math.floor(l.length/4*3)),F=ie=>{switch(k){case 3:W[A++]=I|ie,k=0;break;case 2:W[A++]=I|ie>>>2,I=ie<<6,k=3;break;case 1:W[A++]=I|ie>>>4,I=ie<<4,k=2;break;default:I=ie<<2,k=1}};for(let ie=0;ie<l.length;ie++){const oe=l.charCodeAt(ie);if(oe>=65&&oe<=90)F(oe-65);else if(oe>=97&&oe<=122)F(oe-97+26);else if(oe>=48&&oe<=57)F(oe-48+52);else if(oe===43||oe===45)F(62);else if(oe===47||oe===95)F(63);else{if(oe===61)break;throw new SyntaxError(`Unexpected base64 character ${l[ie]}`)}}const K=A;for(;k>0;)F(0);return D.wrap(W).slice(0,K)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:l},I=!0,k=!1){const A=k?s:n;let W="";const F=l.byteLength%3;let K=0;for(;K<l.byteLength-F;K+=3){const ie=l[K+0],oe=l[K+1],ue=l[K+2];W+=A[ie>>>2],W+=A[(ie<<4|oe>>>4)&63],W+=A[(oe<<2|ue>>>6)&63],W+=A[ue&63]}if(F===1){const ie=l[K+0];W+=A[ie>>>2],W+=A[ie<<4&63],I&&(W+="==")}else if(F===2){const ie=l[K+0],oe=l[K+1];W+=A[ie>>>2],W+=A[(ie<<4|oe>>>4)&63],W+=A[oe<<2&63],I&&(W+="=")}return W}e.encodeBase64=a}),define(X[11],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function S(r){return typeof r=="string"}e.isString=S;function t(r){return Array.isArray(r)&&r.every(i=>S(i))}e.isStringArray=t;function M(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=M;function R(r){const i=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof i}e.isTypedArray=R;function D(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=D;function b(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=b;function h(r){return r===!0||r===!1}e.isBoolean=h;function w(r){return typeof r=="undefined"}e.isUndefined=w;function E(r){return!C(r)}e.isDefined=E;function C(r){return w(r)||r===null}e.isUndefinedOrNull=C;function p(r,i){if(!r)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=p;function g(r){if(C(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=g;function d(...r){const i=[];for(let n=0;n<r.length;n++){const s=r[n];if(C(s))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);i.push(s)}return i}e.assertAllDefined=d;const P=Object.prototype.hasOwnProperty;function y(r){if(!M(r))return!1;for(const i in r)if(P.call(r,i))return!1;return!0}e.isEmptyObject=y;function m(r){return typeof r=="function"}e.isFunction=m;function v(...r){return r.length>0&&r.every(m)}e.areFunctions=v;function f(r,i){const n=Math.min(r.length,i.length);for(let s=0;s<n;s++)u(r[s],i[s])}e.validateConstraints=f;function u(r,i){if(S(i)){if(typeof r!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(m(i)){try{if(r instanceof i)return}catch{}if(!C(r)&&r.constructor===i||i.length===1&&i.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=u;function c(r){return r===null?void 0:r}e.withNullAsUndefined=c;function o(r){return typeof r=="undefined"?null:r}e.withUndefinedAsNull=o}),define(X[51],J([0,1,11]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const v=Array.isArray(m)?[]:{};return Object.keys(m).forEach(f=>{m[f]&&typeof m[f]=="object"?v[f]=t(m[f]):v[f]=m[f]}),v}e.deepClone=t;function M(m){if(!m||typeof m!="object")return m;const v=[m];for(;v.length>0;){const f=v.shift();Object.freeze(f);for(const u in f)if(R.call(f,u)){const c=f[u];typeof c=="object"&&!Object.isFrozen(c)&&!(0,S.isTypedArray)(c)&&v.push(c)}}return m}e.deepFreeze=M;const R=Object.prototype.hasOwnProperty;function D(m,v){return b(m,v,new Set)}e.cloneAndChange=D;function b(m,v,f){if((0,S.isUndefinedOrNull)(m))return m;const u=v(m);if(typeof u!="undefined")return u;if(Array.isArray(m)){const c=[];for(const o of m)c.push(b(o,v,f));return c}if((0,S.isObject)(m)){if(f.has(m))throw new Error("Cannot clone recursive data-structure");f.add(m);const c={};for(const o in m)R.call(m,o)&&(c[o]=b(m[o],v,f));return f.delete(m),c}return m}function h(m,v,f=!0){return(0,S.isObject)(m)?((0,S.isObject)(v)&&Object.keys(v).forEach(u=>{u in m?f&&((0,S.isObject)(m[u])&&(0,S.isObject)(v[u])?h(m[u],v[u],f):m[u]=v[u]):m[u]=v[u]}),m):v}e.mixin=h;function w(m,v){if(m===v)return!0;if(m==null||v===null||v===void 0||typeof m!=typeof v||typeof m!="object"||Array.isArray(m)!==Array.isArray(v))return!1;let f,u;if(Array.isArray(m)){if(m.length!==v.length)return!1;for(f=0;f<m.length;f++)if(!w(m[f],v[f]))return!1}else{const c=[];for(u in m)c.push(u);c.sort();const o=[];for(u in v)o.push(u);if(o.sort(),!w(c,o))return!1;for(f=0;f<c.length;f++)if(!w(m[c[f]],v[c[f]]))return!1}return!0}e.equals=w;function E(m){const v=new Set;return JSON.stringify(m,(f,u)=>{if((0,S.isObject)(u)||Array.isArray(u)){if(v.has(u))return"[Circular]";v.add(u)}return u})}e.safeStringify=E;function C(m,v){const f=Object.create(null);return!m||!v||Object.keys(v).forEach(c=>{const o=m[c],r=v[c];w(o,r)||(f[c]=r)}),f}e.distinct=C;function p(m,v){const f=v.toLowerCase(),u=Object.keys(m).find(c=>c.toLowerCase()===f);return u?m[u]:m[v]}e.getCaseInsensitive=p;function g(m,v){const f=Object.create(null);for(const[u,c]of Object.entries(m))v(u,c)&&(f[u]=c);return f}e.filter=g;function d(m){let v=[],f=Object.getPrototypeOf(m);for(;Object.prototype!==f;)v=v.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return v}e.getAllPropertyNames=d;function P(m){const v=[];for(const f of d(m))typeof m[f]=="function"&&v.push(f);return v}e.getAllMethodNames=P;function y(m,v){const f=c=>function(){const o=Array.prototype.slice.call(arguments,0);return v(c,o)},u={};for(const c of m)u[c]=f(c);return u}e.createProxyObject=y}),define(X[27],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(M){return S.test(M)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let M;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?M=crypto.getRandomValues.bind(crypto):M=function(b){for(let h=0;h<b.length;h++)b[h]=Math.floor(Math.random()*256);return b};const R=new Uint8Array(16),D=[];for(let b=0;b<256;b++)D.push(b.toString(16).padStart(2,"0"));return function(){M(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let h=0,w="";return w+=D[R[h++]],w+=D[R[h++]],w+=D[R[h++]],w+=D[R[h++]],w+="-",w+=D[R[h++]],w+=D[R[h++]],w+="-",w+=D[R[h++]],w+=D[R[h++]],w+="-",w+=D[R[h++]],w+=D[R[h++]],w+="-",w+=D[R[h++]],w+=D[R[h++]],w+=D[R[h++]],w+=D[R[h++]],w+=D[R[h++]],w+=D[R[h++]],w}}()}),define(X[124],J([0,1,75,28,47]),function(z,e,S,t,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function R(D,b){if(await new Promise((E,C)=>{const p=t.createReadStream(D),g=S.createHash("sha1");p.pipe(g);const d=(0,M.once)((P,y)=>{p.removeAllListeners(),g.removeAllListeners(),P?C(P):E(y)});p.once("error",d),p.once("end",d),g.once("error",d),g.once("data",P=>d(void 0,P.toString("hex")))})!==b)throw new Error("Hash mismatch")}e.checksum=R}),define(X[125],J([0,1,29]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function M(D){const b=D.replace(/\-/g,":").toLowerCase();return!t.has(b)}function R(){const D=(0,S.networkInterfaces)();for(const b in D){const h=D[b];if(h){for(const{mac:w}of h)if(M(w))return w}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(X[90],J([0,1,76]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(b,h,w,E=1){let C=!1;return new Promise(p=>{const g=setTimeout(()=>{if(!C)return C=!0,p(0)},w);M(b,h,E,d=>{if(!C)return C=!0,clearTimeout(g),p(d)})})}e.findFreePort=t;function M(b,h,w,E){if(h===0)return E(0);const C=new S.Socket;C.once("connect",()=>(D(C),M(b+w,h-1,w,E))),C.once("data",()=>{}),C.once("error",p=>(D(C),p.code!=="ECONNREFUSED"?M(b+w,h-1,w,E):E(b))),C.connect(b,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(b,h,w){let E=!1,C,p=1;const g=S.createServer({pauseOnConnect:!0});function d(P,y){E||(E=!0,g.removeAllListeners(),g.close(),C&&clearTimeout(C),y(P))}return new Promise(P=>{C=setTimeout(()=>{d(0,P)},w),g.on("listening",()=>{d(b,P)}),g.on("error",y=>{y&&(y.code==="EADDRINUSE"||y.code==="EACCES")&&p<h?(b++,p++,g.listen(b,"127.0.0.1")):d(0,P)}),g.on("close",()=>{d(0,P)}),g.listen(b,"127.0.0.1")})}e.findFreePortFaster=R;function D(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch(h){console.error(h)}}}),define(X[126],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(X[127],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class S{constructor(M,R){this.sender=M,this.onMessage=R}send(M){try{this.sender.send("vscode:message",M.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=S}),define(X[38],J([0,1,14,19]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class M{constructor(){this.mapListenerToWrapper=new WeakMap}on(D,b){const h=(w,...E)=>{this.validateEvent(D,w)&&b(w,...E)};return this.mapListenerToWrapper.set(b,h),S.ipcMain.on(D,h),this}once(D,b){return S.ipcMain.once(D,(h,...w)=>{this.validateEvent(D,h)&&b(h,...w)}),this}handle(D,b){return S.ipcMain.handle(D,(h,...w)=>this.validateEvent(D,h)?b(h,...w):Promise.reject(`Invalid channel '${D}' or sender for ipcMain.handle() usage.`)),this}removeHandler(D){return S.ipcMain.removeHandler(D),this}removeListener(D,b){const h=this.mapListenerToWrapper.get(b);return h&&(S.ipcMain.removeListener(D,h),this.mapListenerToWrapper.delete(b)),this}validateEvent(D,b){if(!D||!D.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because the channel is unknown.`),!1;const h=b.senderFrame,w=h.url;if(!w)return!0;let E="unknown";try{E=new URL(w).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a malformed URL '${w}'.`),!1}return E!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a bad origin of '${E}'.`),!1):h.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because sender of origin '${E}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new M}),define(X[128],J([0,1,14,38,11,126]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function D(){t.validatedIpcMain.on(R.CONTEXT_MENU_CHANNEL,(h,w,E,C,p)=>{const g=b(h,C,E);g.popup({window:(0,M.withNullAsUndefined)(S.BrowserWindow.fromWebContents(h.sender)),x:p?p.x:void 0,y:p?p.y:void 0,positioningItem:p?p.positioningItem:void 0,callback:()=>{g&&h.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,w)}})})}e.registerContextMenuListener=D;function b(h,w,E){const C=new S.Menu;return E.forEach(p=>{let g;p.type==="separator"?g=new S.MenuItem({type:p.type}):Array.isArray(p.submenu)?g=new S.MenuItem({submenu:b(h,w,p.submenu),label:p.label}):g=new S.MenuItem({label:p.label,type:p.type,accelerator:p.accelerator,checked:p.checked,enabled:p.enabled,visible:p.visible,click:(d,P,y)=>h.sender.send(w,p.id,y)}),C.append(g)}),C}}),define(X[129],J([12,10]),function(z,e){return z.create("vs/base/common/date",e)}),define(X[130],J([0,1,129]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,M=t*60,R=M*24,D=R*7,b=R*30,h=R*365;function w(C,p,g){typeof C!="number"&&(C=C.getTime());const d=Math.round((new Date().getTime()-C)/1e3);if(d<-30)return(0,S.localize)(0,null,w(new Date().getTime()+d*1e3,!1));if(d<30)return(0,S.localize)(1,null);let P;return d<t?(P=d,p?P===1?g?(0,S.localize)(2,null,P):(0,S.localize)(3,null,P):g?(0,S.localize)(4,null,P):(0,S.localize)(5,null,P):P===1?g?(0,S.localize)(6,null,P):(0,S.localize)(7,null,P):g?(0,S.localize)(8,null,P):(0,S.localize)(9,null,P)):d<M?(P=Math.floor(d/t),p?P===1?g?(0,S.localize)(10,null,P):(0,S.localize)(11,null,P):g?(0,S.localize)(12,null,P):(0,S.localize)(13,null,P):P===1?g?(0,S.localize)(14,null,P):(0,S.localize)(15,null,P):g?(0,S.localize)(16,null,P):(0,S.localize)(17,null,P)):d<R?(P=Math.floor(d/M),p?P===1?g?(0,S.localize)(18,null,P):(0,S.localize)(19,null,P):g?(0,S.localize)(20,null,P):(0,S.localize)(21,null,P):P===1?g?(0,S.localize)(22,null,P):(0,S.localize)(23,null,P):g?(0,S.localize)(24,null,P):(0,S.localize)(25,null,P)):d<D?(P=Math.floor(d/R),p?P===1?(0,S.localize)(26,null,P):(0,S.localize)(27,null,P):P===1?(0,S.localize)(28,null,P):(0,S.localize)(29,null,P)):d<b?(P=Math.floor(d/D),p?P===1?g?(0,S.localize)(30,null,P):(0,S.localize)(31,null,P):g?(0,S.localize)(32,null,P):(0,S.localize)(33,null,P):P===1?g?(0,S.localize)(34,null,P):(0,S.localize)(35,null,P):g?(0,S.localize)(36,null,P):(0,S.localize)(37,null,P)):d<h?(P=Math.floor(d/b),p?P===1?g?(0,S.localize)(38,null,P):(0,S.localize)(39,null,P):g?(0,S.localize)(40,null,P):(0,S.localize)(41,null,P):P===1?g?(0,S.localize)(42,null,P):(0,S.localize)(43,null,P):g?(0,S.localize)(44,null,P):(0,S.localize)(45,null,P)):(P=Math.floor(d/h),p?P===1?g?(0,S.localize)(46,null,P):(0,S.localize)(47,null,P):g?(0,S.localize)(48,null,P):(0,S.localize)(49,null,P):P===1?g?(0,S.localize)(50,null,P):(0,S.localize)(51,null,P):g?(0,S.localize)(52,null,P):(0,S.localize)(53,null,P))}e.fromNow=w;function E(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=E}),define(X[131],J([12,10]),function(z,e){return z.create("vs/base/common/errorMessage",e)}),define(X[42],J([0,1,25,11,131]),function(z,e,S,t,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(C,p){return p&&(C.stack||C.stacktrace)?M.localize(0,null,b(C),D(C.stack)||D(C.stacktrace)):b(C)}function D(C){return Array.isArray(C)?C.join(`
`):C}function b(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?M.localize(1,null,C.message):C.message||M.localize(2,null)}function h(C=null,p=!1){if(!C)return M.localize(3,null);if(Array.isArray(C)){const g=S.coalesce(C),d=h(g[0],p);return g.length>1?M.localize(4,null,d,g.length):d}if(t.isString(C))return C;if(C.detail){const g=C.detail;if(g.error)return R(g.error,p);if(g.exception)return R(g.exception,p)}return C.stack?R(C,p):C.message?C.message:M.localize(5,null)}e.toErrorMessage=h;function w(C){const p=C;return p instanceof Error&&Array.isArray(p.actions)}e.isErrorWithActions=w;function E(C,p){let g;return typeof C=="string"?g=new Error(C):g=C,g.actions=p,g}e.createErrorWithActions=E}),define(X[132],J([12,10]),function(z,e){return z.create("vs/base/common/platform",e)}),define(X[4],J([0,1,132]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const t="en";let M=!1,R=!1,D=!1,b=!1,h=!1,w=!1,E=!1,C=!1,p=!1,g,d=t,P,y;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let m;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?m=e.globals.vscode.process:typeof process!="undefined"&&(m=process);const v=typeof m?.versions?.electron=="string",f=v&&m?.type==="renderer";if(typeof navigator=="object"&&!f)y=navigator.userAgent,M=y.indexOf("Windows")>=0,R=y.indexOf("Macintosh")>=0,C=(y.indexOf("Macintosh")>=0||y.indexOf("iPad")>=0||y.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=y.indexOf("Linux")>=0,w=!0,g=S.getConfiguredDefaultLocale(S.localize(0,null))||t,d=g;else if(typeof m=="object"){M=m.platform==="win32",R=m.platform==="darwin",D=m.platform==="linux",b=D&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,E=v,p=!!m.env.CI||!!m.env.BUILD_ARTIFACTSTAGINGDIRECTORY,g=t,d=t;const l=m.env.VSCODE_NLS_CONFIG;if(l)try{const I=JSON.parse(l),k=I.availableLanguages["*"];g=I.locale,d=k||t,P=I._translationsConfigFile}catch{}h=!0}else console.error("Unable to resolve platform.");var u;(function(l){l[l.Web=0]="Web",l[l.Mac=1]="Mac",l[l.Linux=2]="Linux",l[l.Windows=3]="Windows"})(u=e.Platform||(e.Platform={}));function c(l){switch(l){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=c;let o=0;R?o=1:M?o=3:D&&(o=2),e.isWindows=M,e.isMacintosh=R,e.isLinux=D,e.isLinuxSnap=b,e.isNative=h,e.isElectron=E,e.isWeb=w,e.isWebWorker=w&&typeof e.globals.importScripts=="function",e.isIOS=C,e.isCI=p,e.platform=o,e.userAgent=y,e.language=d;var r;(function(l){function I(){return e.language}l.value=I;function k(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}l.isDefaultVariant=k;function A(){return e.language==="en"}l.isDefault=A})(r=e.Language||(e.Language={})),e.locale=g,e.translationsConfigFile=P,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const l=[];e.globals.addEventListener("message",k=>{if(k.data&&k.data.vscodeScheduleAsyncWork)for(let A=0,W=l.length;A<W;A++){const F=l[A];if(F.id===k.data.vscodeScheduleAsyncWork){l.splice(A,1),F.callback();return}}});let I=0;return k=>{const A=++I;l.push({id:A,callback:k}),e.globals.postMessage({vscodeScheduleAsyncWork:A},"*")}}return l=>setTimeout(l)})();var i;(function(l){l[l.Windows=1]="Windows",l[l.Macintosh=2]="Macintosh",l[l.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||C?2:M?1:3;let n=!0,s=!1;function a(){if(!s){s=!0;const l=new Uint8Array(2);l[0]=1,l[1]=2,n=new Uint16Array(l.buffer)[0]===(2<<8)+1}return n}e.isLittleEndian=a,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(X[36],J([0,1,4]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof S.globals.vscode!="undefined"&&typeof S.globals.vscode.process!="undefined"){const M=S.globals.vscode.process;t={get platform(){return M.platform},get arch(){return M.arch},get env(){return M.env},cwd(){return M.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return S.isWindows?"win32":S.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(X[9],J([0,1,36]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,M=97,R=90,D=122,b=46,h=47,w=92,E=58,C=63;class p extends Error{constructor(u,c,o){let r;typeof c=="string"&&c.indexOf("not ")===0?(r="must not be",c=c.replace(/^not /,"")):r="must be";const i=u.indexOf(".")!==-1?"property":"argument";let n=`The "${u}" ${i} ${r} of type ${c}`;n+=`. Received type ${typeof o}`;super(n);this.code="ERR_INVALID_ARG_TYPE"}}function g(f,u){if(typeof f!="string")throw new p(u,"string",f)}function d(f){return f===h||f===w}function P(f){return f===h}function y(f){return f>=t&&f<=R||f>=M&&f<=D}function m(f,u,c,o){let r="",i=0,n=-1,s=0,a=0;for(let l=0;l<=f.length;++l){if(l<f.length)a=f.charCodeAt(l);else{if(o(a))break;a=h}if(o(a)){if(!(n===l-1||s===1))if(s===2){if(r.length<2||i!==2||r.charCodeAt(r.length-1)!==b||r.charCodeAt(r.length-2)!==b){if(r.length>2){const I=r.lastIndexOf(c);I===-1?(r="",i=0):(r=r.slice(0,I),i=r.length-1-r.lastIndexOf(c)),n=l,s=0;continue}else if(r.length!==0){r="",i=0,n=l,s=0;continue}}u&&(r+=r.length>0?`${c}..`:"..",i=2)}else r.length>0?r+=`${c}${f.slice(n+1,l)}`:r=f.slice(n+1,l),i=l-n-1;n=l,s=0}else a===b&&s!==-1?++s:s=-1}return r}function v(f,u){if(u===null||typeof u!="object")throw new p("pathObject","Object",u);const c=u.dir||u.root,o=u.base||`${u.name||""}${u.ext||""}`;return c?c===u.root?`${c}${o}`:`${c}${f}${o}`:o}e.win32={resolve(...f){let u="",c="",o=!1;for(let r=f.length-1;r>=-1;r--){let i;if(r>=0){if(i=f[r],g(i,"path"),i.length===0)continue}else u.length===0?i=S.cwd():(i=S.env[`=${u}`]||S.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==u.toLowerCase()&&i.charCodeAt(2)===w)&&(i=`${u}\\`));const n=i.length;let s=0,a="",l=!1;const I=i.charCodeAt(0);if(n===1)d(I)&&(s=1,l=!0);else if(d(I))if(l=!0,d(i.charCodeAt(1))){let k=2,A=k;for(;k<n&&!d(i.charCodeAt(k));)k++;if(k<n&&k!==A){const W=i.slice(A,k);for(A=k;k<n&&d(i.charCodeAt(k));)k++;if(k<n&&k!==A){for(A=k;k<n&&!d(i.charCodeAt(k));)k++;(k===n||k!==A)&&(a=`\\\\${W}\\${i.slice(A,k)}`,s=k)}}}else s=1;else y(I)&&i.charCodeAt(1)===E&&(a=i.slice(0,2),s=2,n>2&&d(i.charCodeAt(2))&&(l=!0,s=3));if(a.length>0)if(u.length>0){if(a.toLowerCase()!==u.toLowerCase())continue}else u=a;if(o){if(u.length>0)break}else if(c=`${i.slice(s)}\\${c}`,o=l,l&&u.length>0)break}return c=m(c,!o,"\\",d),o?`${u}\\${c}`:`${u}${c}`||"."},normalize(f){g(f,"path");const u=f.length;if(u===0)return".";let c=0,o,r=!1;const i=f.charCodeAt(0);if(u===1)return P(i)?"\\":f;if(d(i))if(r=!0,d(f.charCodeAt(1))){let s=2,a=s;for(;s<u&&!d(f.charCodeAt(s));)s++;if(s<u&&s!==a){const l=f.slice(a,s);for(a=s;s<u&&d(f.charCodeAt(s));)s++;if(s<u&&s!==a){for(a=s;s<u&&!d(f.charCodeAt(s));)s++;if(s===u)return`\\\\${l}\\${f.slice(a)}\\`;s!==a&&(o=`\\\\${l}\\${f.slice(a,s)}`,c=s)}}}else c=1;else y(i)&&f.charCodeAt(1)===E&&(o=f.slice(0,2),c=2,u>2&&d(f.charCodeAt(2))&&(r=!0,c=3));let n=c<u?m(f.slice(c),!r,"\\",d):"";return n.length===0&&!r&&(n="."),n.length>0&&d(f.charCodeAt(u-1))&&(n+="\\"),o===void 0?r?`\\${n}`:n:r?`${o}\\${n}`:`${o}${n}`},isAbsolute(f){g(f,"path");const u=f.length;if(u===0)return!1;const c=f.charCodeAt(0);return d(c)||u>2&&y(c)&&f.charCodeAt(1)===E&&d(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let u,c;for(let i=0;i<f.length;++i){const n=f[i];g(n,"path"),n.length>0&&(u===void 0?u=c=n:u+=`\\${n}`)}if(u===void 0)return".";let o=!0,r=0;if(typeof c=="string"&&d(c.charCodeAt(0))){++r;const i=c.length;i>1&&d(c.charCodeAt(1))&&(++r,i>2&&(d(c.charCodeAt(2))?++r:o=!1))}if(o){for(;r<u.length&&d(u.charCodeAt(r));)r++;r>=2&&(u=`\\${u.slice(r)}`)}return e.win32.normalize(u)},relative(f,u){if(g(f,"from"),g(u,"to"),f===u)return"";const c=e.win32.resolve(f),o=e.win32.resolve(u);if(c===o||(f=c.toLowerCase(),u=o.toLowerCase(),f===u))return"";let r=0;for(;r<f.length&&f.charCodeAt(r)===w;)r++;let i=f.length;for(;i-1>r&&f.charCodeAt(i-1)===w;)i--;const n=i-r;let s=0;for(;s<u.length&&u.charCodeAt(s)===w;)s++;let a=u.length;for(;a-1>s&&u.charCodeAt(a-1)===w;)a--;const l=a-s,I=n<l?n:l;let k=-1,A=0;for(;A<I;A++){const F=f.charCodeAt(r+A);if(F!==u.charCodeAt(s+A))break;F===w&&(k=A)}if(A!==I){if(k===-1)return o}else{if(l>I){if(u.charCodeAt(s+A)===w)return o.slice(s+A+1);if(A===2)return o.slice(s+A)}n>I&&(f.charCodeAt(r+A)===w?k=A:A===2&&(k=3)),k===-1&&(k=0)}let W="";for(A=r+k+1;A<=i;++A)(A===i||f.charCodeAt(A)===w)&&(W+=W.length===0?"..":"\\..");return s+=k,W.length>0?`${W}${o.slice(s,a)}`:(o.charCodeAt(s)===w&&++s,o.slice(s,a))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const u=e.win32.resolve(f);if(u.length<=2)return f;if(u.charCodeAt(0)===w){if(u.charCodeAt(1)===w){const c=u.charCodeAt(2);if(c!==C&&c!==b)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(y(u.charCodeAt(0))&&u.charCodeAt(1)===E&&u.charCodeAt(2)===w)return`\\\\?\\${u}`;return f},dirname(f){g(f,"path");const u=f.length;if(u===0)return".";let c=-1,o=0;const r=f.charCodeAt(0);if(u===1)return d(r)?f:".";if(d(r)){if(c=o=1,d(f.charCodeAt(1))){let s=2,a=s;for(;s<u&&!d(f.charCodeAt(s));)s++;if(s<u&&s!==a){for(a=s;s<u&&d(f.charCodeAt(s));)s++;if(s<u&&s!==a){for(a=s;s<u&&!d(f.charCodeAt(s));)s++;if(s===u)return f;s!==a&&(c=o=s+1)}}}}else y(r)&&f.charCodeAt(1)===E&&(c=u>2&&d(f.charCodeAt(2))?3:2,o=c);let i=-1,n=!0;for(let s=u-1;s>=o;--s)if(d(f.charCodeAt(s))){if(!n){i=s;break}}else n=!1;if(i===-1){if(c===-1)return".";i=c}return f.slice(0,i)},basename(f,u){u!==void 0&&g(u,"ext"),g(f,"path");let c=0,o=-1,r=!0,i;if(f.length>=2&&y(f.charCodeAt(0))&&f.charCodeAt(1)===E&&(c=2),u!==void 0&&u.length>0&&u.length<=f.length){if(u===f)return"";let n=u.length-1,s=-1;for(i=f.length-1;i>=c;--i){const a=f.charCodeAt(i);if(d(a)){if(!r){c=i+1;break}}else s===-1&&(r=!1,s=i+1),n>=0&&(a===u.charCodeAt(n)?--n==-1&&(o=i):(n=-1,o=s))}return c===o?o=s:o===-1&&(o=f.length),f.slice(c,o)}for(i=f.length-1;i>=c;--i)if(d(f.charCodeAt(i))){if(!r){c=i+1;break}}else o===-1&&(r=!1,o=i+1);return o===-1?"":f.slice(c,o)},extname(f){g(f,"path");let u=0,c=-1,o=0,r=-1,i=!0,n=0;f.length>=2&&f.charCodeAt(1)===E&&y(f.charCodeAt(0))&&(u=o=2);for(let s=f.length-1;s>=u;--s){const a=f.charCodeAt(s);if(d(a)){if(!i){o=s+1;break}continue}r===-1&&(i=!1,r=s+1),a===b?c===-1?c=s:n!==1&&(n=1):c!==-1&&(n=-1)}return c===-1||r===-1||n===0||n===1&&c===r-1&&c===o+1?"":f.slice(c,r)},format:v.bind(null,"\\"),parse(f){g(f,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return u;const c=f.length;let o=0,r=f.charCodeAt(0);if(c===1)return d(r)?(u.root=u.dir=f,u):(u.base=u.name=f,u);if(d(r)){if(o=1,d(f.charCodeAt(1))){let k=2,A=k;for(;k<c&&!d(f.charCodeAt(k));)k++;if(k<c&&k!==A){for(A=k;k<c&&d(f.charCodeAt(k));)k++;if(k<c&&k!==A){for(A=k;k<c&&!d(f.charCodeAt(k));)k++;k===c?o=k:k!==A&&(o=k+1)}}}}else if(y(r)&&f.charCodeAt(1)===E){if(c<=2)return u.root=u.dir=f,u;if(o=2,d(f.charCodeAt(2))){if(c===3)return u.root=u.dir=f,u;o=3}}o>0&&(u.root=f.slice(0,o));let i=-1,n=o,s=-1,a=!0,l=f.length-1,I=0;for(;l>=o;--l){if(r=f.charCodeAt(l),d(r)){if(!a){n=l+1;break}continue}s===-1&&(a=!1,s=l+1),r===b?i===-1?i=l:I!==1&&(I=1):i!==-1&&(I=-1)}return s!==-1&&(i===-1||I===0||I===1&&i===s-1&&i===n+1?u.base=u.name=f.slice(n,s):(u.name=f.slice(n,i),u.base=f.slice(n,s),u.ext=f.slice(i,s))),n>0&&n!==o?u.dir=f.slice(0,n-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let u="",c=!1;for(let o=f.length-1;o>=-1&&!c;o--){const r=o>=0?f[o]:S.cwd();g(r,"path"),r.length!==0&&(u=`${r}/${u}`,c=r.charCodeAt(0)===h)}return u=m(u,!c,"/",P),c?`/${u}`:u.length>0?u:"."},normalize(f){if(g(f,"path"),f.length===0)return".";const u=f.charCodeAt(0)===h,c=f.charCodeAt(f.length-1)===h;return f=m(f,!u,"/",P),f.length===0?u?"/":c?"./":".":(c&&(f+="/"),u?`/${f}`:f)},isAbsolute(f){return g(f,"path"),f.length>0&&f.charCodeAt(0)===h},join(...f){if(f.length===0)return".";let u;for(let c=0;c<f.length;++c){const o=f[c];g(o,"path"),o.length>0&&(u===void 0?u=o:u+=`/${o}`)}return u===void 0?".":e.posix.normalize(u)},relative(f,u){if(g(f,"from"),g(u,"to"),f===u||(f=e.posix.resolve(f),u=e.posix.resolve(u),f===u))return"";const c=1,o=f.length,r=o-c,i=1,n=u.length-i,s=r<n?r:n;let a=-1,l=0;for(;l<s;l++){const k=f.charCodeAt(c+l);if(k!==u.charCodeAt(i+l))break;k===h&&(a=l)}if(l===s)if(n>s){if(u.charCodeAt(i+l)===h)return u.slice(i+l+1);if(l===0)return u.slice(i+l)}else r>s&&(f.charCodeAt(c+l)===h?a=l:l===0&&(a=0));let I="";for(l=c+a+1;l<=o;++l)(l===o||f.charCodeAt(l)===h)&&(I+=I.length===0?"..":"/..");return`${I}${u.slice(i+a)}`},toNamespacedPath(f){return f},dirname(f){if(g(f,"path"),f.length===0)return".";const u=f.charCodeAt(0)===h;let c=-1,o=!0;for(let r=f.length-1;r>=1;--r)if(f.charCodeAt(r)===h){if(!o){c=r;break}}else o=!1;return c===-1?u?"/":".":u&&c===1?"//":f.slice(0,c)},basename(f,u){u!==void 0&&g(u,"ext"),g(f,"path");let c=0,o=-1,r=!0,i;if(u!==void 0&&u.length>0&&u.length<=f.length){if(u===f)return"";let n=u.length-1,s=-1;for(i=f.length-1;i>=0;--i){const a=f.charCodeAt(i);if(a===h){if(!r){c=i+1;break}}else s===-1&&(r=!1,s=i+1),n>=0&&(a===u.charCodeAt(n)?--n==-1&&(o=i):(n=-1,o=s))}return c===o?o=s:o===-1&&(o=f.length),f.slice(c,o)}for(i=f.length-1;i>=0;--i)if(f.charCodeAt(i)===h){if(!r){c=i+1;break}}else o===-1&&(r=!1,o=i+1);return o===-1?"":f.slice(c,o)},extname(f){g(f,"path");let u=-1,c=0,o=-1,r=!0,i=0;for(let n=f.length-1;n>=0;--n){const s=f.charCodeAt(n);if(s===h){if(!r){c=n+1;break}continue}o===-1&&(r=!1,o=n+1),s===b?u===-1?u=n:i!==1&&(i=1):u!==-1&&(i=-1)}return u===-1||o===-1||i===0||i===1&&u===o-1&&u===c+1?"":f.slice(u,o)},format:v.bind(null,"/"),parse(f){g(f,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return u;const c=f.charCodeAt(0)===h;let o;c?(u.root="/",o=1):o=0;let r=-1,i=0,n=-1,s=!0,a=f.length-1,l=0;for(;a>=o;--a){const I=f.charCodeAt(a);if(I===h){if(!s){i=a+1;break}continue}n===-1&&(s=!1,n=a+1),I===b?r===-1?r=a:l!==1&&(l=1):r!==-1&&(l=-1)}if(n!==-1){const I=i===0&&c?1:i;r===-1||l===0||l===1&&r===n-1&&r===i+1?u.base=u.name=f.slice(I,n):(u.name=f.slice(I,r),u.base=f.slice(I,n),u.ext=f.slice(r,n))}return i>0?u.dir=f.slice(0,i-1):c&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=S.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=S.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=S.platform==="win32"?e.win32.join:e.posix.join,e.resolve=S.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=S.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=S.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=S.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=S.platform==="win32"?e.win32.extname:e.posix.extname,e.format=S.platform==="win32"?e.win32.format:e.posix.format,e.parse=S.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=S.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=S.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=S.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(X[77],J([0,1,4]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var M;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(M=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(b,...h){const w=h.reduce((p,g)=>(p[g]=!0,p),{}),E=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(p=>!w[p]).forEach(p=>{for(let g=0;g<E.length;g++)if(p.search(E[g])!==-1){delete b[p];break}})}e.sanitizeProcessEnvironment=R;function D(b){!b||(delete b.DEBUG,S.isMacintosh&&delete b.DYLD_LIBRARY_PATH,S.isLinux&&delete b.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),define(X[78],J([0,1,4]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=S.globals.performance&&typeof S.globals.performance.now=="function";class M{constructor(D){this._highResolution=t&&D,this._startTime=this._now(),this._stopTime=-1}static create(D=!0){return new M(D)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?S.globals.performance.now():Date.now()}}e.StopWatch=M}),define(X[3],J([0,1,19,47,2,122,78]),function(z,e,S,t,M,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;const b=!1,h=!1;var w;(function(a){a.None=()=>M.Disposable.None;function l(T){if(h){const{onListenerDidAdd:_}=T,q=d.create();let Q=0;T.onListenerDidAdd=()=>{++Q==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),q.print()),_?.()}}}function I(T){return(_,q=null,Q)=>{let te=!1,U;return U=T(Y=>{if(!te)return U?U.dispose():te=!0,_.call(q,Y)},null,Q),te&&U.dispose(),U}}a.once=I;function k(T,_,q){return oe((Q,te=null,U)=>T(Y=>Q.call(te,_(Y)),null,U),q)}a.map=k;function A(T,_,q){return oe((Q,te=null,U)=>T(Y=>{_(Y),Q.call(te,Y)},null,U),q)}a.forEach=A;function W(T,_,q){return oe((Q,te=null,U)=>T(Y=>_(Y)&&Q.call(te,Y),null,U),q)}a.filter=W;function F(T){return T}a.signal=F;function K(...T){return(_,q=null,Q)=>(0,M.combinedDisposable)(...T.map(te=>te(U=>_.call(q,U),null,Q)))}a.any=K;function ie(T,_,q,Q){let te=q;return k(T,U=>(te=_(te,U),te),Q)}a.reduce=ie;function oe(T,_){let q;const Q={onFirstListenerAdd(){q=T(te.fire,te)},onLastListenerRemove(){q?.dispose()}};_||l(Q);const te=new y(Q);return _?.add(te),te.event}function ue(T,_,q=100,Q=!1,te,U){let Y,x,re,ce=0;const Ee={leakWarningThreshold:te,onFirstListenerAdd(){Y=T(Pe=>{ce++,x=_(x,Pe),Q&&!re&&(Ce.fire(x),x=void 0),clearTimeout(re),re=setTimeout(()=>{const Me=x;x=void 0,re=void 0,(!Q||ce>1)&&Ce.fire(Me),ce=0},q)})},onLastListenerRemove(){Y.dispose()}};U||l(Ee);const Ce=new y(Ee);return U?.add(Ce),Ce.event}a.debounce=ue;function ne(T,_=(Q,te)=>Q===te,q){let Q=!0,te;return W(T,U=>{const Y=Q||!_(U,te);return Q=!1,te=U,Y},q)}a.latch=ne;function ae(T,_,q){return[a.filter(T,_,q),a.filter(T,Q=>!_(Q),q)]}a.split=ae;function le(T,_=!1,q=[]){let Q=q.slice(),te=T(x=>{Q?Q.push(x):Y.fire(x)});const U=()=>{Q?.forEach(x=>Y.fire(x)),Q=null},Y=new y({onFirstListenerAdd(){te||(te=T(x=>Y.fire(x)))},onFirstListenerDidAdd(){Q&&(_?setTimeout(U):U())},onLastListenerRemove(){te&&te.dispose(),te=null}});return Y.event}a.buffer=le;class G{constructor(_){this.event=_,this.disposables=new M.DisposableStore}map(_){return new G(k(this.event,_,this.disposables))}forEach(_){return new G(A(this.event,_,this.disposables))}filter(_){return new G(W(this.event,_,this.disposables))}reduce(_,q){return new G(ie(this.event,_,q,this.disposables))}latch(){return new G(ne(this.event,void 0,this.disposables))}debounce(_,q=100,Q=!1,te){return new G(ue(this.event,_,q,Q,te,this.disposables))}on(_,q,Q){return this.event(_,q,Q)}once(_,q,Q){return I(this.event)(_,q,Q)}dispose(){this.disposables.dispose()}}function B(T){return new G(T)}a.chain=B;function N(T,_,q=Q=>Q){const Q=(...x)=>Y.fire(q(...x)),te=()=>T.on(_,Q),U=()=>T.removeListener(_,Q),Y=new y({onFirstListenerAdd:te,onLastListenerRemove:U});return Y.event}a.fromNodeEventEmitter=N;function O(T,_,q=Q=>Q){const Q=(...x)=>Y.fire(q(...x)),te=()=>T.addEventListener(_,Q),U=()=>T.removeEventListener(_,Q),Y=new y({onFirstListenerAdd:te,onLastListenerRemove:U});return Y.event}a.fromDOMEventEmitter=O;function H(T){return new Promise(_=>I(T)(_))}a.toPromise=H;function Z(T,_){return _(void 0),T(q=>_(q))}a.runAndSubscribe=Z;function $(T,_){let q=null;function Q(U){q?.dispose(),q=new M.DisposableStore,_(U,q)}Q(void 0);const te=T(U=>Q(U));return(0,M.toDisposable)(()=>{te.dispose(),q?.dispose()})}a.runAndSubscribeWithStore=$;class j{constructor(_,q){this.obs=_,this._counter=0,this._hasChanged=!1;const Q={onFirstListenerAdd:()=>{_.addObserver(this)},onLastListenerRemove:()=>{_.removeObserver(this)}};q||l(Q),this.emitter=new y(Q),q&&q.add(this.emitter)}beginUpdate(_){this._counter++}handleChange(_,q){this._hasChanged=!0}endUpdate(_){--this._counter==0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function L(T,_){return new j(T,_).emitter.event}a.fromObservable=L})(w=e.Event||(e.Event={}));class E{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${E._idPool++}`}start(l){this._stopWatch=new D.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}E._idPool=0;let C=-1;function p(a){const l=C;return C=a,{dispose(){C=l}}}e.setGlobalLeakWarningThreshold=p;class g{constructor(l,I=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=I,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l,I){let k=C;if(typeof this.customThreshold=="number"&&(k=this.customThreshold),k<=0||I<k)return;this._stacks||(this._stacks=new Map);const A=this._stacks.get(l.value)||0;if(this._stacks.set(l.value,A+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=k*.5;let W,F=0;for(const[K,ie]of this._stacks)(!W||F<ie)&&(W=K,F=ie);console.warn(`[${this.name}] potential listener LEAK detected, having ${I} listeners already. MOST frequent listener (${F}):`),console.warn(W)}return()=>{const W=this._stacks.get(l.value)||0;this._stacks.set(l.value,W-1)}}}class d{constructor(l){this.value=l}static create(){return new d(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class P{constructor(l,I,k){this.callback=l,this.callbackThis=I,this.stack=k,this.subscription=new M.SafeDisposable}invoke(l){this.callback.call(this.callbackThis,l)}}class y{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=C>0?new g(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new E(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(b){const l=Array.from(this._listeners);queueMicrotask(()=>{for(const I of l)I.subscription.isset()&&(I.subscription.unset(),I.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(l,I,k)=>{this._listeners||(this._listeners=new R.LinkedList);const A=this._listeners.isEmpty();A&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let W,F;this._leakageMon&&this._listeners.size>=30&&(F=d.create(),W=this._leakageMon.check(F,this._listeners.size+1)),b&&(F=F??d.create());const K=new P(l,I,F),ie=this._listeners.push(K);A&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,I);const oe=K.subscription.set(()=>{W?.(),this._disposed||(ie(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return k instanceof M.DisposableStore?k.add(oe):Array.isArray(k)&&k.push(oe),oe}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new v);for(const I of this._listeners)this._deliveryQueue.push(this,I,l);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=y;class m{constructor(){this._queue=new R.LinkedList}get size(){return this._queue.size}push(l,I,k){this._queue.push(new f(l,I,k))}clear(l){const I=new R.LinkedList;for(const k of this._queue)k.emitter!==l&&I.push(k);this._queue=I}deliver(){for(;this._queue.size>0;){const l=this._queue.shift();try{l.listener.invoke(l.event)}catch(I){(0,S.onUnexpectedError)(I)}}}}e.EventDeliveryQueue=m;class v extends m{clear(l){this._queue.clear()}}class f{constructor(l,I,k){this.emitter=l,this.listener=I,this.event=k}}class u extends y{async fireAsync(l,I,k){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new R.LinkedList);for(const A of this._listeners)this._asyncDeliveryQueue.push([A,l]);for(;this._asyncDeliveryQueue.size>0&&!I.isCancellationRequested;){const[A,W]=this._asyncDeliveryQueue.shift(),F=[],K={...W,token:I,waitUntil:ie=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");k&&(ie=k(ie,A.callback)),F.push(ie)}};try{A.invoke(K)}catch(ie){(0,S.onUnexpectedError)(ie);continue}Object.freeze(F),await Promise.allSettled(F).then(ie=>{for(const oe of ie)oe.status==="rejected"&&(0,S.onUnexpectedError)(oe.reason)})}}}}e.AsyncEmitter=u;class c extends y{constructor(l){super(l);this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=c;class o extends c{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=o;class r extends y{constructor(l){super(l);this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(I=>super.fire(I)),this._queuedEvents=[]})}}e.MicrotaskEmitter=r;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new y({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const I={event:l,listener:null};this.events.push(I),this.hasListeners&&this.hook(I);const k=()=>{this.hasListeners&&this.unhook(I);const A=this.events.indexOf(I);this.events.splice(A,1)};return(0,M.toDisposable)((0,t.once)(k))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(I=>this.emitter.fire(I))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class n{constructor(){this.buffers=[]}wrapEvent(l){return(I,k,A)=>l(W=>{const F=this.buffers[this.buffers.length-1];F?F.push(()=>I.call(k,W)):I.call(k,W)},void 0,A)}bufferEvents(l){const I=[];this.buffers.push(I);const k=l();return this.buffers.pop(),I.forEach(A=>A()),k}}e.EventBufferer=n;class s{constructor(){this.listening=!1,this.inputEvent=w.None,this.inputEventListener=M.Disposable.None,this.emitter=new y({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(X[21],J([0,1,3]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(b,h){const w=setTimeout(b.bind(h),0);return{dispose(){clearTimeout(w)}}});var M;(function(b){function h(w){return w===b.None||w===b.Cancelled||w instanceof R?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}b.isCancellationToken=h,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(M=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new S.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class D{constructor(h){this._token=void 0,this._parentListener=void 0,this._parentListener=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=M.Cancelled}dispose(h=!1){h&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=M.None}}e.CancellationTokenSource=D}),define(X[133],J([0,1,21]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(b){this.task=b,this.result=null}get(){if(this.result)return this.result;const b=new S.CancellationTokenSource,h=this.task(b.token);return this.result={promise:h,dispose:()=>{this.result=null,b.cancel(),b.dispose()}},this.result}}e.Cache=t;class M{constructor(b){this.fn=b,this.lastCache=void 0,this.lastArgKey=void 0}get(b){const h=JSON.stringify(b);return this.lastArgKey!==h&&(this.lastArgKey=h,this.lastCache=this.fn(b)),this.lastCache}}e.LRUCachedFunction=M;class R{constructor(b){this.fn=b,this._map=new Map}get cachedValues(){return this._map}get(b){if(this._map.has(b))return this._map.get(b);const h=this.fn(b);return this._map.set(b,h),h}}e.CachedFunction=R}),define(X[91],J([0,1,3,2]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const M=D=>({onDidChange:S.Event.None,value:D});e.staticObservableValue=M;class R extends t.Disposable{constructor(b){super();this._value=b,this.changeEmitter=this._register(new S.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(b){b!==this._value&&(this._value=b,this.changeEmitter.fire(b))}}e.MutableObservableValue=R}),define(X[30],J([0,1,133,121]),function(z,e,S,t){"use strict";var M;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(V){return!V||typeof V!="string"?!0:V.trim().length===0}e.isFalsyOrWhitespace=R;const D=/{(\d+)}/g;function b(V,...se){return se.length===0?V:V.replace(D,function(he,me){const be=parseInt(me,10);return isNaN(be)||be<0||be>=se.length?he:se[be]})}e.format=b;const h=/{([^}]+)}/g;function w(V,se){return V.replace(h,(he,me)=>se[me]??he)}e.format2=w;function E(V){return V.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=E;function C(V){return V.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=C;function p(V,se){let he=0;const me=se.charCodeAt(0);for(let be=V.length-1;be>=0;be--)V.charCodeAt(be)===me&&he++;return he}e.count=p;function g(V,se,he="\u2026"){return V.length<=se?V:`${V.substr(0,se)}${he}`}e.truncate=g;function d(V,se=" "){const he=P(V,se);return y(he,se)}e.trim=d;function P(V,se){if(!V||!se)return V;const he=se.length;if(he===0||V.length===0)return V;let me=0;for(;V.indexOf(se,me)===me;)me=me+he;return V.substring(me)}e.ltrim=P;function y(V,se){if(!V||!se)return V;const he=se.length,me=V.length;if(he===0||me===0)return V;let be=me,Ae=-1;for(;Ae=V.lastIndexOf(se,be-1),!(Ae===-1||Ae+he!==be);){if(Ae===0)return"";be=Ae}return V.substring(0,be)}e.rtrim=y;function m(V){return V.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=m;function v(V){return V.replace(/\*/g,"")}e.stripWildcards=v;function f(V,se,he={}){if(!V)throw new Error("Cannot create regex from empty string");se||(V=C(V)),he.wholeWord&&(/\B/.test(V.charAt(0))||(V="\\b"+V),/\B/.test(V.charAt(V.length-1))||(V=V+"\\b"));let me="";return he.global&&(me+="g"),he.matchCase||(me+="i"),he.multiline&&(me+="m"),he.unicode&&(me+="u"),new RegExp(V,me)}e.createRegExp=f;function u(V){return V.source==="^"||V.source==="^$"||V.source==="$"||V.source==="^\\s*$"?!1:!!(V.exec("")&&V.lastIndex===0)}e.regExpLeadsToEndlessLoop=u;function c(V){return!!V.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function o(V){return(V.global?"g":"")+(V.ignoreCase?"i":"")+(V.multiline?"m":"")+(V.unicode?"u":"")}e.regExpFlags=o;function r(V){return V.split(/\r\n|\r|\n/)}e.splitLines=r;function i(V){for(let se=0,he=V.length;se<he;se++){const me=V.charCodeAt(se);if(me!==32&&me!==9)return se}return-1}e.firstNonWhitespaceIndex=i;function n(V,se=0,he=V.length){for(let me=se;me<he;me++){const be=V.charCodeAt(me);if(be!==32&&be!==9)return V.substring(se,me)}return V.substring(se,he)}e.getLeadingWhitespace=n;function s(V,se=V.length-1){for(let he=se;he>=0;he--){const me=V.charCodeAt(he);if(me!==32&&me!==9)return he}return-1}e.lastNonWhitespaceIndex=s;function a(V,se,he){const me=[];let be=0;for(const Ae of V.matchAll(se)){if(me.push(V.slice(be,Ae.index)),Ae.index===void 0)throw new Error("match.index should be defined");be=Ae.index+Ae[0].length,me.push(he(Ae[0],...Ae.slice(1),Ae.index,V,Ae.groups))}return me.push(V.slice(be)),Promise.all(me).then(Ae=>Ae.join(""))}e.replaceAsync=a;function l(V,se){return V<se?-1:V>se?1:0}e.compare=l;function I(V,se,he=0,me=V.length,be=0,Ae=se.length){for(;he<me&&be<Ae;he++,be++){const et=V.charCodeAt(he),He=se.charCodeAt(be);if(et<He)return-1;if(et>He)return 1}const qe=me-he,nt=Ae-be;return qe<nt?-1:qe>nt?1:0}e.compareSubstring=I;function k(V,se){return A(V,se,0,V.length,0,se.length)}e.compareIgnoreCase=k;function A(V,se,he=0,me=V.length,be=0,Ae=se.length){for(;he<me&&be<Ae;he++,be++){let et=V.charCodeAt(he),He=se.charCodeAt(be);if(et===He)continue;if(et>=128||He>=128)return I(V.toLowerCase(),se.toLowerCase(),he,me,be,Ae);F(et)&&(et-=32),F(He)&&(He-=32);const Ze=et-He;if(Ze!==0)return Ze}const qe=me-he,nt=Ae-be;return qe<nt?-1:qe>nt?1:0}e.compareSubstringIgnoreCase=A;function W(V){return V>=48&&V<=57}e.isAsciiDigit=W;function F(V){return V>=97&&V<=122}e.isLowerAsciiLetter=F;function K(V){return V>=65&&V<=90}e.isUpperAsciiLetter=K;function ie(V,se){return V.length===se.length&&A(V,se)===0}e.equalsIgnoreCase=ie;function oe(V,se){const he=se.length;return se.length>V.length?!1:A(V,se,0,he)===0}e.startsWithIgnoreCase=oe;function ue(V,se){const he=Math.min(V.length,se.length);let me;for(me=0;me<he;me++)if(V.charCodeAt(me)!==se.charCodeAt(me))return me;return he}e.commonPrefixLength=ue;function ne(V,se){const he=Math.min(V.length,se.length);let me;const be=V.length-1,Ae=se.length-1;for(me=0;me<he;me++)if(V.charCodeAt(be-me)!==se.charCodeAt(Ae-me))return me;return he}e.commonSuffixLength=ne;function ae(V){return 55296<=V&&V<=56319}e.isHighSurrogate=ae;function le(V){return 56320<=V&&V<=57343}e.isLowSurrogate=le;function G(V,se){return(V-55296<<10)+(se-56320)+65536}e.computeCodePoint=G;function B(V,se,he){const me=V.charCodeAt(he);if(ae(me)&&he+1<se){const be=V.charCodeAt(he+1);if(le(be))return G(me,be)}return me}e.getNextCodePoint=B;function N(V,se){const he=V.charCodeAt(se-1);if(le(he)&&se>1){const me=V.charCodeAt(se-2);if(ae(me))return G(me,he)}return he}class O{constructor(se,he=0){this._str=se,this._len=se.length,this._offset=he}get offset(){return this._offset}setOffset(se){this._offset=se}prevCodePoint(){const se=N(this._str,this._offset);return this._offset-=se>=65536?2:1,se}nextCodePoint(){const se=B(this._str,this._len,this._offset);return this._offset+=se>=65536?2:1,se}eol(){return this._offset>=this._len}}e.CodePointIterator=O;class H{constructor(se,he=0){this._iterator=new O(se,he)}get offset(){return this._iterator.offset}nextGraphemeLength(){const se=Re.getInstance(),he=this._iterator,me=he.offset;let be=se.getGraphemeBreakType(he.nextCodePoint());for(;!he.eol();){const Ae=he.offset,qe=se.getGraphemeBreakType(he.nextCodePoint());if(Le(be,qe)){he.setOffset(Ae);break}be=qe}return he.offset-me}prevGraphemeLength(){const se=Re.getInstance(),he=this._iterator,me=he.offset;let be=se.getGraphemeBreakType(he.prevCodePoint());for(;he.offset>0;){const Ae=he.offset,qe=se.getGraphemeBreakType(he.prevCodePoint());if(Le(qe,be)){he.setOffset(Ae);break}be=qe}return me-he.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=H;function Z(V,se){return new H(V,se).nextGraphemeLength()}e.nextCharLength=Z;function $(V,se){return new H(V,se).prevGraphemeLength()}e.prevCharLength=$;function j(V,se){se>0&&le(V.charCodeAt(se))&&se--;const he=se+Z(V,se);return[he-$(V,he),he]}e.getCharContainingOffset=j;const L=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function T(V){return L.test(V)}e.containsRTL=T;const _=/^[\t\n\r\x20-\x7E]*$/;function q(V){return _.test(V)}e.isBasicASCII=q,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Q(V){return e.UNUSUAL_LINE_TERMINATORS.test(V)}e.containsUnusualLineTerminators=Q;function te(V){return V>=11904&&V<=55215||V>=63744&&V<=64255||V>=65281&&V<=65374}e.isFullWidthCharacter=te;function U(V){return V>=127462&&V<=127487||V===8986||V===8987||V===9200||V===9203||V>=9728&&V<=10175||V===11088||V===11093||V>=127744&&V<=128591||V>=128640&&V<=128764||V>=128992&&V<=129008||V>=129280&&V<=129535||V>=129648&&V<=129782}e.isEmojiImprecise=U;function Y(V,se){if(V.length<se)return V;const he=/\b/g;let me=0;for(;he.test(V)&&!(V.length-he.lastIndex<se);)me=he.lastIndex,he.lastIndex+=1;return V.substring(me).replace(/^\s/,"")}e.lcut=Y;const x=/\x1B\x5B[12]?K/g,re=/\x1b\[\d+m/g,ce=/\x1b\[0?m/g;function Ee(V){return V&&(V=V.replace(x,""),V=V.replace(re,""),V=V.replace(ce,"")),V}e.removeAnsiEscapeCodes=Ee,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(V){return!!(V&&V.length>0&&V.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function Pe(V){return Ce(V)?V.substr(1):V}e.stripUTF8BOM=Pe;function Me(V,se){if(!V||!se||V.length<se.length)return!1;const he=se.length,me=V.toLowerCase();let be=0,Ae=-1;for(;be<he;){const qe=me.indexOf(se[be],Ae+1);if(qe<0)return!1;Ae=qe,be++}return!0}e.fuzzyContains=Me;function Be(V,se=!1){return V?(se&&(V=V.replace(/\\./g,"")),V.toLowerCase()!==V):!1}e.containsUppercaseCharacter=Be;function de(V){return V.charAt(0).toUpperCase()+V.slice(1)}e.uppercaseFirstLetter=de;function fe(V,se=1){if(se===0)return"";let he=-1;do he=V.indexOf(`
`,he+1),se--;while(se>0&&he>=0);return he===-1?V:(V[he-1]==="\r"&&he--,V.substr(0,he))}e.getNLines=fe;function pe(V){const se=90-65+1;return V=V%(2*se),V<se?String.fromCharCode(97+V):String.fromCharCode(65+V-se)}e.singleLetterHash=pe;function Ie(V){return Re.getInstance().getGraphemeBreakType(V)}e.getGraphemeBreakType=Ie;function Le(V,se){return V===0?se!==5&&se!==7:V===2&&se===3?!1:V===4||V===2||V===3||se===4||se===2||se===3?!0:!(V===8&&(se===8||se===9||se===11||se===12)||(V===11||V===9)&&(se===9||se===10)||(V===12||V===10)&&se===10||se===5||se===13||se===7||V===1||V===13&&se===14||V===6&&se===6)}var Xe;(function(V){V[V.Other=0]="Other",V[V.Prepend=1]="Prepend",V[V.CR=2]="CR",V[V.LF=3]="LF",V[V.Control=4]="Control",V[V.Extend=5]="Extend",V[V.Regional_Indicator=6]="Regional_Indicator",V[V.SpacingMark=7]="SpacingMark",V[V.L=8]="L",V[V.V=9]="V",V[V.T=10]="T",V[V.LV=11]="LV",V[V.LVT=12]="LVT",V[V.ZWJ=13]="ZWJ",V[V.Extended_Pictographic=14]="Extended_Pictographic"})(Xe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Re{constructor(){this._data=We()}static getInstance(){return Re._INSTANCE||(Re._INSTANCE=new Re),Re._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const he=this._data,me=he.length/3;let be=1;for(;be<=me;)if(se<he[3*be])be=2*be;else if(se>he[3*be+1])be=2*be+1;else return he[3*be+2];return 0}}Re._INSTANCE=null;function We(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Te(V,se){if(V===0)return 0;const he=Ge(V,se);if(he!==void 0)return he;const me=new O(se,V);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=Te;function Ge(V,se){const he=new O(se,V);let me=he.prevCodePoint();for(;je(me)||me===65039||me===8419;){if(he.offset===0)return;me=he.prevCodePoint()}if(!U(me))return;let be=he.offset;return be>0&&he.prevCodePoint()===8205&&(be=he.offset),be}function je(V){return 127995<=V&&V<=127999}var Je;(function(V){V[V.zwj=8205]="zwj",V[V.emojiVariantSelector=65039]="emojiVariantSelector",V[V.enclosingKeyCap=8419]="enclosingKeyCap"})(Je||(Je={})),e.noBreakWhitespace="\xA0";class ze{constructor(se){this.confusableDictionary=se}static getInstance(se){return ze.cache.get(Array.from(se))}static getLocales(){return ze._locales.getValue()}isAmbiguous(se){return this.confusableDictionary.has(se)}getPrimaryConfusable(se){return this.confusableDictionary.get(se)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=ze,M=ze,ze.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ze.cache=new S.LRUCachedFunction(V=>{function se(He){const Ze=new Map;for(let xe=0;xe<He.length;xe+=2)Ze.set(He[xe],He[xe+1]);return Ze}function he(He,Ze){const xe=new Map(He);for(const[at,ct]of Ze)xe.set(at,ct);return xe}function me(He,Ze){if(!He)return Ze;const xe=new Map;for(const[at,ct]of He)Ze.has(at)&&xe.set(at,ct);return xe}const be=M.ambiguousCharacterData.getValue();let Ae=V.filter(He=>!He.startsWith("_")&&He in be);Ae.length===0&&(Ae=["_default"]);let qe;for(const He of Ae){const Ze=se(be[He]);qe=me(qe,Ze)}const nt=se(be._common),et=he(nt,qe);return new ze(et)}),ze._locales=new t.Lazy(()=>Object.keys(ze.ambiguousCharacterData.getValue()).filter(V=>!V.startsWith("_")));class Ve{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ve.getRawData())),this._data}static isInvisibleCharacter(se){return Ve.getData().has(se)}static get codePoints(){return Ve.getData()}}e.InvisibleCharacters=Ve,Ve._data=void 0}),define(X[31],J([0,1,9,4,30,11]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(s){return s===47||s===92}e.isPathSeparator=D;function b(s){return s.replace(/[\\/]/g,S.posix.sep)}e.toSlashes=b;function h(s){return s.indexOf("/")===-1&&(s=b(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=h;function w(s,a=S.posix.sep){if(!s)return"";const l=s.length,I=s.charCodeAt(0);if(D(I)){if(D(s.charCodeAt(1))&&!D(s.charCodeAt(2))){let A=3;const W=A;for(;A<l&&!D(s.charCodeAt(A));A++);if(W!==A&&!D(s.charCodeAt(A+1))){for(A+=1;A<l;A++)if(D(s.charCodeAt(A)))return s.slice(0,A+1).replace(/[\\/]/g,a)}}return a}else if(m(I)&&s.charCodeAt(1)===58)return D(s.charCodeAt(2))?s.slice(0,2)+a:s.slice(0,2);let k=s.indexOf("://");if(k!==-1){for(k+=3;k<l;k++)if(D(s.charCodeAt(k)))return s.slice(0,k+1)}return""}e.getRoot=w;function E(s){if(!t.isWindows||!s||s.length<5)return!1;let a=s.charCodeAt(0);if(a!==92||(a=s.charCodeAt(1),a!==92))return!1;let l=2;const I=l;for(;l<s.length&&(a=s.charCodeAt(l),a!==92);l++);return!(I===l||(a=s.charCodeAt(l+1),isNaN(a)||a===92))}e.isUNC=E;const C=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(s,a=t.isWindows){const l=a?C:p;return!(!s||s.length===0||/^\s+$/.test(s)||(l.lastIndex=0,l.test(s))||a&&g.test(s)||s==="."||s===".."||a&&s[s.length-1]==="."||a&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=d;function P(s,a,l){const I=s===a;return!l||I?I:!s||!a?!1:(0,M.equalsIgnoreCase)(s,a)}e.isEqual=P;function y(s,a,l,I=S.sep){if(s===a)return!0;if(!s||!a||a.length>s.length)return!1;if(l){if(!(0,M.startsWithIgnoreCase)(s,a))return!1;if(a.length===s.length)return!0;let A=a.length;return a.charAt(a.length-1)===I&&A--,s.charAt(A)===I}return a.charAt(a.length-1)!==I&&(a+=I),s.indexOf(a)===0}e.isEqualOrParent=y;function m(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=m;function v(s,a){return t.isWindows&&s.endsWith(":")&&(s+=S.sep),(0,S.isAbsolute)(s)||(s=(0,S.join)(a,s)),s=(0,S.normalize)(s),t.isWindows?(s=(0,M.rtrim)(s,S.sep),s.endsWith(":")&&(s+=S.sep)):(s=(0,M.rtrim)(s,S.sep),s||(s=S.sep)),s}e.sanitizeFilePath=v;function f(s){const a=(0,S.normalize)(s);return t.isWindows?s.length>3?!1:u(a)&&(s.length===2||a.charCodeAt(2)===92):a===S.posix.sep}e.isRootOrDriveLetter=f;function u(s,a=t.isWindows){return a?m(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=u;function c(s){return u(s)?s[0]:void 0}e.getDriveLetter=c;function o(s,a,l){return a.length>s.length?-1:s===a?0:(l&&(s=s.toLowerCase(),a=a.toLowerCase()),s.indexOf(a))}e.indexOfPath=o;function r(s){const a=s.split(":");let l,I,k;for(const A of a){const W=Number(A);(0,R.isNumber)(W)?I===void 0?I=W:k===void 0&&(k=W):l=l?[l,A].join(":"):A}if(!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:I!==void 0?I:void 0,column:k!==void 0?k:I!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(s,a,l=8){let I="";for(let A=0;A<l;A++)I+=i.charAt(Math.floor(Math.random()*i.length));let k;return a?k=`${a}-${I}`:k=I,s?(0,S.join)(s,k):k}e.randomPath=n}),define(X[65],J([0,1,30]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(m){return M(m,0)}e.hash=t;function M(m,v){switch(typeof m){case"object":return m===null?R(349,v):Array.isArray(m)?h(m,v):w(m,v);case"string":return b(m,v);case"boolean":return D(m,v);case"number":return R(m,v);case"undefined":return R(937,v);default:return R(617,v)}}e.doHash=M;function R(m,v){return(v<<5)-v+m|0}e.numberHash=R;function D(m,v){return R(m?433:863,v)}function b(m,v){v=R(149417,v);for(let f=0,u=m.length;f<u;f++)v=R(m.charCodeAt(f),v);return v}e.stringHash=b;function h(m,v){return v=R(104579,v),m.reduce((f,u)=>M(u,f),v)}function w(m,v){return v=R(181387,v),Object.keys(m).sort().reduce((f,u)=>(f=b(u,f),M(m[u],f)),v)}class E{constructor(){this._value=0}get value(){return this._value}hash(v){return this._value=M(v,this._value),this._value}}e.Hasher=E;var C;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function p(m,v,f=32){const u=f-v,c=~((1<<u)-1);return(m<<v|(c&m)>>>u)>>>0}function g(m,v=0,f=m.byteLength,u=0){for(let c=0;c<f;c++)m[v+c]=u}function d(m,v,f="0"){for(;m.length<v;)m=f+m;return m}function P(m,v=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(f=>f.toString(16).padStart(2,"0")).join(""):d((m>>>0).toString(16),v/4)}e.toHexString=P;class y{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(v){const f=v.length;if(f===0)return;const u=this._buff;let c=this._buffLen,o=this._leftoverHighSurrogate,r,i;for(o!==0?(r=o,i=-1,o=0):(r=v.charCodeAt(0),i=0);;){let n=r;if(S.isHighSurrogate(r))if(i+1<f){const s=v.charCodeAt(i+1);S.isLowSurrogate(s)?(i++,n=S.computeCodePoint(r,s)):n=65533}else{o=r;break}else S.isLowSurrogate(r)&&(n=65533);if(c=this._push(u,c,n),i++,i<f)r=v.charCodeAt(i);else break}this._buffLen=c,this._leftoverHighSurrogate=o}_push(v,f,u){return u<128?v[f++]=u:u<2048?(v[f++]=192|(u&1984)>>>6,v[f++]=128|(u&63)>>>0):u<65536?(v[f++]=224|(u&61440)>>>12,v[f++]=128|(u&4032)>>>6,v[f++]=128|(u&63)>>>0):(v[f++]=240|(u&1835008)>>>18,v[f++]=128|(u&258048)>>>12,v[f++]=128|(u&4032)>>>6,v[f++]=128|(u&63)>>>0),f>=64&&(this._step(),f-=64,this._totalLen+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),f}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),P(this._h0)+P(this._h1)+P(this._h2)+P(this._h3)+P(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,g(this._buff,this._buffLen),this._buffLen>56&&(this._step(),g(this._buff));const v=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(v/4294967296),!1),this._buffDV.setUint32(60,v%4294967296,!1),this._step()}_step(){const v=y._bigBlock32,f=this._buffDV;for(let l=0;l<64;l+=4)v.setUint32(l,f.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)v.setUint32(l,p(v.getUint32(l-12,!1)^v.getUint32(l-32,!1)^v.getUint32(l-56,!1)^v.getUint32(l-64,!1),1),!1);let u=this._h0,c=this._h1,o=this._h2,r=this._h3,i=this._h4,n,s,a;for(let l=0;l<80;l++)l<20?(n=c&o|~c&r,s=1518500249):l<40?(n=c^o^r,s=1859775393):l<60?(n=c&o|c&r|o&r,s=2400959708):(n=c^o^r,s=3395469782),a=p(u,5)+n+i+s+v.getUint32(l*4,!1)&4294967295,i=r,r=o,o=p(c,30),c=u,u=a;this._h0=this._h0+u&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+o&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=y,y._bigBlock32=new DataView(new ArrayBuffer(320))}),define(X[33],J([0,1,25,30]),function(z,e,S,t){"use strict";var M,R,D;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function b(i,n,s){let a=i.get(n);return a===void 0&&(a=s,i.set(n,a)),a}e.getOrSet=b;function h(i){const n=[];return i.forEach((s,a)=>{n.push(`${a} => ${s}`)}),`Map(${i.size}) {${n.join(", ")}}`}e.mapToString=h;function w(i){const n=[];return i.forEach(s=>{n.push(s)}),`Set(${i.size}) {${n.join(", ")}}`}e.setToString=w;class E{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const s=n.charCodeAt(0),a=this._value.charCodeAt(this._pos);return s-a}value(){return this._value[this._pos]}}e.StringIterator=E;class C{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class p{constructor(n=!0,s=!0){this._splitOnBackslash=n,this._caseSensitive=s}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let s=n.length-1;s>=0;s--,this._valueLen--){const a=this._value.charCodeAt(s);if(!(a===47||this._splitOnBackslash&&a===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=p;var g;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(g||(g={}));class d{constructor(n,s){this._ignorePathCasing=n,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new p(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(n)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,t.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class P{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(y||(y={}));class m{constructor(n){this._iter=n}static forUris(n=()=>!1,s=()=>!1){return new m(new d(n,s))}static forPaths(n=!1){return new m(new p(void 0,!n))}static forStrings(){return new m(new E)}static forConfigKeys(){return new m(new C)}clear(){this._root=void 0}fill(n,s){if(s){const a=s.slice(0);(0,S.shuffle)(a);for(const l of a)this.set(l,n)}else{const a=n.slice(0);(0,S.shuffle)(a);for(const l of a)this.set(l[0],l[1])}}set(n,s){const a=this._iter.reset(n);let l;this._root||(this._root=new P,this._root.segment=a.value());const I=[];for(l=this._root;;){const A=a.cmp(l.segment);if(A>0)l.left||(l.left=new P,l.left.segment=a.value()),I.push([-1,l]),l=l.left;else if(A<0)l.right||(l.right=new P,l.right.segment=a.value()),I.push([1,l]),l=l.right;else if(a.hasNext())a.next(),l.mid||(l.mid=new P,l.mid.segment=a.value()),I.push([0,l]),l=l.mid;else break}const k=l.value;l.value=s,l.key=n;for(let A=I.length-1;A>=0;A--){const W=I[A][1];W.updateHeight();const F=W.balanceFactor();if(F<-1||F>1){const K=I[A][0],ie=I[A+1][0];if(K===1&&ie===1)I[A][1]=W.rotateLeft();else if(K===-1&&ie===-1)I[A][1]=W.rotateRight();else if(K===1&&ie===-1)W.right=I[A+1][1]=I[A+1][1].rotateRight(),I[A][1]=W.rotateLeft();else if(K===-1&&ie===1)W.left=I[A+1][1]=I[A+1][1].rotateLeft(),I[A][1]=W.rotateRight();else throw new Error;if(A>0)switch(I[A-1][0]){case-1:I[A-1][1].left=I[A][1];break;case 1:I[A-1][1].right=I[A][1];break;case 0:I[A-1][1].mid=I[A][1];break}else this._root=I[0][1]}}return k}get(n){return this._getNode(n)?.value}_getNode(n){const s=this._iter.reset(n);let a=this._root;for(;a;){const l=s.cmp(a.segment);if(l>0)a=a.left;else if(l<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else break}return a}has(n){const s=this._getNode(n);return!(s?.value===void 0&&s?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,s){const a=this._iter.reset(n),l=[];let I=this._root;for(;I;){const k=a.cmp(I.segment);if(k>0)l.push([-1,I]),I=I.left;else if(k<0)l.push([1,I]),I=I.right;else if(a.hasNext())a.next(),l.push([0,I]),I=I.mid;else break}if(!!I){if(s?(I.left=void 0,I.mid=void 0,I.right=void 0,I.height=1):(I.key=void 0,I.value=void 0),!I.mid&&!I.value)if(I.left&&I.right){const k=this._min(I.right),{key:A,value:W,segment:F}=k;this._delete(k.key,!1),I.key=A,I.value=W,I.segment=F}else{const k=I.left??I.right;if(l.length>0){const[A,W]=l[l.length-1];switch(A){case-1:W.left=k;break;case 0:W.mid=k;break;case 1:W.right=k;break}}else this._root=k}for(let k=l.length-1;k>=0;k--){const A=l[k][1];A.updateHeight();const W=A.balanceFactor();if(W>1?(A.right.balanceFactor()>=0||(A.right=A.right.rotateRight()),l[k][1]=A.rotateLeft()):W<-1&&(A.left.balanceFactor()<=0||(A.left=A.left.rotateLeft()),l[k][1]=A.rotateRight()),k>0)switch(l[k-1][0]){case-1:l[k-1][1].left=l[k][1];break;case 1:l[k-1][1].right=l[k][1];break;case 0:l[k-1][1].mid=l[k][1];break}else this._root=l[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const s=this._iter.reset(n);let a=this._root,l;for(;a;){const I=s.cmp(a.segment);if(I>0)a=a.left;else if(I<0)a=a.right;else if(s.hasNext())s.next(),l=a.value||l,a=a.mid;else break}return a&&a.value||l}findSuperstr(n){const s=this._iter.reset(n);let a=this._root;for(;a;){const l=s.cmp(a.segment);if(l>0)a=a.left;else if(l<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(n){for(const[s,a]of this)n(a,s)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(n){const s=[];return this._dfsEntries(n,s),s[Symbol.iterator]()}_dfsEntries(n,s){!n||(n.left&&this._dfsEntries(n.left,s),n.value&&s.push([n.key,n.value]),n.mid&&this._dfsEntries(n.mid,s),n.right&&this._dfsEntries(n.right,s))}_isBalanced(){const n=s=>{if(!s)return!0;const a=s.balanceFactor();return a<-1||a>1?!1:n(s.left)&&n(s.right)};return n(this._root)}}e.TernarySearchTree=m;class v{constructor(n,s){this.uri=n,this.value=s}}class f{constructor(n,s){this[M]="ResourceMap",n instanceof f?(this.map=new Map(n.map),this.toKey=s??f.defaultToKey):(this.map=new Map,this.toKey=n??f.defaultToKey)}set(n,s){return this.map.set(this.toKey(n),new v(n,s)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,s){typeof s!="undefined"&&(n=n.bind(s));for(const[a,l]of this.map)n(l.value,l.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(M=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=f,f.defaultToKey=i=>i.toString();class u{constructor(n,s){this[R]="ResourceSet",!n||typeof n=="function"?this._map=new f(n):(this._map=new f(s),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,s){this._map.forEach((a,l)=>n.call(s,l,l,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=u;var c;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(c=e.Touch||(e.Touch={}));class o{constructor(){this[D]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,s=0){const a=this._map.get(n);if(!!a)return s!==0&&this.touch(a,s),a.value}set(n,s,a=0){let l=this._map.get(n);if(l)l.value=s,a!==0&&this.touch(l,a);else{switch(l={key:n,value:s,next:void 0,previous:void 0},a){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(n,l),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this._map.get(n);if(!!s)return this._map.delete(n),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,s){const a=this._state;let l=this._head;for(;l;){if(s?n.bind(s)(l.value,l.key,this):n(l.value,l.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const n=this,s=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const I={value:a.key,done:!1};return a=a.next,I}else return{value:void 0,done:!0}}};return l}values(){const n=this,s=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const I={value:a.value,done:!1};return a=a.next,I}else return{value:void 0,done:!0}}};return l}entries(){const n=this,s=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const I={value:[a.key,a.value],done:!1};return a=a.next,I}else return{value:void 0,done:!0}}};return l}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this._head,a=this.size;for(;s&&a>n;)this._map.delete(s.key),s=s.next,a--;this._head=s,this._size=a,s&&(s.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const s=n.next,a=n.previous;if(!s||!a)throw new Error("Invalid list");s.previous=a,a.next=s}n.next=void 0,n.previous=void 0,this._state++}touch(n,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this._head)return;const a=n.next,l=n.previous;n===this._tail?(l.next=void 0,this._tail=l):(a.previous=l,l.next=a),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(s===2){if(n===this._tail)return;const a=n.next,l=n.previous;n===this._head?(a.previous=void 0,this._head=a):(a.previous=l,l.next=a),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((s,a)=>{n.push([a,s])}),n}fromJSON(n){this.clear();for(const[s,a]of n)this.set(s,a)}}e.LinkedMap=o;class r extends o{constructor(n,s=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r}),define(X[79],J([0,1,33]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new S.LRUCache(1e4);function M(w){return h(w,"NFC",t)}e.normalizeNFC=M;const R=new S.LRUCache(1e4);function D(w){return h(w,"NFD",R)}e.normalizeNFD=D;const b=/[^\u0000-\u0080]/;function h(w,E,C){if(!w)return w;const p=C.get(w);if(p)return p;let g;return b.test(w)?g=w.normalize(E):g=w,C.set(w,g),g}e.removeAccents=function(){const w=/[\u0300-\u036f]/g;return function(E){return D(E).replace(w,"")}}()}),define(X[7],J([0,1,9,4]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const M=/^\w[\w\d+.-]*$/,R=/^\//,D=/^\/\//;function b(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!M.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!R.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(i,n){return!i&&!n?"file":i}function w(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==C&&(n=C+n):n=C;break}return n}const E="",C="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{constructor(n,s,a,l,I,k=!1){typeof n=="object"?(this.scheme=n.scheme||E,this.authority=n.authority||E,this.path=n.path||E,this.query=n.query||E,this.fragment=n.fragment||E):(this.scheme=h(n,k),this.authority=s||E,this.path=w(this.scheme,a||E),this.query=l||E,this.fragment=I||E,b(this,k))}static isUri(n){return n instanceof g?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return f(this,!1)}with(n){if(!n)return this;let{scheme:s,authority:a,path:l,query:I,fragment:k}=n;return s===void 0?s=this.scheme:s===null&&(s=E),a===void 0?a=this.authority:a===null&&(a=E),l===void 0?l=this.path:l===null&&(l=E),I===void 0?I=this.query:I===null&&(I=E),k===void 0?k=this.fragment:k===null&&(k=E),s===this.scheme&&a===this.authority&&l===this.path&&I===this.query&&k===this.fragment?this:new P(s,a,l,I,k)}static parse(n,s=!1){const a=p.exec(n);return a?new P(a[2]||E,r(a[4]||E),r(a[5]||E),r(a[7]||E),r(a[9]||E),s):new P(E,E,E,E,E)}static file(n){let s=E;if(t.isWindows&&(n=n.replace(/\\/g,C)),n[0]===C&&n[1]===C){const a=n.indexOf(C,2);a===-1?(s=n.substring(2),n=C):(s=n.substring(2,a),n=n.substring(a)||C)}return new P("file",s,n,E,E)}static from(n){const s=new P(n.scheme,n.authority,n.path,n.query,n.fragment);return b(s,!0),s}static joinPath(n,...s){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return t.isWindows&&n.scheme==="file"?a=g.file(S.win32.join(f(n,!0),...s)).path:a=S.posix.join(n.path,...s),n.with({path:a})}toString(n=!1){return u(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof g)return n;{const s=new P(n);return s._formatted=n.external,s._fsPath=n._sep===d?n.fsPath:null,s}}else return n}}e.URI=g;const d=t.isWindows?1:void 0;class P extends g{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(n=!1){return n?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=d),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const y={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(i,n){let s,a=-1;for(let l=0;l<i.length;l++){const I=i.charCodeAt(l);if(I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57||I===45||I===46||I===95||I===126||n&&I===47)a!==-1&&(s+=encodeURIComponent(i.substring(a,l)),a=-1),s!==void 0&&(s+=i.charAt(l));else{s===void 0&&(s=i.substr(0,l));const k=y[I];k!==void 0?(a!==-1&&(s+=encodeURIComponent(i.substring(a,l)),a=-1),s+=k):a===-1&&(a=l)}}return a!==-1&&(s+=encodeURIComponent(i.substring(a))),s!==void 0?s:i}function v(i){let n;for(let s=0;s<i.length;s++){const a=i.charCodeAt(s);a===35||a===63?(n===void 0&&(n=i.substr(0,s)),n+=y[a]):n!==void 0&&(n+=i[s])}return n!==void 0?n:i}function f(i,n){let s;return i.authority&&i.path.length>1&&i.scheme==="file"?s=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?s=i.path.substr(1):s=i.path[1].toLowerCase()+i.path.substr(2):s=i.path,t.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=f;function u(i,n){const s=n?v:m;let a="",{scheme:l,authority:I,path:k,query:A,fragment:W}=i;if(l&&(a+=l,a+=":"),(I||l==="file")&&(a+=C,a+=C),I){let F=I.indexOf("@");if(F!==-1){const K=I.substr(0,F);I=I.substr(F+1),F=K.indexOf(":"),F===-1?a+=s(K,!1):(a+=s(K.substr(0,F),!1),a+=":",a+=s(K.substr(F+1),!1)),a+="@"}I=I.toLowerCase(),F=I.indexOf(":"),F===-1?a+=s(I,!1):(a+=s(I.substr(0,F),!1),a+=I.substr(F))}if(k){if(k.length>=3&&k.charCodeAt(0)===47&&k.charCodeAt(2)===58){const F=k.charCodeAt(1);F>=65&&F<=90&&(k=`/${String.fromCharCode(F+32)}:${k.substr(3)}`)}else if(k.length>=2&&k.charCodeAt(1)===58){const F=k.charCodeAt(0);F>=65&&F<=90&&(k=`${String.fromCharCode(F+32)}:${k.substr(2)}`)}a+=s(k,!0)}return A&&(a+="?",a+=s(A,!1)),W&&(a+="#",a+=n?W:m(W,!1)),a}function c(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+c(i.substr(3)):i}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(o)?i.replace(o,n=>c(n)):i}}),define(X[134],J([0,1,7]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(w){const E=w;return E&&typeof E.type=="string"&&typeof E.severity=="string"}e.isRemoteConsoleLog=t;function M(w){const E=[];let C;try{const p=JSON.parse(w.arguments),g=p[p.length-1];g&&g.__$stack&&(p.pop(),C=g.__$stack),E.push(...p)}catch{E.push("Unable to log remote console arguments",w.arguments)}return{args:E,stack:C}}e.parse=M;function R(w){if(typeof w!="string")return R(M(w).stack);const E=w;if(E){const C=D(E),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(p&&p.length===4)return{uri:S.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.getFirstFrame=R;function D(w){if(!w)return w;const E=w.indexOf(`
`);return E===-1?w:w.substring(0,E)}function b(w,E){const{args:C,stack:p}=M(w),g=typeof C[0]=="string"&&C.length===1;let d=D(p);d&&(d=`(${d.trim()})`);let P=[];if(typeof C[0]=="string"?d&&g?P=[`%c[${E}] %c${C[0]} %c${d}`,h("blue"),h(""),h("grey")]:P=[`%c[${E}] %c${C[0]}`,h("blue"),h(""),...C.slice(1)]:P=[`%c[${E}]%`,h("blue"),...C],d&&!g&&P.push(d),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,P)}e.log=b;function h(w){return`color: ${w}`}}),define(X[66],J([0,1,17,30,7]),function(z,e,S,t,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(w){return JSON.stringify(w,b)}e.stringify=R;function D(w){let E=JSON.parse(w);return E=h(E),E}e.parse=D;function b(w,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:(0,t.regExpFlags)(E)}:E}function h(w,E=0){if(!w||E>200)return w;if(typeof w=="object"){switch(w.$mid){case 1:return M.URI.revive(w);case 2:return new RegExp(w.source,w.flags);case 14:return new Date(w.source)}if(w instanceof S.VSBuffer||w instanceof Uint8Array)return w;if(Array.isArray(w))for(let C=0;C<w.length;++C)w[C]=h(w[C],E+1);else for(const C in w)Object.hasOwnProperty.call(w,C)&&(w[C]=h(w[C],E+1))}return w}e.revive=h}),define(X[13],J([0,1,4,7]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var M;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.vscodeUserData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebook="vscode-notebook",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractive="vscode-interactive",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls",b.vscodeSourceControl="vscode-scm"})(M=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(h){this._preferredWebSchema=h}setDelegate(h){this._delegate=h}setServerRootPath(h){this._remoteResourcesPath=`${h}/${M.vscodeRemoteResource}`}set(h,w,E){this._hosts[h]=w,this._ports[h]=E}setConnectionToken(h,w){this._connectionTokens[h]=w}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(h){if(this._delegate)return this._delegate(h);const w=h.authority;let E=this._hosts[w];E&&E.indexOf(":")!==-1&&(E=`[${E}]`);const C=this._ports[w],p=this._connectionTokens[w];let g=`path=${encodeURIComponent(h.path)}`;return typeof p=="string"&&(g+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),t.URI.from({scheme:S.isWeb?this._preferredWebSchema:M.vscodeRemoteResource,authority:`${E}:${C}`,path:this._remoteResourcesPath,query:g})}}e.RemoteAuthorities=new R;class D{asBrowserUri(h,w){const E=this.toUri(h,w);return E.scheme===M.vscodeRemote?e.RemoteAuthorities.rewrite(E):E.scheme===M.file&&(S.isNative||S.isWebWorker&&S.globals.origin===`${M.vscodeFileResource}://${D.FALLBACK_AUTHORITY}`)?E.with({scheme:M.vscodeFileResource,authority:E.authority||D.FALLBACK_AUTHORITY,query:null,fragment:null}):E}asFileUri(h,w){const E=this.toUri(h,w);return E.scheme===M.vscodeFileResource?E.with({scheme:M.file,authority:E.authority!==D.FALLBACK_AUTHORITY?E.authority:null,query:null,fragment:null}):E}toUri(h,w){return t.URI.isUri(h)?h:t.URI.parse(w.toUrl(h))}}D.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new D}),define(X[16],J([0,1,31,13,9,4,30,7]),function(z,e,S,t,M,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function h(g){return(0,b.uriToFsPath)(g,!0)}e.originalFSPath=h;class w{constructor(d){this._ignorePathCasing=d}compare(d,P,y=!1){return d===P?0:(0,D.compare)(this.getComparisonKey(d,y),this.getComparisonKey(P,y))}isEqual(d,P,y=!1){return d===P?!0:!d||!P?!1:this.getComparisonKey(d,y)===this.getComparisonKey(P,y)}getComparisonKey(d,P=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:P?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,P,y=!1){if(d.scheme===P.scheme){if(d.scheme===t.Schemas.file)return S.isEqualOrParent(h(d),h(P),this._ignorePathCasing(d))&&d.query===P.query&&(y||d.fragment===P.fragment);if((0,e.isEqualAuthority)(d.authority,P.authority))return S.isEqualOrParent(d.path,P.path,this._ignorePathCasing(d),"/")&&d.query===P.query&&(y||d.fragment===P.fragment)}return!1}joinPath(d,...P){return b.URI.joinPath(d,...P)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return M.posix.basename(d.path)}extname(d){return M.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let P;return d.scheme===t.Schemas.file?P=b.URI.file(M.dirname(h(d))).path:(P=M.posix.dirname(d.path),d.authority&&P.length&&P.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),P="/")),d.with({path:P})}normalizePath(d){if(!d.path.length)return d;let P;return d.scheme===t.Schemas.file?P=b.URI.file(M.normalize(h(d))).path:P=M.posix.normalize(d.path),d.with({path:P})}relativePath(d,P){if(d.scheme!==P.scheme||!(0,e.isEqualAuthority)(d.authority,P.authority))return;if(d.scheme===t.Schemas.file){const v=M.relative(h(d),h(P));return R.isWindows?S.toSlashes(v):v}let y=d.path||"/";const m=P.path||"/";if(this._ignorePathCasing(d)){let v=0;for(const f=Math.min(y.length,m.length);v<f&&!(y.charCodeAt(v)!==m.charCodeAt(v)&&y.charAt(v).toLowerCase()!==m.charAt(v).toLowerCase());v++);y=m.substr(0,v)+y.substr(v)}return M.posix.relative(y,m)}resolvePath(d,P){if(d.scheme===t.Schemas.file){const y=b.URI.file(M.resolve(h(d),P));return d.with({authority:y.authority,path:y.path})}return P=S.toPosixPath(P),d.with({path:M.posix.resolve(d.path,P)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,P){return d===P||d!==void 0&&P!==void 0&&(0,D.equalsIgnoreCase)(d,P)}hasTrailingPathSeparator(d,P=M.sep){if(d.scheme===t.Schemas.file){const y=h(d);return y.length>S.getRoot(y).length&&y[y.length-1]===P}else{const y=d.path;return y.length>1&&y.charCodeAt(y.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,P=M.sep){return(0,e.hasTrailingPathSeparator)(d,P)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,P=M.sep){let y=!1;if(d.scheme===t.Schemas.file){const m=h(d);y=m!==void 0&&m.length===S.getRoot(m).length&&m[m.length-1]===P}else{P="/";const m=d.path;y=m.length===1&&m.charCodeAt(m.length-1)===47}return!y&&!(0,e.hasTrailingPathSeparator)(d,P)?d.with({path:d.path+"/"}):d}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(g=>g.scheme===t.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new w(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function E(g,d){const P=[];for(let y=0;y<g.length;y++){const m=d(g[y]);g.some((v,f)=>f===y?!1:(0,e.isEqualOrParent)(m,d(v)))||P.push(g[y])}return P}e.distinctParents=E;var C;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function d(P){const y=new Map;P.path.substring(P.path.indexOf(";")+1,P.path.lastIndexOf(";")).split(";").forEach(f=>{const[u,c]=f.split(":");u&&c&&y.set(u,c)});const v=P.path.substring(0,P.path.indexOf(";"));return v&&y.set(g.META_DATA_MIME,v),y}g.parseMetaData=d})(C=e.DataUri||(e.DataUri={}));function p(g,d,P){if(d){let y=g.path;return y&&y[0]!==M.posix.sep&&(y=M.posix.sep+y),g.with({scheme:P,authority:d,path:y})}return g.with({scheme:P})}e.toLocalResource=p}),define(X[8],J([0,1,21,19,3,2,16,4]),function(z,e,S,t,M,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function h(j){return!!j&&typeof j.then=="function"}e.isThenable=h;function w(j){const L=new S.CancellationTokenSource,T=j(L.token),_=new Promise((q,Q)=>{const te=L.token.onCancellationRequested(()=>{te.dispose(),L.dispose(),Q(new t.CancellationError)});Promise.resolve(T).then(U=>{te.dispose(),L.dispose(),q(U)},U=>{te.dispose(),L.dispose(),Q(U)})});return new class{cancel(){L.cancel()}then(q,Q){return _.then(q,Q)}catch(q){return this.then(void 0,q)}finally(q){return _.finally(q)}}}e.createCancelablePromise=w;function E(j,L,T){return new Promise((_,q)=>{const Q=L.onCancellationRequested(()=>{Q.dispose(),_(T)});j.then(_,q).finally(()=>Q.dispose())})}e.raceCancellation=E;function C(j,L){return new Promise((T,_)=>{const q=L.onCancellationRequested(()=>{q.dispose(),_(new t.CancellationError)});j.then(T,_).finally(()=>q.dispose())})}e.raceCancellationError=C;async function p(j){let L=-1;const T=j.map((q,Q)=>q.then(te=>(L=Q,te))),_=await Promise.race(T);return j.forEach((q,Q)=>{Q!==L&&q.cancel()}),_}e.raceCancellablePromises=p;function g(j,L,T){let _;const q=setTimeout(()=>{_?.(void 0),T?.()},L);return Promise.race([j.finally(()=>clearTimeout(q)),new Promise(Q=>_=Q)])}e.raceTimeout=g;function d(j){return new Promise((L,T)=>{const _=j();h(_)?_.then(L,T):L(_)})}e.asPromise=d;class P{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const T=()=>{this.queuedPromise=null;const _=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,_};this.queuedPromise=new Promise(_=>{this.activePromise.then(T,T).then(_)})}return new Promise((T,_)=>{this.queuedPromise.then(T,_)})}return this.activePromise=L(),new Promise((T,_)=>{this.activePromise.then(q=>{this.activePromise=null,T(q)},q=>{this.activePromise=null,_(q)})})}}e.Throttler=P;class y{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=y;class m{constructor(){this.promiseMap=new Map}queue(L,T){const q=(this.promiseMap.get(L)??Promise.resolve()).catch(()=>{}).then(T).finally(()=>{this.promiseMap.get(L)===q&&this.promiseMap.delete(L)});return this.promiseMap.set(L,q),q}}e.SequencerByKey=m;const v=(j,L)=>{let T=!0;const _=setTimeout(()=>{T=!1,L()},j);return{isTriggered:()=>T,dispose:()=>{clearTimeout(_),T=!1}}},f=j=>{let L=!0;return queueMicrotask(()=>{L&&(L=!1,j())}),{isTriggered:()=>L,dispose:()=>{L=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class u{constructor(L){this.defaultDelay=L,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,T=this.defaultDelay){this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((q,Q)=>{this.doResolve=q,this.doReject=Q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const q=this.task;return this.task=null,q()}}));const _=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=T===e.MicrotaskDelay?f(_):v(T,_),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=u;class c{constructor(L){this.delayer=new u(L),this.throttler=new P}trigger(L,T){return this.delayer.trigger(()=>this.throttler.queue(L),T)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class o{constructor(){this._isOpen=!1,this._promise=new Promise((L,T)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class r extends o{constructor(L){super();this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function i(j,L){return L?new Promise((T,_)=>{const q=setTimeout(()=>{Q.dispose(),T()},j),Q=L.onCancellationRequested(()=>{clearTimeout(q),Q.dispose(),_(new t.CancellationError)})}):w(T=>i(j,T))}e.timeout=i;function n(j,L=0){const T=setTimeout(j,L);return(0,R.toDisposable)(()=>clearTimeout(T))}e.disposableTimeout=n;function s(j){const L=[];let T=0;const _=j.length;function q(){return T<_?j[T++]():null}function Q(te){te!=null&&L.push(te);const U=q();return U?U.then(Q):Promise.resolve(L)}return Promise.resolve(null).then(Q)}e.sequence=s;function a(j,L=_=>!!_,T=null){let _=0;const q=j.length,Q=()=>{if(_>=q)return Promise.resolve(T);const te=j[_++];return Promise.resolve(te()).then(Y=>L(Y)?Promise.resolve(Y):Q())};return Q()}e.first=a;function l(j,L=_=>!!_,T=null){if(j.length===0)return Promise.resolve(T);let _=j.length;const q=()=>{_=-1;for(const Q of j)Q.cancel?.()};return new Promise((Q,te)=>{for(const U of j)U.then(Y=>{--_>=0&&L(Y)?(q(),Q(Y)):_===0&&Q(T)}).catch(Y=>{--_>=0&&(q(),te(Y))})})}e.firstParallel=l;class I{constructor(L){this._size=0,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new M.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(L){return this._size++,new Promise((T,_)=>{this.outstandingPromises.push({factory:L,c:T,e:_}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const T=L.factory();T.then(L.c,L.e),T.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=I;class k extends I{constructor(){super(1)}}e.Queue=k;class A{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const L=new B;return this.drainers.add(L),L.p}isDrained(){for(const[,L]of this.queues)if(L.size>0)return!1;return!0}queueFor(L,T=D.extUri){const _=T.getComparisonKey(L);let q=this.queues.get(_);return q||(q=new k,M.Event.once(q.onDrained)(()=>{q?.dispose(),this.queues.delete(_),this.onDidQueueDrain()}),this.queues.set(_,q)),q}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const L of this.drainers)L.complete();this.drainers.clear()}dispose(){for(const[,L]of this.queues)L.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=A;class W{constructor(L,T){this._token=-1,typeof L=="function"&&typeof T=="number"&&this.setIfNotSet(L,T)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,T){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},T)}setIfNotSet(L,T){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},T))}}e.TimeoutTimer=W;class F{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(L,T){this.cancel(),this._token=setInterval(()=>{L()},T)}}e.IntervalTimer=F;class K{constructor(L,T){this.timeoutToken=-1,this.runner=L,this.timeout=T,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=K;class ie{constructor(L,T){T%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.runner=L,this.timeout=T,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(L=this.timeout){L%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(L/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=ie;class oe extends K{constructor(L,T){super(L,T);this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner?.(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=oe;class ue extends R.Disposable{constructor(L,T){super();this.options=L,this.handler=T,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(L){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+L.length>this.options.maxBufferedWork)return!1}else if(this.pending+L.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...L),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new K(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=ue,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=j=>{(0,b.setTimeout0)(()=>{if(L)return;const T=Date.now()+15;j(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,T-Date.now())}}))});let L=!1;return{dispose(){L||(L=!0)}}}:e.runWhenIdle=(j,L)=>{const T=requestIdleCallback(j,typeof L=="number"?{timeout:L}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(T))}}}}();class ne{constructor(L){this._didRun=!1,this._executor=()=>{try{this._value=L()}catch(T){this._error=T}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=ne;async function ae(j,L,T){let _;for(let q=0;q<T;q++)try{return await j()}catch(Q){_=Q,await i(L)}throw _}e.retry=ae;class le{hasPending(L){return this._pending?typeof L=="number"?this._pending.taskId===L:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(L,T,_){return this._pending={taskId:L,cancel:()=>_?.(),promise:T},T.then(()=>this.donePending(L),()=>this.donePending(L)),T}donePending(L){this._pending&&L===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const L=this._next;this._next=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this._next)this._next.run=L;else{let T,_;const q=new Promise((Q,te)=>{T=Q,_=te});this._next={run:L,promise:q,promiseResolve:T,promiseReject:_}}return this._next.promise}}e.TaskSequentializer=le;class G{constructor(L,T=()=>Date.now()){this.interval=L,this.nowFn=T,this.lastIncrementTime=0,this.value=0}increment(){const L=this.nowFn();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=G;class B{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((L,T)=>{this.completeCallback=L,this.errorCallback=T})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(L){return new Promise(T=>{this.completeCallback(L),this.resolved=!0,T()})}error(L){return new Promise(T=>{this.errorCallback(L),this.rejected=!0,T()})}cancel(){new Promise(L=>{this.errorCallback(new t.CancellationError),this.rejected=!0,L()})}}e.DeferredPromise=B;var N;(function(j){async function L(_){let q;const Q=await Promise.all(_.map(te=>te.then(U=>U,U=>{q||(q=U)})));if(typeof q!="undefined")throw q;return Q}j.settled=L;function T(_){return new Promise(async(q,Q)=>{try{await _(q,Q)}catch(te){Q(te)}})}j.withAsyncBody=T})(N=e.Promises||(e.Promises={}));var O;(function(j){j[j.Initial=0]="Initial",j[j.DoneOK=1]="DoneOK",j[j.DoneError=2]="DoneError"})(O||(O={}));class H{constructor(L){this._state=0,this._results=[],this._error=null,this._onStateChanged=new M.Emitter,queueMicrotask(async()=>{const T={emitOne:_=>this.emitOne(_),emitMany:_=>this.emitMany(_),reject:_=>this.reject(_)};try{await Promise.resolve(L(T)),this.resolve()}catch(_){this.reject(_)}finally{T.emitOne=void 0,T.emitMany=void 0,T.reject=void 0}})}static fromArray(L){return new H(T=>{T.emitMany(L)})}static fromPromise(L){return new H(async T=>{T.emitMany(await L)})}static fromPromises(L){return new H(async T=>{await Promise.all(L.map(async _=>T.emitOne(await _)))})}static merge(L){return new H(async T=>{await Promise.all(L.map(async _=>{for await(const q of _)T.emitOne(q)}))})}[Symbol.asyncIterator](){let L=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(L<this._results.length)return{done:!1,value:this._results[L++]};if(this._state===1)return{done:!0,value:void 0};await M.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(L,T){return new H(async _=>{for await(const q of L)_.emitOne(T(q))})}map(L){return H.map(this,L)}static filter(L,T){return new H(async _=>{for await(const q of L)T(q)&&_.emitOne(q)})}filter(L){return H.filter(this,L)}static coalesce(L){return H.filter(L,T=>!!T)}coalesce(){return H.coalesce(this)}static async toPromise(L){const T=[];for await(const _ of L)T.push(_);return T}toPromise(){return H.toPromise(this)}emitOne(L){this._state===0&&(this._results.push(L),this._onStateChanged.fire())}emitMany(L){this._state===0&&(this._results=this._results.concat(L),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(L){this._state===0&&(this._state=2,this._error=L,this._onStateChanged.fire())}}e.AsyncIterableObject=H,H.EMPTY=H.fromArray([]);class Z extends H{constructor(L,T){super(T);this._source=L}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Z;function $(j){const L=new S.CancellationTokenSource,T=j(L.token);return new Z(L,async _=>{const q=L.token.onCancellationRequested(()=>{q.dispose(),L.dispose(),_.reject(new t.CancellationError)});try{for await(const Q of T){if(L.token.isCancellationRequested)return;_.emitOne(Q)}q.dispose(),L.dispose()}catch(Q){q.dispose(),L.dispose(),_.reject(Q)}})}e.createCancelableAsyncIterable=$}),define(X[92],J([0,1,25,8,31,33,9,4,30]),function(z,e,S,t,M,R,D,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function w(){return Object.create(null)}e.getEmptyExpression=w,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const E="[/\\\\]",C="[^/\\\\]",p=/\//g;function g(B,N){switch(B){case 0:return"";case 1:return`${C}*?`;default:return`(?:${E}|${C}+${E}${N?`|${E}${C}+`:""})*?`}}function d(B,N){if(!B)return[];const O=[];let H=!1,Z=!1,$="";for(const j of B){switch(j){case N:if(!H&&!Z){O.push($),$="";continue}break;case"{":H=!0;break;case"}":H=!1;break;case"[":Z=!0;break;case"]":Z=!1;break}$+=j}return $&&O.push($),O}e.splitGlobAware=d;function P(B){if(!B)return"";let N="";const O=d(B,e.GLOB_SPLIT);if(O.every(H=>H===e.GLOBSTAR))N=".*";else{let H=!1;O.forEach((Z,$)=>{if(Z===e.GLOBSTAR){if(H)return;N+=g(2,$===O.length-1)}else{let j=!1,L="",T=!1,_="";for(const q of Z){if(q!=="}"&&j){L+=q;continue}if(T&&(q!=="]"||!_)){let Q;q==="-"?Q=q:(q==="^"||q==="!")&&!_?Q="^":q===e.GLOB_SPLIT?Q="":Q=(0,h.escapeRegExpCharacters)(q),_+=Q;continue}switch(q){case"{":j=!0;continue;case"[":T=!0;continue;case"}":{N+=`(?:${d(L,",").map(U=>P(U)).join("|")})`,j=!1,L="";break}case"]":{N+="["+_+"]",T=!1,_="";break}case"?":N+=C;continue;case"*":N+=g(1);continue;default:N+=(0,h.escapeRegExpCharacters)(q)}}$<O.length-1&&(O[$+1]!==e.GLOBSTAR||$+2<O.length)&&(N+=E)}H=Z===e.GLOBSTAR})}return N}const y=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,o=new R.LRUCache(1e4),r=function(){return!1},i=function(){return null};function n(B,N){if(!B)return i;let O;typeof B!="string"?O=B.pattern:O=B,O=O.trim();const H=`${O}_${!!N.trimForExclusions}`;let Z=o.get(H);if(Z)return s(Z,B);let $;return y.test(O)?Z=l(O.substr(4),O):($=m.exec(a(O,N)))?Z=I($[1],O):(N.trimForExclusions?f:v).test(O)?Z=k(O,N):($=u.exec(a(O,N)))?Z=A($[1].substr(1),O,!0):($=c.exec(a(O,N)))?Z=A($[1],O,!1):Z=W(O),o.set(H,Z),s(Z,B)}function s(B,N){if(typeof N=="string")return B;const O=function(H,Z){return(0,M.isEqualOrParent)(H,N.base,!b.isLinux)?B(H.substr(N.base.length+1),Z):null};return O.allBasenames=B.allBasenames,O.allPaths=B.allPaths,O.basenames=B.basenames,O.patterns=B.patterns,O}function a(B,N){return N.trimForExclusions&&B.endsWith("/**")?B.substr(0,B.length-2):B}function l(B,N){return function(O,H){return typeof O=="string"&&O.endsWith(B)?N:null}}function I(B,N){const O=`/${B}`,H=`\\${B}`,Z=function(j,L){return typeof j!="string"?null:L?L===B?N:null:j===B||j.endsWith(O)||j.endsWith(H)?N:null},$=[B];return Z.basenames=$,Z.patterns=[N],Z.allBasenames=$,Z}function k(B,N){const O=le(B.slice(1,-1).split(",").map(L=>n(L,N)).filter(L=>L!==i),B),H=O.length;if(!H)return i;if(H===1)return O[0];const Z=function(L,T){for(let _=0,q=O.length;_<q;_++)if(O[_](L,T))return B;return null},$=O.find(L=>!!L.allBasenames);$&&(Z.allBasenames=$.allBasenames);const j=O.reduce((L,T)=>T.allPaths?L.concat(T.allPaths):L,[]);return j.length&&(Z.allPaths=j),Z}function A(B,N,O){const H=D.sep===D.posix.sep,Z=H?B:B.replace(p,D.sep),$=D.sep+Z,j=D.posix.sep+B;let L;return O?L=function(T,_){return typeof T=="string"&&(T===Z||T.endsWith($)||!H&&(T===B||T.endsWith(j)))?N:null}:L=function(T,_){return typeof T=="string"&&(T===Z||!H&&T===B)?N:null},L.allPaths=[(O?"*/":"./")+B],L}function W(B){try{const N=new RegExp(`^${P(B)}$`);return function(O){return N.lastIndex=0,typeof O=="string"&&N.test(O)?B:null}}catch{return i}}function F(B,N,O){return!B||typeof N!="string"?!1:K(B)(N,void 0,O)}e.match=F;function K(B,N={}){if(!B)return r;if(typeof B=="string"||ie(B)){const O=n(B,N);if(O===i)return r;const H=function(Z,$){return!!O(Z,$)};return O.allBasenames&&(H.allBasenames=O.allBasenames),O.allPaths&&(H.allPaths=O.allPaths),H}return ne(B,N)}e.parse=K;function ie(B){const N=B;return N?typeof N.base=="string"&&typeof N.pattern=="string":!1}e.isRelativePattern=ie;function oe(B){return B.allBasenames||[]}e.getBasenameTerms=oe;function ue(B){return B.allPaths||[]}e.getPathTerms=ue;function ne(B,N){const O=le(Object.getOwnPropertyNames(B).map(L=>ae(L,B[L],N)).filter(L=>L!==i)),H=O.length;if(!H)return i;if(!O.some(L=>!!L.requiresSiblings)){if(H===1)return O[0];const L=function(q,Q){let te;for(let U=0,Y=O.length;U<Y;U++){const x=O[U](q,Q);if(typeof x=="string")return x;(0,t.isThenable)(x)&&(te||(te=[]),te.push(x))}return te?(async()=>{for(const U of te){const Y=await U;if(typeof Y=="string")return Y}return null})():null},T=O.find(q=>!!q.allBasenames);T&&(L.allBasenames=T.allBasenames);const _=O.reduce((q,Q)=>Q.allPaths?q.concat(Q.allPaths):q,[]);return _.length&&(L.allPaths=_),L}const Z=function(L,T,_){let q,Q;for(let te=0,U=O.length;te<U;te++){const Y=O[te];Y.requiresSiblings&&_&&(T||(T=(0,D.basename)(L)),q||(q=T.substr(0,T.length-(0,D.extname)(L).length)));const x=Y(L,T,q,_);if(typeof x=="string")return x;(0,t.isThenable)(x)&&(Q||(Q=[]),Q.push(x))}return Q?(async()=>{for(const te of Q){const U=await te;if(typeof U=="string")return U}return null})():null},$=O.find(L=>!!L.allBasenames);$&&(Z.allBasenames=$.allBasenames);const j=O.reduce((L,T)=>T.allPaths?L.concat(T.allPaths):L,[]);return j.length&&(Z.allPaths=j),Z}function ae(B,N,O){if(N===!1)return i;const H=n(B,O);if(H===i)return i;if(typeof N=="boolean")return H;if(N){const Z=N.when;if(typeof Z=="string"){const $=(j,L,T,_)=>{if(!_||!H(j,L))return null;const q=Z.replace("$(basename)",T),Q=_(q);return(0,t.isThenable)(Q)?Q.then(te=>te?B:null):Q?B:null};return $.requiresSiblings=!0,$}}return H}function le(B,N){const O=B.filter(L=>!!L.basenames);if(O.length<2)return B;const H=O.reduce((L,T)=>{const _=T.basenames;return _?L.concat(_):L},[]);let Z;if(N){Z=[];for(let L=0,T=H.length;L<T;L++)Z.push(N)}else Z=O.reduce((L,T)=>{const _=T.patterns;return _?L.concat(_):L},[]);const $=function(L,T){if(typeof L!="string")return null;if(!T){let q;for(q=L.length;q>0;q--){const Q=L.charCodeAt(q-1);if(Q===47||Q===92)break}T=L.substr(q)}const _=H.indexOf(T);return _!==-1?Z[_]:null};$.basenames=H,$.patterns=Z,$.allBasenames=H;const j=B.filter(L=>!L.basenames);return j.push($),j}function G(B,N){return(0,S.equals)(B,N,(O,H)=>typeof O=="string"&&typeof H=="string"?O===H:typeof O!="string"&&typeof H!="string"?O.base===H.base&&O.pattern===H.pattern:!1)}e.patternsEquals=G}),define(X[34],J([0,1,25,31,9,4,16,30]),function(z,e,S,t,M,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function h(i,n){const{os:s,tildify:a,relative:l}=n;if(l){const A=w(i,l,s);if(typeof A=="string")return A}let I=i.fsPath;if(s===1&&!R.isWindows?I=I.replace(/\//g,"\\"):s!==1&&R.isWindows&&(I=I.replace(/\\/g,"/")),s!==1&&a?.userHome){const A=a.userHome.fsPath;let W;i.scheme!==a.userHome.scheme&&i.path.startsWith(M.posix.sep)?W=a.userHome.with({path:i.path}).fsPath:W=i.fsPath,I=p(W,A,s)}return(s===1?M.win32:M.posix).normalize(E(I,s===1))}e.getPathLabel=h;function w(i,n,s){const a=s===1?M.win32:M.posix,l=s===3?D.extUri:D.extUriIgnorePathCase,I=n.getWorkspace(),k=(0,S.firstOrDefault)(I.folders);if(!k)return;i.scheme!==k.uri.scheme&&i.path.startsWith(M.posix.sep)&&(i=k.uri.with({path:i.path}));const A=n.getWorkspaceFolder(i);if(!A)return;let W;if(l.isEqual(A.uri,i)?W="":W=l.relativePath(A.uri,i)??"",W&&(W=a.normalize(W)),I.folders.length>1&&!n.noPrefix){const F=A.name?A.name:l.basenameOrAuthority(A.uri);W=W?`${F} \u2022 ${W}`:F}return W}function E(i,n=R.isWindows){return(0,t.hasDriveLetter)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=E;let C=Object.create(null);function p(i,n,s=R.OS){if(s===1||!i||!n)return i;let a=C.original===n?C.normalized:void 0;a||(a=n,R.isWindows&&(a=(0,t.toSlashes)(a)),a=`${(0,b.rtrim)(a,M.posix.sep)}${M.posix.sep}`,C={original:n,normalized:a});let l=i;return R.isWindows&&(l=(0,t.toSlashes)(l)),(s===3?l.startsWith(a):(0,b.startsWithIgnoreCase)(l,a))?`~/${l.substr(a.length)}`:i}e.tildify=p;function g(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=g;const d="\u2026",P="\\\\",y="~";function m(i,n=M.sep){const s=new Array(i.length);let a=!1;for(let l=0;l<i.length;l++){const I=i[l];if(I===""){s[l]=`.${n}`;continue}if(!I){s[l]=I;continue}a=!0;let k="",A=I;A.indexOf(P)===0?(k=A.substr(0,A.indexOf(P)+P.length),A=A.substr(A.indexOf(P)+P.length)):A.indexOf(n)===0?(k=A.substr(0,A.indexOf(n)+n.length),A=A.substr(A.indexOf(n)+n.length)):A.indexOf(y)===0&&(k=A.substr(0,A.indexOf(y)+y.length),A=A.substr(A.indexOf(y)+y.length));const W=A.split(n);for(let F=1;a&&F<=W.length;F++)for(let K=W.length-F;a&&K>=0;K--){a=!1;let ie=W.slice(K,K+F).join(n);for(let oe=0;!a&&oe<i.length;oe++)if(oe!==l&&i[oe]&&i[oe].indexOf(ie)>-1){const ue=K+F===W.length,ne=K>0&&i[oe].indexOf(n)>-1?n+ie:ie,ae=i[oe].endsWith(ne);a=!ue||ae}if(!a){let oe="";(W[0].endsWith(":")||k!=="")&&(K===1&&(K=0,F++,ie=W[0]+n+ie),K>0&&(oe=W[0]+n),oe=k+oe),K>0&&(oe=oe+d+n),oe=oe+ie,K+F<W.length&&(oe=oe+n+d),s[l]=oe}}a&&(s[l]=I)}return s}e.shorten=m;var v;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function f(i,n=Object.create(null)){const s=[];let a=!1,l="";for(const I of i)if(I==="$"||a&&I==="{")l&&s.push({value:l,type:v.TEXT}),l="",a=!0;else if(I==="}"&&a){const k=n[l];if(typeof k=="string")k.length&&s.push({value:k,type:v.VARIABLE});else if(k){const A=s[s.length-1];(!A||A.type!==v.SEPARATOR)&&s.push({value:k.label,type:v.SEPARATOR})}l="",a=!1}else l+=I;return l&&!a&&s.push({value:l,type:v.TEXT}),s.filter((I,k)=>{if(I.type===v.SEPARATOR){const A=s[k-1],W=s[k+1];return[A,W].every(F=>F&&(F.type===v.VARIABLE||F.type===v.TEXT)&&F.value.length>0)}return!0}).map(I=>I.value).join("")}e.template=f;function u(i,n){return R.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):i.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=u;function c(i,n){return R.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,""):R.isWindows?i.replace(/&&|&/g,s=>s==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=c;function o(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=o;function r(i){const n=i.indexOf("/")!==-1?M.posix:M.win32,s=n.basename(i),a=n.dirname(i);return s.length?{name:s,parentPath:a}:{name:a,parentPath:""}}e.splitName=r}),define(X[135],J([0,1,7]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(E){return E.toJSON()}class M{constructor(C){this._uriTransformer=C}transformIncoming(C){const p=this._uriTransformer.transformIncoming(C);return p===C?C:t(S.URI.from(p))}transformOutgoing(C){const p=this._uriTransformer.transformOutgoing(C);return p===C?C:t(S.URI.from(p))}transformOutgoingURI(C){const p=this._uriTransformer.transformOutgoing(C);return p===C?C:S.URI.from(p)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=M,e.DefaultURITransformer=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function R(E,C,p){if(!E||p>200)return null;if(typeof E=="object"){if(E instanceof S.URI)return C.transformOutgoing(E);for(const g in E)if(Object.hasOwnProperty.call(E,g)){const d=R(E[g],C,p+1);d!==null&&(E[g]=d)}}return null}function D(E,C){const p=R(E,C,0);return p===null?E:p}e.transformOutgoingURIs=D;function b(E,C,p,g){if(!E||g>200)return null;if(typeof E=="object"){if(E.$mid===1)return p?S.URI.revive(C.transformIncoming(E)):C.transformIncoming(E);for(const d in E)if(Object.hasOwnProperty.call(E,d)){const P=b(E[d],C,p,g+1);P!==null&&(E[d]=P)}}return null}function h(E,C){const p=b(E,C,!1,0);return p===null?E:p}e.transformIncomingURIs=h;function w(E,C){const p=b(E,C,!0,0);return p===null?E:p}e.transformAndReviveIncomingURIs=w}),define(X[80],J([0,1,29,19,33,27,125]),function(z,e,S,t,M,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(E){return this._virtualMachineOUIs||(this._virtualMachineOUIs=M.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(E)}value(){if(this._value===void 0){let E=0,C=0;const p=(0,S.networkInterfaces)();for(const g in p){const d=p[g];if(d)for(const{mac:P,internal:y}of d)y||(C+=1,this._isVirtualMachineMacAddress(P.toUpperCase())&&(E+=1))}this._value=C>0?E/C:0}return this._value}};let b;async function h(){return b||(b=(async()=>await w()||R.generateUuid())()),b}e.getMachineId=h;async function w(){try{const E=await new Promise((p,g)=>{z(["crypto"],p,g)}),C=(0,D.getMac)();return E.createHash("sha256").update(C,"utf8").digest("hex")}catch(E){t.onUnexpectedError(E);return}}}),define(X[23],J([0,1,28,29,136,8,31,79,9,4,16,7]),function(z,e,S,t,M,R,D,b,h,w,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(ne){ne[ne.UNLINK=0]="UNLINK",ne[ne.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function g(ne,ae=p.UNLINK){if((0,D.isRootOrDriveLetter)(ne))throw new Error("rimraf - will refuse to recursively delete root");return ae===p.UNLINK?P(ne):d(ne)}async function d(ne){try{const ae=(0,D.randomPath)((0,t.tmpdir)());try{await S.promises.rename(ne,ae)}catch{return P(ne)}P(ae).catch(le=>{})}catch(ae){if(ae.code!=="ENOENT")throw ae}}async function P(ne){return(0,M.promisify)(S.rm)(ne,{recursive:!0,force:!0,maxRetries:3})}function y(ne){if((0,D.isRootOrDriveLetter)(ne))throw new Error("rimraf - will refuse to recursively delete root");S.rmSync(ne,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=y;async function m(ne,ae){return u(await(ae?v(ne):(0,M.promisify)(S.readdir)(ne)))}async function v(ne){try{return await(0,M.promisify)(S.readdir)(ne,{withFileTypes:!0})}catch(G){console.warn("[node.js fs] readdir with filetypes failed with error: ",G)}const ae=[],le=await m(ne);for(const G of le){let B=!1,N=!1,O=!1;try{const H=await e.Promises.lstat((0,h.join)(ne,G));B=H.isFile(),N=H.isDirectory(),O=H.isSymbolicLink()}catch(H){console.warn("[node.js fs] unexpected error from lstat after readdir: ",H)}ae.push({name:G,isFile:()=>B,isDirectory:()=>N,isSymbolicLink:()=>O})}return ae}function f(ne){return u(S.readdirSync(ne))}e.readdirSync=f;function u(ne){return ne.map(ae=>typeof ae=="string"?w.isMacintosh?(0,b.normalizeNFC)(ae):ae:(ae.name=w.isMacintosh?(0,b.normalizeNFC)(ae.name):ae.name,ae))}async function c(ne){const ae=await m(ne),le=[];for(const G of ae)await r.existsDirectory((0,h.join)(ne,G))&&le.push(G);return le}function o(ne,ae=1e3){return new Promise(le=>{let G=!1;const B=setInterval(()=>{G||(G=!0,S.access(ne,N=>{G=!1,N&&(clearInterval(B),le(void 0))}))},ae)})}e.whenDeleted=o;var r;(function(ne){async function ae(B){let N;try{if(N=await e.Promises.lstat(B),!N.isSymbolicLink())return{stat:N}}catch{}try{return{stat:await e.Promises.stat(B),symbolicLink:N?.isSymbolicLink()?{dangling:!1}:void 0}}catch(O){if(O.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};if(w.isWindows&&O.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(H){if(H.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};throw H}throw O}}ne.stat=ae;async function le(B){try{const{stat:N,symbolicLink:O}=await ne.stat(B);return N.isFile()&&O?.dangling!==!0}catch{}return!1}ne.existsFile=le;async function G(B){try{const{stat:N,symbolicLink:O}=await ne.stat(B);return N.isDirectory()&&O?.dangling!==!0}catch{}return!1}ne.existsDirectory=G})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new R.ResourceQueue;function n(ne,ae,le){return i.queueFor(C.URI.file(ne),E.extUriBiasedIgnorePathCase).queue(()=>{const G=k(le);return new Promise((B,N)=>l(ne,ae,G,O=>O?N(O):B()))})}let s=!0;function a(ne){s=ne}e.configureFlushOnWrite=a;function l(ne,ae,le,G){if(!s)return S.writeFile(ne,ae,{mode:le.mode,flag:le.flag},G);S.open(ne,le.flag,le.mode,(B,N)=>{if(B)return G(B);S.writeFile(N,ae,O=>{if(O)return S.close(N,()=>G(O));S.fdatasync(N,H=>(H&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",H),a(!1)),S.close(N,Z=>G(Z))))})})}function I(ne,ae,le){const G=k(le);if(!s)return S.writeFileSync(ne,ae,{mode:G.mode,flag:G.flag});const B=S.openSync(ne,G.flag,G.mode);try{S.writeFileSync(B,ae);try{S.fdatasyncSync(B)}catch(N){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",N),a(!1)}}finally{S.closeSync(B)}}e.writeFileSync=I;function k(ne){return ne?{mode:typeof ne.mode=="number"?ne.mode:438,flag:typeof ne.flag=="string"?ne.flag:"w"}:{mode:438,flag:"w"}}async function A(ne,ae){if(ne!==ae)try{await e.Promises.rename(ne,ae)}catch(le){if(ne.toLowerCase()!==ae.toLowerCase()&&le.code==="EXDEV"||ne.endsWith("."))await W(ne,ae,{preserveSymlinks:!1}),await g(ne,p.MOVE);else throw le}}async function W(ne,ae,le){return K(ne,ae,{root:{source:ne,target:ae},options:le,handledSourcePaths:new Set})}const F=511;async function K(ne,ae,le){if(le.handledSourcePaths.has(ne))return;le.handledSourcePaths.add(ne);const{stat:G,symbolicLink:B}=await r.stat(ne);if(B){if(le.options.preserveSymlinks)try{return await ue(ne,ae,le)}catch(N){console.warn("[node.js fs] copy of symlink failed: ",N)}if(B.dangling)return}return G.isDirectory()?ie(ne,ae,G.mode&F,le):oe(ne,ae,G.mode&F)}async function ie(ne,ae,le,G){await e.Promises.mkdir(ae,{recursive:!0,mode:le});const B=await m(ne);for(const N of B)await K((0,h.join)(ne,N),(0,h.join)(ae,N),G)}async function oe(ne,ae,le){await e.Promises.copyFile(ne,ae),await e.Promises.chmod(ae,le)}async function ue(ne,ae,le){let G=await e.Promises.readlink(ne);(0,D.isEqualOrParent)(G,le.root.source,!w.isLinux)&&(G=(0,h.join)(le.root.target,G.substr(le.root.source.length+1))),await e.Promises.symlink(G,ae)}e.Promises=new class{get access(){return(0,M.promisify)(S.access)}get stat(){return(0,M.promisify)(S.stat)}get lstat(){return(0,M.promisify)(S.lstat)}get utimes(){return(0,M.promisify)(S.utimes)}get read(){return(ne,ae,le,G,B)=>new Promise((N,O)=>{S.read(ne,ae,le,G,B,(H,Z,$)=>H?O(H):N({bytesRead:Z,buffer:$}))})}get readFile(){return(0,M.promisify)(S.readFile)}get write(){return(ne,ae,le,G,B)=>new Promise((N,O)=>{S.write(ne,ae,le,G,B,(H,Z,$)=>H?O(H):N({bytesWritten:Z,buffer:$}))})}get appendFile(){return(0,M.promisify)(S.appendFile)}get fdatasync(){return(0,M.promisify)(S.fdatasync)}get truncate(){return(0,M.promisify)(S.truncate)}get rename(){return(0,M.promisify)(S.rename)}get copyFile(){return(0,M.promisify)(S.copyFile)}get open(){return(0,M.promisify)(S.open)}get close(){return(0,M.promisify)(S.close)}get symlink(){return(0,M.promisify)(S.symlink)}get readlink(){return(0,M.promisify)(S.readlink)}get chmod(){return(0,M.promisify)(S.chmod)}get mkdir(){return(0,M.promisify)(S.mkdir)}get unlink(){return(0,M.promisify)(S.unlink)}get rmdir(){return(0,M.promisify)(S.rmdir)}get realpath(){return(0,M.promisify)(S.realpath)}async exists(ne){try{return await e.Promises.access(ne),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return c}get writeFile(){return n}get rm(){return g}get move(){return A}get copy(){return W}}}),define(X[93],J([0,1,28,9,4,30,23]),function(z,e,S,t,M,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function b(p){if(M.isLinux)return p;const g=(0,t.dirname)(p);if(p===g)return p;const d=((0,t.basename)(p)||p).toLowerCase();try{const y=(0,D.readdirSync)(g).filter(m=>m.toLowerCase()===d);if(y.length===1){const m=b(g);if(m)return(0,t.join)(m,y[0])}else if(y.length>1){const m=y.indexOf(d);if(m>=0){const v=b(g);if(v)return(0,t.join)(v,y[m])}}}catch{}return null}e.realcaseSync=b;async function h(p){if(M.isLinux)return p;const g=(0,t.dirname)(p);if(p===g)return p;const d=((0,t.basename)(p)||p).toLowerCase();try{const y=(await D.Promises.readdir(g)).filter(m=>m.toLowerCase()===d);if(y.length===1){const m=await h(g);if(m)return(0,t.join)(m,y[0])}else if(y.length>1){const m=y.indexOf(d);if(m>=0){const v=await h(g);if(v)return(0,t.join)(v,y[m])}}}catch{}return null}e.realcase=h;async function w(p){try{return await D.Promises.realpath(p)}catch{const d=C(p);return await D.Promises.access(d,S.constants.R_OK),d}}e.realpath=w;function E(p){try{return S.realpathSync(p)}catch{const d=C(p);return S.accessSync(d,S.constants.R_OK),d}}e.realpathSync=E;function C(p){return(0,R.rtrim)((0,t.normalize)(p),t.sep)}}),define(X[137],J([0,1,29,9,23]),function(z,e,S,t,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,D=/^Microsoft.PowerShell_.*/,b=/^Microsoft.PowerShellPreview_.*/;var h;(function(u){u[u.x64=0]="x64",u[u.x86=1]="x86",u[u.ARM=2]="ARM"})(h||(h={}));let w;switch(process.arch){case"ia32":case"x32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let E;process.env.PROCESSOR_ARCHITEW6432?E=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?E=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?E=1:E=0;class C{constructor(c,o,r){this.exePath=c,this.displayName=o,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await M.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function p({useAlternateBitness:u=!1}={}){return u?w===0?process.env["ProgramFiles(x86)"]||null:E===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function g({useAlternateBitness:u=!1,findPreview:c=!1}={}){const o=p({useAlternateBitness:u});if(!o)return null;const r=t.join(o,"PowerShell");if(!await M.SymlinkSupport.existsDirectory(r))return null;let i=-1,n=null;for(const l of await M.Promises.readdir(r)){let I=-1;if(c){const A=l.indexOf("-");if(A<0)continue;const W=l.substring(0,A);if(!R.test(W)||l.substring(A+1)!=="preview")continue;I=parseInt(W,10)}else{if(!R.test(l))continue;I=parseInt(l,10)}if(I<=i)continue;const k=t.join(r,l,"pwsh.exe");!await M.SymlinkSupport.existsFile(k)||(n=k,i=I)}if(!n)return null;const s=o.includes("x86")?" (x86)":"",a=c?" Preview":"";return new C(n,`PowerShell${a}${s}`,!0)}async function d({findPreview:u}={}){if(!process.env.LOCALAPPDATA)return null;const c=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await M.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:o,pwshMsixName:r}=u?{pwshMsixDirRegex:b,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const i of await M.Promises.readdir(c))if(o.test(i)){const n=t.join(c,i,"pwsh.exe");return new C(n,r)}return null}function P(){const u=t.join(S.homedir(),".dotnet","tools","pwsh.exe");return new C(u,".NET Core PowerShell Global Tool")}function y(){const u=t.join(process.env.windir,w===1&&E!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(u,"Windows PowerShell",!0)}async function*m(){let u=await g();u&&(yield u),u=await g({useAlternateBitness:!0}),u&&(yield u),u=await d(),u&&(yield u),u=P(),u&&(yield u),u=await g({findPreview:!0}),u&&(yield u),u=await d({findPreview:!0}),u&&(yield u),u=await g({useAlternateBitness:!0,findPreview:!0}),u&&(yield u),u=y(),u&&(yield u)}async function*v(){for await(const u of m())await u.exists()&&(yield u)}e.enumeratePowerShellInstallations=v;async function f(){for await(const u of v())return u;return null}e.getFirstAvailablePowerShellInstallation=f}),define(X[81],J([0,1,9,4,36,77,11,23]),function(z,e,S,t,M,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function h(C=M.env){return C.comspec||"cmd.exe"}e.getWindowsShell=h;function w(C){let p=[],g=!1;const d=function(P){if(g){p.push(P);return}(!C.send(P,m=>{if(m&&console.error(m),g=!1,p.length>0){const v=p.slice(0);p=[],v.forEach(f=>d(f))}})||t.isWindows)&&(g=!0)};return{send:d}}e.createQueuedSender=w;var E;(function(C){async function p(g,d,P){if(S.isAbsolute(g))return g;if(d===void 0&&(d=M.cwd()),S.dirname(g)!=="."||(P===void 0&&D.isString(M.env.PATH)&&(P=M.env.PATH.split(S.delimiter)),P===void 0||P.length===0))return S.join(d,g);async function m(v){if(await b.Promises.exists(v)){let f;try{f=await b.Promises.stat(v)}catch(u){u.message.startsWith("EACCES")&&(f=await b.Promises.lstat(v))}return f?!f.isDirectory():!1}return!1}for(const v of P){let f;if(S.isAbsolute(v)?f=S.join(v,g):f=S.join(d,v,g),await m(f))return f;let u=f+".com";if(await m(u)||(u=f+".exe",await m(u)))return u}return S.join(d,g)}C.findExecutable=p})(E=e.win32||(e.win32={}))}),define(X[94],J([0,1,49,13]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function M(D){return new Promise((b,h)=>{let w;const E=new Map;function C(g,d,P,y,m){const v=E.get(d);if(g===D||v){const f={name:p(P),cmd:P,pid:g,ppid:d,load:y,mem:m};E.set(g,f),g===D&&(w=f),v&&(v.children||(v.children=[]),v.children.push(f),v.children.length>1&&(v.children=v.children.sort((u,c)=>u.pid-c.pid)))}}function p(g){const d=/--vscode-window-kind=shared-process/,P=/--vscode-window-kind=issue-reporter/,y=/--vscode-window-kind=process-explorer/,m=/--utility-sub-type=network/,v=/--utility-sub-type=node.mojom.NodeService/,f=/--crashes-directory/,u=/\\pipe\\winpty-control/,c=/conhost\.exe/,o=/--type=([a-zA-Z-]+)/;if(f.exec(g))return"electron-crash-reporter";if(u.exec(g))return"winpty-process";if(c.exec(g))return"console-window-host (Windows internal process)";let r=o.exec(g);if(r&&r.length===2){if(r[1]==="renderer")return d.exec(g)?"shared-process":P.exec(g)?"issue-reporter":y.exec(g)?"process-explorer":"window";if(r[1]==="utility"){if(m.exec(g))return"utility-network-service";if(v.exec(g))return"extension-host"}return r[1]}const i=/[a-zA-Z-]+\.js/g;let n="";do r=i.exec(g),r&&(n+=r+" ");while(r);return n&&g.indexOf("node ")<0&&g.indexOf("node.exe")<0?`electron_node ${n}`:g}if(process.platform==="win32"){const g=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,P)=>{z(["windows-process-tree"],d,P)}).then(d=>{d.getProcessList(D,P=>{if(!P){h(new Error(`Root process ${D} not found`));return}d.getProcessCpuUsage(P,y=>{const m=new Map;y.forEach(v=>{const f=g(v.commandLine||"");m.set(v.pid,{name:p(f),cmd:f,pid:v.pid,ppid:v.ppid,load:v.cpu||0,mem:v.memory||0})}),w=m.get(D),w?(m.forEach(v=>{const f=m.get(v.ppid);f&&(f.children||(f.children=[]),f.children.push(v))}),m.forEach(v=>{v.children&&(v.children=v.children.sort((f,u)=>f.pid-u.pid))}),b(w)):h(new Error(`Root process ${D} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let g=function(){let d=[w];const P=[];for(;d.length;){const m=d.shift();m&&(P.push(m.pid),m.children&&(d=d.concat(m.children)))}let y=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",z).fsPath);y+=" "+P.join(" "),(0,S.exec)(y,{},(m,v,f)=>{if(m||f)h(m||new Error(f.toString()));else{const u=v.toString().split(`
`);for(let c=0;c<P.length;c++){const o=E.get(P[c]);o.load=parseFloat(u[c])}if(!w){h(new Error(`Root process ${D} not found`));return}b(w)}})};(0,S.exec)("which ps",{},(d,P,y)=>{if(d||y)if(process.platform!=="linux")h(d||new Error(y.toString()));else{const m=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",z).fsPath);(0,S.exec)(m,{},(v,f,u)=>{v||u?h(v||new Error(u.toString())):(R(f,C),g())})}else{const m=P.toString().trim(),v="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,S.exec)(`${m} ${v}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,u,c)=>{f||c&&!c.includes("screen size is bogus")?h(f||new Error(c.toString())):(R(u,C),process.platform==="linux"?g():w?b(w):h(new Error(`Root process ${D} not found`)))})}})}})}e.listProcesses=M;function R(D,b){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=D.toString().split(`
`);for(const E of w){const C=h.exec(E.trim());C&&C.length===6&&b(parseInt(C[1]),parseInt(C[2]),C[5],parseFloat(C[3]),parseFloat(C[4]))}}}),define(X[138],J([0,1,29,4,137,81]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function D(g,d){return g===1?t.isWindows?C():R.getWindowsShell(d):w(g,d)}e.getSystemShell=D;function b(g,d){return g===1?t.isWindows?p(d):R.getWindowsShell(d):w(g,d)}e.getSystemShellSync=b;let h=null;function w(g,d){if(t.isLinux&&g===2||t.isMacintosh&&g===3)return"/bin/bash";if(!h){let P;if(t.isWindows)P="/bin/bash";else{if(P=d.SHELL,!P)try{P=(0,S.userInfo)().shell}catch{}P||(P="sh"),P==="/bin/false"&&(P="/bin/bash")}h=P}return h}let E=null;async function C(){return E||(E=(await(0,M.getFirstAvailablePowerShellInstallation)()).exePath),E}function p(g){if(E)return E;const d=t.isWindows&&parseFloat((0,S.release)())>=10,P=g.hasOwnProperty("PROCESSOR_ARCHITEW6432"),y=`${g.windir}\\${P?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?y:R.getWindowsShell(g)}});var ge=this&&this.__decorate||function(z,e,S,t){var M=arguments.length,R=M<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,S):t,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(z,e,S,t);else for(var b=z.length-1;b>=0;b--)(D=z[b])&&(R=(M<3?D(R):M>3?D(e,S,R):D(e,S))||R);return M>3&&R&&Object.defineProperty(e,S,R),R};define(X[43],J([0,1,25,8,17,21,50,19,3,2,66,30,11]),function(z,e,S,t,M,R,D,b,h,w,E,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var g;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(g=e.RequestType||(e.RequestType={}));function d(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var P;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(P=e.ResponseType||(e.ResponseType={}));function y(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(m||(m={}));class v{constructor(N){this.buffer=N,this.pos=0}read(N){const O=this.buffer.slice(this.pos,this.pos+N);return this.pos+=O.byteLength,O}}class f{constructor(){this.buffers=[]}get buffer(){return M.VSBuffer.concat(this.buffers)}write(N){this.buffers.push(N)}}var u;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object"})(u||(u={}));function c(B){const N=M.VSBuffer.alloc(4);return N.writeUInt32BE(B,0),N}function o(B){return B.read(4).readUInt32BE(0)}function r(B){const N=M.VSBuffer.alloc(1);return N.writeUInt8(B,0),N}const i={Undefined:r(u.Undefined),String:r(u.String),Buffer:r(u.Buffer),VSBuffer:r(u.VSBuffer),Array:r(u.Array),Object:r(u.Object)},n=typeof Buffer!="undefined";function s(B,N){if(typeof N=="undefined")B.write(i.Undefined);else if(typeof N=="string"){const O=M.VSBuffer.fromString(N);B.write(i.String),B.write(c(O.byteLength)),B.write(O)}else if(n&&Buffer.isBuffer(N)){const O=M.VSBuffer.wrap(N);B.write(i.Buffer),B.write(c(O.byteLength)),B.write(O)}else if(N instanceof M.VSBuffer)B.write(i.VSBuffer),B.write(c(N.byteLength)),B.write(N);else if(Array.isArray(N)){B.write(i.Array),B.write(c(N.length));for(const O of N)s(B,O)}else{const O=M.VSBuffer.fromString(JSON.stringify(N));B.write(i.Object),B.write(c(O.byteLength)),B.write(O)}}function a(B){switch(B.read(1).readUInt8(0)){case u.Undefined:return;case u.String:return B.read(o(B)).toString();case u.Buffer:return B.read(o(B)).buffer;case u.VSBuffer:return B.read(o(B));case u.Array:{const O=o(B),H=[];for(let Z=0;Z<O;Z++)H.push(a(B));return H}case u.Object:return JSON.parse(B.read(o(B)).toString())}}class l{constructor(N,O,H=null,Z=1e3){this.protocol=N,this.ctx=O,this.logger=H,this.timeoutDelay=Z,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage($=>this.onRawMessage($)),this.sendResponse({type:200})}registerChannel(N,O){this.channels.set(N,O),setTimeout(()=>this.flushPendingRequests(N),0)}sendResponse(N){switch(N.type){case 200:{const O=this.send([N.type]);this.logger?.logOutgoing(O,0,1,y(N.type));return}case 201:case 202:case 204:case 203:{const O=this.send([N.type,N.id],N.data);this.logger?.logOutgoing(O,N.id,1,y(N.type),N.data);return}}}send(N,O=void 0){const H=new f;return s(H,N),s(H,O),this.sendBuffer(H.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch{return 0}}onRawMessage(N){const O=new v(N),H=a(O),Z=a(O),$=H[0];switch($){case 100:return this.logger?.logIncoming(N.byteLength,H[1],1,`${d($)}: ${H[2]}.${H[3]}`,Z),this.onPromise({type:$,id:H[1],channelName:H[2],name:H[3],arg:Z});case 102:return this.logger?.logIncoming(N.byteLength,H[1],1,`${d($)}: ${H[2]}.${H[3]}`,Z),this.onEventListen({type:$,id:H[1],channelName:H[2],name:H[3],arg:Z});case 101:return this.logger?.logIncoming(N.byteLength,H[1],1,`${d($)}`),this.disposeActiveRequest({type:$,id:H[1]});case 103:return this.logger?.logIncoming(N.byteLength,H[1],1,`${d($)}`),this.disposeActiveRequest({type:$,id:H[1]})}}onPromise(N){const O=this.channels.get(N.channelName);if(!O){this.collectPendingRequest(N);return}const H=new R.CancellationTokenSource;let Z;try{Z=O.call(this.ctx,N.name,N.arg,H.token)}catch(L){Z=Promise.reject(L)}const $=N.id;Z.then(L=>{this.sendResponse({id:$,data:L,type:201}),this.activeRequests.delete(N.id)},L=>{L instanceof Error?this.sendResponse({id:$,data:{message:L.message,name:L.name,stack:L.stack?L.stack.split?L.stack.split(`
`):L.stack:void 0},type:202}):this.sendResponse({id:$,data:L,type:203}),this.activeRequests.delete(N.id)});const j=(0,w.toDisposable)(()=>H.cancel());this.activeRequests.set(N.id,j)}onEventListen(N){const O=this.channels.get(N.channelName);if(!O){this.collectPendingRequest(N);return}const H=N.id,$=O.listen(this.ctx,N.name,N.arg)(j=>this.sendResponse({id:H,data:j,type:204}));this.activeRequests.set(N.id,$)}disposeActiveRequest(N){const O=this.activeRequests.get(N.id);O&&(O.dispose(),this.activeRequests.delete(N.id))}collectPendingRequest(N){let O=this.pendingRequests.get(N.channelName);O||(O=[],this.pendingRequests.set(N.channelName,O));const H=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.sendResponse({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);O.push({request:N,timeoutTimer:H})}flushPendingRequests(N){const O=this.pendingRequests.get(N);if(O){for(const H of O)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(N)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,w.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=l;var I;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(I=e.RequestInitiator||(e.RequestInitiator={}));class k{constructor(N,O=null){this.protocol=N,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new h.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=O}getChannel(N){const O=this;return{call(H,Z,$){return O.isDisposed?Promise.reject(b.canceled()):O.requestPromise(N,H,Z,$)},listen(H,Z){return O.isDisposed?h.Event.None:O.requestEvent(N,H,Z)}}}requestPromise(N,O,H,Z=R.CancellationToken.None){const $=this.lastRequestId++,L={id:$,type:100,channelName:N,name:O,arg:H};if(Z.isCancellationRequested)return Promise.reject(b.canceled());let T;return new Promise((q,Q)=>{if(Z.isCancellationRequested)return Q(b.canceled());const te=()=>{const re=ce=>{switch(ce.type){case 201:this.handlers.delete($),q(ce.data);break;case 202:{this.handlers.delete($);const Ee=new Error(ce.data.message);Ee.stack=ce.data.stack,Ee.name=ce.data.name,Q(Ee);break}case 203:this.handlers.delete($),Q(ce.data);break}};this.handlers.set($,re),this.sendRequest(L)};let U=null;this.state===m.Idle?te():(U=(0,t.createCancelablePromise)(re=>this.whenInitialized()),U.then(()=>{U=null,te()}));const Y=()=>{U?(U.cancel(),U=null):this.sendRequest({id:$,type:101}),Q(b.canceled())},x=Z.onCancellationRequested(Y);T=(0,w.combinedDisposable)((0,w.toDisposable)(Y),x),this.activeRequests.add(T)}).finally(()=>{this.activeRequests.delete(T)})}requestEvent(N,O,H){const Z=this.lastRequestId++,j={id:Z,type:102,channelName:N,name:O,arg:H};let L=null;const T=new h.Emitter({onFirstListenerAdd:()=>{L=(0,t.createCancelablePromise)(q=>this.whenInitialized()),L.then(()=>{L=null,this.activeRequests.add(T),this.sendRequest(j)})},onLastListenerRemove:()=>{L?(L.cancel(),L=null):(this.activeRequests.delete(T),this.sendRequest({id:Z,type:103}))}}),_=q=>T.fire(q.data);return this.handlers.set(Z,_),T.event}sendRequest(N){switch(N.type){case 100:case 102:{const O=this.send([N.type,N.id,N.channelName,N.name],N.arg);this.logger?.logOutgoing(O,N.id,0,`${d(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const O=this.send([N.type,N.id]);this.logger?.logOutgoing(O,N.id,0,d(N.type));return}}}send(N,O=void 0){const H=new f;return s(H,N),s(H,O),this.sendBuffer(H.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch{return 0}}onBuffer(N){const O=new v(N),H=a(O),Z=a(O),$=H[0];switch($){case 200:return this.logger?.logIncoming(N.byteLength,0,0,y($)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(N.byteLength,H[1],0,y($),Z),this.onResponse({type:H[0],id:H[1],data:Z})}}onResponse(N){if(N.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}this.handlers.get(N.id)?.(N)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,w.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ge([D.memoize],k.prototype,"onDidInitializePromise",null),e.ChannelClient=k;class A{constructor(N){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new h.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new h.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,N(({protocol:O,onDidClientDisconnect:H})=>{h.Event.once(O.onMessage)($=>{const j=new v($),L=a(j),T=new l(O,L),_=new k(O);this.channels.forEach((Q,te)=>T.registerChannel(te,Q));const q={channelServer:T,channelClient:_,ctx:L};this._connections.add(q),this._onDidAddConnection.fire(q),H(()=>{T.dispose(),_.dispose(),this._connections.delete(q),this._onDidRemoveConnection.fire(q)})})})}get connections(){const N=[];return this._connections.forEach(O=>N.push(O)),N}getChannel(N,O){const H=this;return{call(Z,$,j){let L;if((0,p.isFunction)(O)){const _=(0,S.getRandomElement)(H.connections.filter(O));L=_?Promise.resolve(_):h.Event.toPromise(h.Event.filter(H.onDidAddConnection,O))}else L=O.routeCall(H,Z,$);const T=L.then(_=>_.channelClient.getChannel(N));return F(T).call(Z,$,j)},listen(Z,$){if((0,p.isFunction)(O))return H.getMulticastEvent(N,O,Z,$);const j=O.routeEvent(H,Z,$).then(L=>L.channelClient.getChannel(N));return F(j).listen(Z,$)}}}getMulticastEvent(N,O,H,Z){const $=this;let j=new w.DisposableStore;const L=new h.Emitter({onFirstListenerAdd:()=>{j=new w.DisposableStore;const T=new h.EventMultiplexer,_=new Map,q=te=>{const Y=te.channelClient.getChannel(N).listen(H,Z),x=T.add(Y);_.set(te,x)},Q=te=>{const U=_.get(te);!U||(U.dispose(),_.delete(te))};$.connections.filter(O).forEach(q),h.Event.filter($.onDidAddConnection,O)(q,void 0,j),$.onDidRemoveConnection(Q,void 0,j),T.event(L.fire,L,j),j.add(T)},onLastListenerRemove:()=>{j.dispose()}});return L.event}registerChannel(N,O){this.channels.set(N,O),this._connections.forEach(H=>{H.channelServer.registerChannel(N,O)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class W{constructor(N,O,H=null){const Z=new f;s(Z,O),N.send(Z.buffer),this.channelClient=new k(N,H),this.channelServer=new l(N,O,H)}getChannel(N){return this.channelClient.getChannel(N)}registerChannel(N,O){this.channelServer.registerChannel(N,O)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=W;function F(B){return{call(N,O,H){return B.then(Z=>Z.call(N,O,H))},listen(N,O){const H=new h.Relay;return B.then(Z=>H.input=Z.listen(N,O)),H.event}}}e.getDelayedChannel=F;function K(B){let N=!1;return{call(O,H,Z){return N?B.call(O,H,Z):(0,t.timeout)(0).then(()=>N=!0).then(()=>B.call(O,H,Z))},listen(O,H){if(N)return B.listen(O,H);const Z=new h.Relay;return(0,t.timeout)(0).then(()=>N=!0).then(()=>Z.input=B.listen(O,H)),Z.event}}}e.getNextTickChannel=K;class ie{constructor(N){this.fn=N}routeCall(N){return this.route(N)}routeEvent(N){return this.route(N)}async route(N){for(const O of N.connections)if(await Promise.resolve(this.fn(O.ctx)))return Promise.resolve(O);return await h.Event.toPromise(N.onDidAddConnection),await this.route(N)}}e.StaticRouter=ie;var oe;(function(B){function N($,j){const L=$,T=j&&j.disableMarshalling,_=new Map;for(const q in L)H(q)&&_.set(q,h.Event.buffer(L[q],!0));return new class{listen(q,Q,te){const U=_.get(Q);if(U)return U;if(Z(Q)){const Y=L[Q];if(typeof Y=="function")return Y.call(L,te)}throw new Error(`Event not found: ${Q}`)}call(q,Q,te){const U=L[Q];if(typeof U=="function"){if(!T&&Array.isArray(te))for(let Y=0;Y<te.length;Y++)te[Y]=(0,E.revive)(te[Y]);return U.apply(L,te)}throw new Error(`Method not found: ${Q}`)}}}B.fromService=N;function O($,j){const L=j&&j.disableMarshalling;return new Proxy({},{get(T,_){if(typeof _=="string")return j?.properties?.has(_)?j.properties.get(_):Z(_)?function(q){return $.listen(_,q)}:H(_)?$.listen(_):async function(...q){let Q;j&&!(0,p.isUndefinedOrNull)(j.context)?Q=[j.context,...q]:Q=q;const te=await $.call(_,Q);return L?te:(0,E.revive)(te)};throw new Error(`Property not found: ${String(_)}`)}})}B.toService=O;function H($){return $[0]==="o"&&$[1]==="n"&&C.isUpperAsciiLetter($.charCodeAt(2))}function Z($){return/^onDynamic/.test($)&&C.isUpperAsciiLetter($.charCodeAt(9))}})(oe=e.ProxyChannel||(e.ProxyChannel={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ne(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const N=B.toString();if(N!=="[object Object]")return N}return B}function ae(B){return Array.isArray(B)?B.map(ne):ne(B)}function le(B,N,O,H,Z,$,j){j=ae(j);const L=ue[Z],T=L[H%L.length];let _=[`%c[${B}]%c[${String(N).padStart(7," ")}]%c[len: ${String(O).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${$}`,"color: darkgreen","color: grey","color: grey",`color: ${T}`];/\($/.test($)?(_=_.concat(j),_.push(")")):_.push(j),console.log.apply(console,_)}e.logWithColors=le;class G{constructor(N,O){this._outgoingPrefix=N,this._incomingPrefix=O,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(N,O,H,Z,$){this._totalOutgoing+=N,le(this._outgoingPrefix,this._totalOutgoing,N,O,H,Z,$)}logIncoming(N,O,H,Z,$){this._totalIncoming+=N,le(this._incomingPrefix,this._totalIncoming,N,O,H,Z,$)}}e.IPCLogger=G}),define(X[139],J([0,1,17,3,43]),function(z,e,S,t,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(h){this.port=h,this.onMessage=t.Event.fromDOMEventEmitter(this.port,"message",w=>S.VSBuffer.wrap(w.data)),h.start()}send(h){this.port.postMessage(h.buffer)}disconnect(){this.port.close()}}e.Protocol=R;class D extends M.IPCClient{constructor(h,w){const E=new R(h);super(E,w);this.protocol=E}dispose(){this.protocol.disconnect()}}e.Client=D}),define(X[95],J([0,1,17,3,2,43]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(D=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var b;(function(n){n.enableDiagnostics=!1,n.records=[];const s=new WeakMap;let a=0;function l(k,A){if(!s.has(k)){const W=String(++a);s.set(k,W)}return s.get(k)}function I(k,A,W,F){if(!n.enableDiagnostics)return;const K=l(k,A);if(F instanceof S.VSBuffer||F instanceof Uint8Array||F instanceof ArrayBuffer||ArrayBuffer.isView(F)){const ie=S.VSBuffer.alloc(F.byteLength);ie.set(F),n.records.push({timestamp:Date.now(),id:K,label:A,type:W,buff:ie})}else n.records.push({timestamp:Date.now(),id:K,label:A,type:W,data:F})}n.traceSocketEvent=I})(b=e.SocketDiagnostics||(e.SocketDiagnostics={}));var h;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(h=e.SocketCloseEventType||(e.SocketCloseEventType={}));let w=null;function E(){return w||(w=S.VSBuffer.alloc(0)),w}class C{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,a){if(s===0)return E();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const A=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=s),A}if(this._chunks[0].byteLength>s){const A=this._chunks[0].slice(0,s);return a&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),A}const l=S.VSBuffer.alloc(s);let I=0,k=0;for(;s>0;){const A=this._chunks[k];if(A.byteLength>s){const W=A.slice(0,s);l.set(W,I),I+=s,a&&(this._chunks[k]=A.slice(s),this._totalLength-=s),s-=s}else l.set(A,I),I+=A.byteLength,a?(this._chunks.shift(),this._totalLength-=A.byteLength):k++,s-=A.byteLength}return l}}e.ChunkStream=C;var p;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume"})(p||(p={}));function g(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var d;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(d=e.ProtocolConstants||(e.ProtocolConstants={}));class P{constructor(s,a,l,I){this.type=s,this.id=a,this.ack=l,this.data=I,this.writtenTime=0}get size(){return this.data.byteLength}}class y extends M.Disposable{constructor(s){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new C,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:g(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const l=this._state.messageType,I=this._state.id,k=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",a),this._onMessage.fire(new P(l,I,k,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=S.VSBuffer.alloc(13);a.writeUInt8(s.type,0),a.writeUInt32BE(s.id,1),a.writeUInt32BE(s.ack,5),a.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:g(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(a,s.data)}_bufferAdd(s,a){const l=this._totalLength===0;return this._data.push(s,a),this._totalLength+=s.byteLength+a.byteLength,l}_bufferTake(){const s=S.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,a){this._bufferAdd(s,a)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class v extends M.Disposable{constructor(s){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new y(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new P(1,0,0,s))}}e.Protocol=v;class f extends R.IPCClient{constructor(s,a,l=null){super(s,a,l);this.protocol=s}static fromSocket(s,a){return new f(new v(s),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=f;class u{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=u;class c{constructor(s){this.data=s,this.next=null}}class o{constructor(){this._first=null,this._last=null}length(){let s=0,a=this._first;for(;a;)a=a.next,s++;return s}peek(){return this._first?this._first.data:null}toArray(){const s=[];let a=0,l=this._first;for(;l;)s[a++]=l.data,l=l.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const a=new c(s);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class r{constructor(){this.lastRuns=[];const s=Date.now();for(let a=0;a<r._HISTORY_LENGTH;a++)this.lastRuns[a]=s-1e3*a;setInterval(()=>{for(let a=r._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return r._INSTANCE||(r._INSTANCE=new r),r._INSTANCE}load(){const s=Date.now(),a=(1+r._HISTORY_LENGTH)*1e3;let l=0;for(let I=0;I<r._HISTORY_LENGTH;I++)s-this.lastRuns[I]<=a&&l++;return 1-l/r._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}r._HISTORY_LENGTH=10,r._INSTANCE=null;class i{constructor(s,a=null,l=r.getInstance()){this._onControlMessage=new u,this.onControlMessage=this._onControlMessage.event,this._onMessage=new u,this.onMessage=this._onMessage.event,this._onDidDispose=new u,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new u,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new u,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=l,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new y(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(I=>this._receiveMessage(I))),this._socketDisposables.push(this._socket.onClose(I=>this._onSocketClose.fire(I))),a&&this._socketReader.acceptChunk(a)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,M.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new P(5,0,0,E());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new P(7,0,0,E());this._socketWriter.write(s)}sendResume(){const s=new P(8,0,0,E());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,a){this._isReconnecting=!0,this._socketDisposables=(0,M.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new y(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new P(3,0,this._incomingAckId,E());this._socketWriter.write(s);const a=this._outgoingUnackMsg.toArray();for(let l=0,I=a.length;l<I;l++)this._socketWriter.write(a[l]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new P(6,0,0,E())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const a=this._outgoingUnackMsg.toArray();for(let l=0,I=a.length;l<I;l++)this._socketWriter.write(a[l]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const l=new P(1,a,this._incomingAckId,s);this._outgoingUnackMsg.push(l),this._isReconnecting||(this._socketWriter.write(l),this._recvAckCheck())}sendControl(s){const a=new P(2,0,0,s);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),a=Date.now()-s.writtenTime,l=Date.now()-this._socketReader.lastReadTime,I=Date.now()-this._lastSocketTimeoutTime;if(a>=2e4&&l>=2e4&&I>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:a,timeSinceLastReceivedSomeData:l});return}const k=Math.max(2e4-a,2e4-l,2e4-I,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},k)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new P(3,0,this._incomingAckId,E());this._socketWriter.write(s)}}e.PersistentProtocol=i}),define(X[140],J([0,1,38,17,3,2,43,127]),function(z,e,S,t,M,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function h(E,C){const p=M.Event.fromNodeEventEmitter(S.validatedIpcMain,C,(d,P)=>({event:d,message:P})),g=M.Event.filter(p,({event:d})=>d.sender.id===E);return M.Event.map(g,({message:d})=>d&&t.VSBuffer.wrap(d))}class w extends D.IPCServer{constructor(){super(w.getOnDidClientConnect())}static getOnDidClientConnect(){const C=M.Event.fromNodeEventEmitter(S.validatedIpcMain,"vscode:hello",({sender:p})=>p);return M.Event.map(C,p=>{const g=p.id;w.Clients.get(g)?.dispose();const P=new M.Emitter;w.Clients.set(g,(0,R.toDisposable)(()=>P.fire()));const y=h(g,"vscode:message"),m=M.Event.any(M.Event.signal(h(g,"vscode:disconnect")),P.event);return{protocol:new b.Protocol(p,y),onDidClientDisconnect:m}})}}e.Server=w,w.Clients=new Map}),define(X[96],J([0,1,38,3,27,139]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class D extends R.Client{constructor(w,E){super({addEventListener:(C,p)=>w.addListener(C,p),removeEventListener:(C,p)=>w.removeListener(C,p),postMessage:C=>w.postMessage(C),start:()=>w.start(),close:()=>w.close()},E)}}e.Client=D;async function b(h){if(h.isDestroyed()||h.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const w=(0,M.generateUuid)();h.webContents.send("vscode:createMessageChannel",w);const E=t.Event.fromNodeEventEmitter(S.validatedIpcMain,"vscode:createMessageChannelResult",(p,g)=>({nonce:g,port:p.ports[0]})),{port:C}=await t.Event.toPromise(t.Event.once(t.Event.filter(E,p=>p.nonce===w)));return C}e.connect=b}),define(X[141],J([0,1,49,8,17,21,134,19,3,2,51,81,77,43]),function(z,e,S,t,M,R,D,b,h,w,E,C,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends g.ChannelServer{constructor(m){super({send:v=>{try{process.send?.(v.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",v=>M.VSBuffer.wrap(Buffer.from(v,"base64")))},m);process.once("disconnect",()=>this.dispose())}}e.Server=d;class P{constructor(m,v){this.modulePath=m,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new h.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const f=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new t.Delayer(f),this.child=null,this._client=null}getChannel(m){const v=this;return{call(f,u,c){return v.requestPromise(m,f,u,c)},listen(f,u){return v.requestEvent(m,f,u)}}}requestPromise(m,v,f,u=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(u.isCancellationRequested)return Promise.reject(b.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(m),o=(0,t.createCancelablePromise)(n=>c.call(v,f,n)),r=u.onCancellationRequested(()=>o.cancel()),i=(0,w.toDisposable)(()=>o.cancel());return this.activeRequests.add(i),o.finally(()=>{r.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),o}requestEvent(m,v,f){if(!this.disposeDelayer)return h.Event.None;this.disposeDelayer.cancel();let u;const c=new h.Emitter({onFirstListenerAdd:()=>{u=this.getCachedChannel(m).listen(v,f)(c.fire,c),this.activeRequests.add(u)},onLastListenerRemove:()=>{this.activeRequests.delete(u),u.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const m=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,E.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),(0,p.removeDangerousEnvVariables)(v.env),this.child=(0,S.fork)(this.modulePath,m,v);const f=new h.Emitter;h.Event.fromNodeEventEmitter(this.child,"message",s=>s)(s=>{if((0,D.isRemoteConsoleLog)(s)){(0,D.log)(s,`IPC Library: ${this.options.serverName}`);return}f.fire(M.VSBuffer.wrap(Buffer.from(s,"base64")))});const c=this.options.useQueue?(0,C.createQueuedSender)(this.child):this.child,o=s=>this.child&&this.child.connected&&c.send(s.buffer.toString("base64")),r=f.event,i={send:o,onMessage:r};this._client=new g.ChannelClient(i);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",s=>console.warn('IPC "'+this.options.serverName+'" errored with '+s)),this.child.on("exit",(s,a)=>{process.removeListener("exit",n),this.activeRequests.forEach(l=>(0,w.dispose)(l)),this.activeRequests.clear(),s!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+s+" and signal "+a),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:s,signal:a})})}return this._client}getCachedChannel(m){let v=this.channels.get(m);return v||(v=this.client.getChannel(m),this.channels.set(m,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=P}),define(X[82],J([0,1,17,19,3,2,9,4,27,43,95]),function(z,e,S,t,M,R,D,b,h,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function C(){return{crypto:z.__$__nodeRequire("crypto"),zlib:z.__$__nodeRequire("zlib"),net:z.__$__nodeRequire("net"),os:z.__$__nodeRequire("os")}}class p{constructor(l,I=""){this.debugLabel=I,this.socket=l,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=k=>{if(this.traceSocketEvent("error",{code:k?.code,message:k?.message}),k){if(k.code==="EPIPE")return;(0,t.onUnexpectedError)(k)}},this.socket.on("error",this._errorListener)}traceSocketEvent(l,I){E.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,l,I)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(l){const I=k=>{this.traceSocketEvent("read",k),l(S.VSBuffer.wrap(k))};return this.socket.on("data",I),{dispose:()=>this.socket.off("data",I)}}onClose(l){const I=k=>{this.traceSocketEvent("close",{hadError:k}),l({type:0,hadError:k,error:void 0})};return this.socket.on("close",I),{dispose:()=>this.socket.off("close",I)}}onEnd(l){const I=()=>{this.traceSocketEvent("nodeEndReceived"),l()};return this.socket.on("end",I),{dispose:()=>this.socket.off("end",I)}}write(l){if(!this.socket.destroyed)try{this.traceSocketEvent("write",l),this.socket.write(l.buffer,I=>{if(I){if(I.code==="EPIPE")return;(0,t.onUnexpectedError)(I)}})}catch(I){if(I.code==="EPIPE")return;(0,t.onUnexpectedError)(I)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((l,I)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),l();return}const k=()=>{this.socket.off("close",k),this.socket.off("end",k),this.socket.off("error",k),this.socket.off("timeout",k),this.socket.off("drain",k),this.traceSocketEvent("nodeDrainEnd"),l()};this.socket.on("close",k),this.socket.on("end",k),this.socket.on("error",k),this.socket.on("timeout",k),this.socket.on("drain",k)})}}e.NodeSocket=p;var g;(function(a){a[a.MinHeaderByteSize=2]="MinHeaderByteSize"})(g||(g={}));var d;(function(a){a[a.PeekHeader=1]="PeekHeader",a[a.ReadHeader=2]="ReadHeader",a[a.ReadBody=3]="ReadBody",a[a.Fin=4]="Fin"})(d||(d={}));class P extends R.Disposable{constructor(l,I,k,A){super();this._onData=this._register(new M.Emitter),this._onClose=this._register(new M.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=l,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:I,inflateBytesLength:k?.byteLength||0,recordInflateBytes:A}),this._flowManager=this._register(new y(this,I,k,A,this._onData,(W,F)=>this._write(W,F))),this._register(this._flowManager.onError(W=>{console.error(W),(0,t.onUnexpectedError)(W),this._onClose.fire({type:0,hadError:!0,error:W})})),this._incomingData=new E.ChunkStream,this._register(this.socket.onData(W=>this._acceptChunk(W))),this._register(this.socket.onClose(W=>this._onClose.fire(W)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(l,I){this.socket.traceSocketEvent(l,I)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(l){return this._onData.event(l)}onClose(l){return this._onClose.event(l)}onEnd(l){return this.socket.onEnd(l)}write(l){this._flowManager.writeMessage(l)}_write(l,I){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",l);let k=2;l.byteLength<126?k+=0:l.byteLength<2**16?k+=2:k+=8;const A=S.VSBuffer.alloc(k);if(I?A.writeUInt8(194,0):A.writeUInt8(130,0),l.byteLength<126)A.writeUInt8(l.byteLength,1);else if(l.byteLength<2**16){A.writeUInt8(126,1);let W=1;A.writeUInt8(l.byteLength>>>8&255,++W),A.writeUInt8(l.byteLength>>>0&255,++W)}else{A.writeUInt8(127,1);let W=1;A.writeUInt8(0,++W),A.writeUInt8(0,++W),A.writeUInt8(0,++W),A.writeUInt8(0,++W),A.writeUInt8(l.byteLength>>>24&255,++W),A.writeUInt8(l.byteLength>>>16&255,++W),A.writeUInt8(l.byteLength>>>8&255,++W),A.writeUInt8(l.byteLength>>>0&255,++W)}this.socket.write(S.VSBuffer.concat([A,l]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(l){if(l.byteLength!==0){for(this._incomingData.acceptChunk(l);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const I=this._incomingData.peek(this._state.readLen),k=I.readUInt8(0),A=(k&128)>>>7,W=(k&64)>>>6,F=I.readUInt8(1),K=(F&128)>>>7,ie=F&127;this._state.state=2,this._state.readLen=2+(K?4:0)+(ie===126?2:0)+(ie===127?8:0),this._state.fin=A,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(W)),this._state.firstFrameOfMessage=Boolean(A),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const I=this._incomingData.read(this._state.readLen),k=I.readUInt8(1),A=(k&128)>>>7;let W=k&127,F=1;W===126?W=I.readUInt8(++F)*2**8+I.readUInt8(++F):W===127&&(W=I.readUInt8(++F)*0+I.readUInt8(++F)*0+I.readUInt8(++F)*0+I.readUInt8(++F)*0+I.readUInt8(++F)*2**24+I.readUInt8(++F)*2**16+I.readUInt8(++F)*2**8+I.readUInt8(++F));let K=0;A&&(K=I.readUInt8(++F)*2**24+I.readUInt8(++F)*2**16+I.readUInt8(++F)*2**8+I.readUInt8(++F)),this._state.state=3,this._state.readLen=W,this._state.mask=K,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const I=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",I),f(I,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",I),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(I,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await M.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=P;class y extends R.Disposable{constructor(l,I,k,A,W,F){super();this._tracer=l,this._onData=W,this._writeFn=F,this._onError=this._register(new M.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new M.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,I?(this._zlibInflateStream=this._register(new m(this._tracer,A,k,{windowBits:15})),this._zlibDeflateStream=this._register(new v(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(K=>this._onError.fire(K))),this._register(this._zlibDeflateStream.onError(K=>this._onError.fire(K)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:S.VSBuffer.alloc(0)}writeMessage(l){this._writeQueue.push(l),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const l=this._writeQueue.shift();if(this._zlibDeflateStream){const I=await this._deflateMessage(this._zlibDeflateStream,l);this._writeFn(I,!0)}else this._writeFn(l,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(l,I){return new Promise((k,A)=>{l.write(I),l.flush(W=>k(W))})}acceptFrame(l,I,k){this._readQueue.push({data:l,isCompressed:I,isLastFrameOfMessage:k}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const l=this._readQueue.shift();if(this._zlibInflateStream&&l.isCompressed){const I=await this._inflateFrame(this._zlibInflateStream,l.data,l.isLastFrameOfMessage);this._onData.fire(I)}else this._onData.fire(l.data)}this._isProcessingReadQueue=!1}}_inflateFrame(l,I,k){return new Promise((A,W)=>{l.write(I),k&&l.write(S.VSBuffer.fromByteArray([0,0,255,255])),l.flush(F=>A(F))})}}class m extends R.Disposable{constructor(l,I,k,A){super();this._tracer=l,this._recordInflateBytes=I,this._onError=this._register(new M.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=C().zlib.createInflateRaw(A),this._zlibInflate.on("error",W=>{this._tracer.traceSocketEvent("zlibInflateError",{message:W?.message,code:W?.code}),this._onError.fire(W)}),this._zlibInflate.on("data",W=>{this._tracer.traceSocketEvent("zlibInflateData",W),this._pendingInflateData.push(S.VSBuffer.wrap(W))}),k&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",k.buffer),this._zlibInflate.write(k.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?S.VSBuffer.concat(this._recordedInflateBytes):S.VSBuffer.alloc(0)}write(l){this._recordInflateBytes&&this._recordedInflateBytes.push(l.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",l),this._zlibInflate.write(l.buffer)}flush(l){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const I=S.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,l(I)})}}class v extends R.Disposable{constructor(l,I){super();this._tracer=l,this._onError=this._register(new M.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=C().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",k=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:k?.message,code:k?.code}),this._onError.fire(k)}),this._zlibDeflate.on("data",k=>{this._tracer.traceSocketEvent("zlibDeflateData",k),this._pendingDeflateData.push(S.VSBuffer.wrap(k))})}write(l){this._tracer.traceSocketEvent("zlibDeflateWrite",l.buffer),this._zlibDeflate.write(l.buffer)}flush(l){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let I=S.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,I=I.slice(0,I.byteLength-4),l(I)})}}function f(a,l){if(l===0)return;const I=a.byteLength>>>2;for(let ie=0;ie<I;ie++){const oe=a.readUInt32BE(ie*4);a.writeUInt32BE(oe^l,ie*4)}const k=I*4,A=a.byteLength-k,W=l>>>24&255,F=l>>>16&255,K=l>>>8&255;A>=1&&a.writeUInt8(a.readUInt8(k)^W,k),A>=2&&a.writeUInt8(a.readUInt8(k+1)^F,k+1),A>=3&&a.writeUInt8(a.readUInt8(k+2)^K,k+2)}e.XDG_RUNTIME_DIR=typeof process!="undefined"?process.env.XDG_RUNTIME_DIR:void 0;const u={[2]:107,[1]:103};function c(){const a=(0,h.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${a}-sock`;let l;return e.XDG_RUNTIME_DIR?l=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${a}.sock`):l=(0,D.join)(C().os.tmpdir(),`vscode-ipc-${a}.sock`),r(l),l}e.createRandomIPCHandle=c;function o(a,l,I){const k=C().crypto.createHash("md5").update(a).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${k}-${I}-${l}-sock`;let A;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?A=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${k.substr(0,8)}-${I}-${l}.sock`):A=(0,D.join)(a,`${I}-${l}.sock`),r(A),A}e.createStaticIPCHandle=o;function r(a){const l=u[b.platform];typeof l=="number"&&a.length>=l&&console.warn(`WARNING: IPC handle "${a}" is longer than ${l} chars, try a shorter --user-data-dir`)}class i extends w.IPCServer{constructor(l){super(i.toClientConnectionEvent(l));this.server=l}static toClientConnectionEvent(l){const I=M.Event.fromNodeEventEmitter(l,"connection");return M.Event.map(I,k=>({protocol:new E.Protocol(new p(k,"ipc-server-connection")),onDidClientDisconnect:M.Event.once(M.Event.fromNodeEventEmitter(k,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function n(a){return new Promise((l,I)=>{const k=C().net.createServer();k.on("error",I),k.listen(a,()=>{k.removeListener("error",I),l(new i(k))})})}e.serve=n;function s(a,l){return new Promise((I,k)=>{const A=C().net.createConnection(a,()=>{A.removeListener("error",k),I(E.Client.fromSocket(new p(A,`ipc-client${l}`),l))});A.once("error",k)})}e.connect=s}),define(X[97],J([0,1,8,3,2,11]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var D;(function(C){C[C.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(D=e.StorageHint||(e.StorageHint={}));function b(C){const p=C;return p?.changed instanceof Map||p?.deleted instanceof Set}e.isStorageItemsChangeEvent=b;var h;(function(C){C[C.None=0]="None",C[C.Initialized=1]="Initialized",C[C.Closed=2]="Closed"})(h=e.StorageState||(e.StorageState={}));class w extends M.Disposable{constructor(p,g=Object.create(null)){super();this.database=p,this.options=g,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=h.None,this.cache=new Map,this.flushDelayer=new S.ThrottledDelayer(w.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(p=>this.onDidChangeItemsExternal(p)))}onDidChangeItemsExternal(p){p.changed?.forEach((g,d)=>this.accept(d,g)),p.deleted?.forEach(g=>this.accept(g,void 0))}accept(p,g){if(this.state===h.Closed)return;let d=!1;(0,R.isUndefinedOrNull)(g)?d=this.cache.delete(p):this.cache.get(p)!==g&&(this.cache.set(p,g),d=!0),d&&this._onDidChangeStorage.fire(p)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===h.None&&(this.state=h.Initialized,this.options.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(p,g){const d=this.cache.get(p);return(0,R.isUndefinedOrNull)(d)?g:d}getBoolean(p,g){const d=this.get(p);return(0,R.isUndefinedOrNull)(d)?g:d==="true"}getNumber(p,g){const d=this.get(p);return(0,R.isUndefinedOrNull)(d)?g:parseInt(d,10)}async set(p,g){if(this.state===h.Closed)return;if((0,R.isUndefinedOrNull)(g))return this.delete(p);const d=String(g);if(this.cache.get(p)!==d)return this.cache.set(p,d),this.pendingInserts.set(p,d),this.pendingDeletes.delete(p),this._onDidChangeStorage.fire(p),this.doFlush()}async delete(p){if(!(this.state===h.Closed||!this.cache.delete(p)))return this.pendingDeletes.has(p)||this.pendingDeletes.add(p),this.pendingInserts.delete(p),this._onDidChangeStorage.fire(p),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=h.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const p={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(p).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(p){if(!!this.hasPending)return this.doFlush(p)}async doFlush(p){return this.flushDelayer.trigger(()=>this.flushPending(),p)}async whenFlushed(){if(!!this.hasPending)return new Promise(p=>this.whenFlushedCallbacks.push(p))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=w,w.DEFAULT_FLUSH_DELAY=100;class E{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(p){p.insert?.forEach((g,d)=>this.items.set(d,g)),p.delete?.forEach(g=>this.items.delete(g))}async close(){}}e.InMemoryStorageDatabase=E}),define(X[142],J([0,1,8,3,33,9,23]),function(z,e,S,t,M,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class b{constructor(E,C=Object.create(null)){this.path=E,this.options=C,this.name=(0,R.basename)(this.path),this.logger=new h(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return t.Event.None}async getItems(){const E=await this.whenConnected,C=new Map;return(await this.all(E,"SELECT * FROM ItemTable")).forEach(g=>C.set(g.key,g.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${C.size} rows`),C}async updateItems(E){const C=await this.whenConnected;return this.doUpdateItems(C,E)}doUpdateItems(E,C){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${C.insert?(0,M.mapToString)(C.insert):"0"}), delete(${C.delete?(0,M.setToString)(C.delete):"0"})`),this.transaction(E,()=>{const p=C.insert,g=C.delete;if(p&&p.size>0){const d=[];d.push([]);let P=0;p.forEach((y,m)=>{let v=d[P];v.length>b.MAX_HOST_PARAMETERS&&(P++,v=[],d.push(v)),v.push(m,y)}),d.forEach(y=>{this.prepare(E,`INSERT INTO ItemTable VALUES ${new Array(y.length/2).fill("(?,?)").join(",")}`,m=>m.run(y),()=>{const m=[];let v=0;return p.forEach((f,u)=>{m.push(u),v+=f.length}),`Keys: ${m.join(", ")} Length: ${v}`})})}if(g&&g.size){const d=[];d.push([]);let P=0;g.forEach(y=>{let m=d[P];m.length>b.MAX_HOST_PARAMETERS&&(P++,m=[],d.push(m)),m.push(y)}),d.forEach(y=>{this.prepare(E,`DELETE FROM ItemTable WHERE key IN (${new Array(y.length).fill("?").join(",")})`,m=>m.run(y),()=>{const m=[];return g.forEach(v=>{m.push(v)}),`Keys: ${m.join(", ")}`})})}})}async close(E){this.logger.trace(`[storage ${this.name}] close()`);const C=await this.whenConnected;return this.doClose(C,E)}doClose(E,C){return new Promise((p,g)=>{E.db.close(d=>(d&&this.handleSQLiteError(E,`[storage ${this.name}] close(): ${d}`),this.path===b.IN_MEMORY_PATH?p():!E.isErroneous&&!E.isInMemory?this.backup().then(p,P=>(this.logger.error(`[storage ${this.name}] backup(): ${P}`),p())):typeof C=="function"?D.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(P=>{const y=()=>this.doClose(P,void 0);return this.doUpdateItems(P,{insert:C()}).then(()=>y(),m=>(y(),Promise.reject(m)))})).then(p,g):g(d||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const E=this.toBackupPath(this.path);return D.Promises.copy(this.path,E,{preserveSymlinks:!1})}toBackupPath(E){return`${E}.backup`}async checkIntegrity(E){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${E})`);const C=await this.whenConnected,p=await this.get(C,E?"PRAGMA integrity_check":"PRAGMA quick_check"),g=E?p.integrity_check:p.quick_check;return C.isErroneous?`${g} (last error: ${C.lastError})`:C.isInMemory?`${g} (in-memory!)`:g}async connect(E,C=!0){this.logger.trace(`[storage ${this.name}] open(${E}, retryOnBusy: ${C})`);try{return await this.doConnect(E)}catch(p){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${p}`),p.code==="SQLITE_BUSY"&&C)return await(0,S.timeout)(b.BUSY_OPEN_TIMEOUT),this.connect(E,!1);try{await D.Promises.unlink(E);try{await D.Promises.rename(this.toBackupPath(E),E)}catch{}return await this.doConnect(E)}catch(g){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${g}`),this.doConnect(b.IN_MEMORY_PATH)}}}handleSQLiteError(E,C){E.isErroneous=!0,E.lastError=C,this.logger.error(C)}doConnect(E){return new Promise((C,p)=>{new Promise((g,d)=>{z(["@vscode/sqlite3"],g,d)}).then(g=>{const d={db:new(this.logger.isTracing?g.verbose().Database:g.Database)(E,P=>P?d.db&&P.code!=="SQLITE_CANTOPEN"?d.db.close(()=>p(P)):p(P):this.exec(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>C(d),y=>d.db.close(()=>p(y)))),isInMemory:E===b.IN_MEMORY_PATH};d.db.on("error",P=>this.handleSQLiteError(d,`[storage ${this.name}] Error (event): ${P}`)),this.logger.isTracing&&d.db.on("trace",P=>this.logger.trace(`[storage ${this.name}] Trace (event): ${P}`))},p)})}exec(E,C){return new Promise((p,g)=>{E.db.exec(C,d=>d?(this.handleSQLiteError(E,`[storage ${this.name}] exec(): ${d}`),g(d)):p())})}get(E,C){return new Promise((p,g)=>{E.db.get(C,(d,P)=>d?(this.handleSQLiteError(E,`[storage ${this.name}] get(): ${d}`),g(d)):p(P))})}all(E,C){return new Promise((p,g)=>{E.db.all(C,(d,P)=>d?(this.handleSQLiteError(E,`[storage ${this.name}] all(): ${d}`),g(d)):p(P))})}transaction(E,C){return new Promise((p,g)=>{E.db.serialize(()=>{E.db.run("BEGIN TRANSACTION"),C(),E.db.run("END TRANSACTION",d=>d?(this.handleSQLiteError(E,`[storage ${this.name}] transaction(): ${d}`),g(d)):p())})})}prepare(E,C,p,g){const d=E.db.prepare(C),P=y=>{this.handleSQLiteError(E,`[storage ${this.name}] prepare(): ${y} (${C}). Details: ${g()}`)};d.on("error",P),p(d),d.finalize(y=>{y&&P(y),d.removeListener("error",P)})}}e.SQLiteStorageDatabase=b,b.IN_MEMORY_PATH=":memory:",b.BUSY_OPEN_TIMEOUT=2e3,b.MAX_HOST_PARAMETERS=256;class h{constructor(E){E&&typeof E.logTrace=="function"&&process.env[h.VSCODE_TRACE_STORAGE]&&(this.logTrace=E.logTrace),E&&typeof E.logError=="function"&&(this.logError=E.logError)}get isTracing(){return!!this.logTrace}trace(E){this.logTrace?.(E)}error(E){this.logError?.(E)}}h.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(X[143],J([12,10]),function(z,e){return z.create("vs/code/electron-main/app",e)}),define(X[144],J([12,10]),function(z,e){return z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(X[145],J([12,10]),function(z,e){return z.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(X[146],J([12,10]),function(z,e){return z.create("vs/platform/environment/node/argv",e)}),define(X[147],J([12,10]),function(z,e){return z.create("vs/platform/environment/node/argvHelper",e)}),define(X[148],J([12,10]),function(z,e){return z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(X[149],J([12,10]),function(z,e){return z.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(X[150],J([12,10]),function(z,e){return z.create("vs/platform/files/common/fileService",e)}),define(X[151],J([12,10]),function(z,e){return z.create("vs/platform/files/common/files",e)}),define(X[152],J([12,10]),function(z,e){return z.create("vs/platform/files/common/io",e)}),define(X[153],J([12,10]),function(z,e){return z.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(X[154],J([12,10]),function(z,e){return z.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(X[155],J([12,10]),function(z,e){return z.create("vs/platform/issue/electron-main/issueMainService",e)}),define(X[156],J([12,10]),function(z,e){return z.create("vs/platform/menubar/electron-main/menubar",e)}),define(X[157],J([12,10]),function(z,e){return z.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(X[158],J([12,10]),function(z,e){return z.create("vs/platform/request/common/request",e)}),define(X[159],J([12,10]),function(z,e){return z.create("vs/platform/shell/node/shellEnv",e)}),define(X[160],J([12,10]),function(z,e){return z.create("vs/platform/telemetry/common/telemetryService",e)}),define(X[161],J([12,10]),function(z,e){return z.create("vs/platform/update/common/update.config.contribution",e)}),define(X[162],J([12,10]),function(z,e){return z.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(X[163],J([12,10]),function(z,e){return z.create("vs/platform/windows/electron-main/windowImpl",e)}),define(X[164],J([12,10]),function(z,e){return z.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(X[165],J([12,10]),function(z,e){return z.create("vs/platform/workspace/common/workspace",e)}),define(X[166],J([12,10]),function(z,e){return z.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(X[167],J([12,10]),function(z,e){return z.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(X[168],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function S(M){return M&&M.hasOwnProperty("folderUri")}e.isFolderBackupInfo=S;function t(M){return M&&M.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(X[169],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEmptyWindowBackupInfo=void 0;function S(t){return typeof t?.backupFolder=="string"}e.isEmptyWindowBackupInfo=S}),define(X[170],J([0,1,3,2]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class M{constructor(){this._onCloseEmitter=new S.Emitter,this._onReloadEmitter=new S.Emitter,this._onTerminateEmitter=new S.Emitter,this._onAttachEmitter=new S.Emitter}call(b,h,w){switch(h){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:w[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:w[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:w[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:w[0],port:w[1],subId:w[2]}))}throw new Error("Method not implemented.")}listen(b,h,w){switch(h){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=M,M.ChannelName="extensionhostdebugservice";class R extends t.Disposable{constructor(b){super();this.channel=b}reload(b){this.channel.call("reload",[b])}get onReload(){return this.channel.listen("reload")}close(b){this.channel.call("close",[b])}get onClose(){return this.channel.listen("close")}attachSession(b,h,w){this.channel.call("attach",[b,h,w])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(b,h){this.channel.call("terminate",[b,h])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(b,h){return this.channel.call("openExtensionDevelopmentHostWindow",[b,h])}}e.ExtensionHostDebugChannelClient=R}),define(X[171],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class S{constructor(M){this.machineId=M}encryption(){return new Promise((M,R)=>z(["vscode-encrypt"],M,R))}async encrypt(M){try{return(await this.encryption()).encrypt(this.machineId,M)}catch{return M}}async decrypt(M){try{return(await this.encryption()).decrypt(this.machineId,M)}catch{return M}}}e.EncryptionMainService=S}),define(X[172],J([0,1,130,50,13,9,36,16,7]),function(z,e,S,t,M,R,D,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class w{constructor(P,y,m){this._args=P,this.paths=y,this.productService=m,this.editSessionId=this.args.editSessionId}get appRoot(){return(0,R.dirname)(M.FileAccess.asFileUri("",z).fsPath)}get userHome(){return h.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return h.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.paths.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,b.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,b.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const P=(0,S.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",P)}return this.args.logsPath}get userDataSyncLogResource(){return h.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return h.URI.file((0,R.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,b.joinPath)(h.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,b.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,b.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,b.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const P=D.env.VSCODE_PORTABLE;return P?h.URI.file((0,R.join)(P,"argv.json")):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const P=this.args["builtin-extensions-dir"];return P?(0,R.resolve)(P):(0,R.normalize)((0,R.join)(M.FileAccess.asFileUri("",z).fsPath,"..","extensions"))}get extensionsDownloadPath(){const P=this.args["extensions-download-dir"];return P?(0,R.resolve)(P):(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const P=this.args["extensions-dir"];if(P)return(0,R.resolve)(P);const y=D.env.VSCODE_EXTENSIONS;if(y)return y;const m=D.env.VSCODE_PORTABLE;return m?(0,R.join)(m,"extensions"):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const P=this.args.extensionDevelopmentPath;if(Array.isArray(P))return P.map(y=>/^[^:/?#]+?:\/\//.test(y)?h.URI.parse(y):h.URI.file((0,R.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(P=>P==="ui"||P==="workspace"||P==="web"?P:"workspace")}get extensionTestsLocationURI(){const P=this.args.extensionTestsPath;if(P)return/^[^:/?#]+?:\/\//.test(P)?h.URI.parse(P):h.URI.file((0,R.normalize)(P))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const P=this.args["disable-extension"];if(P){if(typeof P=="string")return[P];if(Array.isArray(P)&&P.length>0)return P}return!1}get debugExtensionHost(){return E(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,b.joinPath)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return h.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get extensionTelemetryLogResource(){return h.URI.file((0,R.join)(this.logsPath,"extensionTelemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const P=D.env.VSCODE_PORTABLE;return P?h.URI.file((0,R.join)(P,"policy.json")):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}ge([t.memoize],w.prototype,"appRoot",null),ge([t.memoize],w.prototype,"userHome",null),ge([t.memoize],w.prototype,"userDataPath",null),ge([t.memoize],w.prototype,"appSettingsHome",null),ge([t.memoize],w.prototype,"tmpDir",null),ge([t.memoize],w.prototype,"cacheHome",null),ge([t.memoize],w.prototype,"stateResource",null),ge([t.memoize],w.prototype,"userRoamingDataHome",null),ge([t.memoize],w.prototype,"userDataSyncHome",null),ge([t.memoize],w.prototype,"userDataSyncLogResource",null),ge([t.memoize],w.prototype,"editSessionsLogResource",null),ge([t.memoize],w.prototype,"sync",null),ge([t.memoize],w.prototype,"machineSettingsResource",null),ge([t.memoize],w.prototype,"workspaceStorageHome",null),ge([t.memoize],w.prototype,"localHistoryHome",null),ge([t.memoize],w.prototype,"keyboardLayoutResource",null),ge([t.memoize],w.prototype,"argvResource",null),ge([t.memoize],w.prototype,"isExtensionDevelopment",null),ge([t.memoize],w.prototype,"untitledWorkspacesHome",null),ge([t.memoize],w.prototype,"installSourcePath",null),ge([t.memoize],w.prototype,"builtinExtensionsPath",null),ge([t.memoize],w.prototype,"extensionsPath",null),ge([t.memoize],w.prototype,"extensionDevelopmentLocationURI",null),ge([t.memoize],w.prototype,"extensionDevelopmentKind",null),ge([t.memoize],w.prototype,"extensionTestsLocationURI",null),ge([t.memoize],w.prototype,"debugExtensionHost",null),ge([t.memoize],w.prototype,"serviceMachineIdResource",null),ge([t.memoize],w.prototype,"telemetryLogResource",null),ge([t.memoize],w.prototype,"disableWorkspaceTrust",null),ge([t.memoize],w.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=w;function E(d,P){return g(d["inspect-extensions"],d["inspect-brk-extensions"],5870,P,d.debugId,d.extensionEnvironment)}e.parseExtensionHostPort=E;function C(d,P){return g(d["inspect-search"],d["inspect-brk-search"],5876,P,d.extensionEnvironment)}e.parseSearchPort=C;function p(d,P){return g(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,P,d.extensionEnvironment)}e.parsePtyHostPort=p;function g(d,P,y,m,v,f){const c=Number(P||d)||(m?null:y),o=c?Boolean(!!P):!1;let r;if(f)try{r=JSON.parse(f)}catch{}return{port:c,break:o,debugId:v,env:r}}}),define(X[98],J([0,1,257,4,146]),function(z,e,S,t,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,M.localize)(0,null),e:(0,M.localize)(1,null),t:(0,M.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,M.localize)(3,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,M.localize)(4,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,M.localize)(5,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,M.localize)(6,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,M.localize)(7,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,M.localize)(8,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,M.localize)(9,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,M.localize)(10,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,M.localize)(11,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,M.localize)(12,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,M.localize)(13,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,M.localize)(14,null)},"show-versions":{type:"boolean",cat:"e",description:(0,M.localize)(15,null)},category:{type:"string",cat:"e",description:(0,M.localize)(16,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,M.localize)(17,null)},"pre-release":{type:"boolean",cat:"e",description:(0,M.localize)(18,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,M.localize)(19,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,M.localize)(20,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,M.localize)(21,null)},verbose:{type:"boolean",cat:"t",description:(0,M.localize)(22,null)},log:{type:"string",cat:"t",args:"level",description:(0,M.localize)(23,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,M.localize)(24,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,M.localize)(25,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,M.localize)(26,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,M.localize)(27,null)},sync:{type:"string",cat:"t",description:(0,M.localize)(28,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,M.localize)(29,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,M.localize)(30,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,M.localize)(31,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,M.localize)(32,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,M.localize)(33,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function b(d,P,y=D){const m={},v=["_"],f=[];for(const r in P){const i=P[r];i.alias&&(m[r]=i.alias),i.type==="string"||i.type==="string[]"?(v.push(r),i.deprecates&&v.push(...i.deprecates)):i.type==="boolean"&&(f.push(r),i.deprecates&&f.push(...i.deprecates))}const u=S(d,{string:v,boolean:f,alias:m}),c={},o=u;c._=u._.map(r=>String(r)).filter(r=>r.length>0),delete o._;for(const r in P){const i=P[r];i.alias&&delete o[i.alias];let n=o[r];if(i.deprecates)for(const s of i.deprecates)o.hasOwnProperty(s)&&(n||(n=o[s],n&&y.onDeprecatedOption(s,i.deprecationMessage||(0,M.localize)(34,null,r))),delete o[s]);if(typeof n!="undefined"){if(i.type==="string[]"){if(Array.isArray(n)||(n=[n]),!i.allowEmptyValue){const s=n.filter(a=>a.length>0);s.length!==n.length&&(y.onEmptyValue(r),n=s.length>0?s:void 0)}}else i.type==="string"&&(Array.isArray(n)?(n=n.pop(),y.onMultipleValues(r,n)):!n&&!i.allowEmptyValue&&(y.onEmptyValue(r),n=void 0));c[r]=n,i.deprecationMessage&&y.onDeprecatedOption(r,i.deprecationMessage)}delete o[r]}for(const r in o)y.onUnknownOption(r);return c}e.parseArgs=b;function h(d,P){let y="";return P.args&&(Array.isArray(P.args)?y=` <${P.args.join("> <")}>`:y=` <${P.args}>`),P.alias?`-${P.alias} --${d}${y}`:`--${d}${y}`}function w(d,P){let y=0;const m=[];for(const c in d){const o=d[c],r=h(c,o);y=Math.max(y,r.length),m.push([r,o.description])}const v=y+2+1;if(P-v<25)return m.reduce((c,o)=>c.concat([`  ${o[0]}`,`      ${o[1]}`]),[]);const f=P-v-1,u=[];for(const c of m){const o=c[0],r=C(c[1],f),i=E(v-o.length-2);u.push("  "+o+i+r[0]);for(let n=1;n<r.length;n++)u.push(E(v)+r[n])}return u}e.formatOptions=w;function E(d){return" ".repeat(d)}function C(d,P){const y=[];for(;d.length;){const m=d.length<P?d.length:d.lastIndexOf(" ",P),v=d.slice(0,m).trim();d=d.slice(m),y.push(v)}return y}function p(d,P,y,m,v){const f=process.stdout.isTTY&&process.stdout.columns||80,u=v?.noInputFiles!==!0?`[${(0,M.localize)(35,null)}...]`:"",c=[`${d} ${y}`];c.push(""),c.push(`${(0,M.localize)(36,null)}: ${P} [${(0,M.localize)(37,null)}]${u}`),c.push(""),v?.noPipe!==!0&&(t.isWindows?c.push((0,M.localize)(38,null,P)):c.push((0,M.localize)(39,null,P)),c.push(""));const o={};for(const r in m){const i=m[r];if(i.description&&i.cat){let n=o[i.cat];n||(o[i.cat]=n={}),n[r]=i}}for(const r in o){const i=r,n=o[i];n&&(c.push(R[i]),c.push(...w(n,f)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=p;function g(d,P){return`${d||(0,M.localize)(40,null)}
${P||(0,M.localize)(41,null)}
${process.arch}`}e.buildVersionMessage=g}),define(X[173],J([0,1,76,170,98]),function(z,e,S,t,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class R extends t.ExtensionHostDebugBroadcastChannel{constructor(b){super();this.windowsMainService=b}call(b,h,w){return h==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(w[0],w[1]):super.call(b,h,w)}async openExtensionDevelopmentHostWindow(b,h){const w=(0,M.parseArgs)(b,M.OPTIONS);w.debugRenderer=h;const E=w.extensionDevelopmentPath;if(!E)return{success:!1};const[C]=this.windowsMainService.openExtensionDevelopmentHostWindow(E,{context:5,cli:w});if(!h)return{success:!0};const p=C.win;if(!p)return{success:!0};const g=p.webContents.debugger;let d=g.isAttached()?1/0:0;const P=(0,S.createServer)(y=>{d++==0&&g.attach();let m=!1;const v=c=>{m||y.write(JSON.stringify(c)+"\0")},f=(c,o,r,i)=>v({method:o,params:r,sessionId:i});p.on("close",()=>{g.removeListener("message",f),y.end(),m=!0}),g.addListener("message",f);let u=Buffer.alloc(0);y.on("data",c=>{u=Buffer.concat([u,c]);for(let o=u.indexOf(0);o!==-1;o=u.indexOf(0)){let r;try{const i=u.slice(0,o).toString("utf8");u=u.slice(o+1),r=JSON.parse(i)}catch(i){console.error("error reading cdp line",i)}g.sendCommand(r.method,r.params,r.sessionId).then(i=>v({id:r.id,sessionId:r.sessionId,result:i})).catch(i=>v({id:r.id,sessionId:r.sessionId,error:{code:0,message:i.message}}))}}),y.on("error",c=>{console.error("error on cdp pipe:",c)}),y.on("close",()=>{m=!0,--d==0&&g.detach()})});return await new Promise(y=>P.listen(0,y)),p.on("close",()=>P.close()),{rendererDebugPort:P.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=R}),define(X[57],J([0,1,258,147,98]),function(z,e,S,t,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const R=2048;function D(p,g){const d={onUnknownOption:y=>{console.warn((0,t.localize)(0,null,y))},onMultipleValues:(y,m)=>{console.warn((0,t.localize)(1,null,y,m))},onEmptyValue:y=>{console.warn((0,t.localize)(2,null,y))},onDeprecatedOption:(y,m)=>{console.warn((0,t.localize)(3,null,y,m))}},P=(0,M.parseArgs)(p,M.OPTIONS,g?d:void 0);return P.goto&&P._.forEach(y=>S(/^(\w:)?[^:]+(:\d*){0,2}$/.test(y),(0,t.localize)(4,null))),P["max-memory"]&&S(parseInt(P["max-memory"])>=R,`The max-memory argument cannot be specified lower than ${R} MB.`),P}function b(p){const g=p.findIndex(d=>!/^-/.test(d));if(g>-1)return[...p.slice(0,g),...p.slice(g+1)]}function h(p){let[,...g]=p;process.env.VSCODE_DEV&&(g=b(g)||[]);const d=!C(process.env);return D(g,d)}e.parseMainProcessArgv=h;function w(p){const[,,...g]=p;return D(g,!0)}e.parseCLIProcessArgv=w;function E(p,...g){const d=p.indexOf("--");return d===-1?p.push(...g):p.splice(d,0,...g),p}e.addArg=E;function C(p){return p.VSCODE_CLI==="1"}e.isLaunchedFromCli=C}),function(){"use strict";function z(e,S,t,M){function R(b){const h=D(b),w=[h];return e.isAbsolute(h)||w.unshift(M),e.resolve(...w)}function D(b){const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,t);const E=b["user-data-dir"];if(E)return E;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const C=process.env.USERPROFILE;if(typeof C!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(C,"AppData","Roaming")}break;case"darwin":w=e.join(S.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,t)}return{getUserDataPath:R}}if(typeof define=="function")define(X[174],J([0,259,29,13,16,36]),function(e,S,t,M,R,D){const b=R.dirname(M.FileAccess.asFileUri("",e)),h=e.__$__nodeRequire(R.joinPath(b,"package.json").fsPath);return z(S,t,h.name,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),S=require("path"),t=require("os");module.exports=z(S,t,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(X[175],J([0,1,29,172,174]),function(z,e,S,t,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class R extends t.AbstractNativeEnvironmentService{constructor(b,h){super(b,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,M.getUserDataPath)(b)},h)}}e.NativeEnvironmentService=R}),define(X[176],J([0,1,28,29,31]),function(z,e,S,t,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function R(D){const b=(0,M.randomPath)((0,t.tmpdir)());try{return(0,S.writeFileSync)(b,""),D&&console.log(`Marker file for --wait created: ${b}`),b}catch(h){D&&console.error(`Failed to create marker file for --wait: ${h}`);return}}e.createWaitMarkerFile=R}),define(X[177],J([0,1,17,27]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function M(R,D,b){let h=b&&b.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const E=(await D.readFile(R.serviceMachineIdResource)).value.toString();h=(0,t.isUUID)(E)?E:null}catch{h=null}if(!h){h=(0,t.generateUuid)();try{await D.writeFile(R.serviceMachineIdResource,S.VSBuffer.fromString(h))}catch{}}return b?.store("storage.serviceMachineId",h,-1,1),h}e.getServiceMachineId=M}),define(X[67],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class S{constructor(M,R=[],D=!1){this.ctor=M,this.staticArguments=R,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=S}),define(X[178],J([0,1,67]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function M(D,b,h){b instanceof S.SyncDescriptor||(b=new S.SyncDescriptor(b,[],h)),t.push([D,b])}e.registerSingleton=M;function R(){return t}e.getSingletonServiceDescriptors=R}),define(X[179],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class S{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}e.Node=S;class t{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(const D of this._nodes.values())D.outgoing.size===0&&R.push(D);return R}insertEdge(R,D){const b=this.lookupOrInsertNode(R),h=this.lookupOrInsertNode(D);b.outgoing.set(this._hashFn(D),h),h.incoming.set(this._hashFn(R),b)}removeNode(R){const D=this._hashFn(R);this._nodes.delete(D);for(const b of this._nodes.values())b.outgoing.delete(D),b.incoming.delete(D)}lookupOrInsertNode(R){const D=this._hashFn(R);let b=this._nodes.get(D);return b||(b=new S(R),this._nodes.set(D,b)),b}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){const R=[];for(const[D,b]of this._nodes)R.push(`${D}, (incoming)[${[...b.incoming.keys()].join(", ")}], (outgoing)[${[...b.outgoing.keys()].join(",")}]`);return R.join(`
`)}findCycleSlow(){for(const[R,D]of this._nodes){const b=new Set([R]),h=this._findCycle(D,b);if(h)return h}}_findCycle(R,D){for(const[b,h]of R.outgoing){if(D.has(b))return[...D,b].join(" -> ");D.add(b);const w=this._findCycle(h,D);if(w)return w;D.delete(b)}}}e.Graph=t}),define(X[5],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var S;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function b(h){return h[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=b})(S=e._util||(e._util={})),e.IInstantiationService=M("instantiationService");function t(D,b,h){b[S.DI_TARGET]===b?b[S.DI_DEPENDENCIES].push({id:D,index:h}):(b[S.DI_DEPENDENCIES]=[{id:D,index:h}],b[S.DI_TARGET]=b)}function M(D){if(S.serviceIds.has(D))return S.serviceIds.get(D);const b=function(h,w,E){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(b,h,E)};return b.toString=()=>D,S.serviceIds.set(D,b),b}e.createDecorator=M;function R(D){return D}e.refineServiceDecorator=R}),define(X[58],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,S.createDecorator)("backupMainService")}),define(X[18],J([0,1,11,7,5]),function(z,e,S,t,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,M.createDecorator)("configurationService");function R(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationOverrides=R;function D(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||Array.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=D;var b;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.USER=2]="USER",m[m.USER_LOCAL=3]="USER_LOCAL",m[m.USER_REMOTE=4]="USER_REMOTE",m[m.WORKSPACE=5]="WORKSPACE",m[m.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",m[m.DEFAULT=7]="DEFAULT",m[m.MEMORY=8]="MEMORY"})(b=e.ConfigurationTarget||(e.ConfigurationTarget={}));function h(m){switch(m){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=h;function w(m,v){const f=Object.create(null);for(const u in m)E(f,u,m[u],v);return f}e.toValuesTree=w;function E(m,v,f,u){const c=v.split("."),o=c.pop();let r=m;for(let i=0;i<c.length;i++){const n=c[i];let s=r[n];switch(typeof s){case"undefined":s=r[n]=Object.create(null);break;case"object":break;default:u(`Ignoring ${v} as ${c.slice(0,i+1).join(".")} is ${JSON.stringify(s)}`);return}r=s}if(typeof r=="object"&&r!==null)try{r[o]=f}catch{u(`Ignoring ${v} as ${c.join(".")} is ${JSON.stringify(r)}`)}else u(`Ignoring ${v} as ${c.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=E;function C(m,v){const f=v.split(".");p(m,f)}e.removeFromValueTree=C;function p(m,v){const f=v.shift();if(v.length===0){delete m[f];return}if(Object.keys(m).indexOf(f)!==-1){const u=m[f];typeof u=="object"&&!Array.isArray(u)&&(p(u,v),Object.keys(u).length===0&&delete m[f])}}function g(m,v,f){function u(r,i){let n=r;for(const s of i){if(typeof n!="object"||n===null)return;n=n[s]}return n}const c=v.split("."),o=u(m,c);return typeof o=="undefined"?f:o}e.getConfigurationValue=g;function d(m,v,f){Object.keys(v).forEach(u=>{u!=="__proto__"&&(u in m?S.isObject(m[u])&&S.isObject(v[u])?d(m[u],v[u],f):f&&(m[u]=v[u]):m[u]=v[u])})}e.merge=d;function P(m,v,f){const u=m.inspect(v),c=m.inspect(f);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:u.defaultValue}e.getMigratedSettingValue=P;function y(m){return m.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=y}),define(X[68],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,S.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,S.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(R,D){return this.secretVault[R]?.[D]??null}async setPassword(R,D,b){this.secretVault[R]=this.secretVault[R]??{},this.secretVault[R][D]=b}async deletePassword(R,D){return this.secretVault[R]?.[D]?(delete this.secretVault[R][D],Object.keys(this.secretVault[R]).length===0&&delete this.secretVault[R],!0):!1}async findPassword(R){return JSON.stringify(this.secretVault[R])??null}async findCredentials(R){const D=[];for(const b of Object.keys(this.secretVault[R]||{}))D.push({account:b,password:this.secretVault[R][b]});return D}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(X[83],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,S.createDecorator)(e.ID);function t(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=t;class M{async getPerformanceInfo(D,b){return{}}async getSystemInfo(D,b){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,b){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.NullDiagnosticsService=M}),define(X[99],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,S.createDecorator)("encryptionMainService")}),define(X[39],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,S.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,S.refineServiceDecorator)(e.IEnvironmentService)}),define(X[26],J([0,1,50,9,82,39,175,5]),function(z,e,S,t,M,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,b.refineServiceDecorator)(R.IEnvironmentService);class h extends D.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,t.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,M.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ge([S.memoize],h.prototype,"cachedLanguagesPath",null),ge([S.memoize],h.prototype,"backupHome",null),ge([S.memoize],h.prototype,"backupWorkspacesPath",null),ge([S.memoize],h.prototype,"mainIPCHandle",null),ge([S.memoize],h.prototype,"mainLockfile",null),ge([S.memoize],h.prototype,"disableUpdates",null),ge([S.memoize],h.prototype,"disableKeytar",null),ge([S.memoize],h.prototype,"codeCachePath",null),ge([S.memoize],h.prototype,"useCodeCache",null),e.EnvironmentMainService=h}),define(X[100],J([0,1,148,5]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDefaultExtensionsProfileInitService=e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IServerExtensionManagementService=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function M(m){switch(m){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=M;function R(m){switch(m){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function D(m,v){switch(m){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function b(m,v){return v==="web"&&!m.includes("web")}e.isNotWebExtensionInWebTargetPlatform=b;function h(m,v,f){return b(v,f)?!1:m==="undefined"||m==="universal"?!0:m==="unknown"?!1:m===f?!0:w(f).includes(m)}e.isTargetPlatformCompatible=h;function w(m){switch(m){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=w;function E(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=E;var C;(function(m){m[m.NoneOrRelevance=0]="NoneOrRelevance",m[m.LastUpdatedDate=1]="LastUpdatedDate",m[m.Title=2]="Title",m[m.PublisherName=3]="PublisherName",m[m.InstallCount=4]="InstallCount",m[m.PublishedDate=10]="PublishedDate",m[m.AverageRating=6]="AverageRating",m[m.WeightedRating=12]="WeightedRating"})(C=e.SortBy||(e.SortBy={}));var p;(function(m){m[m.Default=0]="Default",m[m.Ascending=1]="Ascending",m[m.Descending=2]="Descending"})(p=e.SortOrder||(e.SortOrder={}));var g;(function(m){m.Install="install",m.Uninstall="uninstall"})(g=e.StatisticType||(e.StatisticType={}));var d;(function(m){m[m.None=1]="None",m[m.Install=2]="Install",m[m.Update=3]="Update",m[m.Migrate=4]="Migrate"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var P;(function(m){m.Unsupported="Unsupported",m.Deprecated="Deprecated",m.Malicious="Malicious",m.Incompatible="Incompatible",m.IncompatiblePreRelease="IncompatiblePreRelease",m.IncompatibleTargetPlatform="IncompatibleTargetPlatform",m.ReleaseVersionNotFound="ReleaseVersionNotFound",m.Invalid="Invalid",m.Download="Download",m.Extract="Extract",m.Delete="Delete",m.Rename="Rename",m.CorruptZip="CorruptZip",m.IncompleteZip="IncompleteZip",m.Internal="Internal"})(P=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class y extends Error{constructor(v,f){super(v);this.code=f,this.name=f}}e.ExtensionManagementError=y,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.IServerExtensionManagementService=(0,t.refineServiceDecorator)(e.IExtensionManagementService),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,S.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,S.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,t.createDecorator)("IExtensionManagementCLIService"),e.IDefaultExtensionsProfileInitService=(0,t.createDecorator)("IDefaultExtensionsProfileInitService")}),define(X[180],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,S.createDecorator)("extensionUrlTrustService")}),define(X[181],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,S.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(X[101],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,S.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,S.createDecorator)("externalTerminal")}),define(X[182],J([0,1,49,13,9,4,77,23,81,149,101]),function(z,e,S,t,M,R,D,b,h,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const C=w.localize(0,null);class p{async getDefaultTerminalForPlatforms(){return{windows:g.getDefaultTerminalWindows(),linux:await P.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class g extends p{openTerminal(u,c){return this.spawnTerminal(S,u,h.getWindowsShell(),c)}spawnTerminal(u,c,o,r){const i=c.windowsExec||g.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const n=M.basename(i).toLowerCase();if(n==="cmder"||n==="cmder.exe")return u.spawn(i,r?[r]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return i.indexOf(" ")>=0&&s.push('""'),s.push(i),(n==="wt"||n==="wt.exe")&&s.push("-d ."),new Promise((a,l)=>{const I=y(process),k=u.spawn(o,s,{cwd:r,env:I});k.on("error",l),k.on("exit",()=>a())})}runInTerminal(u,c,o,r,i){const n="windowsExec"in i&&i.windowsExec?i.windowsExec:g.getDefaultTerminalWindows();return new Promise((s,a)=>{const l=`"${c} - ${C}"`,I=`""${o.join('" "')}" & pause"`,k=["/c","start",l,"/wait",n,"/c",I],A=Object.assign({},y(process),r);Object.keys(A).filter(K=>A[K]===null).forEach(K=>delete A[K]);const W={cwd:c,env:A,windowsVerbatimArguments:!0};S.spawn(g.CMD,k,W).on("error",K=>{a(m(K))}),s(void 0)})}static getDefaultTerminalWindows(){if(!g._DEFAULT_TERMINAL_WINDOWS){const u=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");g._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${u?"Sysnative":"System32"}\\cmd.exe`}return g._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=g,g.CMD="cmd.exe";class d extends p{openTerminal(u,c){return this.spawnTerminal(S,u,c)}runInTerminal(u,c,o,r,i){const n=i.osxExec||E.DEFAULT_TERMINAL_OSX;return new Promise((s,a)=>{if(n===E.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const l=n===E.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",k=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${l}.scpt`,z).fsPath,"-t",u||C,"-w",c];for(const F of o)k.push("-a"),k.push(F);if(r){const F=Object.assign({},y(process),r);for(const K in F){const ie=F[K];ie===null?(k.push("-u"),k.push(K)):(k.push("-e"),k.push(`${K}=${ie}`))}}let A="";const W=S.spawn(d.OSASCRIPT,k);W.on("error",F=>{a(m(F))}),W.stderr.on("data",F=>{A+=F.toString()}),W.on("exit",F=>{if(F===0)s(void 0);else if(A){const K=A.split(`
`,1);a(new Error(K[0]))}else a(new Error(w.localize(1,null,l,F)))})}else a(new Error(w.localize(2,null,n)))})}spawnTerminal(u,c,o){const r=c.osxExec||E.DEFAULT_TERMINAL_OSX;return new Promise((i,n)=>{const s=["-a",r];o&&s.push(o);const a=y(process),l=u.spawn("/usr/bin/open",s,{cwd:o,env:a});l.on("error",n),l.on("exit",()=>i())})}}e.MacExternalTerminalService=d,d.OSASCRIPT="/usr/bin/osascript";class P extends p{openTerminal(u,c){return this.spawnTerminal(S,u,c)}runInTerminal(u,c,o,r,i){const n=i.linuxExec?Promise.resolve(i.linuxExec):P.getDefaultTerminalLinuxReady();return new Promise((s,a)=>{const l=[];n.then(I=>{I.indexOf("gnome-terminal")>=0?l.push("-x"):l.push("-e"),l.push("bash"),l.push("-c");const k=`${v(o)}; echo; read -p "${P.WAIT_MESSAGE}" -n1;`;l.push(`''${k}''`);const A=Object.assign({},y(process),r);Object.keys(A).filter(ie=>A[ie]===null).forEach(ie=>delete A[ie]);const W={cwd:c,env:A};let F="";const K=S.spawn(I,l,W);K.on("error",ie=>{a(m(ie))}),K.stderr.on("data",ie=>{F+=ie.toString()}),K.on("exit",ie=>{if(ie===0)s(void 0);else if(F){const oe=F.split(`
`,1);a(new Error(oe[0]))}else a(new Error(w.localize(4,null,I,ie)))})})})}static async getDefaultTerminalLinuxReady(){if(!P._DEFAULT_TERMINAL_LINUX_READY)if(!R.isLinux)P._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const u=await b.Promises.exists("/etc/debian_version");P._DEFAULT_TERMINAL_LINUX_READY=new Promise(c=>{u?c("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?c("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?c("konsole"):process.env.COLORTERM?c(process.env.COLORTERM):process.env.TERM?c(process.env.TERM):c("xterm")})}return P._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(u,c,o){const r=c.linuxExec?Promise.resolve(c.linuxExec):P.getDefaultTerminalLinuxReady();return new Promise((i,n)=>{r.then(s=>{const a=y(process),l=u.spawn(s,[],{cwd:o,env:a});l.on("error",n),l.on("exit",()=>i())})})}}e.LinuxExternalTerminalService=P,P.WAIT_MESSAGE=w.localize(3,null);function y(f){const u={...f.env};return(0,D.sanitizeProcessEnvironment)(u),u}function m(f){return"errno"in f&&f.errno==="ENOENT"&&"path"in f&&typeof f.path=="string"?new Error(w.localize(5,null,f.path)):f}function v(f){let u="";for(const c of f)c.indexOf(" ")>=0?u+='"'+c+'"':u+=c,u+=" ";return u}}),define(X[15],J([0,1,33,9,30,11,7,151,5]),function(z,e,S,t,M,R,D,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,h.createDecorator)("fileService");function w(G){return G.create===!0}e.isFileOpenForWriteOptions=w;var E;(function(G){G[G.Unknown=0]="Unknown",G[G.File=1]="File",G[G.Directory=2]="Directory",G[G.SymbolicLink=64]="SymbolicLink"})(E=e.FileType||(e.FileType={}));var C;(function(G){G[G.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var p;(function(G){G[G.FileReadWrite=2]="FileReadWrite",G[G.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",G[G.FileReadStream=16]="FileReadStream",G[G.FileFolderCopy=8]="FileFolderCopy",G[G.PathCaseSensitive=1024]="PathCaseSensitive",G[G.Readonly=2048]="Readonly",G[G.Trash=4096]="Trash",G[G.FileWriteUnlock=8192]="FileWriteUnlock",G[G.FileAtomicRead=16384]="FileAtomicRead",G[G.FileClone=32768]="FileClone"})(p=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g(G){return!!(G.capabilities&2)}e.hasReadWriteCapability=g;function d(G){return!!(G.capabilities&8)}e.hasFileFolderCopyCapability=d;function P(G){return!!(G.capabilities&32768)}e.hasFileCloneCapability=P;function y(G){return!!(G.capabilities&4)}e.hasOpenReadWriteCloseCapability=y;function m(G){return!!(G.capabilities&16)}e.hasFileReadStreamCapability=m;function v(G){return!!(G.capabilities&2048)}e.hasFileReadCapability=v;function f(G){return g(G)?!!(G.capabilities&16384):!1}e.hasFileAtomicReadCapability=f;var u;(function(G){G.FileExists="EntryExists",G.FileNotFound="EntryNotFound",G.FileNotADirectory="EntryNotADirectory",G.FileIsADirectory="EntryIsADirectory",G.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",G.FileTooLarge="EntryTooLarge",G.FileWriteLocked="EntryWriteLocked",G.NoPermissions="NoPermissions",G.Unavailable="Unavailable",G.Unknown="Unknown"})(u=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor(B,N){super(B);this.code=N}}e.FileSystemProviderError=c;function o(G,B){const N=new c(G.toString(),B);return i(N,B),N}e.createFileSystemProviderError=o;function r(G){return G||o((0,b.localize)(0,null),u.Unknown)}e.ensureFileSystemProviderError=r;function i(G,B){return G.name=B?`${B} (FileSystemError)`:"FileSystemError",G}e.markAsFileSystemProviderError=i;function n(G){if(!G)return u.Unknown;if(G instanceof c)return G.code;const B=/^(.+) \(FileSystemError\)$/.exec(G.name);if(!B)return u.Unknown;switch(B[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileExceedsMemoryLimit:return u.FileExceedsMemoryLimit;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}e.toFileSystemProviderErrorCode=n;function s(G){if(G instanceof W)return G.fileOperationResult;switch(n(G)){case u.FileNotFound:return 1;case u.FileIsADirectory:return 0;case u.FileNotADirectory:return 10;case u.FileWriteLocked:return 5;case u.NoPermissions:return 6;case u.FileExists:return 4;case u.FileExceedsMemoryLimit:return 9;case u.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var a;(function(G){G[G.CREATE=0]="CREATE",G[G.DELETE=1]="DELETE",G[G.MOVE=2]="MOVE",G[G.COPY=3]="COPY",G[G.WRITE=4]="WRITE"})(a=e.FileOperation||(e.FileOperation={}));class l{constructor(B,N,O){this.resource=B,this.operation=N,this.target=O}isOperation(B){return this.operation===B}}e.FileOperationEvent=l;var I;(function(G){G[G.UPDATED=0]="UPDATED",G[G.ADDED=1]="ADDED",G[G.DELETED=2]="DELETED"})(I=e.FileChangeType||(e.FileChangeType={}));class k{constructor(B,N){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=B;const O=new Map;for(const H of B){const Z=O.get(H.type);switch(Z?Z.push([H.resource,H]):O.set(H.type,[[H.resource,H]]),H.type){case 1:this.rawAdded.push(H.resource);break;case 0:this.rawUpdated.push(H.resource);break;case 2:this.rawDeleted.push(H.resource);break}}for(const[H,Z]of O)switch(H){case 1:this.added=S.TernarySearchTree.forUris(()=>N),this.added.fill(Z);break;case 0:this.updated=S.TernarySearchTree.forUris(()=>N),this.updated.fill(Z);break;case 2:this.deleted=S.TernarySearchTree.forUris(()=>N),this.deleted.fill(Z);break}}contains(B,...N){return this.doContains(B,{includeChildren:!1},...N)}affects(B,...N){return this.doContains(B,{includeChildren:!0},...N)}doContains(B,N,...O){if(!B)return!1;const H=O.length>0;return!!((!H||O.includes(1))&&(this.added?.get(B)||N.includeChildren&&this.added?.findSuperstr(B))||(!H||O.includes(0))&&(this.updated?.get(B)||N.includeChildren&&this.updated?.findSuperstr(B))||(!H||O.includes(2))&&(this.deleted?.findSubstr(B)||N.includeChildren&&this.deleted?.findSuperstr(B)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=k;function A(G,B,N){return!G||!B||G===B||B.length>G.length?!1:(B.charAt(B.length-1)!==t.sep&&(B+=t.sep),N?(0,M.startsWithIgnoreCase)(G,B):G.indexOf(B)===0)}e.isParent=A;class W extends Error{constructor(B,N,O){super(B);this.fileOperationResult=N,this.options=O}}e.FileOperationError=W;class F extends W{constructor(B,N,O){super(B,2,O);this.stat=N}}e.NotModifiedSinceFileOperationError=F;var K;(function(G){G[G.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",G[G.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",G[G.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",G[G.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",G[G.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",G[G.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",G[G.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",G[G.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",G[G.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",G[G.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",G[G.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",G[G.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(K=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var ie;(function(G){G[G.FILE=0]="FILE",G[G.FOLDER=1]="FOLDER",G[G.ROOT_FOLDER=2]="ROOT_FOLDER"})(ie=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function oe(G){if(!(typeof G.size!="number"||typeof G.mtime!="number"))return G.mtime.toString(29)+G.size.toString(31)}e.etag=oe;async function ue(G,B){if(!B.hasProvider(D.URI.from({scheme:G.scheme})))return new Promise(N=>{const O=B.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===G.scheme&&H.added&&(O.dispose(),N())})})}e.whenProviderRegistered=ue,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ne{static formatSize(B){return(0,R.isNumber)(B)||(B=0),B<ne.KB?(0,b.localize)(1,null,B.toFixed(0)):B<ne.MB?(0,b.localize)(2,null,(B/ne.KB).toFixed(2)):B<ne.GB?(0,b.localize)(3,null,(B/ne.MB).toFixed(2)):B<ne.TB?(0,b.localize)(4,null,(B/ne.GB).toFixed(2)):(0,b.localize)(5,null,(B/ne.TB).toFixed(2))}}e.ByteSize=ne,ne.KB=1024,ne.MB=ne.KB*ne.KB,ne.GB=ne.MB*ne.KB,ne.TB=ne.GB*ne.KB;var ae;(function(G){G[G.IA32=0]="IA32",G[G.OTHER=1]="OTHER"})(ae=e.Arch||(e.Arch={}));function le(G){return{maxFileSize:G===0?300*ne.MB:16*ne.GB,maxHeapSize:G===0?700*ne.MB:2*700*ne.MB}}e.getPlatformLimits=le}),define(X[183],J([0,1,17,42,19,3,2,56,7,27,15]),function(z,e,S,t,M,R,D,b,h,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class C extends D.Disposable{constructor(g,d){super();this.channel=g,this.extraCapabilities=d,this.onDidChangeCapabilities=R.Event.None,this._onDidChange=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,w.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(g){return this.channel.call("stat",[g])}readdir(g){return this.channel.call("readdir",[g])}async readFile(g,d){const{buffer:P}=await this.channel.call("readFile",[g,d]);return P}readFileStream(g,d,P){const y=(0,b.newWriteableStream)(v=>S.VSBuffer.concat(v.map(f=>S.VSBuffer.wrap(f))).buffer),m=this.channel.listen("readFileStream",[g,d])(v=>{if(v instanceof S.VSBuffer)y.write(v.buffer);else{if(v==="end")y.end();else{let f=v;f instanceof Error||(f=(0,E.createFileSystemProviderError)((0,t.toErrorMessage)(f),E.FileSystemProviderErrorCode.Unknown)),y.error(f),y.end()}m.dispose()}});return P.onCancellationRequested(()=>{y.error((0,M.canceled)()),y.end(),m.dispose()}),y}writeFile(g,d,P){return this.channel.call("writeFile",[g,S.VSBuffer.wrap(d),P])}open(g,d){return this.channel.call("open",[g,d])}close(g){return this.channel.call("close",[g])}async read(g,d,P,y,m){const[v,f]=await this.channel.call("read",[g,d,m]);return P.set(v.buffer.slice(0,f),y),f}write(g,d,P,y,m){return this.channel.call("write",[g,d,S.VSBuffer.wrap(P),y,m])}mkdir(g){return this.channel.call("mkdir",[g])}delete(g,d){return this.channel.call("delete",[g,d])}rename(g,d,P){return this.channel.call("rename",[g,d,P])}copy(g,d,P){return this.channel.call("copy",[g,d,P])}cloneFile(g,d){return this.channel.call("cloneFile",[g,d])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(g=>{if(Array.isArray(g)){const d=g;this._onDidChange.fire(d.map(P=>({resource:h.URI.revive(P.resource),type:P.type})))}else{const d=g;this._onDidWatchError.fire(d)}}))}watch(g,d){const P=(0,w.generateUuid)();return this.channel.call("watch",[this.sessionId,P,g,d]),(0,D.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,P]))}}e.DiskFileSystemProviderClient=C}),define(X[102],J([0,1,17,19,152,15]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(E,C,p,g,d,P){let y;try{await b(E,C,p,g,d,P)}catch(m){y=m}finally{y&&d.errorTransformer&&(y=d.errorTransformer(y)),typeof y!="undefined"&&p.error(y),p.end()}}e.readFileIntoStream=D;async function b(E,C,p,g,d,P){h(P);const y=await E.open(C,{create:!1});try{h(P);let m=0,v=0,f=d&&typeof d.length=="number"?d.length:void 0,u=S.VSBuffer.alloc(Math.min(d.bufferSize,typeof f=="number"?f:d.bufferSize)),c=d&&typeof d.position=="number"?d.position:0,o=0;do v=await E.read(y,c,u.buffer,o,u.byteLength-o),c+=v,o+=v,m+=v,typeof f=="number"&&(f-=v),o===u.byteLength&&(await p.write(g(u)),u=S.VSBuffer.alloc(Math.min(d.bufferSize,typeof f=="number"?f:d.bufferSize)),o=0);while(v>0&&(typeof f!="number"||f>0)&&h(P)&&w(m,d));if(o>0){let r=o;typeof f=="number"&&(r=Math.min(o,f)),p.write(g(u.slice(0,r)))}}catch(m){throw(0,R.ensureFileSystemProviderError)(m)}finally{await E.close(y)}}function h(E){if(E.isCancellationRequested)throw(0,t.canceled)();return!0}function w(E,C){if(C?.limits){if(typeof C.limits.memory=="number"&&E>C.limits.memory)throw(0,R.createFileSystemProviderError)((0,M.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof C.limits.size=="number"&&E>C.limits.size)throw(0,R.createFileSystemProviderError)((0,M.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(X[69],J([0,1,92,2,9,4,7,15]),function(z,e,S,t,M,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function h(m){return m.recursive===!0}e.isRecursiveWatchRequest=h;class w extends t.Disposable{constructor(v,f,u,c){super();this.onFileChanges=v,this.onLogMessage=f,this.verboseLogging=u,this.options=c,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const v=new t.DisposableStore;this.watcherDisposables.value=v,this.watcher=this.createWatcher(v),this.watcher.setVerboseLogging(this.verboseLogging),v.add(this.watcher.onDidChangeFile(f=>this.onFileChanges(f))),v.add(this.watcher.onDidLogMessage(f=>this.onLogMessage(f))),v.add(this.watcher.onDidError(f=>this.onError(f)))}onError(v){this.options.restartOnError?this.restartCounter<w.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${v}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${v}`):this.error(v)}restart(v){this.restartCounter++,this.init(),this.watch(v)}async watch(v){this.requests=v,await this.watcher?.watch(v)}async setVerboseLogging(v){this.verboseLogging=v,await this.watcher?.setVerboseLogging(v)}error(v){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${v}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=w,w.MAX_RESTARTS=5;class E extends w{constructor(v,f,u){super(v,f,u,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=E;class C extends w{constructor(v,f,u){super(v,f,u,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=C;function p(m){return m.map(v=>({type:v.type,resource:D.URI.file(v.path)}))}e.toFileChanges=p;function g(m){const v=new y;for(const f of m)v.processEvent(f);return v.coalesce()}e.coalesceEvents=g;function d(m,v){return typeof v=="string"&&!v.startsWith(S.GLOBSTAR)&&!(0,M.isAbsolute)(v)?{base:m,pattern:v}:v}e.normalizeWatcherPattern=d;function P(m,v){const f=[];for(const u of v)f.push((0,S.parse)(d(m,u)));return f}e.parseWatcherPatterns=P;class y{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(v){return R.isLinux?v.path:v.path.toLowerCase()}processEvent(v){const f=this.mapPathToChange.get(this.toKey(v));let u=!1;if(f){const c=f.type,o=v.type;f.path!==v.path&&(v.type===2||v.type===1)?u=!0:c===1&&o===2?(this.mapPathToChange.delete(this.toKey(v)),this.coalesced.delete(f)):c===2&&o===1?f.type=0:c===1&&o===0||(f.type=o)}else u=!0;u&&(this.coalesced.add(v),this.mapPathToChange.set(this.toKey(v),v))}coalesce(){const v=[],f=[];return Array.from(this.coalesced).filter(u=>u.type!==2?(v.push(u),!1):!0).sort((u,c)=>u.path.length-c.path.length).filter(u=>f.some(c=>(0,b.isParent)(u.path,c,!R.isLinux))?!1:(f.push(u.path),!0)).concat(v)}}}),define(X[184],J([0,1,28,8,21,31,2,79,9,4,93,23,69]),function(z,e,S,t,M,R,D,b,h,w,E,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class g extends D.Disposable{constructor(y,m,v,f){super();this.request=y,this.onDidFilesChange=m,this.onLogMessage=v,this.verboseLogging=f,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},u=>this.onDidFilesChange(u)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(g.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,p.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,p.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new M.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const y=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const m=await C.Promises.stat(y);this._register(await this.doWatch(y,m.isDirectory()))}catch(y){y.code!=="ENOENT"?this.error(y):this.trace(y)}}async normalizePath(y){let m=y.path;try{m=await C.Promises.realpath(y.path),y.path===m&&(m=await(0,E.realcase)(y.path)??y.path),y.path!==m&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${y.path}, real: ${m})`)}catch{}return m}async doWatch(y,m){if(w.isMacintosh&&(0,R.isEqualOrParent)(y,"/Volumes/",!0))return this.error(`Refusing to watch ${y} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.Disposable.None;const v=new M.CancellationTokenSource(this.cts.token),f=new D.DisposableStore;try{const u=(0,h.basename)(y),c=(0,S.watch)(y);f.add((0,D.toDisposable)(()=>{c.removeAllListeners(),c.close()})),this.trace(`Started watching: '${y}'`);const o=new Set;if(m)try{for(const i of await C.Promises.readdir(y))o.add(i)}catch(i){this.error(i)}const r=new Map;f.add((0,D.toDisposable)(()=>{for(const[,i]of r)i.dispose();r.clear()})),c.on("error",(i,n)=>{this.error(`Failed to watch ${y} for changes using fs.watch() (${i}, ${n})`),this.dispose()}),c.on("change",(i,n)=>{if(v.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${n}`);let s="";if(n&&(s=n.toString(),w.isMacintosh&&(s=(0,b.normalizeNFC)(s))),!(!s||i!=="change"&&i!=="rename"))if(m)if(i==="rename"){r.get(s)?.dispose();const a=setTimeout(async()=>{if(r.delete(s),s===u&&!await C.Promises.exists(y)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const l=await this.existsChildStrictCase((0,h.join)(y,s));if(v.token.isCancellationRequested)return;let I;l?o.has(s)?I=0:(I=1,o.add(s)):(o.delete(s),I=2),this.onFileChange({path:(0,h.join)(this.request.path,s),type:I})},g.FILE_DELETE_HANDLER_DELAY);r.set(s,(0,D.toDisposable)(()=>clearTimeout(a)))}else{let a;o.has(s)?a=0:(a=1,o.add(s)),this.onFileChange({path:(0,h.join)(this.request.path,s),type:a})}else if(i==="rename"||s!==u){const a=setTimeout(async()=>{const l=await C.Promises.exists(y);v.token.isCancellationRequested||(l?(this.onFileChange({path:this.request.path,type:0},!0),f.add(await this.doWatch(y,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},g.FILE_DELETE_HANDLER_DELAY);f.clear(),f.add((0,D.toDisposable)(()=>clearTimeout(a)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(u){await C.Promises.exists(y)&&!v.token.isCancellationRequested&&this.error(`Failed to watch ${y} for changes using fs.watch() (${u.toString()})`)}return(0,D.toDisposable)(()=>{v.dispose(!0),f.dispose()})}async onFileChange(y,m=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${y.type===1?"[ADDED]":y.type===2?"[DELETED]":"[CHANGED]"} ${y.path}`),!m&&this.excludes.some(v=>v(y.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${y.path}`):!m&&this.includes&&this.includes.length>0&&!this.includes.some(v=>v(y.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${y.path}`):this.fileChangesBuffer.push(y);try{await this.fileChangesDelayer.trigger(async()=>{const v=this.fileChangesBuffer;this.fileChangesBuffer=[];const f=(0,p.coalesceEvents)(v);if(f.length>0){if(this.verboseLogging)for(const c of f)this.trace(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);this.throttledFileChangesWorker.work(f)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${f.length}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(y){if(w.isLinux)return C.Promises.exists(y);try{const m=(0,h.basename)(y);return(await C.Promises.readdir((0,h.dirname)(y))).some(f=>f===m)}catch(m){return this.trace(m),!1}}setVerboseLogging(y){this.verboseLogging=y}error(y){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${y}`})}warn(y){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${y}`})}trace(y){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${y}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=g,g.FILE_DELETE_HANDLER_DELAY=100,g.FILE_CHANGES_HANDLER_DELAY=50;async function d(P,y,m,v,f=512){const u=await C.Promises.open(P,"r"),c=Buffer.allocUnsafe(f),o=new M.CancellationTokenSource(v);let r,i=!1;const n={path:P,excludes:[],recursive:!1},s=new g(n,a=>{(async()=>{for(const{type:l}of a)if(l===0){if(i)return;i=!0;try{for(;!o.token.isCancellationRequested;){const{bytesRead:I}=await C.Promises.read(u,c,0,f,null);if(!I||o.token.isCancellationRequested)break;y(c.slice(0,I))}}catch(I){r=new Error(I),o.dispose(!0)}finally{i=!1}}})()});return await s.ready,m(),new Promise((a,l)=>{o.token.onCancellationRequested(async()=>{s.dispose();try{await C.Promises.close(u)}catch(I){r=new Error(I)}r?l(r):a()})})}e.watchFileContents=d}),define(X[185],J([0,1,3,92,2,4,184]),function(z,e,S,t,M,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class b extends M.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new S.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new S.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=S.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(w){const E=this.normalizeRequests(w),C=E.filter(g=>{const d=this.watchers.get(g.path);return d?!(0,t.patternsEquals)(d.request.excludes,g.excludes)||!(0,t.patternsEquals)(d.request.includes,g.includes):!0}),p=Array.from(this.watchers.values()).filter(({request:g})=>!E.find(d=>d.path===g.path&&(0,t.patternsEquals)(d.excludes,g.excludes)&&(0,t.patternsEquals)(d.includes,g.includes))).map(({request:g})=>g.path);C.length&&this.trace(`Request to start watching: ${C.map(g=>`${g.path} (excludes: ${g.excludes.length>0?g.excludes:"<none>"}, includes: ${g.includes&&g.includes.length>0?JSON.stringify(g.includes):"<all>"})`).join(",")}`),p.length&&this.trace(`Request to stop watching: ${p.join(",")}`);for(const g of p)this.stopWatching(g);for(const g of C)this.startWatching(g)}startWatching(w){const E=new D.NodeJSFileWatcherLibrary(w,p=>this._onDidChangeFile.fire(p),p=>this._onDidLogMessage.fire(p),this.verboseLogging),C={request:w,instance:E};this.watchers.set(w.path,C)}async stop(){for(const[w]of this.watchers)this.stopWatching(w);this.watchers.clear()}stopWatching(w){const E=this.watchers.get(w);E&&(this.watchers.delete(w),E.instance.dispose())}normalizeRequests(w){const E=new Map;for(const C of w){const p=R.isLinux?C.path:C.path.toLowerCase();E.set(p,C)}return Array.from(E.values())}async setVerboseLogging(w){this.verboseLogging=w;for(const[,E]of this.watchers)E.instance.setVerboseLogging(w)}trace(w){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(w)})}toMessage(w,E){return E?`[File Watcher (node.js)] ${w} (path: ${E.request.path})`:`[File Watcher (node.js)] ${w}`}}e.NodeJSWatcher=b}),define(X[186],J([0,1,69,185]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class M extends S.AbstractNonRecursiveWatcherClient{constructor(D,b,h){super(D,b,h);this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=M}),define(X[187],J([0,1,13,43,141,69]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class D extends R.AbstractUniversalWatcherClient{constructor(h,w,E){super(h,w,E);this.init()}createWatcher(h){const w=h.add(new M.Client(S.FileAccess.asFileUri("bootstrap-fork",z).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(w.onDidProcessExit(({code:E,signal:C})=>this.onError(`terminated by itself with code ${E}, signal: ${C}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(w.getChannel("watcher")))}}e.UniversalWatcherClient=D}),define(X[84],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class S{constructor(...M){this._entries=new Map;for(const[R,D]of M)this.set(R,D)}set(M,R){const D=this._entries.get(M);return this._entries.set(M,R),D}has(M){return this._entries.has(M)}get(M){return this._entries.get(M)}}e.ServiceCollection=S}),define(X[188],J([0,1,8,19,67,179,5,84]),function(z,e,S,t,M,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const h=!1;class w extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class E{constructor(d=new b.ServiceCollection,P=!1,y){this._activeInstantiations=new Set,this._services=d,this._strict=P,this._parent=y,this._services.set(D.IInstantiationService,this)}createChild(d){return new E(d,this._strict,this)}invokeFunction(d,...P){const y=p.traceInvocation(d);let m=!1;try{return d({get:f=>{if(m)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const u=this._getOrCreateServiceInstance(f,y);if(!u)throw new Error(`[invokeFunction] unknown service '${f}'`);return u}},...P)}finally{m=!0,y.stop()}}createInstance(d,...P){let y,m;return d instanceof M.SyncDescriptor?(y=p.traceCreation(d.ctor),m=this._createInstance(d.ctor,d.staticArguments.concat(P),y)):(y=p.traceCreation(d),m=this._createInstance(d,P,y)),y.stop(),m}_createInstance(d,P=[],y){const m=D._util.getServiceDependencies(d).sort((u,c)=>u.index-c.index),v=[];for(const u of m){const c=this._getOrCreateServiceInstance(u.id,y);c||this._throwIfStrict(`[createInstance] ${d.name} depends on UNKNOWN service ${u.id}.`,!1),v.push(c)}const f=m.length>0?m[0].index:P.length;if(P.length!==f){console.trace(`[createInstance] First service dependency of ${d.name} at position ${f+1} conflicts with ${P.length} static arguments`);const u=f-P.length;u>0?P=P.concat(new Array(u)):P=P.slice(0,f)}return new d(...[...P,...v])}_setServiceInstance(d,P){if(this._services.get(d)instanceof M.SyncDescriptor)this._services.set(d,P);else if(this._parent)this._parent._setServiceInstance(d,P);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){const P=this._services.get(d);return!P&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):P}_getOrCreateServiceInstance(d,P){const y=this._getServiceInstanceOrDescriptor(d);return y instanceof M.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,y,P.branch(d,!0)):(P.branch(d,!1),y)}_safeCreateAndCacheServiceInstance(d,P,y){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,P,y)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,P,y){const m=new R.Graph(u=>u.id.toString());let v=0;const f=[{id:d,desc:P,_trace:y}];for(;f.length;){const u=f.pop();if(m.lookupOrInsertNode(u),v++>1e3)throw new w(m);for(const c of D._util.getServiceDependencies(u.desc.ctor)){const o=this._getServiceInstanceOrDescriptor(c.id);if(o||this._throwIfStrict(`[createInstance] ${d} depends on ${c.id} which is NOT registered.`,!0),o instanceof M.SyncDescriptor){const r={id:c.id,desc:o,_trace:u._trace.branch(c.id,!0)};m.insertEdge(u,r),f.push(r)}}}for(;;){const u=m.roots();if(u.length===0){if(!m.isEmpty())throw new w(m);break}for(const{data:c}of u){if(this._getServiceInstanceOrDescriptor(c.id)instanceof M.SyncDescriptor){const r=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,r)}m.removeNode(c)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,P,y=[],m,v){if(this._services.get(d)instanceof M.SyncDescriptor)return this._createServiceInstance(P,y,m,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,P,y,m,v);throw new Error(`illegalState - creating UNKNOWN service instance ${P.name}`)}_createServiceInstance(d,P=[],y,m){if(y){const v=new S.IdleValue(()=>this._createInstance(d,P,m));return new Proxy(Object.create(null),{get(f,u){if(u in f)return f[u];const c=v.value;let o=c[u];return typeof o!="function"||(o=o.bind(c),f[u]=o),o},set(f,u,c){return v.value[u]=c,!0}})}else return this._createInstance(d,P,m)}_throwIfStrict(d,P){if(P&&console.warn(d),this._strict)throw new Error(d)}}e.InstantiationService=E;var C;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(C||(C={}));class p{constructor(d,P){this.type=d,this.name=P,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return h?new p(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):p._None}static traceCreation(d){return h?new p(0,d.name):p._None}branch(d,P){const y=new p(2,d.toString());return this._dep.push([d,P,y]),y}stop(){const d=Date.now()-this._start;p._totals+=d;let P=!1;function y(v,f){const u=[],c=new Array(v+1).join("	");for(const[o,r,i]of f._dep)if(r&&i){P=!0,u.push(`${c}CREATES -> ${o}`);const n=y(v+1,i);n&&u.push(n)}else u.push(`${c}uses -> ${o}`);return u.join(`
`)}const m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${y(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${p._totals.toFixed(2)}ms)`];(d>2||P)&&console.log(m.join(`
`))}}e.Trace=p,p._None=new class extends p{constructor(){super(-1,null)}stop(){}branch(){return this}},p._totals=0}),define(X[6],J([0,1,42,3,2,4,5]),function(z,e,S,t,M,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,D.createDecorator)("logService"),e.ILoggerService=(0,D.createDecorator)("loggerService");function b(){return new Date().toISOString()}var h;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(h=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=h.Info;function w(r,i,n){switch(i){case h.Trace:r.trace(n);break;case h.Debug:r.debug(n);break;case h.Info:r.info(n);break;case h.Warning:r.warn(n);break;case h.Error:r.error(n);break;case h.Critical:r.critical(n);break;default:throw new Error("Invalid log level")}}e.log=w;function E(r){let i="";for(let n=0;n<r.length;n++){let s=r[n];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}i+=(n>0?" ":"")+s}return i}e.format=E;class C extends M.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class p extends C{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...n){this.checkLogLevel(h.Trace)&&this.log(h.Trace,E([i,...n]))}debug(i,...n){this.checkLogLevel(h.Debug)&&this.log(h.Debug,E([i,...n]))}info(i,...n){this.checkLogLevel(h.Info)&&this.log(h.Info,E([i,...n]))}warn(i,...n){this.checkLogLevel(h.Warning)&&this.log(h.Warning,E([i,...n]))}error(i,...n){if(this.checkLogLevel(h.Error))if(i instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=i.stack,this.log(h.Error,E(s))}else this.log(h.Error,E([i,...n]))}critical(i,...n){this.checkLogLevel(h.Critical)&&this.log(h.Critical,E([i,...n]))}flush(){}}e.AbstractMessageLogger=p;class g extends C{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!R.isWindows}trace(i,...n){this.getLevel()<=h.Trace&&(this.useColors?console.log(`[90m[main ${b()}][0m`,i,...n):console.log(`[main ${b()}]`,i,...n))}debug(i,...n){this.getLevel()<=h.Debug&&(this.useColors?console.log(`[90m[main ${b()}][0m`,i,...n):console.log(`[main ${b()}]`,i,...n))}info(i,...n){this.getLevel()<=h.Info&&(this.useColors?console.log(`[90m[main ${b()}][0m`,i,...n):console.log(`[main ${b()}]`,i,...n))}warn(i,...n){this.getLevel()<=h.Warning&&(this.useColors?console.warn(`[93m[main ${b()}][0m`,i,...n):console.warn(`[main ${b()}]`,i,...n))}error(i,...n){this.getLevel()<=h.Error&&(this.useColors?console.error(`[91m[main ${b()}][0m`,i,...n):console.error(`[main ${b()}]`,i,...n))}critical(i,...n){this.getLevel()<=h.Critical&&(this.useColors?console.error(`[90m[main ${b()}][0m`,i,...n):console.error(`[main ${b()}]`,i,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class d extends C{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...n){this.getLevel()<=h.Trace&&console.log("%cTRACE","color: #888",i,...n)}debug(i,...n){this.getLevel()<=h.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...n)}info(i,...n){this.getLevel()<=h.Info&&console.log("%c INFO","color: #33f",i,...n)}warn(i,...n){this.getLevel()<=h.Warning&&console.log("%c WARN","color: #993",i,...n)}error(i,...n){this.getLevel()<=h.Error&&console.log("%c  ERR","color: #f33",i,...n)}critical(i,...n){this.getLevel()<=h.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...n)}dispose(){}flush(){}}e.ConsoleLogger=d;class P extends C{constructor(i,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(n)}trace(i,...n){this.getLevel()<=h.Trace&&this.adapter.log(h.Trace,[this.extractMessage(i),...n])}debug(i,...n){this.getLevel()<=h.Debug&&this.adapter.log(h.Debug,[this.extractMessage(i),...n])}info(i,...n){this.getLevel()<=h.Info&&this.adapter.log(h.Info,[this.extractMessage(i),...n])}warn(i,...n){this.getLevel()<=h.Warning&&this.adapter.log(h.Warning,[this.extractMessage(i),...n])}error(i,...n){this.getLevel()<=h.Error&&this.adapter.log(h.Error,[this.extractMessage(i),...n])}critical(i,...n){this.getLevel()<=h.Critical&&this.adapter.log(h.Critical,[this.extractMessage(i),...n])}extractMessage(i){return typeof i=="string"?i:(0,S.toErrorMessage)(i,this.getLevel()<=h.Trace)}dispose(){}flush(){}}e.AdapterLogger=P;class y extends C{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const n of this.logServices)n.setLevel(i);super.setLevel(i)}trace(i,...n){for(const s of this.logServices)s.trace(i,...n)}debug(i,...n){for(const s of this.logServices)s.debug(i,...n)}info(i,...n){for(const s of this.logServices)s.info(i,...n)}warn(i,...n){for(const s of this.logServices)s.warn(i,...n)}error(i,...n){for(const s of this.logServices)s.error(i,...n)}critical(i,...n){for(const s of this.logServices)s.critical(i,...n)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=y;class m extends M.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...n){this.logger.trace(i,...n)}debug(i,...n){this.logger.debug(i,...n)}info(i,...n){this.logger.info(i,...n)}warn(i,...n){this.logger.warn(i,...n)}error(i,...n){this.logger.error(i,...n)}critical(i,...n){this.logger.critical(i,...n)}flush(){this.logger.flush()}}e.LogService=m;class v extends M.Disposable{constructor(i,n){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(s))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,n){let s=this.loggers.get(i.toString());return s||(s=this.doCreateLogger(i,n?.always?h.Trace:this.logLevel,n),this.loggers.set(i.toString(),s),n?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=v;class f{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(i){}getLevel(){return h.Info}trace(i,...n){}debug(i,...n){}info(i,...n){}warn(i,...n){}error(i,...n){}critical(i,...n){}dispose(){}flush(){}}e.NullLogService=f;function u(r){if(r.verbose)return h.Trace;if(typeof r.logLevel=="string"){const i=c(r.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=u;function c(r){switch(r){case"trace":return h.Trace;case"debug":return h.Debug;case"info":return h.Info;case"warn":return h.Warning;case"error":return h.Error;case"critical":return h.Critical;case"off":return h.Off}}e.parseLogLevel=c;function o(r){switch(r){case h.Trace:return"trace";case h.Debug:return"debug";case h.Info:return"info";case h.Warning:return"warn";case h.Error:return"error";case h.Critical:return"critical";case h.Off:return"off"}}e.LogLevelToString=o});var ee=this&&this.__param||function(z,e){return function(S,t){e(S,t,z)}};define(X[189],J([0,1,68,3,2,6,4]),function(z,e,S,t,M,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let b=class St extends M.Disposable{constructor(w){super();this.logService=w,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(w,E){let C;try{C=await this.withKeytar()}catch{return null}const p=await C.getPassword(w,E);if(p)try{let{content:g,hasNextChunk:d}=JSON.parse(p);if(!g||!d)return p;let P=1;for(;d;){const y=await C.getPassword(w,`${E}-${P}`),m=JSON.parse(y);g+=m.content,d=m.hasNextChunk,P++}return g}catch{return p}return p}async setPassword(w,E,C){let p;try{p=await this.withKeytar()}catch(P){throw this.surfaceKeytarLoadError?.(P),P}const g=3,d=async(P,y,m)=>{let v=0,f;for(;v<g;)try{await p.setPassword(P,y,m);return}catch(u){f=u,this.logService.warn("Error attempting to set a password: ",u?.message??u),v++,await new Promise(c=>setTimeout(c,200))}throw f};if(D.isWindows&&C.length>St.MAX_PASSWORD_LENGTH){let P=0,y=0,m=!0;for(;m;){const v=C.substring(P,P+St.PASSWORD_CHUNK_SIZE);P+=St.PASSWORD_CHUNK_SIZE,m=C.length-P>0;const f={content:v,hasNextChunk:m};await d(w,y?`${E}-${y}`:E,JSON.stringify(f)),y++}}else await d(w,E,C);this._onDidChangePassword.fire({service:w,account:E})}async deletePassword(w,E){let C;try{C=await this.withKeytar()}catch(d){throw this.surfaceKeytarLoadError?.(d),d}const p=await C.getPassword(w,E);if(!p)return!1;const g=await C.deletePassword(w,E);try{let{content:d,hasNextChunk:P}=JSON.parse(p);if(d&&P){let y=1;for(;P;){const m=`${E}-${y}`,v=await C.getPassword(w,m);await C.deletePassword(w,m),P=JSON.parse(v).hasNextChunk,y++}}}catch{}return g&&this._onDidChangePassword.fire({service:w,account:E}),g}async findPassword(w){let E;try{E=await this.withKeytar()}catch{return null}return E.findPassword(w)}async findCredentials(w){let E;try{E=await this.withKeytar()}catch{return[]}return E.findCredentials(w)}clear(){return this._keytarCache instanceof S.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};b.MAX_PASSWORD_LENGTH=2500,b.PASSWORD_CHUNK_SIZE=b.MAX_PASSWORD_LENGTH-100,b=ge([ee(0,R.ILogService)],b),e.BaseCredentialsMainService=b}),define(X[190],J([0,1,25,8,19,3,2,9,69,6]),function(z,e,S,t,M,R,D,b,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class E extends D.Disposable{constructor(p,g){super();this.logService=p,this.options=g,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(p,g){return g.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(p,g):this.watchNonRecursive(p,g)}watchUniversal(p,g){const d={path:this.toFilePath(p),excludes:g.excludes,includes:g.includes,recursive:g.recursive},P=(0,S.insert)(this.universalPathsToWatch,d);return this.refreshUniversalWatchers(),(0,D.toDisposable)(()=>{P(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(p=>(0,M.onUnexpectedError)(p))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(g=>this._onDidChangeFile.fire((0,h.toFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===w.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)})));const p=this.options?.watcher?.recursive?.usePolling;if(p===!0)for(const g of this.universalPathsToWatch)(0,h.isRecursiveWatchRequest)(g)&&(g.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const g of this.universalPathsToWatch)(0,h.isRecursiveWatchRequest)(g)&&p.includes(g.path)&&(g.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(p,g){const d={path:this.toFilePath(p),excludes:g.excludes,includes:g.includes,recursive:!1},P=(0,S.insert)(this.nonRecursivePathsToWatch,d);return this.refreshNonRecursiveWatchers(),(0,D.toDisposable)(()=>{P(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(p=>(0,M.onUnexpectedError)(p))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(p=>this._onDidChangeFile.fire((0,h.toFileChanges)(p)),p=>this.onWatcherLogMessage(p),this.logService.getLevel()===w.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(p){p.type==="error"&&this._onDidWatchError.fire(p.message),this.logService[p.type](p.message)}toFilePath(p){return(0,b.normalize)(p.fsPath)}}e.AbstractDiskFileSystemProvider=E}),define(X[191],J([0,1,25,8,17,21,3,65,55,2,33,13,70,16,56,150,15,102,6]),function(z,e,S,t,M,R,D,b,h,w,E,C,p,g,d,P,y,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let f=class extends w.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new D.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new D.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new D.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(c,o){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${c}`);const r=new w.DisposableStore;return this.provider.set(c,o),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:o}),r.add(o.onDidChangeFile(i=>this._onDidFilesChange.fire(new y.FileChangesEvent(i,!this.isPathCaseSensitive(o))))),typeof o.onDidWatchError=="function"&&r.add(o.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),r.add(o.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:o,scheme:c}))),(0,w.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:o}),this.provider.delete(c),(0,w.dispose)(r)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const o=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(r){o.push(r)}}),!this.provider.has(c)&&await t.Promises.settled(o)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,o){const r=this.provider.get(c.scheme);return!!(r&&r.capabilities&o)}listCapabilities(){return h.Iterable.map(this.provider,([c,o])=>({scheme:c,capabilities:o.capabilities}))}async withProvider(c){if(!(0,g.isAbsolutePath)(c))throw new y.FileOperationError((0,P.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const o=this.provider.get(c.scheme);if(!o){const r=new Error;throw r.name="ENOPRO",r.message=(0,P.localize)(1,null,c.toString()),r}return o}async withReadProvider(c){const o=await this.withProvider(c);if((0,y.hasOpenReadWriteCloseCapability)(o)||(0,y.hasReadWriteCapability)(o)||(0,y.hasFileReadStreamCapability)(o)||(0,y.hasFileReadCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream, FileOpenReadWriteClose nor Readonly capability which is needed for the read operation.`)}async withWriteProvider(c){const o=await this.withProvider(c);if((0,y.hasOpenReadWriteCloseCapability)(o)||(0,y.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,o){try{return await this.doResolveFile(c,o)}catch(r){throw(0,y.toFileSystemProviderErrorCode)(r)===y.FileSystemProviderErrorCode.FileNotFound?new y.FileOperationError((0,P.localize)(2,null,this.resourceForError(c)),1):(0,y.ensureFileSystemProviderError)(r)}}async doResolveFile(c,o){const r=await this.withProvider(c),i=this.isPathCaseSensitive(r),n=o?.resolveTo,s=o?.resolveSingleChildDescendants,a=o?.resolveMetadata,l=await r.stat(c);let I;return this.toFileStat(r,c,l,void 0,!!a,(k,A)=>(I||(I=E.TernarySearchTree.forUris(()=>!i),I.set(c,!0),n&&I.fill(!0,n)),I.get(k.resource)||I.findSuperstr(k.resource.with({query:null,fragment:null}))?!0:k.isDirectory&&s?A===1:!1))}async toFileStat(c,o,r,i,n,s){const{providerExtUri:a}=this.getExtUri(c),l={resource:o,name:a.basename(o),isFile:(r.type&y.FileType.File)!=0,isDirectory:(r.type&y.FileType.Directory)!=0,isSymbolicLink:(r.type&y.FileType.SymbolicLink)!=0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&y.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,y.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(l.isDirectory&&s(l,i)){try{const I=await c.readdir(o),k=await t.Promises.settled(I.map(async([A,W])=>{try{const F=a.joinPath(o,A),K=n?await c.stat(F):{type:W};return await this.toFileStat(c,F,K,I.length,n,s)}catch(F){return this.logService.trace(F),null}}));l.children=(0,S.coalesce)(k)}catch(I){this.logService.trace(I),l.children=[]}return l}return l}async resolveAll(c){return t.Promises.settled(c.map(async o=>{try{return{stat:await this.doResolveFile(o.resource,o.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async stat(c){const o=await this.withProvider(c),r=await o.stat(c);return this.toFileStat(o,c,r,void 0,!0,()=>!1)}async exists(c){const o=await this.withProvider(c);try{return!!await o.stat(c)}catch{return!1}}async canCreateFile(c,o){try{await this.doValidateCreateFile(c,o)}catch(r){return r}return!0}async doValidateCreateFile(c,o){if(!o?.overwrite&&await this.exists(c))throw new y.FileOperationError((0,P.localize)(3,null,this.resourceForError(c)),3,o)}async createFile(c,o=M.VSBuffer.fromString(""),r){await this.doValidateCreateFile(c,r);const i=await this.writeFile(c,o);return this._onDidRunOperation.fire(new y.FileOperationEvent(c,0,i)),i}async writeFile(c,o,r){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,c,r)||await this.mkdirp(i,n.dirname(c));let a;if((0,y.hasReadWriteCapability)(i)&&!(o instanceof M.VSBuffer))if((0,d.isReadableStream)(o)){const l=await(0,d.peekStream)(o,3);l.ended?a=M.VSBuffer.concat(l.buffer):a=l}else a=(0,d.peekReadable)(o,l=>M.VSBuffer.concat(l),3);else a=o;!(0,y.hasOpenReadWriteCloseCapability)(i)||(0,y.hasReadWriteCapability)(i)&&a instanceof M.VSBuffer?await this.doWriteUnbuffered(i,c,r,a):await this.doWriteBuffered(i,c,r,a instanceof M.VSBuffer?(0,M.bufferToReadable)(a):a),this._onDidRunOperation.fire(new y.FileOperationEvent(c,4))}catch(s){throw new y.FileOperationError((0,P.localize)(4,null,this.resourceForError(c),(0,y.ensureFileSystemProviderError)(s).toString()),(0,y.toFileOperationResult)(s),r)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,o,r){if(!!r?.unlock&&!(c.capabilities&8192))throw new Error((0,P.localize)(5,null,this.resourceForError(o)));let n;try{n=await c.stat(o)}catch{return}if((n.type&y.FileType.Directory)!=0)throw new y.FileOperationError((0,P.localize)(6,null,this.resourceForError(o)),0,r);if(this.throwIfFileIsReadonly(o,n),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==y.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&r.mtime<n.mtime&&r.etag!==(0,y.etag)({mtime:r.mtime,size:n.size}))throw new y.FileOperationError((0,P.localize)(7,null),3,r);return n}async readFile(c,o,r){const i=await this.withReadProvider(c);return o?.atomic?this.doReadFileAtomic(i,c,o,r):this.doReadFile(i,c,o,r)}async doReadFileAtomic(c,o,r,i){return new Promise((n,s)=>{this.writeQueue.queueFor(o,this.getExtUri(c).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(c,o,r,i);n(a)}catch(a){s(a)}})})}async doReadFile(c,o,r,i){const n=await this.doReadFileStream(c,o,{...r,preferUnbuffered:!0},i);return{...n,value:await(0,M.streamToBuffer)(n.value)}}async readFileStream(c,o,r){const i=await this.withReadProvider(c);return this.doReadFileStream(i,c,o,r)}async doReadFileStream(c,o,r,i){const n=new R.CancellationTokenSource(i),s=this.validateReadFile(o,r).then(l=>l,l=>{throw n.cancel(),l});let a;try{return typeof r?.etag=="string"&&r.etag!==y.ETAG_DISABLED&&await s,r?.atomic&&(0,y.hasFileAtomicReadCapability)(c)||!((0,y.hasOpenReadWriteCloseCapability)(c)||(0,y.hasFileReadStreamCapability)(c))||(0,y.hasReadWriteCapability)(c)&&r?.preferUnbuffered?a=this.readFileUnbuffered(c,o,r):(0,y.hasFileReadStreamCapability)(c)?a=this.readFileStreamed(c,o,n.token,r):a=this.readFileBuffered(c,o,n.token,r),{...await s,value:a}}catch(l){a&&await(0,d.consumeStream)(a);const I=(0,P.localize)(8,null,this.resourceForError(o),(0,y.ensureFileSystemProviderError)(l).toString());throw l instanceof y.NotModifiedSinceFileOperationError?new y.NotModifiedSinceFileOperationError(I,l.stat,r):new y.FileOperationError(I,(0,y.toFileOperationResult)(l),r)}}readFileStreamed(c,o,r,i=Object.create(null)){const n=c.readFileStream(o,i,r);return(0,d.transform)(n,{data:s=>s instanceof M.VSBuffer?s:M.VSBuffer.wrap(s),error:s=>new y.FileOperationError((0,P.localize)(9,null,this.resourceForError(o),(0,y.ensureFileSystemProviderError)(s).toString()),(0,y.toFileOperationResult)(s),i)},s=>M.VSBuffer.concat(s))}readFileBuffered(c,o,r,i=Object.create(null)){const n=(0,M.newWriteableBufferStream)();return(0,m.readFileIntoStream)(c,o,n,s=>s,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new y.FileOperationError((0,P.localize)(10,null,this.resourceForError(o),(0,y.ensureFileSystemProviderError)(s).toString()),(0,y.toFileOperationResult)(s),i)},r),n}readFileUnbuffered(c,o,r){const i=(0,d.newWriteableStream)(n=>M.VSBuffer.concat(n));return(async()=>{try{let n;r?.atomic&&(0,y.hasFileAtomicReadCapability)(c)?n=await c.readFile(o,{atomic:!0}):n=await c.readFile(o),typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.validateReadFileLimits(o,n.byteLength,r),i.end(M.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(c,o){const r=await this.resolve(c,{resolveMetadata:!0});if(r.isDirectory)throw new y.FileOperationError((0,P.localize)(11,null,this.resourceForError(c)),0,o);if(typeof o?.etag=="string"&&o.etag!==y.ETAG_DISABLED&&o.etag===r.etag)throw new y.NotModifiedSinceFileOperationError((0,P.localize)(12,null),r,o);return this.validateReadFileLimits(c,r.size,o),r}validateReadFileLimits(c,o,r){if(r?.limits){let i;if(typeof r.limits.memory=="number"&&o>r.limits.memory&&(i=9),typeof r.limits.size=="number"&&o>r.limits.size&&(i=7),typeof i=="number")throw new y.FileOperationError((0,P.localize)(13,null,this.resourceForError(c)),i)}}async canMove(c,o,r){return this.doCanMoveCopy(c,o,"move",r)}async canCopy(c,o,r){return this.doCanMoveCopy(c,o,"copy",r)}async doCanMoveCopy(c,o,r,i){if(c.toString()!==o.toString())try{const n=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);await this.doValidateMoveCopy(n,c,s,o,r,i)}catch(n){return n}return!0}async move(c,o,r){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=await this.doMoveCopy(i,c,n,o,"move",!!r),a=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(c,s==="move"?2:3,a)),a}async copy(c,o,r){const i=await this.withReadProvider(c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=await this.doMoveCopy(i,c,n,o,"copy",!!r),a=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(c,s==="copy"?3:2,a)),a}async doMoveCopy(c,o,r,i,n,s){if(o.toString()===i.toString())return n;const{exists:a,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(c,o,r,i,n,s);if(a&&!l&&s&&await this.del(i,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(i)),n==="copy"){if(c===r&&(0,y.hasFileFolderCopyCapability)(c))await c.copy(o,i,{overwrite:s});else{const I=await this.resolve(o);I.isDirectory?await this.doCopyFolder(c,I,r,i):await this.doCopyFile(c,o,r,i)}return n}else return c===r?(await c.rename(o,i,{overwrite:s}),n):(await this.doMoveCopy(c,o,r,i,"copy",s),await this.del(o,{recursive:!0}),"copy")}async doCopyFile(c,o,r,i){if((0,y.hasOpenReadWriteCloseCapability)(c)&&(0,y.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(c,o,r,i);if((0,y.hasOpenReadWriteCloseCapability)(c)&&(0,y.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(c,o,r,i);if((0,y.hasReadWriteCapability)(c)&&(0,y.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(c,o,r,i);if((0,y.hasReadWriteCapability)(c)&&(0,y.hasReadWriteCapability)(r))return this.doPipeUnbuffered(c,o,r,i)}async doCopyFolder(c,o,r,i){await r.mkdir(i),Array.isArray(o.children)&&await t.Promises.settled(o.children.map(async n=>{const s=this.getExtUri(r).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(c,await this.resolve(n.resource),r,s):this.doCopyFile(c,n.resource,r,s)}))}async doValidateMoveCopy(c,o,r,i,n,s){let a=!1;if(c===r){const{providerExtUri:I,isPathCaseSensitive:k}=this.getExtUri(c);if(k||(a=I.isEqual(o,i)),a&&n==="copy")throw new Error((0,P.localize)(14,null,this.resourceForError(o),this.resourceForError(i)));if(!a&&I.isEqualOrParent(i,o))throw new Error((0,P.localize)(15,null,this.resourceForError(o),this.resourceForError(i)))}const l=await this.exists(i);if(l&&!a){if(!s)throw new y.FileOperationError((0,P.localize)(16,null,this.resourceForError(o),this.resourceForError(i)),4);if(c===r){const{providerExtUri:I}=this.getExtUri(c);if(I.isEqualOrParent(o,i))throw new Error((0,P.localize)(17,null,this.resourceForError(o),this.resourceForError(i)))}}return{exists:l,isSameResourceWithDifferentPathCase:a}}getExtUri(c){const o=this.isPathCaseSensitive(c);return{providerExtUri:o?g.extUri:g.extUriIgnorePathCase,isPathCaseSensitive:o}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(o,c);const r=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(c,0,r)),r}async mkdirp(c,o){const r=[],{providerExtUri:i}=this.getExtUri(c);for(;!i.isEqual(o,i.dirname(o));)try{if(((await c.stat(o)).type&y.FileType.Directory)==0)throw new Error((0,P.localize)(18,null,this.resourceForError(o)));break}catch(n){if((0,y.toFileSystemProviderErrorCode)(n)!==y.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(i.basename(o)),o=i.dirname(o)}for(let n=r.length-1;n>=0;n--){o=i.joinPath(o,r[n]);try{await c.mkdir(o)}catch(s){if((0,y.toFileSystemProviderErrorCode)(s)!==y.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(c,o){try{await this.doValidateDelete(c,o)}catch(r){return r}return!0}async doValidateDelete(c,o){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!o?.useTrash&&!(r.capabilities&4096))throw new Error((0,P.localize)(19,null,this.resourceForError(c)));let n;try{n=await r.stat(c)}catch{}if(n)this.throwIfFileIsReadonly(c,n);else throw new y.FileOperationError((0,P.localize)(20,null,this.resourceForError(c)),1);if(!!!o?.recursive){const a=await this.resolve(c);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,P.localize)(21,null,this.resourceForError(c)))}return r}async del(c,o){const r=await this.doValidateDelete(c,o),i=!!o?.useTrash,n=!!o?.recursive;await r.delete(c,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new y.FileOperationEvent(c,1))}async cloneFile(c,o){const r=await this.withProvider(c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);if(r===i&&this.getExtUri(r).providerExtUri.isEqual(c,o))return;if(r===i&&(0,y.hasFileCloneCapability)(r))return r.cloneFile(c,o);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(o));const n=this.writeQueue.queueFor(c,this.getExtUri(r).providerExtUri);return r===i&&(0,y.hasFileFolderCopyCapability)(r)?n.queue(()=>r.copy(c,o,{overwrite:!0})):n.queue(()=>this.doCopyFile(r,c,i,o))}watch(c,o={recursive:!1,excludes:[]}){const r=new w.DisposableStore;let i=!1,n=()=>{i=!0};return r.add((0,w.toDisposable)(()=>n())),(async()=>{try{const s=await this.doWatch(c,o);i?(0,w.dispose)(s):n=()=>(0,w.dispose)(s)}catch(s){this.logService.error(s)}})(),r}async doWatch(c,o){const r=await this.withProvider(c),i=(0,b.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(c),o]);let n=this.activeWatchers.get(i);return n||(n={count:0,disposable:r.watch(c,o)},this.activeWatchers.set(i,n)),n.count+=1,(0,w.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,w.dispose)(n.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,w.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,o,r,i){return this.writeQueue.queueFor(o,this.getExtUri(c).providerExtUri).queue(async()=>{const n=await c.open(o,{create:!0,unlock:r?.unlock??!1});try{(0,d.isReadableStream)(i)||(0,d.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(c,n,i):await this.doWriteReadableBufferedQueued(c,n,i)}catch(s){throw(0,y.ensureFileSystemProviderError)(s)}finally{await c.close(n)}})}async doWriteStreamBufferedQueued(c,o,r){let i=0,n;if((0,d.isReadableBufferedStream)(r)){if(r.buffer.length>0){const s=M.VSBuffer.concat(r.buffer);await this.doWriteBuffer(c,o,s,s.byteLength,i,0),i+=s.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((s,a)=>{(0,d.listenStream)(n,{onData:async l=>{n.pause();try{await this.doWriteBuffer(c,o,l,l.byteLength,i,0)}catch(I){return a(I)}i+=l.byteLength,setTimeout(()=>n.resume())},onError:l=>a(l),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(c,o,r){let i=0,n;for(;(n=r.read())!==null;)await this.doWriteBuffer(c,o,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(c,o,r,i,n,s){let a=0;for(;a<i;)a+=await c.write(o,n+a,r.buffer,s+a,i-a)}async doWriteUnbuffered(c,o,r,i){return this.writeQueue.queueFor(o,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,o,r,i))}async doWriteUnbufferedQueued(c,o,r,i){let n;i instanceof M.VSBuffer?n=i:(0,d.isReadableStream)(i)?n=await(0,M.streamToBuffer)(i):(0,d.isReadableBufferedStream)(i)?n=await(0,M.bufferedStreamToBuffer)(i):n=(0,M.readableToBuffer)(i),await c.writeFile(o,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(c,o,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,o,r,i))}async doPipeBufferedQueued(c,o,r,i){let n,s;try{n=await c.open(o,{create:!1}),s=await r.open(i,{create:!0,unlock:!1});const a=M.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,I=0,k=0;do k=await c.read(n,l,a.buffer,I,a.byteLength-I),await this.doWriteBuffer(r,s,a,k,l,I),l+=k,I+=k,I===a.byteLength&&(I=0);while(k>0)}catch(a){throw(0,y.ensureFileSystemProviderError)(a)}finally{await t.Promises.settled([typeof n=="number"?c.close(n):Promise.resolve(),typeof s=="number"?r.close(s):Promise.resolve()])}}async doPipeUnbuffered(c,o,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,o,r,i))}async doPipeUnbufferedQueued(c,o,r,i){return r.writeFile(i,await c.readFile(o),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,o,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,o,r,i))}async doPipeUnbufferedToBufferedQueued(c,o,r,i){const n=await r.open(i,{create:!0,unlock:!1});try{const s=await c.readFile(o);await this.doWriteBuffer(r,n,M.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,y.ensureFileSystemProviderError)(s)}finally{await r.close(n)}}async doPipeBufferedToUnbuffered(c,o,r,i){const n=await(0,M.streamToBuffer)(this.readFileBuffered(c,o,R.CancellationToken.None));await this.doWriteUnbuffered(r,i,void 0,n)}throwIfFileSystemIsReadonly(c,o){if(c.capabilities&2048)throw new y.FileOperationError((0,P.localize)(22,null,this.resourceForError(o)),6);return c}throwIfFileIsReadonly(c,o){if((o.permissions??0)&y.FilePermission.Readonly)throw new y.FileOperationError((0,P.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===C.Schemas.file?c.fsPath:c.toString(!0)}};f=ge([ee(0,v.ILogService)],f),e.FileService=f}),define(X[85],J([0,1,28,260,8,33,17,3,31,2,9,4,16,56,23,154,15,102,190,42,187,186]),function(z,e,S,t,M,R,D,b,h,w,E,C,p,g,d,P,y,m,v,f,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(S)}catch(r){console.error(`Error enabling graceful-fs: ${(0,f.toErrorMessage)(r)}`)}})();class o extends v.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n);this.onDidChangeCapabilities=b.Event.None,this.resourceLocks=new R.ResourceMap(s=>p.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,C.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:n,symbolicLink:s}=await d.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(n,s),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(i){try{const n=await d.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),s=[];return await Promise.all(n.map(async a=>{try{let l;a.isSymbolicLink()?l=(await this.stat((0,p.joinPath)(i,a.name))).type:l=this.toType(a),s.push([a.name,l])}catch(l){this.logService.trace(l)}})),s}catch(n){throw this.toFileSystemProviderError(n)}}toType(i,n){let s;return n?.dangling?s=y.FileType.Unknown:i.isFile()?s=y.FileType.File:i.isDirectory()?s=y.FileType.Directory:s=y.FileType.Unknown,n&&(s|=y.FileType.SymbolicLink),s}async createResourceLock(i){const n=this.toFilePath(i);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let s;for(;s=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await s.wait();const a=new M.Barrier;return this.resourceLocks.set(i,a),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,w.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(i)===a&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),a.open()})}async readFile(i,n){let s;try{n?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),s=await this.createResourceLock(i));const a=this.toFilePath(i);return await d.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}finally{s?.dispose()}}readFileStream(i,n,s){const a=(0,g.newWriteableStream)(l=>D.VSBuffer.concat(l.map(I=>D.VSBuffer.wrap(I))).buffer);return(0,m.readFileIntoStream)(this,i,a,l=>l.buffer,{...n,bufferSize:256*1024},s),a}async writeFile(i,n,s){let a;try{const l=this.toFilePath(i);if(!s.create||!s.overwrite){if(await d.Promises.exists(l)){if(!s.overwrite)throw(0,y.createFileSystemProviderError)((0,P.localize)(0,null),y.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,y.createFileSystemProviderError)((0,P.localize)(1,null),y.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(i,{create:!0,unlock:s.unlock}),await this.write(a,0,n,0,n.byteLength)}catch(l){throw await this.toFileSystemProviderWriteError(i,l)}finally{typeof a=="number"&&await this.close(a)}}static configureFlushOnWrite(i){o.canFlush=i}async open(i,n){const s=this.toFilePath(i);let a;(0,y.isFileOpenForWriteOptions)(n)&&(a=await this.createResourceLock(i));let l;try{if((0,y.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:k}=await d.SymlinkSupport.stat(s);k.mode&128||await d.Promises.chmod(s,k.mode|128)}catch(k){this.logService.trace(k)}let I;if((0,y.isFileOpenForWriteOptions)(n)){if(C.isWindows)try{await d.Promises.truncate(s,0),I="r+"}catch(k){k.code!=="ENOENT"&&this.logService.trace(k)}I||(I="w")}else I="r";l=await d.Promises.open(s,I)}catch(I){throw a?.dispose(),(0,y.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(i,I):this.toFileSystemProviderError(I)}if(this.mapHandleToPos.set(l,0),(0,y.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(l,i),a){const I=this.mapHandleToLock.get(l);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${s})`),this.mapHandleToLock.set(l,a),I&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${s})`),I.dispose())}return l}async close(i){const n=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&o.canFlush)try{await d.Promises.fdatasync(i)}catch(s){o.configureFlushOnWrite(!1),this.logService.error(s)}return await d.Promises.close(i)}catch(s){throw this.toFileSystemProviderError(s)}finally{n&&(this.mapHandleToLock.get(i)===n&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,s,a,l){const I=this.normalizePos(i,n);let k=null;try{k=(await d.Promises.read(i,s,a,l,I)).bytesRead}catch(A){throw this.toFileSystemProviderError(A)}finally{this.updatePos(i,I,k)}return k}normalizePos(i,n){return n===this.mapHandleToPos.get(i)?null:n}updatePos(i,n,s){const a=this.mapHandleToPos.get(i);typeof a=="number"&&(typeof n=="number"||(typeof s=="number"?this.mapHandleToPos.set(i,a+s):this.mapHandleToPos.delete(i)))}async write(i,n,s,a,l){return(0,M.retry)(()=>this.doWrite(i,n,s,a,l),100,3)}async doWrite(i,n,s,a,l){const I=this.normalizePos(i,n);let k=null;try{k=(await d.Promises.write(i,s,a,l,I)).bytesWritten}catch(A){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),A)}finally{this.updatePos(i,I,k)}return k}async mkdir(i){try{await d.Promises.mkdir(this.toFilePath(i))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(i,n){try{const s=this.toFilePath(i);n.recursive?await d.Promises.rm(s,d.RimRafMode.MOVE):await d.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(i,n,s){const a=this.toFilePath(i),l=this.toFilePath(n);if(a!==l)try{await this.validateTargetDeleted(i,n,"move",s.overwrite),await d.Promises.move(a,l)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,P.localize)(2,null,(0,E.basename)(a),(0,E.basename)((0,E.dirname)(l)),I.toString()))),this.toFileSystemProviderError(I)}}async copy(i,n,s){const a=this.toFilePath(i),l=this.toFilePath(n);if(a!==l)try{await this.validateTargetDeleted(i,n,"copy",s.overwrite),await d.Promises.copy(a,l,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,P.localize)(3,null,(0,E.basename)(a),(0,E.basename)((0,E.dirname)(l)),I.toString()))),this.toFileSystemProviderError(I)}}async validateTargetDeleted(i,n,s,a){const l=this.toFilePath(i),I=this.toFilePath(n);let k=!1;if(!!(this.capabilities&1024)||(k=(0,h.isEqual)(l,I,!0)),k&&s==="copy")throw(0,y.createFileSystemProviderError)((0,P.localize)(4,null),y.FileSystemProviderErrorCode.FileExists);if(!k&&await d.Promises.exists(I)){if(!a)throw(0,y.createFileSystemProviderError)((0,P.localize)(5,null),y.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(i,n){return this.doCloneFile(i,n,!1)}async doCloneFile(i,n,s){const a=this.toFilePath(i),l=this.toFilePath(n),I=!!(this.capabilities&1024);if((0,h.isEqual)(a,l,!I))return;const k=new w.DisposableStore;try{const[A,W]=await Promise.all([this.createResourceLock(i),this.createResourceLock(n)]);k.add(A),k.add(W),s&&await d.Promises.mkdir((0,E.dirname)(l),{recursive:!0}),await d.Promises.copyFile(a,l)}catch(A){if(A.code==="ENOENT"&&!s)return this.doCloneFile(i,n,!0);throw this.toFileSystemProviderError(A)}finally{k.dispose()}}createUniversalWatcher(i,n,s){return new u.UniversalWatcherClient(a=>i(a),a=>n(a),s)}createNonRecursiveWatcher(i,n,s){return new c.NodeJSWatcherClient(a=>i(a),a=>n(a),s)}toFileSystemProviderError(i){if(i instanceof y.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=y.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=y.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=y.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=y.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=y.FileSystemProviderErrorCode.NoPermissions;break;default:n=y.FileSystemProviderErrorCode.Unknown}return(0,y.createFileSystemProviderError)(i,n)}async toFileSystemProviderWriteError(i,n){let s=this.toFileSystemProviderError(n);if(i&&s.code===y.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await d.SymlinkSupport.stat(this.toFilePath(i));a.mode&128||(s=(0,y.createFileSystemProviderError)(n,y.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return s}}e.DiskFileSystemProvider=o,o.canFlush=!0}),define(X[192],J([0,1,3,85,2,17,56,21]),function(z,e,S,t,M,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class h extends M.Disposable{constructor(C,p){super();this.provider=C,this.logService=p,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(C,p,g){const d=this.getUriTransformer(C);switch(p){case"stat":return this.stat(d,g[0]);case"readdir":return this.readdir(d,g[0]);case"open":return this.open(d,g[0],g[1]);case"close":return this.close(g[0]);case"read":return this.read(g[0],g[1],g[2]);case"readFile":return this.readFile(d,g[0],g[1]);case"write":return this.write(g[0],g[1],g[2],g[3],g[4]);case"writeFile":return this.writeFile(d,g[0],g[1],g[2]);case"rename":return this.rename(d,g[0],g[1],g[2]);case"copy":return this.copy(d,g[0],g[1],g[2]);case"cloneFile":return this.cloneFile(d,g[0],g[1]);case"mkdir":return this.mkdir(d,g[0]);case"delete":return this.delete(d,g[0],g[1]);case"watch":return this.watch(d,g[0],g[1],g[2],g[3]);case"unwatch":return this.unwatch(g[0],g[1])}throw new Error(`IPC Command ${p} not found`)}listen(C,p,g){const d=this.getUriTransformer(C);switch(p){case"fileChange":return this.onFileChange(d,g[0]);case"readFileStream":return this.onReadFileStream(d,g[0],g[1])}throw new Error(`Unknown event ${p}`)}stat(C,p){const g=this.transformIncoming(C,p,!0);return this.provider.stat(g)}readdir(C,p){const g=this.transformIncoming(C,p);return this.provider.readdir(g)}async readFile(C,p,g){const d=this.transformIncoming(C,p,!0),P=await this.provider.readFile(d,g);return R.VSBuffer.wrap(P)}onReadFileStream(C,p,g){const d=this.transformIncoming(C,p,!0),P=new b.CancellationTokenSource,y=new S.Emitter({onLastListenerRemove:()=>{P.cancel()}}),m=this.provider.readFileStream(d,g,P.token);return(0,D.listenStream)(m,{onData:v=>y.fire(R.VSBuffer.wrap(v)),onError:v=>y.fire(v),onEnd:()=>{y.fire("end"),y.dispose(),P.dispose()}}),y.event}writeFile(C,p,g,d){const P=this.transformIncoming(C,p);return this.provider.writeFile(P,g.buffer,d)}open(C,p,g){const d=this.transformIncoming(C,p,!0);return this.provider.open(d,g)}close(C){return this.provider.close(C)}async read(C,p,g){const d=R.VSBuffer.alloc(g),P=0,y=await this.provider.read(C,p,d.buffer,P,g);return[d,y]}write(C,p,g,d,P){return this.provider.write(C,p,g.buffer,d,P)}mkdir(C,p){const g=this.transformIncoming(C,p);return this.provider.mkdir(g)}delete(C,p,g){const d=this.transformIncoming(C,p);return this.provider.delete(d,g)}rename(C,p,g,d){const P=this.transformIncoming(C,p),y=this.transformIncoming(C,g);return this.provider.rename(P,y,d)}copy(C,p,g,d){const P=this.transformIncoming(C,p),y=this.transformIncoming(C,g);return this.provider.copy(P,y,d)}cloneFile(C,p,g){const d=this.transformIncoming(C,p),P=this.transformIncoming(C,g);return this.provider.cloneFile(d,P)}onFileChange(C,p){const g=new S.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(p,this.createSessionFileWatcher(C,g))},onLastListenerRemove:()=>{(0,M.dispose)(this.sessionToWatcher.get(p)),this.sessionToWatcher.delete(p)}});return g.event}async watch(C,p,g,d,P){const y=this.sessionToWatcher.get(p);if(y){const m=this.transformIncoming(C,d),v=y.watch(g,m,P);this.watchRequests.set(p+g,v)}}async unwatch(C,p){const g=C+p,d=this.watchRequests.get(g);d&&((0,M.dispose)(d),this.watchRequests.delete(g))}dispose(){super.dispose();for(const[,C]of this.watchRequests)C.dispose();this.watchRequests.clear();for(const[,C]of this.sessionToWatcher)C.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=h;class w extends M.Disposable{constructor(C,p,g,d){super();this.uriTransformer=C,this.logService=g,this.environmentService=d,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(p)}registerListeners(C){const p=this._register(new S.Emitter);this._register(p.event(g=>{C.fire(g.map(d=>({resource:this.uriTransformer.transformOutgoingURI(d.resource),type:d.type})))})),this._register(this.fileWatcher.onDidChangeFile(g=>p.fire(g))),this._register(this.fileWatcher.onDidWatchError(g=>C.fire(g)))}getRecursiveWatcherOptions(C){}getExtraExcludes(C){}watch(C,p,g){const d=this.getExtraExcludes(this.environmentService);return Array.isArray(d)&&(g.excludes=[...g.excludes,...d]),this.watcherRequests.set(C,this.fileWatcher.watch(p,g)),(0,M.toDisposable)(()=>{(0,M.dispose)(this.watcherRequests.get(C)),this.watcherRequests.delete(C)})}dispose(){super.dispose();for(const[,C]of this.watcherRequests)C.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=w}),define(X[193],J([0,1,14,153,4,7,15,9,192,135]),function(z,e,S,t,M,R,D,b,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class E extends h.AbstractDiskFileSystemProviderChannel{constructor(g,d,P){super(g,d);this.environmentService=P}getUriTransformer(g){return w.DefaultURITransformer}transformIncoming(g,d){return R.URI.revive(d)}async delete(g,d,P){if(!P.useTrash)return super.delete(g,d,P);const y=this.transformIncoming(g,d),m=(0,b.normalize)(y.fsPath);try{await S.shell.trashItem(m)}catch{throw(0,D.createFileSystemProviderError)(M.isWindows?(0,t.localize)(0,null,(0,b.basename)(m)):(0,t.localize)(1,null,(0,b.basename)(m)),D.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(g,d){return new C(g,d,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=E;class C extends h.AbstractSessionFileWatcher{watch(g,d,P){if(P.recursive)throw(0,D.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(g,d,P)}}}),define(X[103],J([0,1,6]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function t(R,D){switch(D){case S.LogLevel.Trace:return R.trace;case S.LogLevel.Debug:return R.debug;case S.LogLevel.Info:return R.info;case S.LogLevel.Warning:return R.warn;case S.LogLevel.Error:return R.error;case S.LogLevel.Critical:return R.critical;default:throw new Error("Invalid log level")}}class M extends S.AbstractLogger{constructor(D=S.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(D),this._register(this.onDidChangeLogLevel(b=>{this._logger?.setLevel(b)}))}set logger(D){this._logger=D;for(const{level:b,args:h}of this.buffer)t(D,b).apply(D,h);this.buffer=[]}_log(D,...b){this._logger?t(this._logger,D).apply(this._logger,b):this.getLevel()<=D&&this.buffer.push({level:D,args:b})}trace(D,...b){this._log(S.LogLevel.Trace,D,...b)}debug(D,...b){this._log(S.LogLevel.Debug,D,...b)}info(D,...b){this._log(S.LogLevel.Info,D,...b)}warn(D,...b){this._log(S.LogLevel.Warning,D,...b)}error(D,...b){this._log(S.LogLevel.Error,D,...b)}critical(D,...b){this._log(S.LogLevel.Critical,D,...b)}dispose(){this._logger?.dispose()}flush(){this._logger?.flush()}}e.BufferLogService=M}),define(X[194],J([0,1,8,17,16,15,5,103,6]),function(z,e,S,t,M,R,D,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const w=5*R.ByteSize.MB;let E=class extends h.AbstractLogger{constructor(g,d,P,y,m){super();this.name=g,this.resource=d,this.donotUseFormatters=y,this.fileService=m,this.backupIndex=1,this.setLevel(P),this.queue=this._register(new S.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=h.LogLevel.Trace&&this._log(h.LogLevel.Trace,(0,h.format)(arguments))}debug(){this.getLevel()<=h.LogLevel.Debug&&this._log(h.LogLevel.Debug,(0,h.format)(arguments))}info(){this.getLevel()<=h.LogLevel.Info&&this._log(h.LogLevel.Info,(0,h.format)(arguments))}warn(){this.getLevel()<=h.LogLevel.Warning&&this._log(h.LogLevel.Warning,(0,h.format)(arguments))}error(){if(this.getLevel()<=h.LogLevel.Error){const g=arguments[0];if(g instanceof Error){const d=Array.prototype.slice.call(arguments);d[0]=g.stack,this._log(h.LogLevel.Error,(0,h.format)(d))}else this._log(h.LogLevel.Error,(0,h.format)(arguments))}}critical(){this.getLevel()<=h.LogLevel.Critical&&this._log(h.LogLevel.Critical,(0,h.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(g){if(g.fileOperationResult!==3)throw g}}_log(g,d){this.queue.queue(async()=>{await this.initializePromise;let P=await this.loadContent();P.length>w&&(await this.fileService.writeFile(this.getBackupResource(),t.VSBuffer.fromString(P)),P=""),this.donotUseFormatters?P+=d:P+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(g)}] ${d}
`,await this.fileService.writeFile(this.resource,t.VSBuffer.fromString(P))})}getCurrentTimestamp(){const g=y=>y<10?`0${y}`:y,d=y=>y<10?`00${y}`:y<100?`0${y}`:y,P=new Date;return`${P.getFullYear()}-${g(P.getMonth()+1)}-${g(P.getDate())} ${g(P.getHours())}:${g(P.getMinutes())}:${g(P.getSeconds())}.${d(P.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,M.joinPath)((0,M.dirname)(this.resource),`${(0,M.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch{return""}}stringifyLogLevel(g){switch(g){case h.LogLevel.Critical:return"critical";case h.LogLevel.Debug:return"debug";case h.LogLevel.Error:return"error";case h.LogLevel.Info:return"info";case h.LogLevel.Trace:return"trace";case h.LogLevel.Warning:return"warning"}return""}};E=ge([ee(4,R.IFileService)],E),e.FileLogger=E;let C=class extends h.AbstractLoggerService{constructor(g,d,P){super(g.getLevel(),g.onDidChangeLogLevel);this.instantiationService=d,this.fileService=P}doCreateLogger(g,d,P){const y=new b.BufferLogService(d);return(0,R.whenProviderRegistered)(g,this.fileService).then(()=>y.logger=this.instantiationService.createInstance(E,P?.name||(0,M.basename)(g),g,y.getLevel(),!!P?.donotUseFormatters)),y}};C=ge([ee(0,h.ILogService),ee(1,D.IInstantiationService),ee(2,R.IFileService)],C),e.FileLoggerService=C}),define(X[195],J([0,1,3,7,6]),function(z,e,S,t,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class R{constructor(p){this.service=p,this.onDidChangeLogLevel=S.Event.buffer(p.onDidChangeLogLevel,!0)}listen(p,g){switch(g){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${g}`)}async call(p,g,d){switch(g){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${g}`)}}e.LogLevelChannel=R;class D{constructor(p){this.channel=p}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(p){D.setLevel(this.channel,p)}static setLevel(p,g){return p.call("setLevel",g)}}e.LogLevelChannelClient=D;class b{constructor(p){this.loggerService=p,this.loggers=new Map}listen(p,g){throw new Error(`Event not found: ${g}`)}async call(p,g,d){switch(g){case"createLogger":this.createLogger(t.URI.revive(d[0]),d[1]);return;case"log":return this.log(t.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${g}`)}createLogger(p,g){this.loggers.set(p.toString(),this.loggerService.createLogger(p,g))}consoleLog(p,g){let d=console.log;switch(p){case M.LogLevel.Error:d=console.error;break;case M.LogLevel.Warning:d=console.warn;break;case M.LogLevel.Info:d=console.info;break}d.call(console,...g)}log(p,g){const d=this.loggers.get(p.toString());if(!d)throw new Error("Create the logger before logging");for(const[P,y]of g)(0,M.log)(d,P,y)}}e.LoggerChannel=b;class h extends M.AbstractLoggerService{constructor(p,g,d){super(p,g);this.channel=d}createConsoleMainLogger(){return new M.AdapterLogger({log:(p,g)=>{this.channel.call("consoleLog",[p,g])}})}doCreateLogger(p,g,d){return new w(this.channel,p,g,d)}}e.LoggerChannelClient=h;class w extends M.AbstractMessageLogger{constructor(p,g,d,P){super(P?.always);this.channel=p,this.file=g,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[g,P]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(p,g){const d=[[p,g]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(p){this.channel.call("log",[this.file,p])}}class E extends M.LogService{constructor(p,g){super(g);this.parent=p,this._register(p.onDidChangeLogLevel(d=>g.setLevel(d)))}setLevel(p){super.setLevel(p),this.parent.setLevel(p)}}e.FollowerLogService=E}),define(X[104],J([0,1,15,6]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function M(b,h,w,E,C){try{const p=await new Promise((d,P)=>{z(["spdlog"],d,P)});p.setFlushOn(t.LogLevel.Trace);const g=await p.createAsyncRotatingLogger(b,h,w,E);return C&&g.clearFormatters(),g}catch(p){console.error(p)}return null}function R(b,h,w){switch(h){case t.LogLevel.Trace:b.trace(w);break;case t.LogLevel.Debug:b.debug(w);break;case t.LogLevel.Info:b.info(w);break;case t.LogLevel.Warning:b.warn(w);break;case t.LogLevel.Error:b.error(w);break;case t.LogLevel.Critical:b.critical(w);break;default:throw new Error("Invalid log level")}}class D extends t.AbstractMessageLogger{constructor(h,w,E,C,p){super();this.buffer=[],this.setLevel(p),this._loggerCreationPromise=this._createSpdLogLogger(h,w,E,C),this._register(this.onDidChangeLogLevel(g=>{this._logger?.setLevel(g)}))}async _createSpdLogLogger(h,w,E,C){const p=E?6:1,g=30/p*S.ByteSize.MB,d=await M(h,w,g,p,C);if(d){this._logger=d,this._logger.setLevel(this.getLevel());for(const{level:P,message:y}of this.buffer)R(this._logger,P,y);this.buffer=[]}}log(h,w){this._logger?R(this._logger,h,w):this.getLevel()<=h&&this.buffer.push({level:h,message:w})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=D}),define(X[196],J([0,1,13,16,27,15,194,6,104]),function(z,e,S,t,M,R,D,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let w=class extends b.AbstractLoggerService{constructor(C,p){super(C.getLevel(),C.onDidChangeLogLevel);this.fileService=p}doCreateLogger(C,p,g){return C.scheme===S.Schemas.file?new h.SpdLogLogger(g?.name||(0,M.generateUuid)(),C.fsPath,!g?.donotRotate,!!g?.donotUseFormatters,p):new D.FileLogger(g?.name??(0,t.basename)(C),C,p,!!g?.donotUseFormatters,this.fileService)}};w=ge([ee(0,b.ILogService),ee(1,R.IFileService)],w),e.LoggerService=w}),define(X[197],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function S(D){return D.submenu!==void 0}e.isMenubarMenuItemSubmenu=S;function t(D){return D.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function M(D){return D.uri!==void 0}e.isMenubarMenuItemRecentAction=M;function R(D){return!S(D)&&!t(D)&&!M(D)}e.isMenubarMenuItemAction=R}),define(X[37],J([0,1,3,55,2,5]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,R.createDecorator)("policy");class D extends M.Disposable{constructor(){super(...arguments);this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new S.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(w){const E=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...w,...this.policyDefinitions},E!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(w),t.Iterable.reduce(this.policies.entries(),(C,[p,g])=>({...C,[p]:g}),{})}getPolicyValue(w){return this.policies.get(w)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(w,[E,C])=>({...w,[E]:{definition:C,value:this.policies.get(E)}}),{})}}e.AbstractPolicyService=D;class b{constructor(){this.onDidChange=S.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=b}),define(X[198],J([0,1,8,3,55,11,15,6,37]),function(z,e,S,t,M,R,D,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function w(C,p){const g=[];for(const d of M.Iterable.concat(C.keys(),p.keys()))C.get(d)!==p.get(d)&&g.push(d);return g}let E=class extends h.AbstractPolicyService{constructor(p,g,d){super();this.file=p,this.fileService=g,this.logService=d,this.throttledDelayer=this._register(new S.ThrottledDelayer(500));const P=t.Event.filter(g.onDidFilesChange,y=>y.affects(p));this._register(g.watch(p)),this._register(P(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(p){await this.refresh()}async read(){const p=new Map;try{const g=await this.fileService.readFile(this.file),d=JSON.parse(g.value.toString());if(!(0,R.isObject)(d))throw new Error("Policy file isn't a JSON object");for(const P of Object.keys(d))this.policyDefinitions[P]&&p.set(P,d[P])}catch(g){g.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",g)}return p}async refresh(){const p=await this.read(),g=w(this.policies,p);this.policies=p,g.length>0&&this._onDidChange.fire(g)}};E=ge([ee(1,D.IFileService),ee(2,b.ILogService)],E),e.FilePolicyService=E}),define(X[199],J([0,1,3,2,37]),function(z,e,S,t,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class R{constructor(h){this.service=h,this.disposables=new t.DisposableStore}listen(h,w){switch(w){case"onDidChange":return S.Event.map(this.service.onDidChange,E=>E.reduce((C,p)=>({...C,[p]:this.service.getPolicyValue(p)??null}),{}),this.disposables)}throw new Error(`Event not found: ${w}`)}call(h,w,E){switch(w){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(E)}throw new Error(`Call not found: ${w}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=R;class D extends M.AbstractPolicyService{constructor(h,w){super();this.channel=w;for(const E in h){const{definition:C,value:p}=h[E];this.policyDefinitions[E]=C,p!==void 0&&this.policies.set(E,p)}this.channel.listen("onDidChange")(E=>{for(const C in E){const p=E[C];p===null?this.policies.delete(C):this.policies.set(C,p)}this._onDidChange.fire(Object.keys(E))})}async initializePolicies(h){const w=await this.channel.call("registerPolicyDefinitions",h);for(const E in w)this.policies.set(E,w[E])}}e.PolicyChannelClient=D}),define(X[52],J([0,1,13,4,36,16]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const b=t.globals.vscode.context.configuration();if(b)D=b.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof z?.__$__nodeRequire=="function"){const b=(0,R.dirname)(S.FileAccess.asFileUri("",z));D=z.__$__nodeRequire((0,R.joinPath)(b,"product.json").fsPath);const h=z.__$__nodeRequire((0,R.joinPath)(b,"package.json").fsPath);M.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),Object.assign(D,{version:h.version})}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=D}),define(X[20],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,S.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(X[200],J([0,1,75,6,20]),function(z,e,S,t,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let R=class{constructor(b,h){this.productService=b,this.logService=h,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(b,h){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const w=/^(.*)#([^#]+)$/.exec(h);if(!w)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",h),!1;const[,E,C]=w;let p=this.trustedExtensionUrlPublicKeys.get(b);if(!p){if(p=this.productService.trustedExtensionUrlPublicKeys[b],!p||p.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",b),!1;this.trustedExtensionUrlPublicKeys.set(b,[...p])}const g=Buffer.from(decodeURIComponent(C),"base64");if(g.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",h),!1;const d=g.slice(0,6),P=g.readUIntBE(0,6),y=Date.now()-P;if(y<0||y>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",h),!1;const m=g.slice(6),v=S.createVerify("SHA256");v.write(d),v.write(Buffer.from(E)),v.end();for(let f=0;f<p.length;f++){let u=p[f];if(u!==null){if(typeof u=="string")try{u=S.createPublicKey({key:Buffer.from(u,"base64"),format:"der",type:"spki"}),p[f]=u}catch(c){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${f+1} for ${b}:`,c),p[f]=null;continue}if(v.verify(u,m))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",h),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",h),!1}};R=ge([ee(0,M.IProductService),ee(1,t.ILogService)],R),e.ExtensionUrlTrustService=R}),define(X[59],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,S.createDecorator)("protocolMainService")}),define(X[44],J([0,1,116,11]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class M{constructor(){this.data=new Map}add(D,b){S.ok(t.isString(D)),S.ok(t.isObject(b)),S.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,b)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new M}),define(X[201],J([0,1,3,44]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function M(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class R{constructor(){this._onDidChangeSchema=new S.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(h,w){this.schemasById[M(h)]=w,this._onDidChangeSchema.fire(h)}notifySchemaChanged(h){this._onDidChangeSchema.fire(h)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new R;t.Registry.add(e.Extensions.JSONContribution,D)}),define(X[60],J([0,1,25,3,11,144,18,201,44]),function(z,e,S,t,M,R,D,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var w;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(w=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var E;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const C=h.Registry.as(b.Extensions.JSONContribution);class p{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(o,r=!0){this.registerConfigurations([o],r)}registerConfigurations(o,r=!0){const i=this.doRegisterConfigurations(o,r);C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(o){const r=this.doDeregisterConfigurations(o);C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:o,remove:r}){const i=[];i.push(...this.doDeregisterConfigurations(r)),i.push(...this.doRegisterConfigurations(o,!1)),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,S.distinct)(i)})}registerDefaultConfigurations(o){const r=[],i=[];for(const{overrides:n,source:s}of o)for(const a in n)if(r.push(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const l=this.configurationDefaultsOverrides.get(a),I=l?.valuesSources??new Map;if(s)for(const F of Object.keys(n[a]))I.set(F,s);const k={...l?.value||{},...n[a]};this.configurationDefaultsOverrides.set(a,{source:s,value:k,valuesSources:I});const A=(0,D.getLanguageTagSettingPlainKey)(a),W={type:"object",default:k,description:R.localize(1,null,A),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:k,source:M.isString(s)?void 0:s,defaultValueSource:s};i.push(...P(a)),this.configurationProperties[a]=W,this.defaultLanguageConfigurationOverridesNode.properties[a]=W}else{this.configurationDefaultsOverrides.set(a,{value:n[a],source:s});const l=this.configurationProperties[a];l&&(this.updatePropertyDefaultValue(a,l),this.updateSchema(a,l))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(o){const r=[];for(const{overrides:i,source:n}of o)for(const s in i){const a=this.configurationDefaultsOverrides.get(s),l=M.isString(n)?n:n?.id,I=M.isString(a?.source)?a?.source:a?.source?.id;if(l===I)if(r.push(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const k=this.configurationProperties[s];k&&(this.updatePropertyDefaultValue(s,k),this.updateSchema(s,k))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...o){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(o){for(const r of o)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(o,r){const i=[];return o.forEach(n=>{i.push(...this.validateAndRegisterProperties(n,r,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),i}doDeregisterConfigurations(o){const r=[],i=n=>{if(n.properties)for(const s in n.properties){r.push(s);const a=this.configurationProperties[s];a?.policy?.name&&this.policyConfigurations.delete(a.policy.name),delete this.configurationProperties[s],this.removeFromSchema(s,n.properties[s])}n.allOf?.forEach(s=>i(s))};for(const n of o){i(n);const s=this.configurationContributors.indexOf(n);s!==-1&&this.configurationContributors.splice(s,1)}return r}validateAndRegisterProperties(o,r=!0,i,n,s=3){s=M.isUndefinedOrNull(o.scope)?s:o.scope;const a=[],l=o.properties;if(l)for(const k in l){const A=l[k];if(r&&f(k,A)){delete l[k];continue}if(A.source=i,A.defaultDefaultValue=l[k].default,this.updatePropertyDefaultValue(k,A),e.OVERRIDE_PROPERTY_REGEX.test(k)?A.scope=void 0:(A.scope=M.isUndefinedOrNull(A.scope)?s:A.scope,A.restricted=M.isUndefinedOrNull(A.restricted)?!!n?.includes(k):A.restricted),l[k].hasOwnProperty("included")&&!l[k].included){this.excludedConfigurationProperties[k]=l[k],delete l[k];continue}else this.configurationProperties[k]=l[k],l[k].policy?.name&&this.policyConfigurations.set(l[k].policy.name,k);!l[k].deprecationMessage&&l[k].markdownDeprecationMessage&&(l[k].deprecationMessage=l[k].markdownDeprecationMessage),a.push(k)}const I=o.allOf;if(I)for(const k of I)a.push(...this.validateAndRegisterProperties(k,r,i,n,s));return a}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(o){const r=i=>{const n=i.properties;if(n)for(const a in n)this.updateSchema(a,n[a]);i.allOf?.forEach(r)};r(o)}updateSchema(o,r){switch(e.allSettings.properties[o]=r,r.scope){case 1:e.applicationSettings.properties[o]=r;break;case 2:e.machineSettings.properties[o]=r;break;case 6:e.machineOverridableSettings.properties[o]=r;break;case 3:e.windowSettings.properties[o]=r;break;case 4:e.resourceSettings.properties[o]=r;break;case 5:e.resourceSettings.properties[o]=r,this.resourceLanguageSettingsSchema.properties[o]=r;break}}removeFromSchema(o,r){switch(delete e.allSettings.properties[o],r.scope){case 1:delete e.applicationSettings.properties[o];break;case 2:delete e.machineSettings.properties[o];break;case 6:delete e.machineOverridableSettings.properties[o];break;case 3:delete e.windowSettings.properties[o];break;case 4:case 5:delete e.resourceSettings.properties[o],delete this.resourceLanguageSettingsSchema.properties[o];break}}updateOverridePropertyPatternKey(){for(const o of this.overrideIdentifiers.values()){const r=`[${o}]`,i={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,i),e.allSettings.properties[r]=i,e.applicationSettings.properties[r]=i,e.machineSettings.properties[r]=i,e.machineOverridableSettings.properties[r]=i,e.windowSettings.properties[r]=i,e.resourceSettings.properties[r]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const o={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(o,r){const i=this.configurationDefaultsOverrides.get(o);let n=i?.value,s=i?.source;M.isUndefined(n)&&(n=r.defaultDefaultValue,s=void 0),M.isUndefined(n)&&(n=m(r.type)),r.default=n,r.defaultValueSource=s}}const g="\\[([^\\]]+)\\]",d=new RegExp(g,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${g})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function P(c){const o=[];if(e.OVERRIDE_PROPERTY_REGEX.test(c)){let r=d.exec(c);for(;r?.length;){const i=r[1].trim();i&&o.push(i),r=d.exec(c)}}return(0,S.distinct)(o)}e.overrideIdentifiersFromKey=P;function y(c){return c.reduce((o,r)=>`${o}[${r}]`,"")}e.keyFromOverrideIdentifiers=y;function m(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const v=new p;h.Registry.add(e.Extensions.Configuration,v);function f(c,o){return c.trim()?e.OVERRIDE_PROPERTY_REGEX.test(c)?R.localize(7,null,c):v.getConfigurationProperties()[c]!==void 0?R.localize(8,null,c):o.policy?.name&&v.getPolicyConfigurations().get(o.policy?.name)!==void 0?R.localize(9,null,c,o.policy?.name,v.getPolicyConfigurations().get(o.policy?.name)):null:R.localize(6,null)}e.validateProperty=f;function u(){const c=[],o=v.getConfigurationProperties();for(const r of Object.keys(o))c.push([r,o[r].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=u}),define(X[105],J([0,1,25,3,48,2,33,51,11,7,18,60,44]),function(z,e,S,t,M,R,D,b,h,w,E,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class g{constructor(r={},i=[],n=[]){this._contents=r,this._keys=i,this._overrides=n,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(r){return r?(0,E.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,i){const n=this.getContentsForOverrideIdentifer(i);return n?r?(0,E.getConfigurationValue)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const n of this.overrides)n.identifiers.includes(r)&&i.push(...n.keys);return S.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return S.distinct(r)}override(r){let i=this.overrideConfigurations.get(r);return i||(i=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,i)),i}merge(...r){const i=b.deepClone(this.contents),n=b.deepClone(this.overrides),s=[...this.keys];for(const a of r)if(!a.isEmpty()){this.mergeContents(i,a.contents);for(const l of a.overrides){const[I]=n.filter(k=>S.equals(k.identifiers,l.identifiers));I?(this.mergeContents(I.contents,l.contents),I.keys.push(...l.keys),I.keys=S.distinct(I.keys)):n.push(b.deepClone(l))}for(const l of a.keys)s.indexOf(l)===-1&&s.push(l)}return new g(i,s,n)}freeze(){return this.frozen=!0,this}clone(){return new g(b.deepClone(this.contents),[...this.keys],b.deepClone(this.overrides))}createOverrideConfigurationModel(r){const i=this.getContentsForOverrideIdentifer(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const s of S.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[s];const l=i[s];l&&(typeof a=="object"&&typeof l=="object"?(a=b.deepClone(a),this.mergeContents(a,l)):a=l),n[s]=a}return new g(n,this.keys,this.overrides)}mergeContents(r,i){for(const n of Object.keys(i)){if(n in r&&h.isObject(r[n])&&h.isObject(i[n])){this.mergeContents(r[n],i[n]);continue}r[n]=b.deepClone(i[n])}}checkAndFreeze(r){return this.frozen&&!Object.isFrozen(r)?b.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let i=null,n=null;const s=a=>{a&&(n?this.mergeContents(n,a):n=b.deepClone(a))};for(const a of this.overrides)S.equals(a.identifiers,[r])?i=a.contents:a.identifiers.includes(r)&&s(a.contents);return s(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,i){this.addKey(r),(0,E.addToValueTree)(this.contents,r,i,n=>{throw new Error(n)})}removeValue(r){this.removeKey(r)&&(0,E.removeFromValueTree)(this.contents,r)}addKey(r){let i=this.keys.length;for(let n=0;n<i;n++)r.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,r)}removeKey(r){const i=this.keys.indexOf(r);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=g;class d{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,i){if(!h.isUndefinedOrNull(r)){const n=this.doParseContent(r);this.parseRaw(n,i)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,i){this._raw=r;const{contents:n,keys:s,overrides:a,restricted:l}=this.doParseRaw(r,i);this._configurationModel=new g(n,s,a),this._restrictedConfigurations=l||[]}doParseContent(r){let i={},n=null,s=[];const a=[],l=[];function I(A){Array.isArray(s)?s.push(A):n!==null&&(s[n]=A)}const k={onObjectBegin:()=>{const A={};I(A),a.push(s),s=A,n=null},onObjectProperty:A=>{n=A},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const A=[];I(A),a.push(s),s=A,n=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:I,onError:(A,W,F)=>{l.push({error:A,offset:W,length:F})}};if(r)try{M.visit(r,k),i=s[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return i}doParseRaw(r,i){const n=p.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),s=this.filter(r,n,!0,i);r=s.raw;const a=(0,E.toValuesTree)(r,k=>console.error(`Conflict in settings file ${this._name}: ${k}`)),l=Object.keys(r),I=this.toOverrides(r,k=>console.error(`Conflict in settings file ${this._name}: ${k}`));return{contents:a,keys:l,overrides:I,restricted:s.restricted}}filter(r,i,n,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:r,restricted:[]};const a={},l=[];for(const I in r)if(C.OVERRIDE_PROPERTY_REGEX.test(I)&&n){const k=this.filter(r[I],i,!1,s);a[I]=k.raw,l.push(...k.restricted)}else{const k=i[I],A=k?typeof k.scope!="undefined"?k.scope:3:void 0;k?.restricted&&l.push(I),(A===void 0||s.scopes===void 0||s.scopes.includes(A))&&(s.skipRestricted&&k?.restricted||(a[I]=r[I]))}return{raw:a,restricted:l}}toOverrides(r,i){const n=[];for(const s of Object.keys(r))if(C.OVERRIDE_PROPERTY_REGEX.test(s)){const a={};for(const l in r[s])a[l]=r[s][l];n.push({identifiers:(0,C.overrideIdentifiersFromKey)(s),keys:Object.keys(a),contents:(0,E.toValuesTree)(a,i)})}return n}}e.ConfigurationModelParser=d;class P extends R.Disposable{constructor(r,i,n,s){super();this.userSettingsResource=r,this.scopes=i,this.fileService=s,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&n.isEqual(a.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new g}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=P;class y{constructor(r,i,n,s,a=new g,l=new g,I=new D.ResourceMap,k=new g,A=new D.ResourceMap,W=!0){this._defaultConfiguration=r,this._policyConfiguration=i,this._applicationConfiguration=n,this._localUserConfiguration=s,this._remoteUserConfiguration=a,this._workspaceConfiguration=l,this._folderConfigurations=I,this._memoryConfiguration=k,this._memoryConfigurationByResource=A,this._freeze=W,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(r,i,n){return this.getConsolidatedConfigurationModel(r,i,n).getValue(r)}updateValue(r,i,n={}){let s;n.resource?(s=this._memoryConfigurationByResource.get(n.resource),s||(s=new g,this._memoryConfigurationByResource.set(n.resource,s))):s=this._memoryConfiguration,i===void 0?s.removeValue(r):s.setValue(r,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,i,n){const s=this.getConsolidatedConfigurationModel(r,i,n),a=this.getFolderConfigurationModelForResource(i.resource,n),l=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,I=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),k=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(r),A=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(r),W=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),F=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),K=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),ie=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,oe=a?i.overrideIdentifier?a.freeze().override(i.overrideIdentifier).getValue(r):a.freeze().getValue(r):void 0,ue=i.overrideIdentifier?l.override(i.overrideIdentifier).getValue(r):l.getValue(r),ne=s.getValue(r),ae=S.distinct(s.overrides.map(le=>le.identifiers).flat()).filter(le=>s.getOverrideValue(r,le)!==void 0);return{defaultValue:I,policyValue:k,applicationValue:A,userValue:W,userLocalValue:F,userRemoteValue:K,workspaceValue:ie,workspaceFolderValue:oe,memoryValue:ue,value:ne,default:I!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,policy:k!==void 0?{value:k}:void 0,application:A!==void 0?{value:A,override:i.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,user:W!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userLocal:F!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userRemote:K!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspace:ie!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspaceFolder:oe!==void 0?{value:a?.freeze().getValue(r),override:i.overrideIdentifier?a?.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,memory:ue!==void 0?{value:l.getValue(r),override:i.overrideIdentifier?l.getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ae.length?ae:void 0}}keys(r){const i=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateApplicationConfiguration(r){this._applicationConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,i){this._folderConfigurations.set(r,i),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const n=[];if(!i){const{added:s,updated:a,removed:l}=u(this._defaultConfiguration,r);i=[...s,...a,...l]}for(const s of i)for(const a of(0,C.overrideIdentifiersFromKey)(s)){const l=this._defaultConfiguration.getKeysForOverrideIdentifier(a),I=r.getKeysForOverrideIdentifier(a),k=[...I.filter(A=>l.indexOf(A)===-1),...l.filter(A=>I.indexOf(A)===-1),...l.filter(A=>!b.equals(this._defaultConfiguration.override(a).getValue(A),r.override(a).getValue(A)))];n.push([a,k])}return this.updateDefaultConfiguration(r),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:n,removed:s}=u(this._policyConfiguration,r),a=[...i,...n,...s];return a.length&&this.updatePolicyConfiguration(r),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:n,removed:s,overrides:a}=u(this.applicationConfiguration,r),l=[...i,...n,...s];return l.length&&this.updateApplicationConfiguration(r),{keys:l,overrides:a}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:n,removed:s,overrides:a}=u(this.localUserConfiguration,r),l=[...i,...n,...s];return l.length&&this.updateLocalUserConfiguration(r),{keys:l,overrides:a}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:n,removed:s,overrides:a}=u(this.remoteUserConfiguration,r),l=[...i,...n,...s];return l.length&&this.updateRemoteUserConfiguration(r),{keys:l,overrides:a}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:n,removed:s,overrides:a}=u(this.workspaceConfiguration,r),l=[...i,...n,...s];return l.length&&this.updateWorkspaceConfiguration(r),{keys:l,overrides:a}}compareAndUpdateFolderConfiguration(r,i){const n=this.folderConfigurations.get(r),{added:s,updated:a,removed:l,overrides:I}=u(n,i),k=[...s,...a,...l];return(k.length||!n)&&this.updateFolderConfiguration(r,i),{keys:k,overrides:I}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:s,removed:a,overrides:l}=u(i,void 0);return{keys:[...n,...s,...a],overrides:l}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,i,n){let s=this.getConsolidatedConfigurationModelForResource(i,n);return i.overrideIdentifier&&(s=s.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(s=s.merge(this._policyConfiguration)),s}getConsolidatedConfigurationModelForResource({resource:r},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&r){const s=i.getFolder(r);s&&(n=this.getFolderConsolidatedConfiguration(s.uri)||n);const a=this._memoryConfigurationByResource.get(r);a&&(n=n.merge(a))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let i=this._foldersConsolidatedConfigurations.get(r);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(r);s?(i=n.merge(s),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(r,i)):i=n}return i}getFolderConfigurationModelForResource(r,i){if(i&&r){const n=i.getFolder(r);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,i)=>{const{contents:n,overrides:s,keys:a}=this._folderConfigurations.get(i);return r.push([i,{contents:n,overrides:s,keys:a}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>r.add(i)),this.userConfiguration.freeze().keys.forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>r.add(n))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s))),[...i.values()]}static parse(r){const i=this.parseConfigurationModel(r.defaults),n=this.parseConfigurationModel(r.policy),s=this.parseConfigurationModel(r.application),a=this.parseConfigurationModel(r.user),l=this.parseConfigurationModel(r.workspace),I=r.folders.reduce((k,A)=>(k.set(w.URI.revive(A[0]),this.parseConfigurationModel(A[1])),k),new D.ResourceMap);return new y(i,n,s,a,new g,l,I,new g,new D.ResourceMap,!1)}static parseConfigurationModel(r){return new g(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=y;function m(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const r=new Set,i=new Map;for(const s of o)s.keys.forEach(a=>r.add(a)),s.overrides.forEach(([a,l])=>{const I=(0,D.getOrSet)(i,a,new Set);l.forEach(k=>I.add(k))});const n=[];return i.forEach((s,a)=>n.push([a,[...s.values()]])),{keys:[...r.values()],overrides:n}}e.mergeChanges=m;class v{constructor(r,i,n,s){this.change=r,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=s,this._previousConfiguration=void 0;const a=new Set;r.keys.forEach(I=>a.add(I)),r.overrides.forEach(([,I])=>I.forEach(k=>a.add(k))),this.affectedKeys=[...a.values()];const l=new g;this.affectedKeys.forEach(I=>l.setValue(I,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=y.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(i){const n=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(r,i,this.currentWorkspace);return!b.equals(n,s)}return!0}return!1}doesAffectedKeysTreeContains(r,i){let n=(0,E.toValuesTree)({[i]:!0},()=>{}),s;for(;typeof n=="object"&&(s=Object.keys(n)[0]);){if(r=r[s],!r)return!1;n=n[s]}return!0}}e.ConfigurationChangeEvent=v;class f extends v{constructor(r,i,n,s){super({keys:r.allKeys(),overrides:[]},void 0,r,i);this.source=n,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=f;function u(o,r){const{added:i,removed:n,updated:s}=c(r,o),a=[],l=o?.getAllOverrideIdentifiers()||[],I=r?.getAllOverrideIdentifiers()||[];if(r){const k=I.filter(A=>!l.includes(A));for(const A of k)a.push([A,r.getKeysForOverrideIdentifier(A)])}if(o){const k=l.filter(A=>!I.includes(A));for(const A of k)a.push([A,o.getKeysForOverrideIdentifier(A)])}if(r&&o){for(const k of l)if(I.includes(k)){const A=c({contents:o.getOverrideValue(void 0,k)||{},keys:o.getKeysForOverrideIdentifier(k)},{contents:r.getOverrideValue(void 0,k)||{},keys:r.getKeysForOverrideIdentifier(k)});a.push([k,[...A.added,...A.removed,...A.updated]])}}return{added:i,removed:n,updated:s,overrides:a}}function c(o,r){const i=o?r?o.keys.filter(a=>r.keys.indexOf(a)===-1):[...o.keys]:[],n=r?o?r.keys.filter(a=>o.keys.indexOf(a)===-1):[...r.keys]:[],s=[];if(o&&r){for(const a of r.keys)if(o.keys.indexOf(a)!==-1){const l=(0,E.getConfigurationValue)(r.contents,a),I=(0,E.getConfigurationValue)(o.contents,a);b.equals(l,I)||s.push(a)}}return{added:i,removed:n,updated:s}}}),define(X[202],J([0,1,25,3,2,51,11,18,105,60,6,37,44]),function(z,e,S,t,M,R,D,b,h,w,E,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class g extends M.Disposable{constructor(){super(...arguments);this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new d(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(p.Registry.as(w.Extensions.Configuration).onDidUpdateConfiguration(({properties:v,defaultsOverrides:f})=>this.onDidUpdateConfiguration(v,f))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(v,f){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:v})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=g;class d extends h.ConfigurationModel{constructor(v={}){const f=p.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(f),c=Object.create(null),o=[];for(const r in f){const i=v[r],n=i!==void 0?i:f[r].default;(0,b.addToValueTree)(c,r,n,s=>console.error(`Conflict in default settings: ${s}`))}for(const r of Object.keys(c))w.OVERRIDE_PROPERTY_REGEX.test(r)&&o.push({identifiers:(0,w.overrideIdentifiersFromKey)(r),keys:Object.keys(c[r]),contents:(0,b.toValuesTree)(c[r],i=>console.error(`Conflict in default settings file: ${i}`))});super(c,u,o)}}e.DefaultConfigurationModel=d;class P{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new h.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=P;let y=class extends M.Disposable{constructor(v,f,u){super();this.defaultConfiguration=v,this.policyService=f,this.logService=u,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new h.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(v=>this.onDidChangePolicies(v))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:v})=>this.update(await this.registerPolicyDefinitions(v),!0))),this._configurationModel}async registerPolicyDefinitions(v){const f={},u=[],c=p.Registry.as(w.Extensions.Configuration).getConfigurationProperties();for(const o of v){const r=c[o];if(!r){u.push(o);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.logService.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}u.push(o),f[r.policy.name]={type:r.type}}}return(0,D.isEmptyObject)(f)||await this.policyService.registerPolicyDefinitions(f),u}onDidChangePolicies(v){const f=p.Registry.as(w.Extensions.Configuration).getPolicyConfigurations(),u=(0,S.coalesce)(v.map(c=>f.get(c)));this.update(u,!0)}update(v,f){const u=p.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),c=[],o=this._configurationModel.isEmpty();for(const r of v){const i=u[r]?.policy?.name;if(i){const n=this.policyService.getPolicyValue(i);(o?n!==void 0:!(0,R.equals)(this._configurationModel.getValue(r),n))&&c.push([r,n])}else this._configurationModel.getValue(r)!==void 0&&c.push([r,void 0])}if(c.length){const r=this._configurationModel;this._configurationModel=new h.ConfigurationModel;for(const i of r.keys)this._configurationModel.setValue(i,r.getValue(i));for(const[i,n]of c)n===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,n);f&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};y=ge([ee(1,C.IPolicyService),ee(2,E.ILogService)],y),e.PolicyConfiguration=y}),define(X[203],J([0,1,8,3,2,16,18,105,202,37]),function(z,e,S,t,M,R,D,b,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class E extends M.Disposable{constructor(p,g,d,P){super();this.settingsResource=p,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new h.DefaultConfiguration),this.policyConfiguration=d instanceof w.NullPolicyService?new h.NullPolicyConfiguration:this._register(new h.PolicyConfiguration(this.defaultConfiguration,d,P)),this.userConfiguration=this._register(new b.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,g)),this.configuration=new b.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new b.ConfigurationModel,new b.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new S.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:y,properties:m})=>this.onDidDefaultConfigurationChange(y,m))),this._register(this.policyConfiguration.onDidChangeConfiguration(y=>this.onDidPolicyConfigurationChange(y))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[p,g,d]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new b.Configuration(p,g,new b.ConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(p,g){const d=typeof p=="string"?p:void 0,P=(0,D.isConfigurationOverrides)(p)?p:(0,D.isConfigurationOverrides)(g)?g:{};return this.configuration.getValue(d,P,void 0)}updateValue(p,g,d,P){return Promise.reject(new Error("not supported"))}inspect(p){return this.configuration.inspect(p,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const p=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(p)}onDidChangeUserConfiguration(p){const g=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(p);this.trigger(d,g,2)}onDidDefaultConfigurationChange(p,g){const d=this.configuration.toData(),P=this.configuration.compareAndUpdateDefaultConfiguration(p,g);this.trigger(P,d,7)}onDidPolicyConfigurationChange(p){const g=this.configuration.toData(),d=this.configuration.compareAndUpdatePolicyConfiguration(p);this.trigger(d,g,7)}trigger(p,g,d){const P=new b.ConfigurationChangeEvent(p,{data:g},this.configuration);P.source=d,P.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(P)}getTargetConfiguration(p){switch(p){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=E}),define(X[204],J([0,1,19,5]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var M;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(M=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends S.ErrorNoTelemetry{constructor(b,h=M.Unknown,w){super(b);this._message=b,this._code=h,this._detail=w,this.isHandled=h===M.NotAvailable&&w===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}static isTemporarilyNotAvailable(b){return b instanceof R&&b._code===M.TemporarilyNotAvailable}static isNoResolverFound(b){return b instanceof R&&b._code===M.NoResolverFound}static isHandled(b){return b instanceof R&&b.isHandled}}e.RemoteAuthorityResolverError=R}),define(X[71],J([0,1,13]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(w){return w.scheme===S.Schemas.vscodeRemote?w.authority:void 0}e.getRemoteAuthority=t;function M(w){if(!w)return;const E=w.indexOf("+");return E<0?w:w.substr(0,E)}e.getRemoteName=M;function R(w){return`/${w.quality??"oss"}-${w.commit??"dev"}`}e.getRemoteServerRootPath=R;function D(w){const{host:E,port:C}=h(w);if(typeof C=="undefined")throw new Error("Remote authority doesn't contain a port!");return{host:E,port:C}}e.parseAuthorityWithPort=D;function b(w,E){let{host:C,port:p}=h(w);return typeof p=="undefined"&&(p=E),{host:C,port:p}}e.parseAuthorityWithOptionalPort=b;function h(w){const E=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const C=w.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const p=w.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:w,port:void 0}}}),define(X[205],J([0,1,8,17,21,19,3,2,27,95,204,71]),function(z,e,S,t,M,R,D,b,h,w,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const p=30*1e3;var g;(function($){$[$.Management=1]="Management",$[$.ExtensionHost=2]="ExtensionHost",$[$.Tunnel=3]="Tunnel"})(g=e.ConnectionType||(e.ConnectionType={}));function d($){switch($){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function P($){const j=new M.CancellationTokenSource;return setTimeout(()=>j.cancel(),$),j.token}function y($,j){if($.isCancellationRequested||j.isCancellationRequested)return M.CancellationToken.Cancelled;const L=new M.CancellationTokenSource;return $.onCancellationRequested(()=>L.cancel()),j.onCancellationRequested(()=>L.cancel()),L.token}class m{constructor(j){this._state="pending",this._disposables=new b.DisposableStore,this.promise=new Promise((L,T)=>{this._resolvePromise=L,this._rejectPromise=T}),j.isCancellationRequested?this._timeout():this._disposables.add(j.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(j){this._state==="pending"?this._disposables.add(j):j.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const j=new Error("Time limit reached");return j.code="ETIMEDOUT",j.syscall="connect",j}resolve(j){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(j))}reject(j){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(j))}}function v($,j){const L=new m(j);return L.registerDisposable($.onControlMessage(T=>{const _=JSON.parse(T.toString()),q=B(_);q?L.reject(q):L.resolve(_)})),L.promise}function f($,j,L,T,_,q,Q,te){const U=new m(te);return j.connect(L,T,_,q,Q,(Y,x)=>{U.didTimeout?(Y&&$.error(Y),x?.dispose()):Y||!x?U.reject(Y):U.resolve(x)}),U.promise}function u($,j){const L=new m(j);return $.then(T=>{L.didTimeout||L.resolve(T)},T=>{L.didTimeout||L.reject(T)}),L.promise}async function c($,j,L,T){const _=H($,j);$.logService.trace(`${_} 1/6. invoking socketFactory.connect().`);let q;try{q=await f($.logService,$.socketFactory,$.host,$.port,(0,C.getRemoteServerRootPath)($),`reconnectionToken=${$.reconnectionToken}&reconnection=${$.reconnectionProtocol?"true":"false"}`,`renderer-${d(j)}-${$.reconnectionToken}`,T)}catch(x){throw $.logService.error(`${_} socketFactory.connect() failed or timed out. Error:`),$.logService.error(x),x}$.logService.trace(`${_} 2/6. socketFactory.connect() was successful.`);let Q,te;$.reconnectionProtocol?($.reconnectionProtocol.beginAcceptReconnection(q,null),Q=$.reconnectionProtocol,te=!1):(Q=new w.PersistentProtocol(q,null),te=!0),$.logService.trace(`${_} 3/6. sending AuthRequest control message.`);const U=await u($.signService.createNewMessage((0,h.generateUuid)()),T),Y={type:"auth",auth:$.connectionToken||"00000000000000000000",data:U.data};Q.sendControl(t.VSBuffer.fromString(JSON.stringify(Y)));try{const x=await v(Q,y(T,P(1e4)));if(x.type!=="sign"||typeof x.data!="string"){const Ce=new Error("Unexpected handshake message");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}if($.logService.trace(`${_} 4/6. received SignRequest control message.`),!await u($.signService.validate(U,x.signedData),T)){const Ce=new Error("Refused to connect to unsupported server");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}const ce=await u($.signService.sign(x.data),T),Ee={type:"connectionType",commit:$.commit,signedData:ce,desiredConnectionType:j};return L&&(Ee.args=L),$.logService.trace(`${_} 5/6. sending ConnectionTypeRequest control message.`),Q.sendControl(t.VSBuffer.fromString(JSON.stringify(Ee))),{protocol:Q,ownsProtocol:te}}catch(x){throw x&&x.code==="ETIMEDOUT"&&($.logService.error(`${_} the handshake timed out. Error:`),$.logService.error(x)),x&&x.code==="VSCODE_CONNECTION_ERROR"&&($.logService.error(`${_} received error control message when negotiating connection. Error:`),$.logService.error(x)),te&&G(Q),x}}async function o($,j,L,T){const _=Date.now(),q=H($,j),{protocol:Q,ownsProtocol:te}=await c($,j,L,T),U=new m(T);return U.registerDisposable(Q.onControlMessage(Y=>{const x=JSON.parse(Y.toString()),re=B(x);re?($.logService.error(`${q} received error control message when negotiating connection. Error:`),$.logService.error(re),te&&G(Q),U.reject(re)):($.reconnectionProtocol?.endAcceptReconnection(),$.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${Z(_)}!`),U.resolve({protocol:Q,firstMessage:x}))})),U.promise}async function r($,j){const{protocol:L}=await o($,1,void 0,j);return{protocol:L}}async function i($,j,L){const{protocol:T,firstMessage:_}=await o($,2,j,L),q=_&&_.debugPort;return{protocol:T,debugPort:q}}async function n($,j,L){const T=Date.now(),_=H($,3),{protocol:q}=await c($,3,j,L);return $.logService.trace(`${_} 6/6. handshake finished, connection is up and running after ${Z(T)}!`),q}async function s($,j,L){const{host:T,port:_,connectionToken:q}=await $.addressProvider.getAddress();return{commit:$.commit,quality:$.quality,host:T,port:_,connectionToken:q,reconnectionToken:j,reconnectionProtocol:L,socketFactory:$.socketFactory,signService:$.signService,logService:$.logService}}async function a($,j,L){return I($,async T=>{const{protocol:_}=await r(T,M.CancellationToken.None);return new ae($,j,L,T.reconnectionToken,_)})}e.connectRemoteAgentManagement=a;async function l($,j){return I($,async L=>{const{protocol:T,debugPort:_}=await i(L,j,M.CancellationToken.None);return new le($,j,L.reconnectionToken,T,_)})}e.connectRemoteAgentExtensionHost=l;async function I($,j){const L=5;for(let T=1;;T++)try{const _=(0,h.generateUuid)(),q=await s($,_,null);return await j(q)}catch(_){if(T<L)$.logService.error(`[remote-connection][attempt ${T}] An error occurred in initial connection! Will retry... Error:`),$.logService.error(_);else throw $.logService.error(`[remote-connection][attempt ${T}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),$.logService.error(_),ne.triggerPermanentFailure(0,0,E.RemoteAuthorityResolverError.isHandled(_)),_}}async function k($,j,L){const T=await s($,(0,h.generateUuid)(),null);return await n(T,{host:j,port:L},M.CancellationToken.None)}e.connectRemoteAgentTunnel=k;function A($){return(0,S.createCancelablePromise)(j=>new Promise((L,T)=>{const _=setTimeout(L,$*1e3);j.onCancellationRequested(()=>{clearTimeout(_),L()})}))}var W;(function($){$[$.ConnectionLost=0]="ConnectionLost",$[$.ReconnectionWait=1]="ReconnectionWait",$[$.ReconnectionRunning=2]="ReconnectionRunning",$[$.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",$[$.ConnectionGain=4]="ConnectionGain"})(W=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class F{constructor(j,L){this.reconnectionToken=j,this.millisSinceLastIncomingData=L,this.type=0}}e.ConnectionLostEvent=F;class K{constructor(j,L,T,_){this.reconnectionToken=j,this.millisSinceLastIncomingData=L,this.durationSeconds=T,this.cancellableTimer=_,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=K;class ie{constructor(j,L,T){this.reconnectionToken=j,this.millisSinceLastIncomingData=L,this.attempt=T,this.type=2}}e.ReconnectionRunningEvent=ie;class oe{constructor(j,L,T){this.reconnectionToken=j,this.millisSinceLastIncomingData=L,this.attempt=T,this.type=4}}e.ConnectionGainEvent=oe;class ue{constructor(j,L,T,_){this.reconnectionToken=j,this.millisSinceLastIncomingData=L,this.attempt=T,this.handled=_,this.type=3}}e.ReconnectionPermanentFailureEvent=ue;class ne extends b.Disposable{constructor(j,L,T,_,q){super();this._connectionType=j,this._options=L,this.reconnectionToken=T,this.protocol=_,this._reconnectionFailureIsFatal=q,this._onDidStateChange=this._register(new D.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new oe(this.reconnectionToken,0,0)),this._register(_.onSocketClose(Q=>{const te=O(this._connectionType,this.reconnectionToken,!0);Q?Q.type===0?(this._options.logService.info(`${te} received socket close event (hadError: ${Q.hadError}).`),Q.error&&this._options.logService.error(Q.error)):(this._options.logService.info(`${te} received socket close event (wasClean: ${Q.wasClean}, code: ${Q.code}, reason: ${Q.reason}).`),Q.event&&this._options.logService.error(Q.event)):this._options.logService.info(`${te} received socket close event.`),this._beginReconnecting()})),this._register(_.onSocketTimeout(Q=>{const te=O(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${te} received socket timeout event (unacknowledgedMsgCount: ${Q.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Q.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Q.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),ne._instances.push(this),this._register((0,b.toDisposable)(()=>{const Q=ne._instances.indexOf(this);Q>=0&&ne._instances.splice(Q,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(ne._permanentFailureMillisSinceLastIncomingData,ne._permanentFailureAttempt,ne._permanentFailureHandled)}static triggerPermanentFailure(j,L,T){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=j,this._permanentFailureAttempt=L,this._permanentFailureHandled=T,this._instances.forEach(_=>_._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(j=>j._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(j=>j._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||ne._permanentFailure}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const j=O(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${j} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const L=[0,5,5,10,10,10,10,10,30];let T=-1;do{T++;const _=T<L.length?L[T]:L[L.length-1];try{if(_>0){const Q=A(_);this._onDidStateChange.fire(new K(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_,Q)),this._options.logService.info(`${j} waiting for ${_} seconds before reconnecting...`);try{await Q}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${j} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new ie(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),T+1)),this._options.logService.info(`${j} resolving connection...`);const q=await s(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${j} connecting to ${q.host}:${q.port}...`),await this._reconnect(q,P(p)),this._options.logService.info(`${j} reconnected!`),this._onDidStateChange.fire(new oe(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),T+1));break}catch(q){if(q.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${j} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(q),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),T+1,!1);break}if(T>360){this._options.logService.error(`${j} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(q),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),T+1,!1);break}if(E.RemoteAuthorityResolverError.isTemporarilyNotAvailable(q)){this._options.logService.info(`${j} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(q);continue}if((q.code==="ETIMEDOUT"||q.code==="ENETUNREACH"||q.code==="ECONNREFUSED"||q.code==="ECONNRESET")&&q.syscall==="connect"){this._options.logService.info(`${j} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(q);continue}if((0,R.isCancellationError)(q)){this._options.logService.info(`${j} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(q);continue}if(q instanceof E.RemoteAuthorityResolverError){this._options.logService.error(`${j} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(q),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),T+1,E.RemoteAuthorityResolverError.isHandled(q));break}this._options.logService.error(`${j} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(q),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),T+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(j,L,T){this._reconnectionFailureIsFatal?ne.triggerPermanentFailure(j,L,T):this._gotoPermanentFailure(j,L,T)}_gotoPermanentFailure(j,L,T){this._onDidStateChange.fire(new ue(this.reconnectionToken,j,L,T)),G(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=ne,ne._permanentFailure=!1,ne._permanentFailureMillisSinceLastIncomingData=0,ne._permanentFailureAttempt=0,ne._permanentFailureHandled=!1,ne._instances=[];class ae extends ne{constructor(j,L,T,_,q){super(1,j,_,q,!0);this.client=this._register(new w.Client(q,{remoteAuthority:L,clientId:T},j.ipcLogger))}async _reconnect(j,L){await r(j,L)}}e.ManagementPersistentConnection=ae;class le extends ne{constructor(j,L,T,_,q){super(2,j,T,_,!1);this._startArguments=L,this.debugPort=q}async _reconnect(j,L){await i(j,this._startArguments,L)}}e.ExtensionHostPersistentConnection=le;function G($){try{$.acceptDisconnect();const j=$.getSocket();$.dispose(),j.dispose()}catch(j){(0,R.onUnexpectedError)(j)}}function B($){if($&&$.type==="error"){const j=new Error(`Connection error: ${$.reason}`);return j.code="VSCODE_CONNECTION_ERROR",j}return null}function N($,j){for(;$.length<j;)$+=" ";return $}function O($,j,L){return`[remote-connection][${N(d($),13)}][${j.substr(0,5)}\u2026][${L?"reconnect":"initial"}]`}function H($,j){return`${O(j,$.reconnectionToken,!!$.reconnectionProtocol)}[${$.host}:${$.port}]`}function Z($){return`${Date.now()-$} ms`}}),define(X[206],J([0,1,76,82]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(M,R,D,b,h,w){const E=p=>w(p,void 0),C=S.createConnection({host:M,port:R},()=>{C.removeListener("error",E);const p=Buffer.alloc(16);for(let y=0;y<16;y++)p[y]=Math.round(Math.random()*256);const g=p.toString("base64"),d=[`GET ws://${/:/.test(M)?`[${M}]`:M}:${R}${D}?${b}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${g}`];C.write(d.join(`\r
`)+`\r
\r
`);const P=y=>{y.toString().indexOf(`\r
\r
`)>=0&&(C.off("data",P),w(void 0,new t.NodeSocket(C,h)))};C.on("data",P)});C.setNoDelay(!0),C.once("error",E)}}}),define(X[53],J([0,1,17,158,60,5,44]),function(z,e,S,t,M,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function b(P){return P.res.statusCode&&P.res.statusCode>=200&&P.res.statusCode<300||P.res.statusCode===1223}e.isSuccess=b;function h(P){return P.res.statusCode===204}async function w(P){return h(P)?null:(await(0,S.streamToBuffer)(P.stream)).toString()}e.asText=w;async function E(P){if(!b(P))throw new Error("Server returned "+P.res.statusCode);return w(P)}e.asTextOrError=E;async function C(P){if(!b(P))throw new Error("Server returned "+P.res.statusCode);if(h(P))return null;const m=(await(0,S.streamToBuffer)(P.stream)).toString();try{return JSON.parse(m)}catch(v){throw v.message+=`:
`+m,v}}e.asJson=C;function p(P){d(P)}e.updateProxyConfigurationsScope=p;let g;function d(P){const y=D.Registry.as(M.Extensions.Configuration),m=g;g={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:P,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},y.updateConfigurations({add:[g],remove:m?[m]:[]})}d(2)}),define(X[207],J([0,1,17,21]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class M{constructor(b){this.service=b}listen(b,h){throw new Error("Invalid listen")}call(b,h,w,E=t.CancellationToken.None){switch(h){case"request":return this.service.request(w[0],E).then(async({res:C,stream:p})=>{const g=await(0,S.streamToBuffer)(p);return[{statusCode:C.statusCode,headers:C.headers},g]});case"resolveProxy":return this.service.resolveProxy(w[0])}throw new Error("Invalid call")}}e.RequestChannel=M;class R{constructor(b){this.channel=b}async request(b,h){const[w,E]=await this.channel.call("request",[b],h);return{res:w,stream:(0,S.bufferToStream)(E)}}async resolveProxy(b){return this.channel.call("resolveProxy",[b])}}e.RequestChannelClient=R}),define(X[208],J([0,1,209,11]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function M(D,b){return D.protocol==="http:"?b.HTTP_PROXY||b.http_proxy||null:D.protocol==="https:"&&(b.HTTPS_PROXY||b.https_proxy||b.HTTP_PROXY||b.http_proxy)||null}async function R(D,b,h={}){const w=(0,S.parse)(D),E=h.proxyUrl||M(w,b);if(!E)return null;const C=(0,S.parse)(E);if(!/^https?:$/.test(C.protocol||""))return null;const p={host:C.hostname||"",port:C.port||(C.protocol==="https"?"443":"80"),auth:C.auth,rejectUnauthorized:(0,t.isBoolean)(h.strictSSL)?h.strictSSL:!0};return w.protocol==="http:"?new(await new Promise((g,d)=>{z(["http-proxy-agent"],g,d)}))(p):new(await new Promise((g,d)=>{z(["https-proxy-agent"],g,d)}))(p)}e.getProxyAgent=R}),define(X[106],J([0,1,49,9,159,21,42,19,4,27,138,57,8]),function(z,e,S,t,M,R,D,b,h,w,E,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const g=1e4;let d;async function P(m,v,f){return v["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,C.isLaunchedFromCli)(f)&&!v["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,C.isLaunchedFromCli)(f)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=p.Promises.withAsyncBody(async(u,c)=>{const o=new R.CancellationTokenSource,r=setTimeout(()=>{o.dispose(!0),c(new Error((0,M.localize)(0,null)))},g);try{u(await y(m,o.token))}catch(i){!(0,b.isCancellationError)(i)&&!o.token.isCancellationRequested?c(new Error((0,M.localize)(1,null,(0,D.toErrorMessage)(i)))):u({})}finally{clearTimeout(r),o.dispose()}})),d)}e.getResolvedShellEnv=P;async function y(m,v){const f=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",f);const u=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",u);const c=(0,w.generateUuid)().replace(/-/g,"").substr(0,12),o=new RegExp(c+"(.*)"+c),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};m.trace("getUnixShellEnvironment#env",r);const i=await(0,E.getSystemShell)(h.OS,r);return m.trace("getUnixShellEnvironment#shell",i),new Promise((n,s)=>{if(v.isCancellationRequested)return s((0,b.canceled)());const a=(0,t.basename)(i);let l,I;const k=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(l=`& '${process.execPath}' ${k} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,I=["-Login","-Command"]):(l=`'${process.execPath}' ${k} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,a==="tcsh"?I=["-ic"]:I=["-ilc"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(I),l);const A=(0,S.spawn)(i,[...I,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});v.onCancellationRequested(()=>(A.kill(),s((0,b.canceled)()))),A.on("error",K=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(K)),s(K)});const W=[];A.stdout.on("data",K=>W.push(K));const F=[];A.stderr.on("data",K=>F.push(K)),A.on("close",(K,ie)=>{const oe=Buffer.concat(W).toString("utf8");m.trace("getUnixShellEnvironment#raw",oe);const ue=Buffer.concat(F).toString("utf8");if(ue.trim()&&m.trace("getUnixShellEnvironment#stderr",ue),K||ie)return s(new Error((0,M.localize)(2,null,K,ie)));const ne=o.exec(oe),ae=ne?ne[1]:"{}";try{const le=JSON.parse(ae);f?le.ELECTRON_RUN_AS_NODE=f:delete le.ELECTRON_RUN_AS_NODE,u?le.ELECTRON_NO_ATTACH_CONSOLE=u:delete le.ELECTRON_NO_ATTACH_CONSOLE,delete le.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",le),n(le)}catch(le){m.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(le)),s(le)}})})}}),define(X[86],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,S.createDecorator)(e.SIGN_SERVICE_ID)}),define(X[210],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class S{constructor(){this.validators=new Map}vsda(){return new Promise((M,R)=>z(["vsda"],M,R))}async createNewMessage(M){try{const R=await this.vsda(),D=new R.validator;if(D){const b=String(S._nextId++);return this.validators.set(b,D),{id:b,data:D.createNewMessage(M)}}}catch{}return{id:"",data:M}}async validate(M,R){if(!M.id)return!0;const D=this.validators.get(M.id);if(!D)return!1;this.validators.delete(M.id);try{return D.validate(R)==="ok"}catch{return!1}}async sign(M){try{const R=await this.vsda(),D=new R.signer;if(D)return D.sign(M)}catch{}return M}}e.SignService=S,S._nextId=1}),define(X[40],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,S.createDecorator)("stateMainService")}),define(X[22],J([0,1,14,38,8,3,2,4,36,11,5,6,40]),function(z,e,S,t,M,R,D,b,h,w,E,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,E.createDecorator)("lifecycleMainService");var g;(function(y){y[y.QUIT=1]="QUIT",y[y.KILL=2]="KILL"})(g=e.ShutdownReason||(e.ShutdownReason={}));var d;(function(y){y[y.Starting=1]="Starting",y[y.Ready=2]="Ready",y[y.AfterWindowOpen=3]="AfterWindowOpen"})(d=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let P=class yt extends D.Disposable{constructor(m,v){super();this.logService=m,this.stateMainService=v,this._onBeforeShutdown=this._register(new R.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new R.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new R.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new R.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(yt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(yt.QUIT_AND_RESTART_KEY)}registerListeners(){const m=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),b.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};S.app.addListener("before-quit",m);const v=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!b.isMacintosh)&&S.app.quit()};S.app.addListener("window-all-closed",v),S.app.once("will-quit",f=>{this.logService.trace("Lifecycle#app.on(will-quit)"),f.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.resolvePendingQuitPromise(!1),S.app.removeListener("before-quit",m),S.app.removeListener("window-all-closed",v),S.app.quit()})})}fireOnWillShutdown(m){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const v=[];return this._onWillShutdown.fire({reason:m,join(f){v.push(f)}}),this.pendingWillShutdownPromise=(async()=>{try{await M.Promises.settled(v)}catch(f){this.logService.error(f)}try{await this.stateMainService.close()}catch(f){this.logService.error(f)}})(),this.pendingWillShutdownPromise}set phase(m){if(m<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===m)return;this.logService.trace(`lifecycle (main): phase changed (value: ${m})`),this._phase=m;const v=this.phaseWhen.get(this._phase);v&&(v.open(),this.phaseWhen.delete(this._phase))}async when(m){if(m<=this._phase)return;let v=this.phaseWhen.get(m);v||(v=new M.Barrier,this.phaseWhen.set(m,v)),await v.wait()}registerWindow(m){const v=new D.DisposableStore;this.windowCounter++,v.add(m.onWillLoad(u=>this._onWillLoadWindow.fire({window:m,workspace:u.workspace,reason:u.reason})));const f=(0,w.assertIsDefined)(m.win);f.on("close",u=>{const c=m.id;if(this.windowToCloseRequest.has(c)){this.windowToCloseRequest.delete(c);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${m.id}`),u.preventDefault(),this.unload(m,1).then(o=>{if(o){this.windowToCloseRequest.delete(c);return}this.windowToCloseRequest.add(c),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${c}`),this._onBeforeCloseWindow.fire(m),m.close()})}),f.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${m.id}`),this.windowCounter--,v.dispose(),this.windowCounter===0&&(!b.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(m,v){await this.unload(m,3)||m.reload(v)}unload(m,v){const f=this.mapWindowIdToPendingUnload.get(m.id);if(f)return f;const u=this.doUnload(m,v).finally(()=>{this.mapWindowIdToPendingUnload.delete(m.id)});return this.mapWindowIdToPendingUnload.set(m.id,u),u}async doUnload(m,v){if(!m.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${m.id}`);const f=this._quitRequested?2:v,u=await this.onBeforeUnloadWindowInRenderer(m,f);return u?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${m.id})`),this.handleWindowUnloadVeto(u)):(await this.onWillUnloadWindowInRenderer(m,f),!1)}handleWindowUnloadVeto(m){return m?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(m){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(m),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(m,v){return new Promise(f=>{const u=this.oneTimeListenerTokenGenerator++,c=`vscode:ok${u}`,o=`vscode:cancel${u}`;t.validatedIpcMain.once(c,()=>{f(!1)}),t.validatedIpcMain.once(o,()=>{f(!0)}),m.send("vscode:onBeforeUnload",{okChannel:c,cancelChannel:o,reason:v})})}onWillUnloadWindowInRenderer(m,v){return new Promise(f=>{const c=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;t.validatedIpcMain.once(c,()=>f()),m.send("vscode:onWillUnload",{replyChannel:c,reason:v})})}quit(m){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${m}`),m&&this.stateMainService.setItem(yt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(v=>{this.pendingQuitPromiseResolve=v,this.logService.trace("Lifecycle#quit() - calling app.quit()"),S.app.quit()}),this.pendingQuitPromise)}async relaunch(m){this.logService.trace("Lifecycle#relaunch()");const v=process.argv.slice(1);if(m?.addArgs&&v.push(...m.addArgs),m?.removeArgs)for(const c of m.removeArgs){const o=v.indexOf(c);o>=0&&v.splice(o,1)}const f=()=>{try{if(b.isWindows){const c=(0,h.cwd)();c!==process.cwd()&&process.chdir(c)}}catch(c){this.logService.error(c)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),S.app.relaunch({args:v})};S.app.once("quit",f),await this.quit(!0)&&S.app.removeListener("quit",f)}async kill(m){this.logService.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,M.timeout)(1e3),(async()=>{for(const v of S.BrowserWindow.getAllWindows())if(v&&!v.isDestroyed()){let f;v.webContents&&!v.webContents.isDestroyed()?f=new Promise(u=>v.once("closed",u)):f=Promise.resolve(),v.destroy(),await f}})()]),S.app.exit(m)}};P.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",P=ge([ee(0,C.ILogService),ee(1,p.IStateMainService)],P),e.LifecycleMainService=P}),define(X[211],J([0,1,4,3,2,5,22]),function(z,e,S,t,M,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,R.createDecorator)("keyboardLayoutMainService");let b=class extends M.Disposable{constructor(E){super();this._onDidChangeKeyboardLayout=this._register(new t.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,E.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const E=await new Promise((C,p)=>{z(["native-keymap"],C,p)});this._keyboardLayoutData=h(E),S.isCI||E.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=h(E),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};b=ge([ee(0,D.ILifecycleMainService)],b),e.KeyboardLayoutMainService=b;function h(w){const E=w.getKeyMap(),C=w.getCurrentKeyboardLayout();return{keyboardMapping:E,keyboardLayoutInfo:C}}}),define(X[212],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,S.createDecorator)("stateService")}),define(X[213],J([0,1,8,17,11,39,15,6]),function(z,e,S,t,M,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class h{constructor(C,p,g){this.storagePath=C,this.logService=p,this.fileService=g,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new S.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(C){C.fileOperationResult!==1&&this.logService.error(C)}}getItem(C,p){const g=this.storage[C];return(0,M.isUndefinedOrNull)(g)?p:g}setItem(C,p){this.setItems([{key:C,data:p}])}setItems(C){let p=!1;for(const{key:g,data:d}of C)this.storage[g]!==d&&((0,M.isUndefinedOrNull)(d)?(0,M.isUndefined)(this.storage[g])||(this.storage[g]=void 0,p=!0):(this.storage[g]=d,p=!0));p&&this.save()}removeItem(C){(0,M.isUndefined)(this.storage[C])||(this.storage[C]=void 0,this.save())}async save(C){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),C)}async doSave(){if(!this.initializing)return;await this.initializing;const C=JSON.stringify(this.storage,null,4);if(C!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,t.VSBuffer.fromString(C)),this.lastSavedStorageContents=C}catch(p){this.logService.error(p)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=h;let w=class{constructor(C,p,g){this.fileStorage=new h(C.stateResource,p,g)}async init(){await this.fileStorage.init()}getItem(C,p){return this.fileStorage.getItem(C,p)}};w=ge([ee(0,R.IEnvironmentService),ee(1,b.ILogService),ee(2,D.IFileService)],w),e.StateService=w}),define(X[214],J([0,1,213]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class t extends S.StateService{setItem(R,D){this.fileStorage.setItem(R,D)}setItems(R){this.fileStorage.setItems(R)}removeItem(R){this.fileStorage.removeItem(R)}close(){return this.fileStorage.close()}}e.StateMainService=t}),define(X[107],J([0,1,4,36,7,27]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(w){if(S.platform===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}async function b(w,E,C,p,g,d,P,y,m,v){const f=Object.create(null);f["common.machineId"]=P,f.sessionID=(0,R.generateUuid)()+Date.now(),f.commitHash=g,f.version=d,f["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,S.PlatformToString)(S.platform),f["common.nodePlatform"]=t.platform,f["common.nodeArch"]=p,f["common.product"]=v||"desktop",y&&(f["common.msftInternal"]=y);let u=0;const c=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),S.isLinuxSnap&&(f["common.snap"]="true");const o=D(C);o&&(f["common.platformDetail"]=o);try{const r=await w.readFile(M.URI.file(m));f["common.source"]=r.value.toString().slice(0,30)}catch{}return f}e.resolveCommonProperties=b;function h(w){const E=t.env.USERDNSDOMAIN;if(!E)return!1;const C=E.toLowerCase();return w.some(p=>C===p)}e.verifyMicrosoftInternalDomain=h}),define(X[35],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,S.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,S.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var M;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(M=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(X[215],J([0,1,29,55,8,48,13,9,4,7,80,23,94,83,15,20,35]),function(z,e,S,t,M,R,D,b,h,w,E,C,p,g,d,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const m=new Map;async function v(r,i){const n=`${r}::${i.join(":")}`,s=m.get(n);if(s)return s;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,I=new Map,k=2e4;function A(F,K,ie,oe){const ue=K.substring(F.length+1);return M.Promises.withAsyncBody(async ne=>{let ae;try{ae=await C.Promises.readdir(K,{withFileTypes:!0})}catch{ne();return}if(oe.count>=k){oe.count+=ae.length,oe.maxReached=!0,ne();return}let le=ae.length;if(le===0){ne();return}let G=ae;oe.count+ae.length>k&&(oe.maxReached=!0,le=k-oe.count,G=ae.slice(0,le)),oe.count+=ae.length;for(const B of G)if(B.isDirectory()){if(ie.includes(B.name)||await A(F,(0,b.join)(K,B.name),ie,oe),--le==0){ne();return}}else{const N=B.name.lastIndexOf(".");if(N>=0){const O=B.name.substring(N+1);O&&l.set(O,(l.get(O)??0)+1)}for(const O of a)O.relativePathPattern?.test(ue)!==!1&&O.filePattern.test(B.name)&&I.set(O.tag,(I.get(O.tag)??0)+1);if(--le==0){ne();return}}})}const W=M.Promises.withAsyncBody(async F=>{const K={count:0,maxReached:!1};await A(r,r,i,K);const ie=await c(r);F({configFiles:f(I),fileTypes:f(l),fileCount:K.count,maxFilesReached:K.maxReached,launchConfigFiles:ie})});return m.set(n,W),W}e.collectWorkspaceStats=v;function f(r){return[...t.Iterable.map(r.entries(),([i,n])=>({name:i,count:n}))].sort((i,n)=>n.count-i.count)}function u(){const r={os:`${S.type()} ${S.arch()} ${S.release()}`,memory:`${(S.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(E.virtualMachineHint.value()*100)}%`},i=S.cpus();return i&&i.length>0&&(r.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),r}e.getMachineInfo=u;async function c(r){try{const i=new Map,n=(0,b.join)(r,".vscode","launch.json"),s=await C.Promises.readFile(n),a=[],l=(0,R.parse)(s.toString(),a);if(a.length)return console.log(`Unable to parse ${n}`),[];if((0,R.getNodeType)(l)==="object"&&l.configurations)for(const I of l.configurations){const k=I.type;k&&(i.has(k)?i.set(k,i.get(k)+1):i.set(k,1))}return f(i)}catch{return[]}}e.collectLaunchConfigs=c;let o=class{constructor(i,n){this.telemetryService=i,this.productService=n}formatMachineInfo(i){const n=[];return n.push(`OS Version:       ${i.os}`),n.push(`CPUs:             ${i.cpus}`),n.push(`Memory (System):  ${i.memory}`),n.push(`VM:               ${i.vmHint}`),n.join(`
`)}formatEnvironment(i){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${S.type()} ${S.arch()} ${S.release()}`);const s=S.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(S.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),h.isWindows||n.push(`Load (avg):       ${S.loadavg().map(a=>Math.round(a)).join(", ")}`),n.push(`VM:               ${Math.round(E.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${i.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(i,n){return Promise.all([(0,p.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async s=>{let[a,l]=s,I=this.formatProcessList(i,a);return n.forEach(k=>{if((0,g.isRemoteDiagnosticError)(k))I+=`
${k.errorMessage}`,l+=`
${k.errorMessage}`;else if(I+=`

Remote: ${k.hostName}`,k.processes&&(I+=`
${this.formatProcessList(i,k.processes)}`),k.workspaceMetadata){l+=`
|  Remote: ${k.hostName}`;for(const A of Object.keys(k.workspaceMetadata)){const W=k.workspaceMetadata[A];let F=`${W.fileCount} files`;W.maxFilesReached&&(F=`more than ${F}`),l+=`|    Folder (${A}): ${F}`,l+=this.formatWorkspaceStats(W)}}}),{processInfo:I,workspaceInfo:l}})}async getSystemInfo(i,n){const{memory:s,vmHint:a,os:l,cpus:I}=u(),k={os:l,memory:s,cpus:I,vmHint:a,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:n};return h.isWindows||(k.load=`${S.loadavg().map(A=>Math.round(A)).join(", ")}`),h.isLinux&&(k.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(k)}async getDiagnostics(i,n){const s=[];return(0,p.listProcesses)(i.mainPID).then(async a=>(s.push(""),s.push(this.formatEnvironment(i)),s.push(""),s.push(this.formatProcessList(i,a)),i.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(i))),n.forEach(l=>{if((0,g.isRemoteDiagnosticError)(l))s.push(`
${l.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${l.hostName}`),s.push(this.formatMachineInfo(l.machineInfo)),l.processes&&s.push(this.formatProcessList(i,l.processes)),l.workspaceMetadata)for(const I of Object.keys(l.workspaceMetadata)){const k=l.workspaceMetadata[I];let A=`${k.fileCount} files`;k.maxFilesReached&&(A=`more than ${A}`),s.push(`Folder (${I}): ${A}`),s.push(this.formatWorkspaceStats(k))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(i){const n=[],s=60;let a=0;const l=(W,F)=>{const K=` ${W}(${F})`;a+K.length>s?(n.push(I),I="|                 ",a=I.length):a+=K.length,I+=K};let I="|      File types:";const k=10,A=i.fileTypes.length>k?k:i.fileTypes.length;for(let W=0;W<A;W++){const F=i.fileTypes[W];l(F.name,F.count)}if(n.push(I),i.configFiles.length>=0&&(I="|      Conf files:",a=0,i.configFiles.forEach(W=>{l(W.name,W.count)}),n.push(I)),i.launchConfigFiles.length>0){let W="|      Launch Configs:";i.launchConfigFiles.forEach(F=>{W+=F.count>1?` ${F.name}(${F.count})`:` ${F.name}`}),n.push(W)}return n.join(`
`)}expandGPUFeatures(i){const n=Math.max(...Object.keys(i).map(s=>s.length));return Object.keys(i).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${i[s]}`).join(`
                  `)}formatWorkspaceMetadata(i){const n=[],s=[];return i.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(n.push(`|  Window (${a.title})`),a.folderURIs.forEach(l=>{const I=w.URI.revive(l);if(I.scheme===D.Schemas.file){const k=I.fsPath;s.push(v(k,["node_modules",".git"]).then(A=>{let W=`${A.fileCount} files`;A.maxFilesReached&&(W=`more than ${W}`),n.push(`|    Folder (${(0,b.basename)(k)}): ${W}`),n.push(this.formatWorkspaceStats(A))}).catch(A=>{n.push(`|      Error: Unable to collect workspace stats for folder ${k} (${A.toString()})`)}))}else n.push(`|    Folder (${I.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(a=>n.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(i,n){const s=new Map;i.windows.forEach(l=>s.set(l.pid,l.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(i.mainPID,s,a,n,0),a.join(`
`)}formatProcessItem(i,n,s,a,l){const I=l===0;let k;I?k=a.pid===i?`${this.productService.applicationName} main`:"remote agent":(k=`${"  ".repeat(l)} ${a.name}`,a.name==="window"&&(k=`${k} (${n.get(a.pid)})`));const A=process.platform==="win32"?a.mem:S.totalmem()*(a.mem/100);s.push(`${a.load.toFixed(0).padStart(5," ")}	${(A/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${k}`),Array.isArray(a.children)&&a.children.forEach(W=>this.formatProcessItem(i,n,s,W,l+1))}async getWorkspaceFileExtensions(i){const n=new Set;for(const{uri:s}of i.folders){const a=w.URI.revive(s);if(a.scheme!==D.Schemas.file)continue;const l=a.fsPath;try{(await v(l,["node_modules",".git"])).fileTypes.forEach(k=>n.add(k.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(i){for(const{uri:n}of i.folders){const s=w.URI.revive(n);if(s.scheme!==D.Schemas.file)continue;const a=s.fsPath;try{const l=await v(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),l.fileTypes.forEach(I=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:I.name,count:I.count})}),l.launchConfigFiles.forEach(I=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:I.name,count:I.count})}),l.configFiles.forEach(I=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:I.name,count:I.count})})}catch{}}}};o=ge([ee(0,y.ITelemetryService),ee(1,P.IProductService)],o),e.DiagnosticsService=o}),define(X[216],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class S{constructor(R){this.appenders=R}listen(R,D){throw new Error(`Event not found: ${D}`)}call(R,D,{eventName:b,data:h}){return this.appenders.forEach(w=>w.log(b,h)),Promise.resolve(null)}}e.TelemetryAppenderChannel=S;class t{constructor(R){this.channel=R}log(R,D){return this.channel.call("log",{eventName:R,data:D}).then(void 0,b=>`Failed to log telemetry: ${console.warn(b)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(X[72],J([0,1,51,91,11,18,107,35]),function(z,e,S,t,M,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class h{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(o,r){return Promise.resolve(void 0)}publicLog2(o,r){return this.publicLog(o,r)}publicLogError(o,r){return Promise.resolve(void 0)}publicLogError2(o,r){return this.publicLogError(o,r)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=h,e.NullTelemetryService=new h;class w{async publicLog(o,r,i){}async publicLogError(o,r,i){}}e.NullEndpointTelemetryService=w,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function E(c,o){return o.onDidChangeConfiguration(r=>{r.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(r.source),configurationKeys:m(r.sourceConfig)})})}e.configurationTelemetry=E;function C(c,o){return!(o.disableTelemetry||!c.enableTelemetry||o.extensionTestsLocationURI)}e.supportsTelemetry=C;function p(c){const o=c.getValue(b.TELEMETRY_SETTING_ID),r=c.getValue("telemetry.enableCrashReporter");if(c.getValue(b.TELEMETRY_OLD_SETTING_ID)===!1||r===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=p;function g(c){const o={},r={},i={};y(c,i);for(let n in i){n=n.length>150?n.substr(n.length-149):n;const s=i[n];typeof s=="number"?r[n]=s:typeof s=="boolean"?r[n]=s?1:0:typeof s=="string"?(s.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${s.length}`),o[n]=s.substring(0,8191)):typeof s!="undefined"&&s!==null&&(o[n]=s)}return{properties:o,measurements:r}}e.validateTelemetryData=g;const d=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function P(c){if(!c)return"none";for(const o of d)if(c.startsWith(`${o}+`))return o;return"other"}e.cleanRemoteAuthority=P;function y(c,o,r=0,i){if(!!c)for(const n of Object.getOwnPropertyNames(c)){const s=c[n],a=i?i+n:n;Array.isArray(s)?o[a]=(0,S.safeStringify)(s):s instanceof Date?o[a]=s.toISOString():(0,M.isObject)(s)?r<2?y(s,o,r+1,a+"."):o[a]=(0,S.safeStringify)(s):o[a]=s}}function m(c){if(!c)return[];const o=[];return v(o,"",c),o}function v(c,o,r){r&&typeof r=="object"&&!Array.isArray(r)?Object.keys(r).forEach(i=>v(c,o?`${o}.${i}`:i,r[i])):c.push(o)}function f(c,o){const r=c.msftInternalDomains||[],i=o.getValue("telemetry.internalTesting");return(0,D.verifyMicrosoftInternalDomain)(r)||i}e.isInternalTelemetry=f;function u(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.getPiiPathsFromEnvironment=u}),define(X[217],J([0,1,177,72]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function M(R,D,b,h,w,E,C){const p={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${D.nameShort})`},g=await(0,S.getServiceMachineId)(b,w,E),{sessionId:d}=await C.getTelemetryInfo();return(0,t.supportsTelemetry)(D,b)&&(0,t.getTelemetryLevel)(h)===3&&(p["X-Market-User-Id"]=g,p["VSCode-SessionId"]=d),p}e.resolveMarketplaceHeaders=M}),define(X[218],J([0,1,2,51,91,4,30,160,18,60,52,20,44,35,72]),function(z,e,S,t,M,R,D,b,h,w,E,C,p,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let P=class{constructor(v,f,u){this._configurationService=f,this._productService=u,this._experimentProperties={},this.telemetryLevel=new M.MutableObservableValue(3),this._disposables=new S.DisposableStore,this._cleanupPatterns=[],this._appenders=v.appenders,this._commonProperties=v.commonProperties||Promise.resolve({}),this._piiPaths=v.piiPaths||[],this._sendErrorTelemetry=!!v.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const c of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(c),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(v,f){this._experimentProperties[v]=f}_updateTelemetryLevel(){let v=(0,d.getTelemetryLevel)(this._configurationService);const f=this._productService.enabledTelemetryLevels;if(f){this._sendErrorTelemetry=this.sendErrorTelemetry?f.error:!1;const u=f.usage?3:f.error?2:0;v=Math.min(v,u)}this.telemetryLevel.value=v}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const v=await this._commonProperties,f=v.sessionID,u=v["common.machineId"],c=v["common.firstSessionDate"],o=v["common.msftInternal"];return{sessionId:f,machineId:u,firstSessionDate:c,msftInternal:o}}dispose(){this._disposables.dispose()}_log(v,f,u,c){return this.telemetryLevel.value<f?Promise.resolve(void 0):this._commonProperties.then(o=>{u=(0,t.mixin)(u,o),u=(0,t.mixin)(u,this._experimentProperties),u=(0,t.cloneAndChange)(u,r=>{if(typeof r=="string")return this._cleanupInfo(r,c)}),this._appenders.forEach(r=>r.log(v,u))},o=>{console.error(o)})}publicLog(v,f,u){return this._log(v,3,f,u)}publicLog2(v,f,u){return this.publicLog(v,f,u)}publicLogError(v,f){return this._sendErrorTelemetry?this._log(v,2,f,!0):Promise.resolve(void 0)}publicLogError2(v,f){return this.publicLogError(v,f)}_anonymizeFilePaths(v){let f=v;const u=[];for(const i of this._cleanupPatterns)for(;;){const n=i.exec(v);if(!n)break;u.push([n.index,i.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let r=0;for(f="";;){const i=o.exec(v);if(!i)break;!c.test(i[0])&&u.every(([n,s])=>i.index<n||i.index>=s)&&(f+=v.substring(r,i.index)+"<REDACTED: user-file-path>",r=o.lastIndex)}return r<v.length&&(f+=v.substr(r)),f}_removePropertiesWithPossibleUserInfo(v){if(!v)return v;const f=v.toLowerCase(),u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const c of u)if(c.regex.test(f))return`<REDACTED: ${c.label}>`;return v}_cleanupInfo(v,f){let u=v;f&&(u=this._anonymizeFilePaths(u));for(const c of this._cleanupPatterns)u=u.replace(c,"");return u=this._removePropertiesWithPossibleUserInfo(u),u}};P.IDLE_START_EVENT_NAME="UserIdleStart",P.IDLE_STOP_EVENT_NAME="UserIdleStop",P=ge([ee(1,h.IConfigurationService),ee(2,C.IProductService)],P),e.TelemetryService=P;function y(){const m=(0,b.localize)(0,null,E.default.nameLong),v=E.default.privacyStatementUrl?(0,b.localize)(2,null,"https://aka.ms/vscode-telemetry",E.default.privacyStatementUrl):(0,b.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=R.isWeb?"":(0,b.localize)(3,null),u=(0,b.localize)(4,null),c=(0,b.localize)(5,null),o=(0,b.localize)(6,null),r=(0,b.localize)(7,null),i=`
|       | ${u} | ${c} | ${o} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,b.localize)(8,null);return`
${m} ${v} ${f}

&nbsp;

${r}
${i}

&nbsp;

${n}
`}p.Registry.as(w.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,b.localize)(9,null),properties:{[g.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,b.localize)(10,null),(0,b.localize)(11,null),(0,b.localize)(12,null),(0,b.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.Registry.as(w.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,b.localize)(14,null),properties:{[g.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:E.default.privacyStatementUrl?(0,b.localize)(16,null,E.default.nameLong,E.default.privacyStatementUrl):(0,b.localize)(15,null,E.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,b.localize)(17,null,`\`#${g.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(X[219],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var S;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST_DARK="hcDark",R.HIGH_CONTRAST_LIGHT="hcLight"})(S=e.ColorScheme||(e.ColorScheme={}));function t(R){return R===S.HIGH_CONTRAST_DARK||R===S.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function M(R){return R===S.DARK||R===S.HIGH_CONTRAST_DARK}e.isDark=M}),define(X[220],J([0,1,117,3,2,5,44,219]),function(z,e,S,t,M,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var h;(function(y){function m(v){return v&&typeof v=="object"&&typeof v.id=="string"}y.isThemeColor=m})(h=e.ThemeColor||(e.ThemeColor={}));function w(y){return{id:y}}e.themeColorFromId=w;var E;(function(y){function m(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||h.isThemeColor(n.color))}y.isThemeIcon=m;const v=new RegExp(`^\\$\\((${S.CSSIcon.iconNameExpression}(?:${S.CSSIcon.iconModifierExpression})?)\\)$`);function f(n){const s=v.exec(n);if(!s)return;const[,a]=s;return{id:a}}y.fromString=f;function u(n){return{id:n}}y.fromId=u;function c(n,s){let a=n.id;const l=a.lastIndexOf("~");return l!==-1&&(a=a.substring(0,l)),s&&(a=`${a}~${s}`),{id:a}}y.modify=c;function o(n){const s=n.id.lastIndexOf("~");if(s!==-1)return n.id.substring(s+1)}y.getModifier=o;function r(n,s){return n.id===s.id&&n.color?.id===s.color?.id}y.isEqual=r;function i(n,s){return{id:n.id,color:s?w(s):void 0}}y.asThemeIcon=i,y.asClassNameArray=S.CSSIcon.asClassNameArray,y.asClassName=S.CSSIcon.asClassName,y.asCSSSelector=S.CSSIcon.asCSSSelector})(E=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=S.Codicon.file,e.FolderThemeIcon=S.Codicon.folder;function C(y){switch(y){case b.ColorScheme.DARK:return"vs-dark";case b.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case b.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class p{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,M.toDisposable)(()=>{const v=this.themingParticipants.indexOf(m);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const g=new p;D.Registry.add(e.Extensions.ThemingContribution,g);function d(y){return g.onColorThemeChange(y)}e.registerThemingParticipant=d;class P extends M.Disposable{constructor(m){super();this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,v){let f=this.theme.getColor(m);return f&&v&&(f=v(f,this.theme)),f?f.toString():null}}e.Themable=P}),define(X[61],J([0,1,14,3,2,4,18,5,40]),function(z,e,S,t,M,R,D,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const w="#FFFFFF",E="#1E1E1E",C="#000000",p="#FFFFFF",g="theme",d="themeBackground",P="windowSplash";e.IThemeMainService=(0,b.createDecorator)("themeMainService");let y=class extends M.Disposable{constructor(v,f){super();this.stateMainService=v,this.configurationService=f,this._onDidChangeColorScheme=this._register(new t.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,S.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(R.isWindows){if(S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.isMacintosh){if(S.nativeTheme.shouldUseInvertedColorScheme||S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.isLinux&&S.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const v=this.getColorScheme();if(v.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return v.dark?C:p;let f=this.stateMainService.getItem(d,null);if(!f)switch(this.stateMainService.getItem(g,"vs-dark").split(" ")[0]){case"vs":f=w;break;case"hc-black":f=C;break;case"hc-light":f=p;break;default:f=E}return R.isMacintosh&&f.toUpperCase()===E&&(f="#171717"),f}saveWindowSplash(v,f){this.stateMainService.setItems([{key:g,data:f.baseTheme},{key:d,data:f.colorInfo.background},{key:P,data:f}]),typeof v=="number"&&this.updateBackgroundColor(v,f)}updateBackgroundColor(v,f){for(const u of S.BrowserWindow.getAllWindows())if(u.id===v){u.setBackgroundColor(f.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(P)}};y=ge([ee(0,h.IStateMainService),ee(1,D.IConfigurationService)],y),e.ThemeMainService=y}),define(X[108],J([0,1,3,4,5,6]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,M.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,M.createDecorator)("sharedTunnelsService");var D;(function(P){P.Http="http",P.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var b;(function(P){P.ConstantPrivate="constantPrivate",P.Private="private",P.Public="public"})(b=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var h;(function(P){P[P.Notify=1]="Notify",P[P.OpenBrowser=2]="OpenBrowser",P[P.OpenPreview=3]="OpenPreview",P[P.Silent=4]="Silent",P[P.Ignore=5]="Ignore",P[P.OpenBrowserOnce=6]="OpenBrowserOnce"})(h=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function w(P){if(P.scheme!=="http"&&P.scheme!=="https")return;const y=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(P.authority);if(!!y)return{address:y[1],port:+y[2]}}e.extractLocalHostUriMetaDataForPortMapping=w,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(P){return e.LOCALHOST_ADDRESSES.indexOf(P)>=0}e.isLocalhost=E,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function C(P){return e.ALL_INTERFACES_ADDRESSES.indexOf(P)>=0}e.isAllInterfaces=C;function p(P,y){return y?y!==1&&P<1024:!t.isWindows&&P<1024}e.isPortPrivileged=p;class g{constructor(y,m,v){this.remoteAddress=y,this.localAddress=m,this._dispose=v,this._onDispose=new S.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=g;let d=class{constructor(y){this.logService=y,this._onTunnelOpened=new S.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new S.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new S.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(y){return this._tunnelProvider=y,y?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(y){this._canElevate=y.elevation,this._privacyOptions=y.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const y=[],m=Array.from(this._tunnels.values());for(const v of m){const f=Array.from(v.values());for(const u of f){const c=await u.value;c&&y.push(c)}}return y}async dispose(){for(const y of this._tunnels.values()){for(const{value:m}of y.values())await m.then(v=>v?.dispose());y.clear()}this._tunnels.clear()}openTunnel(y,m,v,f,u=!1,c,o){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${m}:${v} on local port ${f}.`),!y)return;if(m||(m="localhost"),this._tunnelProvider&&this._factoryInProgress.has(v)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.retainOrCreateTunnel(y,m,v,f,u,c,o);return r?r.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(m,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(i);return(i.tunnelRemoteHost!==m||i.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(y){return{tunnelRemotePort:y.tunnelRemotePort,tunnelRemoteHost:y.tunnelRemoteHost,tunnelLocalPort:y.tunnelLocalPort,localAddress:y.localAddress,privacy:y.privacy,protocol:y.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${y.tunnelRemoteHost}:${y.tunnelRemotePort} `);const m=this._tunnels.get(y.tunnelRemoteHost);if(m){const v=m.get(y.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(y.tunnelRemoteHost,y.tunnelRemotePort,v))}}}}async tryDisposeTunnel(y,m,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${y}:${m}.`);const f=v.value.then(async u=>{u&&(await u.dispose(!0),this._onTunnelClosed.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this._tunnels.has(y)&&this._tunnels.get(y).delete(m),f}}async closeTunnel(y,m){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${y}:${m} `);const v=this._tunnels.get(y);if(v&&v.has(m)){const f=v.get(m);f.refcount=0,await this.tryDisposeTunnel(y,m,f)}}addTunnelToMap(y,m,v){this._tunnels.has(y)||this._tunnels.set(y,new Map),this._tunnels.get(y).set(m,{refcount:1,value:v})}async removeEmptyTunnelFromMap(y,m){const v=this._tunnels.get(y);v&&(await v.get(m)||v.delete(m),v.size===0&&this._tunnels.delete(y))}getTunnelFromMap(y,m){const v=[y];E(y)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):C(y)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const f=v.map(u=>this._tunnels.get(u));for(const u of f){const c=u?.get(m);if(c)return c}}canTunnel(y){return!!w(y)}createWithProvider(y,m,v,f,u,c,o){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${m}:${v} on local port ${f}.`);const r=v;this._factoryInProgress.add(r);const n={elevationRequired:u?p(f===void 0?v:f):!1},s={remoteAddress:{host:m,port:v},localAddressPort:f,privacy:c,public:c?c!==b.Private:void 0,protocol:o},a=y.forwardPort(s,n);return a?(this.addTunnelToMap(m,v,a),a.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(r)})):this._factoryInProgress.delete(r),a}};d=ge([ee(0,R.ILogService)],d),e.AbstractTunnelService=d}),define(X[221],J([0,1,76,90,206,8,2,18,6,20,205,108,86]),function(z,e,S,t,M,R,D,b,h,w,E,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function g(v,f,u,c,o){let r;for(let i=3;i&&(r?.dispose(),r=await new d(v,f,u,c,o).waitForReady(),!(o&&t.BROWSER_RESTRICTED_PORTS[o]||!t.BROWSER_RESTRICTED_PORTS[r.tunnelLocalPort]));i--);return r}class d extends D.Disposable{constructor(f,u,c,o,r){super();this.defaultTunnelHost=u,this.suggestedLocalPort=r,this.privacy=C.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=f,this._server=S.createServer(),this._barrier=new R.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=i=>this._onConnection(i),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=o,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(u=>{u()})}async waitForReady(){let f=await(0,t.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),u=null;return this._server.listen(f,this.defaultTunnelHost),await this._barrier.wait(),u=this._server.address(),u||(f=0,this._server.listen(f,this.defaultTunnelHost),await this._barrier.wait(),u=this._server.address()),this.tunnelLocalPort=u.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${u.port}`,this}async _onConnection(f){f.pause();const u=(0,C.isLocalhost)(this.tunnelRemoteHost)||(0,C.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,E.connectRemoteAgentTunnel)(this._options,u,this.tunnelRemotePort),o=c.getSocket().socket,r=c.readEntireBuffer();c.dispose(),r.byteLength>0&&f.write(r.buffer),f.on("end",()=>{f.localAddress&&this._socketsDispose.delete(f.localAddress),o.end()}),f.on("close",()=>o.end()),f.on("error",()=>{f.localAddress&&this._socketsDispose.delete(f.localAddress),o.destroy()}),o.on("end",()=>f.end()),o.on("close",()=>f.end()),o.on("error",()=>{f.destroy()}),f.pipe(o),o.pipe(f),f.localAddress&&this._socketsDispose.set(f.localAddress,()=>{f.end(),o.end()})}}let P=class extends C.AbstractTunnelService{constructor(f,u,c,o,r){super(u);this.socketFactory=f,this.signService=c,this.productService=o,this.configurationService=r}get defaultTunnelHost(){const f=this.configurationService.getValue("remote.localPortHost");return!f||f==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(f,u,c,o,r,i,n){const s=this.getTunnelFromMap(u,c);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,u,c,o,r,i,n);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${u}:${c} on local port ${o}.`);const a={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:f,signService:this.signService,logService:this.logService,ipcLogger:null},l=g(a,this.defaultTunnelHost,u,c,o);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(u,c,l),l}}};P=ge([ee(1,h.ILogService),ee(2,p.ISignService),ee(3,w.IProductService),ee(4,b.IConfigurationService)],P),e.BaseTunnelService=P;let y=class extends P{constructor(f,u,c,o){super(M.nodeSocketFactory,f,u,c,o)}};y=ge([ee(0,h.ILogService),ee(1,p.ISignService),ee(2,w.IProductService),ee(3,b.IConfigurationService)],y),e.TunnelService=y;let m=class extends D.Disposable{constructor(f,u,c,o){super();this.logService=f,this.productService=u,this.signService=c,this.configurationService=o,this._tunnelServices=new Map}async openTunnel(f,u,c,o,r,i,n,s){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${o} on local port ${r}.`),!this._tunnelServices.has(f)){const a=new y(this.logService,this.signService,this.productService,this.configurationService);this._register(a),this._tunnelServices.set(f,a),a.onTunnelClosed(async()=>{(await a.tunnels).length===0&&(a.dispose(),this._tunnelServices.delete(f))})}return this._tunnelServices.get(f).openTunnel(u,c,o,r,i,n,s)}};m=ge([ee(0,h.ILogService),ee(1,w.IProductService),ee(2,p.ISignService),ee(3,b.IConfigurationService)],m),e.SharedTunnelsService=m}),define(X[45],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(R){R.Uninitialized="uninitialized",R.Idle="idle",R.CheckingForUpdates="checking for updates",R.AvailableForDownload="available for download",R.Downloading="downloading",R.Downloaded="downloaded",R.Updating="updating",R.Ready="ready"})(t=e.StateType||(e.StateType={}));var M;(function(R){R[R.Setup=0]="Setup",R[R.Archive=1]="Archive",R[R.Snap=2]="Snap"})(M=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(R,D)=>({type:"idle",updateType:R,error:D}),CheckingForUpdates:R=>({type:"checking for updates",explicit:R}),AvailableForDownload:R=>({type:"available for download",update:R}),Downloading:R=>({type:"downloading",update:R}),Downloaded:R=>({type:"downloaded",update:R}),Updating:R=>({type:"updating",update:R}),Ready:R=>({type:"ready",update:R})},e.IUpdateService=(0,S.createDecorator)("updateService")}),define(X[222],J([0,1,4,161,60,44]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.Registry.as(M.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:S.isWindows&&!S.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(X[223],J([0,1,3,45]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class M{constructor(b){this.service=b}listen(b,h){switch(h){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${h}`)}call(b,h,w){switch(h){case"checkForUpdates":return this.service.checkForUpdates(w);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(w)}throw new Error(`Call not found: ${h}`)}}e.UpdateChannel=M;class R{constructor(b){this.channel=b,this._onStateChange=new S.Emitter,this.onStateChange=this._onStateChange.event,this._state=t.State.Uninitialized,this.channel.listen("onStateChange")(h=>this.state=h),this.channel.call("_getInitialState").then(h=>this.state=h)}get state(){return this._state}set state(b){this._state=b,this._onStateChange.fire(b)}checkForUpdates(b){return this.channel.call("checkForUpdates",b)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(b){return this.channel.call("_applySpecificUpdate",b)}}e.UpdateChannelClient=R}),define(X[87],J([0,1,8,21,3,18,26,22,6,20,53,45]),function(z,e,S,t,M,R,D,b,h,w,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function p(d,P,y){return`${y.updateUrl}/api/update/${d}/${P}/${y.commit}`}e.createUpdateURL=p;let g=class{constructor(P,y,m,v,f,u){this.lifecycleMainService=P,this.configurationService=y,this.environmentMainService=m,this.requestService=v,this.logService=f,this.productService=u,this._state=C.State.Uninitialized,this._onStateChange=new M.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(P){this.logService.info("update#setState",P.type),this._state=P,this._onStateChange.fire(P)}async initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const P=this.getUpdateMode(),y=this.getProductQuality(P);if(!y){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(y),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(C.State.Idle(this.getUpdateType())),P==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}P==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,m=>this.logService.error(m))}getUpdateMode(){return(0,R.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(P){return P==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(P=60*60*1e3){return(0,S.timeout)(P).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(P){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(P)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(P){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(P=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${P}`),!P&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){return this.url?await this.getUpdateMode()==="none"?!1:(await this.requestService.request({url:this.url},t.CancellationToken.None)).res.statusCode===204:void 0}async _applySpecificUpdate(P){}getUpdateType(){return 1}doQuitAndInstall(){}};g=ge([ee(0,b.ILifecycleMainService),ee(1,R.IConfigurationService),ee(2,D.IEnvironmentMainService),ee(3,E.IRequestService),ee(4,h.ILogService),ee(5,w.IProductService)],g),e.AbstractUpdateService=g}),define(X[224],J([0,1,14,50,3,2,18,26,22,6,20,53,35,45,87]),function(z,e,S,t,M,R,D,b,h,w,E,C,p,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let P=class extends d.AbstractUpdateService{constructor(m,v,f,u,c,o,r){super(m,v,u,c,o,r);this.telemetryService=f,this.disposables=new R.DisposableStore}get onRawError(){return M.Event.fromNodeEventEmitter(S.autoUpdater,"error",(m,v)=>v)}get onRawUpdateNotAvailable(){return M.Event.fromNodeEventEmitter(S.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return M.Event.fromNodeEventEmitter(S.autoUpdater,"update-available",(m,v,f)=>({url:v,version:f,productVersion:f}))}get onRawUpdateDownloaded(){return M.Event.fromNodeEventEmitter(S.autoUpdater,"update-downloaded",(m,v,f,u)=>({releaseNotes:v,version:f,productVersion:f,date:u}))}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(m){this.logService.error("UpdateService error:",m);const f=(this.state.type==="checking for updates"?this.state.explicit:!0)?m:void 0;this.setState(g.State.Idle(1,f))}buildUpdateFeedUrl(m){let v;this.productService.darwinUniversalAssetId?v=this.productService.darwinUniversalAssetId:v=process.arch==="x64"?"darwin":"darwin-arm64";const f=(0,d.createUpdateURL)(v,m,this.productService);try{S.autoUpdater.setFeedURL({url:f})}catch(u){this.logService.error("Failed to set update feed URL",u);return}return f}doCheckForUpdates(m){this.setState(g.State.CheckingForUpdates(m)),S.autoUpdater.checkForUpdates()}onUpdateAvailable(m){this.state.type==="checking for updates"&&this.setState(g.State.Downloading(m))}onUpdateDownloaded(m){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:m.version}),this.setState(g.State.Ready(m)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(g.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),S.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ge([t.memoize],P.prototype,"onRawError",null),ge([t.memoize],P.prototype,"onRawUpdateNotAvailable",null),ge([t.memoize],P.prototype,"onRawUpdateAvailable",null),ge([t.memoize],P.prototype,"onRawUpdateDownloaded",null),P=ge([ee(0,h.ILifecycleMainService),ee(1,D.IConfigurationService),ee(2,p.ITelemetryService),ee(3,b.IEnvironmentMainService),ee(4,C.IRequestService),ee(5,w.ILogService),ee(6,E.IProductService)],P),e.DarwinUpdateService=P}),define(X[225],J([0,1,49,28,8,3,9,26,22,6,35,45]),function(z,e,S,t,M,R,D,b,h,w,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let p=class{constructor(P,y,m){if(this.lifecycleMainService=P,this.logService=m,this._state=C.State.Uninitialized,this._onStateChange=new R.Emitter,this.onStateChange=this._onStateChange.event,y.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(C.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,v=>this.logService.error(v))}get state(){return this._state}setState(P){this.logService.info("update#setState",P.type),this._state=P,this._onStateChange.fire(P)}scheduleCheckForUpdates(P=60*60*1e3){return(0,M.timeout)(P).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(P){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(P)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(P){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(P=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${P}`),!P&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}async _applySpecificUpdate(P){}};p=ge([ee(0,h.ILifecycleMainService),ee(1,b.IEnvironmentMainService),ee(2,w.ILogService)],p);let g=class extends p{constructor(P,y,m,v,f,u){super(m,v,f);this.snap=P,this.snapRevision=y,this.telemetryService=u;const c=(0,t.watch)(D.dirname(this.snap)),o=R.Event.fromNodeEventEmitter(c,"change",(s,a)=>a),r=R.Event.filter(o,s=>s==="current"),n=R.Event.debounce(r,(s,a)=>a,2e3)(()=>this.checkForUpdates(!1));m.onWillShutdown(()=>{n.dispose(),c.close()})}doCheckForUpdates(){this.setState(C.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(P=>{P?this.setState(C.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(C.State.Idle(2)))},P=>{this.logService.error(P),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(C.State.Idle(2,P.message||P))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,S.spawn)("sleep 3 && "+D.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const P=await new Promise((m,v)=>(0,t.realpath)(`${D.dirname(this.snap)}/current`,(f,u)=>f?v(f):m(u))),y=D.basename(P);return this.snapRevision!==y}isLatestVersion(){return this.isUpdateAvailable().then(void 0,P=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};g=ge([ee(2,h.ILifecycleMainService),ee(3,b.IEnvironmentMainService),ee(4,w.ILogService),ee(5,E.ITelemetryService)],g),e.SnapUpdateService=g}),define(X[62],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,S.createDecorator)("IUriIdentityService")}),define(X[226],J([0,1,62,178,15,16,123,3,2]),function(z,e,S,t,M,R,D,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class w{constructor(p){this.uri=p,this.time=w._clock++}touch(){return this.time=w._clock++,this}}w._clock=0;let E=class{constructor(p){this._fileService=p,this._dispooables=new h.DisposableStore,this._limit=2**16;const g=new Map,d=P=>{let y=g.get(P.scheme);return y===void 0&&(y=p.hasProvider(P)&&!this._fileService.hasCapability(P,1024),g.set(P.scheme,y)),y};this._dispooables.add(b.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(P=>{g.delete(P.scheme)})),this.extUri=new R.ExtUri(d),this._canonicalUris=new D.SkipList((P,y)=>this.extUri.compare(P,y,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(p){this._fileService.hasProvider(p)&&(p=(0,R.normalizePath)(p));const g=this._canonicalUris.get(p);return g?g.touch().uri.with({fragment:p.fragment}):(this._canonicalUris.set(p,new w(p)),this._checkTrim(),p)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const p=[...this._canonicalUris.entries()].sort((d,P)=>d[1].touch<P[1].touch?1:d[1].touch>P[1].touch?-1:0);w._clock=0,this._canonicalUris.clear();const g=this._limit*.5;for(let d=0;d<g;d++)this._canonicalUris.set(p[d][0],p[d][1].touch())}};E=ge([ee(0,M.IFileService)],E),e.UriIdentityService=E,(0,t.registerSingleton)(S.IUriIdentityService,E,!0)}),define(X[109],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,S.createDecorator)("urlService")}),define(X[227],J([0,1,7]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(b){this.handler=b}listen(b,h){throw new Error(`Event not found: ${h}`)}call(b,h,w){switch(h){case"handleURL":return this.handler.handleURL(S.URI.revive(w[0]),w[1])}throw new Error(`Call not found: ${h}`)}}e.URLHandlerChannel=t;class M{constructor(b){this.channel=b}handleURL(b,h){return this.channel.call("handleURL",[b.toJSON(),h])}}e.URLHandlerChannelClient=M;class R{constructor(b){this.next=b}async routeCall(b,h,w,E){if(h!=="handleURL")throw new Error(`Call not found: ${h}`);if(w){const C=S.URI.revive(w);if(C&&C.query){const p=/\bwindowId=(\d+)/.exec(C.query);if(p){const g=p[1],d=new RegExp(`window:${g}`),P=b.connections.find(y=>d.test(y.ctx));if(P)return P}}}return this.next.routeCall(b,h,w,E)}routeEvent(b,h){throw new Error(`Event not found: ${h}`)}}e.URLHandlerRouter=R}),define(X[228],J([0,1,8,2,7,20]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class D extends t.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(w,E){const C=[...this.handlers.values()];return(0,S.first)(C.map(p=>()=>p.handleURL(w,E)),void 0,!1).then(p=>p||!1)}registerHandler(w){return this.handlers.add(w),(0,t.toDisposable)(()=>this.handlers.delete(w))}}e.AbstractURLService=D;let b=class extends D{constructor(w){super();this.productService=w}create(w){let{authority:E,path:C,query:p,fragment:g}=w||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return E&&C&&C.indexOf("/")!==0&&(C=`/${C}`),M.URI.from({scheme:this.productService.urlProtocol,authority:E,path:C,query:p,fragment:g})}};b=ge([ee(0,R.IProductService)],b),e.NativeURLService=b}),define(X[229],J([0,1,14,8,3,2,4,7]),function(z,e,S,t,M,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function h(E){try{return b.URI.parse(E)}catch{return null}}class w{constructor(C,p,g,d,P){if(this.urlService=p,this.uris=[],this.retryCount=0,this.flushDisposable=R.Disposable.None,this.disposables=new R.DisposableStore,this.uris=C,D.isWindows){const v=d.isBuilt?[]:[`"${d.appRoot}"`];v.push("--open-url","--"),S.app.setAsDefaultProtocolClient(P.urlProtocol,process.execPath,v)}const y=M.Event.map(M.Event.fromNodeEventEmitter(S.app,"open-url",(v,f)=>({event:v,url:f})),({event:v,url:f})=>(v.preventDefault(),f));this.disposables.add(y(v=>{const f=h(v);!f||this.urlService.open(f,{originalUrl:v})})),g.getWindows().filter(v=>v.isReady).length>0?this.flush():M.Event.once(g.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const C=[];for(const p of this.uris)await this.urlService.open(p.uri,{originalUrl:p.url})||C.push(p);C.length!==0&&(this.uris=C,this.flushDisposable=(0,t.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=w}),define(X[230],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,S.createDecorator)("webviewManagerService")}),define(X[231],J([0,1,14,2,13,7]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class D extends t.Disposable{constructor(){super();const h=this.handleWebviewRequest.bind(this);S.protocol.registerFileProtocol(M.Schemas.vscodeWebview,h)}handleWebviewRequest(h,w){try{const E=R.URI.parse(h.url),C=D.validWebviewFilePaths.get(E.path);if(typeof C=="string"){const p=`vs/workbench/contrib/webview/browser/pre/${C}`,g=M.FileAccess.asFileUri(p,z);return w(decodeURIComponent(g.fsPath))}else return w({error:-10})}catch{}return w({error:-2})}}e.WebviewProtocolProvider=D,D.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(X[73],J([0,1,4]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(E){return!!E.workspaceUri}e.isWorkspaceToOpen=t;function M(E){return!!E.folderUri}e.isFolderToOpen=M;function R(E){return!!E.fileUri}e.isFileToOpen=R;function D(E){const C=b(E),p=E.getValue("window.menuBarVisibility");return p==="default"||C==="native"&&p==="compact"||S.isMacintosh&&S.isNative?"classic":p}e.getMenuBarVisibility=D;function b(E){if(S.isWeb)return"custom";const C=E.getValue("window");if(C){if(S.isMacintosh&&C.nativeTabs===!0||S.isMacintosh&&C.nativeFullScreen===!1)return"native";const d=C.titleBarStyle;if(d==="native"||d==="custom")return d}return S.isLinux?"native":"custom"}e.getTitleBarStyle=b;function h(E,C){return!S.isWindows||S.isWeb||!C.isBuilt||b(E)==="native"?!1:E.getValue("window.experimental.windowControlsOverlay.enabled")}e.useWindowControlsOverlay=h;function w(E=0){return Math.pow(1.2,E)}e.zoomLevelToZoomFactor=w}),define(X[110],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var S;(function(b){b[b.INITIAL=1]="INITIAL",b[b.LOAD=2]="LOAD",b[b.RELOAD=3]="RELOAD"})(S=e.LoadReason||(e.LoadReason={}));var t;(function(b){b[b.CLOSE=1]="CLOSE",b[b.QUIT=2]="QUIT",b[b.RELOAD=3]="RELOAD",b[b.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const M=function(b=1){return{width:1024,height:768,mode:b}};e.defaultWindowState=M;var R;(function(b){b[b.Maximized=0]="Maximized",b[b.Normal=1]="Normal",b[b.Minimized=2]="Minimized",b[b.Fullscreen=3]="Fullscreen"})(R=e.WindowMode||(e.WindowMode={}));var D;(function(b){b[b.UNRESPONSIVE=1]="UNRESPONSIVE",b[b.CRASHED=2]="CRASHED",b[b.LOAD=3]="LOAD"})(D=e.WindowError||(e.WindowError={}))}),define(X[32],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,S.createDecorator)("windowsMainService");var t;(function(M){M[M.CLI=0]="CLI",M[M.DOCK=1]="DOCK",M[M.MENU=2]="MENU",M[M.DIALOG=3]="DIALOG",M[M.DESKTOP=4]="DESKTOP",M[M.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(X[232],J([0,1,14,21,3,65,2,27,68,99,6,20,32]),function(z,e,S,t,M,R,D,b,h,w,E,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var g;(function(P){P[P.Initial=1]="Initial",P[P.StoredCredentialsUsed=2]="StoredCredentialsUsed",P[P.LoginDialogShown=3]="LoginDialogShown"})(g||(g={}));let d=class extends D.Disposable{constructor(y,m,v,f,u){super();this.logService=y,this.windowsMainService=m,this.credentialsService=v,this.encryptionMainService=f,this.productService=u,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=g.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const y=M.Event.fromNodeEventEmitter(S.app,"login",(m,v,f,u,c)=>({event:m,webContents:v,req:f,authInfo:u,callback:c}));this._register(y(this.onLogin,this))}async onLogin({event:y,authInfo:m,req:v,callback:f}){if(!m.isProxy)return;if(!this.pendingProxyResolve&&this.state===g.LoginDialogShown&&v.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}y.preventDefault();let u;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),u=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(m);try{u=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}f(u?.username,u?.password)}async resolveProxyCredentials(y){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const m=await this.doResolveProxyCredentials(y);if(m)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),m;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(y){this.logService.trace("auth#doResolveProxyCredentials - enter",y);const m=String((0,R.hash)({scheme:y.scheme,host:y.host,port:y.port}));let v,f;try{const r=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,m);if(r){const i=JSON.parse(await this.encryptionMainService.decrypt(r));v=i.username,f=i.password}}catch(r){this.logService.error(r)}if(this.state!==g.StoredCredentialsUsed&&typeof v=="string"&&typeof f=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=g.StoredCredentialsUsed,{username:v,password:f};const u=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!u){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${u.id} to handle proxy login`);const c={authInfo:y,username:this.sessionCredentials?.username??v,password:this.sessionCredentials?.password??f,replyChannel:`vscode:proxyAuthResponse:${(0,b.generateUuid)()}`};u.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,c),this.state=g.LoginDialogShown;const o=await new Promise(r=>{const i=async(n,s,a)=>{if(s===c.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${u.id}`),u.win?.webContents.off("ipc-message",i),a){const l={username:a.username,password:a.password};try{if(a.remember){const I=await this.encryptionMainService.encrypt(JSON.stringify(l));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,m,I)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,m)}catch(I){this.logService.error(I)}r({username:l.username,password:l.password})}else r(void 0)};u.win?.webContents.on("ipc-message",i)});return this.sessionCredentials=o,o}};d=ge([ee(0,E.ILogService),ee(1,p.IWindowsMainService),ee(2,h.ICredentialsMainService),ee(3,w.IEncryptionMainService),ee(4,C.IProductService)],d),e.ProxyAuthHandler=d}),define(X[233],J([0,1,68,6,39,20,32,189]),function(z,e,S,t,M,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let h=class extends b.BaseCredentialsMainService{constructor(E,C,p,g){super(E);this.environmentMainService=C,this.productService=p,this.windowsMainService=g,this.surfaceKeytarLoadError=d=>{this.windowsMainService.sendToFocused("vscode:showCredentialsError",d.message??d)}}async getSecretStoragePrefix(){return Promise.resolve(this.productService.urlProtocol)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new S.InMemoryCredentialsProvider,this._keytarCache;const E=await new Promise((C,p)=>{z(["keytar"],C,p)});return await E.findCredentials("test-keytar-loads"),this._keytarCache=E,this._keytarCache}};h=ge([ee(0,t.ILogService),ee(1,M.INativeEnvironmentService),ee(2,R.IProductService),ee(3,D.IWindowsMainService)],h),e.CredentialsNativeMainService=h}),define(X[234],J([0,1,19,2,3,6,22,78,49,261,8,13,51,4,36,14,32]),function(z,e,S,t,M,R,D,b,h,w,E,C,p,g,d,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;const m=P.UtilityProcess,v=typeof m!="undefined";let f=class Rt{constructor(r,i,n){this._logService=r,this._windowsMainService=n,this._shutdown=!1,this._extHosts=new Map,i.onWillShutdown(s=>{this._shutdown=!0,s.join(this._waitForAllExit(6e3))})}dispose(){}_getExtHost(r){const i=this._extHosts.get(r);if(!i)throw new Error("Unknown extension host!");return i}onDynamicStdout(r){return this._getExtHost(r).onStdout}onDynamicStderr(r){return this._getExtHost(r).onStderr}onDynamicMessage(r){return this._getExtHost(r).onMessage}onDynamicError(r){return this._getExtHost(r).onError}onDynamicExit(r){return this._getExtHost(r).onExit}async canUseUtilityProcess(){return v}async createExtensionHost(r){if(this._shutdown)throw(0,S.canceled)();const i=String(++Rt._lastId);let n;if(r){if(!v)throw new Error("Cannot use UtilityProcess!");n=new c(i,this._logService,this._windowsMainService)}else n=new u(i,this._logService);return this._extHosts.set(i,n),n.onExit(({pid:s,code:a,signal:l})=>{this._logService.info(`Extension host with pid ${s} exited with code: ${a}, signal: ${l}.`),setTimeout(()=>{n.dispose(),this._extHosts.delete(i)})}),{id:i}}async start(r,i){if(this._shutdown)throw(0,S.canceled)();return this._getExtHost(r).start(i)}async enableInspectPort(r){if(this._shutdown)throw(0,S.canceled)();const i=this._extHosts.get(r);return i?i.enableInspectPort():!1}async kill(r){if(this._shutdown)throw(0,S.canceled)();const i=this._extHosts.get(r);!i||i.kill()}async _killAllNow(){for(const[,r]of this._extHosts)r.kill()}async _waitForAllExit(r){const i=[];for(const[,n]of this._extHosts)i.push(n.waitForExit(r));return E.Promises.settled(i).then(()=>{})}};f._lastId=0,f=ge([ee(0,R.ILogService),ee(1,D.ILifecycleMainService),ee(2,y.IWindowsMainService)],f),e.ExtensionHostStarter=f;let u=class extends t.Disposable{constructor(r,i){super();this.id=r,this._logService=i,this._onStdout=this._register(new M.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new M.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new M.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new M.Emitter),this.onError=this._onError.event,this._onExit=this._register(new M.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(r){g.isCI&&this._logService.info("Calling fork to start extension host...");const i=b.StopWatch.create(!1);this._process=(0,h.fork)(C.FileAccess.asFileUri("bootstrap-fork",z).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,p.mixin)({cwd:(0,d.cwd)()},r));const n=i.elapsed(),s=this._process.pid;this._logService.info(`Starting extension host with pid ${s} (fork() took ${n} ms).`);const a=new w.StringDecoder("utf-8");this._process.stdout?.on("data",I=>{const k=typeof I=="string"?I:a.write(I);this._onStdout.fire(k)});const l=new w.StringDecoder("utf-8");this._process.stderr?.on("data",I=>{const k=typeof I=="string"?I:l.write(I);this._onStderr.fire(k)}),this._process.on("message",I=>{this._onMessage.fire(I)}),this._process.on("error",I=>{this._onError.fire({error:(0,S.transformErrorForSerialization)(I)})}),this._process.on("exit",(I,k)=>{this._hasExited=!0,this._onExit.fire({pid:s,code:I,signal:k})})}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):g.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(r){if(!this._process)return;const i=this._process.pid;this._logService.info(`Waiting for extension host with pid ${i} to exit.`),await Promise.race([M.Event.toPromise(this.onExit),(0,E.timeout)(r)]),this._hasExited||(this._logService.info(`Extension host with pid ${i} did not exit within ${r}ms.`),this._process.kill())}};u=ge([ee(1,R.ILogService)],u);let c=class extends t.Disposable{constructor(r,i,n){super();this.id=r,this._logService=i,this._windowsMainService=n,this.onStdout=M.Event.None,this.onStderr=M.Event.None,this.onError=M.Event.None,this._onMessage=this._register(new M.Emitter),this.onMessage=this._onMessage.event,this._onExit=this._register(new M.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(r){const i=this._windowsMainService.getWindowById(r.responseWindowId);if(!i){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const n=i.win;if(!n||n.isDestroyed()||n.webContents.isDestroyed()){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const s=`extensionHost${this.id}`,a=C.FileAccess.asFileUri("bootstrap-fork.js",z).fsPath,l=["--type=extensionHost","--skipWorkspaceStorageLock"],I=r.execArgv||[],k={...r.env};for(const K of Object.keys(k))k[K]=String(k[K]);this._logService.info(`UtilityProcess<${this.id}>: Creating new...`),this._process=new m(a,l,{serviceName:s,env:k,execArgv:I}),this._register(M.Event.fromNodeEventEmitter(this._process,"spawn")(()=>{this._logService.info(`UtilityProcess<${this.id}>: received spawn event.`)})),this._register(M.Event.fromNodeEventEmitter(this._process,"exit")(K=>{K=K||0,this._logService.info(`UtilityProcess<${this.id}>: received exit event with code ${K}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:K,signal:""})}));const A=(K,ie)=>{ie.type==="Utility"&&ie.name===s&&(this._logService.info(`UtilityProcess<${this.id}>: terminated unexpectedly with code ${ie.exitCode}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:ie.exitCode,signal:""}))};P.app.on("child-process-gone",A),this._register((0,t.toDisposable)(()=>{P.app.off("child-process-gone",A)}));const{port1:W,port2:F}=new P.MessageChannelMain;this._process.postMessage("port",null,[F]),n.webContents.postMessage(r.responseChannel,r.responseNonce,[W])}enableInspectPort(){return this._process?(this._logService.info(`UtilityProcess<${this.id}>: Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):g.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`UtilityProcess<${this.id}>: Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(r){if(!this._process)return;const i=this._process.pid;this._logService.info(`UtilityProcess<${this.id}>: Waiting for extension host with pid ${i} to exit.`),await Promise.race([M.Event.toPromise(this.onExit),(0,E.timeout)(r)]),this._hasExited||(this._logService.info(`UtilityProcess<${this.id}>: Extension host with pid ${i} did not exit within ${r}ms, will kill it now.`),this._process.kill())}};c=ge([ee(1,R.ILogService),ee(2,y.IWindowsMainService)],c)}),define(X[235],J([0,1,14,3,2,231,32]),function(z,e,S,t,M,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let b=class extends M.Disposable{constructor(w){super();this.windowsMainService=w,this._onFoundInFrame=this._register(new t.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new R.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(w,E){let C;if(typeof w.windowId=="number"){const{windowId:p}=w,g=this.windowsMainService.getWindowById(p);if(!g?.win)throw new Error(`Invalid windowId: ${p}`);C=g.win.webContents}else{const{webContentsId:p}=w;if(C=S.webContents.fromId(p),!C)throw new Error(`Invalid webContentsId: ${p}`)}C.isDestroyed()||C.setIgnoreMenuShortcuts(E)}async findInFrame(w,E,C,p){const d=this.getFrameByName(w,E);if(typeof d.findInFrame=="function"){d.findInFrame(C,{findNext:p.findNext,forward:p.forward});const P=(y,m)=>{m.finalUpdate&&(this._onFoundInFrame.fire(m),d.removeListener("found-in-frame",P))};d.on("found-in-frame",P)}}async stopFindInFrame(w,E,C){const g=this.getFrameByName(w,E);typeof g.stopFindInFrame=="function"&&g.stopFindInFrame(C.keepSelection?"keepSelection":"clearSelection")}getFrameByName(w,E){const C=this.windowsMainService.getWindowById(w.windowId);if(!C?.win)throw new Error(`Invalid windowId: ${w}`);const p=C.win.webContents.mainFrame.framesInSubtree.find(g=>g.name===E);if(!p)throw new Error(`Unknown frame: ${E}`);return p}};b=ge([ee(0,D.IWindowsMainService)],b),e.WebviewMainService=b}),define(X[236],J([0,1,8,3,2]),function(z,e,S,t,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends M.Disposable{constructor({onDidOpenWindow:b,onDidFocusWindow:h,getActiveWindowId:w}){super();this.disposables=this._register(new M.DisposableStore),t.Event.latch(t.Event.any(b,h))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,S.createCancelablePromise)(()=>w()),(async()=>{try{const C=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:C}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(b){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=b}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=R}),define(X[24],J([0,1,165,9,33,16,7,5,13]),function(z,e,S,t,M,R,D,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,b.createDecorator)("contextService");function w(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=w;function E(i){if(i.configuration)return{id:i.id,configPath:i.configuration};if(i.folders.length===1)return{id:i.id,uri:i.folders[0].uri}}e.toWorkspaceIdentifier=E;function C(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=C;function p(i){const n=i;if(n?.uri)return{id:n.id,uri:D.URI.revive(n.uri)};const s=i;if(s?.configPath)return{id:s.id,configPath:D.URI.revive(s.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=p;var g;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(g=e.WorkbenchState||(e.WorkbenchState={}));function d(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=d;function P(i){const n=i;return!!(n&&typeof n=="object"&&D.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=P;class y{constructor(n,s,a,l,I){this._id=n,this._transient=a,this._configuration=l,this._ignorePathCasing=I,this._foldersMap=M.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=s}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=M.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=y;class m{constructor(n,s){this.raw=s,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,R.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=m;function v(i){return new m({uri:i,index:0,name:(0,R.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace";const f=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,S.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function u(i,n){return R.extUriBiasedIgnorePathCase.isEqualOrParent(i,n.untitledWorkspacesHome)}e.isUntitledWorkspace=u;function c(i){let n;return D.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===h.Schemas.tmp}e.isTemporaryWorkspace=c;function o(i,n){return!u(i,n)&&!c(i)}e.isSavedWorkspace=o;function r(i){return(typeof i=="string"?(0,t.extname)(i):(0,R.extname)(i))===f}e.hasWorkspaceFileExtension=r}),define(X[237],J([0,1,75,28,31,13,9,4,16,7,23,169,18,26,15,6,168,24]),function(z,e,S,t,M,R,D,b,h,w,E,C,p,g,d,P,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let v=class{constructor(u,c,o){this.configurationService=c,this.logService=o,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=h.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(r,i)=>(0,M.isEqual)(r,i,!b.isLinux)},this.backupHome=u.backupHome,this.workspacesJsonPath=u.backupWorkspacesPath}async initialize(){let u;try{u=JSON.parse(await E.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch{u=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(u.emptyWorkspaceInfos);let c=[];try{Array.isArray(u.rootURIWorkspaces)&&(c=u.rootURIWorkspaces.map(r=>({workspace:{id:r.id,configPath:w.URI.parse(r.configURIPath)},remoteAuthority:r.remoteAuthority})))}catch{}this.workspaces=await this.validateWorkspaces(c);let o=[];try{Array.isArray(u.folderWorkspaceInfos)?o=u.folderWorkspaceInfos.map(r=>({folderUri:w.URI.parse(r.folderUri),remoteAuthority:r.remoteAuthority})):Array.isArray(u.folderURIWorkspaces)&&(o=u.folderURIWorkspaces.map(r=>({folderUri:w.URI.parse(r),remoteAuthority:void 0})))}catch{}this.folders=await this.validateFolders(o),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==d.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===d.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||d.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(u,c){this.workspaces.some(r=>u.workspace.id===r.workspace.id)||(this.workspaces.push(u),this.saveSync());const o=this.getBackupPath(u.workspace.id);return c&&this.moveBackupFolderSync(o,c),o}moveBackupFolderSync(u,c){if(t.existsSync(u)&&this.convertToEmptyWindowBackupSync(u),t.existsSync(c))try{t.renameSync(c,u)}catch(o){this.logService.error(`Backup: Could not move backup folder to new location: ${o.toString()}`)}}unregisterWorkspaceBackupSync(u){const c=u.id,o=this.workspaces.findIndex(r=>r.workspace.id===c);o!==-1&&(this.workspaces.splice(o,1),this.saveSync())}registerFolderBackupSync(u){return this.folders.some(c=>this.backupUriComparer.isEqual(u.folderUri,c.folderUri))||(this.folders.push(u),this.saveSync()),this.getBackupPath(this.getFolderHash(u))}unregisterFolderBackupSync(u){const c=this.folders.findIndex(o=>this.backupUriComparer.isEqual(u,o.folderUri));c!==-1&&(this.folders.splice(c,1),this.saveSync())}registerEmptyWindowBackupSync(u,c){const o=u||this.getRandomEmptyWindowId();return this.emptyWindows.some(r=>!!r.backupFolder&&this.backupPathComparer.isEqual(r.backupFolder,o))||(this.emptyWindows.push({backupFolder:o,remoteAuthority:c}),this.saveSync()),this.getBackupPath(o)}unregisterEmptyWindowBackupSync(u){const c=this.emptyWindows.findIndex(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,u));c!==-1&&(this.emptyWindows.splice(c,1),this.saveSync())}getBackupPath(u){return(0,D.join)(this.backupHome,u)}async validateWorkspaces(u){if(!Array.isArray(u))return[];const c=new Set,o=[];for(const r of u){const i=r.workspace;if(!(0,m.isWorkspaceIdentifier)(i))return[];if(!c.has(i.id)){c.add(i.id);const n=this.getBackupPath(i.id);await this.doHasBackups(n)?i.configPath.scheme!==R.Schemas.file||await E.Promises.exists(i.configPath.fsPath)?o.push(r):await this.convertToEmptyWindowBackup(n):await this.deleteStaleBackup(n)}}return o}async validateFolders(u){if(!Array.isArray(u))return[];const c=[],o=new Set;for(const r of u){const i=r.folderUri,n=this.backupUriComparer.getComparisonKey(i);if(!o.has(n)){o.add(n);const s=this.getBackupPath(this.getFolderHash(r));await this.doHasBackups(s)?i.scheme!==R.Schemas.file||await E.Promises.exists(i.fsPath)?c.push(r):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return c}async validateEmptyWorkspaces(u){if(!Array.isArray(u))return[];const c=[],o=new Set;for(const r of u){const i=r.backupFolder;if(typeof i!="string")return[];if(!o.has(i)){o.add(i);const n=this.getBackupPath(i);await this.doHasBackups(n)?c.push(r):await this.deleteStaleBackup(n)}}return c}async deleteStaleBackup(u){try{await E.Promises.exists(u)&&await E.Promises.rm(u,E.RimRafMode.MOVE)}catch(c){this.logService.error(`Backup: Could not delete stale backup: ${c.toString()}`)}}async convertToEmptyWindowBackup(u){let c=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(r=>!!r.backupFolder&&this.backupPathComparer.isEqual(r.backupFolder,c));)c=this.getRandomEmptyWindowId();const o=this.getBackupPath(c);try{await E.Promises.rename(u,o)}catch(r){return this.logService.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.emptyWindows.push({backupFolder:c}),!0}convertToEmptyWindowBackupSync(u){let c=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(r=>!!r.backupFolder&&this.backupPathComparer.isEqual(r.backupFolder,c));)c=this.getRandomEmptyWindowId();const o=this.getBackupPath(c);try{t.renameSync(u,o)}catch(r){return this.logService.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.emptyWindows.push({backupFolder:c}),!0}async getDirtyWorkspaces(){const u=[];for(const c of this.workspaces)await this.hasBackups(c)&&u.push(c);for(const c of this.folders)await this.hasBackups(c)&&u.push(c);return u}hasBackups(u){let c;return(0,C.isEmptyWindowBackupInfo)(u)?c=u.backupFolder:(0,y.isFolderBackupInfo)(u)?c=this.getBackupPath(this.getFolderHash(u)):c=this.getBackupPath(u.workspace.id),this.doHasBackups(c)}async doHasBackups(u){try{const c=await E.Promises.readdir(u);for(const o of c)try{if((await E.Promises.readdir((0,D.join)(u,o))).length>0)return!0}catch{}}catch{}return!1}saveSync(){try{(0,E.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}async save(){try{await E.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(u=>({id:u.workspace.id,configURIPath:u.workspace.configPath.toString(),remoteAuthority:u.remoteAuthority})),folderWorkspaceInfos:this.folders.map(u=>({folderUri:u.folderUri.toString(),remoteAuthority:u.remoteAuthority})),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(u){const c=u.folderUri;let o;return c.scheme===R.Schemas.file?o=b.isLinux?c.fsPath:c.fsPath.toLowerCase():o=c.toString().toLowerCase(),(0,S.createHash)("md5").update(o).digest("hex")}};v=ge([ee(0,g.IEnvironmentMainService),ee(1,p.IConfigurationService),ee(2,P.ILogService)],v),e.BackupMainService=v}),define(X[54],J([0,1,14,8,65,34,2,79,4,11,23,145,5,6,24]),function(z,e,S,t,M,R,D,b,h,w,E,C,p,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,p.createDecorator)("dialogMainService");let P=class{constructor(m){this.logService=m,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new t.Queue}pickFileFolder(m,v){return this.doPick({...m,pickFolders:!0,pickFiles:!0,title:(0,C.localize)(0,null)},v)}pickFolder(m,v){return this.doPick({...m,pickFolders:!0,title:(0,C.localize)(1,null)},v)}pickFile(m,v){return this.doPick({...m,pickFiles:!0,title:(0,C.localize)(2,null)},v)}pickWorkspace(m,v){const f=(0,C.localize)(3,null),u=(0,R.mnemonicButtonLabel)((0,C.localize)(4,null)),c=d.WORKSPACE_FILTER;return this.doPick({...m,pickFiles:!0,title:f,filters:c,buttonLabel:u},v)}async doPick(m,v){const f={title:m.title,buttonLabel:m.buttonLabel,filters:m.filters,defaultPath:m.defaultPath};(typeof m.pickFiles=="boolean"||typeof m.pickFolders=="boolean")&&(f.properties=void 0,m.pickFiles&&m.pickFolders&&(f.properties=["multiSelections","openDirectory","openFile","createDirectory"])),f.properties||(f.properties=["multiSelections",m.pickFolders?"openDirectory":"openFile","createDirectory"]),h.isMacintosh&&f.properties.push("treatPackageAsDirectory");const u=await this.showOpenDialog(f,(0,w.withNullAsUndefined)(v||S.BrowserWindow.getFocusedWindow()));if(u&&u.filePaths&&u.filePaths.length>0)return u.filePaths}getWindowDialogQueue(m){if(m){let v=this.windowDialogQueues.get(m.id);return v||(v=new t.Queue,this.windowDialogQueues.set(m.id,v)),v}else return this.noWindowDialogueQueue}showMessageBox(m,v){return this.getWindowDialogQueue(v).queue(async()=>v?S.dialog.showMessageBox(v,m):S.dialog.showMessageBox(m))}async showSaveDialog(m,v){const f=this.acquireFileDialogLock(m,v);if(!f)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(v).queue(async()=>{let u;return v?u=await S.dialog.showSaveDialog(v,m):u=await S.dialog.showSaveDialog(m),u.filePath=this.normalizePath(u.filePath),u})}finally{(0,D.dispose)(f)}}normalizePath(m){return m&&h.isMacintosh&&(m=(0,b.normalizeNFC)(m)),m}normalizePaths(m){return m.map(v=>this.normalizePath(v))}async showOpenDialog(m,v){m.defaultPath&&(await E.Promises.exists(m.defaultPath)||(m.defaultPath=void 0));const f=this.acquireFileDialogLock(m,v);if(!f)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(v).queue(async()=>{let u;return v?u=await S.dialog.showOpenDialog(v,m):u=await S.dialog.showOpenDialog(m),u.filePaths=this.normalizePaths(u.filePaths),u})}finally{(0,D.dispose)(f)}}acquireFileDialogLock(m,v){if(!v)return D.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",m);let f=this.windowFileDialogLocks.get(v.id);f||(f=new Set,this.windowFileDialogLocks.set(v.id,f));const u=(0,M.hash)(m);if(!f.has(u))return this.logService.trace("[DialogMainService]: new file dialog lock created",m),f.add(u),(0,D.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",m),f?.delete(u),f?.size===0&&this.windowFileDialogLocks.delete(v.id)})}};P=ge([ee(0,g.ILogService)],P),e.DialogMainService=P}),define(X[238],J([0,1,3,2,66,24]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class D extends t.Disposable{constructor(h,w){super();this.logService=h,this.storageMainService=w,this.onDidChangeApplicationStorageEmitter=this._register(new S.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(w.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(h,w){this._register(S.Event.debounce(h.onDidChangeStorage,(E,C)=>(E?E.push(C):E=[C],E),D.STORAGE_CHANGE_DEBOUNCE_TIME)(E=>{E.length&&w.fire(this.serializeStorageChangeEvents(E,h))}))}serializeStorageChangeEvents(h,w){const E=new Map,C=new Set;return h.forEach(p=>{const g=w.get(p.key);typeof g=="string"?E.set(p.key,g):C.add(p.key)}),{changed:Array.from(E.entries()),deleted:Array.from(C.values())}}listen(h,w,E){switch(w){case"onDidChangeStorage":{const C=E.profile?(0,M.revive)(E.profile):void 0;if(!C)return this.onDidChangeApplicationStorageEmitter.event;let p=this.mapProfileToOnDidChangeProfileStorageEmitter.get(C.id);return p||(p=this._register(new S.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(C),p),this.mapProfileToOnDidChangeProfileStorageEmitter.set(C.id,p)),p.event}}throw new Error(`Event not found: ${w}`)}async call(h,w,E){const C=E.profile?(0,M.revive)(E.profile):void 0,p=(0,R.reviveIdentifier)(E.workspace),g=await this.withStorageInitialized(C,p);switch(w){case"getItems":return Array.from(g.items.entries());case"updateItems":{const d=E;if(d.insert)for(const[P,y]of d.insert)g.set(P,y);d.delete?.forEach(P=>g.delete(P));break}default:throw new Error(`Call not found: ${w}`)}}async withStorageInitialized(h,w){let E;w?E=this.storageMainService.workspaceStorage(w):h?E=this.storageMainService.profileStorage(h):E=this.storageMainService.applicationStorage;try{await E.init()}catch(C){this.logService.error(`StorageIPC#init: Unable to init ${w?"workspace":h?"profile":"application"} storage due to ${C}`)}return E}}e.StorageDatabaseChannel=D,D.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(X[41],J([0,1,65,3,2,16,11,7,162,39,15,5,6,24,33,62,8,27]),function(z,e,S,t,M,R,D,b,h,w,E,C,p,g,d,P,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function v(o){const r=o;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&b.URI.isUri(r.location)&&b.URI.isUri(r.globalStorageHome)&&b.URI.isUri(r.settingsResource)&&b.URI.isUri(r.keybindingsResource)&&b.URI.isUri(r.tasksResource)&&b.URI.isUri(r.snippetsHome)&&((0,D.isUndefined)(r.extensionsResource)||b.URI.isUri(r.extensionsResource)))}e.isUserDataProfile=v,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,C.createDecorator)("IUserDataProfilesService");function f(o,r){return{id:o.id,isDefault:o.isDefault,name:o.name,location:b.URI.revive(o.location).with({scheme:r}),globalStorageHome:b.URI.revive(o.globalStorageHome).with({scheme:r}),settingsResource:b.URI.revive(o.settingsResource).with({scheme:r}),keybindingsResource:b.URI.revive(o.keybindingsResource).with({scheme:r}),tasksResource:b.URI.revive(o.tasksResource).with({scheme:r}),snippetsHome:b.URI.revive(o.snippetsHome).with({scheme:r}),extensionsResource:b.URI.revive(o.extensionsResource)?.with({scheme:r})}}e.reviveProfile=f,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function u(o,r,i){return{id:(0,S.hash)(r.path).toString(16),name:o,location:r,isDefault:!1,globalStorageHome:(0,R.joinPath)(r,"globalStorage"),settingsResource:(0,R.joinPath)(r,"settings.json"),keybindingsResource:(0,R.joinPath)(r,"keybindings.json"),tasksResource:(0,R.joinPath)(r,"tasks.json"),snippetsHome:(0,R.joinPath)(r,"snippets"),extensionsResource:(0,R.joinPath)(r,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:i}}e.toUserDataProfile=u;let c=class extends M.Disposable{constructor(r,i,n,s){super();this.environmentService=r,this.fileService=i,this.uriIdentityService=n,this.logService=s,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new t.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new t.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new t.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new t.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profilesHome=(0,R.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}get defaultProfile(){return this.profiles[0]}get profiles(){return this.profilesObject.profiles}setEnablement(r){this.enabled!==r&&(this._profilesObject=void 0,this.enabled=r)}get profilesObject(){if(!this._profilesObject){const r=this.enabled?this.getStoredProfiles().map(a=>u(a.name,a.location,a.useDefaultFlags)):[];let i;const n=new d.ResourceMap,s=u((0,h.localize)(0,null),this.environmentService.userRoamingDataHome);if(r.unshift({...s,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||r.length>0?s.extensionsResource:void 0}),r.length){const a=this.getStoredProfileAssociations();if(a.workspaces)for(const[l,I]of Object.entries(a.workspaces)){const k=b.URI.parse(l),A=b.URI.parse(I),W=r.find(F=>this.uriIdentityService.extUri.isEqual(F.location,A));W&&n.set(k,W)}if(a.emptyWindow){const l=b.URI.parse(a.emptyWindow);i=r.find(I=>this.uriIdentityService.extUri.isEqual(I.location,l))}}this._profilesObject={profiles:r,workspaces:n,emptyWindow:i}}return this._profilesObject}getProfile(r,i){if(!this.enabled)return this.defaultProfile;const n=this.getWorkspace(r);let s=b.URI.isUri(n)?this.profilesObject.workspaces.get(n):this.profilesObject.emptyWindow;return s||(s=i,this.profiles.length>1&&this.updateWorkspaceAssociation(r,s)),s}getWorkspace(r){return(0,g.isSingleFolderWorkspaceIdentifier)(r)?r.uri:(0,g.isWorkspaceIdentifier)(r)?r.configPath:"empty-window"}async createProfile(r,i,n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(this.getStoredProfiles().some(l=>l.name===r))throw new Error(`Profile with name ${r} already exists`);const s=u(r,(0,R.joinPath)(this.profilesHome,(0,S.hash)((0,m.generateUuid)()).toString(16)),i);await this.fileService.createFolder(s.location);const a=[];return this._onWillCreateProfile.fire({profile:s,join(l){a.push(l)}}),await y.Promises.settled(a),this.updateProfiles([s],[],[]),n&&await this.setProfileForWorkspace(s,n),s}async updateProfile(r,i,n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let s=this.profiles.find(a=>a.id===r.id);if(!s)throw new Error(`Profile '${r.name}' does not exist`);return s=u(i,s.location,n),this.updateProfiles([],[],[s]),s}async setProfileForWorkspace(r,i){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const n=this.profiles.find(s=>s.id===r.id);if(!n)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(i,n)}async unsetWorkspace(r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(r)}async resetWorkspaces(){this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async removeProfile(r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(r.isDefault)throw new Error("Cannot remove default profile");const i=this.profiles.find(s=>s.id===r.id);if(!i)throw new Error(`Profile '${r.name}' does not exist`);const n=[];this._onWillRemoveProfile.fire({profile:i,join(s){n.push(s)}}),await y.Promises.settled(n),i.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const s of[...this.profilesObject.workspaces.keys()])i.id===this.profilesObject.workspaces.get(s)?.id&&this.profilesObject.workspaces.delete(s);this.updateStoredProfileAssociations(),this.updateProfiles([],[i],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(i.location,{recursive:!0})}catch(s){this.logService.error(s)}}updateProfiles(r,i,n){const s=[];for(let a of[...this.profilesObject.profiles,...r])a.isDefault||i.some(l=>a.id===l.id)||(a=n.find(l=>a.id===l.id)??a,s.push({location:a.location,name:a.name,useDefaultFlags:a.useDefaultFlags}));this.saveStoredProfiles(s),this._profilesObject=void 0,this.triggerProfilesChanges(r,i,n)}triggerProfilesChanges(r,i,n){this._onDidChangeProfiles.fire({added:r,removed:i,updated:n,all:this.profiles})}updateWorkspaceAssociation(r,i){const n=this.getWorkspace(r);b.URI.isUri(n)?(this.profilesObject.workspaces.delete(n),i&&this.profilesObject.workspaces.set(n,i)):this.profilesObject.emptyWindow=i,this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const r={};for(const[n,s]of this.profilesObject.workspaces.entries())r[n.toString()]=s.location.toString();const i=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:r,emptyWindow:i}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(r){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(r){throw new Error("not implemented")}};c.PROFILES_KEY="userDataProfiles",c.PROFILE_ASSOCIATIONS_KEY="profileAssociations",c=ge([ee(0,w.IEnvironmentService),ee(1,E.IFileService),ee(2,P.IUriIdentityService),ee(3,p.ILogService)],c),e.UserDataProfilesService=c}),define(X[239],J([0,1,14,38,2,33,13,9,4,7,27,39,6,41]),function(z,e,S,t,M,R,D,b,h,w,E,C,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let d=class extends M.Disposable{constructor(y,m,v){super();this.logService=v,this.validRoots=R.TernarySearchTree.forPaths(!h.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(y.appRoot),this.addValidFileRoot(y.extensionsPath),this.addValidFileRoot(m.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(y.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:y}=S.session;y.protocol.registerFileProtocol(D.Schemas.vscodeFileResource,(m,v)=>this.handleResourceRequest(m,v)),y.protocol.interceptFileProtocol(D.Schemas.file,(m,v)=>this.handleFileRequest(m,v)),this._register((0,M.toDisposable)(()=>{y.protocol.unregisterProtocol(D.Schemas.vscodeFileResource),y.protocol.uninterceptProtocol(D.Schemas.file)}))}addValidFileRoot(y){const m=(0,b.normalize)(y);return this.validRoots.get(m)?M.Disposable.None:(this.validRoots.set(m,!0),(0,M.toDisposable)(()=>this.validRoots.delete(m)))}handleFileRequest(y,m){const v=w.URI.parse(y.url);return this.logService.error(`Refused to load resource ${v.fsPath} from ${D.Schemas.file}: protocol (original URL: ${y.url})`),m({error:-3})}handleResourceRequest(y,m){const v=this.requestToNormalizedFilePath(y);return this.validRoots.findSubstr(v)?m({path:v}):this.validExtensions.has((0,b.extname)(v))?m({path:v}):(this.logService.error(`${D.Schemas.vscodeFileResource}: Refused to load resource ${v} from ${D.Schemas.vscodeFileResource}: protocol (original URL: ${y.url})`),m({error:-3}))}requestToNormalizedFilePath(y){const m=w.URI.parse(y.url),v=D.FileAccess.asFileUri(m);return(0,b.normalize)(v.fsPath)}createIPCObjectUrl(){let y;const m=w.URI.from({scheme:"vscode",path:(0,E.generateUuid)()}),v=m.toString(),f=async()=>y;return t.validatedIpcMain.handle(v,f),this.logService.trace(`IPC Object URL: Registered new channel ${v}.`),{resource:m,update:u=>y=u,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${v}.`),t.validatedIpcMain.removeHandler(v)}}}};d=ge([ee(0,C.INativeEnvironmentService),ee(1,g.IUserDataProfilesService),ee(2,p.ILogService)],d),e.ProtocolMainService=d}),define(X[240],J([0,1,14,38,8,3,2,13,11,96,26,22,6,52,59,61,42,41,37]),function(z,e,S,t,M,R,D,b,h,w,E,C,p,g,d,P,y,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let f=class extends D.Disposable{constructor(c,o,r,i,n,s,a,l,I){super();this.machineId=c,this.userEnv=o,this.environmentMainService=r,this.userDataProfilesService=i,this.lifecycleMainService=n,this.logService=s,this.policyService=a,this.themeMainService=l,this.protocolMainService=I,this.firstWindowConnectionBarrier=new M.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new R.Emitter),this.onDidError=R.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(c,o)=>this.onWindowConnection(c,o)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(c,o)=>this.onWorkerConnection(c,o)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(c,o){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const r=await this.connect();if(c.sender.isDestroyed())return r.close();c.sender.postMessage("vscode:createSharedProcessMessageChannelResult",o,[r])}onWorkerConnection(c,o){this.logService.trace("SharedProcess: onWorkerConnection",o);const r=new D.DisposableStore,i=s=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${s}')`,o),r.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",o))},n=S.BrowserWindow.fromId(o.reply.windowId);if(!n||n.isDestroyed()||n.webContents.isDestroyed()||!o.reply.channel){i("unavailable");return}r.add(R.Event.filter(this.lifecycleMainService.onWillLoadWindow,s=>s.window.win===n)(()=>i("load"))),r.add(R.Event.fromNodeEventEmitter(n,"closed")(()=>i("closed"))),n.webContents.postMessage(o.reply.channel,o.reply.nonce,c.ports)}onWillShutdown(){const c=this.window;!c||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(c.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{c.close()}catch{}this.window=void 0},0))}send(c,...o){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${c}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(c,...o)}catch(r){this.logService.warn(`Error sending IPC message to channel '${c}' of shared process: ${(0,y.toErrorMessage)(r)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(c=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),c()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(c=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),c()}))})()),this._whenIpcReady}createWindow(){const c=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new S.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:b.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${c.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),c.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,profiles:this.userDataProfilesService.profiles,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:g.default,policiesData:this.policyService.serialize()}),this.window.loadURL(b.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",z).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=c=>{this.logService.trace("SharedProcess#close prevented"),c.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(c,o)=>this._onDidError.fire({type:2,details:o})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(c,o,r)=>this._onDidError.fire({type:3,details:{reason:r,exitCode:o}})))}async connect(){await this.whenIpcReady;const c=(0,h.assertIsDefined)(this.window);return(0,w.connect)(c)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const c=this.window;return c?!c.isDestroyed()&&!c.webContents.isDestroyed():!1}};f=ge([ee(2,E.IEnvironmentMainService),ee(3,m.IUserDataProfilesService),ee(4,C.ILifecycleMainService),ee(5,p.ILogService),ee(6,v.IPolicyService),ee(7,P.IThemeMainService),ee(8,d.IProtocolMainService)],f),e.SharedProcess=f}),define(X[111],J([0,1,8,3,2,70,11,97,5,41]),function(z,e,S,t,M,R,D,b,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const E="__$__targetStorageMarker";e.IStorageService=(0,h.createDecorator)("storageService");var C;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(C=e.WillSaveStateReason||(e.WillSaveStateReason={}));var p;(function(v){v[v.APPLICATION=-1]="APPLICATION",v[v.PROFILE=0]="PROFILE",v[v.WORKSPACE=1]="WORKSPACE"})(p=e.StorageScope||(e.StorageScope={}));var g;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(g=e.StorageTarget||(e.StorageTarget={}));class d extends M.Disposable{constructor(f={flushInterval:d.DEFAULT_FLUSH_INTERVAL}){super();this.options=f,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new S.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new M.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,S.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,M.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(f,u){if(u===E){switch(f){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:f})}else this._onDidChangeValue.fire({scope:f,key:u,target:this.getKeyTargets(f)[u]})}emitWillSaveState(f){this._onWillSaveState.fire({reason:f})}get(f,u,c){return this.getStorage(u)?.get(f,c)}getBoolean(f,u,c){return this.getStorage(u)?.getBoolean(f,c)}getNumber(f,u,c){return this.getStorage(u)?.getNumber(f,c)}store(f,u,c,o){if((0,D.isUndefinedOrNull)(u)){this.remove(f,c);return}this.withPausedEmitters(()=>{this.updateKeyTarget(f,c,o),this.getStorage(c)?.set(f,u)})}remove(f,u){this.withPausedEmitters(()=>{this.updateKeyTarget(f,u,void 0),this.getStorage(u)?.delete(f)})}withPausedEmitters(f){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{f()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(f,u){const c=[],o=this.getKeyTargets(f);for(const r of Object.keys(o))o[r]===u&&c.push(r);return c}updateKeyTarget(f,u,c){const o=this.getKeyTargets(u);typeof c=="number"?o[f]!==c&&(o[f]=c,this.getStorage(u)?.set(E,JSON.stringify(o))):typeof o[f]=="number"&&(delete o[f],this.getStorage(u)?.set(E,JSON.stringify(o)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(f){switch(f){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(f){const u=this.get(E,f);if(u)try{return JSON.parse(u)}catch{}return Object.create(null)}isNew(f){return this.getBoolean(e.IS_NEW_KEY,f)===!0}async flush(f=C.NONE){this._onWillSaveState.fire({reason:f});const u=this.getStorage(-1),c=this.getStorage(0),o=this.getStorage(1);switch(f){case C.NONE:await S.Promises.settled([u?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await S.Promises.settled([u?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve()]);break}}async log(){const f=this.getStorage(-1)?.items??new Map,u=this.getStorage(0)?.items??new Map,c=this.getStorage(1)?.items??new Map;return m(f,u,c,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(f,u){return this.emitWillSaveState(C.NONE),(0,w.isUserDataProfile)(f)?this.switchToProfile(f,u):this.switchToWorkspace(f,u)}canSwitchProfile(f,u){return!(f.id===u.id||P(u)&&P(f))}switchData(f,u,c,o){this.withPausedEmitters(()=>{if(o)for(const[r,i]of f)u.set(r,i);else{const r=new Set;for(const[i,n]of f)r.add(i),u.get(i)!==n&&this.emitDidChangeValue(c,i);for(const[i]of u.items)r.has(i)||this.emitDidChangeValue(c,i)}})}}e.AbstractStorageService=d,d.DEFAULT_FLUSH_INTERVAL=60*1e3;function P(v){return v.isDefault||!!v.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=P;class y extends d{constructor(){super();this.applicationStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this.profileStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(f=>this.emitDidChangeValue(1,f))),this._register(this.profileStorage.onDidChangeStorage(f=>this.emitDidChangeValue(0,f))),this._register(this.applicationStorage.onDidChangeStorage(f=>this.emitDidChangeValue(-1,f)))}getStorage(f){switch(f){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(f){switch(f){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}}e.InMemoryStorageService=y;async function m(v,f,u,c,o,r){const i=F=>{try{return JSON.parse(F)}catch{return F}},n=new Map,s=new Map;v.forEach((F,K)=>{n.set(K,F),s.set(K,i(F))});const a=new Map,l=new Map;f.forEach((F,K)=>{a.set(K,F),l.set(K,i(F))});const I=new Map,k=new Map;u.forEach((F,K)=>{I.set(K,F),k.set(K,i(F))}),console.group(c!==o?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const A=[];if(n.forEach((F,K)=>{A.push({key:K,value:F})}),console.table(A),console.groupEnd(),console.log(s),c!==o){console.group(`Storage: Profile (path: ${o}, profile specific)`);const F=[];a.forEach((K,ie)=>{F.push({key:ie,value:K})}),console.table(F),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${r})`);const W=[];I.forEach((F,K)=>{W.push({key:K,value:F})}),console.table(W),console.groupEnd(),console.log(k)}e.logStorage=m}),define(X[241],J([0,1,25,8,3,2,9,78,7,23,97,142,6,111,35,24]),function(z,e,S,t,M,R,D,b,h,w,E,C,p,g,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class y extends R.Disposable{constructor(r,i){super();this.logService=r,this.fileService=i,this._onDidChangeStorage=this._register(new M.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new M.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new E.Storage(new E.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new t.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=E.StorageState.None}get storage(){return this._storage}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===E.StorageState.None)try{const r=await this.doCreate();this._storage.dispose(),this._storage=r,this._register(r.onDidChangeStorage(n=>this._onDidChangeStorage.fire({key:n}))),await this.doInit(r);const i=r.getBoolean(g.IS_NEW_KEY);i===void 0?r.set(g.IS_NEW_KEY,!0):i&&r.set(g.IS_NEW_KEY,!1)}catch(r){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.state=E.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===p.LogLevel.Trace?r=>this.logService.trace(r):void 0,logError:r=>this.logService.error(r)}}doInit(r){return r.init()}get items(){return this._storage.items}get(r,i){return this._storage.get(r,i)}set(r,i){return this._storage.set(r,i)}delete(r){return this._storage.delete(r)}async close(){const r=new b.StopWatch(!1);await this.doClose(),r.stop(),r.elapsed()>y.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(r),this._onDidCloseStorage.fire()}async logSlowClose(r){if(!!this.path)try{const i=(0,S.top)(Array.from(this._storage.items.entries()).map(([s,a])=>({key:s,length:a.length})),(s,a)=>a.length-s.length,5).map(s=>`${s.key}:${s.length}`).join(", "),n=(await this.fileService.stat(h.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${n}b, Large Keys: ${i}`)}catch(i){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=E.StorageState.Closed,await this._storage.close()}}y.LOG_SLOW_CLOSE_THRESHOLD=2e3;class m extends y{constructor(r,i,n,s){super(n,s);this.profile=r,this.options=i}get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.profile.globalStorageHome.fsPath,m.STORAGE_NAME)}async doCreate(){return new E.Storage(new C.SQLiteStorageDatabase(this.path??C.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}))}}m.STORAGE_NAME="state.vscdb";class v extends m{constructor(r,i,n,s){super(r,i,n,s)}}e.ProfileStorageMain=v;class f extends m{constructor(r,i,n,s){super(i.defaultProfile,r,n,s)}async doInit(r){await super.doInit(r),this.updateTelemetryState(r)}updateTelemetryState(r){r.get(d.firstSessionDateStorageKey,void 0)===void 0&&r.set(d.firstSessionDateStorageKey,new Date().toUTCString());const n=r.get(d.currentSessionDateStorageKey,void 0),s=new Date().toUTCString();r.set(d.lastSessionDateStorageKey,typeof n=="undefined"?null:n),r.set(d.currentSessionDateStorageKey,s)}}e.ApplicationStorageMain=f;class u extends y{constructor(r,i,n,s,a){super(n,a);this.workspace=r,this.options=i,this.environmentService=s}get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id,u.WORKSPACE_STORAGE_NAME)}async doCreate(){const{storageFilePath:r,wasCreated:i}=await this.prepareWorkspaceStorageFolder();return new E.Storage(new C.SQLiteStorageDatabase(r,{logging:this.createLoggingOptions()}),{hint:i?E.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:C.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const r=(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),i=(0,D.join)(r,u.WORKSPACE_STORAGE_NAME);return await w.Promises.exists(r)?{storageFilePath:i,wasCreated:!1}:(await w.Promises.mkdir(r,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(r),{storageFilePath:i,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(r){let i;if((0,P.isSingleFolderWorkspaceIdentifier)(this.workspace)?i={folder:this.workspace.uri.toString()}:(0,P.isWorkspaceIdentifier)(this.workspace)&&(i={workspace:this.workspace.configPath.toString()}),i)try{const n=(0,D.join)(r,u.WORKSPACE_META_NAME);await w.Promises.exists(n)||await w.Promises.writeFile(n,JSON.stringify(i,void 0,2))}catch(n){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.WorkspaceStorageMain=u,u.WORKSPACE_STORAGE_NAME="state.vscdb",u.WORKSPACE_META_NAME="workspace.json";class c extends y{get path(){}async doCreate(){return new E.Storage(new E.InMemoryStorageDatabase)}}e.InMemoryStorageMain=c}),define(X[242],J([0,1,66,39,15,6,212,62,41]),function(z,e,S,t,M,R,D,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let w=class Pt extends h.UserDataProfilesService{constructor(C,p,g,d,P){super(g,d,p,P);this.stateService=C}getStoredProfiles(){return(0,S.revive)(this.stateService.getItem(Pt.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,S.revive)(this.stateService.getItem(Pt.PROFILE_ASSOCIATIONS_KEY,{}))}};w=ge([ee(0,D.IStateService),ee(1,b.IUriIdentityService),ee(2,t.IEnvironmentService),ee(3,M.IFileService),ee(4,R.ILogService)],w),e.UserDataProfilesService=w}),define(X[63],J([0,1,7,39,15,5,6,40,62,41,242]),function(z,e,S,t,M,R,D,b,h,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,R.refineServiceDecorator)(w.IUserDataProfilesService);let C=class bt extends E.UserDataProfilesService{constructor(g,d,P,y,m){super(g,d,P,y,m);this.stateMainService=g}isEnabled(){return this.enabled}saveStoredProfiles(g){this.stateMainService.setItem(bt.PROFILES_KEY,g)}saveStoredProfileAssociations(g){this.stateMainService.setItem(bt.PROFILE_ASSOCIATIONS_KEY,g)}getStoredProfileAssociations(){const g="workspaceAndProfileInfo",d=this.stateMainService.getItem(g,void 0);if(d){this.stateMainService.removeItem(g);const P=d.reduce((y,{workspace:m,profile:v})=>(y[S.URI.revive(m).toString()]=S.URI.revive(v).toString(),y),{});this.stateMainService.setItem(bt.PROFILE_ASSOCIATIONS_KEY,{workspaces:P})}return super.getStoredProfileAssociations()}};C=ge([ee(0,b.IStateMainService),ee(1,h.IUriIdentityService),ee(2,t.IEnvironmentService),ee(3,M.IFileService),ee(4,D.ILogService)],C),e.UserDataProfilesMainService=C}),define(X[243],J([0,1,2,100,63]),function(z,e,S,t,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultExtensionsProfileInitHandler=void 0;let R=class extends S.Disposable{constructor(b,h){super();this.defaultExtensionsProfileInitService=b,this._register(h.onWillCreateProfile(w=>{h.profiles.length===1&&w.join(this.defaultExtensionsProfileInitService.initialize())})),this._register(h.onDidChangeProfiles(w=>{h.profiles.length===1&&this.defaultExtensionsProfileInitService.uninitialize()}))}};R=ge([ee(0,t.IDefaultExtensionsProfileInitService),ee(1,M.IUserDataProfilesMainService)],R),e.DefaultExtensionsProfileInitHandler=R}),define(X[88],J([0,1,47,2,39,15,5,22,6,111,241,41,63]),function(z,e,S,t,M,R,D,b,h,w,E,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,D.createDecorator)("storageMainService");let g=class extends t.Disposable{constructor(y,m,v,f,u){super();this.logService=y,this.environmentService=m,this.userDataProfilesService=v,this.lifecycleMainService=f,this.fileService=u,this.shutdownReason=void 0,this.applicationStorage=this.createApplicationStorage(),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.applicationStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(y=>{y.window.profile&&this.profileStorage(y.window.profile).init(),y.workspace&&this.workspaceStorage(y.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(y=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=y.reason,y.join(this.applicationStorage.close());for(const[,m]of this.mapProfileToStorage)y.join(m.close());for(const[,m]of this.mapWorkspaceToStorage)y.join(m.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(y=>{y.join((async()=>{await this.fileService.exists(y.profile.globalStorageHome)||await this.fileService.createFolder(y.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(y=>{const m=this.mapProfileToStorage.get(y.profile.id);m&&y.join(m.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const y=new E.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return(0,S.once)(y.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")}),y}profileStorage(y){if((0,w.isProfileUsingDefaultStorage)(y))return this.applicationStorage;let m=this.mapProfileToStorage.get(y.id);return m||(this.logService.trace(`StorageMainService: creating profile storage (${y.name})`),m=this.createProfileStorage(y),this.mapProfileToStorage.set(y.id,m),(0,S.once)(m.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${y.name})`),this.mapProfileToStorage.delete(y.id)})),m}createProfileStorage(y){return this.shutdownReason===2?new E.InMemoryStorageMain(this.logService,this.fileService):new E.ProfileStorageMain(y,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(y){let m=this.mapWorkspaceToStorage.get(y.id);return m||(this.logService.trace(`StorageMainService: creating workspace storage (${y.id})`),m=this.createWorkspaceStorage(y),this.mapWorkspaceToStorage.set(y.id,m),(0,S.once)(m.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${y.id})`),this.mapWorkspaceToStorage.delete(y.id)})),m}createWorkspaceStorage(y){return this.shutdownReason===2?new E.InMemoryStorageMain(this.logService,this.fileService):new E.WorkspaceStorageMain(y,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}};g=ge([ee(0,h.ILogService),ee(1,M.IEnvironmentService),ee(2,p.IUserDataProfilesMainService),ee(3,b.ILifecycleMainService),ee(4,R.IFileService)],g),e.StorageMainService=g,e.IApplicationStorageMainService=(0,D.createDecorator)("applicationStorageMainService");let d=class extends w.AbstractStorageService{constructor(y,m){super();this.userDataProfilesService=y,this.storageMainService=m,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(y){if(y===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(y){if(y===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}};d=ge([ee(0,C.IUserDataProfilesService),ee(1,e.IStorageMainService)],d),e.ApplicationStorageMainService=d}),define(X[112],J([0,1,16,7,24]),function(z,e,S,t,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function R(h,w,E){for(const p of h){const g=p.openedWorkspace;if((0,M.isWorkspaceIdentifier)(g)){const d=E(g);if(d){if(d.folders.some(P=>S.extUriBiasedIgnorePathCase.isEqualOrParent(w,P.uri)))return p}else if(S.extUriBiasedIgnorePathCase.isEqualOrParent(w,g.configPath))return p}}const C=h.filter(p=>(0,M.isSingleFolderWorkspaceIdentifier)(p.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqualOrParent(w,p.openedWorkspace.uri));if(C.length)return C.sort((p,g)=>-(p.openedWorkspace.uri.path.length-g.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=R;function D(h,w){for(const E of h)if((0,M.isWorkspaceIdentifier)(E.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqual(E.openedWorkspace.configPath,w)||(0,M.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqual(E.openedWorkspace.uri,w))return E}e.findWindowOnWorkspaceOrFolder=D;function b(h,w){const E=C=>w.some(p=>S.extUriBiasedIgnorePathCase.isEqual(t.URI.file(p),t.URI.file(C)));for(const C of h)if(C.config?.extensionDevelopmentPath?.some(p=>E(p)))return C}e.findWindowOnExtensionDevelopmentPath=b}),define(X[244],J([0,1,14,2,4,16,7,18,22,6,40,32,110,24]),function(z,e,S,t,M,R,D,b,h,w,E,C,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let d=class kt extends t.Disposable{constructor(u,c,o,r,i){super();this.windowsMainService=u,this.stateMainService=c,this.lifecycleMainService=o,this.logService=r,this.configurationService=i,this._state=P(this.stateMainService.getItem(kt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){S.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(u=>this.onBeforeCloseWindow(u)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(u=>{u.newCount-u.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(u=>this.onBeforeCloseWindow(u))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const u={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!u.lastActiveWindow){let r=this.windowsMainService.getLastActiveWindow();(!r||r.isExtensionDevelopmentHost)&&(r=this.windowsMainService.getWindows().find(i=>!i.isExtensionDevelopmentHost)),r&&(u.lastActiveWindow=this.toWindowState(r))}const c=this.windowsMainService.getWindows().find(r=>r.isExtensionDevelopmentHost&&!r.isExtensionTestHost);c&&(u.lastPluginDevelopmentHostWindow=this.toWindowState(c)),this.windowsMainService.getWindowCount()>1&&(u.openedWindows=this.windowsMainService.getWindows().filter(r=>!r.isExtensionDevelopmentHost).map(r=>this.toWindowState(r)));const o=m(u);this.stateMainService.setItem(kt.windowsStateStorageKey,o),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",o)}onBeforeCloseWindow(u){if(this.lifecycleMainService.quitRequested)return;const c=this.toWindowState(u);u.isExtensionDevelopmentHost&&!u.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=c:!u.isExtensionDevelopmentHost&&u.openedWorkspace&&this._state.openedWindows.forEach(o=>{const r=(0,g.isWorkspaceIdentifier)(u.openedWorkspace)&&o.workspace?.id===u.openedWorkspace.id,i=(0,g.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)&&o.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(o.folderUri,u.openedWorkspace.uri);(r||i)&&(o.uiState=c.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=c)}toWindowState(u){return{workspace:(0,g.isWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace:void 0,folderUri:(0,g.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace.uri:void 0,backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.serializeWindowState()}}getNewWindowState(u){const c=this.doGetNewWindowState(u),o=this.configurationService.getValue("window");let r;return c.hasDefaultState?r=!!(o?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(o.newWindowDimensions)>=0):(r=!!(this.lifecycleMainService.wasRestarted||o?.restoreFullscreen),r&&M.isMacintosh&&this.windowsMainService.getWindows().some(i=>i.isFullScreen)&&(r=!1)),c.mode===3&&!r&&(c.mode=1),c}doGetNewWindowState(u){const c=this.windowsMainService.getLastActiveWindow();if(!u.extensionTestsPath){if(!!u.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const a=u.workspace;if((0,g.isWorkspaceIdentifier)(a)){const I=this.state.openedWindows.filter(k=>k.workspace&&k.workspace.id===a.id).map(k=>k.uiState);if(I.length)return I[0]}if((0,g.isSingleFolderWorkspaceIdentifier)(a)){const I=this.state.openedWindows.filter(k=>k.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(k.folderUri,a.uri)).map(k=>k.uiState);if(I.length)return I[0]}else if(u.backupPath){const I=this.state.openedWindows.filter(k=>k.backupPath===u.backupPath).map(k=>k.uiState);if(I.length)return I[0]}const l=this.lastClosedState||this.state.lastActiveWindow;if(!c&&l)return l.uiState}let o;const r=S.screen.getAllDisplays();if(r.length===1)o=r[0];else{if(M.isMacintosh){const a=S.screen.getCursorScreenPoint();o=S.screen.getDisplayNearestPoint(a)}!o&&c&&(o=S.screen.getDisplayMatching(c.getBounds())),o||(o=S.screen.getPrimaryDisplay()||r[0])}let i=(0,p.defaultWindowState)();i.x=Math.round(o.bounds.x+o.bounds.width/2-i.width/2),i.y=Math.round(o.bounds.y+o.bounds.height/2-i.height/2);const n=this.configurationService.getValue("window");let s=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")i.mode=0,s=!1;else if(n.newWindowDimensions==="fullscreen")i.mode=3,s=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&c){const a=c.serializeWindowState();a.mode===3?i.mode=3:i=a,s=i.mode!==3&&n.newWindowDimensions==="offset"}}return s&&(i=this.ensureNoOverlap(i)),i.hasDefaultState=!0,i}ensureNoOverlap(u){if(this.windowsMainService.getWindows().length===0)return u;u.x=typeof u.x=="number"?u.x:0,u.y=typeof u.y=="number"?u.y:0;const c=this.windowsMainService.getWindows().map(o=>o.getBounds());for(;c.some(o=>o.x===u.x||o.y===u.y);)u.x+=30,u.y+=30;return u}};d.windowsStateStorageKey="windowsState",d=ge([ee(0,C.IWindowsMainService),ee(1,E.IStateMainService),ee(2,h.ILifecycleMainService),ee(3,w.ILogService),ee(4,b.IConfigurationService)],d),e.WindowsStateHandler=d;function P(f){const u={openedWindows:[]},c=f||{openedWindows:[]};return c.lastActiveWindow&&(u.lastActiveWindow=y(c.lastActiveWindow)),c.lastPluginDevelopmentHostWindow&&(u.lastPluginDevelopmentHostWindow=y(c.lastPluginDevelopmentHostWindow)),Array.isArray(c.openedWindows)&&(u.openedWindows=c.openedWindows.map(o=>y(o))),u}e.restoreWindowsState=P;function y(f){const u={uiState:f.uiState};return f.backupPath&&(u.backupPath=f.backupPath),f.remoteAuthority&&(u.remoteAuthority=f.remoteAuthority),f.folder&&(u.folderUri=D.URI.parse(f.folder)),f.workspaceIdentifier&&(u.workspace={id:f.workspaceIdentifier.id,configPath:D.URI.parse(f.workspaceIdentifier.configURIPath)}),u}function m(f){return{lastActiveWindow:f.lastActiveWindow&&v(f.lastActiveWindow),lastPluginDevelopmentHostWindow:f.lastPluginDevelopmentHostWindow&&v(f.lastPluginDevelopmentHostWindow),openedWindows:f.openedWindows.map(u=>v(u))}}e.getWindowsStateStoreData=m;function v(f){return{workspaceIdentifier:f.workspace&&{id:f.workspace.id,configURIPath:f.workspace.configPath.toString()},folder:f.folderUri&&f.folderUri.toString(),backupPath:f.backupPath,remoteAuthority:f.remoteAuthority,uiState:f.uiState}}}),define(X[89],J([0,1,31,48,120,34,13,9,4,16,7,5,71,24]),function(z,e,S,t,M,R,D,b,h,w,E,C,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,C.createDecorator)("workspacesService");function d(k){return k.hasOwnProperty("workspace")}e.isRecentWorkspace=d;function P(k){return k.hasOwnProperty("folderUri")}e.isRecentFolder=P;function y(k){return k.hasOwnProperty("fileUri")}e.isRecentFile=y;function m(k){return v(k)||f(k)}e.isStoredWorkspaceFolder=m;function v(k){const A=k;return typeof A?.path=="string"&&(!A.name||typeof A.name=="string")}function f(k){const A=k;return typeof A?.uri=="string"&&(!A.name||typeof A.name=="string")}function u(k,A,W,F,K){if(k.scheme!==F.scheme)return{name:W,uri:k.toString(!0)};let ie=A?void 0:K.relativePath(F,k);if(ie!==void 0)ie.length===0?ie=".":h.isWindows&&(ie=c(ie));else if(k.scheme===D.Schemas.file)ie=k.fsPath,h.isWindows&&(ie=c(ie));else if(K.isEqualAuthority(k.authority,F.authority))ie=k.path;else return{name:W,uri:k.toString(!0)};return{name:W,path:ie}}e.getStoredWorkspaceFolder=u;function c(k){return k=(0,R.normalizeDriveLetter)(k),(0,S.isUNC)(k)||(k=(0,S.toSlashes)(k)),k}function o(k,A,W){const F=[],K=new Set,ie=W.dirname(A);for(const oe of k){let ue;if(v(oe))oe.path&&(ue=W.resolvePath(ie,oe.path));else if(f(oe))try{ue=E.URI.parse(oe.uri),ue.path[0]!==b.posix.sep&&(ue=ue.with({path:b.posix.sep+ue.path}))}catch(ne){console.warn(ne)}if(ue){const ne=W.getComparisonKey(ue);if(!K.has(ne)){K.add(ne);const ae=oe.name||W.basenameOrAuthority(ue);F.push(new g.WorkspaceFolder({uri:ue,name:ae,index:F.length},oe))}}}return F}e.toWorkspaceFolders=o;function r(k,A,W,F,K){const ie=i(A,k),oe=K.dirname(A),ue=K.dirname(F),ne=[];for(const B of ie.folders){const N=v(B)?K.resolvePath(oe,B.path):E.URI.parse(B.uri);let O;W?O=!1:O=!v(B)||(0,b.isAbsolute)(B.path),ne.push(u(N,O,B.name,ue,K))}const ae={insertSpaces:!1,tabSize:4,eol:h.isLinux||h.isMacintosh?`
`:`\r
`},le=M.setProperty(k,["folders"],ne,ae);let G=M.applyEdits(k,le);return(0,w.isEqualAuthority)(ie.remoteAuthority,(0,p.getRemoteAuthority)(F))&&(G=M.applyEdits(G,M.removeProperty(G,["remoteAuthority"],ae))),G}e.rewriteWorkspaceFileForNewLocation=r;function i(k,A){const W=t.parse(A);if(W&&Array.isArray(W.folders))W.folders=W.folders.filter(F=>m(F));else throw new Error(`${k} looks like an invalid workspace file.`);return W}function n(k){return k.workspace&&typeof k.workspace=="object"&&typeof k.workspace.id=="string"&&typeof k.workspace.configPath=="string"}function s(k){return typeof k.folderUri=="string"}function a(k){return typeof k.fileUri=="string"}function l(k,A){const W={workspaces:[],files:[]};if(k){const F=function(ie,oe){for(let ue=0;ue<ie.length;ue++)try{oe(ie[ue],ue)}catch(ne){A.warn(`Error restoring recent entry ${JSON.stringify(ie[ue])}: ${ne.toString()}. Skip entry.`)}},K=k;Array.isArray(K.entries)&&F(K.entries,ie=>{const oe=ie.label,ue=ie.remoteAuthority;n(ie)?W.workspaces.push({label:oe,remoteAuthority:ue,workspace:{id:ie.workspace.id,configPath:E.URI.parse(ie.workspace.configPath)}}):s(ie)?W.workspaces.push({label:oe,remoteAuthority:ue,folderUri:E.URI.parse(ie.folderUri)}):a(ie)&&W.files.push({label:oe,remoteAuthority:ue,fileUri:E.URI.parse(ie.fileUri)})})}return W}e.restoreRecentlyOpened=l;function I(k){const A={entries:[]};for(const W of k.workspaces)P(W)?A.entries.push({folderUri:W.folderUri.toString(),label:W.label,remoteAuthority:W.remoteAuthority}):A.entries.push({workspace:{id:W.workspace.id,configPath:W.workspace.configPath.toString()},label:W.label,remoteAuthority:W.remoteAuthority});for(const W of k.files)A.entries.push({fileUri:W.fileUri.toString(),label:W.label,remoteAuthority:W.remoteAuthority});return A}e.toStoreData=I}),define(X[113],J([0,1,75,28,13,4,16]),function(z,e,S,t,M,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function b(w){function E(){let C=w.scheme===M.Schemas.file?(0,D.originalFSPath)(w):w.toString();return R.isLinux||(C=C.toLowerCase()),(0,S.createHash)("md5").update(C).digest("hex")}return{id:E(),configPath:w}}e.getWorkspaceIdentifier=b;function h(w,E){function C(){if(w.scheme!==M.Schemas.file)return(0,S.createHash)("md5").update(w.toString()).digest("hex");if(!E)try{E=(0,t.statSync)(w.fsPath)}catch{return}let g;return R.isLinux?g=E.ino:R.isMacintosh?g=E.birthtime.getTime():R.isWindows&&(typeof E.birthtimeMs=="number"?g=Math.floor(E.birthtimeMs):g=E.birthtime.getTime()),(0,S.createHash)("md5").update(w.fsPath).update(g?String(g):"").digest("hex")}const p=C();if(typeof p=="string")return{id:p,uri:w}}e.getSingleFolderWorkspaceIdentifier=h}),define(X[46],J([0,1,14,28,3,48,34,2,13,9,16,11,23,167,58,54,26,5,6,20,63,112,24,89,113]),function(z,e,S,t,M,R,D,b,h,w,E,C,p,g,d,P,y,m,v,f,u,c,o,r,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,m.createDecorator)("workspacesManagementMainService");let n=class extends b.Disposable{constructor(a,l,I,k,A,W){super();this.environmentMainService=a,this.logService=l,this.userDataProfilesMainService=I,this.backupMainService=k,this.dialogMainService=A,this.productService=W,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new M.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new M.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(a){return this.doResolveLocalWorkspace(a,l=>(0,t.readFileSync)(l,"utf8"))}resolveLocalWorkspace(a){return this.doResolveLocalWorkspace(a,l=>p.Promises.readFile(l,"utf8"))}doResolveLocalWorkspace(a,l){if(!!this.isWorkspacePath(a)&&a.scheme===h.Schemas.file)try{const I=l(a.fsPath);return I instanceof Promise?I.then(k=>this.doResolveWorkspace(a,k),k=>{}):this.doResolveWorkspace(a,I)}catch{return}}isWorkspacePath(a){return(0,o.isUntitledWorkspace)(a,this.environmentMainService)||(0,o.hasWorkspaceFileExtension)(a)}doResolveWorkspace(a,l){try{const I=this.doParseStoredWorkspace(a,l),k=(0,i.getWorkspaceIdentifier)(a);return{id:k.id,configPath:k.configPath,folders:(0,r.toWorkspaceFolders)(I.folders,k.configPath,E.extUriBiasedIgnorePathCase),remoteAuthority:I.remoteAuthority,transient:I.transient}}catch(I){this.logService.warn(I.toString())}}doParseStoredWorkspace(a,l){const I=(0,R.parse)(l);if(I&&Array.isArray(I.folders))I.folders=I.folders.filter(k=>(0,r.isStoredWorkspaceFolder)(k));else throw new Error(`${a.toString(!0)} looks like an invalid workspace file.`);return I}async createUntitledWorkspace(a,l){const{workspace:I,storedWorkspace:k}=this.newUntitledWorkspace(a,l),A=I.configPath.fsPath;return await p.Promises.mkdir((0,w.dirname)(A),{recursive:!0}),await p.Promises.writeFile(A,JSON.stringify(k,null,"	")),I}createUntitledWorkspaceSync(a,l){const{workspace:I,storedWorkspace:k}=this.newUntitledWorkspace(a,l),A=I.configPath.fsPath;return(0,t.mkdirSync)((0,w.dirname)(A),{recursive:!0}),(0,p.writeFileSync)(A,JSON.stringify(k,null,"	")),I}newUntitledWorkspace(a=[],l){const I=(Date.now()+Math.round(Math.random()*1e3)).toString(),k=(0,E.joinPath)(this.untitledWorkspacesHome,I),A=(0,E.joinPath)(k,o.UNTITLED_WORKSPACE_NAME),W=[];for(const F of a)W.push((0,r.getStoredWorkspaceFolder)(F.uri,!0,F.name,k,E.extUriBiasedIgnorePathCase));return{workspace:(0,i.getWorkspaceIdentifier)(A),storedWorkspace:{folders:W,remoteAuthority:l}}}async getWorkspaceIdentifier(a){return(0,i.getWorkspaceIdentifier)(a)}isUntitledWorkspace(a){return(0,o.isUntitledWorkspace)(a.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(a){!this.isUntitledWorkspace(a)||(this.doDeleteUntitledWorkspaceSync(a),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(a),this._onDidDeleteUntitledWorkspace.fire(a))}async deleteUntitledWorkspace(a){this.deleteUntitledWorkspaceSync(a)}doDeleteUntitledWorkspaceSync(a){const l=(0,E.originalFSPath)(a.configPath);try{(0,p.rimrafSync)((0,w.dirname)(l));const I=(0,w.join)(this.environmentMainService.workspaceStorageHome.fsPath,a.id);(0,t.existsSync)(I)&&(0,p.writeFileSync)((0,w.join)(I,"obsolete"),"")}catch(I){this.logService.warn(`Unable to delete untitled workspace ${l} (${I}).`)}}getUntitledWorkspacesSync(){const a=[];try{const l=(0,p.readdirSync)(this.untitledWorkspacesHome.fsPath).map(I=>(0,E.joinPath)(this.untitledWorkspacesHome,I,o.UNTITLED_WORKSPACE_NAME));for(const I of l){const k=(0,i.getWorkspaceIdentifier)(I),A=this.resolveLocalWorkspaceSync(I);A?a.push({workspace:k,remoteAuthority:A.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(k)}}catch(l){l.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${l}).`)}return a}async enterWorkspace(a,l,I){if(!a||!a.win||!a.isReady||!await this.isValidTargetWorkspacePath(a,l,I))return;const A=this.doEnterWorkspace(a,(0,i.getWorkspaceIdentifier)(I));if(!!A)return this._onDidEnterWorkspace.fire({window:a,workspace:A.workspace}),A}async isValidTargetWorkspacePath(a,l,I){if(!I)return!0;if((0,o.isWorkspaceIdentifier)(a.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(a.openedWorkspace.configPath,I))return!1;if((0,c.findWindowOnWorkspaceOrFolder)(l,I)){const k={title:this.productService.nameLong,type:"info",buttons:[(0,D.mnemonicButtonLabel)((0,g.localize)(0,null))],message:(0,g.localize)(1,null,(0,E.basename)(I)),detail:(0,g.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(k,(0,C.withNullAsUndefined)(S.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(a,l){if(!a.config)return;a.focus();let I;return a.config.extensionDevelopmentPath||(I=this.backupMainService.registerWorkspaceBackupSync({workspace:l,remoteAuthority:a.remoteAuthority},a.config.backupPath)),(0,o.isWorkspaceIdentifier)(a.openedWorkspace)&&this.isUntitledWorkspace(a.openedWorkspace)&&this.deleteUntitledWorkspaceSync(a.openedWorkspace),a.config.workspace=l,a.config.backupPath=I,{workspace:l,backupPath:I}}};n=ge([ee(0,y.IEnvironmentMainService),ee(1,v.ILogService),ee(2,u.IUserDataProfilesMainService),ee(3,d.IBackupMainService),ee(4,P.IDialogMainService),ee(5,f.IProductService)],n),e.WorkspacesManagementMainService=n}),define(X[114],J([0,1,38,21,5,32,24,46]),function(z,e,S,t,M,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,M.createDecorator)(e.ID);let h=class{constructor(E,C){this.windowsMainService=E,this.workspacesManagementMainService=C}async getRemoteDiagnostics(E){const C=this.windowsMainService.getWindows();return(await Promise.all(C.map(g=>new Promise(d=>{const P=g.remoteAuthority;if(P){const y=`vscode:getDiagnosticInfoResponse${g.id}`,m={includeProcesses:E.includeProcesses,folders:E.includeWorkspaceMetadata?this.getFolderURIs(g):void 0};g.sendWhenReady("vscode:getDiagnosticInfo",t.CancellationToken.None,{replyChannel:y,args:m}),S.validatedIpcMain.once(y,(v,f)=>{f||d({hostName:P,errorMessage:`Unable to resolve connection to '${P}'.`}),d(f)}),setTimeout(()=>{d({hostName:P,errorMessage:`Connection to '${P}' could not be established`})},5e3)}else d(void 0)})))).filter(g=>!!g)}getFolderURIs(E){const C=[],p=E.openedWorkspace;if((0,D.isSingleFolderWorkspaceIdentifier)(p))C.push(p.uri);else if((0,D.isWorkspaceIdentifier)(p)){const g=this.workspacesManagementMainService.resolveLocalWorkspaceSync(p.configPath);g&&g.folders.forEach(P=>{C.push(P.uri)})}return C}};h=ge([ee(0,R.IWindowsMainService),ee(1,b.IWorkspacesManagementMainService)],h),e.DiagnosticsMainService=h}),define(X[115],J([0,1,14,25,4,11,7,23,18,57,5,6,109,32,24,46]),function(z,e,S,t,M,R,D,b,h,w,E,C,p,g,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,E.createDecorator)(e.ID);let y=class{constructor(v,f,u,c,o){this.logService=v,this.windowsMainService=f,this.urlService=u,this.workspacesManagementMainService=c,this.configurationService=o}async start(v,f){this.logService.trace("Received data from other instance: ",v,f),M.isMacintosh&&S.app.focus({steal:!0});const u=this.parseOpenUrl(v);if(u.length){let c=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(c=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),c.then(()=>{for(const{uri:o,url:r}of u)this.urlService.open(o,{originalUrl:r})})}else return this.startOpenWindow(v,f)}parseOpenUrl(v){return v["open-url"]&&v._urls&&v._urls.length>0?(0,t.coalesce)(v._urls.map(f=>{try{return{uri:D.URI.parse(f),url:f}}catch{return null}})):[]}async startOpenWindow(v,f){const u=(0,w.isLaunchedFromCli)(f)?0:4;let c=[];const o=v.wait&&v.waitMarkerFilePath?D.URI.file(v.waitMarkerFilePath):void 0,r=v.remote||void 0,i={context:u,cli:v,userEnv:f,waitMarkerFileURI:o,remoteAuthority:r};if(v.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(v.extensionDevelopmentPath,i);else if(!v._.length&&!v["folder-uri"]&&!v["file-uri"]){let n=!1;if(v["new-window"]||v["unity-launch"])n=!0;else if(v["reuse-window"])n=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":n=!0;break;case"off":n=!1;break;default:n=!M.isMacintosh}if(n)c=this.windowsMainService.open({...i,forceNewWindow:!0,forceEmpty:!0});else{const s=this.windowsMainService.getLastActiveWindow();s?(this.windowsMainService.openExistingWindow(s,i),c=[s]):c=this.windowsMainService.open({...i,forceEmpty:!0})}}else c=this.windowsMainService.open({...i,forceNewWindow:v["new-window"],preferNewWindow:!v["reuse-window"]&&!v.wait,forceReuseWindow:v["reuse-window"],diffMode:v.diff,mergeMode:v.merge,addMode:v.add,noRecentEntry:!!v["skip-add-to-recently-opened"],gotoLineMode:v.goto});if(o&&c.length===1&&c[0])return Promise.race([c[0].whenClosedOrLoaded,(0,b.whenDeleted)(o.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const v=[];return S.BrowserWindow.getAllWindows().forEach(f=>{const u=this.windowsMainService.getWindowById(f.id);u?v.push(this.codeWindowToInfo(u)):v.push(this.browserWindowToInfo(f))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:v,screenReader:!!S.app.accessibilitySupportEnabled,gpuFeatureStatus:S.app.getGPUFeatureStatus()}}getFolderURIs(v){const f=[],u=v.openedWorkspace;if((0,d.isSingleFolderWorkspaceIdentifier)(u))f.push(u.uri);else if((0,d.isWorkspaceIdentifier)(u)){const c=this.workspacesManagementMainService.resolveLocalWorkspaceSync(u.configPath);c&&c.folders.forEach(r=>{f.push(r.uri)})}return f}codeWindowToInfo(v){const f=this.getFolderURIs(v),u=(0,R.assertIsDefined)(v.win);return this.browserWindowToInfo(u,f,v.remoteAuthority)}browserWindowToInfo(v,f=[],u){return{pid:v.webContents.getOSProcessId(),title:v.getTitle(),folderURIs:f,remoteAuthority:u}}};y=ge([ee(0,C.ILogService),ee(1,g.IWindowsMainService),ee(2,p.IURLService),ee(3,P.IWorkspacesManagementMainService),ee(4,h.IConfigurationService)],y),e.LaunchMainService=y}),define(X[64],J([0,1,49,14,29,136,50,3,34,2,13,9,4,7,93,80,23,90,157,54,26,5,22,6,20,61,32,24,46,17]),function(z,e,S,t,M,R,D,b,h,w,E,C,p,g,d,P,y,m,v,f,u,c,o,r,i,n,s,a,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,c.createDecorator)("nativeHostMainService");let k=class extends w.Disposable{constructor(W,F,K,ie,oe,ue,ne,ae,le){super();this.sharedProcess=W,this.windowsMainService=F,this.dialogMainService=K,this.lifecycleMainService=ie,this.environmentMainService=oe,this.logService=ue,this.productService=ne,this.themeMainService=ae,this.workspacesManagementMainService=le,this.onDidOpenWindow=b.Event.map(this.windowsMainService.onDidOpenWindow,G=>G.id),this.onDidTriggerSystemContextMenu=b.Event.filter(b.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:G,x:B,y:N})=>({windowId:G.id,x:B,y:N})),({windowId:G})=>!!this.windowsMainService.getWindowById(G)),this.onDidMaximizeWindow=b.Event.filter(b.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",(G,B)=>B.id),G=>!!this.windowsMainService.getWindowById(G)),this.onDidUnmaximizeWindow=b.Event.filter(b.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",(G,B)=>B.id),G=>!!this.windowsMainService.getWindowById(G)),this.onDidBlurWindow=b.Event.filter(b.Event.fromNodeEventEmitter(t.app,"browser-window-blur",(G,B)=>B.id),G=>!!this.windowsMainService.getWindowById(G)),this.onDidFocusWindow=b.Event.any(b.Event.map(b.Event.filter(b.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),G=>!!G),G=>G.id),b.Event.filter(b.Event.fromNodeEventEmitter(t.app,"browser-window-focus",(G,B)=>B.id),G=>!!this.windowsMainService.getWindowById(G))),this.onDidResumeOS=b.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new b.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=b.Event.debounce(b.Event.any(b.Event.filter(b.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",(G,B,N)=>N),G=>!(Array.isArray(G)&&G.length===1&&G[0]==="workArea")),b.Event.fromNodeEventEmitter(t.screen,"display-added"),b.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(F=>({id:F.id,workspace:F.openedWorkspace,title:F.win?.getTitle()??"",filename:F.getRepresentedFilename(),dirty:F.isDocumentEdited()}))}async getWindowCount(W){return this.windowsMainService.getWindowCount()}async getActiveWindowId(W){const F=t.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(F)return F.id}openWindow(W,F,K){return Array.isArray(F)?this.doOpenWindow(W,F,K):this.doOpenEmptyWindow(W,F)}async doOpenWindow(W,F,K=Object.create(null)){F.length>0&&this.windowsMainService.open({context:5,contextWindowId:W,urisToOpen:F,cli:this.environmentMainService.args,forceNewWindow:K.forceNewWindow,forceReuseWindow:K.forceReuseWindow,preferNewWindow:K.preferNewWindow,diffMode:K.diffMode,mergeMode:K.mergeMode,addMode:K.addMode,gotoLineMode:K.gotoLineMode,noRecentEntry:K.noRecentEntry,waitMarkerFileURI:K.waitMarkerFileURI,remoteAuthority:K.remoteAuthority||void 0})}async doOpenEmptyWindow(W,F){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:W},F)}async toggleFullScreen(W){this.windowById(W)?.toggleFullScreen()}async handleTitleDoubleClick(W){this.windowById(W)?.handleTitleDoubleClick()}async isMaximized(W){const F=this.windowById(W);return F?.win?F.win.isMaximized():!1}async maximizeWindow(W){const F=this.windowById(W);F?.win&&F.win.maximize()}async unmaximizeWindow(W){const F=this.windowById(W);F?.win&&F.win.unmaximize()}async minimizeWindow(W){const F=this.windowById(W);F?.win&&F.win.minimize()}async updateWindowControls(W,F){const K=this.windowById(W);K&&K.updateWindowControls(F)}async focusWindow(W,F){F&&typeof F.windowId=="number"&&(W=F.windowId),this.windowById(W)?.focus({force:F?.force??!1})}async setMinimumSize(W,F,K){const ie=this.windowById(W);if(ie?.win){const[oe,ue]=ie.win.getSize(),[ne,ae]=ie.win.getMinimumSize(),[le,G]=[F??ne,K??ae],[B,N]=[Math.max(oe,le),Math.max(ue,G)];(ne!==le||ae!==G)&&ie.win.setMinimumSize(le,G),(oe!==B||ue!==N)&&ie.win.setSize(B,N)}}async saveWindowSplash(W,F){this.themeMainService.saveWindowSplash(W,F)}async installShellCommand(W){const{source:F,target:K}=await this.getShellCommandLink();try{const{symbolicLink:ie}=await y.SymlinkSupport.stat(F);if(ie&&!ie.dangling){const oe=await(0,d.realpath)(F);if(K===oe)return}await y.Promises.unlink(F)}catch(ie){if(ie.code!=="ENOENT")throw ie}try{await y.Promises.symlink(K,F)}catch(ie){if(ie.code!=="EACCES"&&ie.code!=="ENOENT")throw ie;const{response:oe}=await this.showMessageBox(W,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(0,null,this.productService.nameShort),buttons:[(0,h.mnemonicButtonLabel)((0,v.localize)(1,null)),(0,h.mnemonicButtonLabel)((0,v.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(oe===0)try{const ue=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${K}' '${F}'\\" with administrator privileges"`;await(0,R.promisify)(S.exec)(ue)}catch{throw new Error((0,v.localize)(3,null,F))}}}async uninstallShellCommand(W){const{source:F}=await this.getShellCommandLink();try{await y.Promises.unlink(F)}catch(K){switch(K.code){case"EACCES":{const{response:ie}=await this.showMessageBox(W,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(4,null,this.productService.nameShort),buttons:[(0,h.mnemonicButtonLabel)((0,v.localize)(5,null)),(0,h.mnemonicButtonLabel)((0,v.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(ie===0)try{const oe=`osascript -e "do shell script \\"rm '${F}'\\" with administrator privileges"`;await(0,R.promisify)(S.exec)(oe)}catch{throw new Error((0,v.localize)(7,null,F))}break}case"ENOENT":break;default:throw K}}}async getShellCommandLink(){const W=(0,C.resolve)(this.environmentMainService.appRoot,"bin","code"),F=`/usr/local/bin/${this.productService.applicationName}`;if(!await y.Promises.exists(W))throw new Error((0,v.localize)(8,null,W));return{source:F,target:W}}async showMessageBox(W,F){return this.dialogMainService.showMessageBox(F,this.toBrowserWindow(W))}async showSaveDialog(W,F){return this.dialogMainService.showSaveDialog(F,this.toBrowserWindow(W))}async showOpenDialog(W,F){return this.dialogMainService.showOpenDialog(F,this.toBrowserWindow(W))}toBrowserWindow(W){const F=this.windowById(W);if(F?.win)return F.win}async pickFileFolderAndOpen(W,F){const K=await this.dialogMainService.pickFileFolder(F);K&&this.doOpenPicked(await Promise.all(K.map(async ie=>await y.SymlinkSupport.existsDirectory(ie)?{folderUri:g.URI.file(ie)}:{fileUri:g.URI.file(ie)})),F,W)}async pickFolderAndOpen(W,F){const K=await this.dialogMainService.pickFolder(F);K&&this.doOpenPicked(K.map(ie=>({folderUri:g.URI.file(ie)})),F,W)}async pickFileAndOpen(W,F){const K=await this.dialogMainService.pickFile(F);K&&this.doOpenPicked(K.map(ie=>({fileUri:g.URI.file(ie)})),F,W)}async pickWorkspaceAndOpen(W,F){const K=await this.dialogMainService.pickWorkspace(F);K&&this.doOpenPicked(K.map(ie=>({workspaceUri:g.URI.file(ie)})),F,W)}doOpenPicked(W,F,K){this.windowsMainService.open({context:3,contextWindowId:K,cli:this.environmentMainService.args,urisToOpen:W,forceNewWindow:F.forceNewWindow})}async showItemInFolder(W,F){t.shell.showItemInFolder(F)}async setRepresentedFilename(W,F){this.windowById(W)?.setRepresentedFilename(F)}async setDocumentEdited(W,F){this.windowById(W)?.setDocumentEdited(F)}async openExternal(W,F){return p.isLinuxSnap?this.safeSnapOpenExternal(F):t.shell.openExternal(F),!0}safeSnapOpenExternal(W){const F=process.env.GDK_PIXBUF_MODULE_FILE,K=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(W),process.env.GDK_PIXBUF_MODULE_FILE=F,process.env.GDK_PIXBUF_MODULEDIR=K}moveItemToTrash(W,F){return t.shell.trashItem(F)}async isAdmin(){let W;return p.isWindows?W=(await new Promise((F,K)=>{z(["native-is-elevated"],F,K)}))():W=process.getuid()===0,W}async writeElevated(W,F,K,ie){const oe=await new Promise((ue,ne)=>{z(["@vscode/sudo-prompt"],ue,ne)});return new Promise((ue,ne)=>{const ae=[`"${this.cliPath}"`];ie?.unlock&&ae.push("--file-chmod"),ae.push("--file-write",`"${F.fsPath}"`,`"${K.fsPath}"`);const le={name:this.productService.nameLong.replace("-",""),icns:p.isMacintosh&&this.environmentMainService.isBuilt?(0,C.join)((0,C.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};oe.exec(ae.join(" "),le,(G,B,N)=>{B&&this.logService.trace(`[sudo-prompt] received stdout: ${B}`),N&&this.logService.trace(`[sudo-prompt] received stderr: ${N}`),G?ne(G):ue(void 0)})})}get cliPath(){return p.isWindows?this.environmentMainService.isBuilt?(0,C.join)((0,C.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,C.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):p.isLinux?this.environmentMainService.isBuilt?(0,C.join)((0,C.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,C.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,C.join)(this.environmentMainService.appRoot,"bin","code"):(0,C.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,M.totalmem)(),freemem:(0,M.freemem)(),loadavg:(0,M.loadavg)()}}async getOSProperties(){return{arch:(0,M.arch)(),platform:(0,M.platform)(),release:(0,M.release)(),type:(0,M.type)(),cpus:(0,M.cpus)()}}async getOSVirtualMachineHint(){return P.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async killProcess(W,F,K){process.kill(F,K)}async readClipboardText(W,F){return t.clipboard.readText(F)}async writeClipboardText(W,F,K){return t.clipboard.writeText(F,K)}async readClipboardFindText(W){return t.clipboard.readFindText()}async writeClipboardFindText(W,F){return t.clipboard.writeFindText(F)}async writeClipboardBuffer(W,F,K,ie){return t.clipboard.writeBuffer(F,Buffer.from(K.buffer),ie)}async readClipboardBuffer(W,F){return I.VSBuffer.wrap(t.clipboard.readBuffer(F))}async hasClipboard(W,F,K){return t.clipboard.has(F,K)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(W,F){this.windowById(W)?.updateTouchBar(F)}async notifyReady(W){this.windowById(W)?.setReady()}async relaunch(W,F){return this.lifecycleMainService.relaunch(F)}async reload(W,F){const K=this.windowById(W);if(K){if((0,a.isWorkspaceIdentifier)(K.openedWorkspace)){const ie=K.openedWorkspace.configPath;if(ie.scheme===E.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(ie))?.transient)return this.openWindow(K.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(K,F?.disableExtensions!==void 0?{_:[],"disable-extensions":F.disableExtensions}:void 0)}}async closeWindow(W){this.closeWindowById(W,W)}async closeWindowById(W,F){const K=this.windowById(F);if(K?.win)return K.win.close()}async quit(W){const F=this.windowsMainService.getLastActiveWindow();F?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&F.win?F.win.close():this.lifecycleMainService.quit()}async exit(W,F){await this.lifecycleMainService.kill(F)}async resolveProxy(W,F){const ie=this.windowById(W)?.win?.webContents?.session;if(ie)return ie.resolveProxy(F)}findFreePort(W,F,K,ie,oe=1){return(0,m.findFreePort)(F,K,ie,oe)}async openDevTools(W,F){const K=this.windowById(W);K?.win&&K.win.webContents.openDevTools(F)}async toggleDevTools(W){const F=this.windowById(W);F?.win&&F.win.webContents.toggleDevTools()}async sendInputEvent(W,F){const K=this.windowById(W);K?.win&&(F.type==="mouseDown"||F.type==="mouseUp")&&K.win.webContents.sendInputEvent(F)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(W,F,K,ie){if(!p.isWindows)return;const oe=await new Promise((ue,ne)=>{z(["@vscode/windows-registry"],ue,ne)});try{return oe.GetStringRegKey(F,K,ie)}catch{return}}windowById(W){if(typeof W=="number")return this.windowsMainService.getWindowById(W)}};ge([D.memoize],k.prototype,"cliPath",null),k=ge([ee(1,s.IWindowsMainService),ee(2,f.IDialogMainService),ee(3,o.ILifecycleMainService),ee(4,u.IEnvironmentMainService),ee(5,r.ILogService),ee(6,i.IProductService),ee(7,n.IThemeMainService),ee(8,l.IWorkspacesManagementMainService)],k),e.NativeHostMainService=k}),define(X[245],J([0,1,14,38,29,34,2,13,4,94,155,83,114,54,26,5,115,6,64,52,20,59,73]),function(z,e,S,t,M,R,D,b,h,w,E,C,p,g,d,P,y,m,v,f,u,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,P.createDecorator)("issueMainService");let r=class Lt{constructor(n,s,a,l,I,k,A,W,F,K){this.userEnv=n,this.environmentMainService=s,this.launchMainService=a,this.logService=l,this.diagnosticsService=I,this.diagnosticsMainService=k,this.dialogMainService=A,this.nativeHostMainService=W,this.protocolMainService=F,this.productService=K,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async n=>{const[s,a]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),l=await this.diagnosticsService.getSystemInfo(s,a);this.safeSend(n,"vscode:issueSystemInfoResponse",l)}),t.validatedIpcMain.on("vscode:listProcesses",async n=>{const s=[];try{const a=await this.launchMainService.getMainProcessId();s.push({name:(0,E.localize)(0,null),rootProcess:await(0,w.listProcesses)(a)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(I=>{(0,C.isRemoteDiagnosticError)(I)?s.push({name:I.hostName,rootProcess:I}):I.processes&&s.push({name:I.hostName,rootProcess:I.processes})})}catch(a){this.logService.error(`Listing processes failed: ${a}`)}this.safeSend(n,"vscode:listProcessesResponse",s)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async n=>{const s={title:this.productService.nameLong,message:(0,E.localize)(1,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,E.localize)(2,null)),(0,R.mnemonicButtonLabel)((0,E.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const a=await this.dialogMainService.showMessageBox(s,this.issueReporterWindow);this.safeSend(n,"vscode:issueReporterClipboardResponse",a.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async n=>{const s=await this.getPerformanceInfo();this.safeSend(n,"vscode:issuePerformanceInfoResponse",s)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const n={title:this.productService.nameLong,message:(0,E.localize)(4,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,E.localize)(5,null)),(0,R.mnemonicButtonLabel)((0,E.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(n,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(n,s)=>{const{id:a,from:l,args:I}=s;let k;switch(l){case"issueReporter":k=this.issueReporterParentWindow;break;case"processExplorer":k=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${l}`)}k?.webContents.send("vscode:runAction",{id:a,from:l,args:I})}),t.validatedIpcMain.on("vscode:openExternal",(n,s)=>{this.nativeHostMainService.openExternal(void 0,s)}),t.validatedIpcMain.on("vscode:closeIssueReporter",n=>{this.issueReporterWindow?.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",n=>{this.processExplorerWindow?.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async n=>{const s=await this.launchMainService.getMainProcessInfo();this.safeSend(n,"vscode:windowsInfoResponse",s.windows)})}safeSend(n,s,...a){n.sender.isDestroyed()||n.sender.send(s,...a)}async openReporter(n){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=S.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const s=new D.DisposableStore,a=s.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(l,a,{backgroundColor:n.styles.backgroundColor,title:(0,E.localize)(7,null),zoomLevel:n.zoomLevel,alwaysOnTop:!1},"issue-reporter"),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:n,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,M.type)(),arch:(0,M.arch)(),release:(0,M.release)()},product:f.default}),this.issueReporterWindow.loadURL(b.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",z).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,s.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,s.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(n){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=S.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const s=new D.DisposableStore,a=s.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(l,a,{backgroundColor:n.styles.backgroundColor,title:(0,E.localize)(8,null),zoomLevel:n.zoomLevel,alwaysOnTop:!0},"process-explorer"),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:n,product:f.default}),this.processExplorerWindow.loadURL(b.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",z).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,s.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,s.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(n){n.isMinimized()&&n.restore(),n.focus()}createBrowserWindow(n,s,a,l){const I=new S.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:n.width,height:n.height,minWidth:300,minHeight:200,x:n.x,y:n.y,title:a.title,backgroundColor:a.backgroundColor||Lt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:b.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${s.resource.toString()}`,`--vscode-window-kind=${l}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,o.zoomLevelToZoomFactor)(a.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:a.alwaysOnTop,experimentalDarkMode:!0});return I.setMenuBarVisibility(!1),I}async getSystemStatus(){const[n,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(n,s)}getWindowPosition(n,s,a){let l;const I=S.screen.getAllDisplays();if(I.length===1)l=I[0];else{if(h.isMacintosh){const W=S.screen.getCursorScreenPoint();l=S.screen.getDisplayNearestPoint(W)}!l&&n&&(l=S.screen.getDisplayMatching(n.getBounds())),l||(l=S.screen.getPrimaryDisplay()||I[0])}const k={width:s,height:a},A=l.bounds;return k.x=A.x+A.width/2-k.width/2,k.y=A.y+A.height/2-k.height/2,A.width>0&&A.height>0&&(k.x<A.x&&(k.x=A.x),k.y<A.y&&(k.y=A.y),k.x>A.x+A.width&&(k.x=A.x),k.y>A.y+A.height&&(k.y=A.y),k.width>A.width&&(k.width=A.width),k.height>A.height&&(k.height=A.height)),k}async getPerformanceInfo(){try{const[n,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(n,s)}catch(n){throw this.logService.warn("issueService#getPerformanceInfo ",n.message),n}}};r.DEFAULT_BACKGROUND_COLOR="#1E1E1E",r=ge([ee(1,d.IEnvironmentMainService),ee(2,y.ILaunchMainService),ee(3,m.ILogService),ee(4,C.IDiagnosticsService),ee(5,p.IDiagnosticsMainService),ee(6,g.IDialogMainService),ee(7,v.INativeHostMainService),ee(8,c.IProtocolMainService),ee(9,u.IProductService)],r),e.IssueMainService=r}),define(X[246],J([0,1,21,18,26,22,6,64,20,53,35,45,87]),function(z,e,S,t,M,R,D,b,h,w,E,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let g=class extends p.AbstractUpdateService{constructor(P,y,m,v,f,u,c,o){super(P,y,v,f,u,o);this.telemetryService=m,this.nativeHostMainService=c}buildUpdateFeedUrl(P){return(0,p.createUpdateURL)(`linux-${process.arch}`,P,this.productService)}doCheckForUpdates(P){!this.url||(this.setState(C.State.CheckingForUpdates(P)),this.requestService.request({url:this.url},S.CancellationToken.None).then(w.asJson).then(y=>{!y||!y.url||!y.version||!y.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!P}),this.setState(C.State.Idle(1))):this.setState(C.State.AvailableForDownload(y))}).then(void 0,y=>{this.logService.error(y),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!P});const m=P?y.message||y:void 0;this.setState(C.State.Idle(1,m))}))}async doDownloadUpdate(P){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):P.update.url&&this.nativeHostMainService.openExternal(void 0,P.update.url),this.setState(C.State.Idle(1))}};g=ge([ee(0,R.ILifecycleMainService),ee(1,t.IConfigurationService),ee(2,E.ITelemetryService),ee(3,M.IEnvironmentMainService),ee(4,w.IRequestService),ee(5,D.ILogService),ee(6,b.INativeHostMainService),ee(7,h.IProductService)],g),e.LinuxUpdateService=g}),define(X[247],J([0,1,49,28,29,8,21,50,9,7,124,23,18,26,15,22,6,64,20,53,35,45,87]),function(z,e,S,t,M,R,D,b,h,w,E,C,p,g,d,P,y,m,v,f,u,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function r(a,l=1e3){for(;!a();)await(0,R.timeout)(l)}let i;function n(){return typeof i=="undefined"&&(i=t.existsSync(h.join(h.dirname(process.execPath),"unins000.exe"))?0:1),i}let s=class extends o.AbstractUpdateService{constructor(l,I,k,A,W,F,K,ie,oe){super(l,I,A,W,F,oe);this.telemetryService=k,this.fileService=K,this.nativeHostMainService=ie}get cachePath(){const l=h.join((0,M.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return C.Promises.mkdir(l,{recursive:!0}).then(()=>l)}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}buildUpdateFeedUrl(l){let I="win32";return process.arch!=="ia32"&&(I+=`-${process.arch}`),n()===1?I+="-archive":this.productService.target==="user"&&(I+="-user"),(0,o.createUpdateURL)(I,l,this.productService)}doCheckForUpdates(l){!this.url||(this.setState(c.State.CheckingForUpdates(l)),this.requestService.request({url:this.url},D.CancellationToken.None).then(f.asJson).then(I=>{const k=n();return!I||!I.url||!I.version||!I.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!l}),this.setState(c.State.Idle(k)),Promise.resolve(null)):k===1?(this.setState(c.State.AvailableForDownload(I)),Promise.resolve(null)):(this.setState(c.State.Downloading(I)),this.cleanup(I.version).then(()=>this.getUpdatePackagePath(I.version).then(A=>C.Promises.exists(A).then(W=>{if(W)return Promise.resolve(A);const F=I.url,K=I.hash,ie=`${A}.tmp`;return this.requestService.request({url:F},D.CancellationToken.None).then(oe=>this.fileService.writeFile(w.URI.file(ie),oe.stream)).then(K?()=>(0,E.checksum)(ie,I.hash):()=>{}).then(()=>C.Promises.rename(ie,A)).then(()=>A)})).then(A=>{const W=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:A},W&&I.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(I)):this.setState(c.State.Ready(I))})))}).then(void 0,I=>{this.logService.error(I),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!l});const k=l?I.message||I:void 0;this.setState(c.State.Idle(n(),k))}))}async doDownloadUpdate(l){l.update.url&&this.nativeHostMainService.openExternal(void 0,l.update.url),this.setState(c.State.Idle(n()))}async getUpdatePackagePath(l){const I=await this.cachePath;return h.join(I,`CodeSetup-${this.productService.quality}-${l}.exe`)}async cleanup(l=null){const I=l?F=>!new RegExp(`${this.productService.quality}-${l}\\.exe$`).test(F):()=>!0,k=await this.cachePath,W=(await C.Promises.readdir(k)).filter(I).map(async F=>{try{await C.Promises.unlink(h.join(k,F))}catch{}});await Promise.all(W)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const l=this.state.update;this.setState(c.State.Updating(l));const I=await this.cachePath;this.availableUpdate.updateFilePath=h.join(I,`CodeSetup-${this.productService.quality}-${l.version}.flag`),await C.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,S.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(c.State.Idle(n()))});const A=`${this.productService.win32MutexName}-ready`,W=await new Promise((F,K)=>{z(["windows-mutex"],F,K)});r(()=>W.isActive(A)).then(()=>this.setState(c.State.Ready(l)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?t.unlinkSync(this.availableUpdate.updateFilePath):(0,S.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return n()}async _applySpecificUpdate(l){if(this.state.type!=="idle")return;const I=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),k={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!I};this.setState(c.State.Downloading(k)),this.availableUpdate={packagePath:l},I?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(k)):this.setState(c.State.Ready(k))}};ge([b.memoize],s.prototype,"cachePath",null),s=ge([ee(0,P.ILifecycleMainService),ee(1,p.IConfigurationService),ee(2,u.ITelemetryService),ee(3,g.IEnvironmentMainService),ee(4,f.IRequestService),ee(5,y.ILogService),ee(6,d.IFileService),ee(7,m.INativeHostMainService),ee(8,v.IProductService)],s),e.Win32UpdateService=s}),define(X[248],J([0,1,14,8,21,42,3,34,2,13,9,70,4,7,163,58,18,54,26,57,15,22,6,20,59,217,88,35,220,61,73,32,24,46,110,118,37,41,66,40,52]),function(z,e,S,t,M,R,D,b,h,w,E,C,p,g,d,P,y,m,v,f,u,c,o,r,i,n,s,a,l,I,k,A,W,F,K,ie,oe,ue,ne,ae,le){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var G;(function(N){N[N.NONE=0]="NONE",N[N.NAVIGATING=1]="NAVIGATING",N[N.READY=2]="READY"})(G||(G={}));let B=class Mt extends h.Disposable{constructor(O,H,Z,$,j,L,T,_,q,Q,te,U,Y,x,re,ce,Ee,Ce,Pe){super();this.logService=H,this.environmentMainService=Z,this.policyService=$,this.userDataProfilesService=j,this.fileService=L,this.applicationStorageMainService=T,this.storageMainService=_,this.configurationService=q,this.themeMainService=Q,this.workspacesManagementMainService=te,this.backupMainService=U,this.telemetryService=Y,this.dialogMainService=x,this.lifecycleMainService=re,this.productService=ce,this.protocolMainService=Ee,this.windowsMainService=Ce,this.stateMainService=Pe,this._onWillLoad=this._register(new D.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new D.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidTriggerSystemContextMenu=this._register(new D.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidClose=this._register(new D.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new D.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[Me,Be]=this.restoreWindowState(O.state);this.windowState=Me,this.logService.trace("window#ctor: using window state",Me);const de=this.windowState.mode===0||this.windowState.mode===3,fe=this.configurationService.getValue("window");let pe=!1;typeof fe?.experimental?.useSandbox=="boolean"?pe=fe.experimental.useSandbox:pe=typeof le.default.quality=="string"&&le.default.quality!=="stable";const Ie={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:k.WindowMinimumSize.WIDTH,minHeight:k.WindowMinimumSize.HEIGHT,show:!de,title:this.productService.nameLong,webPreferences:{preload:w.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,k.zoomLevelToZoomFactor)(fe?.zoomLevel),enableBlinkFeatures:"HighlightAPI",...pe?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};p.isLinux?Ie.icon=(0,E.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):p.isWindows&&!this.environmentMainService.isBuilt&&(Ie.icon=(0,E.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),p.isMacintosh&&!this.useNativeFullScreen()&&(Ie.fullscreenable=!1),p.isMacintosh&&(Ie.acceptFirstMouse=!0,fe?.clickThroughInactive===!1&&(Ie.acceptFirstMouse=!1));const Le=p.isMacintosh&&fe?.nativeTabs===!0;Le&&(Ie.tabbingIdentifier=this.productService.nameShort);const Xe=(0,k.getTitleBarStyle)(this.configurationService)==="custom";if(Xe&&(Ie.titleBarStyle="hidden",p.isMacintosh||(Ie.frame=!1),(0,k.useWindowControlsOverlay)(this.configurationService,this.environmentMainService))){const Re=this.themeMainService.getWindowSplash()?.colorInfo.titleBarBackground??this.themeMainService.getBackgroundColor(),We=ie.Color.fromHex(Re).isDarker()?"#FFFFFF":"#000000";Ie.titleBarOverlay={height:29,color:Re,symbolColor:We}}if((0,C.mark)("code/willCreateCodeBrowserWindow"),this._win=new S.BrowserWindow(Ie),(0,C.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,p.isMacintosh&&Xe&&this._win.setSheetOffset(22),Xe&&(p.isWindows&&(0,k.useWindowControlsOverlay)(this.configurationService,this.environmentMainService)||p.isMacintosh)){const Re=this.stateMainService.getItem(Mt.windowControlHeightStateStorageKey);Re&&this.updateWindowControls({height:Re})}if(p.isWindows&&Xe){const Re=278;this._win.hookWindowMessage(Re,()=>{const[We,Te]=this._win.getPosition(),Ge=S.screen.getCursorScreenPoint(),je=Ge.x-We,Je=Ge.y-Te;return(()=>!(je>30&&Je>=0&&Je<=Math.max(this._win.getBounds().height*.15,35)))()||(this._win.setEnabled(!1),this._win.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:je,y:Je})),0})}(p.isMacintosh||p.isWindows)&&Be&&(!Le||S.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(Re=>typeof Re=="number")&&this._win.setBounds({width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y}),de&&((0,C.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.show(),(0,C.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){return this.config?this.userDataProfilesService.getProfile(this.config.workspace??"empty-window",(0,ne.revive)(this.config.profiles.current)):void 0}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}setRepresentedFilename(O){p.isMacintosh?this._win.setRepresentedFilename(O):this.representedFilename=O}getRepresentedFilename(){return p.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(O){p.isMacintosh&&this._win.setDocumentEdited(O),this.documentEdited=O}isDocumentEdited(){return p.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(O){p.isMacintosh&&O?.force&&S.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(O=>{if(this.isReady)return O(this);this.whenReadyCallbacks.push(O)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(O=>{function H(){Z.dispose(),$.dispose(),O()}const Z=this.onDidClose(()=>H()),$=this.onWillLoad(()=>H())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(H,Z)=>this.onWindowError(2,Z)),this._win.webContents.on("did-fail-load",(H,Z,$)=>this.onWindowError(3,{reason:$,exitCode:Z})),this._win.webContents.on("will-prevent-unload",H=>{H.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",H=>{this._config&&(this._config.maximized=!0),S.app.emit("browser-window-maximize",H,this._win)}),this._win.on("unmaximize",H=>{this._config&&(this._config.maximized=!1),S.app.emit("browser-window-unmaximize",H,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",M.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",M.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(H=>this.onConfigurationUpdated(H))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(H=>this.onDidDeleteUntitledWorkspace(H)));const O=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:O},async(H,Z)=>{const $=await this.getMarketplaceHeaders();Z({cancel:!1,requestHeaders:Object.assign(H.requestHeaders,$)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,n.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(O,H){switch(O){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${H?.reason||"<unknown>"}, code: ${H?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${H?.reason||"<unknown>"}, code: ${H?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:O,reason:H?.reason,code:H?.exitCode}),O){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){this.destroyWindow(!1,!1);return}if(O===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const Z=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,b.mnemonicButtonLabel)((0,d.localize)(0,null)),(0,b.mnemonicButtonLabel)((0,d.localize)(1,null)),(0,b.mnemonicButtonLabel)((0,d.localize)(2,null))],message:(0,d.localize)(3,null),detail:(0,d.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this._config?.workspace?(0,d.localize)(5,null):void 0},this._win);if(Z.response!==1){const $=Z.response===0;this.destroyWindow($,Z.checkboxChecked)}}else if(O===2){let Z;H?Z=(0,d.localize)(7,null,H.reason,H.exitCode??"<unknown>"):Z=(0,d.localize)(6,null);const $=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,b.mnemonicButtonLabel)((0,d.localize)(8,null)),(0,b.mnemonicButtonLabel)((0,d.localize)(9,null))],message:Z,detail:(0,d.localize)(10,null),noLink:!0,defaultId:0,checkboxLabel:this._config?.workspace?(0,d.localize)(11,null):void 0},this._win),j=$.response===0;this.destroyWindow(j,$.checkboxChecked)}break}}async destroyWindow(O,H){const Z=this._config?.workspace;if(H&&Z)try{const $=this.storageMainService.workspaceStorage(Z);await $.init(),$.delete("memento/workbench.parts.editor"),await $.close()}catch($){this.logService.error($)}if(this._onDidDestroy.fire(),this._win?.destroy(),O&&this._config){let $,j;(0,W.isSingleFolderWorkspaceIdentifier)(Z)?$={folderUri:Z.uri}:(0,W.isWorkspaceIdentifier)(Z)?$={workspaceUri:Z.configPath}:j=!0;const[L]=this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:$?[$]:void 0,forceEmpty:j,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});L.focus()}}onDidDeleteUntitledWorkspace(O){this._config?.workspace?.id===O.id&&this._config&&(this._config.workspace=void 0)}onConfigurationUpdated(O){const H=this.getMenuBarVisibility();H!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=H,this.setMenuBarVisibility(H));let Z=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;Z?.endsWith("/")&&(Z=Z.substr(0,Z.length-1));const $=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((Z||"").indexOf("@")===-1&&(Z!==this.currentHttpProxy||$!==this.currentNoProxy)){this.currentHttpProxy=Z,this.currentNoProxy=$;const j=Z||"",L=$?`${$},<local>`:"<local>";this.logService.trace(`Setting proxy to '${j}', bypassing '${L}'`),this._win.webContents.session.setProxy({proxyRules:j,proxyBypassRules:L,pacScript:""})}}addTabbedWindow(O){p.isMacintosh&&O.win&&this._win.addTabbedWindow(O.win)}load(O,H=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!H.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),H.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(O,H),this.readyState===0?this._config=O:this.pendingLoadConfig=O,this.readyState=1,this._win.loadURL(w.FileAccess.asBrowserUri("vs/code/electron-sandbox/workbench/workbench.html",z).toString(!0));const Z=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new t.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:O.workspace,reason:H.isReload?3:Z?2:1})}updateConfiguration(O,H){const Z=(this._config??this.pendingLoadConfig)?.userEnv;if(Z){const $=(0,f.isLaunchedFromCli)(Z)&&!(0,f.isLaunchedFromCli)(O.userEnv),j=this.isExtensionDevelopmentHost;($||j)&&(O.userEnv={...Z,...O.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(O.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),H.disableExtensions!==void 0&&(O["disable-extensions"]=H.disableExtensions),O.fullscreen=this.isFullScreen,O.maximized=this._win.isMaximized(),O.partsSplash=this.themeMainService.getWindowSplash(),(0,C.mark)("code/willOpenNewWindow"),O.perfMarks=(0,C.getMarks)(),this.configObjectUrl.update(O)}async reload(O){const H=Object.assign({},this._config);H.workspace=await this.validateWorkspaceBeforeReload(H),delete H.filesToOpenOrCreate,delete H.filesToDiff,delete H.filesToMerge,delete H.filesToWait,this.isExtensionDevelopmentHost&&O&&(H.verbose=O.verbose,H.debugId=O.debugId,H.extensionEnvironment=O.extensionEnvironment,H["inspect-extensions"]=O["inspect-extensions"],H["inspect-brk-extensions"]=O["inspect-brk-extensions"],H["extensions-dir"]=O["extensions-dir"]),H.isInitialStartup=!1,H.policiesData=this.policyService.serialize(),H.editSessionId=this.environmentMainService.editSessionId,H.profiles={all:this.userDataProfilesService.profiles,current:this.profile||this.userDataProfilesService.defaultProfile},this.load(H,{isReload:!0,disableExtensions:O?.["disable-extensions"]})}async validateWorkspaceBeforeReload(O){if((0,W.isWorkspaceIdentifier)(O.workspace)){const H=O.workspace.configPath;if(H.scheme===w.Schemas.file&&!await this.fileService.exists(H))return}else if((0,W.isSingleFolderWorkspaceIdentifier)(O.workspace)){const H=O.workspace.uri;if(H.scheme===w.Schemas.file&&!await this.fileService.exists(H))return}return O.workspace}serializeWindowState(){if(!this._win)return(0,K.defaultWindowState)();if(this.isFullScreen){let Z;try{Z=S.screen.getDisplayMatching(this.getBounds())}catch{}const $=(0,K.defaultWindowState)();return{mode:3,display:Z?Z.id:void 0,width:this.windowState.width||$.width,height:this.windowState.height||$.height,x:this.windowState.x||0,y:this.windowState.y||0}}const O=Object.create(null);let H;if(!p.isMacintosh&&this._win.isMaximized()?H=0:H=1,H===0?O.mode=0:O.mode=1,H===1||H===0){let Z;H===1?Z=this.getBounds():Z=this._win.getNormalBounds(),O.x=Z.x,O.y=Z.y,O.width=Z.width,O.height=Z.height}return O}updateWindowControls(O){O.height&&this.stateMainService.setItem(Mt.windowControlHeightStateStorageKey,O.height),p.isWindows?this._win.setTitleBarOverlay({color:O.backgroundColor?.trim()===""?void 0:O.backgroundColor,symbolColor:O.foregroundColor?.trim()===""?void 0:O.foregroundColor,height:O.height?O.height-1:void 0}):p.isMacintosh&&O.height!==void 0&&this._win.setTrafficLightPosition({x:7,y:(O.height-15)/2})}restoreWindowState(O){(0,C.mark)("code/willRestoreCodeWindowState");let H=!1;if(O)try{const Z=S.screen.getAllDisplays();H=Z.length>1,O=this.validateWindowState(O,Z)}catch(Z){this.logService.warn(`Unexpected error validating window state: ${Z}
${Z.stack}`)}return(0,C.mark)("code/didRestoreCodeWindowState"),[O||(0,K.defaultWindowState)(),H]}validateWindowState(O,H){if(this.logService.trace(`window#validateWindowState: validating window state on ${H.length} display(s)`,O),typeof O.x!="number"||typeof O.y!="number"||typeof O.width!="number"||typeof O.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(O.width<=0||O.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(H.length===1){const j=this.getWorkingArea(H[0]);if(j){let L=function(){!O||typeof O.x!="number"||typeof O.y!="number"||!j||(O.x<j.x&&(O.x=j.x),O.y<j.y&&(O.y=j.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",j),L(),O.width>j.width&&(O.width=j.width),O.height>j.height&&(O.height=j.height),O.x>j.x+j.width-128&&(O.x=j.x+j.width-O.width),O.y>j.y+j.height-128&&(O.y=j.y+j.height-O.height),L()}return O}if(O.display&&O.mode===3){const j=H.find(L=>L.id===O.display);if(j&&typeof j.bounds?.x=="number"&&typeof j.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const L=(0,K.defaultWindowState)(3);return L.x=j.bounds.x,L.y=j.bounds.y,L}}let Z,$;try{Z=S.screen.getDisplayMatching({x:O.x,y:O.y,width:O.width,height:O.height}),$=this.getWorkingArea(Z)}catch{}if(Z&&$&&O.x+O.width>$.x&&O.y+O.height>$.y&&O.x<$.x+$.width&&O.y<$.y+$.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",$),O}getWorkingArea(O){if(O.workArea.width>0&&O.workArea.height>0)return O.workArea;if(O.bounds.width>0&&O.bounds.height>0)return O.bounds}getBounds(){const[O,H]=this._win.getPosition(),[Z,$]=this._win.getSize();return{x:O,y:H,width:Z,height:$}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(O){this.useNativeFullScreen()?this.setNativeFullScreen(O):this.setSimpleFullScreen(O),this.sendWhenReady(O?"vscode:enterFullScreen":"vscode:leaveFullScreen",M.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(O){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(O)}setSimpleFullScreen(O){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(O),this._win.webContents.focus()}useNativeFullScreen(){const O=this.configurationService.getValue("window");return!O||typeof O.nativeFullScreen!="boolean"||O.nativeTabs?!0:O.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let O=(0,k.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(O)<0&&(O="classic"),O}setMenuBarVisibility(O,H=!0){p.isMacintosh||(O==="toggle"&&H&&this.send("vscode:showInfoMessage",(0,d.localize)(12,null)),O==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(O)}):this.doSetMenuBarVisibility(O))}doSetMenuBarVisibility(O){const H=this.isFullScreen;switch(O){case"classic":this._win.setMenuBarVisibility(!H),this._win.autoHideMenuBar=H;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(p.isMacintosh)switch(S.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win?.close()}sendWhenReady(O,H,...Z){this.isReady?this.send(O,...Z):this.ready().then(()=>{H.isCancellationRequested||this.send(O,...Z)})}send(O,...H){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${O}' for window that is destroyed`);return}try{this._win.webContents.send(O,...H)}catch(Z){this.logService.warn(`Error sending IPC message to channel '${O}' of window ${this._id}: ${(0,R.toErrorMessage)(Z)}`)}}}updateTouchBar(O){!p.isMacintosh||this.touchBarGroups.forEach((H,Z)=>{const $=O[Z];H.segments=this.createTouchBarGroupSegments($)})}createTouchBar(){if(!!p.isMacintosh){for(let O=0;O<10;O++){const H=this.createTouchBarGroup();this.touchBarGroups.push(H)}this._win.setTouchBar(new S.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(O=[]){const H=this.createTouchBarGroupSegments(O),Z=new S.TouchBar.TouchBarSegmentedControl({segments:H,mode:"buttons",segmentStyle:"automatic",change:$=>{this.sendWhenReady("vscode:runAction",M.CancellationToken.None,{id:Z.segments[$].id,from:"touchbar"})}});return Z}createTouchBarGroupSegments(O=[]){return O.map(Z=>{let $;Z.icon&&!l.ThemeIcon.isThemeIcon(Z.icon)&&Z.icon?.dark?.scheme===w.Schemas.file&&($=S.nativeImage.createFromPath(g.URI.revive(Z.icon.dark).fsPath),$.isEmpty()&&($=void 0));let j;return typeof Z.title=="string"?j=Z.title:j=Z.title.value,{id:Z.id,label:$?void 0:j,icon:$}})}dispose(){super.dispose(),this._win=null}};B.windowControlHeightStateStorageKey="windowControlHeight",B=ge([ee(1,o.ILogService),ee(2,v.IEnvironmentMainService),ee(3,oe.IPolicyService),ee(4,ue.IUserDataProfilesService),ee(5,u.IFileService),ee(6,s.IApplicationStorageMainService),ee(7,s.IStorageMainService),ee(8,y.IConfigurationService),ee(9,I.IThemeMainService),ee(10,F.IWorkspacesManagementMainService),ee(11,P.IBackupMainService),ee(12,a.ITelemetryService),ee(13,m.IDialogMainService),ee(14,c.ILifecycleMainService),ee(15,r.IProductService),ee(16,i.IProtocolMainService),ee(17,A.IWindowsMainService),ee(18,ae.IStateMainService)],B),e.CodeWindow=B}),define(X[74],J([0,1,14,25,8,3,34,2,13,4,16,7,23,166,5,22,6,88,89,24,46]),function(z,e,S,t,M,R,D,b,h,w,E,C,p,g,d,P,y,m,v,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,d.createDecorator)("workspacesHistoryMainService");let c=class tt extends b.Disposable{constructor(r,i,n,s){super();this.logService=r,this.workspacesManagementMainService=i,this.lifecycleMainService=n,this.applicationStorageMainService=s,this._onDidChangeRecentlyOpened=this._register(new R.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new M.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(r=>this.addRecentlyOpened([{workspace:r.workspace,remoteAuthority:r.window.remoteAuthority}])))}async addRecentlyOpened(r){const i=[],n=[];for(const s of r)if((0,v.isRecentWorkspace)(s))!this.workspacesManagementMainService.isUntitledWorkspace(s.workspace)&&this.indexOfWorkspace(i,s.workspace)===-1&&i.push(s);else if((0,v.isRecentFolder)(s))this.indexOfFolder(i,s.folderUri)===-1&&i.push(s);else{const a=this.indexOfFile(n,s.fileUri)>=0,l=s.fileUri.scheme===h.Schemas.file&&tt.COMMON_FILES_FILTER.indexOf((0,E.basename)(s.fileUri))>=0;!a&&!l&&(n.push(s),w.isWindows&&s.fileUri.scheme===h.Schemas.file&&S.app.addRecentDocument(s.fileUri.fsPath))}await this.addEntriesFromStorage(i,n),i.length>tt.MAX_TOTAL_RECENT_ENTRIES&&(i.length=tt.MAX_TOTAL_RECENT_ENTRIES),n.length>tt.MAX_TOTAL_RECENT_ENTRIES&&(n.length=tt.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:i,files:n}),this._onDidChangeRecentlyOpened.fire(),w.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(r){const i=l=>{const I=this.location(l);for(const k of r)if(E.extUriBiasedIgnorePathCase.isEqual(k,I))return!1;return!0},n=await this.getRecentlyOpened(),s=n.workspaces.filter(i),a=n.files.filter(i);(s.length!==n.workspaces.length||a.length!==n.files.length)&&(await this.saveRecentlyOpened({files:a,workspaces:s}),this._onDidChangeRecentlyOpened.fire(),w.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),S.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){const r=[],i=[];return await this.addEntriesFromStorage(r,i),{workspaces:r,files:i}}async addEntriesFromStorage(r,i){const n=await this.getRecentlyOpenedFromStorage();for(const s of n.workspaces){const a=(0,v.isRecentFolder)(s)?this.indexOfFolder(r,s.folderUri):this.indexOfWorkspace(r,s.workspace);a>=0?r[a].label=r[a].label||s.label:r.push(s)}for(const s of n.files){const a=this.indexOfFile(i,s.fileUri);a>=0?i[a].label=i[a].label||s.label:i.push(s)}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let r;const i=this.applicationStorageMainService.get(tt.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof i=="string")try{r=JSON.parse(i)}catch(n){this.logService.error("Unexpected error parsing opened paths list",n)}return(0,v.restoreRecentlyOpened)(r,this.logService)}async saveRecentlyOpened(r){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(tt.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,v.toStoreData)(r)),-1,1)}location(r){return(0,v.isRecentFolder)(r)?r.folderUri:(0,v.isRecentFile)(r)?r.fileUri:r.workspace.configPath}indexOfWorkspace(r,i){return r.findIndex(n=>(0,v.isRecentWorkspace)(n)&&n.workspace.id===i.id)}indexOfFolder(r,i){return r.findIndex(n=>(0,v.isRecentFolder)(n)&&E.extUriBiasedIgnorePathCase.isEqual(n.folderUri,i))}indexOfFile(r,i){return r.findIndex(n=>E.extUriBiasedIgnorePathCase.isEqual(n.fileUri,i))}async handleWindowsJumpList(){!w.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!w.isWindows)return;const r=[];if(r.push({type:"tasks",items:[{type:"task",title:(0,g.localize)(0,null),description:(0,g.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const i=[];for(const a of S.app.getJumpListSettings().removedItems){const l=a.args;if(l){const I=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(l);I&&i.push(C.URI.parse(I[2]))}}await this.removeRecentlyOpened(i);let n=!1;const s=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,tt.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(a=>{const l=(0,v.isRecentWorkspace)(a)?a.workspace:a.folderUri,{title:I,description:k}=this.getWindowsJumpListLabel(l,a.label);let A;return C.URI.isUri(l)?A=`--folder-uri "${l.toString()}"`:(n=!0,A=`--file-uri "${l.configPath.toString()}"`),{type:"task",title:I.substr(0,255),description:k.substr(0,255),program:process.execPath,args:A,iconPath:"explorer.exe",iconIndex:0}}));s.length>0&&r.push({type:"custom",name:n?(0,g.localize)(2,null):(0,g.localize)(3,null),items:s})}r.push({type:"recent"});try{const i=S.app.setJumpList(r);i&&i!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${i}`)}catch(i){this.logService.warn("updateWindowsJumpList#setJumpList",i)}}getWindowsJumpListLabel(r,i){if(i)return{title:(0,D.splitName)(i).name,description:i};if(C.URI.isUri(r))return{title:(0,E.basename)(r),description:this.renderJumpListPathDescription(r)};if(this.workspacesManagementMainService.isUntitledWorkspace(r))return{title:(0,g.localize)(4,null),description:""};let n=(0,E.basename)(r.configPath);return n.endsWith(f.WORKSPACE_EXTENSION)&&(n=n.substr(0,n.length-f.WORKSPACE_EXTENSION.length-1)),{title:(0,g.localize)(5,null,n),description:this.renderJumpListPathDescription(r.configPath)}}renderJumpListPathDescription(r){return r.scheme==="file"?(0,D.normalizeDriveLetter)(r.fsPath):r.toString()}async updateMacOSRecentDocuments(){if(!w.isMacintosh)return;S.app.clearRecentDocuments();const r=await this.getRecentlyOpened(),i=[];let n=0;for(let a=0;a<r.workspaces.length&&n<tt.MAX_MACOS_DOCK_RECENT_WORKSPACES;a++){const l=this.location(r.workspaces[a]);if(l.scheme===h.Schemas.file){const I=(0,E.originalFSPath)(l);await p.Promises.exists(I)&&(i.push(I),n++)}}const s=[];for(let a=0;a<r.files.length&&n<tt.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;a++){const l=this.location(r.files[a]);if(l.scheme===h.Schemas.file){const I=(0,E.originalFSPath)(l);if(tt.COMMON_FILES_FILTER.includes((0,E.basename)(l))||i.includes(I))continue;await p.Promises.exists(I)&&(s.push(I),n++)}}s.reverse().forEach(a=>S.app.addRecentDocument(a)),i.reverse().forEach(a=>S.app.addRecentDocument(a))}};c.MAX_TOTAL_RECENT_ENTRIES=500,c.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",c.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,c.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,c.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,c.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],c=ge([ee(0,y.ILogService),ee(1,u.IWorkspacesManagementMainService),ee(2,P.ILifecycleMainService),ee(3,m.IApplicationStorageMainService)],c),e.WorkspacesHistoryMainService=c}),define(X[249],J([0,1,14,8,21,34,4,7,156,18,26,22,6,197,64,20,40,35,45,73,32,74]),function(z,e,S,t,M,R,D,b,h,w,E,C,p,g,d,P,y,m,v,f,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const o="menu";let r=class Dt{constructor(s,a,l,I,k,A,W,F,K,ie,oe){this.updateService=s,this.configurationService=a,this.windowsMainService=l,this.environmentMainService=I,this.telemetryService=k,this.workspacesHistoryMainService=A,this.stateMainService=W,this.lifecycleMainService=F,this.logService=K,this.nativeHostMainService=ie,this.productService=oe,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new t.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new t.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(D.isMacintosh||(0,f.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const s=this.stateMainService.getItem(Dt.lastKnownMenubarStorageKey);s&&(s.menus&&(this.menubarMenus=s.menus),s.keybindings&&(this.keybindings=s.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(A,W,F)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:W?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(A,W,F)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:W?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(A,W,F)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(F),telemetryExtraData:{from:o}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(A,W,F)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(F),telemetryExtraData:{from:o}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(A,W,F)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(F),telemetryExtraData:{from:o}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const s=this.productService.twitterUrl;s&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(s,"openTwitterUrl"));const a=this.productService.requestFeatureUrl;a&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(a,"openUserVoiceUrl"));const l=this.productService.reportIssueUrl;l&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(l,"openReportIssues"));const I=this.productService.licenseUrl;I&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(D.language){const A=I.indexOf("?")>0?"&":"?";this.openUrl(`${I}${A}lang=${D.language}`,"openLicenseUrl")}else this.openUrl(I,"openLicenseUrl")});const k=this.productService.privacyStatementUrl;k&&I&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(k,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(s=>this.onDidChangeWindowsCount(s)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const s=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof s!="boolean"?!0:s}get currentEnableNativeTabs(){if(!D.isMacintosh)return!1;const s=this.configurationService.getValue("window.nativeTabs");return typeof s!="boolean"?!1:s}updateMenu(s,a){this.menubarMenus=s.menus,this.keybindings=s.keybindings,this.stateMainService.setItem(Dt.lastKnownMenubarStorageKey,s),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(s){!D.isMacintosh||(s.oldCount===0&&s.newCount>0||s.oldCount>0&&s.newCount===0)&&(this.closedLastWindow=s.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!D.isMacintosh||(this.noActiveWindow=!S.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const s=S.Menu.getApplicationMenu();if(s&&this.oldMenus.push(s),Object.keys(this.menubarMenus).length===0){S.Menu.setApplicationMenu(D.isMacintosh?new S.Menu:null);return}const a=new S.Menu;let l;if(D.isMacintosh){const k=new S.Menu;l=new S.MenuItem({label:this.productService.nameShort,submenu:k}),this.setMacApplicationMenu(k),a.append(l)}if(D.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const k=new S.Menu;k.append(new S.MenuItem({label:this.mnemonicLabel(h.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),S.app.dock.setMenu(k)}if(this.shouldDrawMenu("File")){const k=new S.Menu,A=new S.MenuItem({label:this.mnemonicLabel(h.localize(1,null)),submenu:k});this.setMenuById(k,"File"),a.append(A)}if(this.shouldDrawMenu("Edit")){const k=new S.Menu,A=new S.MenuItem({label:this.mnemonicLabel(h.localize(2,null)),submenu:k});this.setMenuById(k,"Edit"),a.append(A)}if(this.shouldDrawMenu("Selection")){const k=new S.Menu,A=new S.MenuItem({label:this.mnemonicLabel(h.localize(3,null)),submenu:k});this.setMenuById(k,"Selection"),a.append(A)}if(this.shouldDrawMenu("View")){const k=new S.Menu,A=new S.MenuItem({label:this.mnemonicLabel(h.localize(4,null)),submenu:k});this.setMenuById(k,"View"),a.append(A)}if(this.shouldDrawMenu("Go")){const k=new S.Menu,A=new S.MenuItem({label:this.mnemonicLabel(h.localize(5,null)),submenu:k});this.setMenuById(k,"Go"),a.append(A)}if(this.shouldDrawMenu("Run")){const k=new S.Menu,A=new S.MenuItem({label:this.mnemonicLabel(h.localize(6,null)),submenu:k});this.setMenuById(k,"Run"),a.append(A)}if(this.shouldDrawMenu("Terminal")){const k=new S.Menu,A=new S.MenuItem({label:this.mnemonicLabel(h.localize(7,null)),submenu:k});this.setMenuById(k,"Terminal"),a.append(A)}let I;if(this.shouldDrawMenu("Window")){const k=new S.Menu;I=new S.MenuItem({label:this.mnemonicLabel(h.localize(8,null)),submenu:k,role:"window"}),this.setMacWindowMenu(k)}if(I&&a.append(I),this.shouldDrawMenu("Help")){const k=new S.Menu,A=new S.MenuItem({label:this.mnemonicLabel(h.localize(9,null)),submenu:k,role:"help"});this.setMenuById(k,"Help"),a.append(A)}a.items&&a.items.length>0?S.Menu.setApplicationMenu(a):S.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(s){const a=this.createMenuItem(h.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),l=this.getUpdateMenuItems();let I;if(this.shouldDrawMenu("Preferences")){const ue=new S.Menu;this.setMenuById(ue,"Preferences"),I=new S.MenuItem({label:this.mnemonicLabel(h.localize(11,null)),submenu:ue})}const k=new S.Menu,A=new S.MenuItem({label:h.localize(12,null),role:"services",submenu:k}),W=new S.MenuItem({label:h.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),F=new S.MenuItem({label:h.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),K=new S.MenuItem({label:h.localize(15,null),role:"unhide"}),ie=new S.MenuItem(this.likeAction("workbench.action.quit",{label:h.localize(16,null,this.productService.nameLong),click:async(ue,ne,ae)=>{const le=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!S.BrowserWindow.getFocusedWindow()||le?.isMinimized())&&await this.confirmBeforeQuit(ae)&&this.nativeHostMainService.quit(void 0)}})),oe=[a];oe.push(...l),I&&oe.push(i(),I),oe.push(i(),A,i(),W,F,K,i(),ie),oe.forEach(ue=>s.append(ue))}async confirmBeforeQuit(s){if(this.windowsMainService.getWindowCount()===0)return!0;const a=this.configurationService.getValue("window.confirmBeforeClose");if(a==="always"||a==="keyboardOnly"&&this.isKeyboardEvent(s)){const l={title:this.productService.nameLong,type:"question",buttons:[(0,R.mnemonicButtonLabel)(h.localize(17,null)),(0,R.mnemonicButtonLabel)(h.localize(18,null))],message:h.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:I}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,l);return I===0}return!0}shouldDrawMenu(s){if(!D.isMacintosh&&(0,f.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(s){case"File":case"Help":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[s];case"Window":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[s]}}setMenu(s,a){a.forEach(l=>{if((0,g.isMenubarMenuItemSeparator)(l))s.append(i());else if((0,g.isMenubarMenuItemSubmenu)(l)){const I=new S.Menu,k=new S.MenuItem({label:this.mnemonicLabel(l.label),submenu:I});this.setMenu(I,l.submenu.items),s.append(k)}else(0,g.isMenubarMenuItemRecentAction)(l)?s.append(this.createOpenRecentMenuItem(l)):(0,g.isMenubarMenuItemAction)(l)&&(l.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(s),D.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[l.id]?s.append(new S.MenuItem(this.likeAction(l.id,{label:this.mnemonicLabel(l.label),click:this.fallbackMenuHandlers[l.id]}))):s.append(this.createMenuItem(l.label,l.id,!1,l.checked)):s.append(this.createMenuItem(l.label,l.id,l.enabled!==!1,!!l.checked)):s.append(this.createMenuItem(l.label,l.id,l.enabled!==!1,!!l.checked)))})}setMenuById(s,a){this.menubarMenus&&this.menubarMenus[a]&&this.setMenu(s,this.menubarMenus[a].items)}insertCheckForUpdatesItems(s){const a=this.getUpdateMenuItems();a.length&&(a.forEach(l=>s.append(l)),s.append(i()))}createOpenRecentMenuItem(s){const a=b.URI.revive(s.uri),l=s.id,I=l==="openRecentFile"?{fileUri:a}:l==="openRecentWorkspace"?{workspaceUri:a}:{folderUri:a};return new S.MenuItem(this.likeAction(l,{label:s.label,click:(k,A,W)=>{const F=this.isOptionClick(W);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[I],forceNewWindow:F,gotoLineMode:!1,remoteAuthority:s.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([a])}},!1))}isOptionClick(s){return!!(s&&(!D.isMacintosh&&(s.ctrlKey||s.shiftKey)||D.isMacintosh&&(s.metaKey||s.altKey)))}isKeyboardEvent(s){return!!(s.triggeredByAccelerator||s.altKey||s.ctrlKey||s.metaKey||s.shiftKey)}createRoleMenuItem(s,a,l){const I={label:this.mnemonicLabel(s),role:l,enabled:!0};return new S.MenuItem(this.withKeybinding(a,I))}setMacWindowMenu(s){const a=new S.MenuItem({label:h.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),l=new S.MenuItem({label:h.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),I=new S.MenuItem({label:h.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),k=this.createMenuItem(h.localize(23,null),"workbench.action.switchWindow"),A=[];this.currentEnableNativeTabs&&(A.push(i()),A.push(this.createMenuItem(h.localize(24,null),"workbench.action.newWindowTab")),A.push(this.createRoleMenuItem(h.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),A.push(this.createRoleMenuItem(h.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),A.push(this.createRoleMenuItem(h.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),A.push(this.createRoleMenuItem(h.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[a,l,i(),k,...A,i(),I].forEach(W=>s.append(W))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new S.MenuItem({label:this.mnemonicLabel(h.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new S.MenuItem({label:h.localize(30,null),enabled:!1})];case"available for download":return[new S.MenuItem({label:this.mnemonicLabel(h.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new S.MenuItem({label:h.localize(32,null),enabled:!1})];case"downloaded":return[new S.MenuItem({label:this.mnemonicLabel(h.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new S.MenuItem({label:h.localize(34,null),enabled:!1})];case"ready":return[new S.MenuItem({label:this.mnemonicLabel(h.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(s,a,l,I){const k=this.mnemonicLabel(s),A=typeof a=="function"?a:(oe,ue,ne)=>{const ae=oe?oe.userSettingsLabel:null;let le=a;Array.isArray(a)&&(le=this.isOptionClick(ne)?a[1]:a[0]),ae&&ne.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:ae}):this.runActionInRenderer({type:"commandId",commandId:le})},W=typeof l=="boolean"?l:this.windowsMainService.getWindowCount()>0,F=typeof I=="boolean"?I:!1,K={label:k,click:A,enabled:W};F&&(K.type="checkbox",K.checked=F);let ie;return typeof a=="string"?ie=a:Array.isArray(a)&&(ie=a[0]),D.isMacintosh&&(ie==="editor.action.clipboardCutAction"?K.role="cut":ie==="editor.action.clipboardCopyAction"?K.role="copy":ie==="editor.action.clipboardPasteAction"&&(K.role="paste"),ie==="undo"?K.click=this.makeContextAwareClickHandler(A,{inDevTools:oe=>oe.undo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("undo:")}):ie==="redo"?K.click=this.makeContextAwareClickHandler(A,{inDevTools:oe=>oe.redo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("redo:")}):ie==="editor.action.selectAll"&&(K.click=this.makeContextAwareClickHandler(A,{inDevTools:oe=>oe.selectAll(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("selectAll:")}))),new S.MenuItem(this.withKeybinding(ie,K))}makeContextAwareClickHandler(s,a){return(l,I,k)=>{const A=S.BrowserWindow.getFocusedWindow();if(!A)return a.inNoWindow();if(A.webContents.isDevToolsFocused()&&A.webContents.devToolsWebContents)return a.inDevTools(A.webContents.devToolsWebContents);s(l,I||A,k)}}runActionInRenderer(s){let a=S.BrowserWindow.getFocusedWindow();if(!a){const I=this.windowsMainService.getLastActiveWindow();I?.isMinimized()&&(a=I.win)}const l=a?this.windowsMainService.getWindowById(a.id):void 0;if(l){if(this.logService.trace("menubar#runActionInRenderer",s),D.isMacintosh&&!this.environmentMainService.isBuilt&&!l.isReady&&(s.type==="commandId"&&s.commandId==="workbench.action.toggleDevTools"||s.type!=="commandId"&&s.userSettingsLabel==="alt+cmd+i"))return;if(s.type==="commandId"){const I={id:s.commandId,from:"menu"};l.sendWhenReady("vscode:runAction",M.CancellationToken.None,I)}else{const I={userSettingsLabel:s.userSettingsLabel};l.sendWhenReady("vscode:runKeybinding",M.CancellationToken.None,I)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",s)}withKeybinding(s,a){const l=typeof s=="string"?this.keybindings[s]:void 0;if(l?.label){if(l.isNative!==!1)a.accelerator=l.label,a.userSettingsLabel=l.userSettingsLabel;else if(typeof a.label=="string"){const I=a.label.indexOf("[");I>=0?a.label=`${a.label.substr(0,I)} [${l.label}]`:a.label=`${a.label} [${l.label}]`}}else a.accelerator=void 0;return a}likeAction(s,a,l=!a.accelerator){l&&(a=this.withKeybinding(s,a));const I=a.click;return a.click=(k,A,W)=>{this.reportMenuActionTelemetry(s),I?.(k,A,W)},a}openUrl(s,a){this.nativeHostMainService.openExternal(void 0,s),this.reportMenuActionTelemetry(a)}reportMenuActionTelemetry(s){this.telemetryService.publicLog2("workbenchActionExecuted",{id:s,from:o})}mnemonicLabel(s){return(0,R.mnemonicMenuLabel)(s,!this.currentEnableMenuBarMnemonics)}};r.lastKnownMenubarStorageKey="lastKnownMenubarData",r=ge([ee(0,v.IUpdateService),ee(1,w.IConfigurationService),ee(2,u.IWindowsMainService),ee(3,E.IEnvironmentMainService),ee(4,m.ITelemetryService),ee(5,c.IWorkspacesHistoryMainService),ee(6,y.IStateMainService),ee(7,C.ILifecycleMainService),ee(8,p.ILogService),ee(9,d.INativeHostMainService),ee(10,P.IProductService)],r),e.Menubar=r;function i(){return new S.MenuItem({type:"separator"})}}),define(X[250],J([0,1,5,22,6,249]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,S.createDecorator)("menubarMainService");let D=class{constructor(h,w,E){this.instantiationService=h,this.lifecycleMainService=w,this.logService=E,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(R.Menubar)}async updateMenubar(h,w){this.logService.trace("menubarService#updateMenubar",h),(await this.menubar).updateMenu(w,h)}};D=ge([ee(0,S.IInstantiationService),ee(1,t.ILifecycleMainService),ee(2,M.ILogService)],D),e.MenubarMainService=D}),define(X[251],J([0,1,14,28,29,25,21,3,31,47,34,2,13,9,70,4,36,16,11,7,164,58,18,54,26,15,5,22,6,52,20,59,71,40,73,248,112,244,24,113,74,46,61,41,37]),function(z,e,S,t,M,R,D,b,h,w,E,C,p,g,d,P,y,m,v,f,u,c,o,r,i,n,s,a,l,I,k,A,W,F,K,ie,oe,ue,ne,ae,le,G,B,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function H(j){return(0,ne.isWorkspaceIdentifier)(j?.workspace)}function Z(j){return(0,ne.isSingleFolderWorkspaceIdentifier)(j?.workspace)}let $=class ut extends C.Disposable{constructor(L,T,_,q,Q,te,U,Y,x,re,ce,Ee,Ce,Pe,Me,Be,de,fe){super();this.machineId=L,this.initialUserEnv=T,this.logService=_,this.stateMainService=q,this.policyService=Q,this.environmentMainService=te,this.userDataProfilesService=U,this.lifecycleMainService=Y,this.backupMainService=x,this.configurationService=re,this.workspacesHistoryMainService=ce,this.workspacesManagementMainService=Ee,this.instantiationService=Ce,this.dialogMainService=Pe,this.fileService=Me,this.productService=Be,this.protocolMainService=de,this.themeMainService=fe,this._onDidOpenWindow=this._register(new b.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new b.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new b.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new b.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidTriggerSystemContextMenu=this._register(new b.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windowsStateHandler=this._register(new ue.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(L=>this._onDidSignalReadyWindow.fire(L.window))),this._register(this.onDidSignalReadyWindow(L=>{if(L.config?.extensionDevelopmentPath||L.config?.extensionTestsPath){const T=new C.DisposableStore;if(T.add(b.Event.any(L.onDidClose,L.onDidDestroy)(()=>T.dispose())),L.config.extensionDevelopmentPath)for(const _ of L.config.extensionDevelopmentPath)T.add(this.protocolMainService.addValidFileRoot(_));L.config.extensionTestsPath&&T.add(this.protocolMainService.addValidFileRoot(L.config.extensionTestsPath))}}))}openEmptyWindow(L,T){const _=this.environmentMainService.args,q=T?.remoteAuthority||void 0,Q=!0,te=T?.forceReuseWindow,U=!te;return this.open({...L,cli:_,forceEmpty:Q,forceNewWindow:U,forceReuseWindow:te,remoteAuthority:q})}openExistingWindow(L,T){L.focus(),this.handleWaitMarkerFile(T,[L])}open(L){this.logService.trace("windowsManager#open"),L.addMode&&(L.initialStartup||!this.getLastActiveWindow())&&(L.addMode=!1);const T=[],_=[],q=[],Q=[],te=[];let U,Y=0;const x=this.getPathsToOpen(L);this.logService.trace("windowsManager#open pathsToOpen",x);for(const Pe of x)Z(Pe)?L.addMode?T.push(Pe):_.push(Pe):H(Pe)?q.push(Pe):Pe.fileUri?(U||(U={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Pe.remoteAuthority}),U.filesToOpenOrCreate.push(Pe)):Pe.backupPath?te.push({backupFolder:(0,g.basename)(Pe.backupPath),remoteAuthority:Pe.remoteAuthority}):Y++;L.diffMode&&U&&U.filesToOpenOrCreate.length>=2&&(U.filesToDiff=U.filesToOpenOrCreate.slice(0,2),U.filesToOpenOrCreate=[]),L.mergeMode&&U&&U.filesToOpenOrCreate.length===4&&(U.filesToMerge=U.filesToOpenOrCreate.slice(0,4),U.filesToOpenOrCreate=[],U.filesToDiff=[]),U&&L.waitMarkerFileURI&&(U.filesToWait={paths:(0,R.coalesce)([...U.filesToDiff,U.filesToMerge[3],...U.filesToOpenOrCreate]),waitMarkerFileUri:L.waitMarkerFileURI}),L.initialStartup?(Q.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),q.push(...Q),te.push(...this.backupMainService.getEmptyWindowBackupPaths())):te.length=0;const{windows:re,filesOpenedInWindow:ce}=this.doOpen(L,q,_,te,Y,U,T);if(this.logService.trace(`windowsManager#open used window count ${re.length} (workspacesToOpen: ${q.length}, foldersToOpen: ${_.length}, emptyToRestore: ${te.length}, emptyToOpen: ${Y})`),re.length>1)if(ce)ce.focus();else{const Pe=this.windowsStateHandler.state.lastActiveWindow&&!L.forceEmpty&&!L.cli._.length&&!L.cli["file-uri"]&&!L.cli["folder-uri"]&&!(L.urisToOpen&&L.urisToOpen.length);let Me=!0,Be=!0;if(Pe){const de=re.filter(fe=>this.windowsStateHandler.state.lastActiveWindow&&fe.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);de.length&&(de[0].focus(),Me=!1,Be=!1)}if(Me)for(let de=re.length-1;de>=0;de--){const fe=re[de];if(!(fe.openedWorkspace&&Q.some(pe=>fe.openedWorkspace&&pe.workspace.id===fe.openedWorkspace.id)||fe.backupPath&&te.some(pe=>fe.backupPath&&pe.backupFolder===(0,g.basename)(fe.backupPath)))){fe.focus(),Be=!1;break}}Be&&re[re.length-1].focus()}const Ee=U&&U.filesToDiff.length>0,Ce=U&&U.filesToMerge.length>0;if(!re.some(Pe=>Pe.isExtensionDevelopmentHost)&&!Ee&&!Ce&&!L.noRecentEntry){const Pe=[];for(const Me of x)H(Me)&&!Me.transient?Pe.push({label:Me.label,workspace:Me.workspace,remoteAuthority:Me.remoteAuthority}):Z(Me)?Pe.push({label:Me.label,folderUri:Me.workspace.uri,remoteAuthority:Me.remoteAuthority}):Me.fileUri&&Pe.push({label:Me.label,fileUri:Me.fileUri,remoteAuthority:Me.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(Pe)}return this.handleWaitMarkerFile(L,re),re}handleWaitMarkerFile(L,T){const _=L.waitMarkerFileURI;L.context===0&&_&&T.length===1&&T[0]&&(async()=>{await T[0].whenClosedOrLoaded;try{await this.fileService.del(_)}catch{}})()}doOpen(L,T,_,q,Q,te,U){const Y=[];let x;function re(de,fe){Y.push(de),fe&&(x=de,te=void 0)}let{openFolderInNewWindow:ce,openFilesInNewWindow:Ee}=this.shouldOpenNewWindow(L);if(!L.initialStartup&&U.length>0){const de=U[0].remoteAuthority,fe=this.getLastActiveWindowForAuthority(de);fe&&re(this.doAddFoldersToExistingWindow(fe,U.map(pe=>pe.workspace.uri)))}const Ce=_.length+T.length+q.length;if(te&&Ce===0){const de=te.filesToOpenOrCreate[0]||te.filesToDiff[0]||te.filesToMerge[3],fe=this.getWindows().filter(Ie=>te&&(0,m.isEqualAuthority)(Ie.remoteAuthority,te.remoteAuthority));let pe;de?.fileUri&&!Ee&&((L.context===4||L.context===0||L.context===1)&&(pe=(0,oe.findWindowOnFile)(fe,de.fileUri,Ie=>Ie.configPath.scheme===p.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Ie.configPath):void 0)),pe||(pe=this.doGetLastActiveWindow(fe))),pe?(0,ne.isWorkspaceIdentifier)(pe.openedWorkspace)?T.push({workspace:pe.openedWorkspace,remoteAuthority:pe.remoteAuthority}):(0,ne.isSingleFolderWorkspaceIdentifier)(pe.openedWorkspace)?_.push({workspace:pe.openedWorkspace,remoteAuthority:pe.remoteAuthority}):re(this.doOpenFilesInExistingWindow(L,pe,te),!0):re(this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,filesToOpen:te,forceNewWindow:!0,remoteAuthority:te.remoteAuthority,forceNewTabbedWindow:L.forceNewTabbedWindow}),!0)}const Pe=(0,R.distinct)(T,de=>de.workspace.id);if(Pe.length>0){const de=(0,R.coalesce)(Pe.map(fe=>(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),fe.workspace.configPath)));if(de.length>0){const fe=de[0],pe=(0,m.isEqualAuthority)(te?.remoteAuthority,fe.remoteAuthority)?te:void 0;re(this.doOpenFilesInExistingWindow(L,fe,pe),!!pe),ce=!0}Pe.forEach(fe=>{if(de.some(Le=>Le.openedWorkspace&&Le.openedWorkspace.id===fe.workspace.id))return;const pe=fe.remoteAuthority,Ie=(0,m.isEqualAuthority)(te?.remoteAuthority,pe)?te:void 0;re(this.doOpenFolderOrWorkspace(L,fe,ce,Ie),!!Ie),ce=!0})}const Me=(0,R.distinct)(_,de=>m.extUriBiasedIgnorePathCase.getComparisonKey(de.workspace.uri));if(Me.length>0){const de=(0,R.coalesce)(Me.map(fe=>(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),fe.workspace.uri)));if(de.length>0){const fe=de[0],pe=(0,m.isEqualAuthority)(te?.remoteAuthority,fe.remoteAuthority)?te:void 0;re(this.doOpenFilesInExistingWindow(L,fe,pe),!!pe),ce=!0}Me.forEach(fe=>{if(de.some(Le=>(0,ne.isSingleFolderWorkspaceIdentifier)(Le.openedWorkspace)&&m.extUriBiasedIgnorePathCase.isEqual(Le.openedWorkspace.uri,fe.workspace.uri)))return;const pe=fe.remoteAuthority,Ie=(0,m.isEqualAuthority)(te?.remoteAuthority,pe)?te:void 0;re(this.doOpenFolderOrWorkspace(L,fe,ce,Ie),!!Ie),ce=!0})}const Be=(0,R.distinct)(q,de=>de.backupFolder);if(Be.length>0&&Be.forEach(de=>{const fe=de.remoteAuthority,pe=(0,m.isEqualAuthority)(te?.remoteAuthority,fe)?te:void 0;re(this.doOpenEmpty(L,!0,fe,pe,de),!!pe),ce=!0}),Y.length===0||te){te&&!Q&&Q++;const de=te?te.remoteAuthority:L.remoteAuthority;for(let fe=0;fe<Q;fe++)re(this.doOpenEmpty(L,ce,de,te),!!te),ce=!0}return{windows:(0,R.distinct)(Y),filesOpenedInWindow:x}}doOpenFilesInExistingWindow(L,T,_){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:_}),T.focus();const q={filesToOpenOrCreate:_?.filesToOpenOrCreate,filesToDiff:_?.filesToDiff,filesToMerge:_?.filesToMerge,filesToWait:_?.filesToWait,termProgram:L?.userEnv?.TERM_PROGRAM};return T.sendWhenReady("vscode:openFiles",D.CancellationToken.None,q),T}doAddFoldersToExistingWindow(L,T){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:T}),L.focus();const _={foldersToAdd:T};return L.sendWhenReady("vscode:addFolders",D.CancellationToken.None,_),L}doOpenEmpty(L,T,_,q,Q){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!Q,remoteAuthority:_,filesToOpen:q,forceNewWindow:T});let te;return!T&&typeof L.contextWindowId=="number"&&(te=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:_,forceNewWindow:T,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:q,windowToUse:te,emptyWindowBackupInfo:Q})}doOpenFolderOrWorkspace(L,T,_,q,Q){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:T,filesToOpen:q}),!_&&!Q&&typeof L.contextWindowId=="number"&&(Q=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({workspace:T.workspace,userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:T.remoteAuthority,forceNewWindow:_,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:q,windowToUse:Q})}getPathsToOpen(L){let T,_=!1,q=!1;if(L.urisToOpen&&L.urisToOpen.length>0?(T=this.doExtractPathsFromAPI(L),_=!0):L.forceEmpty?T=[Object.create(null)]:L.cli._.length||L.cli["folder-uri"]||L.cli["file-uri"]?(T=this.doExtractPathsFromCLI(L.cli),T.length===0&&T.push(Object.create(null)),_=!0):(T=this.doGetPathsFromLastSession(),T.length===0&&T.push(Object.create(null)),q=!0),!L.addMode&&_){const Q=T.filter(te=>Z(te));if(Q.length>1){const te=Q[0].remoteAuthority;if(Q.every(U=>(0,m.isEqualAuthority)(U.remoteAuthority,te))){const U=this.workspacesManagementMainService.createUntitledWorkspaceSync(Q.map(Y=>({uri:Y.workspace.uri})));T.push({workspace:U,remoteAuthority:te}),T=T.filter(Y=>!Z(Y))}}}return L.initialStartup&&!q&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&T.unshift(...this.doGetPathsFromLastSession().filter(Q=>H(Q)||Z(Q)||Q.backupPath)),T}doExtractPathsFromAPI(L){const T=[],_={gotoLineMode:L.gotoLineMode,remoteAuthority:L.remoteAuthority};for(const q of(0,R.coalesce)(L.urisToOpen||[])){const Q=this.resolveOpenable(q,_);if(Q)Q.label=q.label,T.push(Q);else{const te=this.resourceFromOpenable(q),U={title:this.productService.nameLong,type:"info",buttons:[(0,E.mnemonicButtonLabel)((0,u.localize)(0,null))],defaultId:0,message:te.scheme===p.Schemas.file?(0,u.localize)(1,null):(0,u.localize)(2,null),detail:te.scheme===p.Schemas.file?(0,u.localize)(3,null,(0,E.getPathLabel)(te,{os:P.OS,tildify:this.environmentMainService})):(0,u.localize)(4,null,te.toString(!0)),noLink:!0};this.dialogMainService.showMessageBox(U,(0,v.withNullAsUndefined)(S.BrowserWindow.getFocusedWindow()))}}return T}doExtractPathsFromCLI(L){const T=[],_={ignoreFileNotFound:!0,gotoLineMode:L.goto,remoteAuthority:L.remote||void 0,forceOpenWorkspaceAsFile:L.diff&&L._.length===2||L.merge&&L._.length===4},q=L["folder-uri"];if(q)for(const U of q){const Y=this.cliArgToUri(U);if(Y){const x=this.resolveOpenable({folderUri:Y},_);x&&T.push(x)}}const Q=L["file-uri"];if(Q)for(const U of Q){const Y=this.cliArgToUri(U);if(Y){const x=this.resolveOpenable((0,ne.hasWorkspaceFileExtension)(U)?{workspaceUri:Y}:{fileUri:Y},_);x&&T.push(x)}}const te=L._;for(const U of te){const Y=_.remoteAuthority?this.doResolvePathRemote(U,_):this.doResolveFilePath(U,_);Y&&T.push(Y)}return T}cliArgToUri(L){try{const T=f.URI.parse(L);if(!T.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${L}`);return}return T}catch(T){this.logService.error(`Invalid URI input string: ${L}, ${T.message}`)}}doGetPathsFromLastSession(){const L=this.getRestoreWindowsSetting();switch(L){case"none":return[];case"one":case"all":case"preserve":case"folders":{const T=[];L!=="one"&&T.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&T.push(this.windowsStateHandler.state.lastActiveWindow);const _=[];for(const q of T)if(q.workspace){const Q=this.resolveOpenable({workspaceUri:q.workspace.configPath},{remoteAuthority:q.remoteAuthority,rejectTransientWorkspaces:!0});H(Q)&&_.push(Q)}else if(q.folderUri){const Q=this.resolveOpenable({folderUri:q.folderUri},{remoteAuthority:q.remoteAuthority});Z(Q)&&_.push(Q)}else L!=="folders"&&q.backupPath&&_.push({backupPath:q.backupPath,remoteAuthority:q.remoteAuthority});return _}}}getRestoreWindowsSetting(){let L;return this.lifecycleMainService.wasRestarted?L="all":(L=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(L)||(L="all")),L}resolveOpenable(L,T=Object.create(null)){const _=this.resourceFromOpenable(L);return _.scheme===p.Schemas.file?((0,K.isFileToOpen)(L)&&(T={...T,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(_.fsPath,T)):this.doResolveRemoteOpenable(L,T)}doResolveRemoteOpenable(L,T){let _=this.resourceFromOpenable(L);const q=(0,W.getRemoteAuthority)(_)||T.remoteAuthority;if(_=(0,m.removeTrailingPathSeparator)((0,m.normalizePath)(_)),(0,K.isFileToOpen)(L)){if(T.gotoLineMode){const{path:Q,line:te,column:U}=(0,h.parseLineAndColumnAware)(_.path);return{fileUri:_.with({path:Q}),options:{selection:te?{startLineNumber:te,startColumn:U||1}:void 0},remoteAuthority:q}}return{fileUri:_,remoteAuthority:q}}else if((0,K.isWorkspaceToOpen)(L))return{workspace:(0,ae.getWorkspaceIdentifier)(_),remoteAuthority:q};return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(_),remoteAuthority:q}}resourceFromOpenable(L){return(0,K.isWorkspaceToOpen)(L)?L.workspaceUri:(0,K.isFolderToOpen)(L)?L.folderUri:L.fileUri}doResolveFilePath(L,T){let _,q;T.gotoLineMode&&({path:L,line:_,column:q}=(0,h.parseLineAndColumnAware)(L)),L=(0,h.sanitizeFilePath)((0,g.normalize)(L),(0,y.cwd)());try{const Q=(0,t.statSync)(L);if(Q.isFile()){if(!T.forceOpenWorkspaceAsFile){const te=this.workspacesManagementMainService.resolveLocalWorkspaceSync(f.URI.file(L));if(te)return te.transient&&T.rejectTransientWorkspaces?void 0:{workspace:{id:te.id,configPath:te.configPath},type:n.FileType.File,exists:!0,remoteAuthority:te.remoteAuthority,transient:te.transient}}return{fileUri:f.URI.file(L),type:n.FileType.File,exists:!0,options:{selection:_?{startLineNumber:_,startColumn:q||1}:void 0}}}else{if(Q.isDirectory())return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(f.URI.file(L),Q),type:n.FileType.Directory,exists:!0};if(!P.isWindows&&L==="/dev/null")return{fileUri:f.URI.file(L),type:n.FileType.File,exists:!0}}}catch{const te=f.URI.file(L);if(this.workspacesHistoryMainService.removeRecentlyOpened([te]),T.ignoreFileNotFound)return{fileUri:te,type:n.FileType.File,exists:!1}}}doResolvePathRemote(L,T){const _=L.charCodeAt(0),q=T.remoteAuthority;let Q,te;T.gotoLineMode&&({path:L,line:Q,column:te}=(0,h.parseLineAndColumnAware)(L)),_!==47&&((0,h.isWindowsDriveLetter)(_)&&L.charCodeAt(L.charCodeAt(1))===58&&(L=(0,h.toSlashes)(L)),L=`/${L}`);const U=f.URI.from({scheme:p.Schemas.vscodeRemote,authority:q,path:L});if(L.charCodeAt(L.length-1)!==47){if((0,ne.hasWorkspaceFileExtension)(L))return T.forceOpenWorkspaceAsFile?{fileUri:U,options:{selection:Q?{startLineNumber:Q,startColumn:te||1}:void 0},remoteAuthority:T.remoteAuthority}:{workspace:(0,ae.getWorkspaceIdentifier)(U),remoteAuthority:q};if(T.gotoLineMode||g.posix.basename(L).indexOf(".")!==-1)return{fileUri:U,options:{selection:Q?{startLineNumber:Q,startColumn:te||1}:void 0},remoteAuthority:q}}return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(U),remoteAuthority:q}}shouldOpenNewWindow(L){const T=this.configurationService.getValue("window"),_=T?.openFoldersInNewWindow||"default",q=T?.openFilesInNewWindow||"off";let Q=(L.preferNewWindow||L.forceNewWindow)&&!L.forceReuseWindow;!L.forceNewWindow&&!L.forceReuseWindow&&(_==="on"||_==="off")&&(Q=_==="on");let te=!1;return L.forceNewWindow||L.forceReuseWindow?te=!!L.forceNewWindow&&!L.forceReuseWindow:(P.isMacintosh?L.context===1&&(te=!0):L.context!==3&&L.context!==2&&!(L.userEnv&&L.userEnv.TERM_PROGRAM==="vscode")&&(te=!0),!L.cli.extensionDevelopmentPath&&(q==="on"||q==="off")&&(te=q==="on")),{openFolderInNewWindow:!!Q,openFilesInNewWindow:te}}openExtensionDevelopmentHostWindow(L,T){const _=(0,oe.findWindowOnExtensionDevelopmentPath)(this.getWindows(),L);if(_)return this.lifecycleMainService.reload(_,T.cli),_.focus(),[_];let q=T.cli["folder-uri"]||[],Q=T.cli["file-uri"]||[],te=T.cli._;if(!te.length&&!q.length&&!Q.length&&!T.cli.extensionTestsPath){const re=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ce=re&&(re.workspace||re.folderUri);ce&&(f.URI.isUri(ce)?ce.scheme===p.Schemas.file?te=[ce.fsPath]:q=[ce.toString()]:ce.configPath.scheme===p.Schemas.file?te=[(0,m.originalFSPath)(ce.configPath)]:Q=[ce.configPath.toString()])}let U=T.remoteAuthority;for(const re of L)if(re.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ce=f.URI.parse(re),Ee=(0,W.getRemoteAuthority)(ce);Ee&&(U?(0,m.isEqualAuthority)(Ee,U)||this.logService.error("more than one extension development path authority"):U=Ee)}te=te.filter(re=>{const ce=f.URI.file(re);return(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:(0,m.isEqualAuthority)((0,W.getRemoteAuthority)(ce),U)}),q=q.filter(re=>{const ce=this.cliArgToUri(re);return ce&&!!(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:ce?(0,m.isEqualAuthority)((0,W.getRemoteAuthority)(ce),U):!1}),Q=Q.filter(re=>{const ce=this.cliArgToUri(re);return ce&&!!(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:ce?(0,m.isEqualAuthority)((0,W.getRemoteAuthority)(ce),U):!1}),T.cli._=te,T.cli["folder-uri"]=q,T.cli["file-uri"]=Q;const Y=!te.length&&!q.length&&!Q.length,x={context:T.context,cli:T.cli,forceNewWindow:!0,forceEmpty:Y,userEnv:T.userEnv,noRecentEntry:!0,waitMarkerFileURI:T.waitMarkerFileURI,remoteAuthority:U};return this.open(x)}openInBrowserWindow(L){const T=this.configurationService.getValue("window"),_={...this.environmentMainService.args,...L.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:L.emptyWindowBackupInfo?(0,g.join)(this.environmentMainService.backupHome,L.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.userDataProfilesService.profiles,current:this.userDataProfilesService.getProfile(L.workspace??"empty-window",(L.windowToUse??this.getLastActiveWindow())?.profile??this.userDataProfilesService.defaultProfile)},homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:L.remoteAuthority,workspace:L.workspace,userEnv:{...this.initialUserEnv,...L.userEnv},filesToOpenOrCreate:L.filesToOpen?.filesToOpenOrCreate,filesToDiff:L.filesToOpen?.filesToDiff,filesToMerge:L.filesToOpen?.filesToMerge,filesToWait:L.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:I.default,isInitialStartup:L.initialStartup,perfMarks:(0,d.getMarks)(),os:{release:(0,M.release)(),hostname:(0,M.hostname)()},zoomLevel:typeof T?.zoomLevel=="number"?T.zoomLevel:void 0,autoDetectHighContrast:T?.autoDetectHighContrast??!0,autoDetectColorScheme:T?.autoDetectColorScheme??!1,accessibilitySupport:S.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize(),editSessionId:this.environmentMainService.editSessionId};let q;if(!L.forceNewWindow&&!L.forceNewTabbedWindow&&(q=L.windowToUse||this.getLastActiveWindow(),q&&q.focus()),q){const Q=q.config;!_.extensionDevelopmentPath&&Q&&!!Q.extensionDevelopmentPath&&(_.extensionDevelopmentPath=Q.extensionDevelopmentPath,_.extensionDevelopmentKind=Q.extensionDevelopmentKind,_["enable-proposed-api"]=Q["enable-proposed-api"],_.verbose=Q.verbose,_["inspect-extensions"]=Q["inspect-extensions"],_["inspect-brk-extensions"]=Q["inspect-brk-extensions"],_.debugId=Q.debugId,_.extensionEnvironment=Q.extensionEnvironment,_["extensions-dir"]=Q["extensions-dir"],_["disable-extensions"]=Q["disable-extensions"])}else{const Q=this.windowsStateHandler.getNewWindowState(_);(0,d.mark)("code/willCreateCodeWindow");const te=q=this.instantiationService.createInstance(ie.CodeWindow,{state:Q,extensionDevelopmentPath:_.extensionDevelopmentPath,isExtensionTestHost:!!_.extensionTestsPath});(0,d.mark)("code/didCreateCodeWindow"),L.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(te),ut.WINDOWS.push(te),this._onDidOpenWindow.fire(te),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,w.once)(te.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(te)),(0,w.once)(te.onDidClose)(()=>this.onWindowClosed(te)),(0,w.once)(te.onDidDestroy)(()=>this._onDidDestroyWindow.fire(te)),te.onDidTriggerSystemContextMenu(({x:Y,y:x})=>this._onDidTriggerSystemContextMenu.fire({window:te,x:Y,y:x}));const U=(0,v.assertIsDefined)(te.win?.webContents);U.removeAllListeners("devtools-reload-page"),U.on("devtools-reload-page",()=>this.lifecycleMainService.reload(te)),this.lifecycleMainService.registerWindow(te)}return _.windowId=q.id,q.isReady?this.lifecycleMainService.unload(q,4).then(Q=>{Q||this.doOpenInBrowserWindow(q,_,L)}):this.doOpenInBrowserWindow(q,_,L),q}doOpenInBrowserWindow(L,T,_){if(!T.extensionDevelopmentPath)if((0,ne.isWorkspaceIdentifier)(T.workspace))T.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:T.workspace,remoteAuthority:T.remoteAuthority});else if((0,ne.isSingleFolderWorkspaceIdentifier)(T.workspace))T.backupPath=this.backupMainService.registerFolderBackupSync({folderUri:T.workspace.uri,remoteAuthority:T.remoteAuthority});else{const q=_.emptyWindowBackupInfo&&_.emptyWindowBackupInfo.backupFolder;T.backupPath=this.backupMainService.registerEmptyWindowBackupSync(q,T.remoteAuthority)}L.load(T)}onWindowClosed(L){const T=ut.WINDOWS.indexOf(L);ut.WINDOWS.splice(T,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const L=S.BrowserWindow.getFocusedWindow();if(L)return this.getWindowById(L.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(L){return this.doGetLastActiveWindow(this.getWindows().filter(T=>(0,m.isEqualAuthority)(T.remoteAuthority,L)))}doGetLastActiveWindow(L){const T=Math.max.apply(Math,L.map(_=>_.lastFocusTime));return L.find(_=>_.lastFocusTime===T)}sendToFocused(L,...T){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(L,D.CancellationToken.None,...T)}sendToAll(L,T,_){for(const q of this.getWindows())_&&_.indexOf(q.id)>=0||q.sendWhenReady(L,D.CancellationToken.None,T)}getWindows(){return ut.WINDOWS}getWindowCount(){return ut.WINDOWS.length}getWindowById(L){const T=this.getWindows().filter(_=>_.id===L);return(0,R.firstOrDefault)(T)}getWindowByWebContents(L){const T=S.BrowserWindow.fromWebContents(L);if(!!T)return this.getWindowById(T.id)}};$.WINDOWS=[],$=ge([ee(2,l.ILogService),ee(3,F.IStateMainService),ee(4,O.IPolicyService),ee(5,i.IEnvironmentMainService),ee(6,N.IUserDataProfilesService),ee(7,a.ILifecycleMainService),ee(8,c.IBackupMainService),ee(9,o.IConfigurationService),ee(10,le.IWorkspacesHistoryMainService),ee(11,G.IWorkspacesManagementMainService),ee(12,s.IInstantiationService),ee(13,r.IDialogMainService),ee(14,n.IFileService),ee(15,k.IProductService),ee(16,A.IProtocolMainService),ee(17,B.IThemeMainService)],$),e.WindowsMainService=$}),define(X[252],J([0,1,58,32,74,46]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let D=class{constructor(h,w,E,C){this.workspacesManagementMainService=h,this.windowsMainService=w,this.workspacesHistoryMainService=E,this.backupMainService=C,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(h,w){const E=this.windowsMainService.getWindowById(h);if(E)return this.workspacesManagementMainService.enterWorkspace(E,this.windowsMainService.getWindows(),w)}createUntitledWorkspace(h,w,E){return this.workspacesManagementMainService.createUntitledWorkspace(w,E)}deleteUntitledWorkspace(h,w){return this.workspacesManagementMainService.deleteUntitledWorkspace(w)}getWorkspaceIdentifier(h,w){return this.workspacesManagementMainService.getWorkspaceIdentifier(w)}getRecentlyOpened(h){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(h,w){return this.workspacesHistoryMainService.addRecentlyOpened(w)}removeRecentlyOpened(h,w){return this.workspacesHistoryMainService.removeRecentlyOpened(w)}clearRecentlyOpened(h){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};D=ge([ee(0,R.IWorkspacesManagementMainService),ee(1,t.IWindowsMainService),ee(2,M.IWorkspacesHistoryMainService),ee(3,S.IBackupMainService)],D),e.WorkspacesMainService=D}),define(X[253],J([0,1,14,38,28,29,17,42,19,31,47,48,34,2,13,9,4,11,7,27,80,128,43,140,96,232,143,58,237,18,68,173,83,114,54,99,171,26,57,106,180,200,181,234,101,182,183,15,193,85,67,5,84,245,211,115,22,6,195,250,64,20,71,240,86,40,238,88,107,35,216,218,72,45,223,224,246,225,247,109,227,228,229,230,235,32,251,236,24,89,74,252,46,233,37,199,63,100,243,207,53]),function(z,e,S,t,M,R,D,b,h,w,E,C,p,g,d,P,y,m,v,f,u,c,o,r,i,n,s,a,l,I,k,A,W,F,K,ie,oe,ue,ne,ae,le,G,B,N,O,H,Z,$,j,L,T,_,q,Q,te,U,Y,x,re,ce,Ee,Ce,Pe,Me,Be,de,fe,pe,Ie,Le,Xe,Re,We,Te,Ge,je,Je,ze,Ve,V,se,he,me,be,Ae,qe,nt,et,He,Ze,xe,at,ct,At,Tt,Wt,Ot,Ft,_t,Ut,Nt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Et=class extends g.Disposable{constructor(we,Se,ye,ve,De,Fe,Oe,_e,ke,Ue){super();this.mainProcessNodeIpcServer=we,this.userEnv=Se,this.mainInstantiationService=ye,this.logService=ve,this.environmentMainService=De,this.lifecycleMainService=Fe,this.configurationService=Oe,this.stateMainService=_e,this.fileService=ke,this.productService=Ue,this.configureSession(),this.registerListeners()}configureSession(){const we=ke=>ke?.startsWith(`${d.Schemas.vscodeWebview}://`),Se=new Set(["clipboard-read","clipboard-sanitized-write"]);S.session.defaultSession.setPermissionRequestHandler((ke,Ue,$e,Ke)=>we(Ke.requestingUrl)?$e(Se.has(Ue)):$e(!1)),S.session.defaultSession.setPermissionCheckHandler((ke,Ue,$e,Ke)=>we(Ke.requestingUrl)?Se.has(Ue):!1);const ye=new Set([d.Schemas.file,d.Schemas.vscodeFileResource,d.Schemas.vscodeRemoteResource,"devtools"]),ve=ke=>{for(let Ue=ke;Ue;Ue=Ue.parent)if(Ue.url.startsWith(`${d.Schemas.vscodeWebview}://`))return!0;return!1},De=ke=>ke.resourceType==="xhr"||ve(ke.frame),Fe=ke=>{const Ue=ke.frame;if(!Ue||!this.windowsMainService)return!1;const $e=S.BrowserWindow.getAllWindows();for(const Ke of $e)if(Ue.processId===Ke.webContents.mainFrame.processId)return!0;return!1},Oe=(ke,Ue)=>{if(ke.path!=="/index.html")return!0;const $e=Ue.frame;if(!$e||!this.windowsMainService)return!1;for(const Ke of this.windowsMainService.getWindows())if(Ke.win&&$e.processId===Ke.win.webContents.mainFrame.processId)return!0;return!1};S.session.defaultSession.webRequest.onBeforeRequest((ke,Ue)=>{const $e=v.URI.parse(ke.url);return $e.scheme===d.Schemas.vscodeWebview&&!Oe($e,ke)?(this.logService.error("Blocked vscode-webview request",ke.url),Ue({cancel:!0})):$e.scheme===d.Schemas.vscodeFileResource&&!Fe(ke)?(this.logService.error("Blocked vscode-file request",ke.url),Ue({cancel:!0})):$e.path.endsWith(".svg")&&!ye.has($e.scheme)?Ue({cancel:!De(ke)}):Ue({cancel:!1})}),S.session.defaultSession.webRequest.onHeadersReceived((ke,Ue)=>{const $e=ke.responseHeaders,Ke=$e["content-type"]||$e["Content-Type"];if(Ke&&Array.isArray(Ke)){const rt=v.URI.parse(ke.url);if(rt.path.endsWith(".svg")&&ye.has(rt.scheme))return $e["Content-Type"]=["image/svg+xml"],Ue({cancel:!1,responseHeaders:$e});if(!rt.path.endsWith(d.Schemas.vscodeRemoteResource)&&Ke.some(dt=>dt.toLowerCase().includes("image/svg")))return Ue({cancel:!De(ke)})}return Ue({cancel:!1})});const _e=S.session.defaultSession;typeof _e.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&_e.setCodeCachePath((0,P.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,h.setUnexpectedErrorHandler)(ye=>this.onUnexpectedError(ye)),process.on("uncaughtException",ye=>(0,h.onUnexpectedError)(ye)),process.on("unhandledRejection",ye=>(0,h.onUnexpectedError)(ye)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,c.registerContextMenuListener)(),S.app.on("accessibility-support-changed",(ye,ve)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",ve)}),S.app.on("activate",(ye,ve)=>{this.logService.trace("app#activate"),ve||this.windowsMainService?.openEmptyWindow({context:1})}),S.app.on("web-contents-created",(ye,ve)=>{ve.on("will-navigate",De=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),De.preventDefault()}),ve.setWindowOpenHandler(({url:De})=>(this.nativeHostMainService?.openExternal(void 0,De),{action:"deny"}))});let we=[],Se;S.app.on("open-file",(ye,ve)=>{this.logService.trace("app#open-file: ",ve),ye.preventDefault(),we.push(this.getWindowOpenableFromPathSync(ve)),Se!==void 0&&(clearTimeout(Se),Se=void 0),Se=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:we,gotoLineMode:!1,preferNewWindow:!0}),we=[],Se=void 0},100)}),S.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",ye=>{const ve=this.windowsMainService?.getWindowByWebContents(ye.sender);let De,Fe;return ve?.config?(De=ve.config,Fe={...process.env,...ve.config.userEnv}):(De=this.environmentMainService.args,Fe=process.env),this.resolveShellEnvironment(De,Fe,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(ye,ve,De)=>{const Fe=this.validateNlsPath([ve]);if(!Fe||typeof De!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Fe,D.VSBuffer.fromString(De))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(ye,...ve)=>{const De=this.validateNlsPath(ve);if(!De)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(De)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",ye=>ye.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",ye=>ye.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",ye=>ye.sender.reload())}validateNlsPath(we){let Se;for(const ye of we)typeof ye=="string"&&(typeof Se!="string"?Se=ye:Se=(0,P.join)(Se,ye));if(!(typeof Se!="string"||!(0,P.isAbsolute)(Se)||!(0,w.isEqualOrParent)(Se,this.environmentMainService.cachedLanguagesPath,!y.isLinux)))return v.URI.file(Se)}onUnexpectedError(we){if(we){const Se={message:`[uncaught exception in main]: ${we.message}`,stack:we.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Se))}this.logService.error(`[uncaught exception in main]: ${we}`),we.stack&&this.logService.error(we.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const we=this.productService.win32AppUserModelId;y.isWindows&&we&&S.app.setAppUserModelId(we);try{y.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!S.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&S.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(ke){this.logService.error(ke)}const Se=new r.Server;this.lifecycleMainService.onWillShutdown(ke=>{ke.reason===2&&Se.dispose()}),this.logService.trace("Resolving machine identifier...");const ye=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${ye}`);const{sharedProcess:ve,sharedProcessReady:De,sharedProcessClient:Fe}=this.setupSharedProcess(ye),Oe=await this.initServices(ye,ve,De);this.setUpHandlers(Oe),Oe.invokeFunction(ke=>this.initChannels(ke,Se,Fe));const _e=Oe.invokeFunction(ke=>this.openFirstWindow(ke,Se));Oe.invokeFunction(ke=>this.afterWindowOpen(ke,ve)),this.environmentMainService.args.trace&&Oe.invokeFunction(ke=>this.stopTracingEventually(ke,_e))}setUpHandlers(we){this._register(we.createInstance(n.ProxyAuthHandler)),this._register(we.createInstance(_t.DefaultExtensionsProfileInitHandler))}async resolveMachineId(){let we=this.stateMainService.getItem(Le.machineIdKey);return(!we||y.isMacintosh&&we==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(we=await(0,u.getMachineId)(),this.stateMainService.setItem(Le.machineIdKey,we)),we}setupSharedProcess(we){const Se=this._register(this.mainInstantiationService.createInstance(Me.SharedProcess,we,this.userEnv)),ye=(async()=>{this.logService.trace("Main->SharedProcess#connect");const De=await Se.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new i.Client(De,"main")})(),ve=(async()=>(await Se.whenReady(),ye))();return{sharedProcess:Se,sharedProcessReady:ve,sharedProcessClient:ye}}async initServices(we,Se,ye){const ve=new q.ServiceCollection;switch(process.platform){case"win32":ve.set(Te.IUpdateService,new T.SyncDescriptor(Ve.Win32UpdateService));break;case"linux":y.isLinuxSnap?ve.set(Te.IUpdateService,new T.SyncDescriptor(ze.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ve.set(Te.IUpdateService,new T.SyncDescriptor(Je.LinuxUpdateService));break;case"darwin":ve.set(Te.IUpdateService,new T.SyncDescriptor(je.DarwinUpdateService));break}ve.set(qe.IWindowsMainService,new T.SyncDescriptor(nt.WindowsMainService,[we,this.userEnv])),ve.set(K.IDialogMainService,new T.SyncDescriptor(K.DialogMainService)),ve.set(U.ILaunchMainService,new T.SyncDescriptor(U.LaunchMainService)),ve.set(F.IDiagnosticsMainService,new T.SyncDescriptor(F.DiagnosticsMainService)),ve.set(W.IDiagnosticsService,o.ProxyChannel.toService((0,o.getDelayedChannel)(ye.then(Fe=>Fe.getChannel("diagnostics"))))),ve.set(Q.IIssueMainService,new T.SyncDescriptor(Q.IssueMainService,[this.userEnv])),ve.set(ie.IEncryptionMainService,new T.SyncDescriptor(oe.EncryptionMainService,[we])),ve.set(te.IKeyboardLayoutMainService,new T.SyncDescriptor(te.KeyboardLayoutMainService)),ve.set(Ee.INativeHostMainService,new T.SyncDescriptor(Ee.NativeHostMainService,[Se])),ve.set(k.ICredentialsMainService,new T.SyncDescriptor(At.CredentialsNativeMainService)),ve.set(be.IWebviewManagerService,new T.SyncDescriptor(Ae.WebviewMainService)),ve.set(Ze.IWorkspacesService,new T.SyncDescriptor(at.WorkspacesMainService)),ve.set(ct.IWorkspacesManagementMainService,new T.SyncDescriptor(ct.WorkspacesManagementMainService)),ve.set(xe.IWorkspacesHistoryMainService,new T.SyncDescriptor(xe.WorkspacesHistoryMainService)),ve.set(ce.IMenubarMainService,new T.SyncDescriptor(ce.MenubarMainService)),ve.set(le.IExtensionUrlTrustService,new T.SyncDescriptor(G.ExtensionUrlTrustService)),ve.set(B.IExtensionHostStarter,new T.SyncDescriptor(N.ExtensionHostStarter)),ve.set(pe.IStorageMainService,new T.SyncDescriptor(pe.StorageMainService)),ve.set(pe.IApplicationStorageMainService,new T.SyncDescriptor(pe.ApplicationStorageMainService)),y.isWindows?ve.set(O.IExternalTerminalMainService,new T.SyncDescriptor(H.WindowsExternalTerminalService)):y.isMacintosh?ve.set(O.IExternalTerminalMainService,new T.SyncDescriptor(H.MacExternalTerminalService)):y.isLinux&&ve.set(O.IExternalTerminalMainService,new T.SyncDescriptor(H.LinuxExternalTerminalService));const De=new l.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(ve.set(a.IBackupMainService,De),ve.set(V.IURLService,new T.SyncDescriptor(he.NativeURLService)),(0,We.supportsTelemetry)(this.productService,this.environmentMainService)){const Fe=(0,We.isInternalTelemetry)(this.productService,this.configurationService),Oe=(0,o.getDelayedChannel)(ye.then(Ke=>Ke.getChannel("telemetryAppender"))),_e=new Xe.TelemetryAppenderClient(Oe),ke=(0,Ie.resolveCommonProperties)(this.fileService,(0,R.release)(),(0,R.hostname)(),process.arch,this.productService.commit,this.productService.version,we,Fe,this.environmentMainService.installSourcePath),Ue=(0,We.getPiiPathsFromEnvironment)(this.environmentMainService),$e={appenders:[_e],commonProperties:ke,piiPaths:Ue,sendErrorTelemetry:!0};ve.set(Le.ITelemetryService,new T.SyncDescriptor(Re.TelemetryService,[$e]))}else ve.set(Le.ITelemetryService,We.NullTelemetryService);return ve.set(Ft.IDefaultExtensionsProfileInitService,o.ProxyChannel.toService((0,o.getDelayedChannel)(ye.then(Fe=>Fe.getChannel("IDefaultExtensionsProfileInitService"))))),await De.initialize(),this.mainInstantiationService.createChild(ve)}initChannels(we,Se,ye){const ve=o.ProxyChannel.fromService(we.get(U.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",ve);const De=o.ProxyChannel.fromService(we.get(F.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",De);const Fe=new Wt.PolicyChannel(we.get(Tt.IPolicyService));Se.registerChannel("policy",Fe),ye.then(Ye=>Ye.registerChannel("policy",Fe));const Oe=this.fileService.getProvider(d.Schemas.file);(0,m.assertType)(Oe instanceof L.DiskFileSystemProvider);const _e=new j.DiskFileSystemProviderChannel(Oe,this.logService,this.environmentMainService);Se.registerChannel(Z.LOCAL_FILE_SYSTEM_CHANNEL_NAME,_e),ye.then(Ye=>Ye.registerChannel(Z.LOCAL_FILE_SYSTEM_CHANNEL_NAME,_e));const ke=o.ProxyChannel.fromService(we.get(Ot.IUserDataProfilesMainService));Se.registerChannel("userDataProfiles",ke),ye.then(Ye=>Ye.registerChannel("userDataProfiles",ke));const Ue=new Ut.RequestChannel(we.get(Nt.IRequestService));ye.then(Ye=>Ye.registerChannel("request",Ue));const $e=new Ge.UpdateChannel(we.get(Te.IUpdateService));Se.registerChannel("update",$e);const Ke=o.ProxyChannel.fromService(we.get(Q.IIssueMainService));Se.registerChannel("issue",Ke);const rt=o.ProxyChannel.fromService(we.get(ie.IEncryptionMainService));Se.registerChannel("encryption",rt);const dt=o.ProxyChannel.fromService(we.get(k.ICredentialsMainService));Se.registerChannel("credentials",dt);const Ct=o.ProxyChannel.fromService(we.get(Be.ISignService));Se.registerChannel("sign",Ct);const Qe=o.ProxyChannel.fromService(we.get(te.IKeyboardLayoutMainService));Se.registerChannel("keyboardLayout",Qe),this.nativeHostMainService=we.get(Ee.INativeHostMainService);const ht=o.ProxyChannel.fromService(this.nativeHostMainService);Se.registerChannel("nativeHost",ht),ye.then(Ye=>Ye.registerChannel("nativeHost",ht));const ft=o.ProxyChannel.fromService(we.get(Ze.IWorkspacesService));Se.registerChannel("workspaces",ft);const gt=o.ProxyChannel.fromService(we.get(ce.IMenubarMainService));Se.registerChannel("menubar",gt);const wt=o.ProxyChannel.fromService(we.get(V.IURLService));Se.registerChannel("url",wt);const pt=o.ProxyChannel.fromService(we.get(le.IExtensionUrlTrustService));Se.registerChannel("extensionUrlTrust",pt);const mt=o.ProxyChannel.fromService(we.get(be.IWebviewManagerService));Se.registerChannel("webview",mt);const lt=this._register(new fe.StorageDatabaseChannel(this.logService,we.get(pe.IStorageMainService)));Se.registerChannel("storage",lt),ye.then(Ye=>Ye.registerChannel("storage",lt));const vt=o.ProxyChannel.fromService(we.get(O.IExternalTerminalMainService));Se.registerChannel("externalTerminal",vt);const Ne=new re.LogLevelChannel(we.get(x.ILogService));Se.registerChannel("logLevel",Ne),ye.then(Ye=>Ye.registerChannel("logLevel",Ne));const it=new re.LoggerChannel(we.get(x.ILoggerService));Se.registerChannel("logger",it),ye.then(Ye=>Ye.registerChannel("logger",it));const ot=new A.ElectronExtensionHostDebugBroadcastChannel(we.get(qe.IWindowsMainService));Se.registerChannel("extensionhostdebugservice",ot);const st=o.ProxyChannel.fromService(we.get(B.IExtensionHostStarter));Se.registerChannel(B.ipcExtensionHostStarterChannelName,st)}openFirstWindow(we,Se){const ye=this.windowsMainService=we.get(qe.IWindowsMainService),ve=we.get(V.IURLService),De=we.get(Ee.INativeHostMainService);this.lifecycleMainService.phase=2;const Fe=[],Oe=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Ne=>{try{return{uri:v.URI.parse(Ne),url:Ne}}catch{return}}).filter(Ne=>{if(!Ne||this.shouldBlockURI(Ne.uri))return!1;const it=this.getWindowOpenableFromProtocolLink(Ne.uri);return it?(Fe.push(it),!1):!0}),_e=this,ke=this.environmentMainService,Ue=this.productService,$e=this.logService;ve.registerHandler({async handleURL(Ne,it){if($e.trace("app#handleURL: ",Ne.toString(!0),it),Ne.scheme===Ue.urlProtocol&&Ne.path==="workspace"&&(Ne=Ne.with({authority:"file",path:v.URI.parse(Ne.query).path,query:""})),_e.shouldBlockURI(Ne))return!0;let ot=!1;const st=new URLSearchParams(Ne.query);st.get("windowId")==="_blank"&&(st.delete("windowId"),Ne=Ne.with({query:st.toString()}),ot=!0),ot||(ot=y.isMacintosh&&ye.getWindowCount()===0),st.get("editSessionId")!==null&&(ke.editSessionId=st.get("editSessionId")??void 0,st.delete("editSessionId"),Ne=Ne.with({query:st.toString()}));const Ye=_e.getWindowOpenableFromProtocolLink(Ne);if($e.trace("app#handleURL: windowOpenableFromProtocolLink = ",Ye),Ye){const[It]=ye.open({context:5,cli:{...ke.args},urisToOpen:[Ye],forceNewWindow:ot,gotoLineMode:!0});return It.focus(),!0}if(ot){const[It]=ye.open({context:5,cli:{...ke.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Pe.getRemoteAuthority)(Ne)});return await It.ready(),ve.open(Ne,it)}return!1}});const Ke=this._register(new et.ActiveWindowManager({onDidOpenWindow:De.onDidOpenWindow,onDidFocusWindow:De.onDidFocusWindow,getActiveWindowId:()=>De.getActiveWindowId(-1)})),rt=new o.StaticRouter(Ne=>Ke.getActiveClientId().then(it=>Ne===it)),dt=new se.URLHandlerRouter(rt),Ct=Se.getChannel("urlHandler",dt);ve.registerHandler(new se.URLHandlerChannelClient(Ct)),this._register(new me.ElectronURLListener(Oe,ve,ye,this.environmentMainService,this.productService));const Qe=this.environmentMainService.args,ht=global.macOpenFiles,ft=(0,ne.isLaunchedFromCli)(process.env)?0:4,gt=Qe._.length,wt=!!Qe["folder-uri"],pt=!!Qe["file-uri"],mt=Qe["skip-add-to-recently-opened"]===!0,lt=Qe.wait&&Qe.waitMarkerFilePath?v.URI.file(Qe.waitMarkerFilePath):void 0,vt=Qe.remote||void 0;return Fe.length>0?ye.open({context:ft,cli:Qe,urisToOpen:Fe,gotoLineMode:!0,initialStartup:!0}):Qe["new-window"]&&!gt&&!wt&&!pt?ye.open({context:ft,cli:Qe,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:mt,waitMarkerFileURI:lt,initialStartup:!0,remoteAuthority:vt}):ht.length&&!gt&&!wt&&!pt?ye.open({context:1,cli:Qe,urisToOpen:ht.map(Ne=>this.getWindowOpenableFromPathSync(Ne)),noRecentEntry:mt,waitMarkerFileURI:lt,initialStartup:!0}):ye.open({context:ft,cli:Qe,forceNewWindow:Qe["new-window"]||!gt&&Qe["unity-launch"],diffMode:Qe.diff,mergeMode:Qe.merge,noRecentEntry:mt,waitMarkerFileURI:lt,gotoLineMode:Qe.goto,initialStartup:!0,remoteAuthority:vt})}shouldBlockURI(we){return!!(we.authority===d.Schemas.file&&y.isWindows&&S.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,p.mnemonicButtonLabel)((0,s.localize)(0,null)),(0,p.mnemonicButtonLabel)((0,s.localize)(1,null))],defaultId:0,cancelId:1,message:(0,s.localize)(2,null,(0,p.getPathLabel)(we,{os:y.OS,tildify:this.environmentMainService}),this.productService.nameShort),detail:(0,s.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(we){if(!!we.path){if(we.authority===d.Schemas.file){const Se=v.URI.file(we.fsPath);return(0,He.hasWorkspaceFileExtension)(Se)?{workspaceUri:Se}:{fileUri:Se}}else if(we.authority===d.Schemas.vscodeRemote){const Se=we.path.indexOf(P.posix.sep,1);if(Se!==-1){const ye=we.path.substring(1,Se),ve=we.path.substring(Se),De=v.URI.from({scheme:d.Schemas.vscodeRemote,authority:ye,path:ve,query:we.query,fragment:we.fragment});return(0,He.hasWorkspaceFileExtension)(ve)?{workspaceUri:De}:/:[\d]+$/.test(ve)?{fileUri:De}:{folderUri:De}}}}}getWindowOpenableFromPathSync(we){try{if((0,M.statSync)(we).isDirectory())return{folderUri:v.URI.file(we)};if((0,He.hasWorkspaceFileExtension)(we))return{workspaceUri:v.URI.file(we)}}catch{}return{fileUri:v.URI.file(we)}}async afterWindowOpen(we,Se){this.lifecycleMainService.phase=3;let ye=!1;(0,E.once)(this.lifecycleMainService.onWillShutdown)(()=>ye=!0);const ve=we.get(Le.ITelemetryService);this._register(Se.onDidError(({type:Oe,details:_e})=>{let ke;switch(Oe){case 1:ke="SharedProcess: detected unresponsive window";break;case 2:ke=`SharedProcess: crashed (detail: ${_e?.reason??"<unknown>"}, code: ${_e?.exitCode??"<unknown>"})`;break;case 3:ke=`SharedProcess: failed to load (detail: ${_e?.reason??"<unknown>"}, code: ${_e?.exitCode??"<unknown>"})`;break}(0,h.onUnexpectedError)(new Error(ke)),ve.publicLog2("sharedprocesserror",{type:Oe,reason:_e?.reason,code:_e?.exitCode,visible:Se.isVisible(),shuttingdown:ye})}));const De=this.productService.win32MutexName;if(y.isWindows&&De)try{const Oe=z.__$__nodeRequire("windows-mutex").Mutex,_e=new Oe(De);(0,E.once)(this.lifecycleMainService.onWillShutdown)(()=>_e.release())}catch(Oe){this.logService.error(Oe)}S.protocol.registerHttpProtocol(d.Schemas.vscodeRemoteResource,(Oe,_e)=>{_e({url:Oe.url.replace(/^vscode-remote-resource:/,"http:"),method:Oe.method})});const Fe=we.get(Te.IUpdateService);(Fe instanceof Ve.Win32UpdateService||Fe instanceof Je.LinuxUpdateService||Fe instanceof je.DarwinUpdateService)&&await Fe.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0);try{const _e=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,C.stripComments)(_e))["enable-crash-reporter"]===void 0){const $e=(0,We.getTelemetryLevel)(this.configurationService)>=1,Ke=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${$e},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,f.generateUuid)()}"`,"}"],rt=_e.substring(0,_e.length-2).concat(`,
`,Ke.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,D.VSBuffer.fromString(rt))}}catch(Oe){this.logService.error(Oe)}}async resolveShellEnvironment(we,Se,ye){try{return await(0,ae.getResolvedShellEnv)(this.logService,we,Se)}catch(ve){const De=(0,b.toErrorMessage)(ve);ye?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",De):this.logService.error(De)}return{}}stopTracingEventually(we,Se){this.logService.info("Tracing: waiting for windows to get ready...");const ye=we.get(K.IDialogMainService);let ve=!1;const De=async Oe=>{if(ve)return;ve=!0;const _e=await S.contentTracing.stopRecording(`${(0,w.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);Oe?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${_e}`):ye.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,s.localize)(4,null),detail:(0,s.localize)(5,null,_e),buttons:[(0,p.mnemonicButtonLabel)((0,s.localize)(6,null))],defaultId:0,noLink:!0},(0,m.withNullAsUndefined)(S.BrowserWindow.getFocusedWindow()))},Fe=setTimeout(()=>De(!0),3e4);Promise.all(Se.map(Oe=>Oe.ready())).then(()=>{clearTimeout(Fe),De(!1)})}};Et=ge([ee(2,_.IInstantiationService),ee(3,x.ILogService),ee(4,ue.IEnvironmentMainService),ee(5,Y.ILifecycleMainService),ee(6,I.IConfigurationService),ee(7,de.IStateMainService),ee(8,$.IFileService),ee(9,Ce.IProductService)],Et),e.CodeApplication=Et}),define(X[254],J([0,1,37,8,262,2]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;class D extends S.AbstractPolicyService{constructor(h){super();this.productName=h,this.throttler=new t.Throttler,this.watcher=this._register(new R.MutableDisposable)}async initializePolicies(h){await this.throttler.queue(()=>new Promise((w,E)=>{try{this.watcher.value=(0,M.createWatcher)(this.productName,h,C=>{for(const p in C){const g=C[p];g===void 0?this.policies.delete(p):this.policies.set(p,g)}this._onDidChange.fire(Object.keys(C)),w()})}catch(C){E(C)}}))}}e.NativePolicyService=D}),define(X[255],J([0,1,209,8,17,19,2,11,18,39,106,6,208,263]),function(z,e,S,t,M,R,D,b,h,w,E,C,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let d=class extends D.Disposable{constructor(y,m,v){super();this.environmentService=m,this.logService=v,this.configure(y.getValue()),this._register(y.onDidChangeConfiguration(()=>this.configure(y.getValue()),this))}configure(y){this.proxyUrl=y.http&&y.http.proxy,this.strictSSL=!!(y.http&&y.http.proxyStrictSSL),this.authorization=y.http&&y.http.proxyAuthorization}async request(y,m){this.logService.trace("RequestService#request (node) - begin",y.url);const{proxyUrl:v,strictSSL:f}=this;let u;try{u=await(0,E.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(r){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",r))}const c={...process.env,...u},o=y.agent?y.agent:await(0,p.getProxyAgent)(y.url||"",c,{proxyUrl:v,strictSSL:f});y.agent=o,y.strictSSL=f,this.authorization&&(y.headers={...y.headers||{},"Proxy-Authorization":this.authorization});try{const r=await this._request(y,m);return this.logService.trace("RequestService#request (node) - success",y.url),r}catch(r){throw this.logService.trace("RequestService#request (node) - error",y.url,r),r}}async getNodeRequest(y){return((0,S.parse)(y.url).protocol==="https:"?await new Promise((f,u)=>{z(["https"],f,u)}):await new Promise((f,u)=>{z(["http"],f,u)})).request}_request(y,m){return t.Promises.withAsyncBody(async(v,f)=>{const u=(0,S.parse)(y.url),c=y.getRawRequest?y.getRawRequest(y):await this.getNodeRequest(y),o={hostname:u.hostname,port:u.port?parseInt(u.port):u.protocol==="https:"?443:80,protocol:u.protocol,path:u.path,method:y.type||"GET",headers:y.headers,agent:y.agent,rejectUnauthorized:(0,b.isBoolean)(y.strictSSL)?y.strictSSL:!0};y.user&&y.password&&(o.auth=y.user+":"+y.password);const r=c(o,i=>{const n=(0,b.isNumber)(y.followRedirects)?y.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...y,url:i.headers.location,followRedirects:n-1},m).then(v,f);else{let s=i;i.headers["content-encoding"]==="gzip"&&(s=i.pipe((0,g.createGunzip)())),v({res:i,stream:(0,M.streamToBufferReadableStream)(s)})}});r.on("error",f),y.timeout&&r.setTimeout(y.timeout),y.data&&typeof y.data=="string"&&r.write(y.data),r.end(),m.onCancellationRequested(()=>{r.abort(),f(new R.CancellationError)})})}async resolveProxy(y){}};d=ge([ee(0,h.IConfigurationService),ee(1,w.INativeEnvironmentService),ee(2,C.ILogService)],d),e.RequestService=d}),define(X[256],J([0,1,14,255]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function M(D){return S.net.request}class R extends t.RequestService{request(b,h){return super.request({...b||{},getRawRequest:M},h)}}e.RequestMainService=R}),define(X[264],J([0,1,14,28,7,25,8,42,19,31,47,34,13,9,70,4,36,30,23,43,82,253,10,18,203,215,26,57,176,15,191,85,67,188,84,22,103,6,196,104,52,20,59,239,108,221,53,256,86,210,40,214,72,61,63,37,254,198,2,62,226,41,222]),function(z,e,S,t,M,R,D,b,h,w,E,C,p,g,d,P,y,m,v,f,u,c,o,r,i,n,s,a,l,I,k,A,W,F,K,ie,oe,ue,ne,ae,le,G,B,N,O,H,Z,$,j,L,T,_,q,Q,te,U,Y,x,re,ce,Ee,Ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Pe{main(){try{this.startup()}catch(de){console.error(de.message),S.app.exit(1)}}async startup(){(0,h.setUnexpectedErrorHandler)(Te=>console.error(Te));const[de,fe,pe,Ie,Le,Xe,Re,We]=this.createServices();try{try{await this.initServices(pe,We,Ie,Le)}catch(Te){throw this.handleStartupDataDirError(pe,Re.nameLong,Te),Te}await de.invokeFunction(async Te=>{const Ge=Te.get(ue.ILogService),je=Te.get(ie.ILifecycleMainService),Je=Te.get(I.IFileService),ze=await this.claimInstance(Ge,pe,je,de,Re,!0);return v.Promises.writeFile(pe.mainLockfile,String(process.pid)).catch(Ve=>{Ge.warn(`Error writing main lockfile: ${Ve.stack}`)}),Xe.logger=new ae.SpdLogLogger("main",(0,g.join)(pe.logsPath,"main.log"),!0,!1,Xe.getLevel()),(0,E.once)(je.onWillShutdown)(Ve=>{Je.dispose(),Ie.dispose(),Ve.join(v.Promises.unlink(pe.mainLockfile).catch(()=>{}))}),de.createInstance(c.CodeApplication,ze,fe).startup()})}catch(Te){de.invokeFunction(this.quit,Te)}}createServices(){const de=new K.ServiceCollection,fe=new re.DisposableStore;process.once("exit",()=>fe.dispose());const pe={_serviceBrand:void 0,...le.default};de.set(G.IProductService,pe);const Ie=new s.EnvironmentMainService(this.resolveArgs(),pe),Le=this.patchEnvironment(Ie);de.set(s.IEnvironmentMainService,Ie);const Xe=new oe.BufferLogService,Re=fe.add(new ue.MultiplexLogService([new ue.ConsoleMainLogger((0,ue.getLogLevel)(Ie)),Xe]));de.set(ue.ILogService,Re);const We=new k.FileService(Re);de.set(I.IFileService,We);const Te=new A.DiskFileSystemProvider(Re);We.registerProvider(p.Schemas.file,Te);const Ge=new Ee.UriIdentityService(We);de.set(ce.IUriIdentityService,Ge),de.set(ue.ILoggerService,new ne.LoggerService(Re,We));const je=new _.StateMainService(Ie,Re,We);de.set(T.IStateMainService,je);const Je=new te.UserDataProfilesMainService(je,Ge,Ie,We,Re);de.set(te.IUserDataProfilesMainService,Je);const ze=P.isWindows&&pe.win32RegValueName?fe.add(new Y.NativePolicyService(pe.win32RegValueName)):Ie.policyFile?fe.add(new x.FilePolicyService(Ie.policyFile,We,Re)):new U.NullPolicyService;de.set(U.IPolicyService,ze);const Ve=new i.ConfigurationService(Je.defaultProfile.settingsResource,We,ze,Re);return de.set(r.IConfigurationService,Ve),de.set(ie.ILifecycleMainService,new W.SyncDescriptor(ie.LifecycleMainService)),de.set(Z.IRequestService,new W.SyncDescriptor($.RequestMainService)),de.set(Q.IThemeMainService,new W.SyncDescriptor(Q.ThemeMainService)),de.set(j.ISignService,new W.SyncDescriptor(L.SignService)),de.set(O.ITunnelService,new W.SyncDescriptor(H.TunnelService)),de.set(B.IProtocolMainService,new W.SyncDescriptor(N.ProtocolMainService)),[new F.InstantiationService(de,!0),Le,Ie,Ve,je,Xe,pe,Je]}patchEnvironment(de){const fe={VSCODE_IPC_HOOK:de.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(pe=>{const Ie=process.env[pe];typeof Ie=="string"&&(fe[pe]=Ie)}),Object.assign(process.env,fe),fe}async initServices(de,fe,pe,Ie){await D.Promises.settled([Promise.all([de.extensionsPath,de.codeCachePath,de.logsPath,fe.defaultProfile.globalStorageHome.fsPath,de.workspaceStorageHome.fsPath,de.localHistoryHome.fsPath,de.backupHome].map(Le=>Le?v.Promises.mkdir(Le,{recursive:!0}):void 0)),Ie.init(),pe.initialize()]),fe.setEnablement(!!pe.getValue(Ce.PROFILES_ENABLEMENT_CONFIG))}async claimInstance(de,fe,pe,Ie,Le,Xe){let Re;try{(0,d.mark)("code/willStartMainServer"),Re=await(0,u.serve)(fe.mainIPCHandle),(0,d.mark)("code/didStartMainServer"),(0,E.once)(pe.onWillShutdown)(()=>Re.dispose())}catch(We){if(We.code!=="EADDRINUSE")throw this.handleStartupDataDirError(fe,Le.nameLong,We),We;let Te;try{Te=await(0,u.connect)(fe.mainIPCHandle,"main")}catch(ze){if(!Xe||P.isWindows||ze.code!=="ECONNREFUSED")throw ze.code==="EPERM"&&this.showStartupWarningDialog((0,o.localize)(0,null,Le.nameShort),(0,o.localize)(1,null),Le.nameLong),ze;try{(0,t.unlinkSync)(fe.mainIPCHandle)}catch(Ve){throw de.warn("Could not delete obsolete instance handle",Ve),Ve}return this.claimInstance(de,fe,pe,Ie,Le,!1)}if(fe.extensionTestsLocationURI&&!fe.debugExtensionHost.break){const ze="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw de.error(ze),Te.dispose(),new Error(ze)}let Ge;!fe.args.wait&&!fe.args.status&&(Ge=setTimeout(()=>{this.showStartupWarningDialog((0,o.localize)(2,null,Le.nameShort),(0,o.localize)(3,null),Le.nameLong)},1e4));const je=f.ProxyChannel.toService(Te.getChannel("launch"),{disableMarshalling:!0}),Je=f.ProxyChannel.toService(Te.getChannel("diagnostics"),{disableMarshalling:!0});if(fe.args.status)return Ie.invokeFunction(async()=>{const ze=new n.DiagnosticsService(q.NullTelemetryService,Le),Ve=await je.getMainProcessInfo(),V=await Je.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),se=await ze.getDiagnostics(Ve,V);throw console.log(se),new h.ExpectedError});throw P.isWindows&&await this.windowsAllowSetForegroundWindow(je,de),de.trace("Sending env to running instance..."),await je.start(fe.args,process.env),Te.dispose(),Ge&&clearTimeout(Ge),new h.ExpectedError("Sent env to running instance. Terminating...")}if(fe.args.status)throw de.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new h.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Re}handleStartupDataDirError(de,fe,pe){if(pe.code==="EACCES"||pe.code==="EPERM"){const Ie=(0,R.coalesce)([de.userDataPath,de.extensionsPath,u.XDG_RUNTIME_DIR]).map(Le=>(0,C.getPathLabel)(M.URI.file(Le),{os:P.OS,tildify:de}));this.showStartupWarningDialog((0,o.localize)(4,null),(0,o.localize)(5,null,(0,b.toErrorMessage)(pe),Ie.join(`
`)),fe)}}showStartupWarningDialog(de,fe,pe){S.dialog.showMessageBoxSync({title:pe,type:"warning",buttons:[(0,C.mnemonicButtonLabel)((0,o.localize)(6,null))],message:de,detail:fe,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(de,fe){if(P.isWindows){const pe=await de.getMainProcessId();fe.trace("Sending some foreground love to the running instance:",pe);try{(await new Promise((Ie,Le)=>{z(["windows-foreground-love"],Ie,Le)})).allowSetForegroundWindow(pe)}catch(Ie){fe.error(Ie)}}}quit(de,fe){const pe=de.get(ue.ILogService),Ie=de.get(ie.ILifecycleMainService);let Le=0;fe&&(fe.isExpected?fe.message&&pe.trace(fe.message):(Le=1,fe.stack?pe.error(fe.stack):pe.error(`Startup error: ${fe.toString()}`))),Ie.kill(Le)}resolveArgs(){const de=this.validatePaths((0,a.parseMainProcessArgv)(process.argv));if(de.wait&&!de.waitMarkerFilePath){const fe=(0,l.createWaitMarkerFile)(de.verbose);fe&&((0,a.addArg)(process.argv,"--waitMarkerFilePath",fe),de.waitMarkerFilePath=fe)}return de}validatePaths(de){if(de["open-url"]&&(de._urls=de._,de._=[]),!de.remote){const fe=this.doValidatePaths(de._,de.goto);de._=fe}return de}doValidatePaths(de,fe){const pe=(0,y.cwd)(),Ie=de.map(Re=>{let We=String(Re),Te;fe&&(Te=(0,w.parseLineAndColumnAware)(We),We=Te.path),We&&(We=this.preparePath(pe,We));const Ge=(0,w.sanitizeFilePath)(We,pe),je=(0,g.basename)(Ge);return je&&!(0,w.isValidBasename)(je)?null:fe&&Te?(Te.path=Ge,this.toPath(Te)):Ge}),Le=P.isWindows||P.isMacintosh,Xe=(0,R.distinct)(Ie,Re=>Re&&Le?Re.toLowerCase():Re||"");return(0,R.coalesce)(Xe)}preparePath(de,fe){return P.isWindows&&(fe=(0,m.rtrim)(fe,'"')),fe=(0,m.trim)((0,m.trim)(fe," "),"	"),P.isWindows&&(fe=(0,g.resolve)(de,fe),fe=(0,m.rtrim)(fe,".")),fe}toPath(de){const fe=[de.path];return typeof de.line=="number"&&fe.push(String(de.line)),typeof de.column=="number"&&fe.push(String(de.column)),fe.join(":")}}new Pe().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/core/vs/code/electron-main/main.js.map
