/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ye=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/errors","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/platform/log/common/log","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/assert","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/marshalling","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configuration","vs/platform/instantiation/common/serviceCollection","vs/base/common/process","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testItemCollection","vs/editor/common/languages","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/idGenerator","vs/base/common/mime","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDecorations","vs/base/common/hash","vs/workbench/api/common/extHostTelemetryLogService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/editor","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/lazy","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/base/common/linkedList","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],De=function(ne){for(var e=[],a=0,p=ne.length;a<p;a++)e[a]=ye[ne[a]];return e};define(ye[72],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function a(D,k){const E=Object.create(null);for(const P of D){const O=k(P);let y=E[O];y||(y=E[O]=[]),y.push(P)}return E}e.groupBy=a;function p(D,k){const E=[],P=[];for(const O of D)k.has(O)||E.push(O);for(const O of k)D.has(O)||P.push(O);return{removed:E,added:P}}e.diffSets=p;function b(D,k){const E=[],P=[];for(const[O,y]of D)k.has(O)||E.push(y);for(const[O,y]of k)D.has(O)||P.push(y);return{removed:E,added:P}}e.diffMaps=b;class L{constructor(){this.map=new Map}add(k,E){let P=this.map.get(k);P||(P=new Set,this.map.set(k,P)),P.add(E)}delete(k,E){const P=this.map.get(k);!P||(P.delete(E),P.size===0&&this.map.delete(k))}forEach(k,E){const P=this.map.get(k);!P||P.forEach(E)}}e.SetMap=L}),define(ye[54],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function a(D){return(k,E,P)=>{let O=null,y=null;if(typeof P.value=="function"?(O="value",y=P.value):typeof P.get=="function"&&(O="get",y=P.get),!y)throw new Error("not supported");P[O]=D(y,E)}}e.createDecorator=a;function p(D,k,E){let P=null,O=null;if(typeof E.value=="function"?(P="value",O=E.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(P="get",O=E.get),!O)throw new Error("not supported");const y=`$memoize$${k}`;E[P]=function(...m){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,m)}),this[y]}}e.memoize=p;function b(D,k,E){return a((P,O)=>{const y=`$debounce$${O}`,m=`$debounce$result$${O}`;return function(...T){this[m]||(this[m]=E?E():void 0),clearTimeout(this[y]),k&&(this[m]=k(this[m],...T),T=[this[m]]),this[y]=setTimeout(()=>{P.apply(this,T),this[m]=E?E():void 0},D)}})}e.debounce=b;function L(D,k,E){return a((P,O)=>{const y=`$throttle$timer$${O}`,m=`$throttle$result$${O}`,T=`$throttle$lastRun$${O}`,f=`$throttle$pending$${O}`;return function(...h){if(this[m]||(this[m]=E?E():void 0),(this[T]===null||this[T]===void 0)&&(this[T]=-Number.MAX_VALUE),k&&(this[m]=k(this[m],...h)),this[f])return;const d=this[T]+D;d<=Date.now()?(this[T]=Date.now(),P.apply(this,[this[m]]),this[m]=E?E():void 0):(this[f]=!0,this[y]=setTimeout(()=>{this[f]=!1,this[T]=Date.now(),P.apply(this,[this[m]]),this[m]=E?E():void 0},d-Date.now()))}})}e.throttle=L}),define(ye[73],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class a{constructor(b){this._prefix=b,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=a,e.defaultGenerator=new a("id#")}),define(ye[105],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var a;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(a=e.ScanError||(e.ScanError={}));var p;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(p=e.SyntaxKind||(e.SyntaxKind={}));var b;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(b=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(s){s.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function D(s,u=!1){let n=0;const i=s.length;let r="",t=0,l=16,_=0;function g($){let F=0,q=0;for(;F<$;){const ie=s.charCodeAt(n);if(ie>=48&&ie<=57)q=q*16+ie-48;else if(ie>=65&&ie<=70)q=q*16+ie-65+10;else if(ie>=97&&ie<=102)q=q*16+ie-97+10;else break;n++,F++}return F<$&&(q=-1),q}function C($){n=$,r="",t=0,l=16,_=0}function U(){const $=n;if(s.charCodeAt(n)===48)n++;else for(n++;n<s.length&&P(s.charCodeAt(n));)n++;if(n<s.length&&s.charCodeAt(n)===46)if(n++,n<s.length&&P(s.charCodeAt(n)))for(n++;n<s.length&&P(s.charCodeAt(n));)n++;else return _=3,s.substring($,n);let F=n;if(n<s.length&&(s.charCodeAt(n)===69||s.charCodeAt(n)===101))if(n++,(n<s.length&&s.charCodeAt(n)===43||s.charCodeAt(n)===45)&&n++,n<s.length&&P(s.charCodeAt(n))){for(n++;n<s.length&&P(s.charCodeAt(n));)n++;F=n}else _=3;return s.substring($,F)}function W(){let $="",F=n;for(;;){if(n>=i){$+=s.substring(F,n),_=2;break}const q=s.charCodeAt(n);if(q===34){$+=s.substring(F,n),n++;break}if(q===92){if($+=s.substring(F,n),n++,n>=i){_=2;break}switch(s.charCodeAt(n++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:{const A=g(4);A>=0?$+=String.fromCharCode(A):_=4;break}default:_=5}F=n;continue}if(q>=0&&q<=31)if(E(q)){$+=s.substring(F,n),_=2;break}else _=6;n++}return $}function M(){if(r="",_=0,t=n,n>=i)return t=i,l=17;let $=s.charCodeAt(n);if(k($)){do n++,r+=String.fromCharCode($),$=s.charCodeAt(n);while(k($));return l=15}if(E($))return n++,r+=String.fromCharCode($),$===13&&s.charCodeAt(n)===10&&(n++,r+=`
`),l=14;switch($){case 123:return n++,l=1;case 125:return n++,l=2;case 91:return n++,l=3;case 93:return n++,l=4;case 58:return n++,l=6;case 44:return n++,l=5;case 34:return n++,r=W(),l=10;case 47:{const F=n-1;if(s.charCodeAt(n+1)===47){for(n+=2;n<i&&!E(s.charCodeAt(n));)n++;return r=s.substring(F,n),l=12}if(s.charCodeAt(n+1)===42){n+=2;const q=i-1;let ie=!1;for(;n<q;){if(s.charCodeAt(n)===42&&s.charCodeAt(n+1)===47){n+=2,ie=!0;break}n++}return ie||(n++,_=1),r=s.substring(F,n),l=13}return r+=String.fromCharCode($),n++,l=16}case 45:if(r+=String.fromCharCode($),n++,n===i||!P(s.charCodeAt(n)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=U(),l=11;default:for(;n<i&&S($);)n++,$=s.charCodeAt(n);if(t!==n){switch(r=s.substring(t,n),r){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return r+=String.fromCharCode($),n++,l=16}}function S($){if(k($)||E($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let $;do $=M();while($>=12&&$<=15);return $}return{setPosition:C,getPosition:()=>n,scan:u?z:M,getToken:()=>l,getTokenValue:()=>r,getTokenOffset:()=>t,getTokenLength:()=>n-t,getTokenError:()=>_}}e.createScanner=D;function k(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function E(s){return s===10||s===13||s===8232||s===8233}function P(s){return s>=48&&s<=57}var O;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(O||(O={}));function y(s,u){const n=[],i=new Object;let r;const t={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function _(g,C,U,W){t.value=g,t.offset=C,t.length=U,t.type=W,t.colonOffset=void 0,r=t}try{R(s,{onObjectBegin:(g,C)=>{if(u<=g)throw i;r=void 0,l=u>g,n.push("")},onObjectProperty:(g,C,U)=>{if(u<C||(_(g,C,U,"property"),n[n.length-1]=g,u<=C+U))throw i},onObjectEnd:(g,C)=>{if(u<=g)throw i;r=void 0,n.pop()},onArrayBegin:(g,C)=>{if(u<=g)throw i;r=void 0,n.push(0)},onArrayEnd:(g,C)=>{if(u<=g)throw i;r=void 0,n.pop()},onLiteralValue:(g,C,U)=>{if(u<C||(_(g,C,U,w(g)),u<=C+U))throw i},onSeparator:(g,C,U)=>{if(u<=C)throw i;if(g===":"&&r&&r.type==="property")r.colonOffset=C,l=!1,r=void 0;else if(g===","){const W=n[n.length-1];typeof W=="number"?n[n.length-1]=W+1:(l=!0,n[n.length-1]=""),r=void 0}}})}catch(g){if(g!==i)throw g}return{path:n,previousNode:r,isAtPropertyKey:l,matches:g=>{let C=0;for(let U=0;C<g.length&&U<n.length;U++)if(g[C]===n[U]||g[C]==="*")C++;else if(g[C]!=="**")return!1;return C===g.length}}}e.getLocation=y;function m(s,u=[],n=L.DEFAULT){let i=null,r=[];const t=[];function l(g){Array.isArray(r)?r.push(g):i!==null&&(r[i]=g)}return R(s,{onObjectBegin:()=>{const g={};l(g),t.push(r),r=g,i=null},onObjectProperty:g=>{i=g},onObjectEnd:()=>{r=t.pop()},onArrayBegin:()=>{const g=[];l(g),t.push(r),r=g,i=null},onArrayEnd:()=>{r=t.pop()},onLiteralValue:l,onError:(g,C,U)=>{u.push({error:g,offset:C,length:U})}},n),r[0]}e.parse=m;function T(s,u=[],n=L.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(g){i.type==="property"&&(i.length=g-i.offset,i=i.parent)}function t(g){return i.children.push(g),g}R(s,{onObjectBegin:g=>{i=t({type:"object",offset:g,length:-1,parent:i,children:[]})},onObjectProperty:(g,C,U)=>{i=t({type:"property",offset:C,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:g,offset:C,length:U,parent:i})},onObjectEnd:(g,C)=>{i.length=g+C-i.offset,i=i.parent,r(g+C)},onArrayBegin:(g,C)=>{i=t({type:"array",offset:g,length:-1,parent:i,children:[]})},onArrayEnd:(g,C)=>{i.length=g+C-i.offset,i=i.parent,r(g+C)},onLiteralValue:(g,C,U)=>{t({type:w(g),offset:C,length:U,parent:i,value:g}),r(C+U)},onSeparator:(g,C,U)=>{i.type==="property"&&(g===":"?i.colonOffset=C:g===","&&r(C))},onError:(g,C,U)=>{u.push({error:g,offset:C,length:U})}},n);const _=i.children[0];return _&&delete _.parent,_}e.parseTree=T;function f(s,u){if(!s)return;let n=s;for(const i of u)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let r=!1;for(const t of n.children)if(Array.isArray(t.children)&&t.children[0].value===i){n=t.children[1],r=!0;break}if(!r)return}else{const r=i;if(n.type!=="array"||r<0||!Array.isArray(n.children)||r>=n.children.length)return;n=n.children[r]}return n}e.findNodeAtLocation=f;function h(s){if(!s.parent||!s.parent.children)return[];const u=h(s.parent);if(s.parent.type==="property"){const n=s.parent.children[0].value;u.push(n)}else if(s.parent.type==="array"){const n=s.parent.children.indexOf(s);n!==-1&&u.push(n)}return u}e.getNodePath=h;function d(s){switch(s.type){case"array":return s.children.map(d);case"object":{const u=Object.create(null);for(const n of s.children){const i=n.children[1];i&&(u[n.children[0].value]=d(i))}return u}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=d;function o(s,u,n=!1){return u>=s.offset&&u<s.offset+s.length||n&&u===s.offset+s.length}e.contains=o;function v(s,u,n=!1){if(o(s,u,n)){const i=s.children;if(Array.isArray(i))for(let r=0;r<i.length&&i[r].offset<=u;r++){const t=v(i[r],u,n);if(t)return t}return s}}e.findNodeAtOffset=v;function R(s,u,n=L.DEFAULT){const i=D(s,!1);function r(Ee){return Ee?()=>Ee(i.getTokenOffset(),i.getTokenLength()):()=>!0}function t(Ee){return Ee?be=>Ee(be,i.getTokenOffset(),i.getTokenLength()):()=>!0}const l=r(u.onObjectBegin),_=t(u.onObjectProperty),g=r(u.onObjectEnd),C=r(u.onArrayBegin),U=r(u.onArrayEnd),W=t(u.onLiteralValue),M=t(u.onSeparator),S=r(u.onComment),z=t(u.onError),$=n&&n.disallowComments,F=n&&n.allowTrailingComma;function q(){for(;;){const Ee=i.scan();switch(i.getTokenError()){case 4:ie(14);break;case 5:ie(15);break;case 3:ie(13);break;case 1:$||ie(11);break;case 2:ie(12);break;case 6:ie(16);break}switch(Ee){case 12:case 13:$?ie(10):S();break;case 16:ie(1);break;case 15:case 14:break;default:return Ee}}}function ie(Ee,be=[],ee=[]){if(z(Ee),be.length+ee.length>0){let ve=i.getToken();for(;ve!==17;){if(be.indexOf(ve)!==-1){q();break}else if(ee.indexOf(ve)!==-1)break;ve=q()}}}function A(Ee){const be=i.getTokenValue();return Ee?W(be):_(be),q(),!0}function Z(){switch(i.getToken()){case 11:{let Ee=0;try{Ee=JSON.parse(i.getTokenValue()),typeof Ee!="number"&&(ie(2),Ee=0)}catch{ie(2)}W(Ee);break}case 7:W(null);break;case 8:W(!0);break;case 9:W(!1);break;default:return!1}return q(),!0}function ce(){return i.getToken()!==10?(ie(3,[],[2,5]),!1):(A(!1),i.getToken()===6?(M(":"),q(),te()||ie(4,[],[2,5])):ie(5,[],[2,5]),!0)}function oe(){l(),q();let Ee=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Ee||ie(4,[],[]),M(","),q(),i.getToken()===2&&F)break}else Ee&&ie(6,[],[]);ce()||ie(4,[],[2,5]),Ee=!0}return g(),i.getToken()!==2?ie(7,[2],[]):q(),!0}function ue(){C(),q();let Ee=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Ee||ie(4,[],[]),M(","),q(),i.getToken()===4&&F)break}else Ee&&ie(6,[],[]);te()||ie(4,[],[4,5]),Ee=!0}return U(),i.getToken()!==4?ie(8,[4],[]):q(),!0}function te(){switch(i.getToken()){case 3:return ue();case 1:return oe();case 10:return A(!0);default:return Z()}}return q(),i.getToken()===17?n.allowEmptyContent?!0:(ie(4,[],[]),!1):te()?(i.getToken()!==17&&ie(9,[],[]),!0):(ie(4,[],[]),!1)}e.visit=R;function c(s,u){const n=D(s),i=[];let r,t=0,l;do switch(l=n.getPosition(),r=n.scan(),r){case 12:case 13:case 17:t!==l&&i.push(s.substring(t,l)),u!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,u)),t=n.getPosition();break}while(r!==17);return i.join("")}e.stripComments=c;function w(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=w}),function(ne,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(ye[106],De([0]),e):(ne=typeof globalThis!="undefined"?globalThis:ne||self,e(ne.marked={}))}(this,function(ne){"use strict";function e(Ie,Se){for(var ke=0;ke<Se.length;ke++){var ae=Se[ke];ae.enumerable=ae.enumerable||!1,ae.configurable=!0,"value"in ae&&(ae.writable=!0),Object.defineProperty(Ie,ae.key,ae)}}function a(Ie,Se,ke){return Se&&e(Ie.prototype,Se),ke&&e(Ie,ke),Object.defineProperty(Ie,"prototype",{writable:!1}),Ie}function p(Ie,Se){if(!!Ie){if(typeof Ie=="string")return b(Ie,Se);var ke=Object.prototype.toString.call(Ie).slice(8,-1);if(ke==="Object"&&Ie.constructor&&(ke=Ie.constructor.name),ke==="Map"||ke==="Set")return Array.from(Ie);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return b(Ie,Se)}}function b(Ie,Se){(Se==null||Se>Ie.length)&&(Se=Ie.length);for(var ke=0,ae=new Array(Se);ke<Se;ke++)ae[ke]=Ie[ke];return ae}function L(Ie,Se){var ke=typeof Symbol!="undefined"&&Ie[Symbol.iterator]||Ie["@@iterator"];if(ke)return(ke=ke.call(Ie)).next.bind(ke);if(Array.isArray(Ie)||(ke=p(Ie))||Se&&Ie&&typeof Ie.length=="number"){ke&&(Ie=ke);var ae=0;return function(){return ae>=Ie.length?{done:!0}:{done:!1,value:Ie[ae++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function D(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ne.defaults=D();function k(Ie){ne.defaults=Ie}var E=/[&<>"']/,P=/[&<>"']/g,O=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},T=function(Se){return m[Se]};function f(Ie,Se){if(Se){if(E.test(Ie))return Ie.replace(P,T)}else if(O.test(Ie))return Ie.replace(y,T);return Ie}var h=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(Ie){return Ie.replace(h,function(Se,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var o=/(^|[^\[])\^/g;function v(Ie,Se){Ie=typeof Ie=="string"?Ie:Ie.source,Se=Se||"";var ke={replace:function(le,G){return G=G.source||G,G=G.replace(o,"$1"),Ie=Ie.replace(le,G),ke},getRegex:function(){return new RegExp(Ie,Se)}};return ke}var R=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function w(Ie,Se,ke){if(Ie){var ae;try{ae=decodeURIComponent(d(ke)).replace(R,"").toLowerCase()}catch{return null}if(ae.indexOf("javascript:")===0||ae.indexOf("vbscript:")===0||ae.indexOf("data:")===0)return null}Se&&!c.test(ke)&&(ke=r(Se,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch{return null}return ke}var s={},u=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(Ie,Se){s[" "+Ie]||(u.test(Ie)?s[" "+Ie]=Ie+"/":s[" "+Ie]=g(Ie,"/",!0)),Ie=s[" "+Ie];var ke=Ie.indexOf(":")===-1;return Se.substring(0,2)==="//"?ke?Se:Ie.replace(n,"$1")+Se:Se.charAt(0)==="/"?ke?Se:Ie.replace(i,"$1")+Se:Ie+Se}var t={exec:function(){}};function l(Ie){for(var Se=1,ke,ae;Se<arguments.length;Se++){ke=arguments[Se];for(ae in ke)Object.prototype.hasOwnProperty.call(ke,ae)&&(Ie[ae]=ke[ae])}return Ie}function _(Ie,Se){var ke=Ie.replace(/\|/g,function(G,Q,I){for(var B=!1,H=Q;--H>=0&&I[H]==="\\";)B=!B;return B?"|":" |"}),ae=ke.split(/ \|/),le=0;if(ae[0].trim()||ae.shift(),ae.length>0&&!ae[ae.length-1].trim()&&ae.pop(),ae.length>Se)ae.splice(Se);else for(;ae.length<Se;)ae.push("");for(;le<ae.length;le++)ae[le]=ae[le].trim().replace(/\\\|/g,"|");return ae}function g(Ie,Se,ke){var ae=Ie.length;if(ae===0)return"";for(var le=0;le<ae;){var G=Ie.charAt(ae-le-1);if(G===Se&&!ke)le++;else if(G!==Se&&ke)le++;else break}return Ie.slice(0,ae-le)}function C(Ie,Se){if(Ie.indexOf(Se[1])===-1)return-1;for(var ke=Ie.length,ae=0,le=0;le<ke;le++)if(Ie[le]==="\\")le++;else if(Ie[le]===Se[0])ae++;else if(Ie[le]===Se[1]&&(ae--,ae<0))return le;return-1}function U(Ie){Ie&&Ie.sanitize&&!Ie.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function W(Ie,Se){if(Se<1)return"";for(var ke="";Se>1;)Se&1&&(ke+=Ie),Se>>=1,Ie+=Ie;return ke+Ie}function M(Ie,Se,ke,ae){var le=Se.href,G=Se.title?f(Se.title):null,Q=Ie[1].replace(/\\([\[\]])/g,"$1");if(Ie[0].charAt(0)!=="!"){ae.state.inLink=!0;var I={type:"link",raw:ke,href:le,title:G,text:Q,tokens:ae.inlineTokens(Q,[])};return ae.state.inLink=!1,I}return{type:"image",raw:ke,href:le,title:G,text:f(Q)}}function S(Ie,Se){var ke=Ie.match(/^(\s+)(?:```)/);if(ke===null)return Se;var ae=ke[1];return Se.split(`
`).map(function(le){var G=le.match(/^\s+/);if(G===null)return le;var Q=G[0];return Q.length>=ae.length?le.slice(ae.length):le}).join(`
`)}var z=function(){function Ie(ke){this.options=ke||ne.defaults}var Se=Ie.prototype;return Se.space=function(ae){var le=this.rules.block.newline.exec(ae);if(le&&le[0].length>0)return{type:"space",raw:le[0]}},Se.code=function(ae){var le=this.rules.block.code.exec(ae);if(le){var G=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?G:g(G,`
`)}}},Se.fences=function(ae){var le=this.rules.block.fences.exec(ae);if(le){var G=le[0],Q=S(G,le[3]||"");return{type:"code",raw:G,lang:le[2]?le[2].trim():le[2],text:Q}}},Se.heading=function(ae){var le=this.rules.block.heading.exec(ae);if(le){var G=le[2].trim();if(/#$/.test(G)){var Q=g(G,"#");(this.options.pedantic||!Q||/ $/.test(Q))&&(G=Q.trim())}var I={type:"heading",raw:le[0],depth:le[1].length,text:G,tokens:[]};return this.lexer.inline(I.text,I.tokens),I}},Se.hr=function(ae){var le=this.rules.block.hr.exec(ae);if(le)return{type:"hr",raw:le[0]}},Se.blockquote=function(ae){var le=this.rules.block.blockquote.exec(ae);if(le){var G=le[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:le[0],tokens:this.lexer.blockTokens(G,[]),text:G}}},Se.list=function(ae){var le=this.rules.block.list.exec(ae);if(le){var G,Q,I,B,H,V,se,de,J,pe,ge,Ne,Be=le[1].trim(),Je=Be.length>1,Ge={type:"list",raw:"",ordered:Je,start:Je?+Be.slice(0,-1):"",loose:!1,items:[]};Be=Je?"\\d{1,9}\\"+Be.slice(-1):"\\"+Be,this.options.pedantic&&(Be=Je?Be:"[*+-]");for(var Te=new RegExp("^( {0,3}"+Be+")((?:[	 ][^\\n]*)?(?:\\n|$))");ae&&(Ne=!1,!(!(le=Te.exec(ae))||this.rules.block.hr.test(ae)));){if(G=le[0],ae=ae.substring(G.length),de=le[2].split(`
`,1)[0],J=ae.split(`
`,1)[0],this.options.pedantic?(B=2,ge=de.trimLeft()):(B=le[2].search(/[^ ]/),B=B>4?1:B,ge=de.slice(B),B+=le[1].length),V=!1,!de&&/^ *$/.test(J)&&(G+=J+`
`,ae=ae.substring(J.length+1),Ne=!0),!Ne)for(var rt=new RegExp("^ {0,"+Math.min(3,B-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),K=new RegExp("^ {0,"+Math.min(3,B-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)");ae&&(pe=ae.split(`
`,1)[0],de=pe,this.options.pedantic&&(de=de.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(rt.test(de)||K.test(ae)));){if(de.search(/[^ ]/)>=B||!de.trim())ge+=`
`+de.slice(B);else if(!V)ge+=`
`+de;else break;!V&&!de.trim()&&(V=!0),G+=pe+`
`,ae=ae.substring(pe.length+1)}Ge.loose||(se?Ge.loose=!0:/\n *\n *$/.test(G)&&(se=!0)),this.options.gfm&&(Q=/^\[[ xX]\] /.exec(ge),Q&&(I=Q[0]!=="[ ] ",ge=ge.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:G,task:!!Q,checked:I,loose:!1,text:ge}),Ge.raw+=G}Ge.items[Ge.items.length-1].raw=G.trimRight(),Ge.items[Ge.items.length-1].text=ge.trimRight(),Ge.raw=Ge.raw.trimRight();var X=Ge.items.length;for(H=0;H<X;H++){this.lexer.state.top=!1,Ge.items[H].tokens=this.lexer.blockTokens(Ge.items[H].text,[]);var fe=Ge.items[H].tokens.filter(function(He){return He.type==="space"}),Ue=fe.every(function(He){for(var Ze=He.raw.split(""),qe=0,We=L(Ze),nt;!(nt=We()).done;){var ot=nt.value;if(ot===`
`&&(qe+=1),qe>1)return!0}return!1});!Ge.loose&&fe.length&&Ue&&(Ge.loose=!0,Ge.items[H].loose=!0)}return Ge}},Se.html=function(ae){var le=this.rules.block.html.exec(ae);if(le){var G={type:"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:le[0]};return this.options.sanitize&&(G.type="paragraph",G.text=this.options.sanitizer?this.options.sanitizer(le[0]):f(le[0]),G.tokens=[],this.lexer.inline(G.text,G.tokens)),G}},Se.def=function(ae){var le=this.rules.block.def.exec(ae);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var G=le[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:G,raw:le[0],href:le[2],title:le[3]}}},Se.table=function(ae){var le=this.rules.block.table.exec(ae);if(le){var G={type:"table",header:_(le[1]).map(function(se){return{text:se}}),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:le[3]&&le[3].trim()?le[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(G.header.length===G.align.length){G.raw=le[0];var Q=G.align.length,I,B,H,V;for(I=0;I<Q;I++)/^ *-+: *$/.test(G.align[I])?G.align[I]="right":/^ *:-+: *$/.test(G.align[I])?G.align[I]="center":/^ *:-+ *$/.test(G.align[I])?G.align[I]="left":G.align[I]=null;for(Q=G.rows.length,I=0;I<Q;I++)G.rows[I]=_(G.rows[I],G.header.length).map(function(se){return{text:se}});for(Q=G.header.length,B=0;B<Q;B++)G.header[B].tokens=[],this.lexer.inline(G.header[B].text,G.header[B].tokens);for(Q=G.rows.length,B=0;B<Q;B++)for(V=G.rows[B],H=0;H<V.length;H++)V[H].tokens=[],this.lexer.inline(V[H].text,V[H].tokens);return G}}},Se.lheading=function(ae){var le=this.rules.block.lheading.exec(ae);if(le){var G={type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1],tokens:[]};return this.lexer.inline(G.text,G.tokens),G}},Se.paragraph=function(ae){var le=this.rules.block.paragraph.exec(ae);if(le){var G={type:"paragraph",raw:le[0],text:le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1],tokens:[]};return this.lexer.inline(G.text,G.tokens),G}},Se.text=function(ae){var le=this.rules.block.text.exec(ae);if(le){var G={type:"text",raw:le[0],text:le[0],tokens:[]};return this.lexer.inline(G.text,G.tokens),G}},Se.escape=function(ae){var le=this.rules.inline.escape.exec(ae);if(le)return{type:"escape",raw:le[0],text:f(le[1])}},Se.tag=function(ae){var le=this.rules.inline.tag.exec(ae);if(le)return!this.lexer.state.inLink&&/^<a /i.test(le[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(le[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(le[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(le[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:le[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):f(le[0]):le[0]}},Se.link=function(ae){var le=this.rules.inline.link.exec(ae);if(le){var G=le[2].trim();if(!this.options.pedantic&&/^</.test(G)){if(!/>$/.test(G))return;var Q=g(G.slice(0,-1),"\\");if((G.length-Q.length)%2==0)return}else{var I=C(le[2],"()");if(I>-1){var B=le[0].indexOf("!")===0?5:4,H=B+le[1].length+I;le[2]=le[2].substring(0,I),le[0]=le[0].substring(0,H).trim(),le[3]=""}}var V=le[2],se="";if(this.options.pedantic){var de=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(V);de&&(V=de[1],se=de[3])}else se=le[3]?le[3].slice(1,-1):"";return V=V.trim(),/^</.test(V)&&(this.options.pedantic&&!/>$/.test(G)?V=V.slice(1):V=V.slice(1,-1)),M(le,{href:V&&V.replace(this.rules.inline._escapes,"$1"),title:se&&se.replace(this.rules.inline._escapes,"$1")},le[0],this.lexer)}},Se.reflink=function(ae,le){var G;if((G=this.rules.inline.reflink.exec(ae))||(G=this.rules.inline.nolink.exec(ae))){var Q=(G[2]||G[1]).replace(/\s+/g," ");if(Q=le[Q.toLowerCase()],!Q||!Q.href){var I=G[0].charAt(0);return{type:"text",raw:I,text:I}}return M(G,Q,G[0],this.lexer)}},Se.emStrong=function(ae,le,G){G===void 0&&(G="");var Q=this.rules.inline.emStrong.lDelim.exec(ae);if(!!Q&&!(Q[3]&&G.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var I=Q[1]||Q[2]||"";if(!I||I&&(G===""||this.rules.inline.punctuation.exec(G))){var B=Q[0].length-1,H,V,se=B,de=0,J=Q[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(J.lastIndex=0,le=le.slice(-1*ae.length+B);(Q=J.exec(le))!=null;)if(H=Q[1]||Q[2]||Q[3]||Q[4]||Q[5]||Q[6],!!H){if(V=H.length,Q[3]||Q[4]){se+=V;continue}else if((Q[5]||Q[6])&&B%3&&!((B+V)%3)){de+=V;continue}if(se-=V,!(se>0)){if(V=Math.min(V,V+se+de),Math.min(B,V)%2){var pe=ae.slice(1,B+Q.index+V);return{type:"em",raw:ae.slice(0,B+Q.index+V+1),text:pe,tokens:this.lexer.inlineTokens(pe,[])}}var ge=ae.slice(2,B+Q.index+V-1);return{type:"strong",raw:ae.slice(0,B+Q.index+V+1),text:ge,tokens:this.lexer.inlineTokens(ge,[])}}}}}},Se.codespan=function(ae){var le=this.rules.inline.code.exec(ae);if(le){var G=le[2].replace(/\n/g," "),Q=/[^ ]/.test(G),I=/^ /.test(G)&&/ $/.test(G);return Q&&I&&(G=G.substring(1,G.length-1)),G=f(G,!0),{type:"codespan",raw:le[0],text:G}}},Se.br=function(ae){var le=this.rules.inline.br.exec(ae);if(le)return{type:"br",raw:le[0]}},Se.del=function(ae){var le=this.rules.inline.del.exec(ae);if(le)return{type:"del",raw:le[0],text:le[2],tokens:this.lexer.inlineTokens(le[2],[])}},Se.autolink=function(ae,le){var G=this.rules.inline.autolink.exec(ae);if(G){var Q,I;return G[2]==="@"?(Q=f(this.options.mangle?le(G[1]):G[1]),I="mailto:"+Q):(Q=f(G[1]),I=Q),{type:"link",raw:G[0],text:Q,href:I,tokens:[{type:"text",raw:Q,text:Q}]}}},Se.url=function(ae,le){var G;if(G=this.rules.inline.url.exec(ae)){var Q,I;if(G[2]==="@")Q=f(this.options.mangle?le(G[0]):G[0]),I="mailto:"+Q;else{var B;do B=G[0],G[0]=this.rules.inline._backpedal.exec(G[0])[0];while(B!==G[0]);Q=f(G[0]),G[1]==="www."?I="http://"+Q:I=Q}return{type:"link",raw:G[0],text:Q,href:I,tokens:[{type:"text",raw:Q,text:Q}]}}},Se.inlineText=function(ae,le){var G=this.rules.inline.text.exec(ae);if(G){var Q;return this.lexer.state.inRawBlock?Q=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(G[0]):f(G[0]):G[0]:Q=f(this.options.smartypants?le(G[0]):G[0]),{type:"text",raw:G[0],text:Q}}},Ie}(),$={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:t,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};$._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,$._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,$.def=v($.def).replace("label",$._label).replace("title",$._title).getRegex(),$.bullet=/(?:[*+-]|\d{1,9}[.)])/,$.listItemStart=v(/^( *)(bull) */).replace("bull",$.bullet).getRegex(),$.list=v($.list).replace(/bull/g,$.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+$.def.source+")").getRegex(),$._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",$._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,$.html=v($.html,"i").replace("comment",$._comment).replace("tag",$._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),$.paragraph=v($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.blockquote=v($.blockquote).replace("paragraph",$.paragraph).getRegex(),$.normal=l({},$),$.gfm=l({},$.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),$.gfm.table=v($.gfm.table).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.gfm.paragraph=v($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",$.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.pedantic=l({},$.normal,{html:v(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",$._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:t,paragraph:v($.normal._paragraph).replace("hr",$.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",$.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var F={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:t,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:t,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};F._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",F.punctuation=v(F.punctuation).replace(/punctuation/g,F._punctuation).getRegex(),F.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,F.escapedEmSt=/\\\*|\\_/g,F._comment=v($._comment).replace("(?:-->|$)","-->").getRegex(),F.emStrong.lDelim=v(F.emStrong.lDelim).replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimAst=v(F.emStrong.rDelimAst,"g").replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimUnd=v(F.emStrong.rDelimUnd,"g").replace(/punct/g,F._punctuation).getRegex(),F._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,F._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,F._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,F.autolink=v(F.autolink).replace("scheme",F._scheme).replace("email",F._email).getRegex(),F._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,F.tag=v(F.tag).replace("comment",F._comment).replace("attribute",F._attribute).getRegex(),F._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,F._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,F._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,F.link=v(F.link).replace("label",F._label).replace("href",F._href).replace("title",F._title).getRegex(),F.reflink=v(F.reflink).replace("label",F._label).replace("ref",$._label).getRegex(),F.nolink=v(F.nolink).replace("ref",$._label).getRegex(),F.reflinkSearch=v(F.reflinkSearch,"g").replace("reflink",F.reflink).replace("nolink",F.nolink).getRegex(),F.normal=l({},F),F.pedantic=l({},F.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:v(/^!?\[(label)\]\((.*?)\)/).replace("label",F._label).getRegex(),reflink:v(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",F._label).getRegex()}),F.gfm=l({},F.normal,{escape:v(F.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),F.gfm.url=v(F.gfm.url,"i").replace("email",F.gfm._extended_email).getRegex(),F.breaks=l({},F.gfm,{br:v(F.br).replace("{2,}","*").getRegex(),text:v(F.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function q(Ie){return Ie.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ie(Ie){var Se="",ke,ae,le=Ie.length;for(ke=0;ke<le;ke++)ae=Ie.charCodeAt(ke),Math.random()>.5&&(ae="x"+ae.toString(16)),Se+="&#"+ae+";";return Se}var A=function(){function Ie(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||ne.defaults,this.options.tokenizer=this.options.tokenizer||new z,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ae={block:$.normal,inline:F.normal};this.options.pedantic?(ae.block=$.pedantic,ae.inline=F.pedantic):this.options.gfm&&(ae.block=$.gfm,this.options.breaks?ae.inline=F.breaks:ae.inline=F.gfm),this.tokenizer.rules=ae}Ie.lex=function(ae,le){var G=new Ie(le);return G.lex(ae)},Ie.lexInline=function(ae,le){var G=new Ie(le);return G.inlineTokens(ae)};var Se=Ie.prototype;return Se.lex=function(ae){ae=ae.replace(/\r\n|\r/g,`
`),this.blockTokens(ae,this.tokens);for(var le;le=this.inlineQueue.shift();)this.inlineTokens(le.src,le.tokens);return this.tokens},Se.blockTokens=function(ae,le){var G=this;le===void 0&&(le=[]),this.options.pedantic?ae=ae.replace(/\t/g,"    ").replace(/^ +$/gm,""):ae=ae.replace(/^( *)(\t+)/gm,function(se,de,J){return de+"    ".repeat(J.length)});for(var Q,I,B,H;ae;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(se){return(Q=se.call({lexer:G},ae,le))?(ae=ae.substring(Q.raw.length),le.push(Q),!0):!1}))){if(Q=this.tokenizer.space(ae)){ae=ae.substring(Q.raw.length),Q.raw.length===1&&le.length>0?le[le.length-1].raw+=`
`:le.push(Q);continue}if(Q=this.tokenizer.code(ae)){ae=ae.substring(Q.raw.length),I=le[le.length-1],I&&(I.type==="paragraph"||I.type==="text")?(I.raw+=`
`+Q.raw,I.text+=`
`+Q.text,this.inlineQueue[this.inlineQueue.length-1].src=I.text):le.push(Q);continue}if(Q=this.tokenizer.fences(ae)){ae=ae.substring(Q.raw.length),le.push(Q);continue}if(Q=this.tokenizer.heading(ae)){ae=ae.substring(Q.raw.length),le.push(Q);continue}if(Q=this.tokenizer.hr(ae)){ae=ae.substring(Q.raw.length),le.push(Q);continue}if(Q=this.tokenizer.blockquote(ae)){ae=ae.substring(Q.raw.length),le.push(Q);continue}if(Q=this.tokenizer.list(ae)){ae=ae.substring(Q.raw.length),le.push(Q);continue}if(Q=this.tokenizer.html(ae)){ae=ae.substring(Q.raw.length),le.push(Q);continue}if(Q=this.tokenizer.def(ae)){ae=ae.substring(Q.raw.length),I=le[le.length-1],I&&(I.type==="paragraph"||I.type==="text")?(I.raw+=`
`+Q.raw,I.text+=`
`+Q.raw,this.inlineQueue[this.inlineQueue.length-1].src=I.text):this.tokens.links[Q.tag]||(this.tokens.links[Q.tag]={href:Q.href,title:Q.title});continue}if(Q=this.tokenizer.table(ae)){ae=ae.substring(Q.raw.length),le.push(Q);continue}if(Q=this.tokenizer.lheading(ae)){ae=ae.substring(Q.raw.length),le.push(Q);continue}if(B=ae,this.options.extensions&&this.options.extensions.startBlock&&function(){var se=1/0,de=ae.slice(1),J=void 0;G.options.extensions.startBlock.forEach(function(pe){J=pe.call({lexer:this},de),typeof J=="number"&&J>=0&&(se=Math.min(se,J))}),se<1/0&&se>=0&&(B=ae.substring(0,se+1))}(),this.state.top&&(Q=this.tokenizer.paragraph(B))){I=le[le.length-1],H&&I.type==="paragraph"?(I.raw+=`
`+Q.raw,I.text+=`
`+Q.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=I.text):le.push(Q),H=B.length!==ae.length,ae=ae.substring(Q.raw.length);continue}if(Q=this.tokenizer.text(ae)){ae=ae.substring(Q.raw.length),I=le[le.length-1],I&&I.type==="text"?(I.raw+=`
`+Q.raw,I.text+=`
`+Q.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=I.text):le.push(Q);continue}if(ae){var V="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(V);break}else throw new Error(V)}}return this.state.top=!0,le},Se.inline=function(ae,le){this.inlineQueue.push({src:ae,tokens:le})},Se.inlineTokens=function(ae,le){var G=this;le===void 0&&(le=[]);var Q,I,B,H=ae,V,se,de;if(this.tokens.links){var J=Object.keys(this.tokens.links);if(J.length>0)for(;(V=this.tokenizer.rules.inline.reflinkSearch.exec(H))!=null;)J.includes(V[0].slice(V[0].lastIndexOf("[")+1,-1))&&(H=H.slice(0,V.index)+"["+W("a",V[0].length-2)+"]"+H.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(V=this.tokenizer.rules.inline.blockSkip.exec(H))!=null;)H=H.slice(0,V.index)+"["+W("a",V[0].length-2)+"]"+H.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(V=this.tokenizer.rules.inline.escapedEmSt.exec(H))!=null;)H=H.slice(0,V.index)+"++"+H.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ae;)if(se||(de=""),se=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ge){return(Q=ge.call({lexer:G},ae,le))?(ae=ae.substring(Q.raw.length),le.push(Q),!0):!1}))){if(Q=this.tokenizer.escape(ae)){ae=ae.substring(Q.raw.length),le.push(Q);continue}if(Q=this.tokenizer.tag(ae)){ae=ae.substring(Q.raw.length),I=le[le.length-1],I&&Q.type==="text"&&I.type==="text"?(I.raw+=Q.raw,I.text+=Q.text):le.push(Q);continue}if(Q=this.tokenizer.link(ae)){ae=ae.substring(Q.raw.length),le.push(Q);continue}if(Q=this.tokenizer.reflink(ae,this.tokens.links)){ae=ae.substring(Q.raw.length),I=le[le.length-1],I&&Q.type==="text"&&I.type==="text"?(I.raw+=Q.raw,I.text+=Q.text):le.push(Q);continue}if(Q=this.tokenizer.emStrong(ae,H,de)){ae=ae.substring(Q.raw.length),le.push(Q);continue}if(Q=this.tokenizer.codespan(ae)){ae=ae.substring(Q.raw.length),le.push(Q);continue}if(Q=this.tokenizer.br(ae)){ae=ae.substring(Q.raw.length),le.push(Q);continue}if(Q=this.tokenizer.del(ae)){ae=ae.substring(Q.raw.length),le.push(Q);continue}if(Q=this.tokenizer.autolink(ae,ie)){ae=ae.substring(Q.raw.length),le.push(Q);continue}if(!this.state.inLink&&(Q=this.tokenizer.url(ae,ie))){ae=ae.substring(Q.raw.length),le.push(Q);continue}if(B=ae,this.options.extensions&&this.options.extensions.startInline&&function(){var ge=1/0,Ne=ae.slice(1),Be=void 0;G.options.extensions.startInline.forEach(function(Je){Be=Je.call({lexer:this},Ne),typeof Be=="number"&&Be>=0&&(ge=Math.min(ge,Be))}),ge<1/0&&ge>=0&&(B=ae.substring(0,ge+1))}(),Q=this.tokenizer.inlineText(B,q)){ae=ae.substring(Q.raw.length),Q.raw.slice(-1)!=="_"&&(de=Q.raw.slice(-1)),se=!0,I=le[le.length-1],I&&I.type==="text"?(I.raw+=Q.raw,I.text+=Q.text):le.push(Q);continue}if(ae){var pe="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(pe);break}else throw new Error(pe)}}return le},a(Ie,null,[{key:"rules",get:function(){return{block:$,inline:F}}}]),Ie}(),Z=function(){function Ie(ke){this.options=ke||ne.defaults}var Se=Ie.prototype;return Se.code=function(ae,le,G){var Q=(le||"").match(/\S*/)[0];if(this.options.highlight){var I=this.options.highlight(ae,Q);I!=null&&I!==ae&&(G=!0,ae=I)}return ae=ae.replace(/\n$/,"")+`
`,Q?'<pre><code class="'+this.options.langPrefix+f(Q,!0)+'">'+(G?ae:f(ae,!0))+`</code></pre>
`:"<pre><code>"+(G?ae:f(ae,!0))+`</code></pre>
`},Se.blockquote=function(ae){return`<blockquote>
`+ae+`</blockquote>
`},Se.html=function(ae){return ae},Se.heading=function(ae,le,G,Q){if(this.options.headerIds){var I=this.options.headerPrefix+Q.slug(G);return"<h"+le+' id="'+I+'">'+ae+"</h"+le+`>
`}return"<h"+le+">"+ae+"</h"+le+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(ae,le,G){var Q=le?"ol":"ul",I=le&&G!==1?' start="'+G+'"':"";return"<"+Q+I+`>
`+ae+"</"+Q+`>
`},Se.listitem=function(ae){return"<li>"+ae+`</li>
`},Se.checkbox=function(ae){return"<input "+(ae?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(ae){return"<p>"+ae+`</p>
`},Se.table=function(ae,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+ae+`</thead>
`+le+`</table>
`},Se.tablerow=function(ae){return`<tr>
`+ae+`</tr>
`},Se.tablecell=function(ae,le){var G=le.header?"th":"td",Q=le.align?"<"+G+' align="'+le.align+'">':"<"+G+">";return Q+ae+("</"+G+`>
`)},Se.strong=function(ae){return"<strong>"+ae+"</strong>"},Se.em=function(ae){return"<em>"+ae+"</em>"},Se.codespan=function(ae){return"<code>"+ae+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(ae){return"<del>"+ae+"</del>"},Se.link=function(ae,le,G){if(ae=w(this.options.sanitize,this.options.baseUrl,ae),ae===null)return G;var Q='<a href="'+f(ae)+'"';return le&&(Q+=' title="'+le+'"'),Q+=">"+G+"</a>",Q},Se.image=function(ae,le,G){if(ae=w(this.options.sanitize,this.options.baseUrl,ae),ae===null)return G;var Q='<img src="'+ae+'" alt="'+G+'"';return le&&(Q+=' title="'+le+'"'),Q+=this.options.xhtml?"/>":">",Q},Se.text=function(ae){return ae},Ie}(),ce=function(){function Ie(){}var Se=Ie.prototype;return Se.strong=function(ae){return ae},Se.em=function(ae){return ae},Se.codespan=function(ae){return ae},Se.del=function(ae){return ae},Se.html=function(ae){return ae},Se.text=function(ae){return ae},Se.link=function(ae,le,G){return""+G},Se.image=function(ae,le,G){return""+G},Se.br=function(){return""},Ie}(),oe=function(){function Ie(){this.seen={}}var Se=Ie.prototype;return Se.serialize=function(ae){return ae.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(ae,le){var G=ae,Q=0;if(this.seen.hasOwnProperty(G)){Q=this.seen[ae];do Q++,G=ae+"-"+Q;while(this.seen.hasOwnProperty(G))}return le||(this.seen[ae]=Q,this.seen[G]=0),G},Se.slug=function(ae,le){le===void 0&&(le={});var G=this.serialize(ae);return this.getNextSafeSlug(G,le.dryrun)},Ie}(),ue=function(){function Ie(ke){this.options=ke||ne.defaults,this.options.renderer=this.options.renderer||new Z,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ce,this.slugger=new oe}Ie.parse=function(ae,le){var G=new Ie(le);return G.parse(ae)},Ie.parseInline=function(ae,le){var G=new Ie(le);return G.parseInline(ae)};var Se=Ie.prototype;return Se.parse=function(ae,le){le===void 0&&(le=!0);var G="",Q,I,B,H,V,se,de,J,pe,ge,Ne,Be,Je,Ge,Te,rt,K,X,fe,Ue=ae.length;for(Q=0;Q<Ue;Q++){if(ge=ae[Q],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ge.type]&&(fe=this.options.extensions.renderers[ge.type].call({parser:this},ge),fe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ge.type))){G+=fe||"";continue}switch(ge.type){case"space":continue;case"hr":{G+=this.renderer.hr();continue}case"heading":{G+=this.renderer.heading(this.parseInline(ge.tokens),ge.depth,d(this.parseInline(ge.tokens,this.textRenderer)),this.slugger);continue}case"code":{G+=this.renderer.code(ge.text,ge.lang,ge.escaped);continue}case"table":{for(J="",de="",H=ge.header.length,I=0;I<H;I++)de+=this.renderer.tablecell(this.parseInline(ge.header[I].tokens),{header:!0,align:ge.align[I]});for(J+=this.renderer.tablerow(de),pe="",H=ge.rows.length,I=0;I<H;I++){for(se=ge.rows[I],de="",V=se.length,B=0;B<V;B++)de+=this.renderer.tablecell(this.parseInline(se[B].tokens),{header:!1,align:ge.align[B]});pe+=this.renderer.tablerow(de)}G+=this.renderer.table(J,pe);continue}case"blockquote":{pe=this.parse(ge.tokens),G+=this.renderer.blockquote(pe);continue}case"list":{for(Ne=ge.ordered,Be=ge.start,Je=ge.loose,H=ge.items.length,pe="",I=0;I<H;I++)Te=ge.items[I],rt=Te.checked,K=Te.task,Ge="",Te.task&&(X=this.renderer.checkbox(rt),Je?Te.tokens.length>0&&Te.tokens[0].type==="paragraph"?(Te.tokens[0].text=X+" "+Te.tokens[0].text,Te.tokens[0].tokens&&Te.tokens[0].tokens.length>0&&Te.tokens[0].tokens[0].type==="text"&&(Te.tokens[0].tokens[0].text=X+" "+Te.tokens[0].tokens[0].text)):Te.tokens.unshift({type:"text",text:X}):Ge+=X),Ge+=this.parse(Te.tokens,Je),pe+=this.renderer.listitem(Ge,K,rt);G+=this.renderer.list(pe,Ne,Be);continue}case"html":{G+=this.renderer.html(ge.text);continue}case"paragraph":{G+=this.renderer.paragraph(this.parseInline(ge.tokens));continue}case"text":{for(pe=ge.tokens?this.parseInline(ge.tokens):ge.text;Q+1<Ue&&ae[Q+1].type==="text";)ge=ae[++Q],pe+=`
`+(ge.tokens?this.parseInline(ge.tokens):ge.text);G+=le?this.renderer.paragraph(pe):pe;continue}default:{var He='Token with "'+ge.type+'" type was not found.';if(this.options.silent){console.error(He);return}else throw new Error(He)}}}return G},Se.parseInline=function(ae,le){le=le||this.renderer;var G="",Q,I,B,H=ae.length;for(Q=0;Q<H;Q++){if(I=ae[Q],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[I.type]&&(B=this.options.extensions.renderers[I.type].call({parser:this},I),B!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(I.type))){G+=B||"";continue}switch(I.type){case"escape":{G+=le.text(I.text);break}case"html":{G+=le.html(I.text);break}case"link":{G+=le.link(I.href,I.title,this.parseInline(I.tokens,le));break}case"image":{G+=le.image(I.href,I.title,I.text);break}case"strong":{G+=le.strong(this.parseInline(I.tokens,le));break}case"em":{G+=le.em(this.parseInline(I.tokens,le));break}case"codespan":{G+=le.codespan(I.text);break}case"br":{G+=le.br();break}case"del":{G+=le.del(this.parseInline(I.tokens,le));break}case"text":{G+=le.text(I.text);break}default:{var V='Token with "'+I.type+'" type was not found.';if(this.options.silent){console.error(V);return}else throw new Error(V)}}}return G},Ie}();function te(Ie,Se,ke){if(typeof Ie=="undefined"||Ie===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");if(typeof Se=="function"&&(ke=Se,Se=null),Se=l({},te.defaults,Se||{}),U(Se),ke){var ae=Se.highlight,le;try{le=A.lex(Ie,Se)}catch(B){return ke(B)}var G=function(H){var V;if(!H)try{Se.walkTokens&&te.walkTokens(le,Se.walkTokens),V=ue.parse(le,Se)}catch(se){H=se}return Se.highlight=ae,H?ke(H):ke(null,V)};if(!ae||ae.length<3||(delete Se.highlight,!le.length))return G();var Q=0;te.walkTokens(le,function(B){B.type==="code"&&(Q++,setTimeout(function(){ae(B.text,B.lang,function(H,V){if(H)return G(H);V!=null&&V!==B.text&&(B.text=V,B.escaped=!0),Q--,Q===0&&G()})},0))}),Q===0&&G();return}try{var I=A.lex(Ie,Se);return Se.walkTokens&&te.walkTokens(I,Se.walkTokens),ue.parse(I,Se)}catch(B){if(B.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+f(B.message+"",!0)+"</pre>";throw B}}te.options=te.setOptions=function(Ie){return l(te.defaults,Ie),k(te.defaults),te},te.getDefaults=D,te.defaults=ne.defaults,te.use=function(){for(var Ie=arguments.length,Se=new Array(Ie),ke=0;ke<Ie;ke++)Se[ke]=arguments[ke];var ae=l.apply(void 0,[{}].concat(Se)),le=te.defaults.extensions||{renderers:{},childTokens:{}},G;Se.forEach(function(Q){if(Q.extensions&&(G=!0,Q.extensions.forEach(function(B){if(!B.name)throw new Error("extension name required");if(B.renderer){var H=le.renderers?le.renderers[B.name]:null;H?le.renderers[B.name]=function(){for(var V=arguments.length,se=new Array(V),de=0;de<V;de++)se[de]=arguments[de];var J=B.renderer.apply(this,se);return J===!1&&(J=H.apply(this,se)),J}:le.renderers[B.name]=B.renderer}if(B.tokenizer){if(!B.level||B.level!=="block"&&B.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");le[B.level]?le[B.level].unshift(B.tokenizer):le[B.level]=[B.tokenizer],B.start&&(B.level==="block"?le.startBlock?le.startBlock.push(B.start):le.startBlock=[B.start]:B.level==="inline"&&(le.startInline?le.startInline.push(B.start):le.startInline=[B.start]))}B.childTokens&&(le.childTokens[B.name]=B.childTokens)})),Q.renderer&&function(){var B=te.defaults.renderer||new Z,H=function(de){var J=B[de];B[de]=function(){for(var pe=arguments.length,ge=new Array(pe),Ne=0;Ne<pe;Ne++)ge[Ne]=arguments[Ne];var Be=Q.renderer[de].apply(B,ge);return Be===!1&&(Be=J.apply(B,ge)),Be}};for(var V in Q.renderer)H(V);ae.renderer=B}(),Q.tokenizer&&function(){var B=te.defaults.tokenizer||new z,H=function(de){var J=B[de];B[de]=function(){for(var pe=arguments.length,ge=new Array(pe),Ne=0;Ne<pe;Ne++)ge[Ne]=arguments[Ne];var Be=Q.tokenizer[de].apply(B,ge);return Be===!1&&(Be=J.apply(B,ge)),Be}};for(var V in Q.tokenizer)H(V);ae.tokenizer=B}(),Q.walkTokens){var I=te.defaults.walkTokens;ae.walkTokens=function(B){Q.walkTokens.call(this,B),I&&I.call(this,B)}}G&&(ae.extensions=le),te.setOptions(ae)})},te.walkTokens=function(Ie,Se){for(var ke=function(){var Q=le.value;switch(Se.call(te,Q),Q.type){case"table":{for(var I=L(Q.header),B;!(B=I()).done;){var H=B.value;te.walkTokens(H.tokens,Se)}for(var V=L(Q.rows),se;!(se=V()).done;)for(var de=se.value,J=L(de),pe;!(pe=J()).done;){var ge=pe.value;te.walkTokens(ge.tokens,Se)}break}case"list":{te.walkTokens(Q.items,Se);break}default:te.defaults.extensions&&te.defaults.extensions.childTokens&&te.defaults.extensions.childTokens[Q.type]?te.defaults.extensions.childTokens[Q.type].forEach(function(Ne){te.walkTokens(Q[Ne],Se)}):Q.tokens&&te.walkTokens(Q.tokens,Se)}},ae=L(Ie),le;!(le=ae()).done;)ke()},te.parseInline=function(Ie,Se){if(typeof Ie=="undefined"||Ie===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");Se=l({},te.defaults,Se||{}),U(Se);try{var ke=A.lexInline(Ie,Se);return Se.walkTokens&&te.walkTokens(ke,Se.walkTokens),ue.parseInline(ke,Se)}catch(ae){if(ae.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+f(ae.message+"",!0)+"</pre>";throw ae}},te.Parser=ue,te.parser=ue.parse,te.Renderer=Z,te.TextRenderer=ce,te.Lexer=A,te.lexer=A.lex,te.Tokenizer=z,te.Slugger=oe,te.parse=te;var Ee=te.options,be=te.setOptions,ee=te.use,ve=te.walkTokens,Ae=te.parseInline,Fe=te,$e=ue.parse,Qe=A.lex;ne.Lexer=A,ne.Parser=ue,ne.Renderer=Z,ne.Slugger=oe,ne.TextRenderer=ce,ne.Tokenizer=z,ne.getDefaults=D,ne.lexer=Qe,ne.marked=te,ne.options=Ee,ne.parse=Fe,ne.parseInline=Ae,ne.parser=$e,ne.setOptions=be,ne.use=ee,ne.walkTokens=ve,Object.defineProperty(ne,"__esModule",{value:!0})}),define(ye[107],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function a(k,E,P){return Math.min(Math.max(k,E),P)}e.clamp=a;function p(k,E){return(E+k%E)%E}e.rot=p;class b{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=b;class L{constructor(){this._n=1,this._val=0}update(E){return this._val=this._val+(E-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=L;class D{constructor(E){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(E),this._values.fill(0,0,E)}update(E){const P=this._values[this._index];return this._values[this._index]=E,this._index=(this._index+1)%this._values.length,this._sum-=P,this._sum+=E,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=D}),function(){function ne(b){const L=[];typeof b=="number"&&L.push("code/timeOrigin",b);function D(E){L.push(E,Date.now())}function k(){const E=[];for(let P=0;P<L.length;P+=2)E.push({name:L[P],startTime:L[P+1]});return E}return{mark:D,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const D of performance.getEntriesByType("mark"))L.push({name:D.name,startTime:Math.round(b+D.startTime)});return L}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function a(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=e()),b.MonacoPerformanceMarks}var p;typeof global=="object"?p=global:typeof self=="object"?p=self:p={},typeof define=="function"?define("vs/base/common/performance",[],function(){return a(p)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=a(p):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),p.perf=a(p))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var a=e();for(var p in a)(typeof exports=="object"?exports:ne)[p]=a[p]}}(typeof self!="undefined"?self:this,function(){return function(ne){var e={};function a(p){if(e[p])return e[p].exports;var b=e[p]={i:p,l:!1,exports:{}};return ne[p].call(b.exports,b,b.exports,a),b.l=!0,b.exports}return a.m=ne,a.c=e,a.d=function(p,b,L){a.o(p,b)||Object.defineProperty(p,b,{enumerable:!0,get:L})},a.r=function(p){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(p,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(p,"__esModule",{value:!0})},a.t=function(p,b){if(1&b&&(p=a(p)),8&b||4&b&&typeof p=="object"&&p&&p.__esModule)return p;var L=Object.create(null);if(a.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:p}),2&b&&typeof p!="string")for(var D in p)a.d(L,D,function(k){return p[k]}.bind(null,D));return L},a.n=function(p){var b=p&&p.__esModule?function(){return p.default}:function(){return p};return a.d(b,"a",b),b},a.o=function(p,b){return Object.prototype.hasOwnProperty.call(p,b)},a.p="",a(a.s=0)}([function(ne,e,a){(function(p){var b;e=ne.exports=ee,b=typeof p=="object"&&p.env&&p.env.NODE_DEBUG&&/\bsemver\b/i.test(p.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],E=e.src=[],P=0,O=P++;E[O]="0|[1-9]\\d*";var y=P++;E[y]="[0-9]+";var m=P++;E[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var T=P++;E[T]="("+E[O]+")\\.("+E[O]+")\\.("+E[O]+")";var f=P++;E[f]="("+E[y]+")\\.("+E[y]+")\\.("+E[y]+")";var h=P++;E[h]="(?:"+E[O]+"|"+E[m]+")";var d=P++;E[d]="(?:"+E[y]+"|"+E[m]+")";var o=P++;E[o]="(?:-("+E[h]+"(?:\\."+E[h]+")*))";var v=P++;E[v]="(?:-?("+E[d]+"(?:\\."+E[d]+")*))";var R=P++;E[R]="[0-9A-Za-z-]+";var c=P++;E[c]="(?:\\+("+E[R]+"(?:\\."+E[R]+")*))";var w=P++,s="v?"+E[T]+E[o]+"?"+E[c]+"?";E[w]="^"+s+"$";var u="[v=\\s]*"+E[f]+E[v]+"?"+E[c]+"?",n=P++;E[n]="^"+u+"$";var i=P++;E[i]="((?:<|>)?=?)";var r=P++;E[r]=E[y]+"|x|X|\\*";var t=P++;E[t]=E[O]+"|x|X|\\*";var l=P++;E[l]="[v=\\s]*("+E[t]+")(?:\\.("+E[t]+")(?:\\.("+E[t]+")(?:"+E[o]+")?"+E[c]+"?)?)?";var _=P++;E[_]="[v=\\s]*("+E[r]+")(?:\\.("+E[r]+")(?:\\.("+E[r]+")(?:"+E[v]+")?"+E[c]+"?)?)?";var g=P++;E[g]="^"+E[i]+"\\s*"+E[l]+"$";var C=P++;E[C]="^"+E[i]+"\\s*"+E[_]+"$";var U=P++;E[U]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var W=P++;E[W]="(?:~>?)";var M=P++;E[M]="(\\s*)"+E[W]+"\\s+",k[M]=new RegExp(E[M],"g");var S=P++;E[S]="^"+E[W]+E[l]+"$";var z=P++;E[z]="^"+E[W]+E[_]+"$";var $=P++;E[$]="(?:\\^)";var F=P++;E[F]="(\\s*)"+E[$]+"\\s+",k[F]=new RegExp(E[F],"g");var q=P++;E[q]="^"+E[$]+E[l]+"$";var ie=P++;E[ie]="^"+E[$]+E[_]+"$";var A=P++;E[A]="^"+E[i]+"\\s*("+u+")$|^$";var Z=P++;E[Z]="^"+E[i]+"\\s*("+s+")$|^$";var ce=P++;E[ce]="(\\s*)"+E[i]+"\\s*("+u+"|"+E[l]+")",k[ce]=new RegExp(E[ce],"g");var oe=P++;E[oe]="^\\s*("+E[l]+")\\s+-\\s+("+E[l]+")\\s*$";var ue=P++;E[ue]="^\\s*("+E[_]+")\\s+-\\s+("+E[_]+")\\s*$";var te=P++;E[te]="(<|>)?=?\\s*\\*";for(var Ee=0;Ee<35;Ee++)b(Ee,E[Ee]),k[Ee]||(k[Ee]=new RegExp(E[Ee]));function be(J,pe){if(J instanceof ee)return J;if(typeof J!="string"||J.length>L||!(pe?k[n]:k[w]).test(J))return null;try{return new ee(J,pe)}catch{return null}}function ee(J,pe){if(J instanceof ee){if(J.loose===pe)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof ee))return new ee(J,pe);b("SemVer",J,pe),this.loose=pe;var ge=J.trim().match(pe?k[n]:k[w]);if(!ge)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ne){if(/^[0-9]+$/.test(Ne)){var Be=+Ne;if(Be>=0&&Be<D)return Be}return Ne}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=be,e.valid=function(J,pe){var ge=be(J,pe);return ge?ge.version:null},e.clean=function(J,pe){var ge=be(J.trim().replace(/^[=v]+/,""),pe);return ge?ge.version:null},e.SemVer=ee,ee.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ee.prototype.toString=function(){return this.version},ee.prototype.compare=function(J){return b("SemVer.compare",this.version,this.loose,J),J instanceof ee||(J=new ee(J,this.loose)),this.compareMain(J)||this.comparePre(J)},ee.prototype.compareMain=function(J){return J instanceof ee||(J=new ee(J,this.loose)),Ae(this.major,J.major)||Ae(this.minor,J.minor)||Ae(this.patch,J.patch)},ee.prototype.comparePre=function(J){if(J instanceof ee||(J=new ee(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var pe=0;do{var ge=this.prerelease[pe],Ne=J.prerelease[pe];if(b("prerelease compare",pe,ge,Ne),ge===void 0&&Ne===void 0)return 0;if(Ne===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ne)return Ae(ge,Ne)}while(++pe)},ee.prototype.inc=function(J,pe){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",pe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",pe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",pe),this.inc("pre",pe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",pe),this.inc("pre",pe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}pe&&(this.prerelease[0]===pe?isNaN(this.prerelease[1])&&(this.prerelease=[pe,0]):this.prerelease=[pe,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,pe,ge,Ne){typeof ge=="string"&&(Ne=ge,ge=void 0);try{return new ee(J,ge).inc(pe,Ne).version}catch{return null}},e.diff=function(J,pe){if(Ie(J,pe))return null;var ge=be(J),Ne=be(pe);if(ge.prerelease.length||Ne.prerelease.length){for(var Be in ge)if((Be==="major"||Be==="minor"||Be==="patch")&&ge[Be]!==Ne[Be])return"pre"+Be;return"prerelease"}for(var Be in ge)if((Be==="major"||Be==="minor"||Be==="patch")&&ge[Be]!==Ne[Be])return Be},e.compareIdentifiers=Ae;var ve=/^[0-9]+$/;function Ae(J,pe){var ge=ve.test(J),Ne=ve.test(pe);return ge&&Ne&&(J=+J,pe=+pe),ge&&!Ne?-1:Ne&&!ge?1:J<pe?-1:J>pe?1:0}function Fe(J,pe,ge){return new ee(J,ge).compare(new ee(pe,ge))}function $e(J,pe,ge){return Fe(J,pe,ge)>0}function Qe(J,pe,ge){return Fe(J,pe,ge)<0}function Ie(J,pe,ge){return Fe(J,pe,ge)===0}function Se(J,pe,ge){return Fe(J,pe,ge)!==0}function ke(J,pe,ge){return Fe(J,pe,ge)>=0}function ae(J,pe,ge){return Fe(J,pe,ge)<=0}function le(J,pe,ge,Ne){var Be;switch(pe){case"===":typeof J=="object"&&(J=J.version),typeof ge=="object"&&(ge=ge.version),Be=J===ge;break;case"!==":typeof J=="object"&&(J=J.version),typeof ge=="object"&&(ge=ge.version),Be=J!==ge;break;case"":case"=":case"==":Be=Ie(J,ge,Ne);break;case"!=":Be=Se(J,ge,Ne);break;case">":Be=$e(J,ge,Ne);break;case">=":Be=ke(J,ge,Ne);break;case"<":Be=Qe(J,ge,Ne);break;case"<=":Be=ae(J,ge,Ne);break;default:throw new TypeError("Invalid operator: "+pe)}return Be}function G(J,pe){if(J instanceof G){if(J.loose===pe)return J;J=J.value}if(!(this instanceof G))return new G(J,pe);b("comparator",J,pe),this.loose=pe,this.parse(J),this.semver===Q?this.value="":this.value=this.operator+this.semver.version,b("comp",this)}e.rcompareIdentifiers=function(J,pe){return Ae(pe,J)},e.major=function(J,pe){return new ee(J,pe).major},e.minor=function(J,pe){return new ee(J,pe).minor},e.patch=function(J,pe){return new ee(J,pe).patch},e.compare=Fe,e.compareLoose=function(J,pe){return Fe(J,pe,!0)},e.rcompare=function(J,pe,ge){return Fe(pe,J,ge)},e.sort=function(J,pe){return J.sort(function(ge,Ne){return e.compare(ge,Ne,pe)})},e.rsort=function(J,pe){return J.sort(function(ge,Ne){return e.rcompare(ge,Ne,pe)})},e.gt=$e,e.lt=Qe,e.eq=Ie,e.neq=Se,e.gte=ke,e.lte=ae,e.cmp=le,e.Comparator=G;var Q={};function I(J,pe){if(J instanceof I)return J.loose===pe?J:new I(J.raw,pe);if(J instanceof G)return new I(J.value,pe);if(!(this instanceof I))return new I(J,pe);if(this.loose=pe,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function B(J){return!J||J.toLowerCase()==="x"||J==="*"}function H(J,pe,ge,Ne,Be,Je,Ge,Te,rt,K,X,fe,Ue){return((pe=B(ge)?"":B(Ne)?">="+ge+".0.0":B(Be)?">="+ge+"."+Ne+".0":">="+pe)+" "+(Te=B(rt)?"":B(K)?"<"+(+rt+1)+".0.0":B(X)?"<"+rt+"."+(+K+1)+".0":fe?"<="+rt+"."+K+"."+X+"-"+fe:"<="+Te)).trim()}function V(J,pe){for(var ge=0;ge<J.length;ge++)if(!J[ge].test(pe))return!1;if(pe.prerelease.length){for(ge=0;ge<J.length;ge++)if(b(J[ge].semver),J[ge].semver!==Q&&J[ge].semver.prerelease.length>0){var Ne=J[ge].semver;if(Ne.major===pe.major&&Ne.minor===pe.minor&&Ne.patch===pe.patch)return!0}return!1}return!0}function se(J,pe,ge){try{pe=new I(pe,ge)}catch{return!1}return pe.test(J)}function de(J,pe,ge,Ne){var Be,Je,Ge,Te,rt;switch(J=new ee(J,Ne),pe=new I(pe,Ne),ge){case">":Be=$e,Je=ae,Ge=Qe,Te=">",rt=">=";break;case"<":Be=Qe,Je=ke,Ge=$e,Te="<",rt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(se(J,pe,Ne))return!1;for(var K=0;K<pe.set.length;++K){var X=pe.set[K],fe=null,Ue=null;if(X.forEach(function(He){He.semver===Q&&(He=new G(">=0.0.0")),fe=fe||He,Ue=Ue||He,Be(He.semver,fe.semver,Ne)?fe=He:Ge(He.semver,Ue.semver,Ne)&&(Ue=He)}),fe.operator===Te||fe.operator===rt||(!Ue.operator||Ue.operator===Te)&&Je(J,Ue.semver)||Ue.operator===rt&&Ge(J,Ue.semver))return!1}return!0}G.prototype.parse=function(J){var pe=this.loose?k[A]:k[Z],ge=J.match(pe);if(!ge)throw new TypeError("Invalid comparator: "+J);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new ee(ge[2],this.loose):this.semver=Q},G.prototype.toString=function(){return this.value},G.prototype.test=function(J){return b("Comparator.test",J,this.loose),this.semver===Q||(typeof J=="string"&&(J=new ee(J,this.loose)),le(J,this.operator,this.semver,this.loose))},G.prototype.intersects=function(J,pe){if(!(J instanceof G))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new I(J.value,pe),se(this.value,ge,pe);if(J.operator==="")return ge=new I(this.value,pe),se(J.semver,ge,pe);var Ne=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),Be=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),Je=this.semver.version===J.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),Te=le(this.semver,"<",J.semver,pe)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),rt=le(this.semver,">",J.semver,pe)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return Ne||Be||Je&&Ge||Te||rt},e.Range=I,I.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},I.prototype.toString=function(){return this.range},I.prototype.parseRange=function(J){var pe=this.loose;J=J.trim(),b("range",J,pe);var ge=pe?k[ue]:k[oe];J=J.replace(ge,H),b("hyphen replace",J),J=J.replace(k[ce],"$1$2$3"),b("comparator trim",J,k[ce]),J=(J=(J=J.replace(k[M],"$1~")).replace(k[F],"$1^")).split(/\s+/).join(" ");var Ne=pe?k[A]:k[Z],Be=J.split(" ").map(function(Je){return function(Ge,Te){return b("comp",Ge),Ge=function(rt,K){return rt.trim().split(/\s+/).map(function(X){return function(fe,Ue){b("caret",fe,Ue);var He=Ue?k[ie]:k[q];return fe.replace(He,function(Ze,qe,We,nt,ot){var ht;return b("caret",fe,Ze,qe,We,nt,ot),B(qe)?ht="":B(We)?ht=">="+qe+".0.0 <"+(+qe+1)+".0.0":B(nt)?ht=qe==="0"?">="+qe+"."+We+".0 <"+qe+"."+(+We+1)+".0":">="+qe+"."+We+".0 <"+(+qe+1)+".0.0":ot?(b("replaceCaret pr",ot),ot.charAt(0)!=="-"&&(ot="-"+ot),ht=qe==="0"?We==="0"?">="+qe+"."+We+"."+nt+ot+" <"+qe+"."+We+"."+(+nt+1):">="+qe+"."+We+"."+nt+ot+" <"+qe+"."+(+We+1)+".0":">="+qe+"."+We+"."+nt+ot+" <"+(+qe+1)+".0.0"):(b("no pr"),ht=qe==="0"?We==="0"?">="+qe+"."+We+"."+nt+" <"+qe+"."+We+"."+(+nt+1):">="+qe+"."+We+"."+nt+" <"+qe+"."+(+We+1)+".0":">="+qe+"."+We+"."+nt+" <"+(+qe+1)+".0.0"),b("caret return",ht),ht})}(X,K)}).join(" ")}(Ge,Te),b("caret",Ge),Ge=function(rt,K){return rt.trim().split(/\s+/).map(function(X){return function(fe,Ue){var He=Ue?k[z]:k[S];return fe.replace(He,function(Ze,qe,We,nt,ot){var ht;return b("tilde",fe,Ze,qe,We,nt,ot),B(qe)?ht="":B(We)?ht=">="+qe+".0.0 <"+(+qe+1)+".0.0":B(nt)?ht=">="+qe+"."+We+".0 <"+qe+"."+(+We+1)+".0":ot?(b("replaceTilde pr",ot),ot.charAt(0)!=="-"&&(ot="-"+ot),ht=">="+qe+"."+We+"."+nt+ot+" <"+qe+"."+(+We+1)+".0"):ht=">="+qe+"."+We+"."+nt+" <"+qe+"."+(+We+1)+".0",b("tilde return",ht),ht})}(X,K)}).join(" ")}(Ge,Te),b("tildes",Ge),Ge=function(rt,K){return b("replaceXRanges",rt,K),rt.split(/\s+/).map(function(X){return function(fe,Ue){fe=fe.trim();var He=Ue?k[C]:k[g];return fe.replace(He,function(Ze,qe,We,nt,ot,ht){b("xRange",fe,Ze,qe,We,nt,ot,ht);var kt=B(We),it=kt||B(nt),dt=it||B(ot);return qe==="="&&dt&&(qe=""),kt?Ze=qe===">"||qe==="<"?"<0.0.0":"*":qe&&dt?(it&&(nt=0),dt&&(ot=0),qe===">"?(qe=">=",it?(We=+We+1,nt=0,ot=0):dt&&(nt=+nt+1,ot=0)):qe==="<="&&(qe="<",it?We=+We+1:nt=+nt+1),Ze=qe+We+"."+nt+"."+ot):it?Ze=">="+We+".0.0 <"+(+We+1)+".0.0":dt&&(Ze=">="+We+"."+nt+".0 <"+We+"."+(+nt+1)+".0"),b("xRange return",Ze),Ze})}(X,K)}).join(" ")}(Ge,Te),b("xrange",Ge),Ge=function(rt,K){return b("replaceStars",rt,K),rt.trim().replace(k[te],"")}(Ge,Te),b("stars",Ge),Ge}(Je,pe)}).join(" ").split(/\s+/);return this.loose&&(Be=Be.filter(function(Je){return!!Je.match(Ne)})),Be=Be.map(function(Je){return new G(Je,pe)})},I.prototype.intersects=function(J,pe){if(!(J instanceof I))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ne){return J.set.some(function(Be){return Be.every(function(Je){return Ne.intersects(Je,pe)})})})})},e.toComparators=function(J,pe){return new I(J,pe).set.map(function(ge){return ge.map(function(Ne){return Ne.value}).join(" ").trim().split(" ")})},I.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new ee(J,this.loose));for(var pe=0;pe<this.set.length;pe++)if(V(this.set[pe],J))return!0;return!1},e.satisfies=se,e.maxSatisfying=function(J,pe,ge){var Ne=null,Be=null;try{var Je=new I(pe,ge)}catch{return null}return J.forEach(function(Ge){Je.test(Ge)&&(Ne&&Be.compare(Ge)!==-1||(Be=new ee(Ne=Ge,ge)))}),Ne},e.minSatisfying=function(J,pe,ge){var Ne=null,Be=null;try{var Je=new I(pe,ge)}catch{return null}return J.forEach(function(Ge){Je.test(Ge)&&(Ne&&Be.compare(Ge)!==1||(Be=new ee(Ne=Ge,ge)))}),Ne},e.validRange=function(J,pe){try{return new I(J,pe).range||"*"}catch{return null}},e.ltr=function(J,pe,ge){return de(J,pe,"<",ge)},e.gtr=function(J,pe,ge){return de(J,pe,">",ge)},e.outside=de,e.prerelease=function(J,pe){var ge=be(J,pe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(J,pe,ge){return J=new I(J,ge),pe=new I(pe,ge),J.intersects(pe)},e.coerce=function(J){if(J instanceof ee)return J;if(typeof J!="string")return null;var pe=J.match(k[U]);return pe==null?null:be((pe[1]||"0")+"."+(pe[2]||"0")+"."+(pe[3]||"0"))}}).call(this,a(1))},function(ne,e){var a,p,b=ne.exports={};function L(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function k(d){if(a===setTimeout)return setTimeout(d,0);if((a===L||!a)&&setTimeout)return a=setTimeout,setTimeout(d,0);try{return a(d,0)}catch{try{return a.call(null,d,0)}catch{return a.call(this,d,0)}}}(function(){try{a=typeof setTimeout=="function"?setTimeout:L}catch{a=L}try{p=typeof clearTimeout=="function"?clearTimeout:D}catch{p=D}})();var E,P=[],O=!1,y=-1;function m(){O&&E&&(O=!1,E.length?P=E.concat(P):y=-1,P.length&&T())}function T(){if(!O){var d=k(m);O=!0;for(var o=P.length;o;){for(E=P,P=[];++y<o;)E&&E[y].run();y=-1,o=P.length}E=null,O=!1,function(v){if(p===clearTimeout)return clearTimeout(v);if((p===D||!p)&&clearTimeout)return p=clearTimeout,clearTimeout(v);try{p(v)}catch{try{return p.call(null,v)}catch{return p.call(this,v)}}}(d)}}function f(d,o){this.fun=d,this.array=o}function h(){}b.nextTick=function(d){var o=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)o[v-1]=arguments[v];P.push(new f(d,o)),P.length!==1||O||k(T)},f.prototype.run=function(){this.fun.apply(null,this.array)},b.title="browser",b.browser=!0,b.env={},b.argv=[],b.version="",b.versions={},b.on=h,b.addListener=h,b.once=h,b.off=h,b.removeListener=h,b.removeAllListeners=h,b.emit=h,b.prependListener=h,b.prependOnceListener=h,b.listeners=function(d){return[]},b.binding=function(d){throw new Error("process.binding is not supported")},b.cwd=function(){return"/"},b.chdir=function(d){throw new Error("process.chdir is not supported")},b.umask=function(){return 0}}])}),define(ye[108],De([1,0,11,7]),function(ne,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function b(c){const w=c;return w?typeof w.read=="function":!1}e.isReadable=b;function L(c){const w=c;return w?[w.on,w.pause,w.resume,w.destroy].every(s=>typeof s=="function"):!1}e.isReadableStream=L;function D(c){const w=c;return w?L(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.isReadableBufferedStream=D;function k(c,w){return new E(c,w)}e.newWriteableStream=k;class E{constructor(w,s){this.reducer=w,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(w){if(!this.state.destroyed){if(this.state.flowing)this.emitData(w);else if(this.buffer.data.push(w),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(w){this.state.destroyed||(this.state.flowing?this.emitError(w):this.buffer.error.push(w))}end(w){this.state.destroyed||(typeof w!="undefined"&&this.write(w),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(w){this.listeners.data.slice(0).forEach(s=>s(w))}emitError(w){this.listeners.error.length===0?(0,a.onUnexpectedError)(w):this.listeners.error.slice(0).forEach(s=>s(w))}emitEnd(){this.listeners.end.slice(0).forEach(w=>w())}on(w,s){if(!this.state.destroyed)switch(w){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(w,s){if(this.state.destroyed)return;let u;switch(w){case"data":u=this.listeners.data;break;case"end":u=this.listeners.end;break;case"error":u=this.listeners.error;break}if(u){const n=u.indexOf(s);n>=0&&u.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const w=this.reducer(this.buffer.data);this.emitData(w),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(u=>u())}}flowErrors(){if(this.listeners.error.length>0){for(const w of this.buffer.error)this.emitError(w);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function P(c,w){const s=[];let u;for(;(u=c.read())!==null;)s.push(u);return w(s)}e.consumeReadable=P;function O(c,w,s){const u=[];let n;for(;(n=c.read())!==null&&u.length<s;)u.push(n);return n===null&&u.length>0?w(u):{read:()=>{if(u.length>0)return u.shift();if(typeof n!="undefined"){const i=n;return n=void 0,i}return c.read()}}}e.peekReadable=O;function y(c,w){return new Promise((s,u)=>{const n=[];m(c,{onData:i=>{w&&n.push(i)},onError:i=>{w?u(i):s(void 0)},onEnd:()=>{s(w?w(n):void 0)}})})}e.consumeStream=y;function m(c,w){let s=!1;return c.on("error",u=>{s||w.onError(u)}),c.on("end",()=>{s||w.onEnd()}),c.on("data",u=>{s||w.onData(u)}),(0,p.toDisposable)(()=>s=!0)}e.listenStream=m;function T(c,w){return new Promise((s,u)=>{const n=new p.DisposableStore,i=[],r=_=>{if(i.push(_),i.length>w)return n.dispose(),c.pause(),s({stream:c,buffer:i,ended:!1})},t=_=>u(_),l=()=>s({stream:c,buffer:i,ended:!0});n.add((0,p.toDisposable)(()=>c.removeListener("error",t))),c.on("error",t),n.add((0,p.toDisposable)(()=>c.removeListener("end",l))),c.on("end",l),n.add((0,p.toDisposable)(()=>c.removeListener("data",r))),c.on("data",r)})}e.peekStream=T;function f(c,w){const s=k(w);return s.end(c),s}e.toStream=f;function h(){const c=k(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=h;function d(c){let w=!1;return{read:()=>w?null:(w=!0,c)}}e.toReadable=d;function o(c,w,s){const u=k(s);return m(c,{onData:n=>u.write(w.data(n)),onError:n=>u.error(w.error?w.error(n):n),onEnd:()=>u.end()}),u}e.transform=o;function v(c,w,s){let u=!1;return{read:()=>{const n=w.read();return u?n:(u=!0,n!==null?s([c,n]):c)}}}e.prefixedReadable=v;function R(c,w,s){let u=!1;const n=k(s);return m(w,{onData:i=>u?n.write(i):(u=!0,n.write(s([c,i]))),onError:i=>n.error(i),onEnd:()=>{u||(u=!0,n.write(c)),n.end()}}),n}e.prefixedStream=R}),define(ye[23],De([1,0,108]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const p=typeof Buffer!="undefined";let b,L;class D{constructor(_){this.buffer=_,this.byteLength=this.buffer.byteLength}static alloc(_){return p?new D(Buffer.allocUnsafe(_)):new D(new Uint8Array(_))}static wrap(_){return p&&!Buffer.isBuffer(_)&&(_=Buffer.from(_.buffer,_.byteOffset,_.byteLength)),new D(_)}static fromString(_,g){return!(g?.dontUseNodeBuffer||!1)&&p?new D(Buffer.from(_)):(b||(b=new TextEncoder),new D(b.encode(_)))}static fromByteArray(_){const g=D.alloc(_.length);for(let C=0,U=_.length;C<U;C++)g.buffer[C]=_[C];return g}static concat(_,g){if(typeof g=="undefined"){g=0;for(let W=0,M=_.length;W<M;W++)g+=_[W].byteLength}const C=D.alloc(g);let U=0;for(let W=0,M=_.length;W<M;W++){const S=_[W];C.set(S,U),U+=S.byteLength}return C}clone(){const _=D.alloc(this.byteLength);return _.set(this),_}toString(){return p?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(_,g){return new D(this.buffer.subarray(_,g))}set(_,g){if(_ instanceof D)this.buffer.set(_.buffer,g);else if(_ instanceof Uint8Array)this.buffer.set(_,g);else if(_ instanceof ArrayBuffer)this.buffer.set(new Uint8Array(_),g);else if(ArrayBuffer.isView(_))this.buffer.set(new Uint8Array(_.buffer,_.byteOffset,_.byteLength),g);else throw new Error("Unknown argument 'array'")}readUInt32BE(_){return P(this.buffer,_)}writeUInt32BE(_,g){O(this.buffer,_,g)}readUInt32LE(_){return y(this.buffer,_)}writeUInt32LE(_,g){m(this.buffer,_,g)}readUInt8(_){return T(this.buffer,_)}writeUInt8(_,g){f(this.buffer,_,g)}}e.VSBuffer=D;function k(l,_){return l[_+0]<<0>>>0|l[_+1]<<8>>>0}e.readUInt16LE=k;function E(l,_,g){l[g+0]=_&255,_=_>>>8,l[g+1]=_&255}e.writeUInt16LE=E;function P(l,_){return l[_]*2**24+l[_+1]*2**16+l[_+2]*2**8+l[_+3]}e.readUInt32BE=P;function O(l,_,g){l[g+3]=_,_=_>>>8,l[g+2]=_,_=_>>>8,l[g+1]=_,_=_>>>8,l[g]=_}e.writeUInt32BE=O;function y(l,_){return l[_+0]<<0>>>0|l[_+1]<<8>>>0|l[_+2]<<16>>>0|l[_+3]<<24>>>0}e.readUInt32LE=y;function m(l,_,g){l[g+0]=_&255,_=_>>>8,l[g+1]=_&255,_=_>>>8,l[g+2]=_&255,_=_>>>8,l[g+3]=_&255}e.writeUInt32LE=m;function T(l,_){return l[_]}e.readUInt8=T;function f(l,_,g){l[g]=_}e.writeUInt8=f;function h(l){return a.consumeReadable(l,_=>D.concat(_))}e.readableToBuffer=h;function d(l){return a.toReadable(l)}e.bufferToReadable=d;function o(l){return a.consumeStream(l,_=>D.concat(_))}e.streamToBuffer=o;async function v(l){return l.ended?D.concat(l.buffer):D.concat([...l.buffer,await o(l.stream)])}e.bufferedStreamToBuffer=v;function R(l){return a.toStream(l,_=>D.concat(_))}e.bufferToStream=R;function c(l){return a.transform(l,{data:_=>typeof _=="string"?D.fromString(_):D.wrap(_)},_=>D.concat(_))}e.streamToBufferReadableStream=c;function w(l){return a.newWriteableStream(_=>D.concat(_),l)}e.newWriteableBufferStream=w;function s(l,_){return a.prefixedReadable(l,_,g=>D.concat(g))}e.prefixedBufferReadable=s;function u(l,_){return a.prefixedStream(l,_,g=>D.concat(g))}e.prefixedBufferStream=u;function n(l){let _=0,g=0,C=0;const U=new Uint8Array(Math.floor(l.length/4*3)),W=S=>{switch(g){case 3:U[C++]=_|S,g=0;break;case 2:U[C++]=_|S>>>2,_=S<<6,g=3;break;case 1:U[C++]=_|S>>>4,_=S<<4,g=2;break;default:_=S<<2,g=1}};for(let S=0;S<l.length;S++){const z=l.charCodeAt(S);if(z>=65&&z<=90)W(z-65);else if(z>=97&&z<=122)W(z-97+26);else if(z>=48&&z<=57)W(z-48+52);else if(z===43||z===45)W(62);else if(z===47||z===95)W(63);else{if(z===61)break;throw new SyntaxError(`Unexpected base64 character ${l[S]}`)}}const M=C;for(;g>0;)W(0);return D.wrap(U).slice(0,M)}e.decodeBase64=n;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function t({buffer:l},_=!0,g=!1){const C=g?r:i;let U="";const W=l.byteLength%3;let M=0;for(;M<l.byteLength-W;M+=3){const S=l[M+0],z=l[M+1],$=l[M+2];U+=C[S>>>2],U+=C[(S<<4|z>>>4)&63],U+=C[(z<<2|$>>>6)&63],U+=C[$&63]}if(W===1){const S=l[M+0];U+=C[S>>>2],U+=C[S<<4&63],_&&(U+="==")}else if(W===2){const S=l[M+0],z=l[M+1];U+=C[S>>>2],U+=C[(S<<4|z>>>4)&63],U+=C[z<<2&63],_&&(U+="=")}return U}e.encodeBase64=t}),define(ye[42],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const a=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function p(b){return a.test(b)}e.isUUID=p,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let b;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?b=crypto.getRandomValues.bind(crypto):b=function(k){for(let E=0;E<k.length;E++)k[E]=Math.floor(Math.random()*256);return k};const L=new Uint8Array(16),D=[];for(let k=0;k<256;k++)D.push(k.toString(16).padStart(2,"0"));return function(){b(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let E=0,P="";return P+=D[L[E++]],P+=D[L[E++]],P+=D[L[E++]],P+=D[L[E++]],P+="-",P+=D[L[E++]],P+=D[L[E++]],P+="-",P+=D[L[E++]],P+=D[L[E++]],P+="-",P+=D[L[E++]],P+=D[L[E++]],P+="-",P+=D[L[E++]],P+=D[L[E++]],P+=D[L[E++]],P+=D[L[E++]],P+=D[L[E++]],P+=D[L[E++]],P}}()}),define(ye[109],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ye[110],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var a;(function(D){D[D.None=0]="None",D[D.Indent=1]="Indent",D[D.IndentOutdent=2]="IndentOutdent",D[D.Outdent=3]="Outdent"})(a=e.IndentAction||(e.IndentAction={}));class p{constructor(k){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=k.open,this.close=k.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(k.notIn))for(let E=0,P=k.notIn.length;E<P;E++)switch(k.notIn[E]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(k){switch(k){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(k,E){if(k.getTokenCount()===0)return!0;const P=k.findTokenIndexAtOffset(E-2),O=k.getStandardTokenType(P);return this.isOK(O)}_findNeutralCharacterInRange(k,E){for(let P=k;P<=E;P++){const O=String.fromCharCode(P);if(!this.open.includes(O)&&!this.close.includes(O))return O}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=p;class b{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of k)L(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),L(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),L(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),L(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&L(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.AutoClosingPairs=b;function L(D,k,E){D.has(k)?D.get(k).push(E):D.set(k,[E])}}),define(ye[111],De([17,18]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(ye[112],De([1,0,111]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const p=60,b=p*60,L=b*24,D=L*7,k=L*30,E=L*365;function P(y,m,T){typeof y!="number"&&(y=y.getTime());const f=Math.round((new Date().getTime()-y)/1e3);if(f<-30)return(0,a.localize)(0,null,P(new Date().getTime()+f*1e3,!1));if(f<30)return(0,a.localize)(1,null);let h;return f<p?(h=f,m?h===1?T?(0,a.localize)(2,null,h):(0,a.localize)(3,null,h):T?(0,a.localize)(4,null,h):(0,a.localize)(5,null,h):h===1?T?(0,a.localize)(6,null,h):(0,a.localize)(7,null,h):T?(0,a.localize)(8,null,h):(0,a.localize)(9,null,h)):f<b?(h=Math.floor(f/p),m?h===1?T?(0,a.localize)(10,null,h):(0,a.localize)(11,null,h):T?(0,a.localize)(12,null,h):(0,a.localize)(13,null,h):h===1?T?(0,a.localize)(14,null,h):(0,a.localize)(15,null,h):T?(0,a.localize)(16,null,h):(0,a.localize)(17,null,h)):f<L?(h=Math.floor(f/b),m?h===1?T?(0,a.localize)(18,null,h):(0,a.localize)(19,null,h):T?(0,a.localize)(20,null,h):(0,a.localize)(21,null,h):h===1?T?(0,a.localize)(22,null,h):(0,a.localize)(23,null,h):T?(0,a.localize)(24,null,h):(0,a.localize)(25,null,h)):f<D?(h=Math.floor(f/L),m?h===1?(0,a.localize)(26,null,h):(0,a.localize)(27,null,h):h===1?(0,a.localize)(28,null,h):(0,a.localize)(29,null,h)):f<k?(h=Math.floor(f/D),m?h===1?T?(0,a.localize)(30,null,h):(0,a.localize)(31,null,h):T?(0,a.localize)(32,null,h):(0,a.localize)(33,null,h):h===1?T?(0,a.localize)(34,null,h):(0,a.localize)(35,null,h):T?(0,a.localize)(36,null,h):(0,a.localize)(37,null,h)):f<E?(h=Math.floor(f/k),m?h===1?T?(0,a.localize)(38,null,h):(0,a.localize)(39,null,h):T?(0,a.localize)(40,null,h):(0,a.localize)(41,null,h):h===1?T?(0,a.localize)(42,null,h):(0,a.localize)(43,null,h):T?(0,a.localize)(44,null,h):(0,a.localize)(45,null,h)):(h=Math.floor(f/E),m?h===1?T?(0,a.localize)(46,null,h):(0,a.localize)(47,null,h):T?(0,a.localize)(48,null,h):(0,a.localize)(49,null,h):h===1?T?(0,a.localize)(50,null,h):(0,a.localize)(51,null,h):T?(0,a.localize)(52,null,h):(0,a.localize)(53,null,h))}e.fromNow=P;function O(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=O}),define(ye[113],De([17,18]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(ye[43],De([1,0,16,10,113]),function(ne,e,a,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(y,m){return m&&(y.stack||y.stacktrace)?b.localize(0,null,k(y),D(y.stack)||D(y.stacktrace)):k(y)}function D(y){return Array.isArray(y)?y.join(`
`):y}function k(y){return typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?b.localize(1,null,y.message):y.message||b.localize(2,null)}function E(y=null,m=!1){if(!y)return b.localize(3,null);if(Array.isArray(y)){const T=a.coalesce(y),f=E(T[0],m);return T.length>1?b.localize(4,null,f,T.length):f}if(p.isString(y))return y;if(y.detail){const T=y.detail;if(T.error)return L(T.error,m);if(T.exception)return L(T.exception,m)}return y.stack?L(y,m):y.message?y.message:b.localize(5,null)}e.toErrorMessage=E;function P(y){const m=y;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=P;function O(y,m){let T;return typeof y=="string"?T=new Error(y):T=y,T.actions=m,T}e.createErrorWithActions=O}),define(ye[74],De([1,0,19]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const p={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},b={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(O){const y=(0,a.extname)(O),m=p[y.toLowerCase()];return m!==void 0?m:D(O)}e.getMediaOrTextMime=L;function D(O){const y=(0,a.extname)(O);return b[y.toLowerCase()]}e.getMediaMime=D;function k(O){for(const y in b)if(b[y]===O)return y}e.getExtensionForMimeType=k;const E=/^(.+)\/(.+?)(;.+)?$/;function P(O,y){const m=E.exec(O);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:y?void 0:O}e.normalizeMimeType=P}),define(ye[37],De([1,0,19,21,9,10]),function(ne,e,a,p,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(r){return r===47||r===92}e.isPathSeparator=D;function k(r){return r.replace(/[\\/]/g,a.posix.sep)}e.toSlashes=k;function E(r){return r.indexOf("/")===-1&&(r=k(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=E;function P(r,t=a.posix.sep){if(!r)return"";const l=r.length,_=r.charCodeAt(0);if(D(_)){if(D(r.charCodeAt(1))&&!D(r.charCodeAt(2))){let C=3;const U=C;for(;C<l&&!D(r.charCodeAt(C));C++);if(U!==C&&!D(r.charCodeAt(C+1))){for(C+=1;C<l;C++)if(D(r.charCodeAt(C)))return r.slice(0,C+1).replace(/[\\/]/g,t)}}return t}else if(o(_)&&r.charCodeAt(1)===58)return D(r.charCodeAt(2))?r.slice(0,2)+t:r.slice(0,2);let g=r.indexOf("://");if(g!==-1){for(g+=3;g<l;g++)if(D(r.charCodeAt(g)))return r.slice(0,g+1)}return""}e.getRoot=P;function O(r){if(!p.isWindows||!r||r.length<5)return!1;let t=r.charCodeAt(0);if(t!==92||(t=r.charCodeAt(1),t!==92))return!1;let l=2;const _=l;for(;l<r.length&&(t=r.charCodeAt(l),t!==92);l++);return!(_===l||(t=r.charCodeAt(l+1),isNaN(t)||t===92))}e.isUNC=O;const y=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,T=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(r,t=p.isWindows){const l=t?y:m;return!(!r||r.length===0||/^\s+$/.test(r)||(l.lastIndex=0,l.test(r))||t&&T.test(r)||r==="."||r===".."||t&&r[r.length-1]==="."||t&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=f;function h(r,t,l){const _=r===t;return!l||_?_:!r||!t?!1:(0,b.equalsIgnoreCase)(r,t)}e.isEqual=h;function d(r,t,l,_=a.sep){if(r===t)return!0;if(!r||!t||t.length>r.length)return!1;if(l){if(!(0,b.startsWithIgnoreCase)(r,t))return!1;if(t.length===r.length)return!0;let C=t.length;return t.charAt(t.length-1)===_&&C--,r.charAt(C)===_}return t.charAt(t.length-1)!==_&&(t+=_),r.indexOf(t)===0}e.isEqualOrParent=d;function o(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=o;function v(r,t){return p.isWindows&&r.endsWith(":")&&(r+=a.sep),(0,a.isAbsolute)(r)||(r=(0,a.join)(t,r)),r=(0,a.normalize)(r),p.isWindows?(r=(0,b.rtrim)(r,a.sep),r.endsWith(":")&&(r+=a.sep)):(r=(0,b.rtrim)(r,a.sep),r||(r=a.sep)),r}e.sanitizeFilePath=v;function R(r){const t=(0,a.normalize)(r);return p.isWindows?r.length>3?!1:c(t)&&(r.length===2||t.charCodeAt(2)===92):t===a.posix.sep}e.isRootOrDriveLetter=R;function c(r,t=p.isWindows){return t?o(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function w(r){return c(r)?r[0]:void 0}e.getDriveLetter=w;function s(r,t,l){return t.length>r.length?-1:r===t?0:(l&&(r=r.toLowerCase(),t=t.toLowerCase()),r.indexOf(t))}e.indexOfPath=s;function u(r){const t=r.split(":");let l,_,g;for(const C of t){const U=Number(C);(0,L.isNumber)(U)?_===void 0?_=U:g===void 0&&(g=U):l=l?[l,C].join(":"):C}if(!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:_!==void 0?_:void 0,column:g!==void 0?g:_!==void 0?1:void 0}}e.parseLineAndColumnAware=u;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(r,t,l=8){let _="";for(let C=0;C<l;C++)_+=n.charAt(Math.floor(Math.random()*n.length));let g;return t?g=`${t}-${_}`:g=_,r?(0,a.join)(r,g):g}e.randomPath=i}),define(ye[25],De([1,0,16,9]),function(ne,e,a,p){"use strict";var b,L,D;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function k(n,i,r){let t=n.get(i);return t===void 0&&(t=r,n.set(i,t)),t}e.getOrSet=k;function E(n){const i=[];return n.forEach((r,t)=>{i.push(`${t} => ${r}`)}),`Map(${n.size}) {${i.join(", ")}}`}e.mapToString=E;function P(n){const i=[];return n.forEach(r=>{i.push(r)}),`Set(${n.size}) {${i.join(", ")}}`}e.setToString=P;class O{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const r=i.charCodeAt(0),t=this._value.charCodeAt(this._pos);return r-t}value(){return this._value[this._pos]}}e.StringIterator=O;class y{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,p.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,p.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=y;class m{constructor(i=!0,r=!0){this._splitOnBackslash=i,this._caseSensitive=r}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let r=i.length-1;r>=0;r--,this._valueLen--){const t=this._value.charCodeAt(r);if(!(t===47||this._splitOnBackslash&&t===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,p.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,p.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var T;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(T||(T={}));class f{constructor(i,r){this._ignorePathCasing=i,this._ignoreQueryAndFragment=r,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(i)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,p.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,p.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,p.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,p.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class h{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(d||(d={}));class o{constructor(i){this._iter=i}static forUris(i=()=>!1,r=()=>!1){return new o(new f(i,r))}static forPaths(i=!1){return new o(new m(void 0,!i))}static forStrings(){return new o(new O)}static forConfigKeys(){return new o(new y)}clear(){this._root=void 0}fill(i,r){if(r){const t=r.slice(0);(0,a.shuffle)(t);for(const l of t)this.set(l,i)}else{const t=i.slice(0);(0,a.shuffle)(t);for(const l of t)this.set(l[0],l[1])}}set(i,r){const t=this._iter.reset(i);let l;this._root||(this._root=new h,this._root.segment=t.value());const _=[];for(l=this._root;;){const C=t.cmp(l.segment);if(C>0)l.left||(l.left=new h,l.left.segment=t.value()),_.push([-1,l]),l=l.left;else if(C<0)l.right||(l.right=new h,l.right.segment=t.value()),_.push([1,l]),l=l.right;else if(t.hasNext())t.next(),l.mid||(l.mid=new h,l.mid.segment=t.value()),_.push([0,l]),l=l.mid;else break}const g=l.value;l.value=r,l.key=i;for(let C=_.length-1;C>=0;C--){const U=_[C][1];U.updateHeight();const W=U.balanceFactor();if(W<-1||W>1){const M=_[C][0],S=_[C+1][0];if(M===1&&S===1)_[C][1]=U.rotateLeft();else if(M===-1&&S===-1)_[C][1]=U.rotateRight();else if(M===1&&S===-1)U.right=_[C+1][1]=_[C+1][1].rotateRight(),_[C][1]=U.rotateLeft();else if(M===-1&&S===1)U.left=_[C+1][1]=_[C+1][1].rotateLeft(),_[C][1]=U.rotateRight();else throw new Error;if(C>0)switch(_[C-1][0]){case-1:_[C-1][1].left=_[C][1];break;case 1:_[C-1][1].right=_[C][1];break;case 0:_[C-1][1].mid=_[C][1];break}else this._root=_[0][1]}}return g}get(i){return this._getNode(i)?.value}_getNode(i){const r=this._iter.reset(i);let t=this._root;for(;t;){const l=r.cmp(t.segment);if(l>0)t=t.left;else if(l<0)t=t.right;else if(r.hasNext())r.next(),t=t.mid;else break}return t}has(i){const r=this._getNode(i);return!(r?.value===void 0&&r?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,r){const t=this._iter.reset(i),l=[];let _=this._root;for(;_;){const g=t.cmp(_.segment);if(g>0)l.push([-1,_]),_=_.left;else if(g<0)l.push([1,_]),_=_.right;else if(t.hasNext())t.next(),l.push([0,_]),_=_.mid;else break}if(!!_){if(r?(_.left=void 0,_.mid=void 0,_.right=void 0,_.height=1):(_.key=void 0,_.value=void 0),!_.mid&&!_.value)if(_.left&&_.right){const g=this._min(_.right),{key:C,value:U,segment:W}=g;this._delete(g.key,!1),_.key=C,_.value=U,_.segment=W}else{const g=_.left??_.right;if(l.length>0){const[C,U]=l[l.length-1];switch(C){case-1:U.left=g;break;case 0:U.mid=g;break;case 1:U.right=g;break}}else this._root=g}for(let g=l.length-1;g>=0;g--){const C=l[g][1];C.updateHeight();const U=C.balanceFactor();if(U>1?(C.right.balanceFactor()>=0||(C.right=C.right.rotateRight()),l[g][1]=C.rotateLeft()):U<-1&&(C.left.balanceFactor()<=0||(C.left=C.left.rotateLeft()),l[g][1]=C.rotateRight()),g>0)switch(l[g-1][0]){case-1:l[g-1][1].left=l[g][1];break;case 1:l[g-1][1].right=l[g][1];break;case 0:l[g-1][1].mid=l[g][1];break}else this._root=l[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const r=this._iter.reset(i);let t=this._root,l;for(;t;){const _=r.cmp(t.segment);if(_>0)t=t.left;else if(_<0)t=t.right;else if(r.hasNext())r.next(),l=t.value||l,t=t.mid;else break}return t&&t.value||l}findSuperstr(i){const r=this._iter.reset(i);let t=this._root;for(;t;){const l=r.cmp(t.segment);if(l>0)t=t.left;else if(l<0)t=t.right;else if(r.hasNext())r.next(),t=t.mid;else return t.mid?this._entries(t.mid):void 0}}forEach(i){for(const[r,t]of this)i(t,r)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(i){const r=[];return this._dfsEntries(i,r),r[Symbol.iterator]()}_dfsEntries(i,r){!i||(i.left&&this._dfsEntries(i.left,r),i.value&&r.push([i.key,i.value]),i.mid&&this._dfsEntries(i.mid,r),i.right&&this._dfsEntries(i.right,r))}_isBalanced(){const i=r=>{if(!r)return!0;const t=r.balanceFactor();return t<-1||t>1?!1:i(r.left)&&i(r.right)};return i(this._root)}}e.TernarySearchTree=o;class v{constructor(i,r){this.uri=i,this.value=r}}class R{constructor(i,r){this[b]="ResourceMap",i instanceof R?(this.map=new Map(i.map),this.toKey=r??R.defaultToKey):(this.map=new Map,this.toKey=i??R.defaultToKey)}set(i,r){return this.map.set(this.toKey(i),new v(i,r)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,r){typeof r!="undefined"&&(i=i.bind(r));for(const[t,l]of this.map)i(l.value,l.uri,this)}*values(){for(const i of this.map.values())yield i.value}*keys(){for(const i of this.map.values())yield i.uri}*entries(){for(const i of this.map.values())yield[i.uri,i.value]}*[(b=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=R,R.defaultToKey=n=>n.toString();class c{constructor(i,r){this[L]="ResourceSet",!i||typeof i=="function"?this._map=new R(i):(this._map=new R(r),i.forEach(this.add,this))}get size(){return this._map.size}add(i){return this._map.set(i,i),this}clear(){this._map.clear()}delete(i){return this._map.delete(i)}forEach(i,r){this._map.forEach((t,l)=>i.call(r,l,l,this))}has(i){return this._map.has(i)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=c;var w;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(w=e.Touch||(e.Touch={}));class s{constructor(){this[D]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,r=0){const t=this._map.get(i);if(!!t)return r!==0&&this.touch(t,r),t.value}set(i,r,t=0){let l=this._map.get(i);if(l)l.value=r,t!==0&&this.touch(l,t);else{switch(l={key:i,value:r,next:void 0,previous:void 0},t){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(i,l),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const r=this._map.get(i);if(!!r)return this._map.delete(i),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,r){const t=this._state;let l=this._head;for(;l;){if(r?i.bind(r)(l.value,l.key,this):i(l.value,l.key,this),this._state!==t)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const i=this,r=this._state;let t=this._head;const l={[Symbol.iterator](){return l},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(t){const _={value:t.key,done:!1};return t=t.next,_}else return{value:void 0,done:!0}}};return l}values(){const i=this,r=this._state;let t=this._head;const l={[Symbol.iterator](){return l},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(t){const _={value:t.value,done:!1};return t=t.next,_}else return{value:void 0,done:!0}}};return l}entries(){const i=this,r=this._state;let t=this._head;const l={[Symbol.iterator](){return l},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(t){const _={value:[t.key,t.value],done:!1};return t=t.next,_}else return{value:void 0,done:!0}}};return l}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let r=this._head,t=this.size;for(;r&&t>i;)this._map.delete(r.key),r=r.next,t--;this._head=r,this._size=t,r&&(r.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const r=i.next,t=i.previous;if(!r||!t)throw new Error("Invalid list");r.previous=t,t.next=r}i.next=void 0,i.previous=void 0,this._state++}touch(i,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(i===this._head)return;const t=i.next,l=i.previous;i===this._tail?(l.next=void 0,this._tail=l):(t.previous=l,l.next=t),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(r===2){if(i===this._tail)return;const t=i.next,l=i.previous;i===this._head?(t.previous=void 0,this._head=t):(t.previous=l,l.next=t),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((r,t)=>{i.push([t,r])}),i}fromJSON(i){this.clear();for(const[r,t]of i)this.set(r,t)}}e.LinkedMap=s;class u extends s{constructor(i,r=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,r=2){return super.get(i,r)}peek(i){return super.get(i,0)}set(i,r){return super.set(i,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=u}),define(ye[114],De([1,0,25,9]),function(ne,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function b(...G){return function(Q,I){for(let B=0,H=G.length;B<H;B++){const V=G[B](Q,I);if(V)return V}return null}}e.or=b,e.matchesStrictPrefix=L.bind(void 0,!1),e.matchesPrefix=L.bind(void 0,!0);function L(G,Q,I){if(!I||I.length<Q.length)return null;let B;return G?B=p.startsWithIgnoreCase(I,Q):B=I.indexOf(Q)===0,B?Q.length>0?[{start:0,end:Q.length}]:[]:null}function D(G,Q){const I=Q.toLowerCase().indexOf(G.toLowerCase());return I===-1?null:[{start:I,end:I+G.length}]}e.matchesContiguousSubString=D;function k(G,Q){return E(G.toLowerCase(),Q.toLowerCase(),0,0)}e.matchesSubString=k;function E(G,Q,I,B){if(I===G.length)return[];if(B===Q.length)return null;if(G[I]===Q[B]){let H=null;return(H=E(G,Q,I+1,B+1))?o({start:B,end:B+1},H):null}return E(G,Q,I,B+1)}function P(G){return 97<=G&&G<=122}function O(G){return 65<=G&&G<=90}e.isUpper=O;function y(G){return 48<=G&&G<=57}function m(G){return G===32||G===9||G===10||G===13}const T=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(G=>T.add(G.charCodeAt(0)));function f(G){return m(G)||T.has(G)}function h(G,Q){return G===Q||f(G)&&f(Q)}function d(G){return P(G)||O(G)||y(G)}function o(G,Q){return Q.length===0?Q=[G]:G.end===Q[0].start?Q[0].start=G.start:Q.unshift(G),Q}function v(G,Q){for(let I=Q;I<G.length;I++){const B=G.charCodeAt(I);if(O(B)||y(B)||I>0&&!d(G.charCodeAt(I-1)))return I}return G.length}function R(G,Q,I,B){if(I===G.length)return[];if(B===Q.length)return null;if(G[I]!==Q[B].toLowerCase())return null;{let H=null,V=B+1;for(H=R(G,Q,I+1,B+1);!H&&(V=v(Q,V))<Q.length;)H=R(G,Q,I+1,V),V++;return H===null?null:o({start:B,end:B+1},H)}}function c(G){let Q=0,I=0,B=0,H=0,V=0;for(let ge=0;ge<G.length;ge++)V=G.charCodeAt(ge),O(V)&&Q++,P(V)&&I++,d(V)&&B++,y(V)&&H++;const se=Q/G.length,de=I/G.length,J=B/G.length,pe=H/G.length;return{upperPercent:se,lowerPercent:de,alphaPercent:J,numericPercent:pe}}function w(G){const{upperPercent:Q,lowerPercent:I}=G;return I===0&&Q>.6}function s(G){const{upperPercent:Q,lowerPercent:I,alphaPercent:B,numericPercent:H}=G;return I>.2&&Q<.8&&B>.6&&H<.2}function u(G){let Q=0,I=0,B=0,H=0;for(let V=0;V<G.length;V++)B=G.charCodeAt(V),O(B)&&Q++,P(B)&&I++,m(B)&&H++;return(Q===0||I===0)&&H===0?G.length<=30:Q<=5}function n(G,Q){if(!Q||(Q=Q.trim(),Q.length===0)||!u(G)||Q.length>60)return null;const I=c(Q);if(!s(I)){if(!w(I))return null;Q=Q.toLowerCase()}let B=null,H=0;for(G=G.toLowerCase();H<Q.length&&(B=R(G,Q,0,H))===null;)H=v(Q,H+1);return B}e.matchesCamelCase=n;function i(G,Q,I=!1){if(!Q||Q.length===0)return null;let B=null,H=0;for(G=G.toLowerCase(),Q=Q.toLowerCase();H<Q.length&&(B=r(G,Q,0,H,I))===null;)H=t(Q,H+1);return B}e.matchesWords=i;function r(G,Q,I,B,H){if(I===G.length)return[];if(B===Q.length)return null;if(h(G.charCodeAt(I),Q.charCodeAt(B))){let V=null,se=B+1;if(V=r(G,Q,I+1,B+1,H),!H)for(;!V&&(se=t(Q,se))<Q.length;)V=r(G,Q,I+1,se,H),se++;return V?G.charCodeAt(I)!==Q.charCodeAt(B)?V:o({start:B,end:B+1},V):null}else return null}function t(G,Q){for(let I=Q;I<G.length;I++)if(f(G.charCodeAt(I))||I>0&&f(G.charCodeAt(I-1)))return I;return G.length}const l=b(e.matchesPrefix,n,D),_=b(e.matchesPrefix,n,k),g=new a.LRUCache(1e4);function C(G,Q,I=!1){if(typeof G!="string"||typeof Q!="string")return null;let B=g.get(G);B||(B=new RegExp(p.convertSimple2RegExpPattern(G),"i"),g.set(G,B));const H=B.exec(Q);return H?[{start:H.index,end:H.index+H[0].length}]:I?_(G,Q):l(G,Q)}e.matchesFuzzy=C;function U(G,Q){const I=$e(G,G.toLowerCase(),0,Q,Q.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return I?M(I):null}e.matchesFuzzy2=U;function W(G,Q,I,B,H,V){const se=Math.min(13,G.length);for(;I<se;I++){const de=$e(G,Q,I,B,H,V,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(de)return de}return[0,V]}e.anyScore=W;function M(G){if(typeof G=="undefined")return[];const Q=[],I=G[1];for(let B=G.length-1;B>1;B--){const H=G[B]+I,V=Q[Q.length-1];V&&V.end===H?V.end=H+1:Q.push({start:H,end:H+1})}return Q}e.createMatches=M;const S=128;function z(){const G=[],Q=[];for(let I=0;I<=S;I++)Q[I]=0;for(let I=0;I<=S;I++)G.push(Q.slice(0));return G}function $(G){const Q=[];for(let I=0;I<=G;I++)Q[I]=0;return Q}const F=$(2*S),q=$(2*S),ie=z(),A=z(),Z=z(),ce=!1;function oe(G,Q,I,B,H){function V(de,J,pe=" "){for(;de.length<J;)de=pe+de;return de}let se=` |   |${B.split("").map(de=>V(de,3)).join("|")}
`;for(let de=0;de<=I;de++)de===0?se+=" |":se+=`${Q[de-1]}|`,se+=G[de].slice(0,H+1).map(J=>V(J.toString(),3)).join("|")+`
`;return se}function ue(G,Q,I,B){G=G.substr(Q),I=I.substr(B),console.log(oe(A,G,G.length,I,I.length)),console.log(oe(Z,G,G.length,I,I.length)),console.log(oe(ie,G,G.length,I,I.length))}function te(G,Q){if(Q<0||Q>=G.length)return!1;const I=G.codePointAt(Q);switch(I){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!p.isEmojiImprecise(I)}}function Ee(G,Q){if(Q<0||Q>=G.length)return!1;switch(G.charCodeAt(Q)){case 32:case 9:return!0;default:return!1}}function be(G,Q,I){return Q[G]!==I[G]}function ee(G,Q,I,B,H,V,se=!1){for(;Q<I&&H<V;)G[Q]===B[H]&&(se&&(F[Q]=H),Q+=1),H+=1;return Q===I}e.isPatternInWord=ee;var ve;(function(G){G[G.Diag=1]="Diag",G[G.Left=2]="Left",G[G.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var Ae;(function(G){G.Default=[-100,0];function Q(I){return!I||I.length===2&&I[0]===-100&&I[1]===0}G.isDefault=Q})(Ae=e.FuzzyScore||(e.FuzzyScore={}));class Fe{constructor(Q,I){this.firstMatchCanBeWeak=Q,this.boostFullMatch=I}}e.FuzzyScoreOptions=Fe,Fe.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function $e(G,Q,I,B,H,V,se=Fe.default){const de=G.length>S?S:G.length,J=B.length>S?S:B.length;if(I>=de||V>=J||de-I>J-V||!ee(Q,I,de,H,V,J,!0))return;Qe(de,J,I,V,Q,H);let pe=1,ge=1,Ne=I,Be=V;const Je=[!1];for(pe=1,Ne=I;Ne<de;pe++,Ne++){const X=F[Ne],fe=q[Ne],Ue=Ne+1<de?q[Ne+1]:J;for(ge=X-V+1,Be=X;Be<Ue;ge++,Be++){let He=Number.MIN_SAFE_INTEGER,Ze=!1;Be<=fe&&(He=Ie(G,Q,Ne,I,B,H,Be,J,V,ie[pe-1][ge-1]===0,Je));let qe=0;He!==Number.MAX_SAFE_INTEGER&&(Ze=!0,qe=He+A[pe-1][ge-1]);const We=Be>X,nt=We?A[pe][ge-1]+(ie[pe][ge-1]>0?-5:0):0,ot=Be>X+1&&ie[pe][ge-1]>0,ht=ot?A[pe][ge-2]+(ie[pe][ge-2]>0?-5:0):0;if(ot&&(!We||ht>=nt)&&(!Ze||ht>=qe))A[pe][ge]=ht,Z[pe][ge]=3,ie[pe][ge]=0;else if(We&&(!Ze||nt>=qe))A[pe][ge]=nt,Z[pe][ge]=2,ie[pe][ge]=0;else if(Ze)A[pe][ge]=qe,Z[pe][ge]=1,ie[pe][ge]=ie[pe-1][ge-1]+1;else throw new Error("not possible")}}if(ce&&ue(G,I,B,V),!Je[0]&&!se.firstMatchCanBeWeak)return;pe--,ge--;const Ge=[A[pe][ge],V];let Te=0,rt=0;for(;pe>=1;){let X=ge;do{const fe=Z[pe][X];if(fe===3)X=X-2;else if(fe===2)X=X-1;else break}while(X>=1);Te>1&&Q[I+pe-1]===H[V+ge-1]&&!be(X+V-1,B,H)&&Te+1>ie[pe][X]&&(X=ge),X===ge?Te++:Te=1,rt||(rt=X),pe--,ge=X-1,Ge.push(ge)}J===de&&se.boostFullMatch&&(Ge[0]+=2);const K=rt-de;return Ge[0]-=K,Ge}e.fuzzyScore=$e;function Qe(G,Q,I,B,H,V){let se=G-1,de=Q-1;for(;se>=I&&de>=B;)H[se]===V[de]&&(q[se]=de,se--),de--}function Ie(G,Q,I,B,H,V,se,de,J,pe,ge){if(Q[I]!==V[se])return Number.MIN_SAFE_INTEGER;let Ne=1,Be=!1;return se===I-B?Ne=G[I]===H[se]?7:5:be(se,H,V)&&(se===0||!be(se-1,H,V))?(Ne=G[I]===H[se]?7:5,Be=!0):te(V,se)&&(se===0||!te(V,se-1))?Ne=5:(te(V,se-1)||Ee(V,se-1))&&(Ne=5,Be=!0),Ne>1&&I===B&&(ge[0]=!0),Be||(Be=be(se,H,V)||te(V,se-1)||Ee(V,se-1)),I===B?se>J&&(Ne-=Be?3:5):pe?Ne+=Be?2:0:Ne+=Be?0:1,se+1===de&&(Ne-=Be?3:5),Ne}function Se(G,Q,I,B,H,V,se){return ae(G,Q,I,B,H,V,!0,se)}e.fuzzyScoreGracefulAggressive=Se;function ke(G,Q,I,B,H,V,se){return ae(G,Q,I,B,H,V,!1,se)}e.fuzzyScoreGraceful=ke;function ae(G,Q,I,B,H,V,se,de){let J=$e(G,Q,I,B,H,V,de);if(J&&!se)return J;if(G.length>=3){const pe=Math.min(7,G.length-1);for(let ge=I+1;ge<pe;ge++){const Ne=le(G,ge);if(Ne){const Be=$e(Ne,Ne.toLowerCase(),I,B,H,V,de);Be&&(Be[0]-=3,(!J||Be[0]>J[0])&&(J=Be))}}}return J}function le(G,Q){if(Q+1>=G.length)return;const I=G[Q],B=G[Q+1];if(I!==B)return G.slice(0,Q)+B+I+G.slice(Q+2)}}),define(ye[115],De([1,0,116,114,9]),function(ne,e,a,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const L=new RegExp(`\\$\\(${a.CSSIcon.iconNameExpression}(?:${a.CSSIcon.iconModifierExpression})?\\)`,"g"),D=new RegExp(a.CSSIcon.iconNameCharacter),k=new RegExp(`(\\\\)?${L.source}`,"g");function E(d){return d.replace(k,(o,v)=>v?o:`\\${o}`)}e.escapeIcons=E;const P=new RegExp(`\\\\${L.source}`,"g");function O(d){return d.replace(P,o=>`\\${o}`)}e.markdownEscapeEscapedIcons=O;const y=new RegExp(`(\\s)?(\\\\)?${L.source}(\\s)?`,"g");function m(d){return d.indexOf(e.iconStartMarker)===-1?d:d.replace(y,(o,v,R,c)=>R?o:v||c||"")}e.stripIcons=m;function T(d){const o=d.indexOf(e.iconStartMarker);return o===-1?{text:d}:f(d,o)}e.parseLabelWithIcons=T;function f(d,o){const v=[];let R="";function c(l){if(l){R+=l;for(const _ of l)v.push(u)}}let w=-1,s="",u=0,n,i,r=o;const t=d.length;for(c(d.substr(0,o));r<t;)n=d[r],i=d[r+1],n===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(w=r,c(s),s=e.iconStartMarker,r++):n===")"&&w!==-1?(u+=r-w+1,w=-1,s=""):w!==-1?D.test(n)?s+=n:(c(s),w=-1,s=""):c(n),r++;return c(s),{text:R,iconOffsets:v}}function h(d,o,v=!1){const{text:R,iconOffsets:c}=o;if(!c||c.length===0)return(0,p.matchesFuzzy)(d,R,v);const w=(0,b.ltrim)(R," "),s=R.length-w.length,u=(0,p.matchesFuzzy)(d,w,v);if(u)for(const n of u){const i=c[n.start+s]+s;n.start+=i,n.end+=i}return u}e.matchesFuzzyIconAware=h}),define(ye[29],De([1,0,9]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var p;(function(b){b[b.Ignore=0]="Ignore",b[b.Info=1]="Info",b[b.Warning=2]="Warning",b[b.Error=3]="Error"})(p||(p={})),function(b){const L="error",D="warning",k="warn",E="info",P="ignore";function O(m){return m?a.equalsIgnoreCase(L,m)?b.Error:a.equalsIgnoreCase(D,m)||a.equalsIgnoreCase(k,m)?b.Warning:a.equalsIgnoreCase(E,m)?b.Info:b.Ignore:b.Ignore}b.fromValue=O;function y(m){switch(m){case b.Error:return L;case b.Warning:return D;case b.Info:return E;default:return P}}b.toString=y}(p||(p={})),e.default=p}),define(ye[55],De([1,0,23,9,2]),function(ne,e,a,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(P){return JSON.stringify(P,k)}e.stringify=L;function D(P){let O=JSON.parse(P);return O=E(O),O}e.parse=D;function k(P,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,p.regExpFlags)(O)}:O}function E(P,O=0){if(!P||O>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return b.URI.revive(P);case 2:return new RegExp(P.source,P.flags);case 14:return new Date(P.source)}if(P instanceof a.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let y=0;y<P.length;++y)P[y]=E(P[y],O+1);else for(const y in P)Object.hasOwnProperty.call(P,y)&&(P[y]=E(P[y],O+1))}return P}e.revive=E}),define(ye[12],De([1,0,21,2]),function(ne,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var b;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.vscodeUserData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp",k.vsls="vsls",k.vscodeSourceControl="vscode-scm"})(b=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class L{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${b.vscodeRemoteResource}`}setPreferredWebSchema(E){this._preferredWebSchema=E}setDelegate(E){this._delegate=E}setServerRootPath(E){this._remoteResourcesPath=`${E}/${b.vscodeRemoteResource}`}set(E,P,O){this._hosts[E]=P,this._ports[E]=O}setConnectionToken(E,P){this._connectionTokens[E]=P}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(E){if(this._delegate)return this._delegate(E);const P=E.authority;let O=this._hosts[P];O&&O.indexOf(":")!==-1&&(O=`[${O}]`);const y=this._ports[P],m=this._connectionTokens[P];let T=`path=${encodeURIComponent(E.path)}`;return typeof m=="string"&&(T+=`&${e.connectionTokenQueryName}=${encodeURIComponent(m)}`),p.URI.from({scheme:a.isWeb?this._preferredWebSchema:b.vscodeRemoteResource,authority:`${O}:${y}`,path:this._remoteResourcesPath,query:T})}}e.RemoteAuthorities=new L;class D{asBrowserUri(E,P){const O=this.toUri(E,P);return O.scheme===b.vscodeRemote?e.RemoteAuthorities.rewrite(O):O.scheme===b.file&&(a.isNative||a.isWebWorker&&a.globals.origin===`${b.vscodeFileResource}://${D.FALLBACK_AUTHORITY}`)?O.with({scheme:b.vscodeFileResource,authority:O.authority||D.FALLBACK_AUTHORITY,query:null,fragment:null}):O}asFileUri(E,P){const O=this.toUri(E,P);return O.scheme===b.vscodeFileResource?O.with({scheme:b.file,authority:O.authority!==D.FALLBACK_AUTHORITY?O.authority:null,query:null,fragment:null}):O}toUri(E,P){return p.URI.isUri(E)?E:p.URI.parse(P.toUrl(E))}}D.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new D}),define(ye[22],De([1,0,37,12,19,21,9,2]),function(ne,e,a,p,b,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(T){return(0,k.uriToFsPath)(T,!0)}e.originalFSPath=E;class P{constructor(f){this._ignorePathCasing=f}compare(f,h,d=!1){return f===h?0:(0,D.compare)(this.getComparisonKey(f,d),this.getComparisonKey(h,d))}isEqual(f,h,d=!1){return f===h?!0:!f||!h?!1:this.getComparisonKey(f,d)===this.getComparisonKey(h,d)}getComparisonKey(f,h=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,h,d=!1){if(f.scheme===h.scheme){if(f.scheme===p.Schemas.file)return a.isEqualOrParent(E(f),E(h),this._ignorePathCasing(f))&&f.query===h.query&&(d||f.fragment===h.fragment);if((0,e.isEqualAuthority)(f.authority,h.authority))return a.isEqualOrParent(f.path,h.path,this._ignorePathCasing(f),"/")&&f.query===h.query&&(d||f.fragment===h.fragment)}return!1}joinPath(f,...h){return k.URI.joinPath(f,...h)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return b.posix.basename(f.path)}extname(f){return b.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let h;return f.scheme===p.Schemas.file?h=k.URI.file(b.dirname(E(f))).path:(h=b.posix.dirname(f.path),f.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),h="/")),f.with({path:h})}normalizePath(f){if(!f.path.length)return f;let h;return f.scheme===p.Schemas.file?h=k.URI.file(b.normalize(E(f))).path:h=b.posix.normalize(f.path),f.with({path:h})}relativePath(f,h){if(f.scheme!==h.scheme||!(0,e.isEqualAuthority)(f.authority,h.authority))return;if(f.scheme===p.Schemas.file){const v=b.relative(E(f),E(h));return L.isWindows?a.toSlashes(v):v}let d=f.path||"/";const o=h.path||"/";if(this._ignorePathCasing(f)){let v=0;for(const R=Math.min(d.length,o.length);v<R&&!(d.charCodeAt(v)!==o.charCodeAt(v)&&d.charAt(v).toLowerCase()!==o.charAt(v).toLowerCase());v++);d=o.substr(0,v)+d.substr(v)}return b.posix.relative(d,o)}resolvePath(f,h){if(f.scheme===p.Schemas.file){const d=k.URI.file(b.resolve(E(f),h));return f.with({authority:d.authority,path:d.path})}return h=a.toPosixPath(h),f.with({path:b.posix.resolve(f.path,h)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,h){return f===h||f!==void 0&&h!==void 0&&(0,D.equalsIgnoreCase)(f,h)}hasTrailingPathSeparator(f,h=b.sep){if(f.scheme===p.Schemas.file){const d=E(f);return d.length>a.getRoot(d).length&&d[d.length-1]===h}else{const d=f.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,h=b.sep){return(0,e.hasTrailingPathSeparator)(f,h)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,h=b.sep){let d=!1;if(f.scheme===p.Schemas.file){const o=E(f);d=o!==void 0&&o.length===a.getRoot(o).length&&o[o.length-1]===h}else{h="/";const o=f.path;d=o.length===1&&o.charCodeAt(o.length-1)===47}return!d&&!(0,e.hasTrailingPathSeparator)(f,h)?f.with({path:f.path+"/"}):f}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(T=>T.scheme===p.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new P(T=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function O(T,f){const h=[];for(let d=0;d<T.length;d++){const o=f(T[d]);T.some((v,R)=>R===d?!1:(0,e.isEqualOrParent)(o,f(v)))||h.push(T[d])}return h}e.distinctParents=O;var y;(function(T){T.META_DATA_LABEL="label",T.META_DATA_DESCRIPTION="description",T.META_DATA_SIZE="size",T.META_DATA_MIME="mime";function f(h){const d=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(R=>{const[c,w]=R.split(":");c&&w&&d.set(c,w)});const v=h.path.substring(0,h.path.indexOf(";"));return v&&d.set(T.META_DATA_MIME,v),d}T.parseMetaData=f})(y=e.DataUri||(e.DataUri={}));function m(T,f,h){if(f){let d=T.path;return d&&d[0]!==b.posix.sep&&(d=b.posix.sep+d),T.with({scheme:h,authority:f,path:d})}return T.with({scheme:h})}e.toLocalResource=m}),define(ye[14],De([1,0,20,11,5,7,22,21]),function(ne,e,a,p,b,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(be){return!!be&&typeof be.then=="function"}e.isThenable=E;function P(be){const ee=new a.CancellationTokenSource,ve=be(ee.token),Ae=new Promise((Fe,$e)=>{const Qe=ee.token.onCancellationRequested(()=>{Qe.dispose(),ee.dispose(),$e(new p.CancellationError)});Promise.resolve(ve).then(Ie=>{Qe.dispose(),ee.dispose(),Fe(Ie)},Ie=>{Qe.dispose(),ee.dispose(),$e(Ie)})});return new class{cancel(){ee.cancel()}then(Fe,$e){return Ae.then(Fe,$e)}catch(Fe){return this.then(void 0,Fe)}finally(Fe){return Ae.finally(Fe)}}}e.createCancelablePromise=P;function O(be,ee,ve){return new Promise((Ae,Fe)=>{const $e=ee.onCancellationRequested(()=>{$e.dispose(),Ae(ve)});be.then(Ae,Fe).finally(()=>$e.dispose())})}e.raceCancellation=O;function y(be,ee){return new Promise((ve,Ae)=>{const Fe=ee.onCancellationRequested(()=>{Fe.dispose(),Ae(new p.CancellationError)});be.then(ve,Ae).finally(()=>Fe.dispose())})}e.raceCancellationError=y;async function m(be){let ee=-1;const ve=be.map((Fe,$e)=>Fe.then(Qe=>(ee=$e,Qe))),Ae=await Promise.race(ve);return be.forEach((Fe,$e)=>{$e!==ee&&Fe.cancel()}),Ae}e.raceCancellablePromises=m;function T(be,ee,ve){let Ae;const Fe=setTimeout(()=>{Ae?.(void 0),ve?.()},ee);return Promise.race([be.finally(()=>clearTimeout(Fe)),new Promise($e=>Ae=$e)])}e.raceTimeout=T;function f(be){return new Promise((ee,ve)=>{const Ae=be();E(Ae)?Ae.then(ee,ve):ee(Ae)})}e.asPromise=f;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(ee){if(this.activePromise){if(this.queuedPromiseFactory=ee,!this.queuedPromise){const ve=()=>{this.queuedPromise=null;const Ae=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Ae};this.queuedPromise=new Promise(Ae=>{this.activePromise.then(ve,ve).then(Ae)})}return new Promise((ve,Ae)=>{this.queuedPromise.then(ve,Ae)})}return this.activePromise=ee(),new Promise((ve,Ae)=>{this.activePromise.then(Fe=>{this.activePromise=null,ve(Fe)},Fe=>{this.activePromise=null,Ae(Fe)})})}}e.Throttler=h;class d{constructor(){this.current=Promise.resolve(null)}queue(ee){return this.current=this.current.then(()=>ee(),()=>ee())}}e.Sequencer=d;class o{constructor(){this.promiseMap=new Map}queue(ee,ve){const Fe=(this.promiseMap.get(ee)??Promise.resolve()).catch(()=>{}).then(ve).finally(()=>{this.promiseMap.get(ee)===Fe&&this.promiseMap.delete(ee)});return this.promiseMap.set(ee,Fe),Fe}}e.SequencerByKey=o;const v=(be,ee)=>{let ve=!0;const Ae=setTimeout(()=>{ve=!1,ee()},be);return{isTriggered:()=>ve,dispose:()=>{clearTimeout(Ae),ve=!1}}},R=be=>{let ee=!0;return queueMicrotask(()=>{ee&&(ee=!1,be())}),{isTriggered:()=>ee,dispose:()=>{ee=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class c{constructor(ee){this.defaultDelay=ee,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(ee,ve=this.defaultDelay){this.task=ee,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Fe,$e)=>{this.doResolve=Fe,this.doReject=$e}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Fe=this.task;return this.task=null,Fe()}}));const Ae=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ve===e.MicrotaskDelay?R(Ae):v(ve,Ae),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new p.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=c;class w{constructor(ee){this.delayer=new c(ee),this.throttler=new h}trigger(ee,ve){return this.delayer.trigger(()=>this.throttler.queue(ee),ve)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class s{constructor(){this._isOpen=!1,this._promise=new Promise((ee,ve)=>{this._completePromise=ee})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class u extends s{constructor(ee){super();this._timeout=setTimeout(()=>this.open(),ee)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function n(be,ee){return ee?new Promise((ve,Ae)=>{const Fe=setTimeout(()=>{$e.dispose(),ve()},be),$e=ee.onCancellationRequested(()=>{clearTimeout(Fe),$e.dispose(),Ae(new p.CancellationError)})}):P(ve=>n(be,ve))}e.timeout=n;function i(be,ee=0){const ve=setTimeout(be,ee);return(0,L.toDisposable)(()=>clearTimeout(ve))}e.disposableTimeout=i;function r(be){const ee=[];let ve=0;const Ae=be.length;function Fe(){return ve<Ae?be[ve++]():null}function $e(Qe){Qe!=null&&ee.push(Qe);const Ie=Fe();return Ie?Ie.then($e):Promise.resolve(ee)}return Promise.resolve(null).then($e)}e.sequence=r;function t(be,ee=Ae=>!!Ae,ve=null){let Ae=0;const Fe=be.length,$e=()=>{if(Ae>=Fe)return Promise.resolve(ve);const Qe=be[Ae++];return Promise.resolve(Qe()).then(Se=>ee(Se)?Promise.resolve(Se):$e())};return $e()}e.first=t;function l(be,ee=Ae=>!!Ae,ve=null){if(be.length===0)return Promise.resolve(ve);let Ae=be.length;const Fe=()=>{Ae=-1;for(const $e of be)$e.cancel?.()};return new Promise(($e,Qe)=>{for(const Ie of be)Ie.then(Se=>{--Ae>=0&&ee(Se)?(Fe(),$e(Se)):Ae===0&&$e(ve)}).catch(Se=>{--Ae>=0&&(Fe(),Qe(Se))})})}e.firstParallel=l;class _{constructor(ee){this._size=0,this.maxDegreeOfParalellism=ee,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new b.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(ee){return this._size++,new Promise((ve,Ae)=>{this.outstandingPromises.push({factory:ee,c:ve,e:Ae}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const ee=this.outstandingPromises.shift();this.runningPromises++;const ve=ee.factory();ve.then(ee.c,ee.e),ve.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=_;class g extends _{constructor(){super(1)}}e.Queue=g;class C{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const ee=new Z;return this.drainers.add(ee),ee.p}isDrained(){for(const[,ee]of this.queues)if(ee.size>0)return!1;return!0}queueFor(ee,ve=D.extUri){const Ae=ve.getComparisonKey(ee);let Fe=this.queues.get(Ae);return Fe||(Fe=new g,b.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.queues.delete(Ae),this.onDidQueueDrain()}),this.queues.set(Ae,Fe)),Fe}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const ee of this.drainers)ee.complete();this.drainers.clear()}dispose(){for(const[,ee]of this.queues)ee.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=C;class U{constructor(ee,ve){this._token=-1,typeof ee=="function"&&typeof ve=="number"&&this.setIfNotSet(ee,ve)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(ee,ve){this.cancel(),this._token=setTimeout(()=>{this._token=-1,ee()},ve)}setIfNotSet(ee,ve){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,ee()},ve))}}e.TimeoutTimer=U;class W{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(ee,ve){this.cancel(),this._token=setInterval(()=>{ee()},ve)}}e.IntervalTimer=W;class M{constructor(ee,ve){this.timeoutToken=-1,this.runner=ee,this.timeout=ve,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(ee=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,ee)}get delay(){return this.timeout}set delay(ee){this.timeout=ee}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=M;class S{constructor(ee,ve){ve%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ve}ms is not a multiple of 1000ms.`),this.runner=ee,this.timeout=ve,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(ee=this.timeout){ee%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(ee/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=S;class z extends M{constructor(ee,ve){super(ee,ve);this.units=[]}work(ee){this.units.push(ee),this.isScheduled()||this.schedule()}doRun(){const ee=this.units;this.units=[],this.runner?.(ee)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=z;class $ extends L.Disposable{constructor(ee,ve){super();this.options=ee,this.handler=ve,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(ee){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+ee.length>this.options.maxBufferedWork)return!1}else if(this.pending+ee.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...ee),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new M(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=$,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=be=>{(0,k.setTimeout0)(()=>{if(ee)return;const ve=Date.now()+15;be(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ve-Date.now())}}))});let ee=!1;return{dispose(){ee||(ee=!0)}}}:e.runWhenIdle=(be,ee)=>{const ve=requestIdleCallback(be,typeof ee=="number"?{timeout:ee}:void 0);let Ae=!1;return{dispose(){Ae||(Ae=!0,cancelIdleCallback(ve))}}}}();class F{constructor(ee){this._didRun=!1,this._executor=()=>{try{this._value=ee()}catch(ve){this._error=ve}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=F;async function q(be,ee,ve){let Ae;for(let Fe=0;Fe<ve;Fe++)try{return await be()}catch($e){Ae=$e,await n(ee)}throw Ae}e.retry=q;class ie{hasPending(ee){return this._pending?typeof ee=="number"?this._pending.taskId===ee:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(ee,ve,Ae){return this._pending={taskId:ee,cancel:()=>Ae?.(),promise:ve},ve.then(()=>this.donePending(ee),()=>this.donePending(ee)),ve}donePending(ee){this._pending&&ee===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const ee=this._next;this._next=void 0,ee.run().then(ee.promiseResolve,ee.promiseReject)}}setNext(ee){if(this._next)this._next.run=ee;else{let ve,Ae;const Fe=new Promise(($e,Qe)=>{ve=$e,Ae=Qe});this._next={run:ee,promise:Fe,promiseResolve:ve,promiseReject:Ae}}return this._next.promise}}e.TaskSequentializer=ie;class A{constructor(ee,ve=()=>Date.now()){this.interval=ee,this.nowFn=ve,this.lastIncrementTime=0,this.value=0}increment(){const ee=this.nowFn();return ee-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=ee,this.value=0),this.value++,this.value}}e.IntervalCounter=A;class Z{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((ee,ve)=>{this.completeCallback=ee,this.errorCallback=ve})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(ee){return new Promise(ve=>{this.completeCallback(ee),this.resolved=!0,ve()})}error(ee){return new Promise(ve=>{this.errorCallback(ee),this.rejected=!0,ve()})}cancel(){new Promise(ee=>{this.errorCallback(new p.CancellationError),this.rejected=!0,ee()})}}e.DeferredPromise=Z;var ce;(function(be){async function ee(Ae){let Fe;const $e=await Promise.all(Ae.map(Qe=>Qe.then(Ie=>Ie,Ie=>{Fe||(Fe=Ie)})));if(typeof Fe!="undefined")throw Fe;return $e}be.settled=ee;function ve(Ae){return new Promise(async(Fe,$e)=>{try{await Ae(Fe,$e)}catch(Qe){$e(Qe)}})}be.withAsyncBody=ve})(ce=e.Promises||(e.Promises={}));var oe;(function(be){be[be.Initial=0]="Initial",be[be.DoneOK=1]="DoneOK",be[be.DoneError=2]="DoneError"})(oe||(oe={}));class ue{constructor(ee){this._state=0,this._results=[],this._error=null,this._onStateChanged=new b.Emitter,queueMicrotask(async()=>{const ve={emitOne:Ae=>this.emitOne(Ae),emitMany:Ae=>this.emitMany(Ae),reject:Ae=>this.reject(Ae)};try{await Promise.resolve(ee(ve)),this.resolve()}catch(Ae){this.reject(Ae)}finally{ve.emitOne=void 0,ve.emitMany=void 0,ve.reject=void 0}})}static fromArray(ee){return new ue(ve=>{ve.emitMany(ee)})}static fromPromise(ee){return new ue(async ve=>{ve.emitMany(await ee)})}static fromPromises(ee){return new ue(async ve=>{await Promise.all(ee.map(async Ae=>ve.emitOne(await Ae)))})}static merge(ee){return new ue(async ve=>{await Promise.all(ee.map(async Ae=>{for await(const Fe of Ae)ve.emitOne(Fe)}))})}[Symbol.asyncIterator](){let ee=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(ee<this._results.length)return{done:!1,value:this._results[ee++]};if(this._state===1)return{done:!0,value:void 0};await b.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(ee,ve){return new ue(async Ae=>{for await(const Fe of ee)Ae.emitOne(ve(Fe))})}map(ee){return ue.map(this,ee)}static filter(ee,ve){return new ue(async Ae=>{for await(const Fe of ee)ve(Fe)&&Ae.emitOne(Fe)})}filter(ee){return ue.filter(this,ee)}static coalesce(ee){return ue.filter(ee,ve=>!!ve)}coalesce(){return ue.coalesce(this)}static async toPromise(ee){const ve=[];for await(const Ae of ee)ve.push(Ae);return ve}toPromise(){return ue.toPromise(this)}emitOne(ee){this._state===0&&(this._results.push(ee),this._onStateChanged.fire())}emitMany(ee){this._state===0&&(this._results=this._results.concat(ee),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(ee){this._state===0&&(this._state=2,this._error=ee,this._onStateChanged.fire())}}e.AsyncIterableObject=ue,ue.EMPTY=ue.fromArray([]);class te extends ue{constructor(ee,ve){super(ve);this._source=ee}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=te;function Ee(be){const ee=new a.CancellationTokenSource,ve=be(ee.token);return new te(ee,async Ae=>{const Fe=ee.token.onCancellationRequested(()=>{Fe.dispose(),ee.dispose(),Ae.reject(new p.CancellationError)});try{for await(const $e of ve){if(ee.token.isCancellationRequested)return;Ae.emitOne($e)}Fe.dispose(),ee.dispose()}catch($e){Fe.dispose(),ee.dispose(),Ae.reject($e)}})}e.createCancelableAsyncIterable=Ee}),define(ye[117],De([1,0,14,19]),function(ne,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const b=new a.IdleValue(()=>{const g=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:g,collatorIsNumeric:g.resolvedOptions().numeric}}),L=new a.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),D=new a.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(g,C,U=!1){const W=g||"",M=C||"",S=b.value.collator.compare(W,M);return b.value.collatorIsNumeric&&S===0&&W!==M?W<M?-1:1:S}e.compareFileNames=k;function E(g,C){const U=L.value.collator;return g=g||"",C=C||"",w(U,g,C)}e.compareFileNamesDefault=E;function P(g,C){const U=L.value.collator;return g=g||"",C=C||"",i(g,C)||w(U,g,C)}e.compareFileNamesUpper=P;function O(g,C){const U=L.value.collator;return g=g||"",C=C||"",n(g,C)||w(U,g,C)}e.compareFileNamesLower=O;function y(g,C){return g=g||"",C=C||"",g===C?0:g<C?-1:1}e.compareFileNamesUnicode=y;function m(g,C,U=!1){U||(g=g&&g.toLowerCase(),C=C&&C.toLowerCase());const[W,M]=R(g),[S,z]=R(C);return W!==S?W<S?-1:1:M===z?0:M<z?-1:1}e.noIntlCompareFileNames=m;function T(g,C){const[U,W]=R(g),[M,S]=R(C);let z=b.value.collator.compare(W,S);if(z===0){if(b.value.collatorIsNumeric&&W!==S)return W<S?-1:1;if(z=b.value.collator.compare(U,M),b.value.collatorIsNumeric&&z===0&&U!==M)return U<M?-1:1}return z}e.compareFileExtensions=T;function f(g,C){g=g||"",C=C||"";const U=c(g),W=c(C),M=L.value.collator,S=D.value.collator;return w(S,U,W)||w(M,g,C)}e.compareFileExtensionsDefault=f;function h(g,C){g=g||"",C=C||"";const U=c(g),W=c(C),M=L.value.collator,S=D.value.collator;return w(S,U,W)||i(g,C)||w(M,g,C)}e.compareFileExtensionsUpper=h;function d(g,C){g=g||"",C=C||"";const U=c(g),W=c(C),M=L.value.collator,S=D.value.collator;return w(S,U,W)||n(g,C)||w(M,g,C)}e.compareFileExtensionsLower=d;function o(g,C){g=g||"",C=C||"";const U=c(g).toLowerCase(),W=c(C).toLowerCase();return U!==W?U<W?-1:1:g!==C?g<C?-1:1:0}e.compareFileExtensionsUnicode=o;const v=/^(.*?)(\.([^.]*))?$/;function R(g,C=!1){const U=g?v.exec(g):[];let W=[U&&U[1]||"",U&&U[3]||""];return C&&(!W[0]&&W[1]||W[0]&&W[0].charAt(0)===".")&&(W=[W[0]+"."+W[1],""]),W}function c(g){const C=g?v.exec(g):[];return C&&C[1]&&C[1].charAt(0)!=="."&&C[3]||""}function w(g,C,U){const W=g.compare(C,U);return W!==0?W:C.length!==U.length?C.length<U.length?-1:1:0}function s(g){const C=g.charAt(0);return C.toLocaleUpperCase()!==C}function u(g){const C=g.charAt(0);return C.toLocaleLowerCase()!==C}function n(g,C){return s(g)&&u(C)?-1:u(g)&&s(C)?1:0}function i(g,C){return u(g)&&s(C)?-1:s(g)&&u(C)?1:0}function r(g,C,U=!1){return U||(g=g&&g.toLowerCase(),C=C&&C.toLowerCase()),g===C?0:g<C?-1:1}function t(g,C,U=!1){const W=g.split(p.sep),M=C.split(p.sep),S=W.length-1,z=M.length-1;let $,F;for(let q=0;;q++){if($=S===q,F=z===q,$&&F)return k(W[q],M[q],U);if($)return-1;if(F)return 1;const ie=r(W[q],M[q],U);if(ie!==0)return ie}}e.comparePaths=t;function l(g,C,U){const W=g.toLowerCase(),M=C.toLowerCase(),S=_(g,C,U);if(S)return S;const z=W.endsWith(U),$=M.endsWith(U);if(z!==$)return z?-1:1;const F=k(W,M);return F!==0?F:W.localeCompare(M)}e.compareAnything=l;function _(g,C,U){const W=g.toLowerCase(),M=C.toLowerCase(),S=W.startsWith(U),z=M.startsWith(U);if(S!==z)return S?-1:1;if(S&&z){if(W.length<M.length)return-1;if(W.length>M.length)return 1}return 0}e.compareByPrefix=_}),define(ye[34],De([1,0,16,14,37,25,19,21,9]),function(ne,e,a,p,b,L,D,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const O="[/\\\\]",y="[^/\\\\]",m=/\//g;function T(Z,ce){switch(Z){case 0:return"";case 1:return`${y}*?`;default:return`(?:${O}|${y}+${O}${ce?`|${O}${y}+`:""})*?`}}function f(Z,ce){if(!Z)return[];const oe=[];let ue=!1,te=!1,Ee="";for(const be of Z){switch(be){case ce:if(!ue&&!te){oe.push(Ee),Ee="";continue}break;case"{":ue=!0;break;case"}":ue=!1;break;case"[":te=!0;break;case"]":te=!1;break}Ee+=be}return Ee&&oe.push(Ee),oe}e.splitGlobAware=f;function h(Z){if(!Z)return"";let ce="";const oe=f(Z,e.GLOB_SPLIT);if(oe.every(ue=>ue===e.GLOBSTAR))ce=".*";else{let ue=!1;oe.forEach((te,Ee)=>{if(te===e.GLOBSTAR){if(ue)return;ce+=T(2,Ee===oe.length-1)}else{let be=!1,ee="",ve=!1,Ae="";for(const Fe of te){if(Fe!=="}"&&be){ee+=Fe;continue}if(ve&&(Fe!=="]"||!Ae)){let $e;Fe==="-"?$e=Fe:(Fe==="^"||Fe==="!")&&!Ae?$e="^":Fe===e.GLOB_SPLIT?$e="":$e=(0,E.escapeRegExpCharacters)(Fe),Ae+=$e;continue}switch(Fe){case"{":be=!0;continue;case"[":ve=!0;continue;case"}":{ce+=`(?:${f(ee,",").map(Ie=>h(Ie)).join("|")})`,be=!1,ee="";break}case"]":{ce+="["+Ae+"]",ve=!1,Ae="";break}case"?":ce+=y;continue;case"*":ce+=T(1);continue;default:ce+=(0,E.escapeRegExpCharacters)(Fe)}}Ee<oe.length-1&&(oe[Ee+1]!==e.GLOBSTAR||Ee+2<oe.length)&&(ce+=O)}ue=te===e.GLOBSTAR})}return ce}const d=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,R=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,w=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new L.LRUCache(1e4),u=function(){return!1},n=function(){return null};function i(Z,ce){if(!Z)return n;let oe;typeof Z!="string"?oe=Z.pattern:oe=Z,oe=oe.trim();const ue=`${oe}_${!!ce.trimForExclusions}`;let te=s.get(ue);if(te)return r(te,Z);let Ee;return d.test(oe)?te=l(oe.substr(4),oe):(Ee=o.exec(t(oe,ce)))?te=_(Ee[1],oe):(ce.trimForExclusions?R:v).test(oe)?te=g(oe,ce):(Ee=c.exec(t(oe,ce)))?te=C(Ee[1].substr(1),oe,!0):(Ee=w.exec(t(oe,ce)))?te=C(Ee[1],oe,!1):te=U(oe),s.set(ue,te),r(te,Z)}function r(Z,ce){if(typeof ce=="string")return Z;const oe=function(ue,te){return(0,b.isEqualOrParent)(ue,ce.base,!k.isLinux)?Z(ue.substr(ce.base.length+1),te):null};return oe.allBasenames=Z.allBasenames,oe.allPaths=Z.allPaths,oe.basenames=Z.basenames,oe.patterns=Z.patterns,oe}function t(Z,ce){return ce.trimForExclusions&&Z.endsWith("/**")?Z.substr(0,Z.length-2):Z}function l(Z,ce){return function(oe,ue){return typeof oe=="string"&&oe.endsWith(Z)?ce:null}}function _(Z,ce){const oe=`/${Z}`,ue=`\\${Z}`,te=function(be,ee){return typeof be!="string"?null:ee?ee===Z?ce:null:be===Z||be.endsWith(oe)||be.endsWith(ue)?ce:null},Ee=[Z];return te.basenames=Ee,te.patterns=[ce],te.allBasenames=Ee,te}function g(Z,ce){const oe=ie(Z.slice(1,-1).split(",").map(ee=>i(ee,ce)).filter(ee=>ee!==n),Z),ue=oe.length;if(!ue)return n;if(ue===1)return oe[0];const te=function(ee,ve){for(let Ae=0,Fe=oe.length;Ae<Fe;Ae++)if(oe[Ae](ee,ve))return Z;return null},Ee=oe.find(ee=>!!ee.allBasenames);Ee&&(te.allBasenames=Ee.allBasenames);const be=oe.reduce((ee,ve)=>ve.allPaths?ee.concat(ve.allPaths):ee,[]);return be.length&&(te.allPaths=be),te}function C(Z,ce,oe){const ue=D.sep===D.posix.sep,te=ue?Z:Z.replace(m,D.sep),Ee=D.sep+te,be=D.posix.sep+Z;let ee;return oe?ee=function(ve,Ae){return typeof ve=="string"&&(ve===te||ve.endsWith(Ee)||!ue&&(ve===Z||ve.endsWith(be)))?ce:null}:ee=function(ve,Ae){return typeof ve=="string"&&(ve===te||!ue&&ve===Z)?ce:null},ee.allPaths=[(oe?"*/":"./")+Z],ee}function U(Z){try{const ce=new RegExp(`^${h(Z)}$`);return function(oe){return ce.lastIndex=0,typeof oe=="string"&&ce.test(oe)?Z:null}}catch{return n}}function W(Z,ce,oe){return!Z||typeof ce!="string"?!1:M(Z)(ce,void 0,oe)}e.match=W;function M(Z,ce={}){if(!Z)return u;if(typeof Z=="string"||S(Z)){const oe=i(Z,ce);if(oe===n)return u;const ue=function(te,Ee){return!!oe(te,Ee)};return oe.allBasenames&&(ue.allBasenames=oe.allBasenames),oe.allPaths&&(ue.allPaths=oe.allPaths),ue}return F(Z,ce)}e.parse=M;function S(Z){const ce=Z;return ce?typeof ce.base=="string"&&typeof ce.pattern=="string":!1}e.isRelativePattern=S;function z(Z){return Z.allBasenames||[]}e.getBasenameTerms=z;function $(Z){return Z.allPaths||[]}e.getPathTerms=$;function F(Z,ce){const oe=ie(Object.getOwnPropertyNames(Z).map(ee=>q(ee,Z[ee],ce)).filter(ee=>ee!==n)),ue=oe.length;if(!ue)return n;if(!oe.some(ee=>!!ee.requiresSiblings)){if(ue===1)return oe[0];const ee=function(Fe,$e){let Qe;for(let Ie=0,Se=oe.length;Ie<Se;Ie++){const ke=oe[Ie](Fe,$e);if(typeof ke=="string")return ke;(0,p.isThenable)(ke)&&(Qe||(Qe=[]),Qe.push(ke))}return Qe?(async()=>{for(const Ie of Qe){const Se=await Ie;if(typeof Se=="string")return Se}return null})():null},ve=oe.find(Fe=>!!Fe.allBasenames);ve&&(ee.allBasenames=ve.allBasenames);const Ae=oe.reduce((Fe,$e)=>$e.allPaths?Fe.concat($e.allPaths):Fe,[]);return Ae.length&&(ee.allPaths=Ae),ee}const te=function(ee,ve,Ae){let Fe,$e;for(let Qe=0,Ie=oe.length;Qe<Ie;Qe++){const Se=oe[Qe];Se.requiresSiblings&&Ae&&(ve||(ve=(0,D.basename)(ee)),Fe||(Fe=ve.substr(0,ve.length-(0,D.extname)(ee).length)));const ke=Se(ee,ve,Fe,Ae);if(typeof ke=="string")return ke;(0,p.isThenable)(ke)&&($e||($e=[]),$e.push(ke))}return $e?(async()=>{for(const Qe of $e){const Ie=await Qe;if(typeof Ie=="string")return Ie}return null})():null},Ee=oe.find(ee=>!!ee.allBasenames);Ee&&(te.allBasenames=Ee.allBasenames);const be=oe.reduce((ee,ve)=>ve.allPaths?ee.concat(ve.allPaths):ee,[]);return be.length&&(te.allPaths=be),te}function q(Z,ce,oe){if(ce===!1)return n;const ue=i(Z,oe);if(ue===n)return n;if(typeof ce=="boolean")return ue;if(ce){const te=ce.when;if(typeof te=="string"){const Ee=(be,ee,ve,Ae)=>{if(!Ae||!ue(be,ee))return null;const Fe=te.replace("$(basename)",ve),$e=Ae(Fe);return(0,p.isThenable)($e)?$e.then(Qe=>Qe?Z:null):$e?Z:null};return Ee.requiresSiblings=!0,Ee}}return ue}function ie(Z,ce){const oe=Z.filter(ee=>!!ee.basenames);if(oe.length<2)return Z;const ue=oe.reduce((ee,ve)=>{const Ae=ve.basenames;return Ae?ee.concat(Ae):ee},[]);let te;if(ce){te=[];for(let ee=0,ve=ue.length;ee<ve;ee++)te.push(ce)}else te=oe.reduce((ee,ve)=>{const Ae=ve.patterns;return Ae?ee.concat(Ae):ee},[]);const Ee=function(ee,ve){if(typeof ee!="string")return null;if(!ve){let Fe;for(Fe=ee.length;Fe>0;Fe--){const $e=ee.charCodeAt(Fe-1);if($e===47||$e===92)break}ve=ee.substr(Fe)}const Ae=ue.indexOf(ve);return Ae!==-1?te[Ae]:null};Ee.basenames=ue,Ee.patterns=te,Ee.allBasenames=ue;const be=Z.filter(ee=>!ee.basenames);return be.push(Ee),be}function A(Z,ce){return(0,a.equals)(Z,ce,(oe,ue)=>typeof oe=="string"&&typeof ue=="string"?oe===ue:typeof oe!="string"&&typeof ue!="string"?oe.base===ue.base&&oe.pattern===ue.pattern:!1)}e.patternsEquals=A}),define(ye[75],De([1,0,11,115,22,9,2]),function(ne,e,a,p,b,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var k;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(k=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class E{constructor(o="",v=!1){if(this.value=o,typeof this.value!="string")throw(0,a.illegalArgument)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(o,v=0){return this.value+=m(this.supportThemeIcons?(0,p.escapeIcons)(o):o).replace(/([ \t]+)/g,(R,c)=>"&nbsp;".repeat(c.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(o){return this.value+=o,this}appendCodeblock(o,v){return this.value+="\n```",this.value+=o,this.value+=`
`,this.value+=v,this.value+="\n```\n",this}appendLink(o,v,R){return this.value+="[",this.value+=this._escape(v,"]"),this.value+="](",this.value+=this._escape(String(o),")"),R&&(this.value+=` "${this._escape(this._escape(R,'"'),")")}"`),this.value+=")",this}_escape(o,v){const R=new RegExp((0,L.escapeRegExpCharacters)(v),"g");return o.replace(R,(c,w)=>o.charAt(w-1)!=="\\"?`\\${c}`:c)}}e.MarkdownString=E;function P(d){return O(d)?!d.value:Array.isArray(d)?d.every(P):!0}e.isEmptyMarkdownString=P;function O(d){return d instanceof E?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}e.isMarkdownString=O;function y(d,o){return d===o?!0:!d||!o?!1:d.value===o.value&&d.isTrusted===o.isTrusted&&d.supportThemeIcons===o.supportThemeIcons&&d.supportHtml===o.supportHtml&&(d.baseUri===o.baseUri||!!d.baseUri&&!!o.baseUri&&(0,b.isEqual)(D.URI.from(d.baseUri),D.URI.from(o.baseUri)))}e.markdownStringEqual=y;function m(d){return d.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=m;function T(d){return d.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=T;function f(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=f;function h(d){const o=[],v=d.split("|").map(c=>c.trim());d=v[0];const R=v[1];if(R){const c=/height=(\d+)/.exec(R),w=/width=(\d+)/.exec(R),s=c?c[1]:"",u=w?w[1]:"",n=isFinite(parseInt(u)),i=isFinite(parseInt(s));n&&o.push(`width="${u}"`),i&&o.push(`height="${s}"`)}return{href:d,dimensions:o}}e.parseHrefAndDimensions=h}),define(ye[76],De([1,0,16,37,19,21,22,9]),function(ne,e,a,p,b,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function E(n,i){const{os:r,tildify:t,relative:l}=i;if(l){const C=P(n,l,r);if(typeof C=="string")return C}let _=n.fsPath;if(r===1&&!L.isWindows?_=_.replace(/\//g,"\\"):r!==1&&L.isWindows&&(_=_.replace(/\\/g,"/")),r!==1&&t?.userHome){const C=t.userHome.fsPath;let U;n.scheme!==t.userHome.scheme&&n.path.startsWith(b.posix.sep)?U=t.userHome.with({path:n.path}).fsPath:U=n.fsPath,_=m(U,C,r)}return(r===1?b.win32:b.posix).normalize(O(_,r===1))}e.getPathLabel=E;function P(n,i,r){const t=r===1?b.win32:b.posix,l=r===3?D.extUri:D.extUriIgnorePathCase,_=i.getWorkspace(),g=(0,a.firstOrDefault)(_.folders);if(!g)return;n.scheme!==g.uri.scheme&&n.path.startsWith(b.posix.sep)&&(n=g.uri.with({path:n.path}));const C=i.getWorkspaceFolder(n);if(!C)return;let U;if(l.isEqual(C.uri,n)?U="":U=l.relativePath(C.uri,n)??"",U&&(U=t.normalize(U)),_.folders.length>1&&!i.noPrefix){const W=C.name?C.name:l.basenameOrAuthority(C.uri);U=U?`${W} \u2022 ${U}`:W}return U}function O(n,i=L.isWindows){return(0,p.hasDriveLetter)(n,i)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=O;let y=Object.create(null);function m(n,i,r=L.OS){if(r===1||!n||!i)return n;let t=y.original===i?y.normalized:void 0;t||(t=i,L.isWindows&&(t=(0,p.toSlashes)(t)),t=`${(0,k.rtrim)(t,b.posix.sep)}${b.posix.sep}`,y={original:i,normalized:t});let l=n;return L.isWindows&&(l=(0,p.toSlashes)(l)),(r===3?l.startsWith(t):(0,k.startsWithIgnoreCase)(l,t))?`~/${l.substr(t.length)}`:n}e.tildify=m;function T(n,i){return n.replace(/^~($|\/|\\)/,`${i}$1`)}e.untildify=T;const f="\u2026",h="\\\\",d="~";function o(n,i=b.sep){const r=new Array(n.length);let t=!1;for(let l=0;l<n.length;l++){const _=n[l];if(_===""){r[l]=`.${i}`;continue}if(!_){r[l]=_;continue}t=!0;let g="",C=_;C.indexOf(h)===0?(g=C.substr(0,C.indexOf(h)+h.length),C=C.substr(C.indexOf(h)+h.length)):C.indexOf(i)===0?(g=C.substr(0,C.indexOf(i)+i.length),C=C.substr(C.indexOf(i)+i.length)):C.indexOf(d)===0&&(g=C.substr(0,C.indexOf(d)+d.length),C=C.substr(C.indexOf(d)+d.length));const U=C.split(i);for(let W=1;t&&W<=U.length;W++)for(let M=U.length-W;t&&M>=0;M--){t=!1;let S=U.slice(M,M+W).join(i);for(let z=0;!t&&z<n.length;z++)if(z!==l&&n[z]&&n[z].indexOf(S)>-1){const $=M+W===U.length,F=M>0&&n[z].indexOf(i)>-1?i+S:S,q=n[z].endsWith(F);t=!$||q}if(!t){let z="";(U[0].endsWith(":")||g!=="")&&(M===1&&(M=0,W++,S=U[0]+i+S),M>0&&(z=U[0]+i),z=g+z),M>0&&(z=z+f+i),z=z+S,M+W<U.length&&(z=z+i+f),r[l]=z}}t&&(r[l]=_)}return r}e.shorten=o;var v;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function R(n,i=Object.create(null)){const r=[];let t=!1,l="";for(const _ of n)if(_==="$"||t&&_==="{")l&&r.push({value:l,type:v.TEXT}),l="",t=!0;else if(_==="}"&&t){const g=i[l];if(typeof g=="string")g.length&&r.push({value:g,type:v.VARIABLE});else if(g){const C=r[r.length-1];(!C||C.type!==v.SEPARATOR)&&r.push({value:g.label,type:v.SEPARATOR})}l="",t=!1}else l+=_;return l&&!t&&r.push({value:l,type:v.TEXT}),r.filter((_,g)=>{if(_.type===v.SEPARATOR){const C=r[g-1],U=r[g+1];return[C,U].every(W=>W&&(W.type===v.VARIABLE||W.type===v.TEXT)&&W.value.length>0)}return!0}).map(_=>_.value).join("")}e.template=R;function c(n,i){return L.isMacintosh||i?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.isMacintosh?"&":"&&"):n.replace(/&&|&/g,r=>r==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function w(n,i){return L.isMacintosh||i?n.replace(/\(&&\w\)|&&/g,""):L.isWindows?n.replace(/&&|&/g,r=>r==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=w;function s(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=s;function u(n){const i=n.indexOf("/")!==-1?b.posix:b.win32,r=i.basename(n),t=i.dirname(n);return r.length?{name:r,parentPath:t}:{name:t,parentPath:""}}e.splitName=u}),define(ye[118],De([1,0,2]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function p(O){return O.toJSON()}class b{constructor(y){this._uriTransformer=y}transformIncoming(y){const m=this._uriTransformer.transformIncoming(y);return m===y?y:p(a.URI.from(m))}transformOutgoing(y){const m=this._uriTransformer.transformOutgoing(y);return m===y?y:p(a.URI.from(m))}transformOutgoingURI(y){const m=this._uriTransformer.transformOutgoing(y);return m===y?y:a.URI.from(m)}transformOutgoingScheme(y){return this._uriTransformer.transformOutgoingScheme(y)}}e.URITransformer=b,e.DefaultURITransformer=new class{transformIncoming(O){return O}transformOutgoing(O){return O}transformOutgoingURI(O){return O}transformOutgoingScheme(O){return O}};function L(O,y,m){if(!O||m>200)return null;if(typeof O=="object"){if(O instanceof a.URI)return y.transformOutgoing(O);for(const T in O)if(Object.hasOwnProperty.call(O,T)){const f=L(O[T],y,m+1);f!==null&&(O[T]=f)}}return null}function D(O,y){const m=L(O,y,0);return m===null?O:m}e.transformOutgoingURIs=D;function k(O,y,m,T){if(!O||T>200)return null;if(typeof O=="object"){if(O.$mid===1)return m?a.URI.revive(y.transformIncoming(O)):y.transformIncoming(O);for(const f in O)if(Object.hasOwnProperty.call(O,f)){const h=k(O[f],y,m,T+1);h!==null&&(O[f]=h)}}return null}function E(O,y){const m=k(O,y,!1,0);return m===null?O:m}e.transformIncomingURIs=E;function P(O,y){const m=k(O,y,!0,0);return m===null?O:m}e.transformAndReviveIncomingURIs=P}),define(ye[119],De([1,0,34,19]),function(ne,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function b(L,D,k,E,P,O){if(Array.isArray(L)){let y=0;for(const m of L){const T=b(m,D,k,E,P,O);if(T===10)return T;T>y&&(y=T)}return y}else{if(typeof L=="string")return E?L==="*"?5:L===k?10:0:0;if(L){const{language:y,pattern:m,scheme:T,hasAccessToAllModels:f,notebookType:h}=L;if(!E&&!f)return 0;h&&P&&(D=P);let d=0;if(T)if(T===D.scheme)d=10;else if(T==="*")d=5;else return 0;if(y)if(y===k)d=10;else if(y==="*")d=Math.max(d,5);else return 0;if(h)if(h===O)d=10;else if(h==="*"&&O!==void 0)d=Math.max(d,5);else return 0;if(m){let o;if(typeof m=="string"?o=m:o={...m,base:(0,p.normalize)(m.base)},o===D.fsPath||(0,a.match)(o,D.fsPath))d=10;else return 0}return d}else return 0}}e.score=b}),define(ye[77],De([1,0,23,21]),function(ne,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var b;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(b||(b={}));function L(y){for(let m=0,T=y.length;m<T;m+=4){const f=y[m+0],h=y[m+1],d=y[m+2],o=y[m+3];y[m+0]=o,y[m+1]=d,y[m+2]=h,y[m+3]=f}}function D(y){const m=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return p.isLittleEndian()||L(m),a.VSBuffer.wrap(m)}function k(y){const m=y.buffer;if(p.isLittleEndian()||L(m),m.byteOffset%4==0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const T=new Uint8Array(m.byteLength);return T.set(m),new Uint32Array(T.buffer,T.byteOffset,T.length/4)}}function E(y){const m=new Uint32Array(P(y));let T=0;if(m[T++]=y.id,y.type==="full")m[T++]=1,m[T++]=y.data.length,m.set(y.data,T),T+=y.data.length;else{m[T++]=2,m[T++]=y.deltas.length;for(const f of y.deltas)m[T++]=f.start,m[T++]=f.deleteCount,f.data?(m[T++]=f.data.length,m.set(f.data,T),T+=f.data.length):m[T++]=0}return D(m)}e.encodeSemanticTokensDto=E;function P(y){let m=0;if(m+=1+1,y.type==="full")m+=1+y.data.length;else{m+=1,m+=(1+1+1)*y.deltas.length;for(const T of y.deltas)T.data&&(m+=T.data.length)}return m}function O(y){const m=k(y);let T=0;const f=m[T++];if(m[T++]===1){const v=m[T++],R=m.subarray(T,T+v);return T+=v,{id:f,type:"full",data:R}}const d=m[T++],o=[];for(let v=0;v<d;v++){const R=m[T++],c=m[T++],w=m[T++];let s;w>0&&(s=m.subarray(T,T+w),T+=w),o[v]={start:R,deleteCount:c,data:s}}return{id:f,type:"delta",deltas:o}}e.decodeSemanticTokensDto=O}),define(ye[120],De([17,18]),function(ne,e){return ne.create("vs/editor/common/config/editorOptions",e)}),define(ye[121],De([1,0,120,21,122,16,26,109]),function(ne,e,a,p,b,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(K){K[K.None=0]="None",K[K.Keep=1]="Keep",K[K.Brackets=2]="Brackets",K[K.Advanced=3]="Advanced",K[K.Full=4]="Full"})(E=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class P{constructor(X){this._values=X}hasChanged(X){return this._values[X]}}e.ConfigurationChangedEvent=P;class O{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=O;class y{constructor(X,fe,Ue,He){this.id=X,this.name=fe,this.defaultValue=Ue,this.schema=He}applyUpdate(X,fe){return T(X,fe)}compute(X,fe,Ue){return Ue}}class m{constructor(X,fe){this.newValue=X,this.didChange=fe}}e.ApplyUpdateResult=m;function T(K,X){if(typeof K!="object"||typeof X!="object"||!K||!X)return new m(X,K!==X);if(Array.isArray(K)||Array.isArray(X)){const Ue=Array.isArray(K)&&Array.isArray(X)&&L.equals(K,X);return new m(X,!Ue)}let fe=!1;for(const Ue in X)if(X.hasOwnProperty(Ue)){const He=T(K[Ue],X[Ue]);He.didChange&&(K[Ue]=He.newValue,fe=!0)}return new m(K,fe)}class f{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,fe){return T(X,fe)}validate(X){return this.defaultValue}}class h{constructor(X,fe,Ue,He){this.id=X,this.name=fe,this.defaultValue=Ue,this.schema=He}applyUpdate(X,fe){return T(X,fe)}validate(X){return typeof X=="undefined"?this.defaultValue:X}compute(X,fe,Ue){return Ue}}function d(K,X){return typeof K=="undefined"?X:K==="false"?!1:Boolean(K)}e.boolean=d;class o extends h{constructor(X,fe,Ue,He=void 0){typeof He!="undefined"&&(He.type="boolean",He.default=Ue);super(X,fe,Ue,He)}validate(X){return d(X,this.defaultValue)}}function v(K,X,fe,Ue){if(typeof K=="undefined")return X;let He=parseInt(K,10);return isNaN(He)?X:(He=Math.max(fe,He),He=Math.min(Ue,He),He|0)}e.clampedInt=v;class R extends h{constructor(X,fe,Ue,He,Ze,qe=void 0){typeof qe!="undefined"&&(qe.type="integer",qe.default=Ue,qe.minimum=He,qe.maximum=Ze);super(X,fe,Ue,qe);this.minimum=He,this.maximum=Ze}static clampedInt(X,fe,Ue,He){return v(X,fe,Ue,He)}validate(X){return R.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}class c extends h{constructor(X,fe,Ue,He,Ze){typeof Ze!="undefined"&&(Ze.type="number",Ze.default=Ue);super(X,fe,Ue,Ze);this.validationFn=He}static clamp(X,fe,Ue){return X<fe?fe:X>Ue?Ue:X}static float(X,fe){if(typeof X=="number")return X;if(typeof X=="undefined")return fe;const Ue=parseFloat(X);return isNaN(Ue)?fe:Ue}validate(X){return this.validationFn(c.float(X,this.defaultValue))}}class w extends h{static string(X,fe){return typeof X!="string"?fe:X}constructor(X,fe,Ue,He=void 0){typeof He!="undefined"&&(He.type="string",He.default=Ue);super(X,fe,Ue,He)}validate(X){return w.string(X,this.defaultValue)}}function s(K,X,fe){return typeof K!="string"||fe.indexOf(K)===-1?X:K}e.stringSet=s;class u extends h{constructor(X,fe,Ue,He,Ze=void 0){typeof Ze!="undefined"&&(Ze.type="string",Ze.enum=He,Ze.default=Ue);super(X,fe,Ue,Ze);this._allowedValues=He}validate(X){return s(X,this.defaultValue,this._allowedValues)}}class n extends y{constructor(X,fe,Ue,He,Ze,qe,We=void 0){typeof We!="undefined"&&(We.type="string",We.enum=Ze,We.default=He);super(X,fe,Ue,We);this._allowedValues=Ze,this._convert=qe}validate(X){return typeof X!="string"?this.defaultValue:this._allowedValues.indexOf(X)===-1?this.defaultValue:this._convert(X)}}function i(K){switch(K){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class r extends y{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[a.localize(0,null),a.localize(1,null),a.localize(2,null)],default:"auto",description:a.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,fe,Ue){return Ue===0?X.accessibilitySupport:Ue}}class t extends y{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:a.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:a.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{insertSpace:d(fe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(fe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var l;(function(K){K[K.Hidden=0]="Hidden",K[K.Blink=1]="Blink",K[K.Smooth=2]="Smooth",K[K.Phase=3]="Phase",K[K.Expand=4]="Expand",K[K.Solid=5]="Solid"})(l=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function _(K){switch(K){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var g;(function(K){K[K.Line=1]="Line",K[K.Block=2]="Block",K[K.Underline=3]="Underline",K[K.LineThin=4]="LineThin",K[K.BlockOutline=5]="BlockOutline",K[K.UnderlineThin=6]="UnderlineThin"})(g=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function C(K){switch(K){case g.Line:return"line";case g.Block:return"block";case g.Underline:return"underline";case g.LineThin:return"line-thin";case g.BlockOutline:return"block-outline";case g.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=C;function U(K){switch(K){case"line":return g.Line;case"block":return g.Block;case"underline":return g.Underline;case"line-thin":return g.LineThin;case"block-outline":return g.BlockOutline;case"underline-thin":return g.UnderlineThin}}class W extends f{constructor(){super(130)}compute(X,fe,Ue){const He=["monaco-editor"];return fe.get(35)&&He.push(fe.get(35)),X.extraEditorClassName&&He.push(X.extraEditorClassName),fe.get(68)==="default"?He.push("mouse-default"):fe.get(68)==="copy"&&He.push("mouse-copy"),fe.get(102)&&He.push("showUnused"),fe.get(128)&&He.push("showDeprecated"),He.join(" ")}}class M extends o{constructor(){super(33,"emptySelectionClipboard",!0,{description:a.localize(6,null)})}compute(X,fe,Ue){return Ue&&X.emptySelectionClipboard}}class S extends y{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(37,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:a.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[a.localize(8,null),a.localize(9,null),a.localize(10,null)],description:a.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[a.localize(12,null),a.localize(13,null),a.localize(14,null)],description:a.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:a.localize(16,null),included:p.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:a.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:a.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{cursorMoveOnType:d(fe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":s(fe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":s(fe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(fe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(fe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(fe.loop,this.defaultValue.loop)}}}class z extends y{constructor(){super(47,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:a.localize(19,null)},{type:"string",description:a.localize(20,null)}],description:a.localize(21,null),default:!1})}validate(X){return typeof X=="undefined"?this.defaultValue:typeof X=="string"?X==="false"?z.OFF:X==="true"?z.ON:X:Boolean(X)?z.ON:z.OFF}}e.EditorFontLigatures=z,z.OFF='"liga" off, "calt" off',z.ON='"liga" on, "calt" on';class $ extends f{constructor(){super(46)}compute(X,fe,Ue){return X.fontInfo}}class F extends h{constructor(){super(48,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:a.localize(22,null)})}validate(X){const fe=c.float(X,this.defaultValue);return fe===0?e.EDITOR_FONT_DEFAULTS.fontSize:c.clamp(fe,6,100)}compute(X,fe,Ue){return X.fontInfo.fontSize}}class q extends y{constructor(){super(49,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:q.MINIMUM_VALUE,maximum:q.MAXIMUM_VALUE,errorMessage:a.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:q.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:a.localize(24,null)})}validate(X){return X==="normal"||X==="bold"?X:String(R.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,q.MINIMUM_VALUE,q.MAXIMUM_VALUE))}}q.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],q.MINIMUM_VALUE=1,q.MAXIMUM_VALUE=1e3;class ie extends y{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},fe={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[a.localize(25,null),a.localize(26,null),a.localize(27,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(53,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:a.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:a.localize(29,null),...fe},"editor.gotoLocation.multipleTypeDefinitions":{description:a.localize(30,null),...fe},"editor.gotoLocation.multipleDeclarations":{description:a.localize(31,null),...fe},"editor.gotoLocation.multipleImplementations":{description:a.localize(32,null),...fe},"editor.gotoLocation.multipleReferences":{description:a.localize(33,null),...fe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:Ue,description:a.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:Ue,description:a.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:Ue,description:a.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:Ue,description:a.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:Ue,description:a.localize(38,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{multiple:s(fe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:fe.multipleDefinitions??s(fe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:fe.multipleTypeDefinitions??s(fe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:fe.multipleDeclarations??s(fe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:fe.multipleImplementations??s(fe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:fe.multipleReferences??s(fe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:w.string(fe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:w.string(fe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:w.string(fe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:w.string(fe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:w.string(fe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class A extends y{constructor(){const X={enabled:!0,delay:300,sticky:!0,above:!0};super(55,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:a.localize(39,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:a.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:a.localize(41,null)},"editor.hover.above":{type:"boolean",default:X.above,description:a.localize(42,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:d(fe.enabled,this.defaultValue.enabled),delay:R.clampedInt(fe.delay,this.defaultValue.delay,0,1e4),sticky:d(fe.sticky,this.defaultValue.sticky),above:d(fe.above,this.defaultValue.above)}}}var Z;(function(K){K[K.None=0]="None",K[K.Text=1]="Text",K[K.Blocks=2]="Blocks"})(Z=e.RenderMinimap||(e.RenderMinimap={}));class ce extends f{constructor(){super(133)}compute(X,fe,Ue){return ce.computeLayout(fe,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio})}static computeContainedMinimapLineCount(X){const fe=X.height/X.lineHeight,Ue=X.scrollBeyondLastLine?fe-1:0,He=(X.viewLineCount+Ue)/(X.pixelRatio*X.height),Ze=Math.floor(X.viewLineCount/He);return{typicalViewportLineCount:fe,extraLinesBeyondLastLine:Ue,desiredRatio:He,minimapLineCount:Ze}}static _computeMinimapLayout(X,fe){const Ue=X.outerWidth,He=X.outerHeight,Ze=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ze*He),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:He};const qe=fe.stableMinimapLayoutInput,We=qe&&X.outerHeight===qe.outerHeight&&X.lineHeight===qe.lineHeight&&X.typicalHalfwidthCharacterWidth===qe.typicalHalfwidthCharacterWidth&&X.pixelRatio===qe.pixelRatio&&X.scrollBeyondLastLine===qe.scrollBeyondLastLine&&X.minimap.enabled===qe.minimap.enabled&&X.minimap.side===qe.minimap.side&&X.minimap.size===qe.minimap.size&&X.minimap.showSlider===qe.minimap.showSlider&&X.minimap.renderCharacters===qe.minimap.renderCharacters&&X.minimap.maxColumn===qe.minimap.maxColumn&&X.minimap.scale===qe.minimap.scale&&X.verticalScrollbarWidth===qe.verticalScrollbarWidth&&X.isViewportWrapping===qe.isViewportWrapping,nt=X.lineHeight,ot=X.typicalHalfwidthCharacterWidth,ht=X.scrollBeyondLastLine,kt=X.minimap.renderCharacters;let it=Ze>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const dt=X.minimap.maxColumn,Ot=X.minimap.size,Wt=X.minimap.side,Dt=X.verticalScrollbarWidth,ft=X.viewLineCount,Ct=X.remainingWidth,Lt=X.isViewportWrapping,Ft=kt?2:3;let Ve=Math.floor(Ze*He);const Nt=Ve/Ze;let Rt=!1,Ut=!1,vt=Ft*it,we=it/Ze,Ce=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:je,extraLinesBeyondLastLine:ut,desiredRatio:gt,minimapLineCount:yt}=ce.computeContainedMinimapLineCount({viewLineCount:ft,scrollBeyondLastLine:ht,height:He,lineHeight:nt,pixelRatio:Ze});if(ft/yt>1)Rt=!0,Ut=!0,it=1,vt=1,we=it/Ze;else{let _t=!1,Pt=it+1;if(Ot==="fit"){const mt=Math.ceil((ft+ut)*vt);Lt&&We&&Ct<=fe.stableFitRemainingWidth?(_t=!0,Pt=fe.stableFitMaxMinimapScale):_t=mt>Ve}if(Ot==="fill"||_t){Rt=!0;const mt=it;vt=Math.min(nt*Ze,Math.max(1,Math.floor(1/gt))),Lt&&We&&Ct<=fe.stableFitRemainingWidth&&(Pt=fe.stableFitMaxMinimapScale),it=Math.min(Pt,Math.max(1,Math.floor(vt/Ft))),it>mt&&(Ce=Math.min(2,it/mt)),we=it/Ze/Ce,Ve=Math.ceil(Math.max(je,ft+ut)*vt),Lt?(fe.stableMinimapLayoutInput=X,fe.stableFitRemainingWidth=Ct,fe.stableFitMaxMinimapScale=it):(fe.stableMinimapLayoutInput=null,fe.stableFitRemainingWidth=0)}}}const me=Math.floor(dt*we),j=Math.min(me,Math.max(0,Math.floor((Ct-Dt-2)*we/(ot+we)))+e.MINIMAP_GUTTER_WIDTH);let Pe=Math.floor(Ze*j);const Le=Pe/Ze;Pe=Math.floor(Pe*Ce);const tt=kt?1:2,Xe=Wt==="left"?0:Ue-j-Dt;return{renderMinimap:tt,minimapLeft:Xe,minimapWidth:j,minimapHeightIsEditorHeight:Rt,minimapIsSampling:Ut,minimapScale:it,minimapLineHeight:vt,minimapCanvasInnerWidth:Pe,minimapCanvasInnerHeight:Ve,minimapCanvasOuterWidth:Le,minimapCanvasOuterHeight:Nt}}static computeLayout(X,fe){const Ue=fe.outerWidth|0,He=fe.outerHeight|0,Ze=fe.lineHeight|0,qe=fe.lineNumbersDigitCount|0,We=fe.typicalHalfwidthCharacterWidth,nt=fe.maxDigitWidth,ot=fe.pixelRatio,ht=fe.viewLineCount,kt=X.get(125),it=kt==="inherit"?X.get(124):kt,dt=it==="inherit"?X.get(120):it,Ot=X.get(123),Wt=X.get(2),Dt=fe.isDominatedByLongLines,ft=X.get(52),Ct=X.get(62).renderType!==0,Lt=X.get(63),Ft=X.get(96),Ve=X.get(67),Nt=X.get(94),Rt=Nt.verticalScrollbarSize,Ut=Nt.verticalHasArrows,vt=Nt.arrowSize,we=Nt.horizontalScrollbarSize,Ce=X.get(60),me=X.get(39),j=X.get(101)!=="never";let Pe;if(typeof Ce=="string"&&/^\d+(\.\d+)?ch$/.test(Ce)){const Ht=parseFloat(Ce.substr(0,Ce.length-2));Pe=R.clampedInt(Ht*We,0,0,1e3)}else Pe=R.clampedInt(Ce,0,0,1e3);me&&j&&(Pe+=16);let Le=0;if(Ct){const Ht=Math.max(qe,Lt);Le=Math.round(Ht*nt)}let tt=0;ft&&(tt=Ze);let Xe=0,je=Xe+tt,ut=je+Le,gt=ut+Pe;const yt=Ue-tt-Le-Pe;let pt=!1,_t=!1,Pt=-1;Wt!==2&&(it==="inherit"&&Dt?(pt=!0,_t=!0):dt==="on"||dt==="bounded"?_t=!0:dt==="wordWrapColumn"&&(Pt=Ot));const mt=ce._computeMinimapLayout({outerWidth:Ue,outerHeight:He,lineHeight:Ze,typicalHalfwidthCharacterWidth:We,pixelRatio:ot,scrollBeyondLastLine:Ft,minimap:Ve,verticalScrollbarWidth:Rt,viewLineCount:ht,remainingWidth:yt,isViewportWrapping:_t},fe.memory||new O);mt.renderMinimap!==0&&mt.minimapLeft===0&&(Xe+=mt.minimapWidth,je+=mt.minimapWidth,ut+=mt.minimapWidth,gt+=mt.minimapWidth);const Yt=yt-mt.minimapWidth,Jt=Math.max(1,Math.floor((Yt-Rt-2)/We)),bt=Ut?vt:0;return _t&&(Pt=Math.max(1,Jt),dt==="bounded"&&(Pt=Math.min(Pt,Ot))),{width:Ue,height:He,glyphMarginLeft:Xe,glyphMarginWidth:tt,lineNumbersLeft:je,lineNumbersWidth:Le,decorationsLeft:ut,decorationsWidth:Pe,contentLeft:gt,contentWidth:Yt,minimap:mt,viewportColumn:Jt,isWordWrapMinified:pt,isViewportWrapping:_t,wrappingColumn:Pt,verticalScrollbarWidth:Rt,horizontalScrollbarHeight:we,overviewRuler:{top:bt,width:Rt,height:He-2*bt,right:0}}}}e.EditorLayoutInfoComputer=ce;class oe extends y{constructor(){const X={enabled:!0};super(59,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:a.localize(43,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:d(X.enabled,this.defaultValue.enabled)}}}class ue extends y{constructor(){const X={stickyScroll:{enabled:!1}};super(34,"experimental",X,{"editor.experimental.stickyScroll.enabled":{type:"boolean",default:X.stickyScroll.enabled,description:a.localize(44,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{stickyScroll:{enabled:d(X.stickyScroll?.enabled,this.defaultValue.stickyScroll.enabled)}}}}class te extends y{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(129,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:a.localize(45,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[a.localize(46,null),a.localize(47,null),a.localize(48,null),a.localize(49,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:a.localize(50,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:a.localize(51,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:a.localize(52,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return typeof fe.enabled=="boolean"&&(fe.enabled=fe.enabled?"on":"off"),{enabled:s(fe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:R.clampedInt(fe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:w.string(fe.fontFamily,this.defaultValue.fontFamily),padding:d(fe.padding,this.defaultValue.padding)}}}class Ee extends c{constructor(){super(61,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>c.clamp(X,0,150),{markdownDescription:a.localize(53,null)})}compute(X,fe,Ue){return X.fontInfo.lineHeight}}class be extends y{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(67,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:a.localize(54,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:a.localize(55,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[a.localize(56,null),a.localize(57,null),a.localize(58,null)],default:X.size,description:a.localize(59,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:a.localize(60,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:a.localize(61,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:a.localize(62,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:a.localize(63,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:a.localize(64,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:d(fe.enabled,this.defaultValue.enabled),autohide:d(fe.autohide,this.defaultValue.autohide),size:s(fe.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(fe.side,this.defaultValue.side,["right","left"]),showSlider:s(fe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(fe.renderCharacters,this.defaultValue.renderCharacters),scale:R.clampedInt(fe.scale,1,1,3),maxColumn:R.clampedInt(fe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ee(K){return K==="ctrlCmd"?p.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ve extends y{constructor(){super(77,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(65,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(66,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{top:R.clampedInt(fe.top,0,0,1e3),bottom:R.clampedInt(fe.bottom,0,0,1e3)}}}class Ae extends y{constructor(){const X={enabled:!0,cycle:!1};super(78,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:a.localize(67,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:a.localize(68,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:d(fe.enabled,this.defaultValue.enabled),cycle:d(fe.cycle,this.defaultValue.cycle)}}}class Fe extends f{constructor(){super(131)}compute(X,fe,Ue){return X.pixelRatio}}class $e extends y{constructor(){const X={other:"on",comments:"off",strings:"off"},fe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[a.localize(69,null),a.localize(70,null),a.localize(71,null)]}];super(81,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:fe,default:X.strings,description:a.localize(72,null)},comments:{anyOf:fe,default:X.comments,description:a.localize(73,null)},other:{anyOf:fe,default:X.other,description:a.localize(74,null)}},default:X,markdownDescription:a.localize(75,null,"#editor.suggestOnTriggerCharacters#")});this.defaultValue=X}validate(X){if(typeof X=="boolean"){const ot=X?"on":"off";return{comments:ot,strings:ot,other:ot}}if(!X||typeof X!="object")return this.defaultValue;const{other:fe,comments:Ue,strings:He}=X,Ze=["on","inline","off"];let qe,We,nt;return typeof fe=="boolean"?qe=fe?"on":"off":qe=s(fe,this.defaultValue.other,Ze),typeof Ue=="boolean"?We=Ue?"on":"off":We=s(Ue,this.defaultValue.comments,Ze),typeof He=="boolean"?nt=He?"on":"off":nt=s(He,this.defaultValue.strings,Ze),{other:qe,comments:We,strings:nt}}}var Qe;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative",K[K.Interval=3]="Interval",K[K.Custom=4]="Custom"})(Qe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ie extends y{constructor(){super(62,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[a.localize(76,null),a.localize(77,null),a.localize(78,null),a.localize(79,null)],default:"on",description:a.localize(80,null)})}validate(X){let fe=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof X!="undefined"&&(typeof X=="function"?(fe=4,Ue=X):X==="interval"?fe=3:X==="relative"?fe=2:X==="on"?fe=1:fe=0),{renderType:fe,renderFn:Ue}}}function Se(K){const X=K.get(89);return X==="editable"?K.get(83):X!=="on"}e.filterValidationDecorations=Se;class ke extends y{constructor(){const X=[],fe={type:"number",description:a.localize(81,null)};super(93,"rulers",X,{type:"array",items:{anyOf:[fe,{type:["object"],properties:{column:fe,color:{type:"string",description:a.localize(82,null),format:"color-hex"}}}]},default:X,description:a.localize(83,null)})}validate(X){if(Array.isArray(X)){const fe=[];for(const Ue of X)if(typeof Ue=="number")fe.push({column:R.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const He=Ue;fe.push({column:R.clampedInt(He.column,0,0,1e4),color:He.color})}return fe.sort((Ue,He)=>Ue.column-He.column),fe}return this.defaultValue}}function ae(K,X){if(typeof K!="string")return X;switch(K){case"hidden":return 2;case"visible":return 3;default:return 1}}class le extends y{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(94,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(84,null),a.localize(85,null),a.localize(86,null)],default:"auto",description:a.localize(87,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(88,null),a.localize(89,null),a.localize(90,null)],default:"auto",description:a.localize(91,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:a.localize(92,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:a.localize(93,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:a.localize(94,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X,Ue=R.clampedInt(fe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),He=R.clampedInt(fe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:R.clampedInt(fe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ae(fe.vertical,this.defaultValue.vertical),horizontal:ae(fe.horizontal,this.defaultValue.horizontal),useShadows:d(fe.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(fe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(fe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(fe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(fe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:R.clampedInt(fe.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:He,verticalSliderSize:R.clampedInt(fe.verticalSliderSize,He,0,1e3),scrollByPage:d(fe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class G extends y{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(115,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:a.localize(95,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:a.localize(96,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:a.localize(97,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:a.localize(98,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:a.localize(99,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:a.localize(100,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:a.localize(101,null)}})}applyUpdate(X,fe){let Ue=!1;fe.allowedCharacters&&X&&(D.equals(X.allowedCharacters,fe.allowedCharacters)||(X={...X,allowedCharacters:fe.allowedCharacters},Ue=!0)),fe.allowedLocales&&X&&(D.equals(X.allowedLocales,fe.allowedLocales)||(X={...X,allowedLocales:fe.allowedLocales},Ue=!0));const He=super.applyUpdate(X,fe);return Ue?new m(He.newValue,!0):He}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{nonBasicASCII:H(fe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:d(fe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:d(fe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:H(fe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:H(fe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(X.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(X,fe){if(typeof X!="object"||!X)return fe;const Ue={};for(const[He,Ze]of Object.entries(X))Ze===!0&&(Ue[He]=!0);return Ue}}class Q extends y{constructor(){const X={enabled:!0,mode:"subwordSmart"};super(57,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:a.localize(102,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:d(fe.enabled,this.defaultValue.enabled),mode:s(fe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class I extends y{constructor(){const X={enabled:k.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:k.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:a.localize(103,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:a.localize(104,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:d(fe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:d(fe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class B extends y{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(105,null),a.localize(106,null),a.localize(107,null)],default:X.bracketPairs,description:a.localize(108,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(109,null),a.localize(110,null),a.localize(111,null)],default:X.bracketPairsHorizontal,description:a.localize(112,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:a.localize(113,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:a.localize(114,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[a.localize(115,null),a.localize(116,null),a.localize(117,null)],default:X.highlightActiveIndentation,description:a.localize(118,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{bracketPairs:H(fe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:H(fe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:d(fe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:d(fe.indentation,this.defaultValue.indentation),highlightActiveIndentation:H(fe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function H(K,X,fe){const Ue=fe.indexOf(K);return Ue===-1?X:fe[Ue]}class V extends y{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(108,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[a.localize(119,null),a.localize(120,null)],default:X.insertMode,description:a.localize(121,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:a.localize(122,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:a.localize(123,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:a.localize(124,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:a.localize(125,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:a.localize(126,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:a.localize(127,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:a.localize(128,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:a.localize(129,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:a.localize(130,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:a.localize(131,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:a.localize(132,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:a.localize(133,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:a.localize(134,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:a.localize(135,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:a.localize(136,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:a.localize(137,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:a.localize(138,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:a.localize(139,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:a.localize(140,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:a.localize(141,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:a.localize(142,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:a.localize(143,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:a.localize(144,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:a.localize(145,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:a.localize(146,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:a.localize(147,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:a.localize(148,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:a.localize(149,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:a.localize(150,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:a.localize(151,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:a.localize(152,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:a.localize(153,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:a.localize(154,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:a.localize(155,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:a.localize(156,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:a.localize(157,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:a.localize(158,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:a.localize(159,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:a.localize(160,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{insertMode:s(fe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(fe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(fe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(fe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(fe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:d(fe.showIcons,this.defaultValue.showIcons),showStatusBar:d(fe.showStatusBar,this.defaultValue.showStatusBar),preview:d(fe.preview,this.defaultValue.preview),previewMode:s(fe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:d(fe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(fe.showMethods,this.defaultValue.showMethods),showFunctions:d(fe.showFunctions,this.defaultValue.showFunctions),showConstructors:d(fe.showConstructors,this.defaultValue.showConstructors),showDeprecated:d(fe.showDeprecated,this.defaultValue.showDeprecated),showFields:d(fe.showFields,this.defaultValue.showFields),showVariables:d(fe.showVariables,this.defaultValue.showVariables),showClasses:d(fe.showClasses,this.defaultValue.showClasses),showStructs:d(fe.showStructs,this.defaultValue.showStructs),showInterfaces:d(fe.showInterfaces,this.defaultValue.showInterfaces),showModules:d(fe.showModules,this.defaultValue.showModules),showProperties:d(fe.showProperties,this.defaultValue.showProperties),showEvents:d(fe.showEvents,this.defaultValue.showEvents),showOperators:d(fe.showOperators,this.defaultValue.showOperators),showUnits:d(fe.showUnits,this.defaultValue.showUnits),showValues:d(fe.showValues,this.defaultValue.showValues),showConstants:d(fe.showConstants,this.defaultValue.showConstants),showEnums:d(fe.showEnums,this.defaultValue.showEnums),showEnumMembers:d(fe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(fe.showKeywords,this.defaultValue.showKeywords),showWords:d(fe.showWords,this.defaultValue.showWords),showColors:d(fe.showColors,this.defaultValue.showColors),showFiles:d(fe.showFiles,this.defaultValue.showFiles),showReferences:d(fe.showReferences,this.defaultValue.showReferences),showFolders:d(fe.showFolders,this.defaultValue.showFolders),showTypeParameters:d(fe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(fe.showSnippets,this.defaultValue.showSnippets),showUsers:d(fe.showUsers,this.defaultValue.showUsers),showIssues:d(fe.showIssues,this.defaultValue.showIssues)}}}class se extends y{constructor(){super(104,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:a.localize(161,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class de extends f{constructor(){super(132)}compute(X,fe,Ue){return fe.get(83)?!0:X.tabFocusMode}}var J;(function(K){K[K.None=0]="None",K[K.Same=1]="Same",K[K.Indent=2]="Indent",K[K.DeepIndent=3]="DeepIndent"})(J=e.WrappingIndent||(e.WrappingIndent={}));function pe(K){switch(K){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ge extends f{constructor(){super(134)}compute(X,fe,Ue){const He=fe.get(133);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:He.isWordWrapMinified,isViewportWrapping:He.isViewportWrapping,wrappingColumn:He.wrappingColumn}}}class Ne extends y{constructor(){const X={enabled:!0};super(32,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:a.localize(162,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:d(X.enabled,this.defaultValue.enabled)}}}const Be="Consolas, 'Courier New', monospace",Je="Menlo, Monaco, 'Courier New', monospace",Ge="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:p.isMacintosh?Je:p.isLinux?Ge:Be,fontWeight:"normal",fontSize:p.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Te(K){return e.editorOptionsRegistry[K.id]=K,K}var rt;(function(K){K[K.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",K[K.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",K[K.accessibilitySupport=2]="accessibilitySupport",K[K.accessibilityPageSize=3]="accessibilityPageSize",K[K.ariaLabel=4]="ariaLabel",K[K.autoClosingBrackets=5]="autoClosingBrackets",K[K.autoClosingDelete=6]="autoClosingDelete",K[K.autoClosingOvertype=7]="autoClosingOvertype",K[K.autoClosingQuotes=8]="autoClosingQuotes",K[K.autoIndent=9]="autoIndent",K[K.automaticLayout=10]="automaticLayout",K[K.autoSurround=11]="autoSurround",K[K.bracketPairColorization=12]="bracketPairColorization",K[K.guides=13]="guides",K[K.codeLens=14]="codeLens",K[K.codeLensFontFamily=15]="codeLensFontFamily",K[K.codeLensFontSize=16]="codeLensFontSize",K[K.colorDecorators=17]="colorDecorators",K[K.columnSelection=18]="columnSelection",K[K.comments=19]="comments",K[K.contextmenu=20]="contextmenu",K[K.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",K[K.cursorBlinking=22]="cursorBlinking",K[K.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",K[K.cursorStyle=24]="cursorStyle",K[K.cursorSurroundingLines=25]="cursorSurroundingLines",K[K.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",K[K.cursorWidth=27]="cursorWidth",K[K.disableLayerHinting=28]="disableLayerHinting",K[K.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",K[K.domReadOnly=30]="domReadOnly",K[K.dragAndDrop=31]="dragAndDrop",K[K.dropIntoEditor=32]="dropIntoEditor",K[K.emptySelectionClipboard=33]="emptySelectionClipboard",K[K.experimental=34]="experimental",K[K.extraEditorClassName=35]="extraEditorClassName",K[K.fastScrollSensitivity=36]="fastScrollSensitivity",K[K.find=37]="find",K[K.fixedOverflowWidgets=38]="fixedOverflowWidgets",K[K.folding=39]="folding",K[K.foldingStrategy=40]="foldingStrategy",K[K.foldingHighlight=41]="foldingHighlight",K[K.foldingImportsByDefault=42]="foldingImportsByDefault",K[K.foldingMaximumRegions=43]="foldingMaximumRegions",K[K.unfoldOnClickAfterEndOfLine=44]="unfoldOnClickAfterEndOfLine",K[K.fontFamily=45]="fontFamily",K[K.fontInfo=46]="fontInfo",K[K.fontLigatures=47]="fontLigatures",K[K.fontSize=48]="fontSize",K[K.fontWeight=49]="fontWeight",K[K.formatOnPaste=50]="formatOnPaste",K[K.formatOnType=51]="formatOnType",K[K.glyphMargin=52]="glyphMargin",K[K.gotoLocation=53]="gotoLocation",K[K.hideCursorInOverviewRuler=54]="hideCursorInOverviewRuler",K[K.hover=55]="hover",K[K.inDiffEditor=56]="inDiffEditor",K[K.inlineSuggest=57]="inlineSuggest",K[K.letterSpacing=58]="letterSpacing",K[K.lightbulb=59]="lightbulb",K[K.lineDecorationsWidth=60]="lineDecorationsWidth",K[K.lineHeight=61]="lineHeight",K[K.lineNumbers=62]="lineNumbers",K[K.lineNumbersMinChars=63]="lineNumbersMinChars",K[K.linkedEditing=64]="linkedEditing",K[K.links=65]="links",K[K.matchBrackets=66]="matchBrackets",K[K.minimap=67]="minimap",K[K.mouseStyle=68]="mouseStyle",K[K.mouseWheelScrollSensitivity=69]="mouseWheelScrollSensitivity",K[K.mouseWheelZoom=70]="mouseWheelZoom",K[K.multiCursorMergeOverlapping=71]="multiCursorMergeOverlapping",K[K.multiCursorModifier=72]="multiCursorModifier",K[K.multiCursorPaste=73]="multiCursorPaste",K[K.occurrencesHighlight=74]="occurrencesHighlight",K[K.overviewRulerBorder=75]="overviewRulerBorder",K[K.overviewRulerLanes=76]="overviewRulerLanes",K[K.padding=77]="padding",K[K.parameterHints=78]="parameterHints",K[K.peekWidgetDefaultFocus=79]="peekWidgetDefaultFocus",K[K.definitionLinkOpensInPeek=80]="definitionLinkOpensInPeek",K[K.quickSuggestions=81]="quickSuggestions",K[K.quickSuggestionsDelay=82]="quickSuggestionsDelay",K[K.readOnly=83]="readOnly",K[K.renameOnType=84]="renameOnType",K[K.renderControlCharacters=85]="renderControlCharacters",K[K.renderFinalNewline=86]="renderFinalNewline",K[K.renderLineHighlight=87]="renderLineHighlight",K[K.renderLineHighlightOnlyWhenFocus=88]="renderLineHighlightOnlyWhenFocus",K[K.renderValidationDecorations=89]="renderValidationDecorations",K[K.renderWhitespace=90]="renderWhitespace",K[K.revealHorizontalRightPadding=91]="revealHorizontalRightPadding",K[K.roundedSelection=92]="roundedSelection",K[K.rulers=93]="rulers",K[K.scrollbar=94]="scrollbar",K[K.scrollBeyondLastColumn=95]="scrollBeyondLastColumn",K[K.scrollBeyondLastLine=96]="scrollBeyondLastLine",K[K.scrollPredominantAxis=97]="scrollPredominantAxis",K[K.selectionClipboard=98]="selectionClipboard",K[K.selectionHighlight=99]="selectionHighlight",K[K.selectOnLineNumbers=100]="selectOnLineNumbers",K[K.showFoldingControls=101]="showFoldingControls",K[K.showUnused=102]="showUnused",K[K.snippetSuggestions=103]="snippetSuggestions",K[K.smartSelect=104]="smartSelect",K[K.smoothScrolling=105]="smoothScrolling",K[K.stickyTabStops=106]="stickyTabStops",K[K.stopRenderingLineAfter=107]="stopRenderingLineAfter",K[K.suggest=108]="suggest",K[K.suggestFontSize=109]="suggestFontSize",K[K.suggestLineHeight=110]="suggestLineHeight",K[K.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",K[K.suggestSelection=112]="suggestSelection",K[K.tabCompletion=113]="tabCompletion",K[K.tabIndex=114]="tabIndex",K[K.unicodeHighlighting=115]="unicodeHighlighting",K[K.unusualLineTerminators=116]="unusualLineTerminators",K[K.useShadowDOM=117]="useShadowDOM",K[K.useTabStops=118]="useTabStops",K[K.wordSeparators=119]="wordSeparators",K[K.wordWrap=120]="wordWrap",K[K.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",K[K.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",K[K.wordWrapColumn=123]="wordWrapColumn",K[K.wordWrapOverride1=124]="wordWrapOverride1",K[K.wordWrapOverride2=125]="wordWrapOverride2",K[K.wrappingIndent=126]="wrappingIndent",K[K.wrappingStrategy=127]="wrappingStrategy",K[K.showDeprecated=128]="showDeprecated",K[K.inlayHints=129]="inlayHints",K[K.editorClassName=130]="editorClassName",K[K.pixelRatio=131]="pixelRatio",K[K.tabFocusMode=132]="tabFocusMode",K[K.layoutInfo=133]="layoutInfo",K[K.wrappingInfo=134]="wrappingInfo"})(rt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Te(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:a.localize(163,null)})),acceptSuggestionOnEnter:Te(new u(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",a.localize(164,null),""],markdownDescription:a.localize(165,null)})),accessibilitySupport:Te(new r),accessibilityPageSize:Te(new R(3,"accessibilityPageSize",10,1,1073741824,{description:a.localize(166,null)})),ariaLabel:Te(new w(4,"ariaLabel",a.localize(167,null))),autoClosingBrackets:Te(new u(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(168,null),a.localize(169,null),""],description:a.localize(170,null)})),autoClosingDelete:Te(new u(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",a.localize(171,null),""],description:a.localize(172,null)})),autoClosingOvertype:Te(new u(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",a.localize(173,null),""],description:a.localize(174,null)})),autoClosingQuotes:Te(new u(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(175,null),a.localize(176,null),""],description:a.localize(177,null)})),autoIndent:Te(new n(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],i,{enumDescriptions:[a.localize(178,null),a.localize(179,null),a.localize(180,null),a.localize(181,null),a.localize(182,null)],description:a.localize(183,null)})),automaticLayout:Te(new o(10,"automaticLayout",!1)),autoSurround:Te(new u(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[a.localize(184,null),a.localize(185,null),a.localize(186,null),""],description:a.localize(187,null)})),bracketPairColorization:Te(new I),bracketPairGuides:Te(new B),stickyTabStops:Te(new o(106,"stickyTabStops",!1,{description:a.localize(188,null)})),codeLens:Te(new o(14,"codeLens",!0,{description:a.localize(189,null)})),codeLensFontFamily:Te(new w(15,"codeLensFontFamily","",{description:a.localize(190,null)})),codeLensFontSize:Te(new R(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:a.localize(191,null)})),colorDecorators:Te(new o(17,"colorDecorators",!0,{description:a.localize(192,null)})),columnSelection:Te(new o(18,"columnSelection",!1,{description:a.localize(193,null)})),comments:Te(new t),contextmenu:Te(new o(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Te(new o(21,"copyWithSyntaxHighlighting",!0,{description:a.localize(194,null)})),cursorBlinking:Te(new n(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],_,{description:a.localize(195,null)})),cursorSmoothCaretAnimation:Te(new o(23,"cursorSmoothCaretAnimation",!1,{description:a.localize(196,null)})),cursorStyle:Te(new n(24,"cursorStyle",g.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],U,{description:a.localize(197,null)})),cursorSurroundingLines:Te(new R(25,"cursorSurroundingLines",0,0,1073741824,{description:a.localize(198,null)})),cursorSurroundingLinesStyle:Te(new u(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[a.localize(199,null),a.localize(200,null)],description:a.localize(201,null)})),cursorWidth:Te(new R(27,"cursorWidth",0,0,1073741824,{markdownDescription:a.localize(202,null)})),disableLayerHinting:Te(new o(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Te(new o(29,"disableMonospaceOptimizations",!1)),domReadOnly:Te(new o(30,"domReadOnly",!1)),dragAndDrop:Te(new o(31,"dragAndDrop",!0,{description:a.localize(203,null)})),emptySelectionClipboard:Te(new M),dropIntoEditor:Te(new Ne),experimental:Te(new ue),extraEditorClassName:Te(new w(35,"extraEditorClassName","")),fastScrollSensitivity:Te(new c(36,"fastScrollSensitivity",5,K=>K<=0?5:K,{markdownDescription:a.localize(204,null)})),find:Te(new S),fixedOverflowWidgets:Te(new o(38,"fixedOverflowWidgets",!1)),folding:Te(new o(39,"folding",!0,{description:a.localize(205,null)})),foldingStrategy:Te(new u(40,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[a.localize(206,null),a.localize(207,null)],description:a.localize(208,null)})),foldingHighlight:Te(new o(41,"foldingHighlight",!0,{description:a.localize(209,null)})),foldingImportsByDefault:Te(new o(42,"foldingImportsByDefault",!1,{description:a.localize(210,null)})),foldingMaximumRegions:Te(new R(43,"foldingMaximumRegions",5e3,10,65e3,{description:a.localize(211,null)})),unfoldOnClickAfterEndOfLine:Te(new o(44,"unfoldOnClickAfterEndOfLine",!1,{description:a.localize(212,null)})),fontFamily:Te(new w(45,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:a.localize(213,null)})),fontInfo:Te(new $),fontLigatures2:Te(new z),fontSize:Te(new F),fontWeight:Te(new q),formatOnPaste:Te(new o(50,"formatOnPaste",!1,{description:a.localize(214,null)})),formatOnType:Te(new o(51,"formatOnType",!1,{description:a.localize(215,null)})),glyphMargin:Te(new o(52,"glyphMargin",!0,{description:a.localize(216,null)})),gotoLocation:Te(new ie),hideCursorInOverviewRuler:Te(new o(54,"hideCursorInOverviewRuler",!1,{description:a.localize(217,null)})),hover:Te(new A),inDiffEditor:Te(new o(56,"inDiffEditor",!1)),letterSpacing:Te(new c(58,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,K=>c.clamp(K,-5,20),{description:a.localize(218,null)})),lightbulb:Te(new oe),lineDecorationsWidth:Te(new h(60,"lineDecorationsWidth",10)),lineHeight:Te(new Ee),lineNumbers:Te(new Ie),lineNumbersMinChars:Te(new R(63,"lineNumbersMinChars",5,1,300)),linkedEditing:Te(new o(64,"linkedEditing",!1,{description:a.localize(219,null)})),links:Te(new o(65,"links",!0,{description:a.localize(220,null)})),matchBrackets:Te(new u(66,"matchBrackets","always",["always","near","never"],{description:a.localize(221,null)})),minimap:Te(new be),mouseStyle:Te(new u(68,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Te(new c(69,"mouseWheelScrollSensitivity",1,K=>K===0?1:K,{markdownDescription:a.localize(222,null)})),mouseWheelZoom:Te(new o(70,"mouseWheelZoom",!1,{markdownDescription:a.localize(223,null)})),multiCursorMergeOverlapping:Te(new o(71,"multiCursorMergeOverlapping",!0,{description:a.localize(224,null)})),multiCursorModifier:Te(new n(72,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ee,{markdownEnumDescriptions:[a.localize(225,null),a.localize(226,null)],markdownDescription:a.localize(227,null)})),multiCursorPaste:Te(new u(73,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[a.localize(228,null),a.localize(229,null)],markdownDescription:a.localize(230,null)})),occurrencesHighlight:Te(new o(74,"occurrencesHighlight",!0,{description:a.localize(231,null)})),overviewRulerBorder:Te(new o(75,"overviewRulerBorder",!0,{description:a.localize(232,null)})),overviewRulerLanes:Te(new R(76,"overviewRulerLanes",3,0,3)),padding:Te(new ve),parameterHints:Te(new Ae),peekWidgetDefaultFocus:Te(new u(79,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[a.localize(233,null),a.localize(234,null)],description:a.localize(235,null)})),definitionLinkOpensInPeek:Te(new o(80,"definitionLinkOpensInPeek",!1,{description:a.localize(236,null)})),quickSuggestions:Te(new $e),quickSuggestionsDelay:Te(new R(82,"quickSuggestionsDelay",10,0,1073741824,{description:a.localize(237,null)})),readOnly:Te(new o(83,"readOnly",!1)),renameOnType:Te(new o(84,"renameOnType",!1,{description:a.localize(238,null),markdownDeprecationMessage:a.localize(239,null)})),renderControlCharacters:Te(new o(85,"renderControlCharacters",!0,{description:a.localize(240,null),restricted:!0})),renderFinalNewline:Te(new o(86,"renderFinalNewline",!0,{description:a.localize(241,null)})),renderLineHighlight:Te(new u(87,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",a.localize(242,null)],description:a.localize(243,null)})),renderLineHighlightOnlyWhenFocus:Te(new o(88,"renderLineHighlightOnlyWhenFocus",!1,{description:a.localize(244,null)})),renderValidationDecorations:Te(new u(89,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Te(new u(90,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",a.localize(245,null),a.localize(246,null),a.localize(247,null),""],description:a.localize(248,null)})),revealHorizontalRightPadding:Te(new R(91,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Te(new o(92,"roundedSelection",!0,{description:a.localize(249,null)})),rulers:Te(new ke),scrollbar:Te(new le),scrollBeyondLastColumn:Te(new R(95,"scrollBeyondLastColumn",4,0,1073741824,{description:a.localize(250,null)})),scrollBeyondLastLine:Te(new o(96,"scrollBeyondLastLine",!0,{description:a.localize(251,null)})),scrollPredominantAxis:Te(new o(97,"scrollPredominantAxis",!0,{description:a.localize(252,null)})),selectionClipboard:Te(new o(98,"selectionClipboard",!0,{description:a.localize(253,null),included:p.isLinux})),selectionHighlight:Te(new o(99,"selectionHighlight",!0,{description:a.localize(254,null)})),selectOnLineNumbers:Te(new o(100,"selectOnLineNumbers",!0)),showFoldingControls:Te(new u(101,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[a.localize(255,null),a.localize(256,null),a.localize(257,null)],description:a.localize(258,null)})),showUnused:Te(new o(102,"showUnused",!0,{description:a.localize(259,null)})),showDeprecated:Te(new o(128,"showDeprecated",!0,{description:a.localize(260,null)})),inlayHints:Te(new te),snippetSuggestions:Te(new u(103,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[a.localize(261,null),a.localize(262,null),a.localize(263,null),a.localize(264,null)],description:a.localize(265,null)})),smartSelect:Te(new se),smoothScrolling:Te(new o(105,"smoothScrolling",!1,{description:a.localize(266,null)})),stopRenderingLineAfter:Te(new R(107,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Te(new V),inlineSuggest:Te(new Q),suggestFontSize:Te(new R(109,"suggestFontSize",0,0,1e3,{markdownDescription:a.localize(267,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Te(new R(110,"suggestLineHeight",0,0,1e3,{markdownDescription:a.localize(268,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Te(new o(111,"suggestOnTriggerCharacters",!0,{description:a.localize(269,null)})),suggestSelection:Te(new u(112,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[a.localize(270,null),a.localize(271,null),a.localize(272,null)],description:a.localize(273,null)})),tabCompletion:Te(new u(113,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[a.localize(274,null),a.localize(275,null),a.localize(276,null)],description:a.localize(277,null)})),tabIndex:Te(new R(114,"tabIndex",0,-1,1073741824)),unicodeHighlight:Te(new G),unusualLineTerminators:Te(new u(116,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[a.localize(278,null),a.localize(279,null),a.localize(280,null)],description:a.localize(281,null)})),useShadowDOM:Te(new o(117,"useShadowDOM",!0)),useTabStops:Te(new o(118,"useTabStops",!0,{description:a.localize(282,null)})),wordSeparators:Te(new w(119,"wordSeparators",b.USUAL_WORD_SEPARATORS,{description:a.localize(283,null)})),wordWrap:Te(new u(120,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[a.localize(284,null),a.localize(285,null),a.localize(286,null),a.localize(287,null)],description:a.localize(288,null)})),wordWrapBreakAfterCharacters:Te(new w(121,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Te(new w(122,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Te(new R(123,"wordWrapColumn",80,1,1073741824,{markdownDescription:a.localize(289,null)})),wordWrapOverride1:Te(new u(124,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Te(new u(125,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Te(new n(126,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],pe,{enumDescriptions:[a.localize(290,null),a.localize(291,null),a.localize(292,null),a.localize(293,null)],description:a.localize(294,null)})),wrappingStrategy:Te(new u(127,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[a.localize(295,null),a.localize(296,null)],description:a.localize(297,null)})),editorClassName:Te(new W),pixelRatio:Te(new Fe),tabFocusMode:Te(new de),layoutInfo:Te(new ce),wrappingInfo:Te(new ge)}}),define(ye[123],De([17,18]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ye[124],De([17,18]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ye[125],De([17,18]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(ye[126],De([17,18]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(ye[127],De([17,18]),function(ne,e){return ne.create("vs/platform/markers/common/markers",e)}),define(ye[128],De([17,18]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(ye[129],De([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ye[130],De([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ye[131],De([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostProgress",e)}),define(ye[132],De([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ye[133],De([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ye[134],De([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ye[135],De([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ye[136],De([17,18]),function(ne,e){return ne.create("vs/workbench/common/editor",e)}),define(ye[137],De([17,18]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ye[138],De([17,18]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/debug",e)}),define(ye[139],De([17,18]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ye[140],De([17,18]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ye[141],De([17,18]),function(ne,e){return ne.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ye[142],De([17,18]),function(ne,e){return ne.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ye[143],De([17,18]),function(ne,e){return ne.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ye[144],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionSource=e.TextEditorSelectionRevealType=e.EditorOpenSource=e.EditorResolution=e.EditorActivation=void 0;var a;(function(k){k[k.ACTIVATE=1]="ACTIVATE",k[k.RESTORE=2]="RESTORE",k[k.PRESERVE=3]="PRESERVE"})(a=e.EditorActivation||(e.EditorActivation={}));var p;(function(k){k[k.PICK=0]="PICK",k[k.DISABLED=1]="DISABLED",k[k.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(p=e.EditorResolution||(e.EditorResolution={}));var b;(function(k){k[k.API=0]="API",k[k.USER=1]="USER"})(b=e.EditorOpenSource||(e.EditorOpenSource={}));var L;(function(k){k[k.Center=0]="Center",k[k.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",k[k.NearTop=2]="NearTop",k[k.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(L=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}));var D;(function(k){k.PROGRAMMATIC="api",k.NAVIGATION="code.navigation",k.JUMP="code.jump"})(D=e.TextEditorSelectionSource||(e.TextEditorSelectionSource={}))}),define(ye[145],De([1,0,22,29,125,239]),function(ne,e,a,p,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function E(o){return o=o.trim(),o==="*"||D.test(o)}e.isValidVersionStr=E;function P(o){if(!E(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=o.match(D);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=P;function O(o){if(!o)return null;const v=o.majorBase,R=o.majorMustEqual,c=o.minorBase;let w=o.minorMustEqual;const s=o.patchBase;let u=o.patchMustEqual;o.hasCaret&&(v===0||(w=!1),u=!1);let n=0;if(o.preRelease){const i=k.exec(o.preRelease);if(i){const[,r,t,l]=i;n=Date.UTC(Number(r),Number(t)-1,Number(l))}}return{majorBase:v,majorMustEqual:R,minorBase:c,minorMustEqual:w,patchBase:s,patchMustEqual:u,isMinimum:o.hasGreaterEquals,notBefore:n}}e.normalizeVersion=O;function y(o,v,R){let c;typeof o=="string"?c=O(P(o)):c=o;let w;v instanceof Date?w=v.getTime():typeof v=="string"&&(w=new Date(v).getTime());let s;if(typeof R=="string"?s=O(P(R)):s=R,!c||!s)return!1;const u=c.majorBase,n=c.minorBase,i=c.patchBase;let r=s.majorBase,t=s.minorBase,l=s.patchBase;const _=s.notBefore;let g=s.majorMustEqual,C=s.minorMustEqual,U=s.patchMustEqual;return s.isMinimum?u>r?!0:u<r?!1:n>t?!0:n<t||w&&w<_?!1:i>=l:(u===1&&r===0&&(!g||!C||!U)&&(r=1,t=0,l=0,g=!0,C=!1,U=!1),u<r?!1:u>r?!g:n<t?!1:n>t?!C:i<l?!1:i>l?!U:!(w&&w<_))}e.isValidVersion=y;function m(o,v,R,c,w){const s=[];if(typeof c.publisher!="undefined"&&typeof c.publisher!="string")return s.push([p.default.Error,b.localize(0,null)]),s;if(typeof c.name!="string")return s.push([p.default.Error,b.localize(1,null,"name")]),s;if(typeof c.version!="string")return s.push([p.default.Error,b.localize(2,null,"version")]),s;if(!c.engines)return s.push([p.default.Error,b.localize(3,null,"engines")]),s;if(typeof c.engines.vscode!="string")return s.push([p.default.Error,b.localize(4,null,"engines.vscode")]),s;if(typeof c.extensionDependencies!="undefined"&&!d(c.extensionDependencies))return s.push([p.default.Error,b.localize(5,null,"extensionDependencies")]),s;if(typeof c.activationEvents!="undefined"){if(!d(c.activationEvents))return s.push([p.default.Error,b.localize(6,null,"activationEvents")]),s;if(typeof c.main=="undefined"&&typeof c.browser=="undefined")return s.push([p.default.Error,b.localize(7,null,"activationEvents","main")]),s}if(typeof c.extensionKind!="undefined"&&typeof c.main=="undefined"&&s.push([p.default.Warning,b.localize(8,null,"extensionKind")]),typeof c.main!="undefined"){if(typeof c.main!="string")return s.push([p.default.Error,b.localize(9,null,"main")]),s;{const i=(0,a.joinPath)(R,c.main);(0,a.isEqualOrParent)(i,R)||s.push([p.default.Warning,b.localize(10,null,i.path,R.path)])}if(typeof c.activationEvents=="undefined")return s.push([p.default.Error,b.localize(11,null,"activationEvents","main")]),s}if(typeof c.browser!="undefined"){if(typeof c.browser!="string")return s.push([p.default.Error,b.localize(12,null,"browser")]),s;{const i=(0,a.joinPath)(R,c.browser);(0,a.isEqualOrParent)(i,R)||s.push([p.default.Warning,b.localize(13,null,i.path,R.path)])}if(typeof c.activationEvents=="undefined")return s.push([p.default.Error,b.localize(14,null,"activationEvents","browser")]),s}if(!L.valid(c.version))return s.push([p.default.Error,b.localize(15,null)]),s;const u=[];if(!T(o,v,c,w,u))for(const i of u)s.push([p.default.Error,i]);return s}e.validateExtensionManifest=m;function T(o,v,R,c,w){return c||typeof R.main=="undefined"&&typeof R.browser=="undefined"?!0:h(o,v,R.engines.vscode,w)}e.isValidExtensionVersion=T;function f(o,v,R){return o==="*"||h(v,R,o)}e.isEngineValid=f;function h(o,v,R,c=[]){const w=O(P(R));if(!w)return c.push(b.localize(16,null,R)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return c.push(b.localize(17,null,R)),!1}else if(!w.majorMustEqual)return c.push(b.localize(18,null,R)),!1;return y(o,v,w)?!0:(c.push(b.localize(19,null,o,R)),!1)}function d(o){if(!Array.isArray(o))return!1;for(let v=0,R=o.length;v<R;v++)if(typeof o[v]!="string")return!1;return!0}}),define(ye[78],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class a{constructor(b,L=[],D=!1){this.ctor=b,this.staticArguments=L,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=a}),define(ye[56],De([1,0,78]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const p=[];function b(D,k,E){k instanceof a.SyncDescriptor||(k=new a.SyncDescriptor(k,[],E)),p.push([D,k])}e.registerSingleton=b;function L(){return p}e.getSingletonServiceDescriptors=L}),define(ye[146],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class a{constructor(L){this.incoming=new Map,this.outgoing=new Map,this.data=L}}e.Node=a;class p{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(const D of this._nodes.values())D.outgoing.size===0&&L.push(D);return L}insertEdge(L,D){const k=this.lookupOrInsertNode(L),E=this.lookupOrInsertNode(D);k.outgoing.set(this._hashFn(D),E),E.incoming.set(this._hashFn(L),k)}removeNode(L){const D=this._hashFn(L);this._nodes.delete(D);for(const k of this._nodes.values())k.outgoing.delete(D),k.incoming.delete(D)}lookupOrInsertNode(L){const D=this._hashFn(L);let k=this._nodes.get(D);return k||(k=new a(L),this._nodes.set(D,k)),k}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){const L=[];for(const[D,k]of this._nodes)L.push(`${D}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return L.join(`
`)}findCycleSlow(){for(const[L,D]of this._nodes){const k=new Set([L]),E=this._findCycle(D,k);if(E)return E}}_findCycle(L,D){for(const[k,E]of L.outgoing){if(D.has(k))return[...D,k].join(" -> ");D.add(k);const P=this._findCycle(E,D);if(P)return P;D.delete(k)}}}e.Graph=p}),define(ye[3],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var a;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function k(E){return E[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=k})(a=e._util||(e._util={})),e.IInstantiationService=b("instantiationService");function p(D,k,E){k[a.DI_TARGET]===k?k[a.DI_DEPENDENCIES].push({id:D,index:E}):(k[a.DI_DEPENDENCIES]=[{id:D,index:E}],k[a.DI_TARGET]=k)}function b(D){if(a.serviceIds.has(D))return a.serviceIds.get(D);const k=function(E,P,O){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");p(k,E,O)};return k.toString=()=>D,a.serviceIds.set(D,k),k}e.createDecorator=b;function L(D){return D}e.refineServiceDecorator=L}),define(ye[57],De([1,0,10,2,3]),function(ne,e,a,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,b.createDecorator)("configurationService");function L(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof p.URI)}e.isConfigurationOverrides=L;function D(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof p.URI)}e.isConfigurationUpdateOverrides=D;var k;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function E(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=E;function P(o,v){const R=Object.create(null);for(const c in o)O(R,c,o[c],v);return R}e.toValuesTree=P;function O(o,v,R,c){const w=v.split("."),s=w.pop();let u=o;for(let n=0;n<w.length;n++){const i=w[n];let r=u[i];switch(typeof r){case"undefined":r=u[i]=Object.create(null);break;case"object":break;default:c(`Ignoring ${v} as ${w.slice(0,n+1).join(".")} is ${JSON.stringify(r)}`);return}u=r}if(typeof u=="object"&&u!==null)try{u[s]=R}catch{c(`Ignoring ${v} as ${w.join(".")} is ${JSON.stringify(u)}`)}else c(`Ignoring ${v} as ${w.join(".")} is ${JSON.stringify(u)}`)}e.addToValueTree=O;function y(o,v){const R=v.split(".");m(o,R)}e.removeFromValueTree=y;function m(o,v){const R=v.shift();if(v.length===0){delete o[R];return}if(Object.keys(o).indexOf(R)!==-1){const c=o[R];typeof c=="object"&&!Array.isArray(c)&&(m(c,v),Object.keys(c).length===0&&delete o[R])}}function T(o,v,R){function c(u,n){let i=u;for(const r of n){if(typeof i!="object"||i===null)return;i=i[r]}return i}const w=v.split("."),s=c(o,w);return typeof s=="undefined"?R:s}e.getConfigurationValue=T;function f(o,v,R){Object.keys(v).forEach(c=>{c!=="__proto__"&&(c in o?a.isObject(o[c])&&a.isObject(v[c])?f(o[c],v[c],R):R&&(o[c]=v[c]):o[c]=v[c])})}e.merge=f;function h(o,v,R){const c=o.inspect(v),w=o.inspect(R);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof w.userValue!="undefined"||typeof w.workspaceValue!="undefined"||typeof w.workspaceFolderValue!="undefined"?w.value:c.defaultValue}e.getMigratedSettingValue=h;function d(o){return o.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=d}),define(ye[38],De([1,0,21,9,3]),function(ne,e,a,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const L=new Map;L.set("false",!1),L.set("true",!0),L.set("isMac",a.isMacintosh),L.set("isLinux",a.isLinux),L.set("isWindows",a.isWindows),L.set("isWeb",a.isWeb),L.set("isMacNative",a.isMacintosh&&!a.isWeb),L.set("isEdge",a.isEdge),L.set("isFirefox",a.isFirefox),L.set("isChrome",a.isChrome),L.set("isSafari",a.isSafari);const D=Object.prototype.hasOwnProperty;var k;(function(M){M[M.False=0]="False",M[M.True=1]="True",M[M.Defined=2]="Defined",M[M.Not=3]="Not",M[M.Equals=4]="Equals",M[M.NotEquals=5]="NotEquals",M[M.And=6]="And",M[M.Regex=7]="Regex",M[M.NotRegex=8]="NotRegex",M[M.Or=9]="Or",M[M.In=10]="In",M[M.NotIn=11]="NotIn",M[M.Greater=12]="Greater",M[M.GreaterEquals=13]="GreaterEquals",M[M.Smaller=14]="Smaller",M[M.SmallerEquals=15]="SmallerEquals"})(k=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return y.INSTANCE}static true(){return m.INSTANCE}static has(S){return T.create(S)}static equals(S,z){return f.create(S,z)}static notEquals(S,z){return o.create(S,z)}static regex(S,z){return n.create(S,z)}static in(S,z){return h.create(S,z)}static notIn(S,z){return d.create(S,z)}static not(S){return v.create(S)}static and(...S){return t.create(S,null)}static or(...S){return l.create(S,null,!0)}static greater(S,z){return c.create(S,z)}static greaterEquals(S,z){return w.create(S,z)}static smaller(S,z){return s.create(S,z)}static smallerEquals(S,z){return u.create(S,z)}static deserialize(S,z=!1){if(!!S)return this._deserializeOrExpression(S,z)}static _deserializeOrExpression(S,z){const $=S.split("||");return l.create($.map(F=>this._deserializeAndExpression(F,z)),null,!0)}static _deserializeAndExpression(S,z){const $=S.split("&&");return t.create($.map(F=>this._deserializeOne(F,z)),null)}static _deserializeOne(S,z){if(S=S.trim(),S.indexOf("!=")>=0){const $=S.split("!=");return o.create($[0].trim(),this._deserializeValue($[1],z))}if(S.indexOf("==")>=0){const $=S.split("==");return f.create($[0].trim(),this._deserializeValue($[1],z))}if(S.indexOf("=~")>=0){const $=S.split("=~");return n.create($[0].trim(),this._deserializeRegexValue($[1],z))}if(S.indexOf(" not in ")>=0){const $=S.split(" not in ");return d.create($[0].trim(),$[1].trim())}if(S.indexOf(" in ")>=0){const $=S.split(" in ");return h.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(S)){const $=S.split(">=");return w.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(S)){const $=S.split(">");return c.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(S)){const $=S.split("<=");return u.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(S)){const $=S.split("<");return s.create($[0].trim(),$[1].trim())}return/^\!\s*/.test(S)?v.create(S.substr(1).trim()):T.create(S)}static _deserializeValue(S,z){if(S=S.trim(),S==="true")return!0;if(S==="false")return!1;const $=/^'([^']*)'$/.exec(S);return $?$[1].trim():S}static _deserializeRegexValue(S,z){if((0,p.isFalsyOrWhitespace)(S)){if(z)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const $=S.indexOf("/"),F=S.lastIndexOf("/");if($===F||$<0){if(z)throw new Error(`bad regexp-value '${S}', missing /-enclosure`);return console.warn(`bad regexp-value '${S}', missing /-enclosure`),null}const q=S.slice($+1,F),ie=S[F+1]==="i"?"i":"";try{return new RegExp(q,ie)}catch(A){if(z)throw new Error(`bad regexp-value '${S}', parse error: ${A}`);return console.warn(`bad regexp-value '${S}', parse error: ${A}`),null}}}e.ContextKeyExpr=E;function P(M,S){const z=M?M.substituteConstants():void 0,$=S?S.substituteConstants():void 0;return!z&&!$?!0:!z||!$?!1:z.equals($)}e.expressionsAreEqualWithConstantSubstitution=P;function O(M,S){return M.cmp(S)}class y{constructor(){this.type=0}cmp(S){return this.type-S.type}equals(S){return S.type===this.type}substituteConstants(){return this}evaluate(S){return!1}serialize(){return"false"}keys(){return[]}map(S){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=y,y.INSTANCE=new y;class m{constructor(){this.type=1}cmp(S){return this.type-S.type}equals(S){return S.type===this.type}substituteConstants(){return this}evaluate(S){return!0}serialize(){return"true"}keys(){return[]}map(S){return this}negate(){return y.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class T{constructor(S,z){this.key=S,this.negated=z,this.type=2}static create(S,z=null){const $=L.get(S);return typeof $=="boolean"?$?m.INSTANCE:y.INSTANCE:new T(S,z)}cmp(S){return S.type!==this.type?this.type-S.type:g(this.key,S.key)}equals(S){return S.type===this.type?this.key===S.key:!1}substituteConstants(){const S=L.get(this.key);return typeof S=="boolean"?S?m.INSTANCE:y.INSTANCE:this}evaluate(S){return!!S.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(S){return S.mapDefined(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=T;class f{constructor(S,z,$){this.key=S,this.value=z,this.negated=$,this.type=4}static create(S,z,$=null){if(typeof z=="boolean")return z?T.create(S,$):v.create(S,$);const F=L.get(S);return typeof F=="boolean"?z===(F?"true":"false")?m.INSTANCE:y.INSTANCE:new f(S,z,$)}cmp(S){return S.type!==this.type?this.type-S.type:C(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){const S=L.get(this.key);if(typeof S=="boolean"){const z=S?"true":"false";return this.value===z?m.INSTANCE:y.INSTANCE}return this}evaluate(S){return S.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(S){return S.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=f;class h{constructor(S,z){this.key=S,this.valueKey=z,this.type=10,this.negated=null}static create(S,z){return new h(S,z)}cmp(S){return S.type!==this.type?this.type-S.type:C(this.key,this.valueKey,S.key,S.valueKey)}equals(S){return S.type===this.type?this.key===S.key&&this.valueKey===S.valueKey:!1}substituteConstants(){return this}evaluate(S){const z=S.getValue(this.valueKey),$=S.getValue(this.key);return Array.isArray(z)?z.includes($):typeof $=="string"&&typeof z=="object"&&z!==null?D.call(z,$):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(S){return S.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=d.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=h;class d{constructor(S,z){this.key=S,this.valueKey=z,this.type=11,this._negated=h.create(S,z)}static create(S,z){return new d(S,z)}cmp(S){return S.type!==this.type?this.type-S.type:this._negated.cmp(S._negated)}equals(S){return S.type===this.type?this._negated.equals(S._negated):!1}substituteConstants(){return this}evaluate(S){return!this._negated.evaluate(S)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(S){return S.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=d;class o{constructor(S,z,$){this.key=S,this.value=z,this.negated=$,this.type=5}static create(S,z,$=null){if(typeof z=="boolean")return z?v.create(S,$):T.create(S,$);const F=L.get(S);return typeof F=="boolean"?z===(F?"true":"false")?y.INSTANCE:m.INSTANCE:new o(S,z,$)}cmp(S){return S.type!==this.type?this.type-S.type:C(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){const S=L.get(this.key);if(typeof S=="boolean"){const z=S?"true":"false";return this.value===z?y.INSTANCE:m.INSTANCE}return this}evaluate(S){return S.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(S){return S.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=o;class v{constructor(S,z){this.key=S,this.negated=z,this.type=3}static create(S,z=null){const $=L.get(S);return typeof $=="boolean"?$?y.INSTANCE:m.INSTANCE:new v(S,z)}cmp(S){return S.type!==this.type?this.type-S.type:g(this.key,S.key)}equals(S){return S.type===this.type?this.key===S.key:!1}substituteConstants(){const S=L.get(this.key);return typeof S=="boolean"?S?y.INSTANCE:m.INSTANCE:this}evaluate(S){return!S.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(S){return S.mapNot(this.key)}negate(){return this.negated||(this.negated=T.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=v;function R(M,S){if(typeof M=="string"){const z=parseFloat(M);isNaN(z)||(M=z)}return typeof M=="string"||typeof M=="number"?S(M):y.INSTANCE}class c{constructor(S,z,$){this.key=S,this.value=z,this.negated=$,this.type=12}static create(S,z,$=null){return R(z,F=>new c(S,F,$))}cmp(S){return S.type!==this.type?this.type-S.type:C(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){return this}evaluate(S){return typeof this.value=="string"?!1:parseFloat(S.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(S){return S.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=c;class w{constructor(S,z,$){this.key=S,this.value=z,this.negated=$,this.type=13}static create(S,z,$=null){return R(z,F=>new w(S,F,$))}cmp(S){return S.type!==this.type?this.type-S.type:C(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){return this}evaluate(S){return typeof this.value=="string"?!1:parseFloat(S.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(S){return S.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=w;class s{constructor(S,z,$){this.key=S,this.value=z,this.negated=$,this.type=14}static create(S,z,$=null){return R(z,F=>new s(S,F,$))}cmp(S){return S.type!==this.type?this.type-S.type:C(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){return this}evaluate(S){return typeof this.value=="string"?!1:parseFloat(S.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(S){return S.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=s;class u{constructor(S,z,$){this.key=S,this.value=z,this.negated=$,this.type=15}static create(S,z,$=null){return R(z,F=>new u(S,F,$))}cmp(S){return S.type!==this.type?this.type-S.type:C(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){return this}evaluate(S){return typeof this.value=="string"?!1:parseFloat(S.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(S){return S.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=u;class n{constructor(S,z){this.key=S,this.regexp=z,this.type=7,this.negated=null}static create(S,z){return new n(S,z)}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.key<S.key)return-1;if(this.key>S.key)return 1;const z=this.regexp?this.regexp.source:"",$=S.regexp?S.regexp.source:"";return z<$?-1:z>$?1:0}equals(S){if(S.type===this.type){const z=this.regexp?this.regexp.source:"",$=S.regexp?S.regexp.source:"";return this.key===S.key&&z===$}return!1}substituteConstants(){return this}evaluate(S){const z=S.getValue(this.key);return this.regexp?this.regexp.test(z):!1}serialize(){const S=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${S}`}keys(){return[this.key]}map(S){return S.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=n;class i{constructor(S){this._actual=S,this.type=8}static create(S){return new i(S)}cmp(S){return S.type!==this.type?this.type-S.type:this._actual.cmp(S._actual)}equals(S){return S.type===this.type?this._actual.equals(S._actual):!1}substituteConstants(){return this}evaluate(S){return!this._actual.evaluate(S)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(S){return new i(this._actual.map(S))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function r(M){let S=null;for(let z=0,$=M.length;z<$;z++){const F=M[z].substituteConstants();if(M[z]!==F&&S===null){S=[];for(let q=0;q<z;q++)S[q]=M[q]}S!==null&&(S[z]=F)}return S===null?M:S}class t{constructor(S,z){this.expr=S,this.negated=z,this.type=6}static create(S,z){return t._normalizeArr(S,z)}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.expr.length<S.expr.length)return-1;if(this.expr.length>S.expr.length)return 1;for(let z=0,$=this.expr.length;z<$;z++){const F=O(this.expr[z],S.expr[z]);if(F!==0)return F}return 0}equals(S){if(S.type===this.type){if(this.expr.length!==S.expr.length)return!1;for(let z=0,$=this.expr.length;z<$;z++)if(!this.expr[z].equals(S.expr[z]))return!1;return!0}return!1}substituteConstants(){const S=r(this.expr);return S===this.expr?this:t.create(S,this.negated)}evaluate(S){for(let z=0,$=this.expr.length;z<$;z++)if(!this.expr[z].evaluate(S))return!1;return!0}static _normalizeArr(S,z){const $=[];let F=!1;for(const q of S)if(!!q){if(q.type===1){F=!0;continue}if(q.type===0)return y.INSTANCE;if(q.type===6){$.push(...q.expr);continue}$.push(q)}if($.length===0&&F)return m.INSTANCE;if($.length!==0){if($.length===1)return $[0];$.sort(O);for(let q=1;q<$.length;q++)$[q-1].equals($[q])&&($.splice(q,1),q--);if($.length===1)return $[0];for(;$.length>1;){const q=$[$.length-1];if(q.type!==9)break;$.pop();const ie=$.pop(),A=$.length===0,Z=l.create(q.expr.map(ce=>t.create([ce,ie],null)),null,A);Z&&($.push(Z),$.sort(O))}return $.length===1?$[0]:new t($,z)}}serialize(){return this.expr.map(S=>S.serialize()).join(" && ")}keys(){const S=[];for(const z of this.expr)S.push(...z.keys());return S}map(S){return new t(this.expr.map(z=>z.map(S)),null)}negate(){if(!this.negated){const S=[];for(const z of this.expr)S.push(z.negate());this.negated=l.create(S,this,!0)}return this.negated}}class l{constructor(S,z){this.expr=S,this.negated=z,this.type=9}static create(S,z,$){return l._normalizeArr(S,z,$)}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.expr.length<S.expr.length)return-1;if(this.expr.length>S.expr.length)return 1;for(let z=0,$=this.expr.length;z<$;z++){const F=O(this.expr[z],S.expr[z]);if(F!==0)return F}return 0}equals(S){if(S.type===this.type){if(this.expr.length!==S.expr.length)return!1;for(let z=0,$=this.expr.length;z<$;z++)if(!this.expr[z].equals(S.expr[z]))return!1;return!0}return!1}substituteConstants(){const S=r(this.expr);return S===this.expr?this:l.create(S,this.negated,!1)}evaluate(S){for(let z=0,$=this.expr.length;z<$;z++)if(this.expr[z].evaluate(S))return!0;return!1}static _normalizeArr(S,z,$){let F=[],q=!1;if(S){for(let ie=0,A=S.length;ie<A;ie++){const Z=S[ie];if(!!Z){if(Z.type===0){q=!0;continue}if(Z.type===1)return m.INSTANCE;if(Z.type===9){F=F.concat(Z.expr);continue}F.push(Z)}}if(F.length===0&&q)return y.INSTANCE;F.sort(O)}if(F.length!==0){if(F.length===1)return F[0];for(let ie=1;ie<F.length;ie++)F[ie-1].equals(F[ie])&&(F.splice(ie,1),ie--);if(F.length===1)return F[0];if($){for(let ie=0;ie<F.length;ie++)for(let A=ie+1;A<F.length;A++)U(F[ie],F[A])&&(F.splice(A,1),A--);if(F.length===1)return F[0]}return new l(F,z)}}serialize(){return this.expr.map(S=>S.serialize()).join(" || ")}keys(){const S=[];for(const z of this.expr)S.push(...z.keys());return S}map(S){return new l(this.expr.map(z=>z.map(S)),null)}negate(){if(!this.negated){const S=[];for(const z of this.expr)S.push(z.negate());for(;S.length>1;){const z=S.shift(),$=S.shift(),F=[];for(const ie of W(z))for(const A of W($))F.push(t.create([ie,A],null));const q=S.length===0;S.unshift(l.create(F,null,q))}this.negated=S[0]}return this.negated}}class _ extends T{constructor(S,z,$){super(S,null);this._defaultValue=z,typeof $=="object"?_._info.push({...$,key:S}):$!==!0&&_._info.push({key:S,description:$,type:z!=null?typeof z:void 0})}static all(){return _._info.values()}bindTo(S){return S.createKey(this.key,this._defaultValue)}getValue(S){return S.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(S){return f.create(this.key,S)}notEqualsTo(S){return o.create(this.key,S)}}e.RawContextKey=_,_._info=[],e.IContextKeyService=(0,b.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function g(M,S){return M<S?-1:M>S?1:0}function C(M,S,z,$){return M<z?-1:M>z?1:S<$?-1:S>$?1:0}function U(M,S){if(S.type===6&&M.type!==9&&M.type!==6){for(const F of S.expr)if(M.equals(F))return!0}const z=M.negate(),$=W(z).concat(W(S));$.sort(O);for(let F=0;F<$.length;F++){const ie=$[F].negate();for(let A=F+1;A<$.length;A++){const Z=$[A];if(ie.equals(Z))return!0}}return!1}e.implies=U;function W(M){return M.type===9?M.expr:[M]}}),define(ye[147],De([1,0,3]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,a.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,a.refineServiceDecorator)(e.IEnvironmentService)}),define(ye[79],De([1,0,124,3]),function(ne,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDefaultExtensionsProfileInitService=e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IServerExtensionManagementService=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function b(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=b;function L(o){switch(o){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function D(o,v){switch(o){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function k(o,v){return v==="web"&&!o.includes("web")}e.isNotWebExtensionInWebTargetPlatform=k;function E(o,v,R){return k(v,R)?!1:o==="undefined"||o==="universal"?!0:o==="unknown"?!1:o===R?!0:P(R).includes(o)}e.isTargetPlatformCompatible=E;function P(o){switch(o){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=P;function O(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}e.isIExtensionIdentifier=O;var y;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var m;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var T;(function(o){o.Install="install",o.Uninstall="uninstall"})(T=e.StatisticType||(e.StatisticType={}));var f;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,p.createDecorator)("extensionGalleryService");var h;(function(o){o.Unsupported="Unsupported",o.Deprecated="Deprecated",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatiblePreRelease="IncompatiblePreRelease",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.Extract="Extract",o.Delete="Delete",o.Rename="Rename",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Internal="Internal"})(h=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class d extends Error{constructor(v,R){super(v);this.code=R,this.name=R}}e.ExtensionManagementError=d,e.IExtensionManagementService=(0,p.createDecorator)("extensionManagementService"),e.IServerExtensionManagementService=(0,p.refineServiceDecorator)(e.IExtensionManagementService),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,p.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,p.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,a.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,a.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,p.createDecorator)("IExtensionManagementCLIService"),e.IDefaultExtensionsProfileInitService=(0,p.createDecorator)("IDefaultExtensionsProfileInitService")}),define(ye[39],De([1,0,25,19,9,10,2,126,3]),function(ne,e,a,p,b,L,D,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,E.createDecorator)("fileService");function P(A){return A.create===!0}e.isFileOpenForWriteOptions=P;var O;(function(A){A[A.Unknown=0]="Unknown",A[A.File=1]="File",A[A.Directory=2]="Directory",A[A.SymbolicLink=64]="SymbolicLink"})(O=e.FileType||(e.FileType={}));var y;(function(A){A[A.Readonly=1]="Readonly"})(y=e.FilePermission||(e.FilePermission={}));var m;(function(A){A[A.FileReadWrite=2]="FileReadWrite",A[A.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",A[A.FileReadStream=16]="FileReadStream",A[A.FileFolderCopy=8]="FileFolderCopy",A[A.PathCaseSensitive=1024]="PathCaseSensitive",A[A.Readonly=2048]="Readonly",A[A.Trash=4096]="Trash",A[A.FileWriteUnlock=8192]="FileWriteUnlock",A[A.FileAtomicRead=16384]="FileAtomicRead",A[A.FileClone=32768]="FileClone"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function T(A){return!!(A.capabilities&2)}e.hasReadWriteCapability=T;function f(A){return!!(A.capabilities&8)}e.hasFileFolderCopyCapability=f;function h(A){return!!(A.capabilities&32768)}e.hasFileCloneCapability=h;function d(A){return!!(A.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function o(A){return!!(A.capabilities&16)}e.hasFileReadStreamCapability=o;function v(A){return!!(A.capabilities&2048)}e.hasFileReadCapability=v;function R(A){return T(A)?!!(A.capabilities&16384):!1}e.hasFileAtomicReadCapability=R;var c;(function(A){A.FileExists="EntryExists",A.FileNotFound="EntryNotFound",A.FileNotADirectory="EntryNotADirectory",A.FileIsADirectory="EntryIsADirectory",A.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",A.FileTooLarge="EntryTooLarge",A.FileWriteLocked="EntryWriteLocked",A.NoPermissions="NoPermissions",A.Unavailable="Unavailable",A.Unknown="Unknown"})(c=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class w extends Error{constructor(Z,ce){super(Z);this.code=ce}}e.FileSystemProviderError=w;function s(A,Z){const ce=new w(A.toString(),Z);return n(ce,Z),ce}e.createFileSystemProviderError=s;function u(A){return A||s((0,k.localize)(0,null),c.Unknown)}e.ensureFileSystemProviderError=u;function n(A,Z){return A.name=Z?`${Z} (FileSystemError)`:"FileSystemError",A}e.markAsFileSystemProviderError=n;function i(A){if(!A)return c.Unknown;if(A instanceof w)return A.code;const Z=/^(.+) \(FileSystemError\)$/.exec(A.name);if(!Z)return c.Unknown;switch(Z[1]){case c.FileExists:return c.FileExists;case c.FileIsADirectory:return c.FileIsADirectory;case c.FileNotADirectory:return c.FileNotADirectory;case c.FileNotFound:return c.FileNotFound;case c.FileExceedsMemoryLimit:return c.FileExceedsMemoryLimit;case c.FileTooLarge:return c.FileTooLarge;case c.FileWriteLocked:return c.FileWriteLocked;case c.NoPermissions:return c.NoPermissions;case c.Unavailable:return c.Unavailable}return c.Unknown}e.toFileSystemProviderErrorCode=i;function r(A){if(A instanceof U)return A.fileOperationResult;switch(i(A)){case c.FileNotFound:return 1;case c.FileIsADirectory:return 0;case c.FileNotADirectory:return 10;case c.FileWriteLocked:return 5;case c.NoPermissions:return 6;case c.FileExists:return 4;case c.FileExceedsMemoryLimit:return 9;case c.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var t;(function(A){A[A.CREATE=0]="CREATE",A[A.DELETE=1]="DELETE",A[A.MOVE=2]="MOVE",A[A.COPY=3]="COPY",A[A.WRITE=4]="WRITE"})(t=e.FileOperation||(e.FileOperation={}));class l{constructor(Z,ce,oe){this.resource=Z,this.operation=ce,this.target=oe}isOperation(Z){return this.operation===Z}}e.FileOperationEvent=l;var _;(function(A){A[A.UPDATED=0]="UPDATED",A[A.ADDED=1]="ADDED",A[A.DELETED=2]="DELETED"})(_=e.FileChangeType||(e.FileChangeType={}));class g{constructor(Z,ce){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=Z;const oe=new Map;for(const ue of Z){const te=oe.get(ue.type);switch(te?te.push([ue.resource,ue]):oe.set(ue.type,[[ue.resource,ue]]),ue.type){case 1:this.rawAdded.push(ue.resource);break;case 0:this.rawUpdated.push(ue.resource);break;case 2:this.rawDeleted.push(ue.resource);break}}for(const[ue,te]of oe)switch(ue){case 1:this.added=a.TernarySearchTree.forUris(()=>ce),this.added.fill(te);break;case 0:this.updated=a.TernarySearchTree.forUris(()=>ce),this.updated.fill(te);break;case 2:this.deleted=a.TernarySearchTree.forUris(()=>ce),this.deleted.fill(te);break}}contains(Z,...ce){return this.doContains(Z,{includeChildren:!1},...ce)}affects(Z,...ce){return this.doContains(Z,{includeChildren:!0},...ce)}doContains(Z,ce,...oe){if(!Z)return!1;const ue=oe.length>0;return!!((!ue||oe.includes(1))&&(this.added?.get(Z)||ce.includeChildren&&this.added?.findSuperstr(Z))||(!ue||oe.includes(0))&&(this.updated?.get(Z)||ce.includeChildren&&this.updated?.findSuperstr(Z))||(!ue||oe.includes(2))&&(this.deleted?.findSubstr(Z)||ce.includeChildren&&this.deleted?.findSuperstr(Z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=g;function C(A,Z,ce){return!A||!Z||A===Z||Z.length>A.length?!1:(Z.charAt(Z.length-1)!==p.sep&&(Z+=p.sep),ce?(0,b.startsWithIgnoreCase)(A,Z):A.indexOf(Z)===0)}e.isParent=C;class U extends Error{constructor(Z,ce,oe){super(Z);this.fileOperationResult=ce,this.options=oe}}e.FileOperationError=U;class W extends U{constructor(Z,ce,oe){super(Z,2,oe);this.stat=ce}}e.NotModifiedSinceFileOperationError=W;var M;(function(A){A[A.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",A[A.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",A[A.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",A[A.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",A[A.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",A[A.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",A[A.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",A[A.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",A[A.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",A[A.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",A[A.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",A[A.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(M=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var S;(function(A){A[A.FILE=0]="FILE",A[A.FOLDER=1]="FOLDER",A[A.ROOT_FOLDER=2]="ROOT_FOLDER"})(S=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function z(A){if(!(typeof A.size!="number"||typeof A.mtime!="number"))return A.mtime.toString(29)+A.size.toString(31)}e.etag=z;async function $(A,Z){if(!Z.hasProvider(D.URI.from({scheme:A.scheme})))return new Promise(ce=>{const oe=Z.onDidChangeFileSystemProviderRegistrations(ue=>{ue.scheme===A.scheme&&ue.added&&(oe.dispose(),ce())})})}e.whenProviderRegistered=$,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(Z){return(0,L.isNumber)(Z)||(Z=0),Z<F.KB?(0,k.localize)(1,null,Z.toFixed(0)):Z<F.MB?(0,k.localize)(2,null,(Z/F.KB).toFixed(2)):Z<F.GB?(0,k.localize)(3,null,(Z/F.MB).toFixed(2)):Z<F.TB?(0,k.localize)(4,null,(Z/F.GB).toFixed(2)):(0,k.localize)(5,null,(Z/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB;var q;(function(A){A[A.IA32=0]="IA32",A[A.OTHER=1]="OTHER"})(q=e.Arch||(e.Arch={}));function ie(A){return{maxFileSize:A===0?300*F.MB:16*F.GB,maxHeapSize:A===0?700*F.MB:2*700*F.MB}}e.getPlatformLimits=ie}),define(ye[58],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class a{constructor(...b){this._entries=new Map;for(const[L,D]of b)this.set(L,D)}set(b,L){const D=this._entries.get(b);return this._entries.set(b,L),D}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}e.ServiceCollection=a}),define(ye[148],De([1,0,14,11,78,146,3,58]),function(ne,e,a,p,b,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const E=!1;class P extends Error{constructor(f){super("cyclic dependency between services");this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class O{constructor(f=new k.ServiceCollection,h=!1,d){this._activeInstantiations=new Set,this._services=f,this._strict=h,this._parent=d,this._services.set(D.IInstantiationService,this)}createChild(f){return new O(f,this._strict,this)}invokeFunction(f,...h){const d=m.traceInvocation(f);let o=!1;try{return f({get:R=>{if(o)throw(0,p.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(R,d);if(!c)throw new Error(`[invokeFunction] unknown service '${R}'`);return c}},...h)}finally{o=!0,d.stop()}}createInstance(f,...h){let d,o;return f instanceof b.SyncDescriptor?(d=m.traceCreation(f.ctor),o=this._createInstance(f.ctor,f.staticArguments.concat(h),d)):(d=m.traceCreation(f),o=this._createInstance(f,h,d)),d.stop(),o}_createInstance(f,h=[],d){const o=D._util.getServiceDependencies(f).sort((c,w)=>c.index-w.index),v=[];for(const c of o){const w=this._getOrCreateServiceInstance(c.id,d);w||this._throwIfStrict(`[createInstance] ${f.name} depends on UNKNOWN service ${c.id}.`,!1),v.push(w)}const R=o.length>0?o[0].index:h.length;if(h.length!==R){console.trace(`[createInstance] First service dependency of ${f.name} at position ${R+1} conflicts with ${h.length} static arguments`);const c=R-h.length;c>0?h=h.concat(new Array(c)):h=h.slice(0,R)}return new f(...[...h,...v])}_setServiceInstance(f,h){if(this._services.get(f)instanceof b.SyncDescriptor)this._services.set(f,h);else if(this._parent)this._parent._setServiceInstance(f,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){const h=this._services.get(f);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):h}_getOrCreateServiceInstance(f,h){const d=this._getServiceInstanceOrDescriptor(f);return d instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,d,h.branch(f,!0)):(h.branch(f,!1),d)}_safeCreateAndCacheServiceInstance(f,h,d){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,h,d)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,h,d){const o=new L.Graph(c=>c.id.toString());let v=0;const R=[{id:f,desc:h,_trace:d}];for(;R.length;){const c=R.pop();if(o.lookupOrInsertNode(c),v++>1e3)throw new P(o);for(const w of D._util.getServiceDependencies(c.desc.ctor)){const s=this._getServiceInstanceOrDescriptor(w.id);if(s||this._throwIfStrict(`[createInstance] ${f} depends on ${w.id} which is NOT registered.`,!0),s instanceof b.SyncDescriptor){const u={id:w.id,desc:s,_trace:c._trace.branch(w.id,!0)};o.insertEdge(c,u),R.push(u)}}}for(;;){const c=o.roots();if(c.length===0){if(!o.isEmpty())throw new P(o);break}for(const{data:w}of c){if(this._getServiceInstanceOrDescriptor(w.id)instanceof b.SyncDescriptor){const u=this._createServiceInstanceWithOwner(w.id,w.desc.ctor,w.desc.staticArguments,w.desc.supportsDelayedInstantiation,w._trace);this._setServiceInstance(w.id,u)}o.removeNode(w)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,h,d=[],o,v){if(this._services.get(f)instanceof b.SyncDescriptor)return this._createServiceInstance(h,d,o,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,h,d,o,v);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(f,h=[],d,o){if(d){const v=new a.IdleValue(()=>this._createInstance(f,h,o));return new Proxy(Object.create(null),{get(R,c){if(c in R)return R[c];const w=v.value;let s=w[c];return typeof s!="function"||(s=s.bind(w),R[c]=s),s},set(R,c,w){return v.value[c]=w,!0}})}else return this._createInstance(f,h,o)}_throwIfStrict(f,h){if(h&&console.warn(f),this._strict)throw new Error(f)}}e.InstantiationService=O;var y;(function(T){T[T.Creation=0]="Creation",T[T.Invocation=1]="Invocation",T[T.Branch=2]="Branch"})(y||(y={}));class m{constructor(f,h){this.type=f,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(f){return E?new m(1,f.name||f.toString().substring(0,42).replace(/\n/g,"")):m._None}static traceCreation(f){return E?new m(0,f.name):m._None}branch(f,h){const d=new m(2,f.toString());return this._dep.push([f,h,d]),d}stop(){const f=Date.now()-this._start;m._totals+=f;let h=!1;function d(v,R){const c=[],w=new Array(v+1).join("	");for(const[s,u,n]of R._dep)if(u&&n){h=!0,c.push(`${w}CREATES -> ${s}`);const i=d(v+1,n);i&&c.push(i)}else c.push(`${w}uses -> ${s}`);return c.join(`
`)}const o=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(f>2||h)&&console.log(o.join(`
`))}}e.Trace=m,m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(ye[15],De([1,0,43,5,7,21,3]),function(ne,e,a,p,b,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,D.createDecorator)("logService"),e.ILoggerService=(0,D.createDecorator)("loggerService");function k(){return new Date().toISOString()}var E;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function P(u,n,i){switch(n){case E.Trace:u.trace(i);break;case E.Debug:u.debug(i);break;case E.Info:u.info(i);break;case E.Warning:u.warn(i);break;case E.Error:u.error(i);break;case E.Critical:u.critical(i);break;default:throw new Error("Invalid log level")}}e.log=P;function O(u){let n="";for(let i=0;i<u.length;i++){let r=u[i];if(typeof r=="object")try{r=JSON.stringify(r)}catch{}n+=(i>0?" ":"")+r}return n}e.format=O;class y extends b.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new p.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=y;class m extends y{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...i){this.checkLogLevel(E.Trace)&&this.log(E.Trace,O([n,...i]))}debug(n,...i){this.checkLogLevel(E.Debug)&&this.log(E.Debug,O([n,...i]))}info(n,...i){this.checkLogLevel(E.Info)&&this.log(E.Info,O([n,...i]))}warn(n,...i){this.checkLogLevel(E.Warning)&&this.log(E.Warning,O([n,...i]))}error(n,...i){if(this.checkLogLevel(E.Error))if(n instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=n.stack,this.log(E.Error,O(r))}else this.log(E.Error,O([n,...i]))}critical(n,...i){this.checkLogLevel(E.Critical)&&this.log(E.Critical,O([n,...i]))}flush(){}}e.AbstractMessageLogger=m;class T extends y{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!L.isWindows}trace(n,...i){this.getLevel()<=E.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,n,...i):console.log(`[main ${k()}]`,n,...i))}debug(n,...i){this.getLevel()<=E.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,n,...i):console.log(`[main ${k()}]`,n,...i))}info(n,...i){this.getLevel()<=E.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,n,...i):console.log(`[main ${k()}]`,n,...i))}warn(n,...i){this.getLevel()<=E.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,n,...i):console.warn(`[main ${k()}]`,n,...i))}error(n,...i){this.getLevel()<=E.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,n,...i):console.error(`[main ${k()}]`,n,...i))}critical(n,...i){this.getLevel()<=E.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,n,...i):console.error(`[main ${k()}]`,n,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=T;class f extends y{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...i){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",n,...i)}debug(n,...i){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...i)}info(n,...i){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",n,...i)}warn(n,...i){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",n,...i)}error(n,...i){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",n,...i)}critical(n,...i){this.getLevel()<=E.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...i)}dispose(){}flush(){}}e.ConsoleLogger=f;class h extends y{constructor(n,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(i)}trace(n,...i){this.getLevel()<=E.Trace&&this.adapter.log(E.Trace,[this.extractMessage(n),...i])}debug(n,...i){this.getLevel()<=E.Debug&&this.adapter.log(E.Debug,[this.extractMessage(n),...i])}info(n,...i){this.getLevel()<=E.Info&&this.adapter.log(E.Info,[this.extractMessage(n),...i])}warn(n,...i){this.getLevel()<=E.Warning&&this.adapter.log(E.Warning,[this.extractMessage(n),...i])}error(n,...i){this.getLevel()<=E.Error&&this.adapter.log(E.Error,[this.extractMessage(n),...i])}critical(n,...i){this.getLevel()<=E.Critical&&this.adapter.log(E.Critical,[this.extractMessage(n),...i])}extractMessage(n){return typeof n=="string"?n:(0,a.toErrorMessage)(n,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class d extends y{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const i of this.logServices)i.setLevel(n);super.setLevel(n)}trace(n,...i){for(const r of this.logServices)r.trace(n,...i)}debug(n,...i){for(const r of this.logServices)r.debug(n,...i)}info(n,...i){for(const r of this.logServices)r.info(n,...i)}warn(n,...i){for(const r of this.logServices)r.warn(n,...i)}error(n,...i){for(const r of this.logServices)r.error(n,...i)}critical(n,...i){for(const r of this.logServices)r.critical(n,...i)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=d;class o extends b.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...i){this.logger.trace(n,...i)}debug(n,...i){this.logger.debug(n,...i)}info(n,...i){this.logger.info(n,...i)}warn(n,...i){this.logger.warn(n,...i)}error(n,...i){this.logger.error(n,...i)}critical(n,...i){this.logger.critical(n,...i)}flush(){this.logger.flush()}}e.LogService=o;class v extends b.Disposable{constructor(n,i){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(t=>t.setLevel(r))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,i){let r=this.loggers.get(n.toString());return r||(r=this.doCreateLogger(n,i?.always?E.Trace:this.logLevel,i),this.loggers.set(n.toString(),r),i?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=v;class R{constructor(){this.onDidChangeLogLevel=new p.Emitter().event}setLevel(n){}getLevel(){return E.Info}trace(n,...i){}debug(n,...i){}info(n,...i){}warn(n,...i){}error(n,...i){}critical(n,...i){}dispose(){}flush(){}}e.NullLogService=R;function c(u){if(u.verbose)return E.Trace;if(typeof u.logLevel=="string"){const n=w(u.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function w(u){switch(u){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Critical;case"off":return E.Off}}e.parseLogLevel=w;function s(u){switch(u){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Critical:return"critical";case E.Off:return"off"}}e.LogLevelToString=s}),define(ye[80],De([1,0,29,127,3]),function(ne,e,a,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(L=e.MarkerTag||(e.MarkerTag={}));var D;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(D=e.MarkerSeverity||(e.MarkerSeverity={})),function(E){function P(f,h){return h-f}E.compare=P;const O=Object.create(null);O[E.Error]=(0,p.localize)(0,null),O[E.Warning]=(0,p.localize)(1,null),O[E.Info]=(0,p.localize)(2,null);function y(f){return O[f]||""}E.toString=y;function m(f){switch(f){case a.default.Error:return E.Error;case a.default.Warning:return E.Warning;case a.default.Info:return E.Info;case a.default.Ignore:return E.Hint}}E.fromSeverity=m;function T(f){switch(f){case E.Error:return a.default.Error;case E.Warning:return a.default.Warning;case E.Info:return a.default.Info;case E.Hint:return a.default.Ignore}}E.toSeverity=T}(D=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(E){const P="";function O(m){return y(m,!0)}E.makeKey=O;function y(m,T){const f=[P];return m.source?f.push(m.source.replace("\xA6","\\\xA6")):f.push(P),m.code?typeof m.code=="string"?f.push(m.code.replace("\xA6","\\\xA6")):f.push(m.code.value.replace("\xA6","\\\xA6")):f.push(P),m.severity!==void 0&&m.severity!==null?f.push(D.toString(m.severity)):f.push(P),m.message&&T?f.push(m.message.replace("\xA6","\\\xA6")):f.push(P),m.startLineNumber!==void 0&&m.startLineNumber!==null?f.push(m.startLineNumber.toString()):f.push(P),m.startColumn!==void 0&&m.startColumn!==null?f.push(m.startColumn.toString()):f.push(P),m.endLineNumber!==void 0&&m.endLineNumber!==null?f.push(m.endLineNumber.toString()):f.push(P),m.endColumn!==void 0&&m.endColumn!==null?f.push(m.endColumn.toString()):f.push(P),f.push(P),f.join("\xA6")}E.makeKeyOptionalMessage=y})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,b.createDecorator)("markerService")}),define(ye[149],De([1,0,5,29,3]),function(ne,e,a,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=p.default,e.INotificationService=(0,b.createDecorator)("notificationService");var L;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(L=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var D;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(D=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new E,this.onDidClose=a.Event.None,this.onDidChangeVisibility=a.Event.None}updateSeverity(O){}updateMessage(O){}updateActions(O){}close(){}}e.NoOpNotification=k;class E{infinite(){}done(){}total(O){}worked(O){}}e.NoOpProgress=E}),define(ye[81],De([1,0,7,9,2,3]),function(ne,e,a,p,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,L.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return a.Disposable.None},registerValidator(){return a.Disposable.None},registerExternalUriResolver(){return a.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return a.Disposable.None},async open(){return!1},async resolveExternalUri(O){return{resolved:O,dispose(){}}}});function D(O,y){return b.URI.isUri(O)?(0,p.equalsIgnoreCase)(O.scheme,y):(0,p.startsWithIgnoreCase)(O,y+":")}e.matchesScheme=D;function k(O,...y){return y.some(m=>D(O,m))}e.matchesSomeScheme=k;function E(O,y){return O.with({fragment:`${y.startLineNumber},${y.startColumn}${y.endLineNumber?`-${y.endLineNumber}${y.endColumn?`,${y.endColumn}`:""}`:""}`})}e.withSelection=E;function P(O){let y;const m=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(O.fragment);return m&&(y={startLineNumber:parseInt(m[1]),startColumn:m[2]?parseInt(m[2]):1,endLineNumber:m[4]?parseInt(m[4]):void 0,endColumn:m[4]?m[5]?parseInt(m[5]):1:void 0},O=O.with({fragment:""})),{selection:y,uri:O}}e.extractSelection=P}),define(ye[150],De([1,0,3]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,a.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var ze=this&&this.__decorate||function(ne,e,a,p){var b=arguments.length,L=b<3?e:p===null?p=Object.getOwnPropertyDescriptor(e,a):p,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(ne,e,a,p);else for(var k=ne.length-1;k>=0;k--)(D=ne[k])&&(L=(b<3?D(L):b>3?D(e,a,L):D(e,a))||L);return b>3&&L&&Object.defineProperty(e,a,L),L},xe=this&&this.__param||function(ne,e){return function(a,p){e(a,p,ne)}};define(ye[151],De([1,0,14,20,7,3]),function(ne,e,a,p,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,L.createDecorator)("progressService");var D;(function(O){O[O.Explorer=1]="Explorer",O[O.Scm=3]="Scm",O[O.Extensions=5]="Extensions",O[O.Window=10]="Window",O[O.Notification=15]="Notification",O[O.Dialog=20]="Dialog"})(D=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(y){this.callback=y}get value(){return this._value}report(y){this._value=y,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let E=class extends b.Disposable{constructor(y,m){super();this.deferred=new a.DeferredPromise,m.withProgress(y,T=>(this.reporter=T,this.lastStep&&T.report(this.lastStep),this.deferred.p)),this._register((0,b.toDisposable)(()=>this.deferred.complete()))}report(y){this.reporter?this.reporter.report(y):this.lastStep=y}};E=ze([xe(1,e.IProgressService)],E),e.UnmanagedProgress=E;class P extends b.Disposable{constructor(y){super();this.progressIndicator=y,this.currentOperationId=0,this.currentOperationDisposables=this._register(new b.DisposableStore)}start(y){this.stop();const m=++this.currentOperationId,T=new p.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{m===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},y),this.currentOperationDisposables.add((0,b.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,b.toDisposable)(()=>T.cancel())),this.currentOperationDisposables.add((0,b.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:m,token:T.token,stop:()=>this.doStop(m),isCurrent:()=>this.currentOperationId===m}}stop(){this.doStop(this.currentOperationId)}doStop(y){this.currentOperationId===y&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,L.createDecorator)("editorProgressService")}),define(ye[30],De([1,0,44,10]),function(ne,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class b{constructor(){this.data=new Map}add(D,k){a.ok(p.isString(D)),a.ok(p.isObject(k)),a.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,k)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new b}),define(ye[82],De([1,0,5,30]),function(ne,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function b(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class L{constructor(){this._onDidChangeSchema=new a.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,P){this.schemasById[b(E)]=P,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new L;p.Registry.add(e.Extensions.JSONContribution,D)}),define(ye[83],De([1,0,16,5,10,123,57,82,30]),function(ne,e,a,p,b,L,D,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var P;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(P=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var O;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const y=E.Registry.as(k.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new p.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new p.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(s,u=!0){this.registerConfigurations([s],u)}registerConfigurations(s,u=!0){const n=this.doRegisterConfigurations(s,u);y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(s){const u=this.doDeregisterConfigurations(s);y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u})}updateConfigurations({add:s,remove:u}){const n=[];n.push(...this.doDeregisterConfigurations(u)),n.push(...this.doRegisterConfigurations(s,!1)),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,a.distinct)(n)})}registerDefaultConfigurations(s){const u=[],n=[];for(const{overrides:i,source:r}of s)for(const t in i)if(u.push(t),e.OVERRIDE_PROPERTY_REGEX.test(t)){const l=this.configurationDefaultsOverrides.get(t),_=l?.valuesSources??new Map;if(r)for(const W of Object.keys(i[t]))_.set(W,r);const g={...l?.value||{},...i[t]};this.configurationDefaultsOverrides.set(t,{source:r,value:g,valuesSources:_});const C=(0,D.getLanguageTagSettingPlainKey)(t),U={type:"object",default:g,description:L.localize(1,null,C),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:g,source:b.isString(r)?void 0:r,defaultValueSource:r};n.push(...h(t)),this.configurationProperties[t]=U,this.defaultLanguageConfigurationOverridesNode.properties[t]=U}else{this.configurationDefaultsOverrides.set(t,{value:i[t],source:r});const l=this.configurationProperties[t];l&&(this.updatePropertyDefaultValue(t,l),this.updateSchema(t,l))}this.registerOverrideIdentifiers(n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}deregisterDefaultConfigurations(s){const u=[];for(const{overrides:n,source:i}of s)for(const r in n){const t=this.configurationDefaultsOverrides.get(r),l=b.isString(i)?i:i?.id,_=b.isString(t?.source)?t?.source:t?.source?.id;if(l===_)if(u.push(r),this.configurationDefaultsOverrides.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const g=this.configurationProperties[r];g&&(this.updatePropertyDefaultValue(r,g),this.updateSchema(r,g))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...s){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(s){for(const u of s)this.overrideIdentifiers.add(u);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(s,u){const n=[];return s.forEach(i=>{n.push(...this.validateAndRegisterProperties(i,u,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),n}doDeregisterConfigurations(s){const u=[],n=i=>{if(i.properties)for(const r in i.properties){u.push(r);const t=this.configurationProperties[r];t?.policy?.name&&this.policyConfigurations.delete(t.policy.name),delete this.configurationProperties[r],this.removeFromSchema(r,i.properties[r])}i.allOf?.forEach(r=>n(r))};for(const i of s){n(i);const r=this.configurationContributors.indexOf(i);r!==-1&&this.configurationContributors.splice(r,1)}return u}validateAndRegisterProperties(s,u=!0,n,i,r=3){r=b.isUndefinedOrNull(s.scope)?r:s.scope;const t=[],l=s.properties;if(l)for(const g in l){const C=l[g];if(u&&R(g,C)){delete l[g];continue}if(C.source=n,C.defaultDefaultValue=l[g].default,this.updatePropertyDefaultValue(g,C),e.OVERRIDE_PROPERTY_REGEX.test(g)?C.scope=void 0:(C.scope=b.isUndefinedOrNull(C.scope)?r:C.scope,C.restricted=b.isUndefinedOrNull(C.restricted)?!!i?.includes(g):C.restricted),l[g].hasOwnProperty("included")&&!l[g].included){this.excludedConfigurationProperties[g]=l[g],delete l[g];continue}else this.configurationProperties[g]=l[g],l[g].policy?.name&&this.policyConfigurations.set(l[g].policy.name,g);!l[g].deprecationMessage&&l[g].markdownDeprecationMessage&&(l[g].deprecationMessage=l[g].markdownDeprecationMessage),t.push(g)}const _=s.allOf;if(_)for(const g of _)t.push(...this.validateAndRegisterProperties(g,u,n,i,r));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(s){const u=n=>{const i=n.properties;if(i)for(const t in i)this.updateSchema(t,i[t]);n.allOf?.forEach(u)};u(s)}updateSchema(s,u){switch(e.allSettings.properties[s]=u,u.scope){case 1:e.applicationSettings.properties[s]=u;break;case 2:e.machineSettings.properties[s]=u;break;case 6:e.machineOverridableSettings.properties[s]=u;break;case 3:e.windowSettings.properties[s]=u;break;case 4:e.resourceSettings.properties[s]=u;break;case 5:e.resourceSettings.properties[s]=u,this.resourceLanguageSettingsSchema.properties[s]=u;break}}removeFromSchema(s,u){switch(delete e.allSettings.properties[s],u.scope){case 1:delete e.applicationSettings.properties[s];break;case 2:delete e.machineSettings.properties[s];break;case 6:delete e.machineOverridableSettings.properties[s];break;case 3:delete e.windowSettings.properties[s];break;case 4:case 5:delete e.resourceSettings.properties[s],delete this.resourceLanguageSettingsSchema.properties[s];break}}updateOverridePropertyPatternKey(){for(const s of this.overrideIdentifiers.values()){const u=`[${s}]`,n={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(u,n),e.allSettings.properties[u]=n,e.applicationSettings.properties[u]=n,e.machineSettings.properties[u]=n,e.machineOverridableSettings.properties[u]=n,e.windowSettings.properties[u]=n,e.resourceSettings.properties[u]=n}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const s={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(s,u){const n=this.configurationDefaultsOverrides.get(s);let i=n?.value,r=n?.source;b.isUndefined(i)&&(i=u.defaultDefaultValue,r=void 0),b.isUndefined(i)&&(i=o(u.type)),u.default=i,u.defaultValueSource=r}}const T="\\[([^\\]]+)\\]",f=new RegExp(T,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${T})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(w){const s=[];if(e.OVERRIDE_PROPERTY_REGEX.test(w)){let u=f.exec(w);for(;u?.length;){const n=u[1].trim();n&&s.push(n),u=f.exec(w)}}return(0,a.distinct)(s)}e.overrideIdentifiersFromKey=h;function d(w){return w.reduce((s,u)=>`${s}[${u}]`,"")}e.keyFromOverrideIdentifiers=d;function o(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=o;const v=new m;E.Registry.add(e.Extensions.Configuration,v);function R(w,s){return w.trim()?e.OVERRIDE_PROPERTY_REGEX.test(w)?L.localize(7,null,w):v.getConfigurationProperties()[w]!==void 0?L.localize(8,null,w):s.policy?.name&&v.getPolicyConfigurations().get(s.policy?.name)!==void 0?L.localize(9,null,w,s.policy?.name,v.getPolicyConfigurations().get(s.policy?.name)):null:L.localize(6,null)}e.validateProperty=R;function c(){const w=[],s=v.getConfigurationProperties();for(const u of Object.keys(s))w.push([u,s[u].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=c}),define(ye[152],De([1,0,16,5,105,7,25,26,10,2,57,83,30]),function(ne,e,a,p,b,L,D,k,E,P,O,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class T{constructor(u={},n=[],i=[]){this._contents=u,this._keys=n,this._overrides=i,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(u){return u?(0,O.getConfigurationValue)(this.contents,u):this.contents}getOverrideValue(u,n){const i=this.getContentsForOverrideIdentifer(n);return i?u?(0,O.getConfigurationValue)(i,u):i:void 0}getKeysForOverrideIdentifier(u){const n=[];for(const i of this.overrides)i.identifiers.includes(u)&&n.push(...i.keys);return a.distinct(n)}getAllOverrideIdentifiers(){const u=[];for(const n of this.overrides)u.push(...n.identifiers);return a.distinct(u)}override(u){let n=this.overrideConfigurations.get(u);return n||(n=this.createOverrideConfigurationModel(u),this.overrideConfigurations.set(u,n)),n}merge(...u){const n=k.deepClone(this.contents),i=k.deepClone(this.overrides),r=[...this.keys];for(const t of u)if(!t.isEmpty()){this.mergeContents(n,t.contents);for(const l of t.overrides){const[_]=i.filter(g=>a.equals(g.identifiers,l.identifiers));_?(this.mergeContents(_.contents,l.contents),_.keys.push(...l.keys),_.keys=a.distinct(_.keys)):i.push(k.deepClone(l))}for(const l of t.keys)r.indexOf(l)===-1&&r.push(l)}return new T(n,r,i)}freeze(){return this.frozen=!0,this}clone(){return new T(k.deepClone(this.contents),[...this.keys],k.deepClone(this.overrides))}createOverrideConfigurationModel(u){const n=this.getContentsForOverrideIdentifer(u);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const i={};for(const r of a.distinct([...Object.keys(this.contents),...Object.keys(n)])){let t=this.contents[r];const l=n[r];l&&(typeof t=="object"&&typeof l=="object"?(t=k.deepClone(t),this.mergeContents(t,l)):t=l),i[r]=t}return new T(i,this.keys,this.overrides)}mergeContents(u,n){for(const i of Object.keys(n)){if(i in u&&E.isObject(u[i])&&E.isObject(n[i])){this.mergeContents(u[i],n[i]);continue}u[i]=k.deepClone(n[i])}}checkAndFreeze(u){return this.frozen&&!Object.isFrozen(u)?k.deepFreeze(u):u}getContentsForOverrideIdentifer(u){let n=null,i=null;const r=t=>{t&&(i?this.mergeContents(i,t):i=k.deepClone(t))};for(const t of this.overrides)a.equals(t.identifiers,[u])?n=t.contents:t.identifiers.includes(u)&&r(t.contents);return r(n),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(u,n){this.addKey(u),(0,O.addToValueTree)(this.contents,u,n,i=>{throw new Error(i)})}removeValue(u){this.removeKey(u)&&(0,O.removeFromValueTree)(this.contents,u)}addKey(u){let n=this.keys.length;for(let i=0;i<n;i++)u.indexOf(this.keys[i])===0&&(n=i);this.keys.splice(n,1,u)}removeKey(u){const n=this.keys.indexOf(u);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=T;class f{constructor(u){this._name=u,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new T}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(u,n){if(!E.isUndefinedOrNull(u)){const i=this.doParseContent(u);this.parseRaw(i,n)}}reparse(u){this._raw&&this.parseRaw(this._raw,u)}parseRaw(u,n){this._raw=u;const{contents:i,keys:r,overrides:t,restricted:l}=this.doParseRaw(u,n);this._configurationModel=new T(i,r,t),this._restrictedConfigurations=l||[]}doParseContent(u){let n={},i=null,r=[];const t=[],l=[];function _(C){Array.isArray(r)?r.push(C):i!==null&&(r[i]=C)}const g={onObjectBegin:()=>{const C={};_(C),t.push(r),r=C,i=null},onObjectProperty:C=>{i=C},onObjectEnd:()=>{r=t.pop()},onArrayBegin:()=>{const C=[];_(C),t.push(r),r=C,i=null},onArrayEnd:()=>{r=t.pop()},onLiteralValue:_,onError:(C,U,W)=>{l.push({error:C,offset:U,length:W})}};if(u)try{b.visit(u,g),n=r[0]||{}}catch(C){console.error(`Error while parsing settings file ${this._name}: ${C}`),this._parseErrors=[C]}return n}doParseRaw(u,n){const i=m.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),r=this.filter(u,i,!0,n);u=r.raw;const t=(0,O.toValuesTree)(u,g=>console.error(`Conflict in settings file ${this._name}: ${g}`)),l=Object.keys(u),_=this.toOverrides(u,g=>console.error(`Conflict in settings file ${this._name}: ${g}`));return{contents:t,keys:l,overrides:_,restricted:r.restricted}}filter(u,n,i,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:u,restricted:[]};const t={},l=[];for(const _ in u)if(y.OVERRIDE_PROPERTY_REGEX.test(_)&&i){const g=this.filter(u[_],n,!1,r);t[_]=g.raw,l.push(...g.restricted)}else{const g=n[_],C=g?typeof g.scope!="undefined"?g.scope:3:void 0;g?.restricted&&l.push(_),(C===void 0||r.scopes===void 0||r.scopes.includes(C))&&(r.skipRestricted&&g?.restricted||(t[_]=u[_]))}return{raw:t,restricted:l}}toOverrides(u,n){const i=[];for(const r of Object.keys(u))if(y.OVERRIDE_PROPERTY_REGEX.test(r)){const t={};for(const l in u[r])t[l]=u[r][l];i.push({identifiers:(0,y.overrideIdentifiersFromKey)(r),keys:Object.keys(t),contents:(0,O.toValuesTree)(t,n)})}return i}}e.ConfigurationModelParser=f;class h extends L.Disposable{constructor(u,n,i,r){super();this.userSettingsResource=u,this.scopes=n,this.fileService=r,this._onDidChange=this._register(new p.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(p.Event.any(p.Event.filter(this.fileService.onDidFilesChange,t=>t.contains(this.userSettingsResource)),p.Event.filter(this.fileService.onDidRunOperation,t=>(t.isOperation(0)||t.isOperation(3)||t.isOperation(1)||t.isOperation(4))&&i.isEqual(t.resource,u)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const u=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(u.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new T}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=h;class d{constructor(u,n,i,r,t=new T,l=new T,_=new D.ResourceMap,g=new T,C=new D.ResourceMap,U=!0){this._defaultConfiguration=u,this._policyConfiguration=n,this._applicationConfiguration=i,this._localUserConfiguration=r,this._remoteUserConfiguration=t,this._workspaceConfiguration=l,this._folderConfigurations=_,this._memoryConfiguration=g,this._memoryConfigurationByResource=C,this._freeze=U,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(u,n,i){return this.getConsolidatedConfigurationModel(u,n,i).getValue(u)}updateValue(u,n,i={}){let r;i.resource?(r=this._memoryConfigurationByResource.get(i.resource),r||(r=new T,this._memoryConfigurationByResource.set(i.resource,r))):r=this._memoryConfiguration,n===void 0?r.removeValue(u):r.setValue(u,n),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(u,n,i){const r=this.getConsolidatedConfigurationModel(u,n,i),t=this.getFolderConfigurationModelForResource(n.resource,i),l=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,_=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(u):this._defaultConfiguration.freeze().getValue(u),g=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(u),C=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(u),U=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(u):this.userConfiguration.freeze().getValue(u),W=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(u):this.localUserConfiguration.freeze().getValue(u),M=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(u):this.remoteUserConfiguration.freeze().getValue(u),S=i?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(u):this._workspaceConfiguration.freeze().getValue(u):void 0,z=t?n.overrideIdentifier?t.freeze().override(n.overrideIdentifier).getValue(u):t.freeze().getValue(u):void 0,$=n.overrideIdentifier?l.override(n.overrideIdentifier).getValue(u):l.getValue(u),F=r.getValue(u),q=a.distinct(r.overrides.map(ie=>ie.identifiers).flat()).filter(ie=>r.getOverrideValue(u,ie)!==void 0);return{defaultValue:_,policyValue:g,applicationValue:C,userValue:U,userLocalValue:W,userRemoteValue:M,workspaceValue:S,workspaceFolderValue:z,memoryValue:$,value:F,default:_!==void 0?{value:this._defaultConfiguration.freeze().getValue(u),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(u,n.overrideIdentifier):void 0}:void 0,policy:g!==void 0?{value:g}:void 0,application:C!==void 0?{value:C,override:n.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(u,n.overrideIdentifier):void 0}:void 0,user:U!==void 0?{value:this.userConfiguration.freeze().getValue(u),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(u,n.overrideIdentifier):void 0}:void 0,userLocal:W!==void 0?{value:this.localUserConfiguration.freeze().getValue(u),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(u,n.overrideIdentifier):void 0}:void 0,userRemote:M!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(u),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(u,n.overrideIdentifier):void 0}:void 0,workspace:S!==void 0?{value:this._workspaceConfiguration.freeze().getValue(u),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(u,n.overrideIdentifier):void 0}:void 0,workspaceFolder:z!==void 0?{value:t?.freeze().getValue(u),override:n.overrideIdentifier?t?.freeze().getOverrideValue(u,n.overrideIdentifier):void 0}:void 0,memory:$!==void 0?{value:l.getValue(u),override:n.overrideIdentifier?l.getOverrideValue(u,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:q.length?q:void 0}}keys(u){const n=this.getFolderConfigurationModelForResource(void 0,u);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(u){this._defaultConfiguration=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(u){this._policyConfiguration=u}updateApplicationConfiguration(u){this._applicationConfiguration=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(u){this._localUserConfiguration=u,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(u){this._remoteUserConfiguration=u,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(u){this._workspaceConfiguration=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(u,n){this._folderConfigurations.set(u,n),this._foldersConsolidatedConfigurations.delete(u)}deleteFolderConfiguration(u){this.folderConfigurations.delete(u),this._foldersConsolidatedConfigurations.delete(u)}compareAndUpdateDefaultConfiguration(u,n){const i=[];if(!n){const{added:r,updated:t,removed:l}=c(this._defaultConfiguration,u);n=[...r,...t,...l]}for(const r of n)for(const t of(0,y.overrideIdentifiersFromKey)(r)){const l=this._defaultConfiguration.getKeysForOverrideIdentifier(t),_=u.getKeysForOverrideIdentifier(t),g=[..._.filter(C=>l.indexOf(C)===-1),...l.filter(C=>_.indexOf(C)===-1),...l.filter(C=>!k.equals(this._defaultConfiguration.override(t).getValue(C),u.override(t).getValue(C)))];i.push([t,g])}return this.updateDefaultConfiguration(u),{keys:n,overrides:i}}compareAndUpdatePolicyConfiguration(u){const{added:n,updated:i,removed:r}=c(this._policyConfiguration,u),t=[...n,...i,...r];return t.length&&this.updatePolicyConfiguration(u),{keys:t,overrides:[]}}compareAndUpdateApplicationConfiguration(u){const{added:n,updated:i,removed:r,overrides:t}=c(this.applicationConfiguration,u),l=[...n,...i,...r];return l.length&&this.updateApplicationConfiguration(u),{keys:l,overrides:t}}compareAndUpdateLocalUserConfiguration(u){const{added:n,updated:i,removed:r,overrides:t}=c(this.localUserConfiguration,u),l=[...n,...i,...r];return l.length&&this.updateLocalUserConfiguration(u),{keys:l,overrides:t}}compareAndUpdateRemoteUserConfiguration(u){const{added:n,updated:i,removed:r,overrides:t}=c(this.remoteUserConfiguration,u),l=[...n,...i,...r];return l.length&&this.updateRemoteUserConfiguration(u),{keys:l,overrides:t}}compareAndUpdateWorkspaceConfiguration(u){const{added:n,updated:i,removed:r,overrides:t}=c(this.workspaceConfiguration,u),l=[...n,...i,...r];return l.length&&this.updateWorkspaceConfiguration(u),{keys:l,overrides:t}}compareAndUpdateFolderConfiguration(u,n){const i=this.folderConfigurations.get(u),{added:r,updated:t,removed:l,overrides:_}=c(i,n),g=[...r,...t,...l];return(g.length||!i)&&this.updateFolderConfiguration(u,n),{keys:g,overrides:_}}compareAndDeleteFolderConfiguration(u){const n=this.folderConfigurations.get(u);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(u);const{added:i,updated:r,removed:t,overrides:l}=c(n,void 0);return{keys:[...i,...r,...t],overrides:l}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(u,n,i){let r=this.getConsolidatedConfigurationModelForResource(n,i);return n.overrideIdentifier&&(r=r.override(n.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(u)!==void 0&&(r=r.merge(this._policyConfiguration)),r}getConsolidatedConfigurationModelForResource({resource:u},n){let i=this.getWorkspaceConsolidatedConfiguration();if(n&&u){const r=n.getFolder(u);r&&(i=this.getFolderConsolidatedConfiguration(r.uri)||i);const t=this._memoryConfigurationByResource.get(u);t&&(i=i.merge(t))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(u){let n=this._foldersConsolidatedConfigurations.get(u);if(!n){const i=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(u);r?(n=i.merge(r),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(u,n)):n=i}return n}getFolderConfigurationModelForResource(u,n){if(n&&u){const i=n.getFolder(u);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((u,n)=>{const{contents:i,overrides:r,keys:t}=this._folderConfigurations.get(n);return u.push([n,{contents:i,overrides:r,keys:t}]),u},[])}}allKeys(){const u=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>u.add(n)),this.userConfiguration.freeze().keys.forEach(n=>u.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>u.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(i=>u.add(i))),[...u.values()]}allOverrideIdentifiers(){const u=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>u.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>u.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>u.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(i=>u.add(i))),[...u.values()]}getAllKeysForOverrideIdentifier(u){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(u).forEach(i=>n.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(u).forEach(i=>n.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(u).forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(u).forEach(r=>n.add(r))),[...n.values()]}static parse(u){const n=this.parseConfigurationModel(u.defaults),i=this.parseConfigurationModel(u.policy),r=this.parseConfigurationModel(u.application),t=this.parseConfigurationModel(u.user),l=this.parseConfigurationModel(u.workspace),_=u.folders.reduce((g,C)=>(g.set(P.URI.revive(C[0]),this.parseConfigurationModel(C[1])),g),new D.ResourceMap);return new d(n,i,r,t,new T,l,_,new T,new D.ResourceMap,!1)}static parseConfigurationModel(u){return new T(u.contents,u.keys,u.overrides).freeze()}}e.Configuration=d;function o(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const u=new Set,n=new Map;for(const r of s)r.keys.forEach(t=>u.add(t)),r.overrides.forEach(([t,l])=>{const _=(0,D.getOrSet)(n,t,new Set);l.forEach(g=>_.add(g))});const i=[];return n.forEach((r,t)=>i.push([t,[...r.values()]])),{keys:[...u.values()],overrides:i}}e.mergeChanges=o;class v{constructor(u,n,i,r){this.change=u,this.previous=n,this.currentConfiguraiton=i,this.currentWorkspace=r,this._previousConfiguration=void 0;const t=new Set;u.keys.forEach(_=>t.add(_)),u.overrides.forEach(([,_])=>_.forEach(g=>t.add(g))),this.affectedKeys=[...t.values()];const l=new T;this.affectedKeys.forEach(_=>l.setValue(_,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=d.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(u,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,u)){if(n){const i=this.previousConfiguration?this.previousConfiguration.getValue(u,n,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(u,n,this.currentWorkspace);return!k.equals(i,r)}return!0}return!1}doesAffectedKeysTreeContains(u,n){let i=(0,O.toValuesTree)({[n]:!0},()=>{}),r;for(;typeof i=="object"&&(r=Object.keys(i)[0]);){if(u=u[r],!u)return!1;i=i[r]}return!0}}e.ConfigurationChangeEvent=v;class R extends v{constructor(u,n,i,r){super({keys:u.allKeys(),overrides:[]},void 0,u,n);this.source=i,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=R;function c(s,u){const{added:n,removed:i,updated:r}=w(u,s),t=[],l=s?.getAllOverrideIdentifiers()||[],_=u?.getAllOverrideIdentifiers()||[];if(u){const g=_.filter(C=>!l.includes(C));for(const C of g)t.push([C,u.getKeysForOverrideIdentifier(C)])}if(s){const g=l.filter(C=>!_.includes(C));for(const C of g)t.push([C,s.getKeysForOverrideIdentifier(C)])}if(u&&s){for(const g of l)if(_.includes(g)){const C=w({contents:s.getOverrideValue(void 0,g)||{},keys:s.getKeysForOverrideIdentifier(g)},{contents:u.getOverrideValue(void 0,g)||{},keys:u.getKeysForOverrideIdentifier(g)});t.push([g,[...C.added,...C.removed,...C.updated]])}}return{added:n,removed:i,updated:r,overrides:t}}function w(s,u){const n=s?u?s.keys.filter(t=>u.keys.indexOf(t)===-1):[...s.keys]:[],i=u?s?u.keys.filter(t=>s.keys.indexOf(t)===-1):[...u.keys]:[],r=[];if(s&&u){for(const t of u.keys)if(s.keys.indexOf(t)!==-1){const l=(0,O.getConfigurationValue)(u.contents,t),_=(0,O.getConfigurationValue)(s.contents,t);k.equals(l,_)||r.push(t)}}return{added:n,removed:i,updated:r}}}),define(ye[84],De([1,0,11,3]),function(ne,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,p.createDecorator)("remoteAuthorityResolverService");var b;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(b=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends a.ErrorNoTelemetry{constructor(k,E=b.Unknown,P){super(k);this._message=k,this._code=E,this._detail=P,this.isHandled=E===b.NotAvailable&&P===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}static isTemporarilyNotAvailable(k){return k instanceof L&&k._code===b.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof L&&k._code===b.NoResolverFound}static isHandled(k){return k instanceof L&&k.isHandled}}e.RemoteAuthorityResolverError=L}),define(ye[85],De([1,0,12]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function p(P){return P.scheme===a.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=p;function b(P){if(!P)return;const O=P.indexOf("+");return O<0?P:P.substr(0,O)}e.getRemoteName=b;function L(P){return`/${P.quality??"oss"}-${P.commit??"dev"}`}e.getRemoteServerRootPath=L;function D(P){const{host:O,port:y}=E(P);if(typeof y=="undefined")throw new Error("Remote authority doesn't contain a port!");return{host:O,port:y}}e.parseAuthorityWithPort=D;function k(P,O){let{host:y,port:m}=E(P);return typeof m=="undefined"&&(m=O),{host:y,port:m}}e.parseAuthorityWithOptionalPort=k;function E(P){const O=P.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(O)return{host:O[1],port:parseInt(O[2],10)};const y=P.match(/^(\[[0-9a-z:]+\])$/);if(y)return{host:y[1],port:void 0};const m=P.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:P,port:void 0}}}),define(ye[27],De([1,0,9,3,85]),function(ne,e,a,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=L;function D(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));var E;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(E=e.TargetPlatform||(e.TargetPlatform={}));class P{constructor(h){this.value=h,this._lower=h.toLowerCase()}static equals(h,d){if(typeof h=="undefined"||h===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof h=="string"||typeof d=="string"){const o=typeof h=="string"?h:h.value,v=typeof d=="string"?d:d.value;return a.equalsIgnoreCase(o,v)}return h._lower===d._lower}static toKey(h){return typeof h=="string"?h.toLowerCase():h._lower}}e.ExtensionIdentifier=P;function O(f){return y(f)}e.isApplicationScopedExtension=O;function y(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function m(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function T(f,h){if(h){const d=`onResolveRemoteAuthority:${(0,b.getRemoteName)(h)}`;return f.activationEvents?.indexOf(d)!==-1}return!1}e.isResolverExtension=T,e.IBuiltinExtensionsScannerService=(0,p.createDecorator)("IBuiltinExtensionsScannerService")}),define(ye[153],De([1,0,9,79,27,21,2,11,59]),function(ne,e,a,p,b,L,D,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(u,n){return u.uuid&&n.uuid?u.uuid===n.uuid:u.id===n.id?!0:(0,a.compareIgnoreCase)(u.id,n.id)===0}e.areSameExtensions=P;const O=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{constructor(n,i,r="undefined"){this.version=i,this.targetPlatform=r,this.id=n.id}static create(n){const i=n.manifest?n.manifest.version:n.version,r=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new y(n.identifier,i,r)}static parse(n){const i=O.exec(n);return i&&i[1]&&i[2]?new y({id:i[1]},i[2],i[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof y?P(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=y;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function T(u){const n=m.exec(u);return n&&n[1]?[h(n[1]),n[2]]:[h(u),void 0]}e.getIdAndVersion=T;function f(u,n){return`${u}.${n}`}e.getExtensionId=f;function h(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=h;function d(u,n){return h(f(u,n))}e.getGalleryExtensionId=d;function o(u,n){const i=[],r=t=>{for(const l of i)if(l.some(_=>P(n(_),n(t))))return l;return null};for(const t of u){const l=r(t);l?l.push(t):i.push([t])}return i}e.groupByExtension=o;function v(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function R(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=R,e.BetterMergeId=new b.ExtensionIdentifier("pprice.better-merge");function c(u,n){const i=[],r=n.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const t=r.shift();if(t&&i.every(l=>!P(l.identifier,{id:t}))){const l=u.filter(_=>P(_.identifier,{id:t}));l.length===1&&(i.push(l[0]),r.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.getExtensionDependencies=c;async function w(u,n){if(!L.isLinux)return!1;let i;try{i=(await u.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await u.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(t){n.debug("Error while getting the os-release file.",(0,k.getErrorMessage)(t))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=w;async function s(u,n){const i=await w(u,n),r=(0,p.getTargetPlatform)(i?"alpine":L.platform,E.arch);return n.debug("ComputeTargetPlatform:",r),r}e.computeTargetPlatform=s}),define(ye[154],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class a{constructor(b){this._callback=b,this._terminalBufferMap=new Map}dispose(){for(const b of this._terminalBufferMap.values())b.dispose()}startBuffering(b,L,D=5){const k=L(E=>{const P=typeof E=="string"?E:E.data;let O=this._terminalBufferMap.get(b);if(O){O.data.push(P);return}const y=setTimeout(()=>this.flushBuffer(b),D);O={data:[P],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(b),k.dispose()}},this._terminalBufferMap.set(b,O)});return k}stopBuffering(b){this._terminalBufferMap.get(b)?.dispose()}flushBuffer(b){const L=this._terminalBufferMap.get(b);L&&(this._terminalBufferMap.delete(b),this._callback(b,L.data.join("")))}}e.TerminalDataBufferer=a}),define(ye[155],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var a;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST_DARK="hcDark",L.HIGH_CONTRAST_LIGHT="hcLight"})(a=e.ColorScheme||(e.ColorScheme={}));function p(L){return L===a.HIGH_CONTRAST_DARK||L===a.HIGH_CONTRAST_LIGHT}e.isHighContrast=p;function b(L){return L===a.DARK||L===a.HIGH_CONTRAST_DARK}e.isDark=b}),define(ye[60],De([1,0,116,5,7,3,30,155]),function(ne,e,a,p,b,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,L.createDecorator)("themeService");var E;(function(d){function o(v){return v&&typeof v=="object"&&typeof v.id=="string"}d.isThemeColor=o})(E=e.ThemeColor||(e.ThemeColor={}));function P(d){return{id:d}}e.themeColorFromId=P;var O;(function(d){function o(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||E.isThemeColor(i.color))}d.isThemeIcon=o;const v=new RegExp(`^\\$\\((${a.CSSIcon.iconNameExpression}(?:${a.CSSIcon.iconModifierExpression})?)\\)$`);function R(i){const r=v.exec(i);if(!r)return;const[,t]=r;return{id:t}}d.fromString=R;function c(i){return{id:i}}d.fromId=c;function w(i,r){let t=i.id;const l=t.lastIndexOf("~");return l!==-1&&(t=t.substring(0,l)),r&&(t=`${t}~${r}`),{id:t}}d.modify=w;function s(i){const r=i.id.lastIndexOf("~");if(r!==-1)return i.id.substring(r+1)}d.getModifier=s;function u(i,r){return i.id===r.id&&i.color?.id===r.color?.id}d.isEqual=u;function n(i,r){return{id:i.id,color:r?P(r):void 0}}d.asThemeIcon=n,d.asClassNameArray=a.CSSIcon.asClassNameArray,d.asClassName=a.CSSIcon.asClassName,d.asCSSSelector=a.CSSIcon.asCSSSelector})(O=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=a.Codicon.file,e.FolderThemeIcon=a.Codicon.folder;function y(d){switch(d){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case k.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=y,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new p.Emitter}onColorThemeChange(o){return this.themingParticipants.push(o),this.onThemingParticipantAddedEmitter.fire(o),(0,b.toDisposable)(()=>{const v=this.themingParticipants.indexOf(o);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const T=new m;D.Registry.add(e.Extensions.ThemingContribution,T);function f(d){return T.onColorThemeChange(d)}e.registerThemingParticipant=f;class h extends b.Disposable{constructor(o){super();this.themeService=o,this.theme=o.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(o){this.theme=o,this.updateStyles()}updateStyles(){}getColor(o,v){let R=this.theme.getColor(o);return R&&v&&(R=v(R,this.theme)),R?R.toString():null}}e.Themable=h}),define(ye[156],De([1,0,5,21,3,15]),function(ne,e,a,p,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,b.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,b.createDecorator)("sharedTunnelsService");var D;(function(h){h.Http="http",h.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var E;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(E=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function P(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function O(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=O,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=y;function m(h,d){return d?d!==1&&h<1024:!p.isWindows&&h<1024}e.isPortPrivileged=m;class T{constructor(d,o,v){this.remoteAddress=d,this.localAddress=o,this._dispose=v,this._onDispose=new a.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=T;let f=class{constructor(d){this.logService=d,this._onTunnelOpened=new a.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new a.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new a.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(d){return this._tunnelProvider=d,d?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(d){this._canElevate=d.elevation,this._privacyOptions=d.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const d=[],o=Array.from(this._tunnels.values());for(const v of o){const R=Array.from(v.values());for(const c of R){const w=await c.value;w&&d.push(w)}}return d}async dispose(){for(const d of this._tunnels.values()){for(const{value:o}of d.values())await o.then(v=>v?.dispose());d.clear()}this._tunnels.clear()}openTunnel(d,o,v,R,c=!1,w,s){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${o}:${v} on local port ${R}.`),!d)return;if(o||(o="localhost"),this._tunnelProvider&&this._factoryInProgress.has(v)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const u=this.retainOrCreateTunnel(d,o,v,R,c,w,s);return u?u.then(n=>{if(!n){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(o,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(n);return(n.tunnelRemoteHost!==o||n.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),u)}makeTunnel(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,privacy:d.privacy,protocol:d.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const o=this._tunnels.get(d.tunnelRemoteHost);if(o){const v=o.get(d.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(d.tunnelRemoteHost,d.tunnelRemotePort,v))}}}}async tryDisposeTunnel(d,o,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${o}.`);const R=v.value.then(async c=>{c&&(await c.dispose(!0),this._onTunnelClosed.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this._tunnels.has(d)&&this._tunnels.get(d).delete(o),R}}async closeTunnel(d,o){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${o} `);const v=this._tunnels.get(d);if(v&&v.has(o)){const R=v.get(o);R.refcount=0,await this.tryDisposeTunnel(d,o,R)}}addTunnelToMap(d,o,v){this._tunnels.has(d)||this._tunnels.set(d,new Map),this._tunnels.get(d).set(o,{refcount:1,value:v})}async removeEmptyTunnelFromMap(d,o){const v=this._tunnels.get(d);v&&(await v.get(o)||v.delete(o),v.size===0&&this._tunnels.delete(d))}getTunnelFromMap(d,o){const v=[d];O(d)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):y(d)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const R=v.map(c=>this._tunnels.get(c));for(const c of R){const w=c?.get(o);if(w)return w}}canTunnel(d){return!!P(d)}createWithProvider(d,o,v,R,c,w,s){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${o}:${v} on local port ${R}.`);const u=v;this._factoryInProgress.add(u);const i={elevationRequired:c?m(R===void 0?v:R):!1},r={remoteAddress:{host:o,port:v},localAddressPort:R,privacy:w,public:w?w!==k.Private:void 0,protocol:s},t=d.forwardPort(r,i);return t?(this.addTunnelToMap(o,v,t),t.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(u)})):this._factoryInProgress.delete(u),t}};f=ze([xe(0,L.ILogService)],f),e.AbstractTunnelService=f}),define(ye[157],De([1,0,12]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function p(E){return E.scheme!==a.Schemas.file&&E.scheme!==a.Schemas.vscodeRemote}e.isVirtualResource=p;function b(E){if(E.folders.length)return E.folders.every(P=>p(P.uri))?E.folders[0].uri:void 0;if(E.configuration&&p(E.configuration))return E.configuration}e.getVirtualWorkspaceLocation=b;function L(E){return b(E)?.scheme}e.getVirtualWorkspaceScheme=L;function D(E){return b(E)?.authority}e.getVirtualWorkspaceAuthority=D;function k(E){return b(E)!==void 0}e.isVirtualWorkspace=k}),define(ye[45],De([1,0,128,19,25,22,2,3,12]),function(ne,e,a,p,b,L,D,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");function P(n){const i=n;return typeof i?.id=="string"&&D.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=P;function O(n){if(n.configuration)return{id:n.id,configPath:n.configuration};if(n.folders.length===1)return{id:n.id,uri:n.folders[0].uri}}e.toWorkspaceIdentifier=O;function y(n){const i=n;return typeof i?.id=="string"&&D.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=y;function m(n){const i=n;if(i?.uri)return{id:i.id,uri:D.URI.revive(i.uri)};const r=n;if(r?.configPath)return{id:r.id,configPath:D.URI.revive(r.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=m;var T;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(T=e.WorkbenchState||(e.WorkbenchState={}));function f(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=f;function h(n){const i=n;return!!(i&&typeof i=="object"&&D.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=h;class d{constructor(i,r,t,l,_){this._id=i,this._transient=t,this._configuration=l,this._ignorePathCasing=_,this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i)||null}updateFoldersMap(){this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=d;class o{constructor(i,r){this.raw=r,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,L.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=o;function v(n){return new o({uri:n,index:0,name:(0,L.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace";const R=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,a.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function c(n,i){return L.extUriBiasedIgnorePathCase.isEqualOrParent(n,i.untitledWorkspacesHome)}e.isUntitledWorkspace=c;function w(n){let i;return D.URI.isUri(n)?i=n:i=n.configuration,i?.scheme===E.Schemas.tmp}e.isTemporaryWorkspace=w;function s(n,i){return!c(n,i)&&!w(n)}e.isSavedWorkspace=s;function u(n){return(typeof n=="string"?(0,p.extname)(n):(0,L.extname)(n))===R}e.hasWorkspaceFileExtension=u}),define(ye[61],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class a{constructor(b){this.id=b,this._data=new Map,this._idPool=1}add(b){const L=this._idPool++;return this._data.set(L,b),this.logDebugInfo(),L}get(b,L){return this._data.has(b)?this._data.get(b)[L]:void 0}delete(b){this._data.delete(b),this.logDebugInfo()}logDebugInfo(){!a.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=a,a.enableDebugLogging=!1}),define(ye[35],De([1,0,12,22,3]),function(ne,e,a,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class L{constructor(){this._systemSchemes=new Set(Object.keys(a.Schemas)),this._providerInfo=new Map,this.extUri=new p.ExtUri(k=>{const E=this._providerInfo.get(k.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos(k,E){E===null?this._providerInfo.delete(k.scheme):this._providerInfo.set(k.scheme,E)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=L,e.IExtHostFileSystemInfo=(0,b.createDecorator)("IExtHostFileSystemInfo")}),define(ye[28],De([1,0,3]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,a.createDecorator)("IExtHostInitDataService")}),define(ye[158],De([1,0,14]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class p{constructor(D,k,E){this._deferredPromises=new Map,this._id=D,this._shared=k,this._storage=E,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new a.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const O of P.values())O.complete()}catch(O){for(const y of P.values())y.error(O)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,D])=>D!==void 0).map(([D])=>D)}get whenReady(){return this._init}get(D,k){let E=this._value[D];return typeof E=="undefined"&&(E=k),E}update(D,k){this._value[D]=k;const E=this._deferredPromises.get(D);if(E!==void 0)return E.p;const P=new a.DeferredPromise;return this._deferredPromises.set(D,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=p;class b extends p{constructor(D,k){super(D.identifier.value,!0,k);this._extension=D}setKeysForSync(D){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},D)}}e.ExtensionGlobalMemento=b}),define(ye[159],De([1,0,5,2]),function(ne,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class b{constructor(D){this._notebooksAndEditors=D,this._onDidSaveNotebookDocument=new a.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new a.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(D,k,E,P){const y=this._notebooksAndEditors.getNotebookDocument(p.URI.revive(D)).acceptModelChanged(k.value,E,P);this._onDidChangeNotebookDocument.fire(y)}$acceptDirtyStateChanged(D,k){this._notebooksAndEditors.getNotebookDocument(p.URI.revive(D)).acceptDirty(k)}$acceptModelSaved(D){const k=this._notebooksAndEditors.getNotebookDocument(p.URI.revive(D));this._onDidSaveNotebookDocument.fire(k.apiNotebook)}}e.ExtHostNotebookDocuments=b}),define(ye[13],De([1,0,3]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,a.createDecorator)("IExtHostRpcService");class p{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.ExtHostRpcService=p});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,a,p,b){if(p==="m")throw new TypeError("Private method is not writable");if(p==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return p==="a"?b.call(ne,a):b?b.value=a:e.set(ne,a),a},Oe=this&&this.__classPrivateFieldGet||function(ne,e,a,p){if(a==="a"&&!p)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!p:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?p:a==="a"?p.call(ne):p?p.value:e.get(ne)};define(ye[160],De([1,0,27,5]),function(ne,e,a,p){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class L{constructor(k,E){b.set(this,void 0),this._onDidChange=new p.Emitter,this.onDidChange=this._onDidChange.event,this._id=a.ExtensionIdentifier.toKey(k.identifier),Ye(this,b,E,"f"),Oe(this,b,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(k){return Oe(this,b,"f").get(this._id,k)}store(k,E){return Oe(this,b,"f").store(this._id,k,E)}delete(k){return Oe(this,b,"f").delete(this._id,k)}}e.ExtensionSecrets=L,b=new WeakMap}),define(ye[86],De([1,0,3,5]),function(ne,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class b{constructor(){this._onDidChangeTelemetryEnabled=new p.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new p.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}$initializeTelemetryLevel(D,k){this._level=D,this._productConfig=k||{usage:!0,error:!0}}$onDidChangeTelemetryLevel(D){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=D,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=b,e.IExtHostTelemetry=(0,a.createDecorator)("IExtHostTelemetry")}),define(ye[62],De([1,0,3,156,5,13]),function(ne,e,a,p,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var D;(function(E){function P(y){return{remoteAddress:y.remoteAddress,localAddress:y.localAddress,public:!!y.public,privacy:y.privacy??(y.public?p.TunnelPrivacyId.Public:p.TunnelPrivacyId.Private),protocol:y.protocol}}E.fromApiTunnel=P;function O(y){return{remoteAddress:{host:y.tunnelRemoteHost,port:y.tunnelRemotePort},localAddress:y.localAddress,public:y.privacy!==p.TunnelPrivacyId.ConstantPrivate&&y.privacy!==p.TunnelPrivacyId.ConstantPrivate,privacy:y.privacy,protocol:y.protocol}}E.fromServiceTunnel=O})(D=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,a.createDecorator)("IExtHostTunnelService");let k=class{constructor(P){this.onDidChangeTunnels=new b.Emitter().event}async $applyCandidateFilter(P){return P}async openTunnel(P,O){}async getTunnels(){return[]}async setTunnelFactory(P){return{dispose:()=>{}}}registerPortsAttributesProvider(P,O){return{dispose:()=>{}}}async $providePortAttributes(P,O,y,m,T){return[]}async $forwardPort(P,O){}async $closeTunnel(P){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=ze([xe(0,L.IExtHostRpcService)],k),e.ExtHostTunnelService=k});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,a,p,b){if(p==="m")throw new TypeError("Private method is not writable");if(p==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return p==="a"?b.call(ne,a):b?b.value=a:e.set(ne,a),a},Oe=this&&this.__classPrivateFieldGet||function(ne,e,a,p){if(a==="a"&&!p)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!p:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?p:a==="a"?p.call(ne):p?p.value:e.get(ne)};define(ye[6],De([1,0,16,11,75,25,74,9,10,2,42,39,84]),function(ne,e,a,p,b,L,D,k,E,P,O,y,m){"use strict";var T,f,h,d,o,v,R,c,w,s,u,n,i,r,t,l,_,g,C,U,W,M,S;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function z(x){function N(){return Reflect.construct(x,arguments,this.constructor)}return Object.defineProperty(N,"name",Object.getOwnPropertyDescriptor(x,"name")),Object.setPrototypeOf(N,x),Object.setPrototypeOf(N.prototype,x.prototype),N}let $=v=class{constructor(N){T.set(this,void 0),Ye(this,T,N,"f")}static from(...N){let Y=N;return new v(function(){if(Y){for(const _e of Y)_e&&typeof _e.dispose=="function"&&_e.dispose();Y=void 0}})}dispose(){typeof Oe(this,T,"f")=="function"&&(Oe(this,T,"f").call(this),Ye(this,T,void 0,"f"))}};T=new WeakMap,$=v=ze([z],$),e.Disposable=$;let F=R=class{constructor(N,Y){if(N<0)throw(0,p.illegalArgument)("line must be non-negative");if(Y<0)throw(0,p.illegalArgument)("character must be non-negative");this._line=N,this._character=Y}static Min(...N){if(N.length===0)throw new TypeError;let Y=N[0];for(let _e=1;_e<N.length;_e++){const Ke=N[_e];Ke.isBefore(Y)&&(Y=Ke)}return Y}static Max(...N){if(N.length===0)throw new TypeError;let Y=N[0];for(let _e=1;_e<N.length;_e++){const Ke=N[_e];Ke.isAfter(Y)&&(Y=Ke)}return Y}static isPosition(N){if(!N)return!1;if(N instanceof R)return!0;const{line:Y,character:_e}=N;return typeof Y=="number"&&typeof _e=="number"}static of(N){if(N instanceof R)return N;if(this.isPosition(N))return new R(N.line,N.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(N){return this._line<N._line?!0:N._line<this._line?!1:this._character<N._character}isBeforeOrEqual(N){return this._line<N._line?!0:N._line<this._line?!1:this._character<=N._character}isAfter(N){return!this.isBeforeOrEqual(N)}isAfterOrEqual(N){return!this.isBefore(N)}isEqual(N){return this._line===N._line&&this._character===N._character}compareTo(N){return this._line<N._line?-1:this._line>N.line?1:this._character<N._character?-1:this._character>N._character?1:0}translate(N,Y=0){if(N===null||Y===null)throw(0,p.illegalArgument)();let _e;return typeof N=="undefined"?_e=0:typeof N=="number"?_e=N:(_e=typeof N.lineDelta=="number"?N.lineDelta:0,Y=typeof N.characterDelta=="number"?N.characterDelta:0),_e===0&&Y===0?this:new R(this.line+_e,this.character+Y)}with(N,Y=this.character){if(N===null||Y===null)throw(0,p.illegalArgument)();let _e;return typeof N=="undefined"?_e=this.line:typeof N=="number"?_e=N:(_e=typeof N.line=="number"?N.line:this.line,Y=typeof N.character=="number"?N.character:this.character),_e===this.line&&Y===this.character?this:new R(_e,Y)}toJSON(){return{line:this.line,character:this.character}}};F=R=ze([z],F),e.Position=F;let q=c=class{constructor(N,Y,_e,Ke){let et,at;if(typeof N=="number"&&typeof Y=="number"&&typeof _e=="number"&&typeof Ke=="number"?(et=new F(N,Y),at=new F(_e,Ke)):F.isPosition(N)&&F.isPosition(Y)&&(et=F.of(N),at=F.of(Y)),!et||!at)throw new Error("Invalid arguments");et.isBefore(at)?(this._start=et,this._end=at):(this._start=at,this._end=et)}static isRange(N){return N instanceof c?!0:N?F.isPosition(N.start)&&F.isPosition(N.end):!1}static of(N){if(N instanceof c)return N;if(this.isRange(N))return new c(N.start,N.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(N){return c.isRange(N)?this.contains(N.start)&&this.contains(N.end):F.isPosition(N)?!(F.of(N).isBefore(this._start)||this._end.isBefore(N)):!1}isEqual(N){return this._start.isEqual(N._start)&&this._end.isEqual(N._end)}intersection(N){const Y=F.Max(N.start,this._start),_e=F.Min(N.end,this._end);if(!Y.isAfter(_e))return new c(Y,_e)}union(N){if(this.contains(N))return this;if(N.contains(this))return N;const Y=F.Min(N.start,this._start),_e=F.Max(N.end,this.end);return new c(Y,_e)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(N,Y=this.end){if(N===null||Y===null)throw(0,p.illegalArgument)();let _e;return N?F.isPosition(N)?_e=N:(_e=N.start||this.start,Y=N.end||this.end):_e=this.start,_e.isEqual(this._start)&&Y.isEqual(this.end)?this:new c(_e,Y)}toJSON(){return[this.start,this.end]}};q=c=ze([z],q),e.Range=q;let ie=w=class extends q{constructor(N,Y,_e,Ke){let et,at;if(typeof N=="number"&&typeof Y=="number"&&typeof _e=="number"&&typeof Ke=="number"?(et=new F(N,Y),at=new F(_e,Ke)):F.isPosition(N)&&F.isPosition(Y)&&(et=F.of(N),at=F.of(Y)),!et||!at)throw new Error("Invalid arguments");super(et,at);this._anchor=et,this._active=at}static isSelection(N){return N instanceof w?!0:N?q.isRange(N)&&F.isPosition(N.anchor)&&F.isPosition(N.active)&&typeof N.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};ie=w=ze([z],ie),e.Selection=ie;class A{constructor(N,Y,_e){if(typeof N!="string"||N.length===0)throw(0,p.illegalArgument)("host");if(typeof Y!="number"||Y===0||Math.round(Y)!==Y)throw(0,p.illegalArgument)("port");if(typeof _e!="undefined"&&(typeof _e!="string"||_e.length===0||!/^[0-9A-Za-z\-]+$/.test(_e)))throw(0,p.illegalArgument)("connectionToken");this.host=N,this.port=Math.round(Y),this.connectionToken=_e}}e.ResolvedAuthority=A;class Z extends Error{constructor(N,Y=m.RemoteAuthorityResolverErrorCode.Unknown,_e){super(N);this._message=N,this._code=Y,this._detail=_e,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,Z.prototype)}static NotAvailable(N,Y){return new Z(N,m.RemoteAuthorityResolverErrorCode.NotAvailable,Y)}static TemporarilyNotAvailable(N){return new Z(N,m.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=Z;var ce;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})(ce=e.EndOfLine||(e.EndOfLine={}));var oe;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(oe=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ue=s=class{constructor(N,Y){this._range=N,this._newText=Y}static isTextEdit(N){return N instanceof s?!0:N?q.isRange(N)&&typeof N.newText=="string":!1}static replace(N,Y){return new s(N,Y)}static insert(N,Y){return s.replace(new q(N,N),Y)}static delete(N){return s.replace(N,"")}static setEndOfLine(N){const Y=new s(new q(new F(0,0),new F(0,0)),"");return Y.newEol=N,Y}get range(){return this._range}set range(N){if(N&&!q.isRange(N))throw(0,p.illegalArgument)("range");this._range=N}get newText(){return this._newText||""}set newText(N){if(N&&typeof N!="string")throw(0,p.illegalArgument)("newText");this._newText=N}get newEol(){return this._newEol}set newEol(N){if(N&&typeof N!="number")throw(0,p.illegalArgument)("newEol");this._newEol=N}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ue=s=ze([z],ue),e.TextEdit=ue;let te=u=class{constructor(N,Y){this.range=N,this.newCells=Y}static isNotebookCellEdit(N){return N instanceof u?!0:N?xt.isNotebookRange(N)&&Array.isArray(N.newCells):!1}static replaceCells(N,Y){return new u(N,Y)}static insertCells(N,Y){return new u(new xt(N,N),Y)}static deleteCells(N){return new u(N,[])}static updateCellMetadata(N,Y){const _e=new u(new xt(N,N),[]);return _e.newCellMetadata=Y,_e}static updateNotebookMetadata(N){const Y=new u(new xt(0,0),[]);return Y.newNotebookMetadata=N,Y}};te=u=ze([z],te),e.NotebookEdit=te;var Ee;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellReplace=5]="CellReplace",x[x.Snippet=6]="Snippet"})(Ee=e.FileEditType||(e.FileEditType={}));let be=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(N,Y,_e,Ke){this._edits.push({_type:1,from:N,to:Y,options:_e,metadata:Ke})}createFile(N,Y,_e){this._edits.push({_type:1,from:void 0,to:N,options:Y,metadata:_e})}deleteFile(N,Y,_e){this._edits.push({_type:1,from:N,to:void 0,options:Y,metadata:_e})}replaceNotebookMetadata(N,Y,_e){this._edits.push({_type:3,metadata:_e,uri:N,edit:{editType:5,metadata:Y},notebookMetadata:Y})}replaceNotebookCells(N,Y,_e,Ke,et){let at,ct,St=[],At;if(xt.isNotebookRange(Y)&&Gt.isNotebookCellDataArray(_e)&&!Gt.isNotebookCellDataArray(Ke)?(at=Y.start,ct=Y.end,St=_e,At=Ke):typeof Y=="number"&&typeof _e=="number"&&Gt.isNotebookCellDataArray(Ke)&&(at=Y,ct=_e,St=Ke,At=et),at===void 0||ct===void 0)throw new Error("Invalid arguments");(at!==ct||St.length>0)&&this._edits.push({_type:5,uri:N,index:at,count:ct-at,cells:St,metadata:At})}replaceNotebookCellMetadata(N,Y,_e,Ke){this._edits.push({_type:3,metadata:Ke,uri:N,edit:{editType:8,index:Y,metadata:_e}})}replace(N,Y,_e,Ke){typeof _e=="string"?this._edits.push({_type:2,uri:N,edit:new ue(Y,_e),metadata:Ke}):this._edits.push({_type:6,uri:N,range:Y,edit:_e,metadata:Ke})}insert(N,Y,_e,Ke){this.replace(N,new q(Y,Y),_e,Ke)}delete(N,Y,_e){this.replace(N,Y,"",_e)}has(N){return this._edits.some(Y=>Y._type===2&&Y.uri.toString()===N.toString())}set(N,Y){if(Y)for(const _e of Y)_e&&(te.isNotebookCellEdit(_e)?_e.newCellMetadata?this.replaceNotebookCellMetadata(N,_e.range.start,_e.newCellMetadata):_e.newNotebookMetadata?this.replaceNotebookMetadata(N,_e.newNotebookMetadata):this.replaceNotebookCells(N,_e.range,_e.newCells):this._edits.push({_type:2,uri:N,edit:_e}));else{for(let _e=0;_e<this._edits.length;_e++){const Ke=this._edits[_e];Ke._type===2&&Ke.uri.toString()===N.toString()&&(this._edits[_e]=void 0)}(0,a.coalesceInPlace)(this._edits)}}get(N){const Y=[];for(const _e of this._edits)_e._type===2&&_e.uri.toString()===N.toString()&&Y.push(_e.edit);return Y}entries(){const N=new L.ResourceMap;for(const Y of this._edits)if(Y._type===2){let _e=N.get(Y.uri);_e||(_e=[Y.uri,[]],N.set(Y.uri,_e)),_e[1].push(Y.edit)}return[...N.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};be=ze([z],be),e.WorkspaceEdit=be;let ee=n=class{constructor(N){this._tabstop=1,this.value=N||""}static isSnippetString(N){return N instanceof n?!0:N?typeof N.value=="string":!1}static _escape(N){return N.replace(/\$|}|\\/g,"\\$&")}appendText(N){return this.value+=n._escape(N),this}appendTabstop(N=this._tabstop++){return this.value+="$",this.value+=N,this}appendPlaceholder(N,Y=this._tabstop++){if(typeof N=="function"){const _e=new n;_e._tabstop=this._tabstop,N(_e),this._tabstop=_e._tabstop,N=_e.value}else N=n._escape(N);return this.value+="${",this.value+=Y,this.value+=":",this.value+=N,this.value+="}",this}appendChoice(N,Y=this._tabstop++){const _e=N.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=Y,this.value+="|",this.value+=_e,this.value+="|}",this}appendVariable(N,Y){if(typeof Y=="function"){const _e=new n;_e._tabstop=this._tabstop,Y(_e),this._tabstop=_e._tabstop,Y=_e.value}else typeof Y=="string"&&(Y=Y.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=N,Y&&(this.value+=":",this.value+=Y),this.value+="}",this}};ee=n=ze([z],ee),e.SnippetString=ee;var ve;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(ve=e.DiagnosticTag||(e.DiagnosticTag={}));var Ae;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(Ae=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Fe=i=class{constructor(N,Y){if(this.uri=N,Y)if(q.isRange(Y))this.range=q.of(Y);else if(F.isPosition(Y))this.range=new q(Y,Y);else throw new Error("Illegal argument")}static isLocation(N){return N instanceof i?!0:N?q.isRange(N.range)&&P.URI.isUri(N.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Fe=i=ze([z],Fe),e.Location=Fe;let $e=class{constructor(N,Y){this.location=N,this.message=Y}static is(N){return N?typeof N.message=="string"&&N.location&&q.isRange(N.location.range)&&P.URI.isUri(N.location.uri):!1}static isEqual(N,Y){return N===Y?!0:!N||!Y?!1:N.message===Y.message&&N.location.range.isEqual(Y.location.range)&&N.location.uri.toString()===Y.location.uri.toString()}};$e=ze([z],$e),e.DiagnosticRelatedInformation=$e;let Qe=class{constructor(N,Y,_e=Ae.Error){if(!q.isRange(N))throw new TypeError("range must be set");if(!Y)throw new TypeError("message must be set");this.range=N,this.message=Y,this.severity=_e}toJSON(){return{severity:Ae[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(N,Y){return N===Y?!0:!N||!Y?!1:N.message===Y.message&&N.severity===Y.severity&&N.code===Y.code&&N.severity===Y.severity&&N.source===Y.source&&N.range.isEqual(Y.range)&&(0,a.equals)(N.tags,Y.tags)&&(0,a.equals)(N.relatedInformation,Y.relatedInformation,$e.isEqual)}};Qe=ze([z],Qe),e.Diagnostic=Qe;let Ie=class{constructor(N,Y){if(!N)throw new Error("Illegal argument, contents must be defined");Array.isArray(N)?this.contents=N:this.contents=[N],this.range=Y}};Ie=ze([z],Ie),e.Hover=Ie;var Se;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(Se=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ke=class{constructor(N,Y=Se.Text){this.range=N,this.kind=Y}toJSON(){return{range:this.range,kind:Se[this.kind]}}};ke=ze([z],ke),e.DocumentHighlight=ke;var ae;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(ae=e.SymbolKind||(e.SymbolKind={}));var le;(function(x){x[x.Deprecated=1]="Deprecated"})(le=e.SymbolTag||(e.SymbolTag={}));let G=r=class{constructor(N,Y,_e,Ke,et){this.name=N,this.kind=Y,this.containerName=et,typeof _e=="string"&&(this.containerName=_e),Ke instanceof Fe?this.location=Ke:_e instanceof q&&(this.location=new Fe(Ke,_e)),r.validate(this)}static validate(N){if(!N.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:ae[this.kind],location:this.location,containerName:this.containerName}}};G=r=ze([z],G),e.SymbolInformation=G;let Q=t=class{constructor(N,Y,_e,Ke,et){this.name=N,this.detail=Y,this.kind=_e,this.range=Ke,this.selectionRange=et,this.children=[],t.validate(this)}static validate(N){if(!N.name)throw new Error("name must not be falsy");if(!N.range.contains(N.selectionRange))throw new Error("selectionRange must be contained in fullRange");N.children?.forEach(t.validate)}};Q=t=ze([z],Q),e.DocumentSymbol=Q;var I;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(I=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let B=class{constructor(N,Y){this.title=N,this.kind=Y}};B=ze([z],B),e.CodeAction=B;let H=l=class{constructor(N){this.value=N}append(N){return new l(this.value?this.value+l.sep+N:N)}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+l.sep)}};H.sep=".",H=l=ze([z],H),e.CodeActionKind=H,H.Empty=new H(""),H.QuickFix=H.Empty.append("quickfix"),H.Refactor=H.Empty.append("refactor"),H.RefactorExtract=H.Refactor.append("extract"),H.RefactorInline=H.Refactor.append("inline"),H.RefactorRewrite=H.Refactor.append("rewrite"),H.Source=H.Empty.append("source"),H.SourceOrganizeImports=H.Source.append("organizeImports"),H.SourceFixAll=H.Source.append("fixAll");let V=class{constructor(N,Y){if(this.range=N,this.parent=Y,Y&&!Y.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};V=ze([z],V),e.SelectionRange=V;class se{constructor(N,Y,_e,Ke,et,at){this.kind=N,this.name=Y,this.detail=_e,this.uri=Ke,this.range=et,this.selectionRange=at}}e.CallHierarchyItem=se;class de{constructor(N,Y){this.fromRanges=Y,this.from=N}}e.CallHierarchyIncomingCall=de;class J{constructor(N,Y){this.fromRanges=Y,this.to=N}}e.CallHierarchyOutgoingCall=J;var pe;(function(x){x[x.Information=0]="Information",x[x.Warning=1]="Warning",x[x.Error=2]="Error"})(pe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let ge=class{constructor(N,Y){this.range=N,this.command=Y}get isResolved(){return!!this.command}};ge=ze([z],ge),e.CodeLens=ge;let Ne=_=class{constructor(N,Y=!1){f.set(this,void 0),Ye(this,f,new b.MarkdownString(N,{supportThemeIcons:Y}),"f")}static isMarkdownString(N){return N instanceof _?!0:N&&N.appendCodeblock&&N.appendMarkdown&&N.appendText&&N.value!==void 0}get value(){return Oe(this,f,"f").value}set value(N){Oe(this,f,"f").value=N}get isTrusted(){return Oe(this,f,"f").isTrusted}set isTrusted(N){Oe(this,f,"f").isTrusted=N}get supportThemeIcons(){return Oe(this,f,"f").supportThemeIcons}set supportThemeIcons(N){Oe(this,f,"f").supportThemeIcons=N}get supportHtml(){return Oe(this,f,"f").supportHtml}set supportHtml(N){Oe(this,f,"f").supportHtml=N}get baseUri(){return Oe(this,f,"f").baseUri}set baseUri(N){Oe(this,f,"f").baseUri=N}appendText(N){return Oe(this,f,"f").appendText(N),this}appendMarkdown(N){return Oe(this,f,"f").appendMarkdown(N),this}appendCodeblock(N,Y){return Oe(this,f,"f").appendCodeblock(Y??"",N),this}};f=new WeakMap,Ne=_=ze([z],Ne),e.MarkdownString=Ne;let Be=class{constructor(N,Y){this.label=N,this.documentation=Y}};Be=ze([z],Be),e.ParameterInformation=Be;let Je=class{constructor(N,Y){this.label=N,this.documentation=Y,this.parameters=[]}};Je=ze([z],Je),e.SignatureInformation=Je;let Ge=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ge=ze([z],Ge),e.SignatureHelp=Ge;var Te;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(Te=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var rt;(function(x){x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(rt=e.InlayHintKind||(e.InlayHintKind={}));let K=class{constructor(N){this.value=N}};K=ze([z],K),e.InlayHintLabelPart=K;let X=class{constructor(N,Y,_e){this.position=N,this.label=Y,this.kind=_e}};X=ze([z],X),e.InlayHint=X;var fe;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(fe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ue;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(Ue=e.CompletionItemKind||(e.CompletionItemKind={}));var He;(function(x){x[x.Deprecated=1]="Deprecated"})(He=e.CompletionItemTag||(e.CompletionItemTag={}));let Ze=class{constructor(N,Y){this.label=N,this.kind=Y}toJSON(){return{label:this.label,kind:this.kind&&Ue[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ze=ze([z],Ze),e.CompletionItem=Ze;let qe=class{constructor(N=[],Y=!1){this.items=N,this.isIncomplete=Y}};qe=ze([z],qe),e.CompletionList=qe;let We=class{constructor(N,Y,_e){this.insertText=N,this.range=Y,this.command=_e}};We=ze([z],We),e.InlineSuggestion=We;let nt=class{constructor(N){this.commands=void 0,this.items=N}};nt=ze([z],nt),e.InlineSuggestionList=nt;let ot=class{constructor(N,Y,_e){this.insertText=N,this.range=Y,this.command=_e}};ot=ze([z],ot),e.InlineSuggestionNew=ot;let ht=class{constructor(N,Y){this.items=N,this.commands=Y}};ht=ze([z],ht),e.InlineSuggestionsNew=ht;var kt;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(kt=e.ViewColumn||(e.ViewColumn={}));var it;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(it=e.StatusBarAlignment||(e.StatusBarAlignment={}));var dt;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(dt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ot;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(Ot=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Wt;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(Wt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Dt;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(Dt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ft;(function(x){x[x.Undo=1]="Undo",x[x.Redo=2]="Redo"})(ft=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Ct;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(Ct=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(x){function N(Y){switch(Y){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=N}(Dt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Lt=class{constructor(N,Y){if(Y&&!P.URI.isUri(Y))throw(0,p.illegalArgument)("target");if(!q.isRange(N)||N.isEmpty)throw(0,p.illegalArgument)("range");this.range=N,this.target=Y}};Lt=ze([z],Lt),e.DocumentLink=Lt;let Ft=class{constructor(N,Y,_e,Ke){this.red=N,this.green=Y,this.blue=_e,this.alpha=Ke}};Ft=ze([z],Ft),e.Color=Ft;let Ve=class{constructor(N,Y){if(Y&&!(Y instanceof Ft))throw(0,p.illegalArgument)("color");if(!q.isRange(N)||N.isEmpty)throw(0,p.illegalArgument)("range");this.range=N,this.color=Y}};Ve=ze([z],Ve),e.ColorInformation=Ve;let Nt=class{constructor(N){if(!N||typeof N!="string")throw(0,p.illegalArgument)("label");this.label=N}};Nt=ze([z],Nt),e.ColorPresentation=Nt;var Rt;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(Rt=e.ColorFormat||(e.ColorFormat={}));var Ut;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(Ut=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var vt;(function(x){x[x.Unknown=0]="Unknown",x[x.Shutdown=1]="Shutdown",x[x.Process=2]="Process",x[x.User=3]="User",x[x.Extension=4]="Extension"})(vt=e.TerminalExitReason||(e.TerminalExitReason={}));class we{constructor(N,Y,_e){if(this.startIndex=N,this.length=Y,this.tooltip=_e,typeof N!="number"||N<0)throw(0,p.illegalArgument)("startIndex");if(typeof Y!="number"||Y<1)throw(0,p.illegalArgument)("length");if(_e!==void 0&&typeof _e!="string")throw(0,p.illegalArgument)("tooltip")}}e.TerminalLink=we;var Ce;(function(x){x[x.Panel=1]="Panel",x[x.Editor=2]="Editor"})(Ce=e.TerminalLocation||(e.TerminalLocation={}));class me{constructor(N){if(this.options=N,typeof N!="object")throw(0,p.illegalArgument)("options")}}e.TerminalProfile=me;var j;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(j=e.TaskRevealKind||(e.TaskRevealKind={}));var Pe;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(Pe=e.TaskPanelKind||(e.TaskPanelKind={}));let Le=g=class{constructor(N,Y){if(this.label=Y,typeof N!="string"||typeof Y!="string")throw(0,p.illegalArgument)("name");this._id=N}static from(N){switch(N){case"clean":return g.Clean;case"build":return g.Build;case"rebuild":return g.Rebuild;case"test":return g.Test;default:return}}get id(){return this._id}};Le.Clean=new g("clean","Clean"),Le.Build=new g("build","Build"),Le.Rebuild=new g("rebuild","Rebuild"),Le.Test=new g("test","Test"),Le=g=ze([z],Le),e.TaskGroup=Le;function tt(x){let N="";for(let Y=0;Y<x.length;Y++)N+=x[Y].replace(/,/g,",,")+",";return N}let Xe=class{constructor(N,Y,_e){if(typeof N!="string")throw(0,p.illegalArgument)("process");this._args=[],this._process=N,Y!==void 0&&(Array.isArray(Y)?(this._args=Y,this._options=_e):this._options=Y)}get process(){return this._process}set process(N){if(typeof N!="string")throw(0,p.illegalArgument)("process");this._process=N}get args(){return this._args}set args(N){Array.isArray(N)||(N=[]),this._args=N}get options(){return this._options}set options(N){this._options=N}computeId(){const N=[];if(N.push("process"),this._process!==void 0&&N.push(this._process),this._args&&this._args.length>0)for(const Y of this._args)N.push(Y);return tt(N)}};Xe=ze([z],Xe),e.ProcessExecution=Xe;let je=class{constructor(N,Y,_e){if(this._args=[],Array.isArray(Y)){if(!N)throw(0,p.illegalArgument)("command can't be undefined or null");if(typeof N!="string"&&typeof N.value!="string")throw(0,p.illegalArgument)("command");this._command=N,this._args=Y,this._options=_e}else{if(typeof N!="string")throw(0,p.illegalArgument)("commandLine");this._commandLine=N,this._options=Y}}get commandLine(){return this._commandLine}set commandLine(N){if(typeof N!="string")throw(0,p.illegalArgument)("commandLine");this._commandLine=N}get command(){return this._command?this._command:""}set command(N){if(typeof N!="string"&&typeof N.value!="string")throw(0,p.illegalArgument)("command");this._command=N}get args(){return this._args}set args(N){this._args=N||[]}get options(){return this._options}set options(N){this._options=N}computeId(){const N=[];if(N.push("shell"),this._commandLine!==void 0&&N.push(this._commandLine),this._command!==void 0&&N.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const Y of this._args)N.push(typeof Y=="string"?Y:Y.value);return tt(N)}};je=ze([z],je),e.ShellExecution=je;var ut;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(ut=e.ShellQuoting||(e.ShellQuoting={}));var gt;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(gt=e.TaskScope||(e.TaskScope={}));class yt{constructor(N){this._callback=N}computeId(){return"customExecution"+(0,O.generateUuid)()}set callback(N){this._callback=N}get callback(){return this._callback}}e.CustomExecution=yt;let pt=C=class{constructor(N,Y,_e,Ke,et,at){this.__deprecated=!1,this._definition=this.definition=N;let ct;typeof Y=="string"?(this._name=this.name=Y,this._source=this.source=_e,this.execution=Ke,ct=et,this.__deprecated=!0):Y===gt.Global||Y===gt.Workspace?(this.target=Y,this._name=this.name=_e,this._source=this.source=Ke,this.execution=et,ct=at):(this.target=Y,this._name=this.name=_e,this._source=this.source=Ke,this.execution=et,ct=at),typeof ct=="string"?(this._problemMatchers=[ct],this._hasDefinedMatchers=!0):Array.isArray(ct)?(this._problemMatchers=ct,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(N){this.__id=N}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Xe?this._definition={type:C.ProcessType,id:this._execution.computeId()}:this._execution instanceof je?this._definition={type:C.ShellType,id:this._execution.computeId()}:this._execution instanceof yt?this._definition={type:C.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:C.EmptyType,id:(0,O.generateUuid)()}}get definition(){return this._definition}set definition(N){if(N==null)throw(0,p.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=N}get scope(){return this._scope}set target(N){this.clear(),this._scope=N}get name(){return this._name}set name(N){if(typeof N!="string")throw(0,p.illegalArgument)("name");this.clear(),this._name=N}get execution(){return this._execution}set execution(N){N===null&&(N=void 0),this.clear(),this._execution=N;const Y=this._definition.type;(C.EmptyType===Y||C.ProcessType===Y||C.ShellType===Y||C.ExtensionCallbackType===Y)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(N){if(Array.isArray(N))this.clear(),this._problemMatchers=N,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(N){N!==!0&&N!==!1&&(N=!1),this.clear(),this._isBackground=N}get source(){return this._source}set source(N){if(typeof N!="string"||N.length===0)throw(0,p.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=N}get group(){return this._group}set group(N){N===null&&(N=void 0),this.clear(),this._group=N}get detail(){return this._detail}set detail(N){N===null&&(N=void 0),this._detail=N}get presentationOptions(){return this._presentationOptions}set presentationOptions(N){N==null&&(N=Object.create(null)),this.clear(),this._presentationOptions=N}get runOptions(){return this._runOptions}set runOptions(N){N==null&&(N=Object.create(null)),this.clear(),this._runOptions=N}};pt.ExtensionCallbackType="customExecution",pt.ProcessType="process",pt.ShellType="shell",pt.EmptyType="$empty",pt=C=ze([z],pt),e.Task=pt;var _t;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(_t=e.ProgressLocation||(e.ProgressLocation={}));let Pt=U=class{constructor(N,Y=mt.None){this.collapsibleState=Y,P.URI.isUri(N)?this.resourceUri=N:this.label=N}static isTreeItem(N){if(N instanceof U)return!0;const Y=N;if(Y.label!==void 0&&!(0,E.isString)(Y.label)&&!Y.label.label)return console.log("INVALID tree item, invalid label",Y.label),!1;if(Y.id!==void 0&&!(0,E.isString)(Y.id))return console.log("INVALID tree item, invalid id",Y.id),!1;if(Y.iconPath!==void 0&&!(0,E.isString)(Y.iconPath)&&!P.URI.isUri(Y.iconPath)&&!(0,E.isString)(Y.iconPath.id)){const _e=Y.iconPath;if(!(0,E.isString)(_e.light)&&!P.URI.isUri(_e.light)&&!(0,E.isString)(_e.dark)&&!P.URI.isUri(_e.dark))return console.log("INVALID tree item, invalid iconPath",Y.iconPath),!1}return Y.description!==void 0&&!(0,E.isString)(Y.description)&&typeof Y.description!="boolean"?(console.log("INVALID tree item, invalid description",Y.description),!1):Y.resourceUri!==void 0&&!P.URI.isUri(Y.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Y.resourceUri),!1):Y.tooltip!==void 0&&!(0,E.isString)(Y.tooltip)&&!(Y.tooltip instanceof Ne)?(console.log("INVALID tree item, invalid tooltip",Y.tooltip),!1):Y.command!==void 0&&!Y.command.command?(console.log("INVALID tree item, invalid command",Y.command),!1):Y.collapsibleState!==void 0&&Y.collapsibleState<mt.None&&Y.collapsibleState>mt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Y.collapsibleState),!1):Y.contextValue!==void 0&&!(0,E.isString)(Y.contextValue)?(console.log("INVALID tree item, invalid contextValue",Y.contextValue),!1):Y.accessibilityInformation!==void 0&&!Y.accessibilityInformation.label?(console.log("INVALID tree item, invalid accessibilityInformation",Y.accessibilityInformation),!1):!0}};Pt=U=ze([z],Pt),e.TreeItem=Pt;var mt;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(mt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Yt=class{constructor(N){this.value=N}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}};Yt=ze([z],Yt),e.DataTransferItem=Yt;let Jt=class{constructor(N){h.set(this,new Map);for(const[Y,_e]of N??[]){const Ke=Oe(this,h,"f").get(Y);Ke?Ke.push(_e):Oe(this,h,"f").set(Y,[_e])}}get(N){return Oe(this,h,"f").get(N)?.[0]}set(N,Y){Oe(this,h,"f").set(N,[Y])}forEach(N,Y){for(const[_e,Ke]of Oe(this,h,"f"))for(const et of Ke)N.call(Y,et,_e,this)}*[(h=new WeakMap,Symbol.iterator)](){for(const[N,Y]of Oe(this,h,"f"))for(const _e of Y)yield[N,_e]}};Jt=ze([z],Jt),e.DataTransfer=Jt;let bt=class{constructor(N){this.insertText=N}};bt=ze([z],bt),e.DocumentDropEdit=bt;let Ht=class{constructor(N){this.insertText=N}};Ht=ze([z],Ht),e.DocumentPasteEdit=Ht;let Bt=class{constructor(N,Y){this.id=N,this.color=Y}};Bt=ze([z],Bt),e.ThemeIcon=Bt,Bt.File=new Bt("file"),Bt.Folder=new Bt("folder");let oi=class{constructor(N){this.id=N}};oi=ze([z],oi),e.ThemeColor=oi;var ki;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(ki=e.ConfigurationTarget||(e.ConfigurationTarget={}));let It=class{constructor(N,Y){if(typeof N!="string"&&(!N||!P.URI.isUri(N)&&!P.URI.isUri(N.uri)))throw(0,p.illegalArgument)("base");if(typeof Y!="string")throw(0,p.illegalArgument)("pattern");typeof N=="string"?this.baseUri=P.URI.file(N):P.URI.isUri(N)?this.baseUri=N:this.baseUri=N.uri,this.pattern=Y}get base(){return this._base}set base(N){this._base=N,this._baseUri=P.URI.file(N)}get baseUri(){return this._baseUri}set baseUri(N){this._baseUri=N,this._base=N.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};It=ze([z],It),e.RelativePattern=It;let qt=class{constructor(N,Y,_e,Ke){this.enabled=typeof N=="boolean"?N:!0,typeof Y=="string"&&(this.condition=Y),typeof _e=="string"&&(this.hitCondition=_e),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=(0,O.generateUuid)()),this._id}};qt=ze([z],qt),e.Breakpoint=qt;let mi=class extends qt{constructor(N,Y,_e,Ke,et){super(Y,_e,Ke,et);if(N===null)throw(0,p.illegalArgument)("location");this.location=N}};mi=ze([z],mi),e.SourceBreakpoint=mi;let Zt=class extends qt{constructor(N,Y,_e,Ke,et){super(Y,_e,Ke,et);this.functionName=N}};Zt=ze([z],Zt),e.FunctionBreakpoint=Zt;let ei=class extends qt{constructor(N,Y,_e,Ke,et,at,ct){super(Ke,et,at,ct);if(!Y)throw(0,p.illegalArgument)("dataId");this.label=N,this.dataId=Y,this.canPersist=_e}};ei=ze([z],ei),e.DataBreakpoint=ei;let lt=class{constructor(N,Y,_e){this.command=N,this.args=Y||[],this.options=_e}};lt=ze([z],lt),e.DebugAdapterExecutable=lt;let gi=class{constructor(N,Y){this.port=N,this.host=Y}};gi=ze([z],gi),e.DebugAdapterServer=gi;let zt=class{constructor(N){this.path=N}};zt=ze([z],zt),e.DebugAdapterNamedPipeServer=zt;let Kt=class{constructor(N){this.implementation=N}};Kt=ze([z],Kt),e.DebugAdapterInlineImplementation=Kt;let ai=class{constructor(N,Y){this.range=N,this.expression=Y}};ai=ze([z],ai),e.EvaluatableExpression=ai;var Pi;(function(x){x[x.Invoke=0]="Invoke",x[x.Automatic=1]="Automatic"})(Pi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var yi;(function(x){x[x.Invoke=0]="Invoke",x[x.Automatic=1]="Automatic"})(yi=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let pi=class{constructor(N,Y){this.range=N,this.text=Y}};pi=ze([z],pi),e.InlineValueText=pi;let ci=class{constructor(N,Y,_e=!0){this.range=N,this.variableName=Y,this.caseSensitiveLookup=_e}};ci=ze([z],ci),e.InlineValueVariableLookup=ci;let ti=class{constructor(N,Y){this.range=N,this.expression=Y}};ti=ze([z],ti),e.InlineValueEvaluatableExpression=ti;let vi=class{constructor(N,Y){this.frameId=N,this.stoppedLocation=Y}};vi=ze([z],vi),e.InlineValueContext=vi;var Ei;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(Ei=e.FileChangeType||(e.FileChangeType={}));let ii=W=class extends Error{constructor(N,Y=y.FileSystemProviderErrorCode.Unknown,_e){super(P.URI.isUri(N)?N.toString(!0):N);this.code=_e?.name??"Unknown",(0,y.markAsFileSystemProviderError)(this,Y),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,W.prototype),typeof Error.captureStackTrace=="function"&&typeof _e=="function"&&Error.captureStackTrace(this,_e)}static FileExists(N){return new W(N,y.FileSystemProviderErrorCode.FileExists,W.FileExists)}static FileNotFound(N){return new W(N,y.FileSystemProviderErrorCode.FileNotFound,W.FileNotFound)}static FileNotADirectory(N){return new W(N,y.FileSystemProviderErrorCode.FileNotADirectory,W.FileNotADirectory)}static FileIsADirectory(N){return new W(N,y.FileSystemProviderErrorCode.FileIsADirectory,W.FileIsADirectory)}static NoPermissions(N){return new W(N,y.FileSystemProviderErrorCode.NoPermissions,W.NoPermissions)}static Unavailable(N){return new W(N,y.FileSystemProviderErrorCode.Unavailable,W.Unavailable)}};ii=W=ze([z],ii),e.FileSystemError=ii;let bi=class{constructor(N,Y,_e){this.start=N,this.end=Y,this.kind=_e}};bi=ze([z],bi),e.FoldingRange=bi;var Ai;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(Ai=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ni;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(ni=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ri;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(Ri=e.CommentMode||(e.CommentMode={}));var Oi;(function(x){x[x.Unresolved=0]="Unresolved",x[x.Resolved=1]="Resolved"})(Oi=e.CommentThreadState||(e.CommentThreadState={}));class Fi{constructor(N,Y=[]){this.tokenTypes=N,this.tokenModifiers=Y}}e.SemanticTokensLegend=Fi;function Ni(x){return typeof x=="undefined"||(0,E.isStringArray)(x)}class ri{constructor(N){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,N){this._hasLegend=!0;for(let Y=0,_e=N.tokenTypes.length;Y<_e;Y++)this._tokenTypeStrToInt.set(N.tokenTypes[Y],Y);for(let Y=0,_e=N.tokenModifiers.length;Y<_e;Y++)this._tokenModifierStrToInt.set(N.tokenModifiers[Y],Y)}}push(N,Y,_e,Ke,et){if(typeof N=="number"&&typeof Y=="number"&&typeof _e=="number"&&typeof Ke=="number"&&(typeof et=="number"||typeof et=="undefined"))return typeof et=="undefined"&&(et=0),this._pushEncoded(N,Y,_e,Ke,et);if(q.isRange(N)&&typeof Y=="string"&&Ni(_e))return this._push(N,Y,_e);throw(0,p.illegalArgument)()}_push(N,Y,_e){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(N.start.line!==N.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(Y))throw new Error("`tokenType` is not in the provided legend");const Ke=N.start.line,et=N.start.character,at=N.end.character-N.start.character,ct=this._tokenTypeStrToInt.get(Y);let St=0;if(_e)for(const At of _e){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const $t=this._tokenModifierStrToInt.get(At);St|=1<<$t>>>0}this._pushEncoded(Ke,et,at,ct,St)}_pushEncoded(N,Y,_e,Ke,et){if(this._dataIsSortedAndDeltaEncoded&&(N<this._prevLine||N===this._prevLine&&Y<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let At=0,$t=0;for(let jt=0;jt<St;jt++){let Xt=this._data[5*jt],_i=this._data[5*jt+1];Xt===0?(Xt=At,_i+=$t):Xt+=At,this._data[5*jt]=Xt,this._data[5*jt+1]=_i,At=Xt,$t=_i}}let at=N,ct=Y;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(ct-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=ct,this._data[this._dataLen++]=_e,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=et,this._prevLine=N,this._prevChar=Y}static _sortAndDeltaEncode(N){const Y=[],_e=N.length/5|0;for(let ct=0;ct<_e;ct++)Y[ct]=ct;Y.sort((ct,St)=>{const At=N[5*ct],$t=N[5*St];if(At===$t){const jt=N[5*ct+1],Xt=N[5*St+1];return jt-Xt}return At-$t});const Ke=new Uint32Array(N.length);let et=0,at=0;for(let ct=0;ct<_e;ct++){const St=5*Y[ct],At=N[St+0],$t=N[St+1],jt=N[St+2],Xt=N[St+3],_i=N[St+4],Qi=At-et,bn=Qi===0?$t-at:$t,Si=5*ct;Ke[Si+0]=Qi,Ke[Si+1]=bn,Ke[Si+2]=jt,Ke[Si+3]=Xt,Ke[Si+4]=_i,et=At,at=$t}return Ke}build(N){return this._dataIsSortedAndDeltaEncoded?new li(new Uint32Array(this._data),N):new li(ri._sortAndDeltaEncode(this._data),N)}}e.SemanticTokensBuilder=ri;class li{constructor(N,Y){this.resultId=Y,this.data=N}}e.SemanticTokens=li;class Di{constructor(N,Y,_e){this.start=N,this.deleteCount=Y,this.data=_e}}e.SemanticTokensEdit=Di;class Me{constructor(N,Y){this.resultId=Y,this.edits=N}}e.SemanticTokensEdits=Me;var Vt;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(Vt=e.DebugConsoleMode||(e.DebugConsoleMode={}));let si=class{constructor(){}};si.Back={iconPath:new Bt("arrow-left")},si=ze([z],si),e.QuickInputButtons=si;var Et;(function(x){x[x.Separator=-1]="Separator",x[x.Default=0]="Default"})(Et=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Mi;(function(x){x[x.Info=1]="Info",x[x.Warning=2]="Warning",x[x.Error=3]="Error"})(Mi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Li;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(Li=e.ExtensionKind||(e.ExtensionKind={}));class Ci{constructor(N,Y,_e){this.badge=N,this.tooltip=Y,this.color=_e}static validate(N){if(N.badge){let Y=(0,k.nextCharLength)(N.badge,0);if(Y<N.badge.length&&(Y+=(0,k.nextCharLength)(N.badge,Y)),N.badge.length>Y)throw new Error("The 'badge'-property must be undefined or a short character")}if(!N.color&&!N.badge&&!N.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Ci;let wi=class{constructor(N){this.kind=N}};wi=ze([z],wi),e.ColorTheme=wi;var ui;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast",x[x.HighContrastLight=4]="HighContrastLight"})(ui=e.ColorThemeKind||(e.ColorThemeKind={}));class xt{constructor(N,Y){if(N<0)throw(0,p.illegalArgument)("start must be positive");if(Y<0)throw(0,p.illegalArgument)("end must be positive");N<=Y?(this._start=N,this._end=Y):(this._start=Y,this._end=N)}static isNotebookRange(N){return N instanceof xt?!0:N?typeof N.start=="number"&&typeof N.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(N){let Y=this._start,_e=this._end;return N.start!==void 0&&(Y=N.start),N.end!==void 0&&(_e=N.end),Y===this._start&&_e===this._end?this:new xt(Y,_e)}}e.NotebookRange=xt;class Gt{constructor(N,Y,_e,Ke,et,at,ct){this.kind=N,this.value=Y,this.languageId=_e,this.mime=Ke,this.outputs=et??[],this.metadata=at,this.executionSummary=ct,Gt.validate(this)}static validate(N){if(typeof N.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof N.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof N.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(N){return Array.isArray(N)&&N.every(Y=>Gt.isNotebookCellData(Y))}static isNotebookCellData(N){return!0}}e.NotebookCellData=Gt;class Ui{constructor(N){this.cells=N}}e.NotebookData=Ui;class Mt{constructor(N,Y){this.data=N,this.mime=Y;const _e=(0,D.normalizeMimeType)(Y,!0);if(!_e)throw new Error(`INVALID mime type: ${Y}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=_e}static isNotebookCellOutputItem(N){return N instanceof Mt?!0:N?typeof N.mime=="string"&&N.data instanceof Uint8Array:!1}static error(N){const Y={name:N.name,message:N.message,stack:N.stack};return Mt.json(Y,"application/vnd.code.notebook.error")}static stdout(N){return Mt.text(N,"application/vnd.code.notebook.stdout")}static stderr(N){return Mt.text(N,"application/vnd.code.notebook.stderr")}static bytes(N,Y="application/octet-stream"){return new Mt(N,Y)}static text(N,Y=D.Mimes.text){const _e=Oe(Mt,d,"f",o).encode(String(N));return new Mt(_e,Y)}static json(N,Y="text/x-json"){const _e=JSON.stringify(N,void 0,"	");return Mt.text(_e,Y)}}e.NotebookCellOutputItem=Mt,d=Mt,o={value:new TextEncoder};class di{constructor(N,Y,_e){this.items=di.ensureUniqueMimeTypes(N,!0),typeof Y=="string"?(this.id=Y,this.metadata=_e):(this.id=(0,O.generateUuid)(),this.metadata=Y??_e)}static isNotebookCellOutput(N){return N instanceof di?!0:!N||typeof N!="object"?!1:typeof N.id=="string"&&Array.isArray(N.items)}static ensureUniqueMimeTypes(N,Y=!1){const _e=new Set,Ke=new Set;for(let et=0;et<N.length;et++){const at=N[et],ct=(0,D.normalizeMimeType)(at.mime);if(!_e.has(ct)){_e.add(ct);continue}Ke.add(et),Y&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ke.size===0?N:N.filter((et,at)=>!Ke.has(at))}}e.NotebookCellOutput=di;var Bi;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(Bi=e.NotebookCellKind||(e.NotebookCellKind={}));var zi;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(zi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var xi;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(xi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var $i;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})($i=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class re{constructor(N,Y){this.text=N,this.alignment=Y}}e.NotebookCellStatusBarItem=re;var he;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(he=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Re{constructor(N,Y=[]){this.uri=N,this.provides=(0,a.asArray)(Y)}}e.NotebookRendererScript=Re;let st=class{constructor(N,Y){this.label=N,this.timestamp=Y}};st=ze([z],st),e.TimelineItem=st;var wt;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(wt=e.ExtensionMode||(e.ExtensionMode={}));var Tt;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(Tt=e.ExtensionRuntime||(e.ExtensionRuntime={}));var en;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=3]="RegEx"})(en=e.StandardTokenType||(e.StandardTokenType={}));class tn{constructor(N,Y){this.ranges=N,this.wordPattern=Y}}e.LinkedEditingRanges=tn;class nn{constructor(N,Y){this._port=N,this._autoForwardAction=Y}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=nn;var rn;(function(x){x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(rn=e.TestResultState||(e.TestResultState={}));var sn;(function(x){x[x.Run=1]="Run",x[x.Debug=2]="Debug",x[x.Coverage=3]="Coverage"})(sn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Wi=class{constructor(N=void 0,Y=void 0,_e=void 0){this.include=N,this.exclude=Y,this.profile=_e}};Wi=ze([z],Wi),e.TestRunRequest=Wi;let Hi=M=class{constructor(N){this.message=N}static diff(N,Y,_e){const Ke=new M(N);return Ke.expectedOutput=Y,Ke.actualOutput=_e,Ke}};Hi=M=ze([z],Hi),e.TestMessage=Hi;let Vi=class{constructor(N){this.id=N}};Vi=ze([z],Vi),e.TestTag=Vi;let hi=class{constructor(N,Y){this.covered=N,this.total=Y}};hi=ze([z],hi),e.CoveredCount=hi;let ji=S=class{constructor(N,Y,_e,Ke){this.uri=N,this.statementCoverage=Y,this.branchCoverage=_e,this.functionCoverage=Ke}static fromDetails(N,Y){const _e=new hi(0,0),Ke=new hi(0,0),et=new hi(0,0);for(const ct of Y)if("branches"in ct){_e.total+=1,_e.covered+=ct.executionCount>0?1:0;for(const St of ct.branches)Ke.total+=1,Ke.covered+=St.executionCount>0?1:0}else et.total+=1,et.covered+=ct.executionCount>0?1:0;const at=new S(N,_e,Ke.total>0?Ke:void 0,et.total>0?et:void 0);return at.detailedCoverage=Y,at}};ji=S=ze([z],ji),e.FileCoverage=ji;let qi=class{constructor(N,Y,_e=[]){this.executionCount=N,this.location=Y,this.branches=_e}};qi=ze([z],qi),e.StatementCoverage=qi;let Ki=class{constructor(N,Y){this.executionCount=N,this.location=Y}};Ki=ze([z],Ki),e.BranchCoverage=Ki;let Gi=class{constructor(N,Y){this.executionCount=N,this.location=Y}};Gi=ze([z],Gi),e.FunctionCoverage=Gi;var on;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(on=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var an;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(an=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var cn;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore",x[x.OpenBrowserOnce=6]="OpenBrowserOnce"})(cn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class ln{constructor(N,Y,_e,Ke,et,at){this.kind=N,this.name=Y,this.detail=_e,this.uri=Ke,this.range=et,this.selectionRange=at}}e.TypeHierarchyItem=ln;class un{constructor(N){this.uri=N}}e.TextTabInput=un;class dn{constructor(N,Y){this.original=N,this.modified=Y}}e.TextDiffTabInput=dn;class hn{constructor(N,Y,_e,Ke){this.base=N,this.input1=Y,this.input2=_e,this.result=Ke}}e.TextMergeTabInput=hn;class fn{constructor(N,Y){this.uri=N,this.viewType=Y}}e.CustomEditorTabInput=fn;class mn{constructor(N){this.viewType=N}}e.WebviewEditorTabInput=mn;class gn{constructor(N,Y){this.uri=N,this.notebookType=Y}}e.NotebookEditorTabInput=gn;class pn{constructor(N,Y,_e){this.original=N,this.modified=Y,this.notebookType=_e}}e.NotebookDiffEditorTabInput=pn;class vn{constructor(){}}e.TerminalEditorTabInput=vn;class En{constructor(N,Y){this.uri=N,this.inputBoxUri=Y}}e.InteractiveWindowInput=En}),define(ye[87],De([1,0,44,12,9,240,122,6,16]),function(ne,e,a,p,b,L,D,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function O(f,h){h?P.set(f,h):P.delete(f)}e.setWordDefinitionFor=O;function y(f){return P.get(f)}e.getWordDefinitionFor=y;class m extends L.MirrorTextModel{constructor(h,d,o,v,R,c,w,s){super(d,o,v,R);this._proxy=h,this._languageId=c,this._isDirty=w,this.notebook=s,this._isDisposed=!1}dispose(){(0,a.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(h){return(0,E.equals)(this._lines,h)}get document(){if(!this._document){const h=this;this._document={get uri(){return h._uri},get fileName(){return h._uri.fsPath},get isUntitled(){return h._uri.scheme===p.Schemas.untitled},get languageId(){return h._languageId},get version(){return h._versionId},get isClosed(){return h._isDisposed},get isDirty(){return h._isDirty},save(){return h._save()},getText(d){return d?h._getTextInRange(d):h.getText()},get eol(){return h._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return h._lines.length},lineAt(d){return h._lineAt(d)},offsetAt(d){return h._offsetAt(d)},positionAt(d){return h._positionAt(d)},validateRange(d){return h._validateRange(d)},validatePosition(d){return h._validatePosition(d)},getWordRangeAtPosition(d,o){return h._getWordRangeAtPosition(d,o)}}}return Object.freeze(this._document)}_acceptLanguageId(h){(0,a.ok)(!this._isDisposed),this._languageId=h}_acceptIsDirty(h){(0,a.ok)(!this._isDisposed),this._isDirty=h}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(h){const d=this._validateRange(h);if(d.isEmpty)return"";if(d.isSingleLine)return this._lines[d.start.line].substring(d.start.character,d.end.character);const o=this._eol,v=d.start.line,R=d.end.line,c=[];c.push(this._lines[v].substring(d.start.character));for(let w=v+1;w<R;w++)c.push(this._lines[w]);return c.push(this._lines[R].substring(0,d.end.character)),c.join(o)}_lineAt(h){let d;if(h instanceof k.Position?d=h.line:typeof h=="number"&&(d=h),typeof d!="number"||d<0||d>=this._lines.length||Math.floor(d)!==d)throw new Error("Illegal value for `line`");return new T(d,this._lines[d],d===this._lines.length-1)}_offsetAt(h){return h=this._validatePosition(h),this._ensureLineStarts(),this._lineStarts.getPrefixSum(h.line-1)+h.character}_positionAt(h){h=Math.floor(h),h=Math.max(0,h),this._ensureLineStarts();const d=this._lineStarts.getIndexOf(h),o=this._lines[d.index].length;return new k.Position(d.index,Math.min(d.remainder,o))}_validateRange(h){if(!(h instanceof k.Range))throw new Error("Invalid argument");const d=this._validatePosition(h.start),o=this._validatePosition(h.end);return d===h.start&&o===h.end?h:new k.Range(d.line,d.character,o.line,o.character)}_validatePosition(h){if(!(h instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return h.with(0,0);let{line:d,character:o}=h,v=!1;if(d<0)d=0,o=0,v=!0;else if(d>=this._lines.length)d=this._lines.length-1,o=this._lines[d].length,v=!0;else{const R=this._lines[d].length;o<0?(o=0,v=!0):o>R&&(o=R,v=!0)}return v?new k.Position(d,o):h}_getWordRangeAtPosition(h,d){const o=this._validatePosition(h);if(!d)d=y(this._languageId);else if((0,b.regExpLeadsToEndlessLoop)(d))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${d.source}' because it matches the empty string.`);const v=(0,D.getWordAtText)(o.character+1,(0,D.ensureValidWordDefinition)(d),this._lines[o.line],0);if(v)return new k.Range(o.line,v.startColumn-1,o.line,v.endColumn-1)}}e.ExtHostDocumentData=m;class T{constructor(h,d,o){this._line=h,this._text=d,this._isLastLine=o}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=T}),define(ye[161],De([1,0,6,13,5]),function(ne,e,a,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let L=class{constructor(k){this._actual=new a.ColorTheme(a.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new b.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let E;switch(k){case"light":E=a.ColorThemeKind.Light;break;case"hcDark":E=a.ColorThemeKind.HighContrast;break;case"hcLight":E=a.ColorThemeKind.HighContrastLight;break;default:E=a.ColorThemeKind.Dark}this._actual=new a.ColorTheme(E),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};L=ze([xe(0,p.IExtHostRpcService)],L),e.ExtHostTheming=L}),define(ye[63],De([1,0,3]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,a.createDecorator)("IURITransformerService");class p{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=D=>D,this.transformOutgoing=D=>D,this.transformOutgoingURI=D=>D,this.transformOutgoingScheme=D=>D)}}e.URITransformerService=p}),define(ye[162],De([1,0,23]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class p{constructor(){this.buffers=[]}add(E){let P=this.buffers.indexOf(E);return P<0&&(P=this.buffers.length,this.buffers.push(E)),P}}function b(k,E){if(E.serializeBuffersForPostMessage){const P=new p,O=(T,f)=>{if(f instanceof ArrayBuffer){const h=P.add(f);return{$$vscode_array_buffer_reference$$:!0,index:h}}else if(ArrayBuffer.isView(f)){const h=L(f);if(h){const d=P.add(f.buffer);return{$$vscode_array_buffer_reference$$:!0,index:d,view:{type:h,byteLength:f.byteLength,byteOffset:f.byteOffset}}}}return f},y=JSON.stringify(k,O),m=P.buffers.map(T=>{const f=new Uint8Array(T);return a.VSBuffer.wrap(f)});return{message:y,buffers:m}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=b;function L(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function D(k,E){const P=E.map(m=>{const T=new ArrayBuffer(m.byteLength);return new Uint8Array(T).set(m.buffer),T}),O=E.length?(m,T)=>{if(T&&typeof T=="object"&&T.$$vscode_array_buffer_reference$$){const f=T,{index:h}=f,d=P[h];if(f.view)switch(f.view.type){case 1:return new Int8Array(d,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(d,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(d,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(d,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(d,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(d,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(d,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(d,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(d,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(d,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(d,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return T}:void 0;return{message:JSON.parse(k,O),arrayBuffers:P}}e.deserializeWebviewMessage=D}),define(ye[163],De([1,0,136,10,2,7,3,30,39,16,12]),function(ne,e,a,p,b,L,D,k,E,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,a.localize)(0,null),providerDisplayName:(0,a.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var y;(function(A){A[A.PROGRAMMATIC=1]="PROGRAMMATIC",A[A.USER=2]="USER",A[A.EDIT=3]="EDIT",A[A.NAVIGATION=4]="NAVIGATION",A[A.JUMP=5]="JUMP"})(y=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var m;(function(A){A[A.IDENTICAL=1]="IDENTICAL",A[A.SIMILAR=2]="SIMILAR",A[A.DIFFERENT=3]="DIFFERENT"})(m=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function T(A){const Z=A;return!!Z&&typeof Z.getSelection=="function"&&!!Z.onDidChangeSelection}e.isEditorPaneWithSelection=T;function f(A,Z,ce){for(const oe of ce.visibleEditorPanes)if(oe.group.id===Z&&A.matches(oe.input))return oe.getViewState()}e.findViewStateForEditor=f;function h(A){if(i(A))return!1;const Z=A;return b.URI.isUri(Z?.resource)}e.isResourceEditorInput=h;function d(A){if(i(A))return!1;const Z=A;return Z?.original!==void 0&&Z.modified!==void 0}e.isResourceDiffEditorInput=d;function o(A){if(i(A)||d(A))return!1;const Z=A;return Z?.primary!==void 0&&Z.secondary!==void 0}e.isResourceSideBySideEditorInput=o;function v(A){if(i(A))return!1;const Z=A;return Z?Z.resource===void 0||Z.resource.scheme===O.Schemas.untitled||Z.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=v;function R(A){if(i(A))return!1;const Z=A;return b.URI.isUri(Z?.base?.resource)&&b.URI.isUri(Z?.input1?.resource)&&b.URI.isUri(Z?.input2?.resource)&&b.URI.isUri(Z?.result?.resource)}e.isResourceMergeEditorInput=R;var c;(function(A){A[A.SHORT=0]="SHORT",A[A.MEDIUM=1]="MEDIUM",A[A.LONG=2]="LONG"})(c=e.Verbosity||(e.Verbosity={}));var w;(function(A){A[A.EXPLICIT=1]="EXPLICIT",A[A.AUTO=2]="AUTO",A[A.FOCUS_CHANGE=3]="FOCUS_CHANGE",A[A.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(w=e.SaveReason||(e.SaveReason={}));class s{constructor(){this.mapIdToSaveSource=new Map}registerSource(Z,ce){let oe=this.mapIdToSaveSource.get(Z);return oe||(oe={source:Z,label:ce},this.mapIdToSaveSource.set(Z,oe)),oe.source}getSourceLabel(Z){return this.mapIdToSaveSource.get(Z)?.label??Z}}e.SaveSourceRegistry=new s;var u;(function(A){A[A.None=0]="None",A[A.Readonly=2]="Readonly",A[A.Untitled=4]="Untitled",A[A.Singleton=8]="Singleton",A[A.RequiresTrust=16]="RequiresTrust",A[A.CanSplitInGroup=32]="CanSplitInGroup",A[A.ForceDescription=64]="ForceDescription",A[A.CanDropIntoEditor=128]="CanDropIntoEditor",A[A.MultipleEditors=256]="MultipleEditors"})(u=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class n extends L.Disposable{}e.AbstractEditorInput=n;function i(A){return A instanceof n}e.isEditorInput=i;function r(A){const Z=A;return b.URI.isUri(Z?.preferredResource)}function t(A){const Z=A;return i(Z?.primary)&&i(Z?.secondary)}e.isSideBySideEditorInput=t;function l(A){const Z=A;return i(Z?.modified)&&i(Z?.original)}e.isDiffEditorInput=l;function _(A){return i(A?.editor)}e.isEditorInputWithOptions=_;function g(A){const Z=A;return _(A)&&Z?.group!==void 0}e.isEditorInputWithOptionsAndGroup=g;function C(A){const Z=A;return typeof Z?.groupId=="number"&&i(Z.editor)}e.isEditorIdentifier=C;var U;(function(A){A[A.UNKNOWN=0]="UNKNOWN",A[A.REPLACE=1]="REPLACE",A[A.MOVE=2]="MOVE",A[A.UNPIN=3]="UNPIN"})(U=e.EditorCloseContext||(e.EditorCloseContext={}));var W;(function(A){A[A.GROUP_ACTIVE=0]="GROUP_ACTIVE",A[A.GROUP_INDEX=1]="GROUP_INDEX",A[A.GROUP_LOCKED=2]="GROUP_LOCKED",A[A.EDITOR_OPEN=3]="EDITOR_OPEN",A[A.EDITOR_CLOSE=4]="EDITOR_CLOSE",A[A.EDITOR_MOVE=5]="EDITOR_MOVE",A[A.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",A[A.EDITOR_LABEL=7]="EDITOR_LABEL",A[A.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",A[A.EDITOR_PIN=9]="EDITOR_PIN",A[A.EDITOR_STICKY=10]="EDITOR_STICKY",A[A.EDITOR_DIRTY=11]="EDITOR_DIRTY",A[A.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(W=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var M;(function(A){A[A.PRIMARY=1]="PRIMARY",A[A.SECONDARY=2]="SECONDARY",A[A.BOTH=3]="BOTH",A[A.ANY=4]="ANY"})(M=e.SideBySideEditor||(e.SideBySideEditor={}));class S{getOriginalUri(Z,ce){if(!Z)return;if(R(Z))return e.EditorResourceAccessor.getOriginalUri(Z.result,ce);if(ce?.supportSideBySide){const{primary:ue,secondary:te}=this.getSideEditors(Z);if(ue&&te){if(ce?.supportSideBySide===M.BOTH)return{primary:this.getOriginalUri(ue,{filterByScheme:ce.filterByScheme}),secondary:this.getOriginalUri(te,{filterByScheme:ce.filterByScheme})};if(ce?.supportSideBySide===M.ANY)return this.getOriginalUri(ue,{filterByScheme:ce.filterByScheme})??this.getOriginalUri(te,{filterByScheme:ce.filterByScheme});Z=ce.supportSideBySide===M.PRIMARY?ue:te}}if(d(Z)||o(Z)||R(Z))return;const oe=r(Z)?Z.preferredResource:Z.resource;return!oe||!ce||!ce.filterByScheme?oe:this.filterUri(oe,ce.filterByScheme)}getSideEditors(Z){return t(Z)||o(Z)?{primary:Z.primary,secondary:Z.secondary}:l(Z)||d(Z)?{primary:Z.modified,secondary:Z.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(Z,ce){if(!Z)return;if(R(Z))return e.EditorResourceAccessor.getCanonicalUri(Z.result,ce);if(ce?.supportSideBySide){const{primary:ue,secondary:te}=this.getSideEditors(Z);if(ue&&te){if(ce?.supportSideBySide===M.BOTH)return{primary:this.getCanonicalUri(ue,{filterByScheme:ce.filterByScheme}),secondary:this.getCanonicalUri(te,{filterByScheme:ce.filterByScheme})};if(ce?.supportSideBySide===M.ANY)return this.getCanonicalUri(ue,{filterByScheme:ce.filterByScheme})??this.getCanonicalUri(te,{filterByScheme:ce.filterByScheme});Z=ce.supportSideBySide===M.PRIMARY?ue:te}}if(d(Z)||o(Z)||R(Z))return;const oe=Z.resource;return!oe||!ce||!ce.filterByScheme?oe:this.filterUri(oe,ce.filterByScheme)}filterUri(Z,ce){if(Array.isArray(ce)){if(ce.some(oe=>Z.scheme===oe))return Z}else if(ce===Z.scheme)return Z}}e.EditorResourceAccessor=new S;var z;(function(A){A[A.LEFT=0]="LEFT",A[A.RIGHT=1]="RIGHT"})(z=e.CloseDirection||(e.CloseDirection={}));class ${constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(Z){const ce=this.instantiationService=Z.get(D.IInstantiationService);for(const[oe,ue]of this.editorSerializerConstructors)this.createEditorSerializer(oe,ue,ce);this.editorSerializerConstructors.clear()}createEditorSerializer(Z,ce,oe){const ue=oe.createInstance(ce);this.editorSerializerInstances.set(Z,ue)}registerFileEditorFactory(Z){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=Z}getFileEditorFactory(){return(0,p.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(Z,ce){if(this.editorSerializerConstructors.has(Z)||this.editorSerializerInstances.has(Z))throw new Error(`A editor serializer with type ID '${Z}' was already registered.`);return this.instantiationService?this.createEditorSerializer(Z,ce,this.instantiationService):this.editorSerializerConstructors.set(Z,ce),(0,L.toDisposable)(()=>{this.editorSerializerConstructors.delete(Z),this.editorSerializerInstances.delete(Z)})}getEditorSerializer(Z){return this.editorSerializerInstances.get(typeof Z=="string"?Z:Z.typeId)}}k.Registry.add(e.EditorExtensions.EditorFactory,new $);async function F(A,Z){if(!A||!A.length)return[];const ce=await Promise.all(A.map(async oe=>{const ue=b.URI.revive(oe.fileUri);if(!ue||!await Z.canHandleResource(ue))return;let Ee=oe.exists,be=oe.type;if(typeof Ee!="boolean"||typeof be!="number")try{be=(await Z.stat(ue)).isDirectory?E.FileType.Directory:E.FileType.Unknown,Ee=!0}catch{Ee=!1}if(!Ee&&oe.openOnlyIfExists||be===E.FileType.Directory)return;const ee={...oe.options,pinned:!0};let ve;return Ee?ve={resource:ue,options:ee}:ve={resource:ue,options:ee,forceUntitled:!0},ve}));return(0,P.coalesce)(ce)}e.pathsToEditors=F;var q;(function(A){A[A.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",A[A.SEQUENTIAL=1]="SEQUENTIAL"})(q=e.EditorsOrder||(e.EditorsOrder={}));function ie(A){const Z=A;if(!Z)return!1;const ce=Z;if(ce.modified)return ie(ce.modified);const oe=Z;return!!(oe.contributionsState&&oe.viewState&&Array.isArray(oe.cursorState))}e.isTextEditorViewState=ie}),define(ye[64],De([1,0,12,2]),function(ne,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function b(k,E){return k.scheme===a.Schemas.http||k.scheme===a.Schemas.https?k:(E&&E.authority&&E.isRemote&&k.scheme===a.Schemas.file&&(k=p.URI.from({scheme:a.Schemas.vscodeRemote,authority:E.authority,path:k.path})),p.URI.from({scheme:a.Schemas.https,authority:`${k.scheme}+${L(k.authority)}.${e.webviewRootResourceAuthority}`,path:k.path,fragment:k.fragment,query:k.query}))}e.asWebviewUri=b;function L(k){return k.replace(/./g,E=>{const P=E.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?E:"-"+P.toString(16).padStart(4,"0")})}function D(k){return k.replace(/-([0-9a-f]{4})/g,(E,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=D}),define(ye[164],De([1,0,5,7,64]),function(ne,e,a,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class L{constructor(k,E,P){this._proxy=k,this._editors=E,this._remoteInfo=P,this._handlePool=0,this._disposables=new p.DisposableStore,this._insets=new Map,this._disposables.add(E.onDidChangeVisibleTextEditors(()=>{const O=E.getVisibleTextEditors();for(const y of this._insets.values())O.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this._insets.forEach(k=>k.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(k,E,P,O,y){let m;for(const R of this._editors.getVisibleTextEditors(!0))if(R.value===k){m=R;break}if(!m)throw new Error("not a visible editor");const T=this,f=this._handlePool++,h=new a.Emitter,d=new a.Emitter,o=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(R){return(0,b.asWebviewUri)(R,T._remoteInfo)}get cspSource(){return b.webviewGenericCspSource}set options(R){this._options=R,T._proxy.$setOptions(f,R)}get options(){return this._options}set html(R){this._html=R,T._proxy.$setHtml(f,R)}get html(){return this._html}get onDidReceiveMessage(){return h.event}postMessage(R){return T._proxy.$postMessage(f,R)}},v=new class{constructor(){this.editor=k,this.line=E,this.height=P,this.webview=o,this.onDidDispose=d.event}dispose(){T._insets.has(f)&&(T._insets.delete(f),T._proxy.$disposeEditorInset(f),d.fire(),d.dispose(),h.dispose())}};return this._proxy.$createEditorInset(f,m.id,m.value.document.uri,E+1,P,O||{},y.identifier,y.extensionLocation),this._insets.set(f,{editor:k,inset:v,onDidReceiveMessage:h}),v}$onDidDispose(k){const E=this._insets.get(k);E&&E.inset.dispose()}$onDidReceiveMessage(k,E){this._insets.get(k)?.onDidReceiveMessage.fire(E)}}e.ExtHostEditorInsets=L}),define(ye[165],De([1,0,5,14,137]),function(ne,e,a,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class L{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new a.Emitter,this._onExit=new a.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,E,P,O){const y={command:k};if(E&&Object.keys(E).length>0&&(y.arguments=E),this.internalSend("request",y),typeof O=="number"){const m=setTimeout(()=>{clearTimeout(m);const T=this.pendingRequests.get(y.seq);if(T){this.pendingRequests.delete(y.seq);const f={type:"response",seq:0,request_seq:y.seq,success:!1,command:k,message:(0,b.localize)(0,null,O,k)};T(f)}},O)}return P&&this.pendingRequests.set(y.seq,P),y.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,E){return k.type!=="event"||E.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,p.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback?.(k);break;case"request":this.requestCallback?.(k);break;case"response":{const E=k,P=this.pendingRequests.get(E.request_seq);P&&(this.pendingRequests.delete(E.request_seq),P(E));break}}}}internalSend(k,E){E.type=k,E.seq=this.sequence++,this.sendMessage(E)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((E,P)=>k.set(P,E)),await(0,p.timeout)(500),k.forEach((E,P)=>{E({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=L}),define(ye[166],De([1,0,138,38,3]),function(ne,e,a,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerUiMessage=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new p.RawContextKey("debugType",void 0,{type:"string",description:a.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new p.RawContextKey("debugConfigurationType",void 0,{type:"string",description:a.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new p.RawContextKey("debugState","inactive",{type:"string",description:a.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new p.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:a.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new p.RawContextKey("inDebugMode",!1,{type:"boolean",description:a.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new p.RawContextKey("inDebugRepl",!1,{type:"boolean",description:a.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new p.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:a.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new p.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:a.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new p.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:a.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new p.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:a.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new p.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:a.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new p.RawContextKey("variablesFocused",!0,{type:"boolean",description:a.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new p.RawContextKey("expressionSelected",!1,{type:"boolean",description:a.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new p.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:a.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new p.RawContextKey("callStackItemType",void 0,{type:"string",description:a.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new p.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:a.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new p.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:a.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new p.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:a.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new p.RawContextKey("watchItemType",void 0,{type:"string",description:a.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new p.RawContextKey("canViewMemory",void 0,{type:"boolean",description:a.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new p.RawContextKey("breakpointItemType",void 0,{type:"string",description:a.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new p.RawContextKey("breakpointAccessType",void 0,{type:"string",description:a.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new p.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:a.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new p.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:a.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new p.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:a.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new p.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:a.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new p.RawContextKey("stepBackSupported",!1,{type:"boolean",description:a.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new p.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:a.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new p.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:a.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new p.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:a.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new p.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:a.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new p.RawContextKey("breakpointsExist",!1,{type:"boolean",description:a.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new p.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:a.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new p.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:a.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new p.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:a.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new p.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:a.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new p.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:a.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new p.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:a.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new p.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:a.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new p.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:a.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new p.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:a.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new p.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:a.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new p.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:a.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new p.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:a.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new p.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:a.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new p.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:a.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new p.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:a.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new p.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:a.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new p.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:a.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new p.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:a.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new p.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:a.localize(50,null)});const L=m=>a.localize(51,null,m);e.debuggerDisabledMessage=L,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:a.localize(52,null)};var D;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(D=e.State||(e.State={}));function k(m){switch(m){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=k;var E;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})(E=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var P;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(P=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var O;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(O=e.DebuggerUiMessage||(e.DebuggerUiMessage={})),e.IDebugService=(0,b.createDecorator)(e.DEBUG_SERVICE_ID);var y;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE"})(y=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(ye[167],De([1,0,9,2,19,26,12]),function(ne,e,a,p,b,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function E(n,i,r){return n.replace(k,function(t,l){return i&&l.length>0&&l[0]!=="_"?t:r&&r.hasOwnProperty(l)?r[l]:t})}e.formatPII=E;function P(n){const i={};for(const r of Object.keys(n))r.startsWith("!")||(i[r]=n[r]);return i}e.filterExceptionsFromTelemetry=P;function O(n){return n.configuration.request==="attach"&&!y(n)&&(!n.parentSession||O(n.parentSession))}e.isSessionAttach=O;function y(n){let i=n.configuration.type;if(!!i)return i==="vslsShare"&&(i=n.configuration.adapterProxy.configuration.type),(0,a.equalsIgnoreCase)(i,"extensionhost")||(0,a.equalsIgnoreCase)(i,"pwa-extensionhost")?n:n.parentSession?y(n.parentSession):void 0}e.getExtensionHostDebugSession=y;function m(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=m;function T(n,i,r){let t,l=0;const _=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let g=null;for(;g=_.exec(n);){const C=g.index+1,U=C+g[0].length;if(C<=i&&U>=r){t=g[0],l=C;break}}if(t){const C=/\w+/g;let U=null;for(;(U=C.exec(t))&&!(U.index+1+l+U[0].length>=r););U&&(t=t.substring(0,C.lastIndex))}return t?{start:l,end:l+t.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=T;const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function h(n){return!!(n&&n.match(f))}e.isUri=h;function d(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(h(n.path))return p.URI.parse(n.path);if((0,b.isAbsolute)(n.path))return p.URI.file(n.path)}return n.path}function o(n){if(typeof n.path=="object"){const i=p.URI.revive(n.path);if(i)return i.scheme===D.Schemas.file?i.fsPath:i.toString()}return n.path}function v(n,i){const r=i?d:o,t=(0,L.deepClone)(n);return c(t,(l,_)=>{l&&_&&(_.path=r(_))}),t}e.convertToDAPaths=v;function R(n,i){const r=i?d:o,t=(0,L.deepClone)(n);return c(t,(l,_)=>{!l&&_&&(_.path=r(_))}),t}e.convertToVSCPaths=R;function c(n,i){switch(n.type){case"event":{const r=n;switch(r.event){case"output":i(!1,r.body.source);break;case"loadedSource":i(!1,r.body.source);break;case"breakpoint":i(!1,r.body.breakpoint.source);break;default:break}break}case"request":{const r=n;switch(r.command){case"setBreakpoints":i(!0,r.arguments.source);break;case"breakpointLocations":i(!0,r.arguments.source);break;case"source":i(!0,r.arguments.source);break;case"gotoTargets":i(!0,r.arguments.source);break;case"launchVSCode":r.arguments.args.forEach(t=>i(!1,t));break;default:break}break}case"response":{const r=n;if(r.success&&r.body)switch(r.command){case"stackTrace":r.body.stackFrames.forEach(t=>i(!1,t.source));break;case"loadedSources":r.body.sources.forEach(t=>i(!1,t));break;case"scopes":r.body.scopes.forEach(t=>i(!1,t.source));break;case"setFunctionBreakpoints":r.body.breakpoints.forEach(t=>i(!1,t.source));break;case"setBreakpoints":r.body.breakpoints.forEach(t=>i(!1,t.source));break;case"disassemble":r.body?.instructions.forEach(l=>i(!1,l.location));break;default:break}break}}}function w(n){return n.filter(i=>!i.presentation?.hidden).sort((i,r)=>i.presentation?r.presentation?i.presentation.group?r.presentation.group?i.presentation.group!==r.presentation.group?i.presentation.group.localeCompare(r.presentation.group):s(i.presentation.order,r.presentation.order):-1:r.presentation.group?1:s(i.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=w;function s(n,i){return typeof n!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:n-i}async function u(n,i){const r=n.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorLanguageId});if(r!=="none"&&(await i.saveAll(),r==="allEditorsInActiveGroup")){const t=i.activeEditorPane;t&&t.input.resource?.scheme===D.Schemas.untitled&&await i.save({editor:t.input,groupId:t.group.id})}await n.reloadConfiguration()}e.saveAllBeforeDebugStart=u}),define(ye[88],De([1,0,23,34,168,74,12,19,21,38]),function(ne,e,a,p,b,L,D,k,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var O;(function(t){t[t.Markup=1]="Markup",t[t.Code=2]="Code"})(O=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",L.Mimes.latex,L.Mimes.markdown,"image/png","image/jpeg",L.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[L.Mimes.latex,L.Mimes.markdown,"application/json",L.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var y;(function(t){t[t.Running=1]="Running",t[t.Idle=2]="Idle"})(y=e.NotebookRunState||(e.NotebookRunState={}));var m;(function(t){t[t.Unconfirmed=1]="Unconfirmed",t[t.Pending=2]="Pending",t[t.Executing=3]="Executing"})(m=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var T;(function(t){t[t.WithHardKernelDependency=0]="WithHardKernelDependency",t[t.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",t[t.Pure=2]="Pure",t[t.Never=3]="Never"})(T=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var f;(function(t){t.Always="always",t.Never="never",t.Optional="optional"})(f=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var h;(function(t){t[t.ModelChange=1]="ModelChange",t[t.Move=2]="Move",t[t.ChangeCellLanguage=5]="ChangeCellLanguage",t[t.Initialize=6]="Initialize",t[t.ChangeCellMetadata=7]="ChangeCellMetadata",t[t.Output=8]="Output",t[t.OutputItem=9]="OutputItem",t[t.ChangeCellContent=10]="ChangeCellContent",t[t.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",t[t.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",t[t.ChangeCellMime=13]="ChangeCellMime",t[t.Unknown=100]="Unknown"})(h=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(t){t[t.Handle=0]="Handle",t[t.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var o;(function(t){t[t.Replace=1]="Replace",t[t.Output=2]="Output",t[t.Metadata=3]="Metadata",t[t.CellLanguage=4]="CellLanguage",t[t.DocumentMetadata=5]="DocumentMetadata",t[t.Move=6]="Move",t[t.OutputItems=7]="OutputItems",t[t.PartialMetadata=8]="PartialMetadata",t[t.PartialInternalMetadata=9]="PartialInternalMetadata"})(o=e.CellEditType||(e.CellEditType={}));var v;(function(t){t.scheme=D.Schemas.vscodeNotebookCell;const l=["W","X","Y","Z","a","b","c","d","e","f"],_=new RegExp(`^[${l.join("")}]+`),g=7;function C(F,q){const ie=q.toString(g),Z=`${ie.length<l.length?l[ie.length-1]:"z"}${ie}s${(0,a.encodeBase64)(a.VSBuffer.fromString(F.scheme),!0,!0)}`;return F.with({scheme:t.scheme,fragment:Z})}t.generate=C;function U(F){if(F.scheme!==t.scheme)return;const q=F.fragment.indexOf("s");if(q<0)return;const ie=parseInt(F.fragment.substring(0,q).replace(_,""),g),A=(0,a.decodeBase64)(F.fragment.substring(q+1)).toString();if(!isNaN(ie))return{handle:ie,notebook:F.with({scheme:A,fragment:null})}}t.parse=U;const W=/^(\d{8,})(\w[\w\d+.-]*)$/;function M(F,q){return F.with({scheme:D.Schemas.vscodeNotebookCellOutput,fragment:`op${q??""},${F.scheme!==D.Schemas.file?F.scheme:""}`})}t.generateCellOutputUri=M;function S(F){if(F.scheme!==D.Schemas.vscodeNotebookCellOutput)return;const q=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(F.fragment);if(!q)return;const ie=q[1]&&q[1]!==""?q[1]:void 0,A=q[2];return{outputId:ie,notebook:F.with({scheme:A||D.Schemas.file,fragment:null})}}t.parseCellOutputUri=S;function z(F,q,ie){return F.with({scheme:ie,fragment:`ch${q.toString().padStart(7,"0")}${F.scheme!==D.Schemas.file?F.scheme:""}`})}t.generateCellUri=z;function $(F,q){if(F.scheme!==q)return;const ie=W.exec(F.fragment);return ie?{handle:Number(ie[1]),notebook:F.with({scheme:F.fragment.substring(ie[0].length)||D.Schemas.file,fragment:null})}:void 0}t.parseCellUri=$})(v=e.CellUri||(e.CellUri={}));const R=t=>E.isWindows?t.replace(/\//g,"\\"):t;class c{constructor(l=[],_=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=_,this.order=[...new Set(l)].map(g=>({pattern:g,matches:p.parse(R(g))}))}sort(l){const _=new Map(b.Iterable.map(l,C=>[C,R(C)]));let g=[];for(const{matches:C}of this.order)for(const[U,W]of _)if(C(W)){g.push(U),_.delete(U);break}return _.size&&(g=g.concat([..._.keys()].sort((C,U)=>this.defaultOrder.indexOf(C)-this.defaultOrder.indexOf(U)))),g}prioritize(l,_){const g=this.findIndex(l);if(g===-1){this.order.unshift({pattern:l,matches:p.parse(R(l))});return}const C=new Set(_.map(W=>this.findIndex(W,g)));C.delete(-1);const U=Array.from(C).sort();this.order.splice(g+1,0,...U.map(W=>this.order[W]));for(let W=U.length-1;W>=0;W--)this.order.splice(U[W],1)}toArray(){return this.order.map(l=>l.pattern)}findIndex(l,_=this.order.length){const g=R(l);for(let C=0;C<_;C++)if(this.order[C].matches(g))return C;return-1}}e.MimeTypeDisplayOrder=c;function w(t,l,_,g=(C,U)=>C===U){const C=[];function U(S,z,$){if(z===0&&$.length===0)return;const F=C[C.length-1];F&&F.start+F.deleteCount===S?(F.deleteCount+=z,F.toInsert.push(...$)):C.push({start:S,deleteCount:z,toInsert:$})}let W=0,M=0;for(;;){if(W===t.length){U(W,0,l.slice(M));break}if(M===l.length){U(W,t.length-W,[]);break}const S=t[W],z=l[M];if(g(S,z)){W+=1,M+=1;continue}_(z)?(U(W,1,[]),W+=1):(U(W,0,[z]),M+=1)}return C}e.diff=w,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new P.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(t){t.default="default",t.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function u(t){const l=t;return!!((typeof l.include=="string"||p.isRelativePattern(l.include))&&(typeof l.exclude=="string"||p.isRelativePattern(l.exclude)))}e.isDocumentExcludePattern=u;function n(t,l,_){if(Array.isArray(t.viewType)&&t.viewType.indexOf(l)>=0||t.viewType===l)return!0;if(t.filenamePattern){const g=u(t.filenamePattern)?t.filenamePattern.include:t.filenamePattern,C=u(t.filenamePattern)?t.filenamePattern.exclude:void 0;if(p.match(g,(0,k.basename)(_.fsPath).toLowerCase()))return!(C&&p.match(C,(0,k.basename)(_.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=n,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var i;(function(t){t[t.Left=1]="Left",t[t.Right=2]="Right"})(i=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class r{static create(l){return`${r._prefix}${l}`}static parse(l){if(l.startsWith(r._prefix))return l.substring(r._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=r,r._prefix="notebook/"}),define(ye[169],De([1,0,3]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var p;(function(b){b[b.Output=1]="Output",b[b.OutputItems=2]="OutputItems",b[b.ExecutionState=3]="ExecutionState"})(p=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,a.createDecorator)("INotebookExecutionService")}),define(ye[170],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function a(D){return[...D.entries()]}e.serializeEnvironmentVariableCollection=a;function p(D){return new Map(D)}e.deserializeEnvironmentVariableCollection=p;function b(D){return Array.from(D.entries()).map(k=>[k[0],a(k[1].map)])}e.serializeEnvironmentVariableCollections=b;function L(D){return new Map(D.map(k=>[k[0],{map:p(k[1])}]))}e.deserializeEnvironmentVariableCollections=L}),define(ye[46],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var a;(function(L){L.Delimiter="\0"})(a=e.TestIdPathParts||(e.TestIdPathParts={}));var p;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(p=e.TestPosition||(e.TestPosition={}));class b{constructor(D,k=D.length){if(this.path=D,this.viewEnd=k,D.length===0||k<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(D,k,E=D.parent){if(D.id===k)return new b([k]);const P=[D.id];for(let O=E;O&&O.id!==k;O=O.parent)P.push(O.id);return P.push(k),new b(P.reverse())}static isRoot(D){return!D.includes("\0")}static root(D){const k=D.indexOf("\0");return k===-1?D:D.slice(0,k)}static fromString(D){return new b(D.split("\0"))}static join(D,k){return new b([...D.path,k])}static joinToString(D,k){return D.toString()+"\0"+k}static compare(D,k){return D===k?0:k.startsWith(D+"\0")?2:D.startsWith(k+"\0")?3:1}get parentId(){return this.viewEnd>1?new b(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let D=1;D<=this.viewEnd;D++)yield new b(this.path,D)}compare(D){if(typeof D=="string")return b.compare(this.toString(),D);for(let k=0;k<D.viewEnd&&k<this.viewEnd;k++)if(D.path[k]!==this.path[k])return 1;return D.viewEnd>this.viewEnd?2:D.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let D=1;D<this.viewEnd;D++)this.stringifed+="\0",this.stringifed+=this.path[D]}return this.stringifed}}e.TestId=b}),define(ye[47],De([1,0,2,48]),function(ne,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var b;(function(r){r[r.Unset=0]="Unset",r[r.Queued=1]="Queued",r[r.Running=2]="Running",r[r.Passed=3]="Passed",r[r.Failed=4]="Failed",r[r.Skipped=5]="Skipped",r[r.Errored=6]="Errored"})(b=e.TestResultState||(e.TestResultState={}));var L;(function(r){r[r.Run=2]="Run",r[r.Debug=4]="Debug",r[r.Coverage=8]="Coverage",r[r.HasNonDefaultProfile=16]="HasNonDefaultProfile",r[r.HasConfigurable=32]="HasConfigurable"})(L=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var D;(function(r){r.serialize=t=>({range:t.range.toJSON(),uri:t.uri.toJSON()}),r.deserialize=t=>({range:p.Range.lift(t.range),uri:a.URI.revive(t.uri)})})(D=e.IRichLocation||(e.IRichLocation={}));var k;(function(r){r[r.Error=0]="Error",r[r.Output=1]="Output"})(k=e.TestMessageType||(e.TestMessageType={}));var E;(function(r){r.serialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&D.serialize(t.location)}),r.deserialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&D.deserialize(t.location)})})(E=e.ITestErrorMessage||(e.ITestErrorMessage={}));var P;(function(r){r.serialize=t=>({message:t.message,type:1,offset:t.offset,length:t.length,location:t.location&&D.serialize(t.location)}),r.deserialize=t=>({message:t.message,type:1,offset:t.offset,length:t.length,location:t.location&&D.deserialize(t.location)})})(P=e.ITestOutputMessage||(e.ITestOutputMessage={}));var O;(function(r){r.serialize=t=>t.type===0?E.serialize(t):P.serialize(t),r.deserialize=t=>t.type===0?E.deserialize(t):P.deserialize(t)})(O=e.ITestMessage||(e.ITestMessage={}));var y;(function(r){r.serializeWithoutMessages=t=>({state:t.state,duration:t.duration,messages:[]}),r.serialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(O.serialize)}),r.deserialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(O.deserialize)})})(y=e.ITestTaskState||(e.ITestTaskState={}));const m="\0",T=(r,t)=>r+m+t;e.namespaceTestTag=T;const f=r=>{const t=r.indexOf(m);return{ctrlId:r.slice(0,t),tagId:r.slice(t+1)}};e.denamespaceTestTag=f;var h;(function(r){r.serialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?.toJSON(),range:t.range?.toJSON()||null,description:t.description,error:t.error,sortText:t.sortText}),r.deserialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?a.URI.revive(t.uri):void 0,range:t.range?p.Range.lift(t.range):null,description:t.description,error:t.error,sortText:t.sortText})})(h=e.ITestItem||(e.ITestItem={}));var d;(function(r){r[r.NotExpandable=0]="NotExpandable",r[r.Expandable=1]="Expandable",r[r.BusyExpanding=2]="BusyExpanding",r[r.Expanded=3]="Expanded"})(d=e.TestItemExpandState||(e.TestItemExpandState={}));var o;(function(r){r.serialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:h.serialize(t.item)}),r.deserialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:h.deserialize(t.item)})})(o=e.InternalTestItem||(e.InternalTestItem={}));var v;(function(r){r.serialize=t=>{let l;return t.item&&(l={},t.item.label!==void 0&&(l.label=t.item.label),t.item.tags!==void 0&&(l.tags=t.item.tags),t.item.busy!==void 0&&(l.busy=t.item.busy),t.item.uri!==void 0&&(l.uri=t.item.uri?.toJSON()),t.item.range!==void 0&&(l.range=t.item.range?.toJSON()),t.item.description!==void 0&&(l.description=t.item.description),t.item.error!==void 0&&(l.error=t.item.error),t.item.sortText!==void 0&&(l.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:l}},r.deserialize=t=>{let l;return t.item&&(l={},t.item.label!==void 0&&(l.label=t.item.label),t.item.tags!==void 0&&(l.tags=t.item.tags),t.item.busy!==void 0&&(l.busy=t.item.busy),t.item.range!==void 0&&(l.range=t.item.range?p.Range.lift(t.item.range):null),t.item.description!==void 0&&(l.description=t.item.description),t.item.error!==void 0&&(l.error=t.item.error),t.item.sortText!==void 0&&(l.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:l}}})(v=e.ITestItemUpdate||(e.ITestItemUpdate={}));const R=(r,t)=>{t.expand!==void 0&&(r.expand=t.expand),t.item!==void 0&&(r.item=r.item?Object.assign(r.item,t.item):t.item)};e.applyTestItemUpdate=R;var c;(function(r){r.serializeWithoutMessages=t=>({...o.serialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(y.serializeWithoutMessages),retired:t.retired}),r.serialize=t=>({...o.serialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(y.serialize),retired:t.retired})})(c=e.TestResultItem||(e.TestResultItem={}));var w;(function(r){r[r.Function=0]="Function",r[r.Statement=1]="Statement"})(w=e.DetailType||(e.DetailType={}));var s;(function(r){r[r.Add=0]="Add",r[r.Update=1]="Update",r[r.Remove=2]="Remove",r[r.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",r[r.Retire=4]="Retire",r[r.AddTag=5]="AddTag",r[r.RemoveTag=6]="RemoveTag"})(s=e.TestDiffOpType||(e.TestDiffOpType={}));var u;(function(r){r.deserialize=t=>t.op===0?{op:t.op,item:o.deserialize(t.item)}:t.op===1?{op:t.op,item:v.deserialize(t.item)}:t,r.serialize=t=>t.op===0?{op:t.op,item:o.serialize(t.item)}:t.op===1?{op:t.op,item:v.serialize(t.item)}:t})(u=e.TestsDiffOp||(e.TestsDiffOp={}));class n{add(t){}update(t){}remove(t,l){}complete(){}}e.IncrementalChangeCollector=n;class i{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(t){const l=this.createChangeCollector();for(const _ of t)switch(_.op){case 0:{const g=o.deserialize(_.item);if(g.parent){if(this.items.has(g.parent)){const C=this.items.get(g.parent);C.children.add(g.item.extId);const U=this.createItem(g,C);this.items.set(g.item.extId,U),l.add(U)}}else{const C=this.createItem(g);this.roots.add(C),this.items.set(g.item.extId,C),l.add(C)}g.expand===2&&this.busyControllerCount++;break}case 1:{const g=v.deserialize(_.item),C=this.items.get(g.extId);if(!C)break;g.expand!==void 0&&(C.expand===2&&this.busyControllerCount--,g.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(C,g),l.update(C);break}case 2:{const g=this.items.get(_.itemId);if(!g)break;g.parent?this.items.get(g.parent).children.delete(g.item.extId):this.roots.delete(g);const C=[[_.itemId]];for(;C.length;)for(const U of C.pop()){const W=this.items.get(U);W&&(C.push(W.children),this.items.delete(U),l.remove(W,W!==g),W.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(_.itemId);break;case 3:this.updatePendingRoots(_.amount);break;case 5:this._tags.set(_.tag.id,_.tag);break;case 6:this._tags.delete(_.id);break}l.complete()}retireTest(t){}updatePendingRoots(t){this.pendingRootCount+=t}createChangeCollector(){return new n}}e.AbstractIncrementalTestCollection=i}),define(ye[65],De([1,0,14,5,7,44,47,46]),function(ne,e,a,p,b,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var E;(function(o){o[o.Upsert=0]="Upsert",o[o.SetTags=1]="SetTags",o[o.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",o[o.RemoveChild=3]="RemoveChild",o[o.SetProp=4]="SetProp",o[o.Bulk=5]="Bulk"})(E=e.TestItemEventOp||(e.TestItemEventOp={}));const P=(o,v)=>o===v,O={range:(o,v)=>o===v?!0:!o||!v?!1:o.equalsRange(v),busy:P,label:P,description:P,error:P,tags:(o,v)=>!(o.length!==v.length||o.some(R=>!v.includes(R)))},y=(o,v)=>{let R;for(const[c,w]of Object.entries(O))w(o[c],v[c])||(R?R[c]=v[c]:R={[c]:v[c]});return R};class m extends b.Disposable{constructor(v){super();this.options=v,this.debounceSendDiff=this._register(new a.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new p.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}get root(){return this.options.root}set resolveHandler(v){this._resolveHandler=v;for(const R of this.tree.values())this.updateExpandability(R)}collectDiff(){const v=this.diff;return this.diff=[],v}pushDiff(v){const R=this.diff[this.diff.length-1];if(R&&v.op===1){if(R.op===1&&R.item.extId===v.item.extId){(0,D.applyTestItemUpdate)(R.item,v.item);return}if(R.op===0&&R.item.item.extId===v.item.extId){(0,D.applyTestItemUpdate)(R.item,v.item);return}}this.diff.push(v),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(v,R){const c=this.tree.get(v);if(!!c){if((c.expandLevels===void 0||R>c.expandLevels)&&(c.expandLevels=R),c.expand===1){const w=this.resolveChildren(c);return w.isOpen()?this.expandChildren(c,R-1):w.wait().then(()=>this.expandChildren(c,R-1))}else if(c.expand===3)return c.resolveBarrier?.isOpen()===!1?c.resolveBarrier.wait().then(()=>this.expandChildren(c,R-1)):this.expandChildren(c,R-1)}}dispose(){for(const v of this.tree.values())this.options.getApiFor(v.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(v,R){switch(R.op){case 3:this.removeItem(k.TestId.joinToString(v.fullId,R.id));break;case 0:this.upsertItem(R.item,v);break;case 5:for(const c of R.ops)this.onTestItemEvent(v,c);break;case 1:this.diffTagRefs(R.new,R.old,v.fullId.toString());break;case 2:this.updateExpandability(v);break;case 4:this.pushDiff({op:1,item:{extId:v.fullId.toString(),item:R.update}});break;default:(0,L.assertNever)(R)}}upsertItem(v,R){const c=k.TestId.fromExtHostTestItem(v,this.root.id,R?.actual),w=this.options.getApiFor(v);w.parent&&w.parent!==R?.actual&&this.options.getChildren(w.parent).delete(v.id);let s=this.tree.get(c.toString());if(!s){s={fullId:c,actual:v,parent:R?c.parentId:null,expandLevels:R?.expandLevels?R.expandLevels-1:void 0,expand:0},v.tags.forEach(this.incrementTagRefs,this),this.tree.set(s.fullId.toString(),s),this.setItemParent(v,R),this.pushDiff({op:0,item:{parent:s.parent&&s.parent.toString(),controllerId:this.options.controllerId,expand:s.expand,item:this.options.toITestItem(v)}}),this.connectItemAndChildren(v,s,R);return}if(s.actual===v){this.connectItem(v,s,R);return}const u=this.options.getChildren(s.actual),n=s.actual,i=y(this.options.toITestItem(n),this.options.toITestItem(v));this.options.getApiFor(n).listener=void 0,s.actual=v,s.expand=0,i&&(i.hasOwnProperty("tags")&&(this.diffTagRefs(v.tags,n.tags,c.toString()),delete i.tags),this.onTestItemEvent(s,{op:4,update:i})),this.connectItemAndChildren(v,s,R);for(const[r,t]of u)this.options.getChildren(v).get(t.id)||this.removeItem(k.TestId.joinToString(c,t.id))}diffTagRefs(v,R,c){const w=new Set(R.map(s=>s.id));for(const s of v)w.delete(s.id)||this.incrementTagRefs(s);this.pushDiff({op:1,item:{extId:c,item:{tags:v.map(s=>(0,D.namespaceTestTag)(this.options.controllerId,s.id))}}}),w.forEach(this.decrementTagRefs,this)}incrementTagRefs(v){const R=this.tags.get(v.id);R?R.refCount++:(this.tags.set(v.id,{refCount:1}),this.pushDiff({op:5,tag:{id:(0,D.namespaceTestTag)(this.options.controllerId,v.id)}}))}decrementTagRefs(v){const R=this.tags.get(v);R&&!--R.refCount&&(this.tags.delete(v),this.pushDiff({op:6,id:(0,D.namespaceTestTag)(this.options.controllerId,v)}))}setItemParent(v,R){this.options.getApiFor(v).parent=R&&R.actual!==this.root?R.actual:void 0}connectItem(v,R,c){this.setItemParent(v,c);const w=this.options.getApiFor(v);w.parent=c?.actual,w.listener=s=>this.onTestItemEvent(R,s),this.updateExpandability(R)}connectItemAndChildren(v,R,c){this.connectItem(v,R,c);for(const[w,s]of this.options.getChildren(v))this.upsertItem(s,R)}updateExpandability(v){let R;this._resolveHandler?v.resolveBarrier?R=v.resolveBarrier.isOpen()?3:2:R=v.actual.canResolveChildren?1:0:R=0,R!==v.expand&&(v.expand=R,this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:R}}),R===1&&v.expandLevels!==void 0&&this.resolveChildren(v))}expandChildren(v,R){if(R<0)return;const c=[];for(const[w,s]of this.options.getChildren(v.actual)){const u=this.expand(k.TestId.joinToString(v.fullId,s.id),R);(0,a.isThenable)(u)&&c.push(u)}if(c.length)return Promise.all(c).then(()=>{})}resolveChildren(v){if(v.resolveBarrier)return v.resolveBarrier;if(!this._resolveHandler){const s=new a.Barrier;return s.open(),s}v.expand=2,this.pushExpandStateUpdate(v);const R=v.resolveBarrier=new a.Barrier,c=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,s)};let w;try{w=this._resolveHandler(v.actual===this.root?void 0:v.actual)}catch(s){c(s)}return(0,a.isThenable)(w)?w.catch(c).then(()=>{R.open(),this.updateExpandability(v)}):(R.open(),this.updateExpandability(v)),v.resolveBarrier}pushExpandStateUpdate(v){this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:v.expand}})}removeItem(v){const R=this.tree.get(v);if(!R)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:v});const c=[R];for(;c.length;){const w=c.pop();if(!!w){this.options.getApiFor(w.actual).listener=void 0;for(const s of w.actual.tags)this.decrementTagRefs(s.id);this.tree.delete(w.fullId.toString());for(const[s,u]of this.options.getChildren(w.actual))c.push(this.tree.get(k.TestId.joinToString(w.fullId,u.id)))}}}flushDiff(){const v=this.collectDiff();v.length&&this.diffOpEmitter.fire(v)}}e.TestItemCollection=m;class T extends Error{constructor(v){super(`Attempted to insert a duplicate test item ID ${v}`)}}e.DuplicateTestItemError=T;class f extends Error{constructor(v){super(`TestItem with ID "${v}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class h extends Error{constructor(v,R,c){super(`TestItem with ID "${v}" is from controller "${R}" and cannot be added as a child of an item from controller "${c}".`)}}e.MixedTestItemController=h;const d=(o,v,R)=>{let c=new Map;return{get size(){return c.size},forEach(w,s){for(const u of c.values())w.call(s,u,this)},[Symbol.iterator](){return c.entries()},replace(w){const s=new Map,u=new Set(c.keys()),n={op:5,ops:[]};for(const i of w){if(!(i instanceof R))throw new f(i.id);const r=v(i).controllerId;if(r!==o.controllerId)throw new h(i.id,r,o.controllerId);if(s.has(i.id))throw new T(i.id);s.set(i.id,i),u.delete(i.id),n.ops.push({op:0,item:i})}for(const i of u.keys())n.ops.push({op:3,id:i});o.listener?.(n),c=s},add(w){if(!(w instanceof R))throw new f(w.id);c.set(w.id,w),o.listener?.({op:0,item:w})},delete(w){c.delete(w)&&o.listener?.({op:3,id:w})},get(w){return c.get(w)},toJSON(){return Array.from(c.values())}}};e.createTestItemChildren=d}),define(ye[89],De([1,0,65]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const p=new WeakMap,b=(D,k)=>{const E={controllerId:k};return p.set(D,E),E};e.createPrivateApiFor=b;const L=D=>{const k=p.get(D);if(!k)throw new a.InvalidTestItemError(D?.id||"<unknown>");return k};e.getPrivateApiFor=L}),define(ye[171],De([1,0,19,59,10,26,21,76,141,9]),function(ne,e,a,p,b,L,D,k,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class O{constructor(m,T,f,h){this._contributedVariables=new Map,this._context=m,this._labelService=T,this._userHomePromise=f,h&&(this._envVariablesPromise=h.then(d=>this.prepareEnv(d)))}prepareEnv(m){if(D.isWindows){const T=Object.create(null);return Object.keys(m).forEach(f=>{T[f.toLowerCase()]=m[f]}),T}return m}resolveWithEnvironment(m,T,f){return this.recursiveResolve({env:this.prepareEnv(m),userHome:void 0},T?T.uri:void 0,f)}async resolveAsync(m,T){const f={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(f,m?m.uri:void 0,T)}async resolveAnyBase(m,T,f,h){const d=L.deepClone(T);D.isWindows&&d.windows?Object.keys(d.windows).forEach(v=>d[v]=d.windows[v]):D.isMacintosh&&d.osx?Object.keys(d.osx).forEach(v=>d[v]=d.osx[v]):D.isLinux&&d.linux&&Object.keys(d.linux).forEach(v=>d[v]=d.linux[v]),delete d.windows,delete d.osx,delete d.linux;const o={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(o,m?m.uri:void 0,d,f,h)}async resolveAnyAsync(m,T,f){return this.resolveAnyBase(m,T,f)}async resolveAnyMap(m,T,f){const h=new Map;return{newConfig:await this.resolveAnyBase(m,T,f,h),resolvedVariables:h}}resolveWithInteractionReplace(m,T,f,h){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(m,T,f,h){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(m,T){if(this._contributedVariables.has(m))throw new Error("Variable "+m+" is contributed twice.");this._contributedVariables.set(m,T)}async recursiveResolve(m,T,f,h,d){if(b.isString(f))return this.resolveString(m,T,f,h,d);if(Array.isArray(f))return Promise.all(f.map(o=>this.recursiveResolve(m,T,o,h,d)));if(b.isObject(f)){const o=Object.create(null),v=await Promise.all(Object.keys(f).map(async R=>[await this.resolveString(m,T,R,h,d),await this.recursiveResolve(m,T,f[R],h,d)]));for(const[R,c]of v)o[R]=c;return o}return f}resolveString(m,T,f,h,d){return(0,P.replaceAsync)(f,O.VARIABLE_REGEXP,async(o,v)=>{if(v.includes(O.VARIABLE_LHS))return o;let R=await this.evaluateSingleVariable(m,o,v,T,h);return d?.set(v,R),R!==o&&b.isString(R)&&R.match(O.VARIABLE_REGEXP)&&(R=await this.resolveString(m,T,R,h,d)),R})}fsPath(m){return this._labelService?this._labelService.getUriLabel(m,{noPrefix:!0}):m.fsPath}async evaluateSingleVariable(m,T,f,h,d){let o;const v=f.split(":");v.length>1&&(f=v[0],o=v[1]);const R=()=>{const s=this._context.getFilePath();if(s)return s;throw new Error((0,E.localize)(0,null,T))},c=()=>{const s=R();if(this._context.getWorkspaceFolderPathForFile){const u=this._context.getWorkspaceFolderPathForFile();if(u)return u}throw new Error((0,E.localize)(1,null,T,a.basename(s)))},w=()=>{if(o){const s=this._context.getFolderUri(o);if(s)return s;throw new Error((0,E.localize)(2,null,T,o))}if(h)return h;throw this._context.getWorkspaceFolderCount()>1?new Error((0,E.localize)(3,null,T)):new Error((0,E.localize)(4,null,T))};switch(f){case"env":if(o){if(m.env){const s=m.env[D.isWindows?o.toLowerCase():o];if(b.isString(s))return s}return""}throw new Error((0,E.localize)(5,null,T));case"config":if(o){const s=this._context.getConfigurationValue(h,o);if(b.isUndefinedOrNull(s))throw new Error((0,E.localize)(6,null,T,o));if(b.isObject(s))throw new Error((0,E.localize)(7,null,T,o));return s}throw new Error((0,E.localize)(8,null,T));case"command":return this.resolveFromMap(T,o,d,"command");case"input":return this.resolveFromMap(T,o,d,"input");case"extensionInstallFolder":if(o){const s=await this._context.getExtension(o);if(!s)throw new Error((0,E.localize)(9,null,T,o));return this.fsPath(s.extensionLocation)}throw new Error((0,E.localize)(10,null,T));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(w()));case"cwd":return h||o?(0,k.normalizeDriveLetter)(this.fsPath(w())):p.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return a.basename(this.fsPath(w()));case"userHome":{if(m.userHome)return m.userHome;throw new Error((0,E.localize)(11,null,T))}case"lineNumber":{const s=this._context.getLineNumber();if(s)return s;throw new Error((0,E.localize)(12,null,T))}case"selectedText":{const s=this._context.getSelectedText();if(s)return s;throw new Error((0,E.localize)(13,null,T))}case"file":return R();case"fileWorkspaceFolder":return c();case"relativeFile":return h||o?a.relative(this.fsPath(w()),R()):R();case"relativeFileDirname":{const s=a.dirname(R());if(h||o){const u=a.relative(this.fsPath(w()),s);return u.length===0?".":u}return s}case"fileDirname":return a.dirname(R());case"fileExtname":return a.extname(R());case"fileBasename":return a.basename(R());case"fileBasenameNoExtension":{const s=a.basename(R());return s.slice(0,s.length-a.extname(s).length)}case"fileDirnameBasename":return a.basename(a.dirname(R()));case"execPath":{const s=this._context.getExecPath();return s||T}case"execInstallFolder":{const s=this._context.getAppRoot();return s||T}case"pathSeparator":return a.sep;default:try{const s=o?`${f}:${o}`:f;return this.resolveFromMap(T,s,d,void 0)}catch{return T}}}}resolveFromMap(m,T,f,h){if(T&&f){const d=h===void 0?f[T]:f[h+":"+T];if(typeof d=="string")return d;throw new Error((0,E.localize)(14,null,m))}return m}}e.AbstractVariableResolverService=O,O.VARIABLE_LHS="${",O.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ye[90],De([1,0,3,163]),function(ne,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,a.createDecorator)("editorGroupsService");var b;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(b=e.GroupDirection||(e.GroupDirection={}));var L;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(L=e.GroupOrientation||(e.GroupOrientation={}));var D;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(D=e.GroupLocation||(e.GroupLocation={}));var k;(function(f){f[f.MAXIMIZE=0]="MAXIMIZE",f[f.EVEN=1]="EVEN",f[f.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var E;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(E=e.MergeGroupMode||(e.MergeGroupMode={}));function P(f){const h=f;return(0,p.isEditorInput)(h?.editor)&&(0,p.isEditorInput)(h?.replacement)}e.isEditorReplacement=P;var O;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(O=e.GroupsOrder||(e.GroupsOrder={}));var y;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(y=e.OpenEditorContext||(e.OpenEditorContext={}));function m(f){const h=f;return!!h&&typeof h.id=="number"&&Array.isArray(h.editors)}e.isEditorGroup=m;function T(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=T}),define(ye[172],De([1,0,3,90]),function(ne,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,a.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function b(L){const D=L;return typeof L=="number"||(0,p.isEditorGroup)(D)}e.isPreferredGroup=b}),define(ye[8],De([1,0,16,23,75,25,106,55,26,10,2,48,66,144,80,89,88,46,47,172,6,173]),function(ne,e,a,p,b,L,D,k,E,P,O,y,m,T,f,h,d,o,v,R,c,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(we){function Ce(j){const{selectionStartLineNumber:Pe,selectionStartColumn:Le,positionLineNumber:tt,positionColumn:Xe}=j,je=new c.Position(Pe-1,Le-1),ut=new c.Position(tt-1,Xe-1);return new c.Selection(je,ut)}we.to=Ce;function me(j){const{anchor:Pe,active:Le}=j;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}we.from=me})(s=e.Selection||(e.Selection={}));var u;(function(we){function Ce(j){if(!j)return;const{start:Pe,end:Le}=j;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}we.from=Ce;function me(j){if(!j)return;const{startLineNumber:Pe,startColumn:Le,endLineNumber:tt,endColumn:Xe}=j;return new c.Range(Pe-1,Le-1,tt-1,Xe-1)}we.to=me})(u=e.Range||(e.Range={}));var n;(function(we){function Ce(me){switch(me){case 1:return c.StandardTokenType.Comment;case 0:return c.StandardTokenType.Other;case 3:return c.StandardTokenType.RegEx;case 2:return c.StandardTokenType.String}}we.to=Ce})(n=e.TokenType||(e.TokenType={}));var i;(function(we){function Ce(j){return new c.Position(j.lineNumber-1,j.column-1)}we.to=Ce;function me(j){return{lineNumber:j.line+1,column:j.character+1}}we.from=me})(i=e.Position||(e.Position={}));var r;(function(we){function Ce(Pe,Le){return(0,a.coalesce)((0,a.asArray)(Pe).map(tt=>me(tt,Le)))}we.from=Ce;function me(Pe,Le){if(typeof Pe=="string")return{$serialized:!0,language:Pe};if(Pe)return{$serialized:!0,language:Pe.language,scheme:j(Pe.scheme,Le),pattern:fe.from(Pe.pattern)??void 0,exclusive:Pe.exclusive,notebookType:Pe.notebookType}}function j(Pe,Le){return Le&&typeof Pe=="string"?Le.transformOutgoingScheme(Pe):Pe}})(r=e.DocumentSelector||(e.DocumentSelector={}));var t;(function(we){function Ce(j){switch(j){case c.DiagnosticTag.Unnecessary:return 1;case c.DiagnosticTag.Deprecated:return 2}}we.from=Ce;function me(j){switch(j){case 1:return c.DiagnosticTag.Unnecessary;case 2:return c.DiagnosticTag.Deprecated;default:return}}we.to=me})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var l;(function(we){function Ce(j){let Pe;return j.code&&((0,P.isString)(j.code)||(0,P.isNumber)(j.code)?Pe=String(j.code):Pe={value:String(j.code.value),target:j.code.target}),{...u.from(j.range),message:j.message,source:j.source,code:Pe,severity:g.from(j.severity),relatedInformation:j.relatedInformation&&j.relatedInformation.map(_.from),tags:Array.isArray(j.tags)?(0,a.coalesce)(j.tags.map(t.from)):void 0}}we.from=Ce;function me(j){const Pe=new c.Diagnostic(u.to(j),j.message,g.to(j.severity));return Pe.source=j.source,Pe.code=(0,P.isString)(j.code)?j.code:j.code?.value,Pe.relatedInformation=j.relatedInformation&&j.relatedInformation.map(_.to),Pe.tags=j.tags&&(0,a.coalesce)(j.tags.map(t.to)),Pe}we.to=me})(l=e.Diagnostic||(e.Diagnostic={}));var _;(function(we){function Ce(j){return{...u.from(j.location.range),message:j.message,resource:j.location.uri}}we.from=Ce;function me(j){return new c.DiagnosticRelatedInformation(new c.Location(j.resource,u.to(j)),j.message)}we.to=me})(_=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var g;(function(we){function Ce(j){switch(j){case c.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case c.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case c.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case c.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}we.from=Ce;function me(j){switch(j){case f.MarkerSeverity.Info:return c.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return c.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return c.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return c.DiagnosticSeverity.Hint;default:return c.DiagnosticSeverity.Error}}we.to=me})(g=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var C;(function(we){function Ce(j){return typeof j=="number"&&j>=c.ViewColumn.One?j-1:j===c.ViewColumn.Beside?R.SIDE_GROUP:R.ACTIVE_GROUP}we.from=Ce;function me(j){if(typeof j=="number"&&j>=0)return j+1;throw new Error("invalid 'EditorGroupColumn'")}we.to=me})(C=e.ViewColumn||(e.ViewColumn={}));function U(we){return typeof we.range!="undefined"}function W(we){return we.length===0?!0:!!U(we[0])}e.isDecorationOptionsArr=W;var M;(function(we){function Ce(Xe){return Xe.map(we.from)}we.fromMany=Ce;function me(Xe){return Xe&&typeof Xe=="object"&&typeof Xe.language=="string"&&typeof Xe.value=="string"}function j(Xe){let je;if(me(Xe)){const{language:pt,value:_t}=Xe;je={value:"```"+pt+`
`+_t+"\n```\n"}}else c.MarkdownString.isMarkdownString(Xe)?je={value:Xe.value,isTrusted:Xe.isTrusted,supportThemeIcons:Xe.supportThemeIcons,supportHtml:Xe.supportHtml,baseUri:Xe.baseUri}:typeof Xe=="string"?je={value:Xe}:je={value:""};const ut=Object.create(null);je.uris=ut;const gt=pt=>{try{let _t=O.URI.parse(pt,!0);_t=_t.with({query:Pe(_t.query,ut)}),ut[pt]=_t}catch{}return""},yt=new D.marked.Renderer;return yt.link=gt,yt.image=pt=>typeof pt=="string"?gt(b.parseHrefAndDimensions(pt).href):"",(0,D.marked)(je.value,{renderer:yt}),je}we.from=j;function Pe(Xe,je){if(!Xe)return Xe;let ut;try{ut=(0,k.parse)(Xe)}catch{}if(!ut)return Xe;let gt=!1;return ut=(0,E.cloneAndChange)(ut,yt=>{if(O.URI.isUri(yt)){const pt=`__uri_${Math.random().toString(16).slice(2,8)}`;return je[pt]=yt,gt=!0,pt}else return}),gt?JSON.stringify(ut):Xe}function Le(Xe){const je=new c.MarkdownString(Xe.value,Xe.supportThemeIcons);return je.isTrusted=Xe.isTrusted,je.supportHtml=Xe.supportHtml,je.baseUri=Xe.baseUri?O.URI.from(Xe.baseUri):void 0,je}we.to=Le;function tt(Xe){if(!!Xe)return typeof Xe=="string"?Xe:we.from(Xe)}we.fromStrict=tt})(M=e.MarkdownString||(e.MarkdownString={}));function S(we){return W(we)?we.map(Ce=>({range:u.from(Ce.range),hoverMessage:Array.isArray(Ce.hoverMessage)?M.fromMany(Ce.hoverMessage):Ce.hoverMessage?M.from(Ce.hoverMessage):void 0,renderOptions:Ce.renderOptions})):we.map(Ce=>({range:u.from(Ce)}))}e.fromRangeOrRangeWithMessage=S;function z(we){return typeof we=="undefined"?we:typeof we=="string"?O.URI.file(we):we}e.pathOrURIToURI=z;var $;(function(we){function Ce(me){return typeof me=="undefined"?me:{contentText:me.contentText,contentIconPath:me.contentIconPath?z(me.contentIconPath):void 0,border:me.border,borderColor:me.borderColor,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,color:me.color,backgroundColor:me.backgroundColor,margin:me.margin,width:me.width,height:me.height}}we.from=Ce})($=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var F;(function(we){function Ce(me){return typeof me=="undefined"?me:{backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?z(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?$.from(me.before):void 0,after:me.after?$.from(me.after):void 0}}we.from=Ce})(F=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var q;(function(we){function Ce(me){if(typeof me=="undefined")return me;switch(me){case c.DecorationRangeBehavior.OpenOpen:return 0;case c.DecorationRangeBehavior.ClosedClosed:return 1;case c.DecorationRangeBehavior.OpenClosed:return 2;case c.DecorationRangeBehavior.ClosedOpen:return 3}}we.from=Ce})(q=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var ie;(function(we){function Ce(me){return{isWholeLine:me.isWholeLine,rangeBehavior:me.rangeBehavior?q.from(me.rangeBehavior):void 0,overviewRulerLane:me.overviewRulerLane,light:me.light?F.from(me.light):void 0,dark:me.dark?F.from(me.dark):void 0,backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?z(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?$.from(me.before):void 0,after:me.after?$.from(me.after):void 0}}we.from=Ce})(ie=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var A;(function(we){function Ce(j){return{text:j.newText,eol:j.newEol&&Ge.from(j.newEol),range:u.from(j.range)}}we.from=Ce;function me(j){const Pe=new c.TextEdit(u.to(j.range),j.text);return Pe.newEol=typeof j.eol=="undefined"?void 0:Ge.to(j.eol),Pe}we.to=me})(A=e.TextEdit||(e.TextEdit={}));var Z;(function(we){function Ce(j,Pe,Le){const tt={edits:[]};if(j instanceof c.WorkspaceEdit){const Xe=new L.ResourceSet;for(const je of j._allEntries())je._type===1&&O.URI.isUri(je.to)&&je.from===void 0&&Xe.add(je.to);for(const je of j._allEntries())if(je._type===1)tt.edits.push({oldResource:je.from,newResource:je.to,options:je.options,metadata:je.metadata});else if(je._type===2)tt.edits.push({resource:je.uri,textEdit:A.from(je.edit),versionId:Xe.has(je.uri)?void 0:Pe?.getTextDocumentVersion(je.uri),metadata:je.metadata});else if(je._type===6){if(!Le){console.warn("DROPPING snippet text edit because proposal IS NOT ENABLED",je);continue}tt.edits.push({resource:je.uri,textEdit:{range:u.from(je.range),text:je.edit.value,insertAsSnippet:!0},versionId:Xe.has(je.uri)?void 0:Pe?.getTextDocumentVersion(je.uri),metadata:je.metadata})}else je._type===3?tt.edits.push({metadata:je.metadata,resource:je.uri,cellEdit:je.edit,notebookMetadata:je.notebookMetadata,notebookVersionId:Pe?.getNotebookDocumentVersion(je.uri)}):je._type===5&&tt.edits.push({metadata:je.metadata,resource:je.uri,notebookVersionId:Pe?.getNotebookDocumentVersion(je.uri),cellEdit:{editType:1,index:je.index,count:je.count,cells:je.cells.map(ot.from)}})}return tt}we.from=Ce;function me(j){const Pe=new c.WorkspaceEdit;for(const Le of j.edits)Le.textEdit?Pe.replace(O.URI.revive(Le.resource),u.to(Le.textEdit.range),Le.textEdit.text):Pe.renameFile(O.URI.revive(Le.oldResource),O.URI.revive(Le.newResource),Le.options);return Pe}we.to=me})(Z=e.WorkspaceEdit||(e.WorkspaceEdit={}));var ce;(function(we){const Ce=Object.create(null);Ce[c.SymbolKind.File]=0,Ce[c.SymbolKind.Module]=1,Ce[c.SymbolKind.Namespace]=2,Ce[c.SymbolKind.Package]=3,Ce[c.SymbolKind.Class]=4,Ce[c.SymbolKind.Method]=5,Ce[c.SymbolKind.Property]=6,Ce[c.SymbolKind.Field]=7,Ce[c.SymbolKind.Constructor]=8,Ce[c.SymbolKind.Enum]=9,Ce[c.SymbolKind.Interface]=10,Ce[c.SymbolKind.Function]=11,Ce[c.SymbolKind.Variable]=12,Ce[c.SymbolKind.Constant]=13,Ce[c.SymbolKind.String]=14,Ce[c.SymbolKind.Number]=15,Ce[c.SymbolKind.Boolean]=16,Ce[c.SymbolKind.Array]=17,Ce[c.SymbolKind.Object]=18,Ce[c.SymbolKind.Key]=19,Ce[c.SymbolKind.Null]=20,Ce[c.SymbolKind.EnumMember]=21,Ce[c.SymbolKind.Struct]=22,Ce[c.SymbolKind.Event]=23,Ce[c.SymbolKind.Operator]=24,Ce[c.SymbolKind.TypeParameter]=25;function me(Pe){return typeof Ce[Pe]=="number"?Ce[Pe]:6}we.from=me;function j(Pe){for(const Le in Ce)if(Ce[Le]===Pe)return Number(Le);return c.SymbolKind.Property}we.to=j})(ce=e.SymbolKind||(e.SymbolKind={}));var oe;(function(we){function Ce(j){switch(j){case c.SymbolTag.Deprecated:return 1}}we.from=Ce;function me(j){switch(j){case 1:return c.SymbolTag.Deprecated}}we.to=me})(oe=e.SymbolTag||(e.SymbolTag={}));var ue;(function(we){function Ce(j){return{name:j.name,kind:ce.from(j.kind),tags:j.tags&&j.tags.map(oe.from),containerName:j.containerName,location:ve.from(j.location)}}we.from=Ce;function me(j){const Pe=new c.SymbolInformation(j.name,ce.to(j.kind),j.containerName,ve.to(j.location));return Pe.tags=j.tags&&j.tags.map(oe.to),Pe}we.to=me})(ue=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var te;(function(we){function Ce(j){const Pe={name:j.name||"!!MISSING: name!!",detail:j.detail,range:u.from(j.range),selectionRange:u.from(j.selectionRange),kind:ce.from(j.kind),tags:j.tags?.map(oe.from)??[]};return j.children&&(Pe.children=j.children.map(Ce)),Pe}we.from=Ce;function me(j){const Pe=new c.DocumentSymbol(j.name,j.detail,ce.to(j.kind),u.to(j.range),u.to(j.selectionRange));return(0,a.isNonEmptyArray)(j.tags)&&(Pe.tags=j.tags.map(oe.to)),j.children&&(Pe.children=j.children.map(me)),Pe}we.to=me})(te=e.DocumentSymbol||(e.DocumentSymbol={}));var Ee;(function(we){function Ce(j){const Pe=new c.CallHierarchyItem(ce.to(j.kind),j.name,j.detail||"",O.URI.revive(j.uri),u.to(j.range),u.to(j.selectionRange));return Pe._sessionId=j._sessionId,Pe._itemId=j._itemId,Pe}we.to=Ce;function me(j,Pe,Le){if(Pe=Pe??j._sessionId,Le=Le??j._itemId,Pe===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Le,name:j.name,detail:j.detail,kind:ce.from(j.kind),uri:j.uri,range:u.from(j.range),selectionRange:u.from(j.selectionRange),tags:j.tags?.map(oe.from)}}we.from=me})(Ee=e.CallHierarchyItem||(e.CallHierarchyItem={}));var be;(function(we){function Ce(me){return new c.CallHierarchyIncomingCall(Ee.to(me.from),me.fromRanges.map(j=>u.to(j)))}we.to=Ce})(be=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ee;(function(we){function Ce(me){return new c.CallHierarchyOutgoingCall(Ee.to(me.to),me.fromRanges.map(j=>u.to(j)))}we.to=Ce})(ee=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ve;(function(we){function Ce(j){return{range:j.range&&u.from(j.range),uri:j.uri}}we.from=Ce;function me(j){return new c.Location(O.URI.revive(j.uri),u.to(j.range))}we.to=me})(ve=e.location||(e.location={}));var Ae;(function(we){function Ce(j){const Pe=j,Le=j;return{originSelectionRange:Pe.originSelectionRange?u.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:Le.uri,range:u.from(Pe.targetRange?Pe.targetRange:Le.range),targetSelectionRange:Pe.targetSelectionRange?u.from(Pe.targetSelectionRange):void 0}}we.from=Ce;function me(j){return{targetUri:O.URI.revive(j.uri),targetRange:u.to(j.range),targetSelectionRange:j.targetSelectionRange?u.to(j.targetSelectionRange):void 0,originSelectionRange:j.originSelectionRange?u.to(j.originSelectionRange):void 0}}we.to=me})(Ae=e.DefinitionLink||(e.DefinitionLink={}));var Fe;(function(we){function Ce(j){return{range:u.from(j.range),contents:M.fromMany(j.contents)}}we.from=Ce;function me(j){return new c.Hover(j.contents.map(M.to),u.to(j.range))}we.to=me})(Fe=e.Hover||(e.Hover={}));var $e;(function(we){function Ce(j){return{range:u.from(j.range),expression:j.expression}}we.from=Ce;function me(j){return new c.EvaluatableExpression(u.to(j.range),j.expression)}we.to=me})($e=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Qe;(function(we){function Ce(j){if(j instanceof c.InlineValueText)return{type:"text",range:u.from(j.range),text:j.text};if(j instanceof c.InlineValueVariableLookup)return{type:"variable",range:u.from(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};if(j instanceof c.InlineValueEvaluatableExpression)return{type:"expression",range:u.from(j.range),expression:j.expression};throw new Error("Unknown 'InlineValue' type")}we.from=Ce;function me(j){switch(j.type){case"text":return{range:u.to(j.range),text:j.text};case"variable":return{range:u.to(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};case"expression":return{range:u.to(j.range),expression:j.expression}}}we.to=me})(Qe=e.InlineValue||(e.InlineValue={}));var Ie;(function(we){function Ce(j){return{frameId:j.frameId,stoppedLocation:u.from(j.stoppedLocation)}}we.from=Ce;function me(j){return new c.InlineValueContext(j.frameId,u.to(j.stoppedLocation))}we.to=me})(Ie=e.InlineValueContext||(e.InlineValueContext={}));var Se;(function(we){function Ce(j){return{range:u.from(j.range),kind:j.kind}}we.from=Ce;function me(j){return new c.DocumentHighlight(u.to(j.range),j.kind)}we.to=me})(Se=e.DocumentHighlight||(e.DocumentHighlight={}));var ke;(function(we){function Ce(me){switch(me){case 1:return c.CompletionTriggerKind.TriggerCharacter;case 2:return c.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return c.CompletionTriggerKind.Invoke}}we.to=Ce})(ke=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ae;(function(we){function Ce(me){return{triggerKind:ke.to(me.triggerKind),triggerCharacter:me.triggerCharacter}}we.to=Ce})(ae=e.CompletionContext||(e.CompletionContext={}));var le;(function(we){function Ce(j){switch(j){case c.CompletionItemTag.Deprecated:return 1}}we.from=Ce;function me(j){switch(j){case 1:return c.CompletionItemTag.Deprecated}}we.to=me})(le=e.CompletionItemTag||(e.CompletionItemTag={}));var G;(function(we){const Ce=new Map([[c.CompletionItemKind.Method,0],[c.CompletionItemKind.Function,1],[c.CompletionItemKind.Constructor,2],[c.CompletionItemKind.Field,3],[c.CompletionItemKind.Variable,4],[c.CompletionItemKind.Class,5],[c.CompletionItemKind.Interface,7],[c.CompletionItemKind.Struct,6],[c.CompletionItemKind.Module,8],[c.CompletionItemKind.Property,9],[c.CompletionItemKind.Unit,12],[c.CompletionItemKind.Value,13],[c.CompletionItemKind.Constant,14],[c.CompletionItemKind.Enum,15],[c.CompletionItemKind.EnumMember,16],[c.CompletionItemKind.Keyword,17],[c.CompletionItemKind.Snippet,27],[c.CompletionItemKind.Text,18],[c.CompletionItemKind.Color,19],[c.CompletionItemKind.File,20],[c.CompletionItemKind.Reference,21],[c.CompletionItemKind.Folder,23],[c.CompletionItemKind.Event,10],[c.CompletionItemKind.Operator,11],[c.CompletionItemKind.TypeParameter,24],[c.CompletionItemKind.Issue,26],[c.CompletionItemKind.User,25]]);function me(Le){return Ce.get(Le)??9}we.from=me;const j=new Map([[0,c.CompletionItemKind.Method],[1,c.CompletionItemKind.Function],[2,c.CompletionItemKind.Constructor],[3,c.CompletionItemKind.Field],[4,c.CompletionItemKind.Variable],[5,c.CompletionItemKind.Class],[7,c.CompletionItemKind.Interface],[6,c.CompletionItemKind.Struct],[8,c.CompletionItemKind.Module],[9,c.CompletionItemKind.Property],[12,c.CompletionItemKind.Unit],[13,c.CompletionItemKind.Value],[14,c.CompletionItemKind.Constant],[15,c.CompletionItemKind.Enum],[16,c.CompletionItemKind.EnumMember],[17,c.CompletionItemKind.Keyword],[27,c.CompletionItemKind.Snippet],[18,c.CompletionItemKind.Text],[19,c.CompletionItemKind.Color],[20,c.CompletionItemKind.File],[21,c.CompletionItemKind.Reference],[23,c.CompletionItemKind.Folder],[10,c.CompletionItemKind.Event],[11,c.CompletionItemKind.Operator],[24,c.CompletionItemKind.TypeParameter],[25,c.CompletionItemKind.User],[26,c.CompletionItemKind.Issue]]);function Pe(Le){return j.get(Le)??c.CompletionItemKind.Property}we.to=Pe})(G=e.CompletionItemKind||(e.CompletionItemKind={}));var Q;(function(we){function Ce(me,j){const Pe=new c.CompletionItem(me.label);return Pe.insertText=me.insertText,Pe.kind=G.to(me.kind),Pe.tags=me.tags?.map(le.to),Pe.detail=me.detail,Pe.documentation=b.isMarkdownString(me.documentation)?M.to(me.documentation):me.documentation,Pe.sortText=me.sortText,Pe.filterText=me.filterText,Pe.preselect=me.preselect,Pe.commitCharacters=me.commitCharacters,y.Range.isIRange(me.range)?Pe.range=u.to(me.range):typeof me.range=="object"&&(Pe.range={inserting:u.to(me.range.insert),replacing:u.to(me.range.replace)}),Pe.keepWhitespace=typeof me.insertTextRules=="undefined"?!1:Boolean(me.insertTextRules&1),typeof me.insertTextRules!="undefined"&&me.insertTextRules&4?Pe.insertText=new c.SnippetString(me.insertText):(Pe.insertText=me.insertText,Pe.textEdit=Pe.range instanceof c.Range?new c.TextEdit(Pe.range,Pe.insertText):void 0),me.additionalTextEdits&&me.additionalTextEdits.length>0&&(Pe.additionalTextEdits=me.additionalTextEdits.map(Le=>A.to(Le))),Pe.command=j&&me.command?j.fromInternal(me.command):void 0,Pe}we.to=Ce})(Q=e.CompletionItem||(e.CompletionItem={}));var I;(function(we){function Ce(j){return{label:j.label,documentation:M.fromStrict(j.documentation)}}we.from=Ce;function me(j){return{label:j.label,documentation:b.isMarkdownString(j.documentation)?M.to(j.documentation):j.documentation}}we.to=me})(I=e.ParameterInformation||(e.ParameterInformation={}));var B;(function(we){function Ce(j){return{label:j.label,documentation:M.fromStrict(j.documentation),parameters:Array.isArray(j.parameters)?j.parameters.map(I.from):[],activeParameter:j.activeParameter}}we.from=Ce;function me(j){return{label:j.label,documentation:b.isMarkdownString(j.documentation)?M.to(j.documentation):j.documentation,parameters:Array.isArray(j.parameters)?j.parameters.map(I.to):[],activeParameter:j.activeParameter}}we.to=me})(B=e.SignatureInformation||(e.SignatureInformation={}));var H;(function(we){function Ce(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(B.from):[]}}we.from=Ce;function me(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(B.to):[]}}we.to=me})(H=e.SignatureHelp||(e.SignatureHelp={}));var V;(function(we){function Ce(me,j){const Pe=new c.InlayHint(i.to(j.position),typeof j.label=="string"?j.label:j.label.map(se.to.bind(void 0,me)),j.kind&&de.to(j.kind));return Pe.textEdits=j.textEdits&&j.textEdits.map(A.to),Pe.tooltip=b.isMarkdownString(j.tooltip)?M.to(j.tooltip):j.tooltip,Pe.paddingLeft=j.paddingLeft,Pe.paddingRight=j.paddingRight,Pe}we.to=Ce})(V=e.InlayHint||(e.InlayHint={}));var se;(function(we){function Ce(me,j){const Pe=new c.InlayHintLabelPart(j.label);return Pe.tooltip=b.isMarkdownString(j.tooltip)?M.to(j.tooltip):j.tooltip,m.Command.is(j.command)&&(Pe.command=me.fromInternal(j.command)),j.location&&(Pe.location=ve.to(j.location)),Pe}we.to=Ce})(se=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var de;(function(we){function Ce(j){return j}we.from=Ce;function me(j){return j}we.to=me})(de=e.InlayHintKind||(e.InlayHintKind={}));var J;(function(we){function Ce(j){return{range:u.from(j.range),url:j.target,tooltip:j.tooltip}}we.from=Ce;function me(j){let Pe;if(j.url)try{Pe=typeof j.url=="string"?O.URI.parse(j.url,!0):O.URI.revive(j.url)}catch{}return new c.DocumentLink(u.to(j.range),Pe)}we.to=me})(J=e.DocumentLink||(e.DocumentLink={}));var pe;(function(we){function Ce(j){const Pe=new c.ColorPresentation(j.label);return j.textEdit&&(Pe.textEdit=A.to(j.textEdit)),j.additionalTextEdits&&(Pe.additionalTextEdits=j.additionalTextEdits.map(Le=>A.to(Le))),Pe}we.to=Ce;function me(j){return{label:j.label,textEdit:j.textEdit?A.from(j.textEdit):void 0,additionalTextEdits:j.additionalTextEdits?j.additionalTextEdits.map(Pe=>A.from(Pe)):void 0}}we.from=me})(pe=e.ColorPresentation||(e.ColorPresentation={}));var ge;(function(we){function Ce(j){return new c.Color(j[0],j[1],j[2],j[3])}we.to=Ce;function me(j){return[j.red,j.green,j.blue,j.alpha]}we.from=me})(ge=e.Color||(e.Color={}));var Ne;(function(we){function Ce(j){return{range:u.from(j.range)}}we.from=Ce;function me(j){return new c.SelectionRange(u.to(j.range))}we.to=me})(Ne=e.SelectionRange||(e.SelectionRange={}));var Be;(function(we){function Ce(me){switch(me){case 2:return c.TextDocumentSaveReason.AfterDelay;case 1:return c.TextDocumentSaveReason.Manual;case 3:case 4:return c.TextDocumentSaveReason.FocusOut}}we.to=Ce})(Be=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Je;(function(we){function Ce(j){switch(j){case c.TextEditorLineNumbersStyle.Off:return 0;case c.TextEditorLineNumbersStyle.Relative:return 2;case c.TextEditorLineNumbersStyle.On:default:return 1}}we.from=Ce;function me(j){switch(j){case 0:return c.TextEditorLineNumbersStyle.Off;case 2:return c.TextEditorLineNumbersStyle.Relative;case 1:default:return c.TextEditorLineNumbersStyle.On}}we.to=me})(Je=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ge;(function(we){function Ce(j){if(j===c.EndOfLine.CRLF)return 1;if(j===c.EndOfLine.LF)return 0}we.from=Ce;function me(j){if(j===1)return c.EndOfLine.CRLF;if(j===0)return c.EndOfLine.LF}we.to=me})(Ge=e.EndOfLine||(e.EndOfLine={}));var Te;(function(we){function Ce(me){if(typeof me=="object")return me.viewId;switch(me){case c.ProgressLocation.SourceControl:return 3;case c.ProgressLocation.Window:return 10;case c.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}we.from=Ce})(Te=e.ProgressLocation||(e.ProgressLocation={}));var rt;(function(we){function Ce(me){const j={start:me.start+1,end:me.end+1};return me.kind&&(j.kind=K.from(me.kind)),j}we.from=Ce})(rt=e.FoldingRange||(e.FoldingRange={}));var K;(function(we){function Ce(me){if(me)switch(me){case c.FoldingRangeKind.Comment:return m.FoldingRangeKind.Comment;case c.FoldingRangeKind.Imports:return m.FoldingRangeKind.Imports;case c.FoldingRangeKind.Region:return m.FoldingRangeKind.Region}}we.from=Ce})(K=e.FoldingRangeKind||(e.FoldingRangeKind={}));var X;(function(we){function Ce(me){if(me)return{pinned:typeof me.preview=="boolean"?!me.preview:void 0,inactive:me.background,preserveFocus:me.preserveFocus,selection:typeof me.selection=="object"?u.from(me.selection):void 0,override:typeof me.override=="boolean"?T.EditorResolution.DISABLED:void 0}}we.from=Ce})(X=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var fe;(function(we){function Ce(Le){return Le instanceof c.RelativePattern?Le.toJSON():typeof Le=="string"?Le:me(Le)||j(Le)?new c.RelativePattern(Le.baseUri??Le.base,Le.pattern).toJSON():Le}we.from=Ce;function me(Le){const tt=Le;return tt?O.URI.isUri(tt.baseUri)&&typeof tt.pattern=="string":!1}function j(Le){const tt=Le;return tt?typeof tt.base=="string"&&typeof tt.pattern=="string":!1}function Pe(Le){return typeof Le=="string"?Le:new c.RelativePattern(O.URI.revive(Le.baseUri),Le.pattern)}we.to=Pe})(fe=e.GlobPattern||(e.GlobPattern={}));var Ue;(function(we){function Ce(me){if(me){if(Array.isArray(me))return me.map(Ce);if(typeof me=="string")return me;{const j=me;return{language:j.language,scheme:j.scheme,pattern:fe.from(j.pattern),exclusive:j.exclusive,notebookType:j.notebookType}}}else return}we.from=Ce})(Ue=e.LanguageSelector||(e.LanguageSelector={}));var He;(function(we){function Ce(j){return{start:j.start,end:j.end}}we.from=Ce;function me(j){return new c.NotebookRange(j.start,j.end)}we.to=me})(He=e.NotebookRange||(e.NotebookRange={}));var Ze;(function(we){function Ce(j){return{timing:typeof j.runStartTime=="number"&&typeof j.runEndTime=="number"?{startTime:j.runStartTime,endTime:j.runEndTime}:void 0,executionOrder:j.executionOrder,success:j.lastRunSuccess}}we.to=Ce;function me(j){return{lastRunSuccess:j.success,runStartTime:j.timing?.startTime,runEndTime:j.timing?.endTime,executionOrder:j.executionOrder}}we.from=me})(Ze=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var qe;(function(we){function Ce(me){if(me===d.NotebookCellExecutionState.Unconfirmed)return c.NotebookCellExecutionState.Pending;if(me===d.NotebookCellExecutionState.Pending)return;if(me===d.NotebookCellExecutionState.Executing)return c.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${me}`)}we.to=Ce})(qe=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var We;(function(we){function Ce(j){switch(j){case c.NotebookCellKind.Markup:return d.CellKind.Markup;case c.NotebookCellKind.Code:default:return d.CellKind.Code}}we.from=Ce;function me(j){switch(j){case d.CellKind.Markup:return c.NotebookCellKind.Markup;case d.CellKind.Code:default:return c.NotebookCellKind.Code}}we.to=me})(We=e.NotebookCellKind||(e.NotebookCellKind={}));var nt;(function(we){function Ce(j){const Pe={metadata:j.metadata??Object.create(null),cells:[]};for(const Le of j.cells)c.NotebookCellData.validate(Le),Pe.cells.push(ot.from(Le));return Pe}we.from=Ce;function me(j){const Pe=new c.NotebookData(j.cells.map(ot.to));return(0,P.isEmptyObject)(j.metadata)||(Pe.metadata=j.metadata),Pe}we.to=me})(nt=e.NotebookData||(e.NotebookData={}));var ot;(function(we){function Ce(j){return{cellKind:We.from(j.kind),language:j.languageId,mime:j.mime,source:j.value,metadata:j.metadata,internalMetadata:Ze.from(j.executionSummary??{}),outputs:j.outputs?j.outputs.map(kt.from):[]}}we.from=Ce;function me(j){return new c.NotebookCellData(We.to(j.cellKind),j.source,j.language,j.mime,j.outputs?j.outputs.map(kt.to):void 0,j.metadata,j.internalMetadata?Ze.to(j.internalMetadata):void 0)}we.to=me})(ot=e.NotebookCellData||(e.NotebookCellData={}));var ht;(function(we){function Ce(j){return{mime:j.mime,valueBytes:p.VSBuffer.wrap(j.data)}}we.from=Ce;function me(j){return new c.NotebookCellOutputItem(j.valueBytes.buffer,j.mime)}we.to=me})(ht=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var kt;(function(we){function Ce(j){return{outputId:j.id,items:j.items.map(ht.from),metadata:j.metadata}}we.from=Ce;function me(j){const Pe=j.items.map(ht.to);return new c.NotebookCellOutput(Pe,j.outputId,j.metadata)}we.to=me})(kt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var it;(function(we){function Ce(Pe){return j(Pe)?{include:(0,P.withNullAsUndefined)(fe.from(Pe.include)),exclude:(0,P.withNullAsUndefined)(fe.from(Pe.exclude))}:(0,P.withNullAsUndefined)(fe.from(Pe))}we.from=Ce;function me(Pe){return j(Pe)?{include:fe.to(Pe.include),exclude:fe.to(Pe.exclude)}:fe.to(Pe)}we.to=me;function j(Pe){const Le=Pe;return Le?!(0,P.isUndefinedOrNull)(Le.include)&&!(0,P.isUndefinedOrNull)(Le.exclude):!1}})(it=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var dt;(function(we){function Ce(me,j,Pe){const Le=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{alignment:me.alignment===c.NotebookCellStatusBarAlignment.Left?1:2,command:j.toInternal(Le,Pe),text:me.text,tooltip:me.tooltip,accessibilityInformation:me.accessibilityInformation,priority:me.priority}}we.from=Ce})(dt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Ot;(function(we){function Ce(me){return{transientOutputs:me?.transientOutputs??!1,transientCellMetadata:me?.transientCellMetadata??{},transientDocumentMetadata:me?.transientDocumentMetadata??{}}}we.from=Ce})(Ot=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Wt;(function(we){function Ce(j){return{uri:j.uri,provides:j.provides}}we.from=Ce;function me(j){return new c.NotebookRendererScript(O.URI.revive(j.uri),j.provides)}we.to=me})(Wt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Dt;(function(we){function Ce(j){return{message:M.fromStrict(j.message)||"",type:0,expected:j.expectedOutput,actual:j.actualOutput,location:j.location&&{range:u.from(j.location.range),uri:j.location.uri}}}we.from=Ce;function me(j){const Pe=new c.TestMessage(typeof j.message=="string"?j.message:M.to(j.message));return Pe.actualOutput=j.actual,Pe.expectedOutput=j.expected,Pe.location=j.location?ve.to(j.location):void 0,Pe}we.to=me})(Dt=e.TestMessage||(e.TestMessage={}));var ft;(function(we){we.namespace=v.namespaceTestTag,we.denamespace=v.denamespaceTestTag})(ft=e.TestTag||(e.TestTag={}));var Ct;(function(we){function Ce(j){const Pe=(0,h.getPrivateApiFor)(j).controllerId;return{extId:o.TestId.fromExtHostTestItem(j,Pe).toString(),label:j.label,uri:O.URI.revive(j.uri),busy:!1,tags:j.tags.map(Le=>ft.namespace(Pe,Le.id)),range:y.Range.lift(u.from(j.range)),description:j.description||null,sortText:j.sortText||null,error:j.error&&M.fromStrict(j.error)||null}}we.from=Ce;function me(j){return{parent:void 0,error:void 0,id:o.TestId.fromString(j.extId).localId,label:j.label,uri:O.URI.revive(j.uri),tags:(j.tags||[]).map(Pe=>{const{tagId:Le}=ft.denamespace(Pe);return new c.TestTag(Le)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:u.to(j.range||void 0),canResolveChildren:!1,busy:!1,description:j.description||void 0,sortText:j.sortText||void 0}}we.toPlain=me})(Ct=e.TestItem||(e.TestItem={})),function(we){function Ce(j){return{id:j.id}}we.from=Ce;function me(j){return new c.TestTag(j.id)}we.to=me}(ft=e.TestTag||(e.TestTag={}));var Lt;(function(we){const Ce=(j,Pe)=>{const Le=[];for(const[Xe,je]of Pe)o.TestId.compare(je.item.extId,Xe)===2&&(Pe.delete(Xe),Le.push(je));const tt={...Ct.toPlain(j.item),parent:void 0,taskStates:j.tasks.map(Xe=>({state:Xe.state,duration:Xe.duration,messages:Xe.messages.filter(je=>je.type===0).map(Dt.to)})),children:Le.map(Xe=>Ce(Xe,Pe))};for(const Xe of tt.children)Xe.parent=tt;return tt};function me(j){const Pe=[],Le=new Map;for(const tt of j.items)Le.set(tt.item.extId,tt),j.request.targets.some(Xe=>Xe.controllerId===tt.controllerId&&Xe.testIds.includes(tt.item.extId))&&Pe.push(tt);return{completedAt:j.completedAt,results:Pe.map(tt=>Ce(tt,Le))}}we.to=me})(Lt=e.TestResults||(e.TestResults={}));var Ft;(function(we){function Ce(Le){return{covered:Le.covered,total:Le.covered}}function me(Le){return"line"in Le?i.from(Le):u.from(Le)}function j(Le){return"branches"in Le?{count:Le.executionCount,location:me(Le.location),type:1,branches:Le.branches.length?Le.branches.map(tt=>({count:tt.executionCount,location:tt.location&&me(tt.location)})):void 0}:{type:0,count:Le.executionCount,location:me(Le.location)}}we.fromDetailed=j;function Pe(Le){return{uri:Le.uri,statement:Ce(Le.statementCoverage),branch:Le.branchCoverage&&Ce(Le.branchCoverage),function:Le.functionCoverage&&Ce(Le.functionCoverage),details:Le.detailedCoverage?.map(j)}}we.fromFile=Pe})(Ft=e.TestCoverage||(e.TestCoverage={}));var Ve;(function(we){function Ce(me){switch(me){case 1:return c.CodeActionTriggerKind.Invoke;case 2:return c.CodeActionTriggerKind.Automatic}}we.to=Ce})(Ve=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Nt;(function(we){function Ce(j){const Pe=new c.TypeHierarchyItem(ce.to(j.kind),j.name,j.detail||"",O.URI.revive(j.uri),u.to(j.range),u.to(j.selectionRange));return Pe._sessionId=j._sessionId,Pe._itemId=j._itemId,Pe}we.to=Ce;function me(j,Pe,Le){if(Pe=Pe??j._sessionId,Le=Le??j._itemId,Pe===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Le,kind:ce.from(j.kind),name:j.name,detail:j.detail??"",uri:j.uri,range:u.from(j.range),selectionRange:u.from(j.selectionRange),tags:j.tags?.map(oe.from)}}we.from=me})(Nt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Rt;(function(we){function Ce(me){if(!!me)return{value:me.value,tooltip:me.tooltip}}we.from=Ce})(Rt=e.ViewBadge||(e.ViewBadge={}));var Ut;(function(we){function Ce(me,j){const Pe=me.fileData;return Pe?new class extends c.DataTransferItem{asFile(){return{name:Pe.name,uri:O.URI.revive(Pe.uri),data:(0,w.once)(()=>j())}}}(""):new c.DataTransferItem(me.asString)}we.toDataTransferItem=Ce})(Ut=e.DataTransferItem||(e.DataTransferItem={}));var vt;(function(we){function Ce(j,Pe){const Le=j.items.map(([tt,Xe],je)=>[tt,Ut.toDataTransferItem(Xe,()=>Pe(je))]);return new c.DataTransfer(Le)}we.toDataTransfer=Ce;async function me(j){const Pe={items:[]},Le=[];return j.forEach((tt,Xe)=>{Le.push((async()=>{const je=await tt.asString(),ut=tt.asFile();Pe.items.push([Xe,{asString:je,fileData:ut?{name:ut.name,uri:ut.uri}:void 0}])})())}),await Promise.all(Le),Pe}we.toDataTransferDTO=me})(vt=e.DataTransfer||(e.DataTransfer={}))}),define(ye[174],De([1,0,2,11,6,8,241]),function(ne,e,a,p,b,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(P,O,y,m={timeout:1500,errors:3}){this._logService=P,this._documents=O,this._mainThreadBulkEdits=y,this._thresholds=m,this._callbacks=new D.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(O,y,m)=>{const f={dispose:this._callbacks.push([O,y,P])};return Array.isArray(m)&&m.push(f),f}}async $participateInSave(P,O){const y=a.URI.revive(P);let m=!1;const T=setTimeout(()=>m=!0,this._thresholds.timeout),f=[];try{for(const h of[...this._callbacks]){if(m)break;const d=this._documents.getDocument(y),o=await this._deliverEventAsyncAndBlameBadListeners(h,{document:d,reason:L.TextDocumentSaveReason.to(O)});f.push(o)}}finally{clearTimeout(T)}return f}_deliverEventAsyncAndBlameBadListeners([P,O,y],m){const T=this._badListeners.get(P);return typeof T=="number"&&T>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(y,P,O,m).then(()=>!0,f=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' threw ERROR`),this._logService.error(f),!(f instanceof Error)||f.message!=="concurrent_edits"){const h=this._badListeners.get(P);this._badListeners.set(P,h?h+1:1),typeof h=="number"&&h>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,O,y,m){const T=[],f=Date.now(),{document:h,reason:d}=m,{version:o}=h,v=Object.freeze({document:h,reason:d,waitUntil(R){if(Object.isFrozen(T))throw(0,p.illegalState)("waitUntil can not be called async");T.push(Promise.resolve(R))}});try{O.apply(y,[v])}catch(R){return Promise.reject(R)}return Object.freeze(T),new Promise((R,c)=>{const w=setTimeout(()=>c(new Error("timeout")),this._thresholds.timeout);return Promise.all(T).then(s=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-f}ms`),clearTimeout(w),R(s)}).catch(s=>{clearTimeout(w),c(s)})}).then(R=>{const c={edits:[]};for(const w of R)if(Array.isArray(w)&&w.every(s=>s instanceof b.TextEdit))for(const{newText:s,newEol:u,range:n}of w)c.edits.push({resource:h.uri,versionId:void 0,textEdit:{range:n&&L.Range.from(n),text:s,eol:u&&L.EndOfLine.from(u)}});if(c.edits.length!==0)return o===h.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(ye[175],De([1,0,12,2,8,6,88]),function(ne,e,a,p,b,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class k{constructor(y,m,T,f){this.start=y,this.deletedCount=m,this.deletedItems=T,this.items=f}asApiEvent(){return{range:new L.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(y=>y.apiCell),removedCells:this.deletedItems}}}class E{constructor(y,m,T){this.notebook=y,this._extHostDocument=m,this._cellData=T,this.handle=T.handle,this.uri=p.URI.revive(T.uri),this.cellKind=T.cellKind,this._outputs=T.outputs.map(b.NotebookCellOutput.to),this._internalMetadata=T.internalMetadata??{},this._metadata=Object.freeze(T.metadata??{}),this._previousResult=Object.freeze(b.NotebookCellExecutionSummary.to(T.internalMetadata??{}))}static asModelAddData(y,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:y}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const y=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const T={get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:b.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get mime(){return y._mime},set mime(f){y._mime=f},get outputs(){return y._outputs.slice(0)},get metadata(){return y._metadata},get executionSummary(){return y._previousResult}};this._apiCell=Object.freeze(T)}return this._apiCell}setOutputs(y){this._outputs=y.map(b.NotebookCellOutput.to)}setOutputItems(y,m,T){const f=T.map(b.NotebookCellOutputItem.to),h=this._outputs.find(d=>d.id===y);h&&(m||(h.items.length=0),h.items.push(...f))}setMetadata(y){this._metadata=Object.freeze(y)}setInternalMetadata(y){this._internalMetadata=y,this._previousResult=Object.freeze(b.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.ExtHostCell=E;class P{constructor(y,m,T,f,h){this._proxy=y,this._textDocumentsAndEditors=m,this._textDocuments=T,this.uri=f,this.handle=P._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=h.viewType,this._metadata=Object.freeze(h.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,h.cells]],!0,void 0),this._versionId=h.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const y=this,m={get uri(){return y.uri},get version(){return y._versionId},get notebookType(){return y._notebookType},get isDirty(){return y._isDirty},get isUntitled(){return y.uri.scheme===a.Schemas.untitled},get isClosed(){return y._disposed},get metadata(){return y._metadata},get cellCount(){return y._cells.length},cellAt(T){return T=y._validateIndex(T),y._cells[T].apiCell},getCells(T){return(T?y._getCells(T):y._cells).map(h=>h.apiCell)},save(){return y._save()}};this._notebook=Object.freeze(m)}return this._notebook}updateBackup(y){this._backup?.delete(),this._backup=y}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(y){y.metadata&&(this._metadata=Object.freeze({...this._metadata,...y.metadata}))}acceptDirty(y){this._isDirty=y}acceptModelChanged(y,m,T){this._versionId=y.versionId,this._isDirty=m,this.acceptDocumentPropertiesChanged({metadata:T});const f={notebook:this.apiNotebook,metadata:T,cellChanges:[],contentChanges:[]},h=[];for(const o of y.rawEvents)o.kind===D.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(o.changes,!1,f.contentChanges):o.kind===D.NotebookCellsChangeType.Move?this._moveCell(o.index,o.newIdx,f.contentChanges):o.kind===D.NotebookCellsChangeType.Output?(this._setCellOutputs(o.index,o.outputs),h.push({cell:this._cells[o.index].apiCell,outputs:this._cells[o.index].apiCell.outputs})):o.kind===D.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(o.index,o.outputId,o.append,o.outputItems),h.push({cell:this._cells[o.index].apiCell,outputs:this._cells[o.index].apiCell.outputs})):o.kind===D.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(o.index,o.language),h.push({cell:this._cells[o.index].apiCell,document:this._cells[o.index].apiCell.document})):o.kind===D.NotebookCellsChangeType.ChangeCellContent?h.push({cell:this._cells[o.index].apiCell,document:this._cells[o.index].apiCell.document}):o.kind===D.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(o.index,o.mime):o.kind===D.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(o.index,o.metadata),h.push({cell:this._cells[o.index].apiCell,metadata:this._cells[o.index].apiCell.metadata})):o.kind===D.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(o.index,o.internalMetadata),h.push({cell:this._cells[o.index].apiCell,executionSummary:this._cells[o.index].apiCell.executionSummary}));const d=new Map;for(let o=0;o<h.length;o++){const v=h[o],R=d.get(v.cell);if(R===void 0){const c=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...v});d.set(v.cell,c-1)}else f.cellChanges[R]={...f.cellChanges[R],...v}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}_validateIndex(y){return y=y|0,y<0?0:y>=this._cells.length?this._cells.length-1:y}_validateRange(y){let m=y.start|0,T=y.end|0;return m<0&&(m=0),T>this._cells.length&&(T=this._cells.length),y.with({start:m,end:T})}_getCells(y){y=this._validateRange(y);const m=[];for(let T=y.start;T<y.end;T++)m.push(this._cells[T]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(y,m,T){if(this._disposed)return;const f=[],h=[],d=[];if(y.reverse().forEach(o=>{const R=o[2].map(s=>{const u=new E(this,this._textDocumentsAndEditors,s);return m||h.push(E.asModelAddData(this.apiNotebook,s)),u}),c=new k(o[0],o[1],[],R),w=this._cells.splice(o[0],o[1],...R);for(const s of w)d.push(s.uri),c.deletedItems.push(s.apiCell);f.push(c)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:d}),T)for(const o of f)T.push(o.asApiEvent())}_moveCell(y,m,T){const f=this._cells.splice(y,1);this._cells.splice(m,0,...f);const h=[new k(y,1,f.map(d=>d.apiCell),[]),new k(m,0,[],f)];for(const d of h)T.push(d.asApiEvent())}_setCellOutputs(y,m){this._cells[y].setOutputs(m)}_setCellOutputItems(y,m,T,f){this._cells[y].setOutputItems(m,T,f)}_changeCellLanguage(y,m){const T=this._cells[y];T.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelLanguageChanged(T.uri,m)}_changeCellMime(y,m){const T=this._cells[y];T.apiCell.mime=m}_changeCellMetadata(y,m){this._cells[y].setMetadata(m)}_changeCellInternalMetadata(y,m){this._cells[y].setInternalMetadata(m)}getCellFromApiCell(y){return this._cells.find(m=>m.apiCell===y)}getCellFromIndex(y){return this._cells[y]}getCell(y){return this._cells.find(m=>m.handle===y)}getCellIndex(y){return this._cells.indexOf(y)}}e.ExtHostNotebookDocument=P,P._handlePool=0}),define(ye[91],De([1,0,6,8,11]),function(ne,e,a,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class L{constructor(E){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=E}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(E){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:E})}replaceCellMetadata(E,P){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:E,metadata:P})}replaceCells(E,P,O){this._throwIfFinalized(),!(E===P&&O.length===0)&&this._collectedEdits.push({editType:1,index:E,count:P-E,cells:O.map(p.NotebookCellData.from)})}}class D{constructor(E,P,O,y,m,T){this.id=E,this._proxy=P,this.notebookData=O,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=m,this._visibleRanges=y,this._viewColumn=T}get apiEditor(){if(!this._editor){const E=this;this._editor={get document(){return E.notebookData.apiNotebook},get notebook(){return E.notebookData.apiNotebook},get selection(){return E._selections[0]},set selection(P){this.selections=[P]},get selections(){return E._selections},set selections(P){if(!Array.isArray(P)||!P.every(a.NotebookRange.isNotebookRange))throw(0,b.illegalArgument)("selections");E._selections=P,E._trySetSelections(P)},get visibleRanges(){return E._visibleRanges},revealRange(P,O){E._proxy.$tryRevealRange(E.id,p.NotebookRange.from(P),O??a.NotebookEditorRevealType.Default)},get viewColumn(){return E._viewColumn},edit(P){const O=new L(this.document.version);return P(O),E._applyEdit(O.finalize())}},D.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(E){this._visible=E}_acceptVisibleRanges(E){this._visibleRanges=E}_acceptSelections(E){this._selections=E}_trySetSelections(E){this._proxy.$trySetSelections(this.id,E.map(p.NotebookRange.from))}_acceptViewColumn(E){this._viewColumn=E}_applyEdit(E){if(E.cellEdits.length===0)return Promise.resolve(!0);const P=[];let O=-1;for(let y=0;y<E.cellEdits.length;y++){if(O<0){P.push(E.cellEdits[y]),O++;continue}const T=P[O],f=E.cellEdits[y];if(T.editType===1&&f.editType===1&&T.index===f.index){T.cells.push(...E.cellEdits[y].cells),T.count+=E.cellEdits[y].count;continue}P.push(E.cellEdits[y]),O++}return this._proxy.$tryApplyEdits(this.id,E.documentVersionId,P)}}e.ExtHostNotebookEditor=D,D.apiEditorsToExtHost=new WeakMap}),define(ye[176],De([1,0,5,15,8]),function(ne,e,a,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let L=class{constructor(k,E){this._logService=k,this._notebooksAndEditors=E,this._onDidChangeNotebookEditorSelection=new a.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new a.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(k,E){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",k,E);const P=this._notebooksAndEditors.getEditorById(k);E.visibleRanges&&P._acceptVisibleRanges(E.visibleRanges.ranges.map(b.NotebookRange.to)),E.selections&&P._acceptSelections(E.selections.selections.map(b.NotebookRange.to)),E.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:P.apiEditor,visibleRanges:P.apiEditor.visibleRanges}),E.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:P.apiEditor,selections:P.apiEditor.selections}))}$acceptEditorViewColumns(k){for(const E in k)this._notebooksAndEditors.getEditorById(E)._acceptViewColumn(b.ViewColumn.to(k[E]))}};L=ze([xe(0,p.ILogService)],L),e.ExtHostNotebookEditors=L}),define(ye[177],De([1,0,8,151,131,20,54,11]),function(ne,e,a,p,b,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class E{constructor(m){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=m}async withProgress(m,T,f){const h=this._handles++,{title:d,location:o,cancellable:v}=T,R={label:(0,b.localize)(0,null,m.displayName||m.name),id:m.identifier.value};return this._proxy.$startProgress(h,{location:a.ProgressLocation.from(o),title:d,source:R,cancellable:v},m.isUnderDevelopment?void 0:m.identifier.value).catch(k.onUnexpectedExternalError),this._withProgress(h,f,!!v)}_withProgress(m,T,f){let h;f&&(h=new L.CancellationTokenSource,this._mapHandleToCancellationSource.set(m,h));const d=v=>{this._proxy.$progressEnd(v),this._mapHandleToCancellationSource.delete(v),h?.dispose()};let o;try{o=T(new O(this._proxy,m),f&&h?h.token:L.CancellationToken.None)}catch(v){throw d(m),v}return o.then(v=>d(m),v=>d(m)),o}$acceptProgressCanceled(m){const T=this._mapHandleToCancellationSource.get(m);T&&(T.cancel(),this._mapHandleToCancellationSource.delete(m))}}e.ExtHostProgress=E;function P(y,m){return y.message=m.message,typeof m.increment=="number"&&(typeof y.increment=="number"?y.increment+=m.increment:y.increment=m.increment),y}class O extends p.Progress{constructor(m,T){super(f=>this.throttledReport(f));this._proxy=m,this._handle=T}throttledReport(m){this._proxy.$progressReport(this._handle,m)}}ze([(0,D.throttle)(100,(y,m)=>P(y,m),()=>Object.create(null))],O.prototype,"throttledReport",null)}),define(ye[92],De([1,0,48,89,46,65,47,8,2]),function(ne,e,a,p,b,L,D,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const P=(R,c,w,s)=>{let u=c;return{enumerable:!0,configurable:!1,get(){return u},set(n){if(!w(u,n)){const i=u;u=n,R.listener?.(s(n,i))}}}},O=(R,c)=>R===c,y={range:(R,c)=>R===c?!0:!R||!c?!1:R.isEqual(c),label:O,description:O,sortText:O,busy:O,error:O,canResolveChildren:O,tags:(R,c)=>!(R.length!==c.length||R.some(w=>!c.find(s=>w.id===s.id)))},m=R=>c=>({op:4,update:R(c)}),T=(R,c)=>({range:P(R,void 0,y.range,m(w=>({range:a.Range.lift(k.Range.from(w))}))),label:P(R,c,y.label,m(w=>({label:w}))),description:P(R,void 0,y.description,m(w=>({description:w}))),sortText:P(R,void 0,y.sortText,m(w=>({sortText:w}))),canResolveChildren:P(R,!1,y.canResolveChildren,w=>({op:2,state:w})),busy:P(R,!1,y.busy,m(w=>({busy:w}))),error:P(R,void 0,y.error,m(w=>({error:k.MarkdownString.fromStrict(w)||null}))),tags:P(R,[],y.tags,(w,s)=>({op:1,new:w.map(k.TestTag.from),old:s.map(k.TestTag.from)}))}),f=R=>{const c=b.TestId.fromString(R.extId),w=new d(c.controllerId,c.localId,R.label,E.URI.revive(R.uri)||void 0);return w.range=k.Range.to(R.range||void 0),w.description=R.description||void 0,w.sortText=R.sortText||void 0,w.tags=R.tags.map(s=>k.TestTag.to({id:(0,D.denamespaceTestTag)(s).tagId})),w},h=R=>{let c;for(const w of R.tests){const s=f(w.item);(0,p.getPrivateApiFor)(s).parent=c,c=s}return c};e.toItemFromContext=h;class d{constructor(c,w,s,u){if(w.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(w)} symbol`);const n=(0,p.createPrivateApiFor)(this,c);Object.defineProperties(this,{id:{value:w,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof o?void 0:n.parent}},children:{value:(0,L.createTestItemChildren)(n,p.getPrivateApiFor,d),enumerable:!0,writable:!1},...T(n,s)})}}e.TestItemImpl=d;class o extends d{constructor(c,w){super(c,c,w,void 0)}}e.TestItemRootImpl=o;class v extends L.TestItemCollection{constructor(c,w){super({controllerId:c,getApiFor:p.getPrivateApiFor,getChildren:s=>s.children,root:new o(c,w),toITestItem:k.TestItem.from})}}e.ExtHostTestItemCollection=v}),define(ye[93],De([1,0,44,11,73,8,6]),function(ne,e,a,p,b,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(m,T,f){const h=k._Keys.nextId();m.$registerTextEditorDecorationType(T.identifier,h,L.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:h,dispose(){m.$removeTextEditorDecorationType(h)}})}}e.TextEditorDecorationType=k,k._Keys=new b.IdGenerator("TextEditorDecorationType");class E{constructor(m,T){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=m,this._documentVersionId=m.version,this._undoStopBefore=T.undoStopBefore,this._undoStopAfter=T.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(m,T){this._throwIfFinalized();let f=null;if(m instanceof D.Position)f=new D.Range(m,m);else if(m instanceof D.Range)f=m;else throw new Error("Unrecognized location");this._pushEdit(f,T,!1)}insert(m,T){this._throwIfFinalized(),this._pushEdit(new D.Range(m,m),T,!0)}delete(m){this._throwIfFinalized();let T=null;if(m instanceof D.Range)T=m;else throw new Error("Unrecognized location");this._pushEdit(T,null,!0)}_pushEdit(m,T,f){const h=this._document.validateRange(m);this._collectedEdits.push({range:h,text:T,forceMoveMarkers:f})}setEndOfLine(m){if(this._throwIfFinalized(),m!==D.EndOfLine.LF&&m!==D.EndOfLine.CRLF)throw(0,p.illegalArgument)("endOfLine");this._setEndOfLine=m}}e.TextEditorEdit=E;class P{constructor(m,T,f,h){this._proxy=m,this._id=T,this._accept(f),this._logService=h;const d=this;this.value={get tabSize(){return d._tabSize},set tabSize(o){d._setTabSize(o)},get insertSpaces(){return d._insertSpaces},set insertSpaces(o){d._setInsertSpaces(o)},get cursorStyle(){return d._cursorStyle},set cursorStyle(o){d._setCursorStyle(o)},get lineNumbers(){return d._lineNumbers},set lineNumbers(o){d._setLineNumbers(o)}}}_accept(m){this._tabSize=m.tabSize,this._insertSpaces=m.insertSpaces,this._cursorStyle=m.cursorStyle,this._lineNumbers=L.TextEditorLineNumbersStyle.to(m.lineNumbers)}_validateTabSize(m){if(m==="auto")return"auto";if(typeof m=="number"){const T=Math.floor(m);return T>0?T:null}if(typeof m=="string"){const T=parseInt(m,10);return isNaN(T)?null:T>0?T:null}return null}_setTabSize(m){const T=this._validateTabSize(m);if(T!==null){if(typeof T=="number"){if(this._tabSize===T)return;this._tabSize=T}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:T}))}}_validateInsertSpaces(m){return m==="auto"?"auto":m==="false"?!1:Boolean(m)}_setInsertSpaces(m){const T=this._validateInsertSpaces(m);if(typeof T=="boolean"){if(this._insertSpaces===T)return;this._insertSpaces=T}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:T}))}_setCursorStyle(m){this._cursorStyle!==m&&(this._cursorStyle=m,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:m})))}_setLineNumbers(m){this._lineNumbers!==m&&(this._lineNumbers=m,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:L.TextEditorLineNumbersStyle.from(m)})))}assign(m){const T={};let f=!1;if(typeof m.tabSize!="undefined"){const h=this._validateTabSize(m.tabSize);h==="auto"?(f=!0,T.tabSize=h):typeof h=="number"&&this._tabSize!==h&&(this._tabSize=h,f=!0,T.tabSize=h)}if(typeof m.insertSpaces!="undefined"){const h=this._validateInsertSpaces(m.insertSpaces);h==="auto"?(f=!0,T.insertSpaces=h):this._insertSpaces!==h&&(this._insertSpaces=h,f=!0,T.insertSpaces=h)}typeof m.cursorStyle!="undefined"&&this._cursorStyle!==m.cursorStyle&&(this._cursorStyle=m.cursorStyle,f=!0,T.cursorStyle=m.cursorStyle),typeof m.lineNumbers!="undefined"&&this._lineNumbers!==m.lineNumbers&&(this._lineNumbers=m.lineNumbers,f=!0,T.lineNumbers=L.TextEditorLineNumbersStyle.from(m.lineNumbers)),f&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,T))}_warnOnError(m,T){T.catch(f=>{this._logService.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this._logService.warn(f)})}}e.ExtHostTextEditorOptions=P;class O{constructor(m,T,f,h,d,o,v,R){this.id=m,this._proxy=T,this._logService=f,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=d,this._options=new P(this._proxy,this.id,o,f),this._visibleRanges=v,this._viewColumn=R;const c=this;this.value=Object.freeze({get document(){return h.getValue()},set document(w){throw(0,p.readonly)("document")},get selection(){return c._selections&&c._selections[0]},set selection(w){if(!(w instanceof D.Selection))throw(0,p.illegalArgument)("selection");c._selections=[w],c._trySetSelection()},get selections(){return c._selections},set selections(w){if(!Array.isArray(w)||w.some(s=>!(s instanceof D.Selection)))throw(0,p.illegalArgument)("selections");c._selections=w,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(w){throw(0,p.readonly)("visibleRanges")},get options(){return c._options.value},set options(w){c._disposed||c._options.assign(w)},get viewColumn(){return c._viewColumn},set viewColumn(w){throw(0,p.readonly)("viewColumn")},edit(w,s={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new E(h.getValue(),s);return w(u),c._applyEdit(u)},insertSnippet(w,s,u={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!s||Array.isArray(s)&&s.length===0)n=c._selections.map(i=>L.Range.from(i));else if(s instanceof D.Position){const{lineNumber:i,column:r}=L.Position.from(s);n=[{startLineNumber:i,startColumn:r,endLineNumber:i,endColumn:r}]}else if(s instanceof D.Range)n=[L.Range.from(s)];else{n=[];for(const i of s)if(i instanceof D.Range)n.push(L.Range.from(i));else{const{lineNumber:r,column:t}=L.Position.from(i);n.push({startLineNumber:r,startColumn:t,endLineNumber:r,endColumn:t})}}return T.$tryInsertSnippet(m,h.getValue().version,w.value,n,u)},setDecorations(w,s){const u=s.length===0;u&&!c._hasDecorationsForKey.has(w.key)||(u?c._hasDecorationsForKey.delete(w.key):c._hasDecorationsForKey.add(w.key),c._runOnProxy(()=>{if(L.isDecorationOptionsArr(s))return T.$trySetDecorations(m,w.key,L.fromRangeOrRangeWithMessage(s));{const n=new Array(4*s.length);for(let i=0,r=s.length;i<r;i++){const t=s[i];n[4*i]=t.start.line+1,n[4*i+1]=t.start.character+1,n[4*i+2]=t.end.line+1,n[4*i+3]=t.end.character+1}return T.$trySetDecorationsFast(m,w.key,n)}}))},revealRange(w,s){c._runOnProxy(()=>T.$tryRevealRange(m,L.Range.from(w),s||D.TextEditorRevealType.Default))},show(w){T.$tryShowEditor(m,L.ViewColumn.from(w))},hide(){T.$tryHideEditor(m)}})}dispose(){(0,a.ok)(!this._disposed),this._disposed=!0}_acceptOptions(m){(0,a.ok)(!this._disposed),this._options._accept(m)}_acceptVisibleRanges(m){(0,a.ok)(!this._disposed),this._visibleRanges=m}_acceptViewColumn(m){(0,a.ok)(!this._disposed),this._viewColumn=m}_acceptSelections(m){(0,a.ok)(!this._disposed),this._selections=m}async _trySetSelection(){const m=this._selections.map(L.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,m)),this.value}_applyEdit(m){const T=m.finalize();if(T.edits.length===0&&!T.setEndOfLine)return Promise.resolve(!0);const f=T.edits.map(d=>d.range);f.sort((d,o)=>d.end.line===o.end.line?d.end.character===o.end.character?d.start.line===o.start.line?d.start.character-o.start.character:d.start.line-o.start.line:d.end.character-o.end.character:d.end.line-o.end.line);for(let d=0,o=f.length-1;d<o;d++){const v=f[d].end;if(f[d+1].start.isBefore(v))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=T.edits.map(d=>({range:L.Range.from(d.range),text:d.text,forceMoveMarkers:d.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,T.documentVersionId,h,{setEndOfLine:typeof T.setEndOfLine=="number"?L.EndOfLine.from(T.setEndOfLine):void 0,undoStopBefore:T.undoStopBefore,undoStopAfter:T.undoStopAfter})}_runOnProxy(m){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,T=>(T instanceof Error&&T.name==="DISPOSED"||this._logService.warn(T),null))}}e.ExtHostTextEditor=O}),define(ye[178],De([1,0,3,147]),function(ne,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,a.refineServiceDecorator)(p.IEnvironmentService)}),define(ye[179],De([1,0,27,5,19]),function(ne,e,a,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class L{constructor(y){this.removedDueToLooping=y}}e.DeltaExtensionsResult=L;class D{constructor(y){this._onDidChange=new p.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=y,this._initialize()}_initialize(){this._extensionDescriptions.sort(E),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const y of this._extensionDescriptions){if(this._extensionsMap.has(a.ExtensionIdentifier.toKey(y.identifier))){console.error("Extension `"+y.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(a.ExtensionIdentifier.toKey(y.identifier),y),this._extensionsArr.push(y),Array.isArray(y.activationEvents))for(let m of y.activationEvents)m==="onUri"&&(m=`onUri:${a.ExtensionIdentifier.toKey(y.identifier)}`),this._activationMap.has(m)||this._activationMap.set(m,[]),this._activationMap.get(m).push(y)}}set(y){this._extensionDescriptions=y,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(y,m){this._extensionDescriptions=P(this._extensionDescriptions,m),this._extensionDescriptions=this._extensionDescriptions.concat(y);const T=D._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=P(this._extensionDescriptions,T.map(f=>f.identifier)),this._initialize(),this._onDidChange.fire(void 0),new L(T)}static _findLoopingExtensions(y){const m=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(o){this._nodesSet.has(o)||(this._nodesSet.add(o),this._nodesArr.push(o))}addArc(o,v){this.addNode(o),this.addNode(v),this._arcs.has(o)?this._arcs.get(o).push(v):this._arcs.set(o,[v])}getArcs(o){return this._arcs.has(o)?this._arcs.get(o):[]}hasOnlyGoodArcs(o,v){const R=m.getArcs(o);for(let c=0;c<R.length;c++)if(!v.has(R[c]))return!1;return!0}getNodes(){return this._nodesArr}},T=new Map;for(const o of y){const v=a.ExtensionIdentifier.toKey(o.identifier);if(T.set(v,o),o.extensionDependencies)for(const R of o.extensionDependencies){const c=a.ExtensionIdentifier.toKey(R);m.addArc(v,c)}}const f=new Set;m.getNodes().filter(o=>m.getArcs(o).length===0).forEach(o=>f.add(o));const h=m.getNodes().filter(o=>!f.has(o));let d;do{d=!1;for(let o=0;o<h.length;o++){const v=h[o];m.hasOnlyGoodArcs(v,f)&&(h.splice(o,1),o--,f.add(v),d=!0)}}while(d);return h.map(o=>T.get(o))}containsActivationEvent(y){return this._activationMap.has(y)}containsExtension(y){return this._extensionsMap.has(a.ExtensionIdentifier.toKey(y))}getExtensionDescriptionsForActivationEvent(y){const m=this._activationMap.get(y);return m?m.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(y){const m=this._extensionsMap.get(a.ExtensionIdentifier.toKey(y));return m||void 0}getExtensionDescriptionByUUID(y){for(const m of this._extensionsArr)if(m.uuid===y)return m}getExtensionDescriptionByIdOrUUID(y,m){return this.getExtensionDescription(y)??(m?this.getExtensionDescriptionByUUID(m):void 0)}}e.ExtensionDescriptionRegistry=D;var k;(function(O){O[O.Builtin=0]="Builtin",O[O.User=1]="User",O[O.Dev=2]="Dev"})(k||(k={}));function E(O,y){const m=O.isBuiltin?0:O.isUnderDevelopment?2:1,T=y.isBuiltin?0:y.isUnderDevelopment?2:1;if(m!==T)return m-T;const f=b.posix.basename(O.extensionLocation.path),h=b.posix.basename(y.extensionLocation.path);return f<h?-1:f>h?1:0}function P(O,y){const m=new Set;return y.forEach(T=>m.add(a.ExtensionIdentifier.toKey(T))),O.filter(T=>!m.has(a.ExtensionIdentifier.toKey(T.identifier)))}}),define(ye[94],De([1,0,23]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var p;(function(P){P[P.Desktop=1]="Desktop",P[P.Web=2]="Web"})(p=e.UIKind||(e.UIKind={}));var b;(function(P){P[P.VersionMismatch=55]="VersionMismatch",P[P.UnexpectedError=81]="UnexpectedError"})(b=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var L;(function(P){P[P.Initialized=0]="Initialized",P[P.Ready=1]="Ready",P[P.Terminate=2]="Terminate"})(L=e.MessageType||(e.MessageType={}));function D(P){const O=a.VSBuffer.alloc(1);switch(P){case 0:O.writeUInt8(1,0);break;case 1:O.writeUInt8(2,0);break;case 2:O.writeUInt8(3,0);break}return O}e.createMessageOfType=D;function k(P,O){if(P.byteLength!==1)return!1;switch(P.readUInt8(0)){case 1:return O===0;case 2:return O===1;case 3:return O===2;default:return!1}}e.isMessageOfType=k;var E;(function(P){P.Start="START_NATIVE_LOG",P.End="END_NATIVE_LOG"})(E=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(ye[24],De([1,0,5,2,3,27,153]),function(ne,e,a,p,b,L,D){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new L.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:p.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,b.createDecorator)("extensionService");class E{constructor(t){this.affinity=t,this.kind=1}equals(t){return this.kind===t.kind&&this.affinity===t.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=E;class P{constructor(){this.kind=2,this.affinity=0}equals(t){return this.kind===t.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=P;class O{constructor(){this.kind=3,this.affinity=0}equals(t){return this.kind===t.kind}asString(){return"Remote"}}e.RemoteRunningLocation=O;class y{constructor(t){this.dependency=t}}e.MissingExtensionDependency=y;var m;(function(r){r[r.LocalProcess=1]="LocalProcess",r[r.LocalWebWorker=2]="LocalWebWorker",r[r.Remote=3]="Remote"})(m=e.ExtensionHostKind||(e.ExtensionHostKind={}));function T(r){if(r===null)return"None";switch(r){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=T;class f{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(t,l){const _=[],g=[],C=[],U=[],W=o(this._allExtensions),M=o(t),S=(q,ie)=>q.extensionLocation.toString()===ie.extensionLocation.toString()||q.isBuiltin===ie.isBuiltin||q.isUserBuiltin===ie.isUserBuiltin||q.isUnderDevelopment===ie.isUnderDevelopment;for(const q of this._allExtensions){const ie=M.get(L.ExtensionIdentifier.toKey(q.identifier));if(!ie){_.push(q.identifier),W.delete(L.ExtensionIdentifier.toKey(q.identifier));continue}if(!S(q,ie)){_.push(q.identifier),W.delete(L.ExtensionIdentifier.toKey(q.identifier));continue}}for(const q of t){const ie=W.get(L.ExtensionIdentifier.toKey(q.identifier));if(!ie){g.push(q);continue}if(!S(ie,q)){_.push(ie.identifier),W.delete(L.ExtensionIdentifier.toKey(ie.identifier));continue}}const z=d(this._myExtensions),$=d(l);for(const q of this._myExtensions)$.has(L.ExtensionIdentifier.toKey(q))||C.push(q);for(const q of l)z.has(L.ExtensionIdentifier.toKey(q))||U.push(q);const F={toRemove:_,toAdd:g,myToRemove:C,myToAdd:U};return this.delta(F),F}delta(t){const{toRemove:l,toAdd:_,myToRemove:g,myToAdd:C}=t,U=d(l),W=d(g);for(let M=0;M<this._allExtensions.length;M++)U.has(L.ExtensionIdentifier.toKey(this._allExtensions[M].identifier))&&(this._allExtensions.splice(M,1),M--);for(let M=0;M<this._myExtensions.length;M++)W.has(L.ExtensionIdentifier.toKey(this._myExtensions[M]))&&(this._myExtensions.splice(M,1),M--);for(const M of _)this._allExtensions.push(M);for(const M of C)this._myExtensions.push(M)}containsExtension(t){for(const l of this._myExtensions)if(L.ExtensionIdentifier.equals(l,t))return!0;return!1}}e.ExtensionHostExtensions=f;class h{constructor(t){if(this[k]="ExtensionIdentifierSet",this._map=new Map,this._toKey=L.ExtensionIdentifier.toKey,t)for(const l of t)this.add(l)}get size(){return this._map.size}add(t){return this._map.set(this._toKey(t),t),this}clear(){this._map.clear()}delete(t){return this._map.delete(this._toKey(t))}has(t){return this._map.has(this._toKey(t))}forEach(t,l){this._map.forEach(_=>t.call(l,_,_,this))}*entries(){for(const[t,l]of this._map)yield[l,l]}keys(){return this._map.values()}values(){return this._map.values()}[(k=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=h;function d(r){const t=new Set;for(const l of r)t.add(L.ExtensionIdentifier.toKey(l));return t}e.extensionIdentifiersArrayToSet=d;function o(r){const t=new Map;for(const l of r)t.set(L.ExtensionIdentifier.toKey(l.identifier),l);return t}function v(r,t){return r.enabledApiProposals?r.enabledApiProposals.includes(t):!1}e.isProposedApiEnabled=v;function R(r,t){if(!v(r,t))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}e.checkProposedApiEnabled=R;class c{constructor(t,l,_,g){this.codeLoadingTime=t,this.activateCallTime=l,this.activateResolvedTime=_,this.activationReason=g}}e.ActivationTimes=c;class w{constructor(t,l){this.description=t,this.value=l}}e.ExtensionPointContribution=w,e.ExtensionHostLogFileName="exthost";var s;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(s=e.ActivationKind||(e.ActivationKind={}));function u(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,D.getGalleryExtensionId)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}e.toExtension=u;function n(r,t){return{identifier:new L.ExtensionIdentifier((0,D.getExtensionId)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!t,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform,browserNlsBundleUris:r.browserNlsBundleUris}}e.toExtensionDescription=n;class i{constructor(){this.onDidRegisterExtensions=a.Event.None,this.onDidChangeExtensionsStatus=a.Event.None,this.onDidChangeExtensions=a.Event.None,this.onWillActivateByEvent=a.Event.None,this.onDidChangeResponsiveChange=a.Event.None}activateByEvent(t){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(t,l){return Promise.resolve(0)}getInspectPorts(t,l){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(t,l){return Promise.resolve()}}e.NullExtensionService=i}),define(ye[180],De([1,0,11,27,24,15,14]),function(ne,e,a,p,b,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class k{constructor(d,o,v,R){this.startup=d,this.codeLoadingTime=o,this.activateCallTime=v,this.activateResolvedTime=R}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class E{constructor(d){this._startup=d,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(d,o){return d===-1||o===-1?-1:o-d}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=E;class P{constructor(d,o,v,R,c,w){this.activationFailed=d,this.activationFailedError=o,this.activationTimes=v,this.module=R,this.exports=c,this.subscriptions=w}}e.ActivatedExtension=P;class O extends P{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=O;class y extends P{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=y;class m extends P{constructor(d){super(!0,d,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=m;let T=class{constructor(d,o,v,R,c){this._logService=c,this._registry=d,this._resolvedExtensionsSet=new Set,o.forEach(w=>this._resolvedExtensionsSet.add(p.ExtensionIdentifier.toKey(w))),this._externalExtensionsMap=new Map,v.forEach(w=>this._externalExtensionsMap.set(p.ExtensionIdentifier.toKey(w),w)),this._host=R,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[d,o]of this._operations)o.dispose()}isActivated(d){const o=this._operations.get(p.ExtensionIdentifier.toKey(d));return Boolean(o&&o.value)}getActivatedExtension(d){const o=this._operations.get(p.ExtensionIdentifier.toKey(d));if(!o||!o.value)throw new Error(`Extension '${d.value}' is not known or not activated`);return o.value}async activateByEvent(d,o){if(this._alreadyActivatedEvents[d])return;const v=this._registry.getExtensionDescriptionsForActivationEvent(d);await this._activateExtensions(v.map(R=>({id:R.identifier,reason:{startup:o,extensionId:R.identifier,activationEvent:d}}))),this._alreadyActivatedEvents[d]=!0}activateById(d,o){const v=this._registry.getExtensionDescription(d);if(!v)throw new Error(`Extension '${d}' is not known`);return this._activateExtensions([{id:v.identifier,reason:o}])}async _activateExtensions(d){const o=d.filter(v=>!this.isActivated(v.id)).map(v=>this._handleActivationRequest(v));await Promise.all(o.map(v=>v.wait()))}_handleActivationRequest(d){if(this._operations.has(p.ExtensionIdentifier.toKey(d.id)))return this._operations.get(p.ExtensionIdentifier.toKey(d.id));if(this._externalExtensionsMap.has(p.ExtensionIdentifier.toKey(d.id)))return this._createAndSaveOperation(d,null,[],null);const o=this._registry.getExtensionDescription(d.id);if(!o){const c=new Error(`Cannot activate unknown extension '${d.id.value}'`),w=this._createAndSaveOperation(d,null,[],new m(c));return this._host.onExtensionActivationError(d.id,c,new b.MissingExtensionDependency(d.id.value)),w}const v=[],R=typeof o.extensionDependencies=="undefined"?[]:o.extensionDependencies;for(const c of R){if(this._resolvedExtensionsSet.has(p.ExtensionIdentifier.toKey(c)))continue;const w=this._operations.get(p.ExtensionIdentifier.toKey(c));if(w){v.push(w);continue}if(this._externalExtensionsMap.has(p.ExtensionIdentifier.toKey(c))){v.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(p.ExtensionIdentifier.toKey(c)),reason:d.reason}));continue}const s=this._registry.getExtensionDescription(c);if(s){if(!s.main&&!s.browser)continue;v.push(this._handleActivationRequest({id:s.identifier,reason:d.reason}));continue}const u=o.displayName||o.identifier.value,n=new Error(`Cannot activate the '${u}' extension because it depends on unknown extension '${c}'`),i=this._createAndSaveOperation(d,o.displayName,[],new m(n));return this._host.onExtensionActivationError(o.identifier,n,new b.MissingExtensionDependency(c)),i}return this._createAndSaveOperation(d,o.displayName,v,null)}_createAndSaveOperation(d,o,v,R){const c=new f(d.id,o,d.reason,v,R,this._host,this._logService);return this._operations.set(p.ExtensionIdentifier.toKey(d.id),c),c}};T=ze([xe(4,L.ILogService)],T),e.ExtensionsActivator=T;let f=class{constructor(d,o,v,R,c,w,s){this._id=d,this._displayName=o,this._reason=v,this._deps=R,this._value=c,this._host=w,this._logService=s,this._barrier=new D.Barrier,this._isDisposed=!1,this._initialize()}get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let d=0;d<this._deps.length;d++){const o=this._deps[d];if(o.value&&!o.value.activationFailed){this._deps.splice(d,1),d--;continue}if(o.value&&o.value.activationFailed){const v=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${o.friendlyName}' failed to activate`);v.detail=o.value.activationFailedError,this._value=new m(v),this._host.onExtensionActivationError(this._id,v,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(d=>d.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(d){const o=new Error;if(d&&d.name&&(o.name=d.name),d&&d.message?o.message=`Activating extension '${this._id.value}' failed: ${d.message}.`:o.message=`Activating extension '${this._id.value}' failed: ${d}.`,d&&d.stack&&(o.stack=d.stack),this._value=new m(o),this._isDisposed&&a.isCancellationError(d))return;this._host.onExtensionActivationError(this._id,o,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(d)}}};f=ze([xe(6,L.ILogService)],f)}),define(ye[181],De([1,0,15,28,24]),function(ne,e,a,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let L=class extends a.LogService{constructor(k,E){super(k.createLogger(E.logFile,{name:b.ExtensionHostLogFileName}))}};L=ze([xe(0,a.ILoggerService),xe(1,p.IExtHostInitDataService)],L),e.ExtHostLogService=L}),define(ye[182],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",badges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.badges.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorToolbar:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorToolbar.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewSize.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",contribWebviewContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribWebviewContext.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineCompletionsNew:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsNew.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookContentProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookContentProvider.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDebugOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDebugOptions.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditor.d.ts",notebookEditorEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditorEdit.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookWorkspaceEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookWorkspaceEdit.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",snippetWorkspaceEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.snippetWorkspaceEdit.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLog:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLog.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ye[183],De([1,0,142,11,29,79,82,30,27,182,150]),function(ne,e,a,p,b,L,D,k,E,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const y=k.Registry.as(D.Extensions.JSONContribution);class m{constructor(c,w,s){this._messageHandler=c,this._extension=w,this._extensionPointId=s}_msg(c,w){this._messageHandler({type:c,message:w,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(c){this._msg(b.default.Error,c)}warn(c){this._msg(b.default.Warning,c)}info(c){this._msg(b.default.Info,c)}}e.ExtensionMessageCollector=m;class T{constructor(c,w){this.added=c,this.removed=w}static _toSet(c){const w=new Set;for(let s=0,u=c.length;s<u;s++)w.add(E.ExtensionIdentifier.toKey(c[s].description.identifier));return w}static compute(c,w){if(!c||!c.length)return new T(w,[]);if(!w||!w.length)return new T([],c);const s=this._toSet(c),u=this._toSet(w),n=w.filter(r=>!s.has(E.ExtensionIdentifier.toKey(r.description.identifier))),i=c.filter(r=>!u.has(E.ExtensionIdentifier.toKey(r.description.identifier)));return new T(n,i)}}e.ExtensionPointUserDelta=T;class f{constructor(c,w){this.name=c,this.defaultExtensionKind=w,this._handler=null,this._users=null,this._delta=null}setHandler(c){if(this._handler!==null)throw new Error("Handler already set!");this._handler=c,this._handle()}acceptUsers(c){this._delta=T.compute(this._users,c),this._users=c,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(c){(0,p.onUnexpectedError)(c)}}}e.ExtensionPoint=f;const h={type:"string",enum:["ui","workspace"],enumDescriptions:[a.localize(0,null),a.localize(1,null)]},d="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:a.localize(2,null),properties:{vscode:{type:"string",description:a.localize(3,null),default:"^1.22.0"}}},publisher:{description:a.localize(4,null),type:"string"},displayName:{description:a.localize(5,null),type:"string"},categories:{description:a.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:a.localize(7,null)}]}},galleryBanner:{type:"object",description:a.localize(8,null),properties:{color:{description:a.localize(9,null),type:"string"},theme:{description:a.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:a.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:a.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:a.localize(13,null)},enabledApiProposals:{markdownDescription:a.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(P.allApiProposals),markdownEnumDescriptions:Object.values(P.allApiProposals)}},activationEvents:{description:a.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:a.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:a.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:a.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:a.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:a.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:a.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:a.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:a.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:a.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:a.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:a.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:a.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onSearch",description:a.localize(28,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:a.localize(29,null)},{label:"onIdentity",body:"onIdentity:${8:identity}",description:a.localize(30,null)},{label:"onUri",body:"onUri",description:a.localize(31,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:a.localize(32,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:a.localize(33,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:a.localize(34,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:a.localize(35,null)},{label:"onRenderer",description:a.localize(36,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:a.localize(37,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:a.localize(38,null)},{label:"*",description:a.localize(39,null),body:"*"}]}},badges:{type:"array",description:a.localize(40,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:a.localize(41,null)},href:{type:"string",description:a.localize(42,null)},description:{type:"string",description:a.localize(43,null)}}}},markdown:{type:"string",description:a.localize(44,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:a.localize(45,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:a.localize(46,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:a.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:a.localize(48,null),type:"array",items:h,default:["workspace"],defaultSnippets:[{body:["ui"],description:a.localize(49,null)},{body:["workspace"],description:a.localize(50,null)},{body:["ui","workspace"],description:a.localize(51,null)},{body:["workspace","ui"],description:a.localize(52,null)},{body:[],description:a.localize(53,null)}]},capabilities:{description:a.localize(54,null),type:"object",properties:{virtualWorkspaces:{description:a.localize(55,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:a.localize(56,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(57,null),a.localize(58,null),a.localize(59,null)]},description:{type:"string",markdownDescription:a.localize(60,null)}}},untrustedWorkspaces:{description:a.localize(61,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:a.localize(62,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(63,null),a.localize(64,null),a.localize(65,null)]},restrictedConfigurations:{description:a.localize(66,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:a.localize(67,null)}}}}},sponsor:{description:a.localize(68,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:a.localize(69,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:a.localize(70,null),type:"string"},"vscode:uninstall":{description:a.localize(71,null),type:"string"}}},icon:{type:"string",description:a.localize(72,null)}}};class o{constructor(){this._extensionPoints=new Map}registerExtensionPoint(c){if(this._extensionPoints.has(c.extensionPoint))throw new Error("Duplicate extension point: "+c.extensionPoint);const w=new f(c.extensionPoint,c.defaultExtensionKind);return this._extensionPoints.set(c.extensionPoint,w),e.schema.properties.contributes.properties[c.extensionPoint]=c.jsonSchema,y.registerSchema(d,e.schema),w}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=o;const v={ExtensionsRegistry:"ExtensionsRegistry"};k.Registry.add(v.ExtensionsRegistry,new o),e.ExtensionsRegistry=k.Registry.as(v.ExtensionsRegistry),y.registerSchema(d,e.schema),y.registerSchema(O.productSchemaId,{properties:{extensionEnabledApiProposals:{description:a.localize(73,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(P.allApiProposals),markdownEnumDescriptions:Object.values(P.allApiProposals)}}]}}}})}),define(ye[184],De([1,0,139,10,26,183,38,5]),function(ne,e,a,p,b,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=e.TaskDefinitionRegistryImpl=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:a.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:a.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:a.localize(2,null),default:""}}};var P;(function(m){function T(f,h,d){if(!f)return;const o=p.isString(f.type)?f.type:void 0;if(!o||o.length===0){d.error(a.localize(3,null));return}const v=[];if(Array.isArray(f.required))for(const R of f.required)p.isString(R)&&v.push(R);return{extensionId:h.value,taskType:o,required:v,properties:f.properties?b.deepClone(f.properties):{},when:f.when?D.ContextKeyExpr.deserialize(f.when):void 0}}m.from=T})(P||(P={}));const O=L.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:a.localize(4,null),type:"array",items:E}});class y{constructor(){this._onDefinitionsChanged=new k.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((T,f)=>{O.setHandler((h,d)=>{this._schema=void 0;try{for(const o of d.removed){const v=o.value;for(const R of v)this.taskTypes&&R.type&&this.taskTypes[R.type]&&delete this.taskTypes[R.type]}for(const o of d.added){const v=o.value;for(const R of v){const c=P.from(R,o.description.identifier,o.collector);c&&(this.taskTypes[c.taskType]=c)}}(d.removed.length>0||d.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}T(void 0)})})}onReady(){return this.readyPromise}get(T){return this.taskTypes[T]}all(){return Object.keys(this.taskTypes).map(T=>this.taskTypes[T])}getJsonSchema(){if(this._schema===void 0){const T=[];for(const f of this.all()){const h={type:"object",additionalProperties:!1};f.required.length>0&&(h.required=f.required.slice(0)),f.properties!==void 0?h.properties=b.deepClone(f.properties):h.properties=Object.create(null),h.properties.type={type:"string",enum:[f.taskType]},T.push(h)}this._schema={oneOf:T}}return this._schema}}e.TaskDefinitionRegistryImpl=y,e.TaskDefinitionRegistry=new y}),define(ye[185],De([1,0,140,10,22,26,38,184]),function(ne,e,a,p,b,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new D.RawContextKey("taskRunning",!1,a.localize(0,null)),e.TASKS_CATEGORY={value:a.localize(1,null),original:"Tasks"};var E;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(E=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(F){function q(ie){if(!ie)return F.Strong;switch(ie.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=q}(E=e.ShellQuoting||(e.ShellQuoting={}));var P;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(P=e.CommandOptions||(e.CommandOptions={}));var O;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(O=e.RevealKind||(e.RevealKind={})),function(F){function q(ie){switch(ie.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=q}(O=e.RevealKind||(e.RevealKind={}));var y;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(y=e.RevealProblemKind||(e.RevealProblemKind={})),function(F){function q(ie){switch(ie.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=q}(y=e.RevealProblemKind||(e.RevealProblemKind={}));var m;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(m=e.PanelKind||(e.PanelKind={})),function(F){function q(ie){switch(ie.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=q}(m=e.PanelKind||(e.PanelKind={}));var T;(function(F){F.defaults={echo:!0,reveal:O.Always,revealProblems:y.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(T=e.PresentationOptions||(e.PresentationOptions={}));var f;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(f=e.RuntimeType||(e.RuntimeType={})),function(F){function q(A){switch(A.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=q;function ie(A){switch(A){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=ie}(f=e.RuntimeType||(e.RuntimeType={}));var h;(function(F){function q(ie){return p.isString(ie)?ie:ie.value}F.value=q})(h=e.CommandString||(e.CommandString={}));var d;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function q(A){return A===F.Clean._id||A===F.Build._id||A===F.Rebuild._id||A===F.Test._id}F.is=q;function ie(A){if(A!==void 0)return p.isString(A)?q(A)?{_id:A,isDefault:!1}:void 0:A}F.from=ie})(d=e.TaskGroup||(e.TaskGroup={}));var o;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(o=e.TaskScope||(e.TaskScope={}));var v;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function q(ie){switch(ie){case F.User:return 2;case F.WorkspaceFile:return 5;default:return 6}}F.toConfigurationTarget=q})(v=e.TaskSourceKind||(e.TaskSourceKind={}));var R;(function(F){F.parallel="parallel",F.sequence="sequence"})(R=e.DependsOrder||(e.DependsOrder={}));var c;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(c=e.RunOnOptions||(e.RunOnOptions={}));var w;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(w=e.RunOptions||(e.RunOptions={}));class s{constructor(q,ie,A,Z,ce,oe){this._label="",this._id=q,ie&&(this._label=ie),A&&(this.type=A),this.runOptions=Z,this.configurationProperties=ce,this._source=oe}getDefinition(q){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const q={folder:this.getFolderId(),id:this._id};return JSON.stringify(q)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(q,ie=!1){if(q===void 0)return!1;if(p.isString(q))return q===this._label||q===this.configurationProperties.identifier||ie&&q===this._id;const A=this.getDefinition(!0);return A!==void 0&&A._key===q._key}getQualifiedLabel(){const q=this.getWorkspaceFolder();return q?`${this._label} (${q.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(q){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),q&&(this._taskLoadMessages=this._taskLoadMessages.concat(q))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=s;class u extends s{constructor(q,ie,A,Z,ce,oe,ue,te){super(q,A,void 0,ue,te,ie);this.command={},this._source=ie,this.hasDefinedMatchers=oe,ce&&(this.command=ce)}clone(){return new u(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(q=!1){if(q&&this._source.customizes!==void 0)return this._source.customizes;{let ie;switch(this.command?this.command.runtime:void 0){case f.Shell:ie="shell";break;case f.Process:ie="process";break;case f.CustomExecution:ie="customExecution";break;case void 0:ie="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:ie,_key:this._id,id:this._id}}}static is(q){return q instanceof u}getMapKey(){const q=this._source.config.workspaceFolder;return q?`${q.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const q=this.getFolderId();if(!q)return;let ie=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(ie+=this._source.kind);const A={type:e.CUSTOMIZED_TASK_TYPE,folder:q,id:ie};return JSON.stringify(A)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?b.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(q){return new u(q._id,q._source,q._label,q.type,q.command,q.hasDefinedMatchers,q.runOptions,q.configurationProperties)}}e.CustomTask=u;class n extends s{constructor(q,ie,A,Z,ce,oe,ue){super(q,A,Z,oe,ue,ie);this._source=ie,this.configures=ce}static is(q){return q instanceof n}fromObject(q){return q}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?b.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const q=this.getFolderId();if(!q)return;let ie=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(ie+=this._source.kind);const A={type:e.CUSTOMIZED_TASK_TYPE,folder:q,id:ie};return JSON.stringify(A)}}e.ConfiguringTask=n;class i extends s{constructor(q,ie,A,Z,ce,oe,ue,te,Ee){super(q,A,Z,te,Ee,ie);this.defines=ce,this.hasDefinedMatchers=ue,this.command=oe,this.icon=Ee.icon,this.hide=Ee.hide}clone(){return new i(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(q){return q instanceof i}getMapKey(){const q=this._source.workspaceFolder;return q?`${this._source.scope.toString()}|${q.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const q={type:"contributed",scope:this._source.scope,id:this._id};return q.folder=this.getFolderId(),JSON.stringify(q)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(q){return new i(q._id,q._source,q._label,q.type,q.defines,q.command,q.hasDefinedMatchers,q.runOptions,q.configurationProperties)}}e.ContributedTask=i;class r extends s{constructor(q,ie,A,Z,ce,oe){super(q,A,Z,ce,oe,ie);this._source=ie}clone(){return new r(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(q){return q instanceof r}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(q){return new r(q._id,q._source,q._label,q.type,q.runOptions,q.configurationProperties)}}e.InMemoryTask=r;var t;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(t=e.ExecutionEngine||(e.ExecutionEngine={})),function(F){F._default=F.Terminal}(t=e.ExecutionEngine||(e.ExecutionEngine={}));var l;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(l=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class _{constructor(q){this._order=new Map;for(let ie=0;ie<q.length;ie++)this._order.set(q[ie].uri.toString(),ie)}compare(q,ie){const A=q.getWorkspaceFolder(),Z=ie.getWorkspaceFolder();if(A&&Z){let ce=this._order.get(A.uri.toString());ce=ce===void 0?0:ce+1;let oe=this._order.get(Z.uri.toString());return oe=oe===void 0?0:oe+1,ce===oe?q._label.localeCompare(ie._label):ce-oe}else return!A&&Z?-1:A&&!Z?1:0}}e.TaskSorter=_;var g;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(g=e.TaskEventKind||(e.TaskEventKind={}));var C;(function(F){F.SingleRun="singleRun",F.Background="background"})(C=e.TaskRunType||(e.TaskRunType={}));var U;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(U=e.TaskRunSource||(e.TaskRunSource={}));var W;(function(F){function q(ie,A,Z,ce,oe){if(A){const ue={kind:ie,taskId:A._id,taskName:A.configurationProperties.name,runType:A.configurationProperties.isBackground?"background":"singleRun",group:A.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:void 0,__task:A};return ie==="start"?(ue.terminalId=Z,ue.resolvedVariables=ce):ie==="processStarted"?ue.processId=Z:ie==="processEnded"&&(ue.exitCode=Z),Object.freeze(ue)}else return Object.freeze({kind:"changed"})}F.create=q})(W=e.TaskEvent||(e.TaskEvent={}));var M;(function(F){function q(A){const Z=Object.keys(A).sort();let ce="";for(const oe of Z){let ue=A[oe];ue instanceof Object?ue=q(ue):typeof ue=="string"&&(ue=ue.replace(/,/g,",,")),ce+=oe+","+ue+","}return ce}function ie(A){const ce={_key:q(A),type:A.taskType};return Object.assign(ce,A),ce}F.create=ie})(M=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var S;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.experimental.reconnection"})(S=e.TaskSettingId||(e.TaskSettingId={}));var z;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(z=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var $;(function(F){function q(ie,A){const Z=k.TaskDefinitionRegistry.get(ie.type);if(Z===void 0){const te=L.deepClone(ie);return delete te._key,M.create(te)}const ce=Object.create(null);ce.type=Z.taskType;const oe=new Set;Z.required.forEach(te=>oe.add(te));const ue=Z.properties;for(const te of Object.keys(ue)){const Ee=ie[te];if(Ee!=null)ce[te]=Ee;else if(oe.has(te)){const be=ue[te];if(be.default!==void 0)ce[te]=L.deepClone(be.default);else switch(be.type){case"boolean":ce[te]=!1;break;case"number":case"integer":ce[te]=0;break;case"string":ce[te]="";break;default:A.error(a.localize(2,null,JSON.stringify(ie,void 0,0),te));return}}}return M.create(ce)}F.createTaskIdentifier=q})($=e.TaskDefinition||(e.TaskDefinition={}))}),define(ye[186],De([1,0,11]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class p{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((D,k)=>{this._actualOk=D,this._actualErr=k,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(D){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=D,this._actual&&this._actualOk(D))}resolveErr(D){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=D,this._actual?this._actualErr(D):(0,a.onUnexpectedError)(D))}then(D,k){return this._ensureActual().then(D,k)}catch(D){return this._ensureActual().then(void 0,D)}finally(D){return this._ensureActual().finally(D)}}e.LazyPromise=p;class b extends p{constructor(){super();this._hasErr=!0,this._err=new a.CancellationError}}e.CanceledLazyPromise=b}),define(ye[40],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class a{constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++a.count}}e.ProxyIdentifier=a,a.count=0;const p=[];function b(k){const E=new a(k);return p[E.nid]=E,E}e.createProxyIdentifier=b;function L(k){return p[k].sid}e.getStringIdentifierForProxy=L;class D{constructor(E){this.value=E}}e.SerializableObjectWithBuffers=D}),define(ye[4],De([1,0,55,40]),function(ne,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var b;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(b=e.TextEditorRevealType||(e.TextEditorRevealType={}));var L;(function(o){o[o.UnknownInput=0]="UnknownInput",o[o.TextInput=1]="TextInput",o[o.TextDiffInput=2]="TextDiffInput",o[o.TextMergeInput=3]="TextMergeInput",o[o.NotebookInput=4]="NotebookInput",o[o.NotebookDiffInput=5]="NotebookDiffInput",o[o.CustomEditorInput=6]="CustomEditorInput",o[o.WebviewEditorInput=7]="WebviewEditorInput",o[o.TerminalEditorInput=8]="TerminalEditorInput",o[o.InteractiveEditorInput=9]="InteractiveEditorInput"})(L=e.TabInputKind||(e.TabInputKind={}));var D;(function(o){o[o.TAB_OPEN=0]="TAB_OPEN",o[o.TAB_CLOSE=1]="TAB_CLOSE",o[o.TAB_UPDATE=2]="TAB_UPDATE",o[o.TAB_MOVE=3]="TAB_MOVE"})(D=e.TabModelOperationKind||(e.TabModelOperationKind={}));var k;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var E;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(E=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(P=e.CellOutputKind||(e.CellOutputKind={}));var O;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(O=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var y;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output"})(y=e.CandidatePortSource||(e.CandidatePortSource={}));class m{static mixin(v){return v._id=m._n++,v}}e.IdObject=m,m._n=0;var T;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.command="m",o.kindModifier="n"})(T=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var f;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(f=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));function h(o){return o&&o.edits&&(0,a.revive)(o),o}e.reviveWorkspaceEditDto=h;var d;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(d=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,p.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,p.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,p.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,p.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,p.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,p.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,p.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,p.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,p.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,p.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,p.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,p.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,p.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,p.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,p.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,p.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,p.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,p.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,p.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,p.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,p.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,p.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,p.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,p.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,p.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,p.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,p.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,p.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,p.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,p.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,p.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,p.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,p.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,p.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,p.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,p.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,p.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,p.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,p.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,p.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,p.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,p.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,p.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,p.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,p.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,p.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,p.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,p.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,p.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,p.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,p.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,p.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,p.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,p.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,p.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,p.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,p.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,p.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,p.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,p.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,p.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,p.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,p.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,p.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,p.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,p.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,p.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,p.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,p.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,p.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,p.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,p.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,p.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,p.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,p.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,p.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,p.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,p.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,p.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,p.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,p.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,p.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,p.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,p.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,p.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,p.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,p.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,p.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,p.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,p.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,p.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,p.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,p.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,p.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,p.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,p.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,p.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,p.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,p.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,p.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,p.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,p.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,p.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,p.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,p.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,p.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,p.createProxyIdentifier)("ExtHostTelemetry")}}),define(ye[67],De([1,0,4,5,3]),function(ne,e,a,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class L{constructor(k){this._onDidChangePassword=new p.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(a.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,E){return this._proxy.$getPassword(k,E)}store(k,E,P){return this._proxy.$setPassword(k,E,P)}delete(k,E){return this._proxy.$deletePassword(k,E)}}e.ExtHostSecretState=L,e.IExtHostSecretState=(0,b.createDecorator)("IExtHostSecretState")}),define(ye[68],De([1,0,3,15,4,13]),function(ne,e,a,p,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,a.createDecorator)("IExtHostApiDeprecationService");let D=class{constructor(E,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=E.getProxy(b.MainContext.MainThreadTelemetry)}report(E,P,O){const y=this.getUsageKey(E,P);this._reportedUsages.has(y)||(this._reportedUsages.add(y),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${E}' is deprecated. ${O}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:E}))}getUsageKey(E,P){return`${E}-${P.identifier.value}`}};D=ze([xe(0,L.IExtHostRpcService),xe(1,p.ILogService)],D),e.ExtHostApiDeprecationService=D,e.NullApiDeprecationService=Object.freeze(new class{report(k,E,P){}})}),define(ye[187],De([1,0,5,4,6,27]),function(ne,e,a,p,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class D{constructor(E){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new a.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=E.getProxy(p.MainContext.MainThreadAuthentication)}$setProviders(E){return this._providers=E,Promise.resolve()}async getSession(E,P,O,y={}){const m=L.ExtensionIdentifier.toKey(E.identifier),T=this._inFlightRequests.get(m)||[],f=[...O].sort().join(" ");let h=T.find(d=>d.providerId===P&&d.scopes===f);if(h)return h.result;{const d=this._getSession(E,m,P,O,y);h={providerId:P,scopes:f,result:d},T.push(h),this._inFlightRequests.set(m,T);try{await d}finally{const o=T.findIndex(v=>v.providerId===P&&v.scopes===f);o>-1&&(T.splice(o),this._inFlightRequests.set(m,T))}return d}}async _getSession(E,P,O,y,m={}){await this._proxy.$ensureProvider(O);const T=E.displayName||E.name;return this._proxy.$getSession(O,y,P,T,m)}async removeSession(E,P){const O=this._authenticationProviders.get(E);return O?O.provider.removeSession(P):this._proxy.$removeSession(E,P)}registerAuthenticationProvider(E,P,O,y){if(this._authenticationProviders.get(E))throw new Error(`An authentication provider with id '${E}' is already registered.`);this._authenticationProviders.set(E,{label:P,provider:O,options:y??{supportsMultipleAccounts:!1}}),this._providers.find(T=>T.id===E)||this._providers.push({id:E,label:P});const m=O.onDidChangeSessions(T=>{this._proxy.$sendDidChangeSessions(E,{added:T.added??[],changed:T.changed??[],removed:T.removed??[]})});return this._proxy.$registerAuthenticationProvider(E,P,y?.supportsMultipleAccounts??!1),new b.Disposable(()=>{m.dispose(),this._authenticationProviders.delete(E);const T=this._providers.findIndex(f=>f.id===E);T>-1&&this._providers.splice(T),this._proxy.$unregisterAuthenticationProvider(E)})}$createSession(E,P){const O=this._authenticationProviders.get(E);if(O)return Promise.resolve(O.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$removeSession(E,P){const O=this._authenticationProviders.get(E);if(O)return Promise.resolve(O.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$getSessions(E,P){const O=this._authenticationProviders.get(E);if(O)return Promise.resolve(O.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$onDidChangeAuthenticationSessions(E,P){return this._onDidChangeSessions.fire({provider:{id:E,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=D}),define(ye[188],De([1,0,4,13,8,24]),function(ne,e,a,p,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let D=class{constructor(E,P){this._proxy=E.getProxy(a.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:O=>P.getDocument(O)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(E,P){const O=(0,L.isProposedApiEnabled)(P,"snippetWorkspaceEdit"),y=b.WorkspaceEdit.from(E,this._versionInformationProvider,O);return this._proxy.$tryApplyWorkspaceEdit(y)}};D=ze([xe(0,p.IExtHostRpcService)],D),e.ExtHostBulkEdits=D}),define(ye[189],De([1,0,4]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class p{constructor(L){const D=L.getProxy(a.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return D.$readText()},writeText(k){return D.$writeText(k)}})}}e.ExtHostClipboard=p});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,a,p,b){if(p==="m")throw new TypeError("Private method is not writable");if(p==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return p==="a"?b.call(ne,a):b?b.value=a:e.set(ne,a),a},Oe=this&&this.__classPrivateFieldGet||function(ne,e,a,p){if(a==="a"&&!p)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!p:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?p:a==="a"?p.call(ne):p?p.value:e.get(ne)};define(ye[36],De([1,0,10,6,8,26,4,16,15,55,48,242,2,7,3,13,92,23,40,43]),function(ne,e,a,p,b,L,D,k,E,P,O,y,m,T,f,h,d,o,v,R){"use strict";var c,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let s=class{constructor(l,_){c.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,w.set(this,void 0),Ye(this,c,l.getProxy(D.MainContext.MainThreadCommands),"f"),this._logService=_,Ye(this,w,l.getProxy(D.MainContext.MainThreadTelemetry),"f"),this.converter=new u(this,g=>{const C=this._apiCommands.get(g);return C?.result===i.Void?C:void 0},_),this._argumentProcessors=[{processArgument(g){return(0,P.revive)(g)}},{processArgument(g){return(0,L.cloneAndChange)(g,function(C){if(O.Range.isIRange(C))return b.Range.to(C);if(y.Position.isIPosition(C))return b.Position.to(C);if(O.Range.isIRange(C.range)&&m.URI.isUri(C.uri))return b.location.to(C);if(C instanceof o.VSBuffer)return C.buffer.buffer;if(!Array.isArray(C))return C})}}]}registerArgumentProcessor(l){this._argumentProcessors.push(l)}registerApiCommand(l){const _=this.registerCommand(!1,l.id,async(...g)=>{const C=l.args.map((W,M)=>{if(!W.validate(g[M]))throw new Error(`Invalid argument '${W.name}' when running '${l.id}', received: ${g[M]}`);return W.convert(g[M])}),U=await this.executeCommand(l.internalId,...C);return l.result.convert(U,g,this.converter)},void 0,{description:l.description,args:l.args,returns:l.result.description});return this._apiCommands.set(l.id,l),new p.Disposable(()=>{_.dispose(),this._apiCommands.delete(l.id)})}registerCommand(l,_,g,C,U,W){if(this._logService.trace("ExtHostCommands#registerCommand",_),!_.trim().length)throw new Error("invalid id");if(this._commands.has(_))throw new Error(`command '${_}' already exists`);return this._commands.set(_,{callback:g,thisArg:C,description:U,extension:W}),l&&Oe(this,c,"f").$registerCommand(_),new p.Disposable(()=>{this._commands.delete(_)&&l&&Oe(this,c,"f").$unregisterCommand(_)})}executeCommand(l,..._){return this._logService.trace("ExtHostCommands#executeCommand",l),this._doExecuteCommand(l,_,!0)}async _doExecuteCommand(l,_,g){if(this._commands.has(l))return Oe(this,c,"f").$fireCommandActivationEvent(l),this._executeContributedCommand(l,_,!1);{let C=!1;const U=(0,L.cloneAndChange)(_,function(W){if(W instanceof p.Position)return b.Position.from(W);if(W instanceof p.Range)return b.Range.from(W);if(W instanceof p.Location)return b.location.from(W);if(p.NotebookRange.isNotebookRange(W))return b.NotebookRange.from(W);if(W instanceof ArrayBuffer)return C=!0,o.VSBuffer.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return C=!0,o.VSBuffer.wrap(W);if(W instanceof o.VSBuffer)return C=!0,W;if(!Array.isArray(W))return W});try{const W=await Oe(this,c,"f").$executeCommand(l,C?new v.SerializableObjectWithBuffers(U):U,g);return(0,P.revive)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this._doExecuteCommand(l,_,!1);throw W}}}async _executeContributedCommand(l,_,g){const C=this._commands.get(l);if(!C)throw new Error("Unknown command");this._reportTelemetry(C,l);const{callback:U,thisArg:W,description:M}=C;if(M)for(let S=0;S<M.args.length;S++)try{(0,a.validateConstraint)(_[S],M.args[S].constraint)}catch{throw new Error(`Running the contributed command: '${l}' failed. Illegal argument '${M.args[S].name}' - ${M.args[S].description}`)}try{return await U.apply(W,_)}catch(S){if(l===this.converter.delegatingCommandId){const z=this.converter.getActualCommand(..._);z&&(l=z.command)}throw this._logService.error(S,l,C.extension?.identifier),g?new class extends Error{constructor(){super((0,R.toErrorMessage)(S));this.id=l,this.source=C.extension?.displayName??C.extension?.name}}:S}}_reportTelemetry(l,_){!l.extension||l.extension.isBuiltin||Oe(this,w,"f").$publicLog2("Extension:ActionExecuted",{extensionId:l.extension.identifier.value,id:_})}$executeContributedCommand(l,..._){return this._logService.trace("ExtHostCommands#$executeContributedCommand",l),this._commands.has(l)?(_=_.map(g=>this._argumentProcessors.reduce((C,U)=>U.processArgument(C),g)),this._executeContributedCommand(l,_,!0)):Promise.reject(new Error(`Contributed command '${l}' does not exist.`))}getCommands(l=!1){return this._logService.trace("ExtHostCommands#getCommands",l),Oe(this,c,"f").$getCommands().then(_=>(l&&(_=_.filter(g=>g[0]!=="_")),_))}$getContributedCommandHandlerDescriptions(){const l=Object.create(null);for(const[_,g]of this._commands){const{description:C}=g;C&&(l[_]=C)}return Promise.resolve(l)}};c=new WeakMap,w=new WeakMap,s=ze([xe(0,h.IExtHostRpcService),xe(1,E.ILogService)],s),e.ExtHostCommands=s,e.IExtHostCommands=(0,f.createDecorator)("IExtHostCommands");class u{constructor(l,_,g){this._commands=l,this._lookupApiCommand=_,this._logService=g,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(l,_){if(!l)return;const g={$ident:void 0,id:l.command,title:l.title,tooltip:l.tooltip};if(!l.command)return g;const C=this._lookupApiCommand(l.command);if(C)g.id=C.internalId,g.arguments=C.args.map((U,W)=>U.convert(l.arguments&&l.arguments[W]));else if((0,k.isNonEmptyArray)(l.arguments)){const U=++this._cachIdPool;this._cache.set(U,l),_.add((0,T.toDisposable)(()=>{this._cache.delete(U),this._logService.trace("CommandsConverter#DISPOSE",U)})),g.$ident=U,g.id=this.delegatingCommandId,g.arguments=[U],this._logService.trace("CommandsConverter#CREATE",l.command,U)}return g}fromInternal(l){return typeof l.$ident=="number"?this._cache.get(l.$ident):{command:l.id,title:l.title,arguments:l.arguments}}getActualCommand(...l){return this._cache.get(l[0])}_executeConvertedCommand(...l){const _=this.getActualCommand(...l);return this._logService.trace("CommandsConverter#EXECUTE",l[0],_?_.command:"MISSING"),_?this._commands.executeCommand(_.command,..._.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=u;class n{constructor(l,_,g,C){this.name=l,this.description=_,this.validate=g,this.convert=C}optional(){return new n(this.name,`(optional) ${this.description}`,l=>l==null||this.validate(l),l=>l===void 0?void 0:l===null?null:this.convert(l))}with(l,_){return new n(l??this.name,_??this.description,this.validate,this.convert)}}e.ApiCommandArgument=n,n.Uri=new n("uri","Uri of a text document",t=>m.URI.isUri(t),t=>t),n.Position=new n("position","A position in a text document",t=>p.Position.isPosition(t),b.Position.from),n.Range=new n("range","A range in a text document",t=>p.Range.isRange(t),b.Range.from),n.Selection=new n("selection","A selection in a text document",t=>p.Selection.isSelection(t),b.Selection.from),n.Number=new n("number","",t=>typeof t=="number",t=>t),n.String=new n("string","",t=>typeof t=="string",t=>t),n.CallHierarchyItem=new n("item","A call hierarchy item",t=>t instanceof p.CallHierarchyItem,b.CallHierarchyItem.from),n.TypeHierarchyItem=new n("item","A type hierarchy item",t=>t instanceof p.TypeHierarchyItem,b.TypeHierarchyItem.from),n.TestItem=new n("testItem","A VS Code TestItem",t=>t instanceof d.TestItemImpl,b.TestItem.from);class i{constructor(l,_){this.description=l,this.convert=_}}e.ApiCommandResult=i,i.Void=new i("no result",t=>t);class r{constructor(l,_,g,C,U){this.id=l,this.internalId=_,this.description=g,this.args=C,this.result=U}}e.ApiCommand=r}),define(ye[190],De([1,0,2,8,6,66,36,16,77,81,12]),function(ne,e,a,p,b,L,D,k,E,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const y=[new D.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",T(p.DocumentHighlight.to))),new D.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(h,d)=>{if((0,k.isFalsyOrEmpty)(h))return;class o extends b.SymbolInformation{static to(R){const c=new o(R.name,p.SymbolKind.to(R.kind),R.containerName||"",new b.Location(d[0],p.Range.to(R.range)));return c.detail=R.detail,c.range=c.location.range,c.selectionRange=p.Range.to(R.selectionRange),c.children=R.children?R.children.map(o.to):[],c}}return h.map(o.to)})),new D.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("options","Formatting options",h=>!0,h=>h)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(p.TextEdit.to))),new D.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range,new D.ApiCommandArgument("options","Formatting options",h=>!0,h=>h)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(p.TextEdit.to))),new D.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,new D.ApiCommandArgument("ch","Trigger character",h=>typeof h=="string",h=>h),new D.ApiCommandArgument("options","Formatting options",h=>!0,h=>h)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(p.TextEdit.to))),new D.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new D.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new D.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new D.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new D.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location-instances.",T(p.location.to))),new D.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Hover-instances.",T(p.Hover.to))),new D.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("position","A position in a text document",h=>Array.isArray(h)&&h.every(d=>b.Position.isPosition(d)),h=>h.map(p.Position.from))],new D.ApiCommandResult("A promise that resolves to an array of ranges.",h=>h.map(d=>{let o;for(const v of d.reverse())o=new b.SelectionRange(p.Range.to(v),o);return o}))),new D.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[D.ApiCommandArgument.String.with("query","Search string")],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",h=>h.map(p.WorkspaceSymbol.to))),new D.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A CallHierarchyItem or undefined",h=>h.map(p.CallHierarchyItem.to))),new D.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",h=>h.map(p.CallHierarchyIncomingCall.to))),new D.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",h=>h.map(p.CallHierarchyOutgoingCall.to))),new D.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to a range and placeholder text.",h=>{if(!!h)return{range:p.Range.to(h.range),placeholder:h.text}})),new D.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("newName","The new symbol name")],new D.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",h=>{if(!!h){if(h.rejectReason)throw new Error(h.rejectReason);return p.WorkspaceEdit.to(h)}})),new D.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new D.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",h=>h.map(p.DocumentLink.to))),new D.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",h=>{if(!!h)return new b.SemanticTokensLegend(h.tokenTypes,h.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const d=(0,E.decodeSemanticTokensDto)(h);if(d.type==="full")return new b.SemanticTokens(d.data,void 0)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range.optional()],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",h=>{if(!!h)return new b.SemanticTokensLegend(h.tokenTypes,h.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const d=(0,E.decodeSemanticTokensDto)(h);if(d.type==="full")return new b.SemanticTokens(d.data,void 0)})),new D.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new D.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(h,d,o)=>{if(!h)return new b.CompletionList([]);const v=h.suggestions.map(R=>p.CompletionItem.to(R,o));return new b.CompletionList(v,h.incomplete)})),new D.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new D.ApiCommandResult("A promise that resolves to SignatureHelp.",h=>{if(h)return p.SignatureHelp.to(h)})),new D.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new D.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(h,d,o)=>T(v=>new b.CodeLens(p.Range.to(v.range),v.command&&o.fromInternal(v.command)))(h))),new D.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",h=>b.Range.isRange(h),h=>b.Selection.isSelection(h)?p.Selection.from(h):p.Range.from(h)),D.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new D.ApiCommandResult("A promise that resolves to an array of Command-instances.",(h,d,o)=>T(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(v.command)}else{const R=new b.CodeAction(v.title,v.kind?new b.CodeActionKind(v.kind):void 0);return v.edit&&(R.edit=p.WorkspaceEdit.to(v.edit)),v.command&&(R.command=o.fromInternal(v.command)),R.isPreferred=v.isPreferred,R}})(h))),new D.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",h=>h?h.map(d=>new b.ColorInformation(p.Range.to(d.range),p.Color.to(d.color))):[])),new D.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new D.ApiCommandArgument("color","The color to show and insert",h=>h instanceof b.Color,p.Color.from),new D.ApiCommandArgument("context","Context object with uri and range",h=>!0,h=>({uri:h.uri,range:p.Range.from(h.range)}))],new D.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",h=>h?h.map(p.ColorPresentation.to):[])),new D.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of Inlay objects",(h,d,o)=>h.map(p.InlayHint.to.bind(void 0,o)))),new D.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new D.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",T(h=>({viewType:h.viewType,displayName:h.displayName,options:{transientOutputs:h.options.transientOutputs,transientCellMetadata:h.options.transientCellMetadata,transientDocumentMetadata:h.options.transientDocumentMetadata},filenamePattern:h.filenamePattern.map(d=>p.NotebookExclusiveDocumentPattern.to(d))})))),new D.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineValue objects",h=>h.map(p.InlineValue.to))),new D.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new D.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",h=>a.URI.isUri(h)||typeof h=="string"&&(0,P.matchesSomeScheme)(h,O.Schemas.http,O.Schemas.https),h=>h),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[p.ViewColumn.from(h),void 0]:[p.ViewColumn.from(h.viewColumn),p.TextEditorOpenOptions.from(h)])).optional(),D.ApiCommandArgument.String.with("label","").optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[D.ApiCommandArgument.Uri.with("resource","Resource to open"),D.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[p.ViewColumn.from(h),void 0]:[p.ViewColumn.from(h.viewColumn),p.TextEditorOpenOptions.from(h)])).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[D.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),D.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),D.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="object",h=>h&&[p.ViewColumn.from(h.viewColumn),p.TextEditorOpenOptions.from(h)]).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A TypeHierarchyItem or undefined",h=>h.map(p.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A TypeHierarchyItem or undefined",h=>h.map(p.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A TypeHierarchyItem or undefined",h=>h.map(p.TypeHierarchyItem.to))),new D.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[D.ApiCommandArgument.TestItem],D.ApiCommandResult.Void),new D.ApiCommand("vscode.experimental.editSession.continue","_workbench.experimental.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[D.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],D.ApiCommandResult.Void)];class m{static register(d){y.forEach(d.registerApiCommand,d)}}e.ExtHostApiCommands=m;function T(h){return d=>{if(Array.isArray(d))return d.map(h)}}function f(h){if(!Array.isArray(h))return;const d=[];for(const o of h)L.isLocationLink(o)?d.push(p.DefinitionLink.to(o)):d.push(p.location.to(o));return d}}),define(ye[191],De([1,0,14,54,5,7,2,66,27,8,6,24,4]),function(ne,e,a,p,b,L,D,k,E,P,O,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function T(f,h,d){const o=f.getProxy(m.MainContext.MainThreadComments);class v{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,h.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const l=this._commentControllers.get(t.handle);return l?l.value:t}else if(t&&t.$mid===7){const l=this._commentControllers.get(t.commentControlHandle);if(!l)return t;const _=l.getCommentThread(t.commentThreadHandle);return _?_.value:t}else if(t&&t.$mid===8){const l=this._commentControllers.get(t.thread.commentControlHandle);if(!l)return t;const _=l.getCommentThread(t.thread.commentThreadHandle);return _?{thread:_.value,text:t.text}:t}else if(t&&t.$mid===9){const l=this._commentControllers.get(t.thread.commentControlHandle);if(!l)return t;const _=l.getCommentThread(t.thread.commentThreadHandle);if(!_)return t;const g=t.commentUniqueId,C=_.getCommentByUniqueId(g);return C||t}else if(t&&t.$mid===10){const l=this._commentControllers.get(t.thread.commentControlHandle);if(!l)return t;const _=l.getCommentThread(t.thread.commentThreadHandle);if(!_)return t;const g=t.text,C=t.commentUniqueId,U=_.getCommentByUniqueId(C);return U?(U.body=g,U):t}return t}})}createCommentController(t,l,_){const g=v.handlePool++,C=new c(t,g,l,_);this._commentControllers.set(C.handle,C);const U=this._commentControllersByExtension.get(E.ExtensionIdentifier.toKey(t.identifier))||[];return U.push(C),this._commentControllersByExtension.set(E.ExtensionIdentifier.toKey(t.identifier),U),C.value}$createCommentThreadTemplate(t,l,_){const g=this._commentControllers.get(t);!g||g.$createCommentThreadTemplate(l,_)}async $updateCommentThreadTemplate(t,l,_){const g=this._commentControllers.get(t);!g||g.$updateCommentThreadTemplate(l,_)}$deleteCommentThread(t,l){this._commentControllers.get(t)?.$deleteCommentThread(l)}$provideCommentingRanges(t,l,_){const g=this._commentControllers.get(t);if(!g||!g.commentingRangeProvider)return Promise.resolve(void 0);const C=d.getDocument(D.URI.revive(l));return(0,a.asPromise)(()=>g.commentingRangeProvider.provideCommentingRanges(C,_)).then(U=>U?U.map(W=>P.Range.from(W)):void 0)}$toggleReaction(t,l,_,g,C){const U=this._commentControllers.get(t);return!U||!U.reactionHandler?Promise.resolve(void 0):(0,a.asPromise)(()=>{const W=U.getCommentThread(l);if(W){const M=W.getCommentByUniqueId(g.uniqueIdInThread);if(U!==void 0&&M&&U.reactionHandler)return U.reactionHandler(M,u(C))}return Promise.resolve(void 0)})}dispose(){}}v.handlePool=0;class R{constructor(t,l,_,g,C,U,W,M){this._commentControllerHandle=l,this._id=_,this._uri=g,this._range=C,this._comments=U,this.extensionDescription=W,this._isTemplate=M,this.handle=R._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new b.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new L.MutableDisposable,this._acceptInputDisposables.value=new L.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),o.$createCommentThread(l,this.handle,this._id,this._uri,P.Range.from(this._range),W.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=U,this._localDisposables.push({dispose:()=>{o.$deleteCommentThread(l,this.handle)}});const S=this;this.value={get uri(){return S.uri},get range(){return S.range},set range(z){S.range=z},get comments(){return S.comments},set comments(z){S.comments=z},get collapsibleState(){return S.collapsibleState},set collapsibleState(z){S.collapsibleState=z},get canReply(){return S.canReply},set canReply(z){S.canReply=z},get contextValue(){return S.contextValue},set contextValue(z){S.contextValue=z},get label(){return S.label},set label(z){S.label=z},get state(){return S.state},set state(z){S.state=z},dispose:()=>{S.dispose()}}}set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get state(){return(0,y.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(t){(0,y.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=t,this.modifications.state=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new L.DisposableStore);const t=_=>Object.prototype.hasOwnProperty.call(this.modifications,_),l={};t("range")&&(l.range=P.Range.from(this._range)),t("label")&&(l.label=this.label),t("contextValue")&&(l.contextValue=this.contextValue??null),t("comments")&&(l.comments=this._comments.map(_=>w(this,_,this._commentsMap))),t("collapsibleState")&&(l.collapseState=n(this._collapseState)),t("canReply")&&(l.canReply=this.canReply),t("state")&&(l.state=i(this._state)),t("isTemplate")&&(l.isTemplate=this._isTemplate),this.modifications={},o.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,l)}getCommentByUniqueId(t){for(const l of this._commentsMap){const _=l[0],g=l[1];if(t===g)return _}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}R._handlePool=0,ze([(0,p.debounce)(100)],R.prototype,"eventuallyUpdateCommentThread",null);class c{constructor(t,l,_,g){this._extension=t,this._handle=l,this._id=_,this._label=g,this._threads=new Map,o.$registerCommentController(this.handle,_,g);const C=this;this.value=Object.freeze({id:C.id,label:C.label,get options(){return C.options},set options(U){C.options=U},get commentingRangeProvider(){return C.commentingRangeProvider},set commentingRangeProvider(U){C.commentingRangeProvider=U},get reactionHandler(){return C.reactionHandler},set reactionHandler(U){C.reactionHandler=U},createCommentThread(U,W,M){return C.createCommentThread(U,W,M).value},dispose:()=>{C.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,o.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,o.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(t,l,_,g){if(typeof t=="string"){const C=new R(this.id,this.handle,t,l,_,g,this._extension,!1);return this._threads.set(C.handle,C),C}else{const C=new R(this.id,this.handle,void 0,t,l,_,this._extension,!1);return this._threads.set(C.handle,C),C}}$createCommentThreadTemplate(t,l){const _=new R(this.id,this.handle,void 0,D.URI.revive(t),P.Range.to(l),[],this._extension,!0);return _.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(_.handle,_),_}$updateCommentThreadTemplate(t,l){const _=this._threads.get(t);_&&(_.range=P.Range.to(l))}$deleteCommentThread(t){this._threads.get(t)?.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function w(r,t,l){let _=l.get(t);_||(_=++r.commentHandle,l.set(t,_));const g=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:_,body:typeof t.body=="string"?t.body:P.MarkdownString.from(t.body),userName:t.author.name,userIconPath:g,label:t.label,commentReactions:t.reactions?t.reactions.map(C=>s(C)):void 0,timestamp:t.timestamp?.toJSON()}}function s(r){return{label:r.label,iconPath:r.iconPath?P.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function u(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?D.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function n(r){if(r!==void 0)switch(r){case O.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case O.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}function i(r){if(r!==void 0)switch(r){case O.CommentThreadState.Unresolved:return k.CommentThreadState.Unresolved;case O.CommentThreadState.Resolved:return k.CommentThreadState.Resolved}return k.CommentThreadState.Unresolved}return new v}e.createExtHostComments=T}),define(ye[192],De([1,0,26,4,28,13]),function(ne,e,a,p,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let D=class{constructor(O,y){this._mainThreadConsole=O.getProxy(p.MainContext.MainThreadConsole),this._includeStack=y.consoleForward.includeStack,this._logNative=y.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(O,y){const m=this,T=console[O];Object.defineProperty(console,O,{set:()=>{},get:()=>function(){m._handleConsoleCall(O,y,T,arguments)}})}_handleConsoleCall(O,y,m,T){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:y,arguments:E(T,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(O,m,T)}};D=ze([xe(0,L.IExtHostRpcService),xe(1,b.IExtHostInitDataService)],D),e.AbstractExtHostConsoleForwarder=D;const k=1e5;function E(P,O){const y=[];if(P.length)for(let m=0;m<P.length;m++){let T=P[m];if(typeof T=="undefined")T="undefined";else if(T instanceof Error){const f=T;f.stack?T=f.stack:T=f.toString()}y.push(T)}if(O){const m=new Error().stack;m&&y.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,a.safeStringify)(y);return m.length>k?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(ye[95],De([1,0,2,4,6,3,13,15,16,9,19]),function(ne,e,a,p,b,L,D,k,E,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let y=class Ii{constructor(T,f){this._logService=f,this._provider=new Map,this._proxy=T.getProxy(p.MainContext.MainThreadDecorations)}registerFileDecorationProvider(T,f){const h=Ii._handlePool++;this._provider.set(h,{provider:T,extensionId:f}),this._proxy.$registerDecorationProvider(h,f.value);const d=T.onDidChangeFileDecorations&&T.onDidChangeFileDecorations(o=>{if(!o){this._proxy.$onDidChange(h,null);return}const v=(0,E.asArray)(o);if(v.length<=Ii._maxEventSize){this._proxy.$onDidChange(h,v);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",f.value,v.length);const R=v.map(s=>({uri:s,rank:(0,P.count)(s.path,"/")})),c=(0,E.groupBy)(R,(s,u)=>s.rank-u.rank||(0,P.compare)(s.uri.path,u.uri.path)),w=[];e:for(const s of c){let u;for(const n of s){const i=(0,O.dirname)(n.uri.path);if(u!==i&&(u=i,w.push(n.uri)>=Ii._maxEventSize))break e}}this._proxy.$onDidChange(h,w)});return new b.Disposable(()=>{d?.dispose(),this._proxy.$unregisterDecorationProvider(h),this._provider.delete(h)})}async $provideDecorations(T,f,h){if(!this._provider.has(T))return Object.create(null);const d=Object.create(null),{provider:o,extensionId:v}=this._provider.get(T);return await Promise.all(f.map(async R=>{try{const{uri:c,id:w}=R,s=await Promise.resolve(o.provideFileDecoration(a.URI.revive(c),h));if(!s)return;try{b.FileDecoration.validate(s),d[w]=[s.propagate,s.tooltip,s.badge,s.color]}catch(u){this._logService.warn(`INVALID decoration from extension '${v.value}': ${u}`)}}catch(c){this._logService.error(c)}})),d}};y._handlePool=0,y._maxEventSize=250,y=ze([xe(0,D.IExtHostRpcService),xe(1,k.ILogService)],y),e.ExtHostDecorations=y,e.IExtHostDecorations=(0,L.createDecorator)("IExtHostDecorations")});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,a,p,b){if(p==="m")throw new TypeError("Private method is not writable");if(p==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return p==="a"?b.call(ne,a):b?b.value=a:e.set(ne,a),a},Oe=this&&this.__classPrivateFieldGet||function(ne,e,a,p){if(a==="a"&&!p)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!p:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?p:a==="a"?p.call(ne):p?p.value:e.get(ne)};define(ye[193],De([1,0,129,80,2,4,6,8,5,15,25,35]),function(ne,e,a,p,b,L,D,k,E,P,O,y){"use strict";var m,T,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class h{constructor(v,R,c,w,s,u){this._name=v,this._owner=R,this._maxDiagnosticsPerFile=c,m.set(this,void 0),T.set(this,void 0),f.set(this,void 0),this._isDisposed=!1,Ye(this,f,new O.ResourceMap(n=>w.getComparisonKey(n)),"f"),Ye(this,m,s,"f"),Ye(this,T,u,"f")}dispose(){this._isDisposed||(Oe(this,T,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,m,"f")?.$clear(this._owner),Oe(this,f,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(v,R){if(!v){this.clear();return}this._checkDisposed();let c=[];if(b.URI.isUri(v)){if(!R){this.delete(v);return}Oe(this,f,"f").set(v,R.slice()),c=[v]}else if(Array.isArray(v)){c=[];let s;v=[...v].sort(h._compareIndexedTuplesByUri);for(const u of v){const[n,i]=u;if((!s||n.toString()!==s.toString())&&(s&&Oe(this,f,"f").get(s).length===0&&Oe(this,f,"f").delete(s),s=n,c.push(n),Oe(this,f,"f").set(n,[])),i)Oe(this,f,"f").get(n)?.push(...i);else{const r=Oe(this,f,"f").get(n);r&&(r.length=0)}}}if(Oe(this,T,"f").fire(c),!Oe(this,m,"f"))return;const w=[];for(const s of c){let u=[];const n=Oe(this,f,"f").get(s);if(n)if(n.length>this._maxDiagnosticsPerFile){u=[];const i=[D.DiagnosticSeverity.Error,D.DiagnosticSeverity.Warning,D.DiagnosticSeverity.Information,D.DiagnosticSeverity.Hint];e:for(let r=0;r<4;r++)for(const t of n)if(t.severity===i[r]&&u.push(k.Diagnostic.from(t))===this._maxDiagnosticsPerFile)break e;u.push({severity:p.MarkerSeverity.Info,message:(0,a.localize)(0,null,n.length-this._maxDiagnosticsPerFile),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=n.map(i=>k.Diagnostic.from(i));w.push([s,u])}Oe(this,m,"f").$changeMany(this._owner,w)}delete(v){this._checkDisposed(),Oe(this,T,"f").fire([v]),Oe(this,f,"f").delete(v),Oe(this,m,"f")?.$changeMany(this._owner,[[v,void 0]])}clear(){this._checkDisposed(),Oe(this,T,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,f,"f").clear(),Oe(this,m,"f")?.$clear(this._owner)}forEach(v,R){this._checkDisposed();for(const[c,w]of this)v.call(R,c,w,this)}*[(m=new WeakMap,T=new WeakMap,f=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const v of Oe(this,f,"f").keys())yield[v,this.get(v)]}get(v){this._checkDisposed();const R=Oe(this,f,"f").get(v);return Array.isArray(R)?Object.freeze(R.slice(0)):[]}has(v){return this._checkDisposed(),Array.isArray(Oe(this,f,"f").get(v))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(v,R){return v[0].toString()<R[0].toString()?-1:v[0].toString()>R[0].toString()?1:0}}e.DiagnosticCollection=h;let d=class fi{constructor(v,R,c){this._logService=R,this._fileSystemInfoService=c,this._collections=new Map,this._onDidChangeDiagnostics=new E.DebounceEmitter({merge:w=>w.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this._onDidChangeDiagnostics.event,fi._mapper),this._proxy=v.getProxy(L.MainContext.MainThreadDiagnostics)}static _mapper(v){const R=new O.ResourceMap;for(const c of v)R.set(c,c);return{uris:Object.freeze(Array.from(R.values()))}}createDiagnosticCollection(v,R){const{_collections:c,_proxy:w,_onDidChangeDiagnostics:s,_logService:u,_fileSystemInfoService:n}=this,i=new class{$changeMany(l,_){w.$changeMany(l,_),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",v.value,l,_.length===0?"CLEARING":_)}$clear(l){w.$clear(l),u.trace("[DiagnosticCollection] remove all (extension, owner)",v.value,l)}dispose(){w.dispose()}};let r;if(!R)R="_generated_diagnostic_collection_name_#"+fi._idPool++,r=R;else if(!c.has(R))r=R;else{this._logService.warn(`DiagnosticCollection with name '${R}' does already exist.`);do r=R+fi._idPool++;while(c.has(r))}return new class extends h{constructor(){super(R,r,fi._maxDiagnosticsPerFile,n.extUri,i,s);c.set(r,this)}dispose(){super.dispose(),c.delete(r)}}}getDiagnostics(v){if(v)return this._getDiagnostics(v);{const R=new Map,c=[];for(const w of this._collections.values())w.forEach((s,u)=>{let n=R.get(s.toString());typeof n=="undefined"&&(n=c.length,R.set(s.toString(),n),c.push([s,[]])),c[n][1]=c[n][1].concat(...u)});return c}}_getDiagnostics(v){let R=[];for(const c of this._collections.values())c.has(v)&&(R=R.concat(c.get(v)));return R}$acceptMarkersChange(v){if(!this._mirrorCollection){const R="_generated_mirror",c=new h(R,R,fi._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(R,c),this._mirrorCollection=c}for(const[R,c]of v)this._mirrorCollection.set(b.URI.revive(R),c.map(k.Diagnostic.to))}};d._idPool=0,d._maxDiagnosticsPerFile=1e3,d=ze([xe(1,P.ILogService),xe(2,y.IExtHostFileSystemInfo)],d),e.ExtHostDiagnostics=d}),define(ye[194],De([1,0,2,4]),function(ne,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class b{constructor(D){this._proxy=D.getProxy(p.MainContext.MainThreadDialogs)}showOpenDialog(D){return this._proxy.$showOpenDialog(D).then(k=>k?k.map(E=>a.URI.revive(E)):void 0)}showSaveDialog(D){return this._proxy.$showSaveDialog(D).then(k=>k?a.URI.revive(k):void 0)}}e.ExtHostDialogs=b}),define(ye[195],De([1,0,11,2,6,4,12,20,9]),function(ne,e,a,p,b,L,D,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(y,m,T){this._documentsAndEditors=m,this._logService=T,this._documentContentProviders=new Map,this._proxy=y.getProxy(L.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,m){if(Object.keys(D.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const T=P._handlePool++;this._documentContentProviders.set(T,m),this._proxy.$registerTextContentProvider(T,y);let f;return typeof m.onDidChange=="function"&&(f=m.onDidChange(h=>{if(h.scheme!==y){this._logService.warn(`Provider for scheme '${y}' is firing event for schema '${h.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(h)&&this.$provideTextDocumentContent(T,h).then(d=>{if(!d&&typeof d!="string")return;const o=this._documentsAndEditors.getDocument(h);if(!o)return;const v=(0,E.splitLines)(d);if(!o.equalLines(v))return this._proxy.$onVirtualDocumentChange(h,d)},a.onUnexpectedError)})),new b.Disposable(()=>{this._documentContentProviders.delete(T)&&this._proxy.$unregisterTextContentProvider(T),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(y,m){const T=this._documentContentProviders.get(y);return T?Promise.resolve(T.provideTextDocumentContent(p.URI.revive(m),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(ye[196],De([1,0,5,7,2,4,87,8,10,26,6]),function(ne,e,a,p,b,L,D,k,E,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class y{constructor(T,f){this._onDidAddDocument=new a.Emitter,this._onDidRemoveDocument=new a.Emitter,this._onDidChangeDocument=new a.Emitter,this._onDidSaveDocument=new a.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new p.DisposableStore,this._documentLoader=new Map,this._proxy=T.getProxy(L.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(h=>{for(const d of h)this._onDidRemoveDocument.fire(d.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(h=>{for(const d of h)this._onDidAddDocument.fire(d.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(T){if(!T)return;const f=this._documentsAndEditors.getDocument(T);if(f)return f}getDocument(T){const f=this.getDocumentData(T);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${T}'`);return f.document}ensureDocumentData(T){const f=this._documentsAndEditors.getDocument(T);if(f)return Promise.resolve(f);let h=this._documentLoader.get(T.toString());return h||(h=this._proxy.$tryOpenDocument(T).then(d=>{this._documentLoader.delete(T.toString());const o=b.URI.revive(d);return(0,E.assertIsDefined)(this._documentsAndEditors.getDocument(o))},d=>(this._documentLoader.delete(T.toString()),Promise.reject(d))),this._documentLoader.set(T.toString(),h)),h}createDocumentData(T){return this._proxy.$tryCreateDocument(T).then(f=>b.URI.revive(f))}$acceptModelLanguageChanged(T,f){const h=b.URI.revive(T),d=this._documentsAndEditors.getDocument(h);if(!d)throw new Error("unknown document");this._onDidRemoveDocument.fire(d.document),d._acceptLanguageId(f),this._onDidAddDocument.fire(d.document)}$acceptModelSaved(T){const f=b.URI.revive(T),h=this._documentsAndEditors.getDocument(f);if(!h)throw new Error("unknown document");this.$acceptDirtyStateChanged(T,!1),this._onDidSaveDocument.fire(h.document)}$acceptDirtyStateChanged(T,f){const h=b.URI.revive(T),d=this._documentsAndEditors.getDocument(h);if(!d)throw new Error("unknown document");d._acceptIsDirty(f),this._onDidChangeDocument.fire({document:d.document,contentChanges:[],reason:void 0})}$acceptModelChanged(T,f,h){const d=b.URI.revive(T),o=this._documentsAndEditors.getDocument(d);if(!o)throw new Error("unknown document");o._acceptIsDirty(h),o.onEvents(f);let v;f.isUndoing?v=O.TextDocumentChangeReason.Undo:f.isRedoing&&(v=O.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:o.document,contentChanges:f.changes.map(R=>({range:k.Range.to(R.range),rangeOffset:R.rangeOffset,rangeLength:R.rangeLength,text:R.text})),reason:v}))}setWordDefinitionFor(T,f){(0,D.setWordDefinitionFor)(T,f)}}e.ExtHostDocuments=y}),define(ye[49],De([1,0,44,5,7,2,3,4,87,13,93,8,15,25,12,168,197]),function(ne,e,a,p,b,L,D,k,E,P,O,y,m,T,f,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class o{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let v=class{constructor(c,w){this._extHostRpc=c,this._logService=w,this._activeEditorId=null,this._editors=new Map,this._documents=new T.ResourceMap,this._onDidAddDocuments=new p.Emitter,this._onDidRemoveDocuments=new p.Emitter,this._onDidChangeVisibleTextEditors=new p.Emitter,this._onDidChangeActiveTextEditor=new p.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const w=[],s=[],u=[];if(c.removedDocuments)for(const n of c.removedDocuments){const i=L.URI.revive(n),r=this._documents.get(i);r?.unref()&&(this._documents.delete(i),w.push(r.value))}if(c.addedDocuments)for(const n of c.addedDocuments){const i=L.URI.revive(n.uri);let r=this._documents.get(i);if(r&&i.scheme!==f.Schemas.vscodeNotebookCell&&i.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);r||(r=new o(new E.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),i,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this._documents.set(i,r),s.push(r.value)),r.ref()}if(c.removedEditors)for(const n of c.removedEditors){const i=this._editors.get(n);this._editors.delete(n),i&&u.push(i)}if(c.addedEditors)for(const n of c.addedEditors){const i=L.URI.revive(n.documentUri);a.ok(this._documents.has(i),`document '${i}' does not exist`),a.ok(!this._editors.has(n.id),`editor '${n.id}' already exists!`);const r=this._documents.get(i).value,t=new O.ExtHostTextEditor(n.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new d.Lazy(()=>r.document),n.selections.map(y.Selection.to),n.options,n.visibleRanges.map(l=>y.Range.to(l)),typeof n.editorPosition=="number"?y.ViewColumn.to(n.editorPosition):void 0);this._editors.set(n.id,t)}c.newActiveEditor!==void 0&&(a.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,b.dispose)(w),(0,b.dispose)(u),c.removedDocuments&&this._onDidRemoveDocuments.fire(w),c.addedDocuments&&this._onDidAddDocuments.fire(s),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(n=>n.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){return this._documents.get(c)?.value}allDocuments(){return h.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!this._activeEditorId)return;const w=this._editors.get(this._activeEditorId);return c?w:w?.value}allEditors(){return[...this._editors.values()]}};v=ze([xe(0,P.IExtHostRpcService),xe(1,m.ILogService)],v),e.ExtHostDocumentsAndEditors=v,e.IExtHostDocumentsAndEditors=(0,D.createDecorator)("IExtHostDocumentsAndEditors")}),define(ye[50],De([1,0,8,4,2,5,3,6,13,10,72]),function(ne,e,a,p,b,L,D,k,E,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,D.createDecorator)("IExtHostEditorTabs");class y{constructor(d,o,v){this._activeTabIdGetter=v,this._parentGroup=o,this.acceptDtoUpdate(d)}get apiObject(){if(!this._apiObject){const d=this,o={get isActive(){return d._dto.id===d._activeTabIdGetter()},get label(){return d._dto.label},get input(){return d._input},get isDirty(){return d._dto.isDirty},get isPinned(){return d._dto.isPinned},get isPreview(){return d._dto.isPreview},get group(){return d._parentGroup.apiObject}};this._apiObject=Object.freeze(o)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(d){this._dto=d,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new k.TextTabInput(b.URI.revive(this._dto.input.uri));case 2:return new k.TextDiffTabInput(b.URI.revive(this._dto.input.original),b.URI.revive(this._dto.input.modified));case 3:return new k.TextMergeTabInput(b.URI.revive(this._dto.input.base),b.URI.revive(this._dto.input.input1),b.URI.revive(this._dto.input.input2),b.URI.revive(this._dto.input.result));case 6:return new k.CustomEditorTabInput(b.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new k.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new k.NotebookEditorTabInput(b.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new k.NotebookDiffEditorTabInput(b.URI.revive(this._dto.input.original),b.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new k.TerminalEditorTabInput;case 9:return new k.InteractiveWindowInput(b.URI.revive(this._dto.input.uri),b.URI.revive(this._dto.input.inputBoxUri));default:return}}}class m{constructor(d,o){this._tabs=[],this._activeTabId="",this._dto=d,this._activeGroupIdGetter=o;for(const v of d.tabs)v.isActive&&(this._activeTabId=v.id),this._tabs.push(new y(v,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const d=this,o={get isActive(){return d._dto.groupId===d._activeGroupIdGetter()},get viewColumn(){return a.ViewColumn.to(d._dto.viewColumn)},get activeTab(){return d._tabs.find(v=>v.tabId===d._activeTabId)?.apiObject},get tabs(){return Object.freeze(d._tabs.map(v=>v.apiObject))}};this._apiObject=Object.freeze(o)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(d){this._dto=d}acceptTabOperation(d){if(d.kind===0){const v=new y(d.tabDto,this,()=>this.activeTabId());return this._tabs.splice(d.index,0,v),d.tabDto.isActive&&(this._activeTabId=v.tabId),v}else if(d.kind===1){const v=this._tabs.splice(d.index,1)[0];if(!v)throw new Error(`Tab close updated received for index ${d.index} which does not exist`);return v.tabId===this._activeTabId&&(this._activeTabId=""),v}else if(d.kind===3){if(d.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const v=this._tabs.splice(d.oldIndex,1)[0];if(!v)throw new Error(`Tab move updated received for index ${d.oldIndex} which does not exist`);return this._tabs.splice(d.index,0,v),v}const o=this._tabs.find(v=>v.tabId===d.tabDto.id);if(!o)throw new Error("INVALID tab");return d.tabDto.isActive?this._activeTabId=d.tabDto.id:this._activeTabId===d.tabDto.id&&!d.tabDto.isActive&&(this._activeTabId=""),o.acceptDtoUpdate(d.tabDto),o}activeTabId(){return this._activeTabId}}let T=class{constructor(d){this._onDidChangeTabs=new L.Emitter,this._onDidChangeTabGroups=new L.Emitter,this._extHostTabGroups=[],this._proxy=d.getProxy(p.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const d=this,o={onDidChangeTabGroups:d._onDidChangeTabGroups.event,onDidChangeTabs:d._onDidChangeTabs.event,get all(){return Object.freeze(d._extHostTabGroups.map(v=>v.apiObject))},get activeTabGroup(){const v=d._activeGroupId;return(0,P.assertIsDefined)(d._extHostTabGroups.find(c=>c.groupId===v)?.apiObject)},close:async(v,R)=>{const c=Array.isArray(v)?v:[v];return c.length?f(c[0])?this._closeGroups(c,R):this._closeTabs(c,R):!0}};this._apiObject=Object.freeze(o)}return this._apiObject}$acceptEditorTabModel(d){const o=new Set(this._extHostTabGroups.map(n=>n.groupId)),v=new Set(d.map(n=>n.groupId)),R=(0,O.diffSets)(o,v),c=this._extHostTabGroups.filter(n=>R.removed.includes(n.groupId)).map(n=>n.apiObject),w=[],s=[];this._extHostTabGroups=d.map(n=>{const i=new m(n,()=>this._activeGroupId);return R.added.includes(i.groupId)?w.push(i.apiObject):s.push(i.apiObject),i});const u=(0,P.assertIsDefined)(d.find(n=>n.isActive===!0)?.groupId);u!==void 0&&this._activeGroupId!==u&&(this._activeGroupId=u),this._onDidChangeTabGroups.fire(Object.freeze({opened:w,closed:c,changed:s}))}$acceptTabGroupUpdate(d){const o=this._extHostTabGroups.find(v=>v.groupId===d.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(d),d.isActive&&(this._activeGroupId=d.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(d){const o=this._extHostTabGroups.find(R=>R.groupId===d.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const v=o.acceptTabOperation(d);switch(d.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[v.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[v.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[v.apiObject]}));return}}_findExtHostTabFromApi(d){for(const o of this._extHostTabGroups)for(const v of o.tabs)if(v.apiObject===d)return v}_findExtHostTabGroupFromApi(d){return this._extHostTabGroups.find(o=>o.apiObject===d)}async _closeTabs(d,o){const v=[];for(const R of d){const c=this._findExtHostTabFromApi(R);if(!c)throw new Error("Tab close: Invalid tab not found!");v.push(c.tabId)}return this._proxy.$closeTab(v,o)}async _closeGroups(d,o){const v=[];for(const R of d){const c=this._findExtHostTabGroupFromApi(R);if(!c)throw new Error("Group close: Invalid group not found!");v.push(c.groupId)}return this._proxy.$closeGroup(v,o)}};T=ze([xe(0,E.IExtHostRpcService)],T),e.ExtHostEditorTabs=T;function f(h){return h.tabs!==void 0}}),define(ye[198],De([1,0,2,4,7,6,8,243,9,23,24]),function(ne,e,a,p,b,L,D,k,E,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class y{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const h=this._schemes.indexOf(f);h>=0&&(this._schemes.splice(h,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),h=[];let d,o,v=14,R=14;for(const c of f){let w=d?(0,E.commonPrefixLength)(d,c):0;for(w===0?o=1:o=R;w<c.length;w++)w+1===c.length?(v=R,R=9):R+=1,h.push([o,c.toUpperCase().charCodeAt(w),R]),h.push([o,c.toLowerCase().charCodeAt(w),R]),o=R;d=c,R=v}h.push([9,58,10]),h.push([10,47,12]),this._stateMachine=new k.StateMachine(h)}}provideDocumentLinks(f){this._initStateMachine();const h=[],d=k.LinkComputer.computeLinks({getLineContent(o){return f.lineAt(o-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const o of d){const v=D.DocumentLink.to(o);v.target&&h.push(v)}return h}}class m{constructor(f,h){this._extHostLanguageFeatures=h,this._linkProvider=new y,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(p.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(f,h,d,o={}){if(this._registeredSchemes.has(h))throw new Error(`a provider for the scheme '${h}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(f,"*",this._linkProvider));const v=this._handlePool++;this._linkProvider.add(h),this._registeredSchemes.add(h),this._fsProvider.set(v,d);let R=2;o.isCaseSensitive&&(R+=1024),o.isReadonly&&(R+=2048),typeof d.copy=="function"&&(R+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&((0,O.checkProposedApiEnabled)(f,"fsChunks"),R+=4),this._proxy.$registerFileSystemProvider(v,h,R).catch(w=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${h}`),console.error(w)});const c=d.onDidChangeFile(w=>{const s=[];for(const u of w){const{uri:n,type:i}=u;if(n.scheme!==h)continue;let r;switch(i){case L.FileChangeType.Changed:r=0;break;case L.FileChangeType.Created:r=1;break;case L.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:n,type:r})}this._proxy.$onFileSystemChange(v,s)});return(0,b.toDisposable)(()=>{c.dispose(),this._linkProvider.delete(h),this._registeredSchemes.delete(h),this._fsProvider.delete(v),this._proxy.$unregisterProvider(v)})}static _asIStat(f){const{type:h,ctime:d,mtime:o,size:v,permissions:R}=f;return{type:h,ctime:d,mtime:o,size:v,permissions:R}}$stat(f,h){return Promise.resolve(this._getFsProvider(f).stat(a.URI.revive(h))).then(d=>m._asIStat(d))}$readdir(f,h){return Promise.resolve(this._getFsProvider(f).readDirectory(a.URI.revive(h)))}$readFile(f,h){return Promise.resolve(this._getFsProvider(f).readFile(a.URI.revive(h))).then(d=>P.VSBuffer.wrap(d))}$writeFile(f,h,d,o){return Promise.resolve(this._getFsProvider(f).writeFile(a.URI.revive(h),d.buffer,o))}$delete(f,h,d){return Promise.resolve(this._getFsProvider(f).delete(a.URI.revive(h),d))}$rename(f,h,d,o){return Promise.resolve(this._getFsProvider(f).rename(a.URI.revive(h),a.URI.revive(d),o))}$copy(f,h,d,o){const v=this._getFsProvider(f);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(a.URI.revive(h),a.URI.revive(d),o))}$mkdir(f,h){return Promise.resolve(this._getFsProvider(f).createDirectory(a.URI.revive(h)))}$watch(f,h,d,o){const v=this._getFsProvider(f).watch(a.URI.revive(d),o);this._watches.set(h,v)}$unwatch(f,h){const d=this._watches.get(h);d&&(d.dispose(),this._watches.delete(h))}$open(f,h,d){const o=this._getFsProvider(f);if(!o.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(o.open(a.URI.revive(h),d))}$close(f,h){const d=this._getFsProvider(f);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(h))}$read(f,h,d,o){const v=this._getFsProvider(f);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const R=P.VSBuffer.alloc(o);return Promise.resolve(v.read(h,d,R.buffer,0,o)).then(c=>R.slice(0,c))}$write(f,h,d,o){const v=this._getFsProvider(f);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(h,d,o.buffer,0,o.byteLength))}_getFsProvider(f){const h=this._fsProvider.get(f);if(!h){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return h}}e.ExtHostFileSystem=m}),define(ye[51],De([1,0,4,39,6,23,3,13,35,7]),function(ne,e,a,p,b,L,D,k,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let O=class Qt{constructor(m,T){this._fileSystemProvider=new Map,this._proxy=m.getProxy(a.MainContext.MainThreadFileSystem);const f=this;this.value=Object.freeze({async stat(h){try{const d=f._fileSystemProvider.get(h.scheme);if(!d)return await f._proxy.$stat(h);await f._proxy.$ensureActivation(h.scheme);const o=await d.stat(h);return{type:o.type,ctime:o.ctime,mtime:o.mtime,size:o.size,permissions:o.permissions}}catch(d){Qt._handleError(d)}},async readDirectory(h){try{const d=f._fileSystemProvider.get(h.scheme);return d?(await f._proxy.$ensureActivation(h.scheme),(await d.readDirectory(h)).slice()):await f._proxy.$readdir(h)}catch(d){return Qt._handleError(d)}},async createDirectory(h){try{return await f._proxy.$mkdir(h)}catch(d){return Qt._handleError(d)}},async readFile(h){try{const d=f._fileSystemProvider.get(h.scheme);return d?(await f._proxy.$ensureActivation(h.scheme),(await d.readFile(h)).slice()):(await f._proxy.$readFile(h)).buffer}catch(d){return Qt._handleError(d)}},async writeFile(h,d){try{return await f._proxy.$writeFile(h,L.VSBuffer.wrap(d))}catch(o){return Qt._handleError(o)}},async delete(h,d){try{const o=f._fileSystemProvider.get(h.scheme);return o?(await f._proxy.$ensureActivation(h.scheme),await o.delete(h,{recursive:!1,...d})):await f._proxy.$delete(h,{recursive:!1,useTrash:!1,...d})}catch(o){return Qt._handleError(o)}},async rename(h,d,o){try{return await f._proxy.$rename(h,d,{overwrite:!1,...o})}catch(v){return Qt._handleError(v)}},async copy(h,d,o){try{return await f._proxy.$copy(h,d,{overwrite:!1,...o})}catch(v){return Qt._handleError(v)}},isWritableFileSystem(h){const d=T.getCapabilities(h);if(typeof d=="number")return!(d&2048)}})}static _handleError(m){if(m instanceof b.FileSystemError)throw m;if(!(m instanceof Error))throw new b.FileSystemError(String(m));if(m.name==="ENOPRO")throw b.FileSystemError.Unavailable(m.message);switch(m.name){case p.FileSystemProviderErrorCode.FileExists:throw b.FileSystemError.FileExists(m.message);case p.FileSystemProviderErrorCode.FileNotFound:throw b.FileSystemError.FileNotFound(m.message);case p.FileSystemProviderErrorCode.FileNotADirectory:throw b.FileSystemError.FileNotADirectory(m.message);case p.FileSystemProviderErrorCode.FileIsADirectory:throw b.FileSystemError.FileIsADirectory(m.message);case p.FileSystemProviderErrorCode.NoPermissions:throw b.FileSystemError.NoPermissions(m.message);case p.FileSystemProviderErrorCode.Unavailable:throw b.FileSystemError.Unavailable(m.message);default:throw new b.FileSystemError(m.message,m.name)}}addFileSystemProvider(m,T){return this._fileSystemProvider.set(m,T),(0,P.toDisposable)(()=>this._fileSystemProvider.delete(m))}};O=ze([xe(0,k.IExtHostRpcService),xe(1,E.IExtHostFileSystemInfo)],O),e.ExtHostConsumerFileSystem=O,e.IExtHostConsumerFileSystem=(0,D.createDecorator)("IExtHostConsumerFileSystem")}),define(ye[199],De([1,0,5,34,2,4,8,6,24]),function(ne,e,a,p,b,L,D,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class P{constructor(m,T,f,h,d,o,v,R){this._onDidCreate=new a.Emitter,this._onDidChange=new a.Emitter,this._onDidDelete=new a.Emitter;const c=this.ensureWatching(m,f,d);this._config=0,o&&(this._config+=1),v&&(this._config+=2),R&&(this._config+=4);const w=(0,p.parse)(d),s=typeof d=="string",u=h(n=>{if(!o)for(const i of n.created){const r=b.URI.revive(i);w(r.fsPath)&&(!s||T.getWorkspaceFolder(r))&&this._onDidCreate.fire(r)}if(!v)for(const i of n.changed){const r=b.URI.revive(i);w(r.fsPath)&&(!s||T.getWorkspaceFolder(r))&&this._onDidChange.fire(r)}if(!R)for(const i of n.deleted){const r=b.URI.revive(i);w(r.fsPath)&&(!s||T.getWorkspaceFolder(r))&&this._onDidDelete.fire(r)}});this._disposable=k.Disposable.from(c,this._onDidCreate,this._onDidChange,this._onDidDelete,u)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(m,T,f){const h=k.Disposable.from();if(typeof f=="string")return h;const d=m.getProxy(L.MainContext.MainThreadFileSystem);let o=!1;(f.pattern.includes(p.GLOBSTAR)||f.pattern.includes(p.GLOB_SPLIT))&&(o=!0);const v=Math.random();return d.$watch(T.identifier.value,v,f.baseUri,{recursive:o,excludes:[]}),k.Disposable.from({dispose:()=>d.$unwatch(v)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class O{constructor(m,T,f){this._mainContext=m,this._logService=T,this._extHostDocumentsAndEditors=f,this._onFileSystemEvent=new a.Emitter,this._onDidRenameFile=new a.Emitter,this._onDidCreateFile=new a.Emitter,this._onDidDeleteFile=new a.Emitter,this._onWillRenameFile=new a.AsyncEmitter,this._onWillCreateFile=new a.AsyncEmitter,this._onWillDeleteFile=new a.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(m,T,f,h,d,o){return new P(this._mainContext,m,T,this._onFileSystemEvent.event,D.GlobPattern.from(f),h,d,o)}$onFileEvent(m){this._onFileSystemEvent.fire(m)}$onDidRunFileOperation(m,T){switch(m){case 2:this._onDidRenameFile.fire(Object.freeze({files:T.map(f=>({oldUri:b.URI.revive(f.source),newUri:b.URI.revive(f.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:T.map(f=>b.URI.revive(f.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:T.map(f=>b.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(m){return this._createWillExecuteEvent(m,this._onWillRenameFile)}getOnWillCreateFileEvent(m){return this._createWillExecuteEvent(m,this._onWillCreateFile)}getOnWillDeleteFileEvent(m){return this._createWillExecuteEvent(m,this._onWillDeleteFile)}_createWillExecuteEvent(m,T){return(f,h,d)=>{const o=function(R){f.call(h,R)};return o.extension=m,T.event(o,void 0,d)}}async $onWillRunFileOperation(m,T,f,h){switch(m){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:T.map(d=>({oldUri:b.URI.revive(d.source),newUri:b.URI.revive(d.target)}))},f,h);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:T.map(d=>b.URI.revive(d.target))},f,h);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:T.map(d=>b.URI.revive(d.target))},f,h)}}async _fireWillEvent(m,T,f,h){const d=new Set,o=[];if(await m.fireAsync(T,h,async(R,c)=>{const w=Date.now(),s=await Promise.resolve(R);s instanceof k.WorkspaceEdit&&(o.push([c.extension,s]),d.add(c.extension.displayName??c.extension.identifier.value)),Date.now()-w>f&&this._logService.warn("SLOW file-participant",c.extension.identifier)}),h.isCancellationRequested||o.length===0)return;const v={edits:[]};for(const[R,c]of o){const{edits:w}=D.WorkspaceEdit.from(c,{getTextDocumentVersion:s=>this._extHostDocumentsAndEditors.getDocument(s)?.version,getNotebookDocumentVersion:()=>{}},(0,E.isProposedApiEnabled)(R,"snippetWorkspaceEdit"));v.edits=v.edits.concat(w)}return{edit:v,extensionNames:Array.from(d)}}}e.ExtHostFileSystemEventService=O}),define(ye[200],De([1,0,2,36]),function(ne,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class b{constructor(D,k,E,P,O){this._extHostNotebooks=k,this._textDocumentsAndEditors=E,this._commands=P;const y=new p.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new p.ApiCommandArgument("showOptions","Show Options",m=>!0,m=>m),new p.ApiCommandArgument("resource","Interactive resource Uri",m=>!0,m=>m),new p.ApiCommandArgument("controllerId","Notebook controller Id",m=>!0,m=>m),new p.ApiCommandArgument("title","Interactive editor title",m=>!0,m=>m)],new p.ApiCommandResult("Notebook and input URI",m=>{if(O.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const T=this._extHostNotebooks.getEditorById(m.notebookEditorId);return O.debug("[ExtHostInteractive] notebook editor found",T.id),{notebookUri:a.URI.revive(m.notebookUri),inputUri:a.URI.revive(m.inputUri),notebookEditor:T.apiEditor}}return O.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:a.URI.revive(m.notebookUri),inputUri:a.URI.revive(m.inputUri)}}));this._commands.registerApiCommand(y)}$willAddInteractiveDocument(D,k,E,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:k,lines:[""],languageId:E,uri:D,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(a.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(D,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[D]})}}e.ExtHostInteractive=b}),define(ye[201],De([1,0,7,4]),function(ne,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class b{constructor(D){this._handlePool=0,this._proxy=D.getProxy(p.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(D){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,D),(0,a.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=b}),define(ye[202],De([1,0,2,26,8,6,66,4,9,48,16,10,244,20,7,77,73,61,203,11,14,24]),function(ne,e,a,p,b,L,D,k,E,P,O,y,m,T,f,h,d,o,v,R,c,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class s{constructor(I,B){this._documents=I,this._provider=B}async provideDocumentSymbols(I,B){const H=this._documents.getDocument(I),V=await this._provider.provideDocumentSymbols(H,B);if(!(0,O.isFalsyOrEmpty)(V))return V[0]instanceof L.DocumentSymbol?V.map(b.DocumentSymbol.from):s._asDocumentSymbolTree(V)}static _asDocumentSymbolTree(I){I=I.slice(0).sort((V,se)=>{let de=V.location.range.start.compareTo(se.location.range.start);return de===0&&(de=se.location.range.end.compareTo(V.location.range.end)),de});const B=[],H=[];for(const V of I){const se={name:V.name||"!!MISSING: name!!",kind:b.SymbolKind.from(V.kind),tags:V.tags?.map(b.SymbolTag.from)||[],detail:"",containerName:V.containerName,range:b.Range.from(V.location.range),selectionRange:b.Range.from(V.location.range),children:[]};for(;;){if(H.length===0){H.push(se),B.push(se);break}const de=H[H.length-1];if(P.Range.containsRange(de.range,se.range)&&!P.Range.equalsRange(de.range,se.range)){de.children?.push(se),H.push(se);break}H.pop()}}return B}}class u{constructor(I,B,H){this._documents=I,this._commands=B,this._provider=H,this._cache=new o.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(I,B){const H=this._documents.getDocument(I),V=await this._provider.provideCodeLenses(H,B);if(!V||B.isCancellationRequested)return;const se=this._cache.add(V),de=new f.DisposableStore;this._disposables.set(se,de);const J={cacheId:se,lenses:[]};for(let pe=0;pe<V.length;pe++)J.lenses.push({cacheId:[se,pe],range:b.Range.from(V[pe].range),command:this._commands.toInternal(V[pe].command,de)});return J}async resolveCodeLens(I,B){const H=I.cacheId&&this._cache.get(...I.cacheId);if(!H)return;let V;if(typeof this._provider.resolveCodeLens!="function"||H.isResolved?V=H:V=await this._provider.resolveCodeLens(H,B),V||(V=H),B.isCancellationRequested)return;const se=I.cacheId&&this._disposables.get(I.cacheId[0]);if(!!se)return I.command=this._commands.toInternal(V.command??u._badCmd,se),I}releaseCodeLenses(I){this._disposables.get(I)?.dispose(),this._disposables.delete(I),this._cache.delete(I)}}u._badCmd={command:"missing",title:"!!MISSING: command!!"};function n(Q){return Array.isArray(Q)?Q.map(b.DefinitionLink.from):Q?[b.DefinitionLink.from(Q)]:[]}class i{constructor(I,B){this._documents=I,this._provider=B}async provideDefinition(I,B,H){const V=this._documents.getDocument(I),se=b.Position.to(B),de=await this._provider.provideDefinition(V,se,H);return n(de)}}class r{constructor(I,B){this._documents=I,this._provider=B}async provideDeclaration(I,B,H){const V=this._documents.getDocument(I),se=b.Position.to(B),de=await this._provider.provideDeclaration(V,se,H);return n(de)}}class t{constructor(I,B){this._documents=I,this._provider=B}async provideImplementation(I,B,H){const V=this._documents.getDocument(I),se=b.Position.to(B),de=await this._provider.provideImplementation(V,se,H);return n(de)}}class l{constructor(I,B){this._documents=I,this._provider=B}async provideTypeDefinition(I,B,H){const V=this._documents.getDocument(I),se=b.Position.to(B),de=await this._provider.provideTypeDefinition(V,se,H);return n(de)}}class _{constructor(I,B){this._documents=I,this._provider=B}async provideHover(I,B,H){const V=this._documents.getDocument(I),se=b.Position.to(B),de=await this._provider.provideHover(V,se,H);if(!(!de||(0,O.isFalsyOrEmpty)(de.contents)))return de.range||(de.range=V.getWordRangeAtPosition(se)),de.range||(de.range=new L.Range(se,se)),b.Hover.from(de)}}class g{constructor(I,B){this._documents=I,this._provider=B}async provideEvaluatableExpression(I,B,H){const V=this._documents.getDocument(I),se=b.Position.to(B),de=await this._provider.provideEvaluatableExpression(V,se,H);if(de)return b.EvaluatableExpression.from(de)}}class C{constructor(I,B){this._documents=I,this._provider=B}async provideInlineValues(I,B,H,V){const se=this._documents.getDocument(I),de=await this._provider.provideInlineValues(se,b.Range.to(B),b.InlineValueContext.to(H),V);if(Array.isArray(de))return de.map(J=>b.InlineValue.from(J))}}class U{constructor(I,B){this._documents=I,this._provider=B}async provideDocumentHighlights(I,B,H){const V=this._documents.getDocument(I),se=b.Position.to(B),de=await this._provider.provideDocumentHighlights(V,se,H);if(Array.isArray(de))return de.map(b.DocumentHighlight.from)}}class W{constructor(I,B){this._documents=I,this._provider=B}async provideLinkedEditingRanges(I,B,H){const V=this._documents.getDocument(I),se=b.Position.to(B),de=await this._provider.provideLinkedEditingRanges(V,se,H);if(de&&Array.isArray(de.ranges))return{ranges:(0,O.coalesce)(de.ranges.map(b.Range.from)),wordPattern:de.wordPattern}}}class M{constructor(I,B){this._documents=I,this._provider=B}async provideReferences(I,B,H,V){const se=this._documents.getDocument(I),de=b.Position.to(B),J=await this._provider.provideReferences(se,de,H,V);if(Array.isArray(J))return J.map(b.location.from)}}class S{constructor(I,B,H,V,se,de,J){this._documents=I,this._commands=B,this._diagnostics=H,this._provider=V,this._logService=se,this._extension=de,this._apiDeprecation=J,this._cache=new o.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(I,B,H,V){const se=this._documents.getDocument(I),de=m.Selection.isISelection(B)?b.Selection.to(B):b.Range.to(B),J=[];for(const Ge of this._diagnostics.getDiagnostics(I))if(de.intersection(Ge.range)&&J.push(Ge)>S._maxCodeActionsPerFile)break;const pe={diagnostics:J,only:H.only?new L.CodeActionKind(H.only):void 0,triggerKind:b.CodeActionTriggerKind.to(H.trigger)},ge=await this._provider.provideCodeActions(se,de,pe,V);if(!(0,O.isNonEmptyArray)(ge)||V.isCancellationRequested)return;const Ne=this._cache.add(ge),Be=new f.DisposableStore;this._disposables.set(Ne,Be);const Je=[];for(let Ge=0;Ge<ge.length;Ge++){const Te=ge[Ge];!Te||(S._isCommand(Te)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Je.push({_isSynthetic:!0,title:Te.title,command:this._commands.toInternal(Te,Be)})):(pe.only&&(Te.kind?pe.only.contains(Te.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action is of kind '${Te.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Je.push({cacheId:[Ne,Ge],title:Te.title,command:Te.command&&this._commands.toInternal(Te.command,Be),diagnostics:Te.diagnostics&&Te.diagnostics.map(b.Diagnostic.from),edit:Te.edit&&b.WorkspaceEdit.from(Te.edit,void 0,(0,w.isProposedApiEnabled)(this._extension,"snippetWorkspaceEdit")),kind:Te.kind&&Te.kind.value,isPreferred:Te.isPreferred,disabled:Te.disabled?.reason})))}return{cacheId:Ne,actions:Je}}async resolveCodeAction(I,B){const[H,V]=I,se=this._cache.get(H,V);if(!se||S._isCommand(se)||!this._provider.resolveCodeAction)return;const de=await this._provider.resolveCodeAction(se,B)??se;return de?.edit?b.WorkspaceEdit.from(de.edit,void 0,(0,w.isProposedApiEnabled)(this._extension,"snippetWorkspaceEdit")):void 0}releaseCodeActions(I){this._disposables.get(I)?.dispose(),this._disposables.delete(I),this._cache.delete(I)}static _isCommand(I){return typeof I.command=="string"&&typeof I.title=="string"}}S._maxCodeActionsPerFile=1e3;class z{constructor(I,B,H,V){this._proxy=I,this._documents=B,this._provider=H,this._handle=V}async prepareDocumentPaste(I,B,H,V){if(!this._provider.prepareDocumentPaste)return;const se=this._documents.getDocument(I),de=B.map(pe=>b.Range.to(pe)),J=b.DataTransfer.toDataTransfer(H,()=>{throw new R.NotImplementedError});return await this._provider.prepareDocumentPaste(se,de,J,V),b.DataTransfer.toDataTransferDTO(J)}async providePasteEdits(I,B,H,V,se){const de=this._documents.getDocument(B),J=H.map(Ne=>b.Range.to(Ne)),pe=b.DataTransfer.toDataTransfer(V,async Ne=>(await this._proxy.$resolvePasteFileData(this._handle,I,Ne)).buffer),ge=await this._provider.provideDocumentPasteEdits(de,J,pe,se);if(!!ge)return{insertText:typeof ge.insertText=="string"?ge.insertText:{snippet:ge.insertText.value},additionalEdit:ge.additionalEdit?b.WorkspaceEdit.from(ge.additionalEdit,void 0,!0):void 0}}}class ${constructor(I,B){this._documents=I,this._provider=B}async provideDocumentFormattingEdits(I,B,H){const V=this._documents.getDocument(I),se=await this._provider.provideDocumentFormattingEdits(V,B,H);if(Array.isArray(se))return se.map(b.TextEdit.from)}}class F{constructor(I,B){this._documents=I,this._provider=B}async provideDocumentRangeFormattingEdits(I,B,H,V){const se=this._documents.getDocument(I),de=b.Range.to(B),J=await this._provider.provideDocumentRangeFormattingEdits(se,de,H,V);if(Array.isArray(J))return J.map(b.TextEdit.from)}}class q{constructor(I,B){this._documents=I,this._provider=B,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(I,B,H,V,se){const de=this._documents.getDocument(I),J=b.Position.to(B),pe=await this._provider.provideOnTypeFormattingEdits(de,J,H,V,se);if(Array.isArray(pe))return pe.map(b.TextEdit.from)}}class ie{constructor(I,B){this._provider=I,this._logService=B,this._cache=new o.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(I,B){const H=await this._provider.provideWorkspaceSymbols(I,B);if(!(0,O.isNonEmptyArray)(H))return{symbols:[]};const V=this._cache.add(H),se={cacheId:V,symbols:[]};for(let de=0;de<H.length;de++){const J=H[de];if(!J||!J.name){this._logService.warn("INVALID SymbolInformation",J);continue}se.symbols.push({...b.WorkspaceSymbol.from(J),cacheId:[V,de]})}return se}async resolveWorkspaceSymbol(I,B){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!I.cacheId)return I;const H=this._cache.get(...I.cacheId);if(H){const V=await this._provider.resolveWorkspaceSymbol(H,B);return V&&(0,p.mixin)(I,b.WorkspaceSymbol.from(V),!0)}}releaseWorkspaceSymbols(I){this._cache.delete(I)}}class A{constructor(I,B,H){this._documents=I,this._provider=B,this._logService=H}static supportsResolving(I){return typeof I.prepareRename=="function"}async provideRenameEdits(I,B,H,V){const se=this._documents.getDocument(I),de=b.Position.to(B);try{const J=await this._provider.provideRenameEdits(se,de,H,V);return J?b.WorkspaceEdit.from(J):void 0}catch(J){const pe=A._asMessage(J);return pe?{rejectReason:pe,edits:void 0}:Promise.reject(J)}}async resolveRenameLocation(I,B,H){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const V=this._documents.getDocument(I),se=b.Position.to(B);try{const de=await this._provider.prepareRename(V,se,H);let J,pe;if(L.Range.isRange(de)?(J=de,pe=V.getText(de)):(0,y.isObject)(de)&&(J=de.range,pe=de.placeholder),!J||!pe)return;if(J.start.line>se.line||J.end.line<se.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:b.Range.from(J),text:pe}}catch(de){const J=A._asMessage(de);return J?{rejectReason:J,range:void 0,text:void 0}:Promise.reject(de)}}static _asMessage(I){return typeof I=="string"?I:I instanceof Error&&typeof I.message=="string"?I.message:void 0}}class Z{constructor(I,B){this.resultId=I,this.tokens=B}}class ce{constructor(I,B){this._documents=I,this._provider=B,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(I,B,H){const V=this._documents.getDocument(I),se=B!==0?this._previousResults.get(B):null;let de=typeof se?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(V,se.resultId,H):await this._provider.provideDocumentSemanticTokens(V,H);return se&&this._previousResults.delete(B),de?(de=ce._fixProvidedSemanticTokens(de),this._send(ce._convertToEdits(se,de),de)):null}async releaseDocumentSemanticColoring(I){this._previousResults.delete(I)}static _fixProvidedSemanticTokens(I){return ce._isSemanticTokens(I)?ce._isCorrectSemanticTokens(I)?I:new L.SemanticTokens(new Uint32Array(I.data),I.resultId):ce._isSemanticTokensEdits(I)?ce._isCorrectSemanticTokensEdits(I)?I:new L.SemanticTokensEdits(I.edits.map(B=>new L.SemanticTokensEdit(B.start,B.deleteCount,B.data?new Uint32Array(B.data):B.data)),I.resultId):I}static _isSemanticTokens(I){return I&&!!I.data}static _isCorrectSemanticTokens(I){return I.data instanceof Uint32Array}static _isSemanticTokensEdits(I){return I&&Array.isArray(I.edits)}static _isCorrectSemanticTokensEdits(I){for(const B of I.edits)if(!(B.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(I,B){if(!ce._isSemanticTokens(B)||!I||!I.tokens)return B;const H=I.tokens,V=H.length,se=B.data,de=se.length;let J=0;const pe=Math.min(V,de);for(;J<pe&&H[J]===se[J];)J++;if(J===V&&J===de)return new L.SemanticTokensEdits([],B.resultId);let ge=0;const Ne=pe-J;for(;ge<Ne&&H[V-ge-1]===se[de-ge-1];)ge++;return new L.SemanticTokensEdits([{start:J,deleteCount:V-J-ge,data:se.subarray(J,de-ge)}],B.resultId)}_send(I,B){if(ce._isSemanticTokens(I)){const H=this._nextResultId++;return this._previousResults.set(H,new Z(I.resultId,I.data)),(0,h.encodeSemanticTokensDto)({id:H,type:"full",data:I.data})}if(ce._isSemanticTokensEdits(I)){const H=this._nextResultId++;return ce._isSemanticTokens(B)?this._previousResults.set(H,new Z(B.resultId,B.data)):this._previousResults.set(H,new Z(I.resultId)),(0,h.encodeSemanticTokensDto)({id:H,type:"delta",deltas:(I.edits||[]).map(V=>({start:V.start,deleteCount:V.deleteCount,data:V.data}))})}return null}}e.DocumentSemanticTokensAdapter=ce;class oe{constructor(I,B){this._documents=I,this._provider=B}async provideDocumentRangeSemanticTokens(I,B,H){const V=this._documents.getDocument(I),se=await this._provider.provideDocumentRangeSemanticTokens(V,b.Range.to(B),H);return se?this._send(se):null}_send(I){return(0,h.encodeSemanticTokensDto)({id:0,type:"full",data:I.data})}}e.DocumentRangeSemanticTokensAdapter=oe;class ue{constructor(I,B,H,V,se){this._documents=I,this._commands=B,this._provider=H,this._apiDeprecation=V,this._extension=se,this._cache=new o.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(I){return typeof I.resolveCompletionItem=="function"}async provideCompletionItems(I,B,H,V){const se=this._documents.getDocument(I),de=b.Position.to(B),J=se.getWordRangeAtPosition(de)||new L.Range(de,de),pe=J.with({end:de}),ge=new v.StopWatch(!0),Ne=await this._provider.provideCompletionItems(se,de,V,b.CompletionContext.to(H));if(!Ne||V.isCancellationRequested)return;const Be=Array.isArray(Ne)?new L.CompletionList(Ne):Ne,Je=ue.supportsResolving(this._provider)?this._cache.add(Be.items):this._cache.add([]),Ge=new f.DisposableStore;this._disposables.set(Je,Ge);const Te=[],rt={x:Je,b:Te,a:{replace:b.Range.from(J),insert:b.Range.from(pe)},c:Be.isIncomplete||void 0,d:ge.elapsed()};for(let K=0;K<Be.items.length;K++){const X=Be.items[K],fe=this._convertCompletionItem(X,[Je,K],pe,J);Te.push(fe)}return rt}async resolveCompletionItem(I,B){if(typeof this._provider.resolveCompletionItem!="function")return;const H=this._cache.get(...I);if(!H)return;const V=await this._provider.resolveCompletionItem(H,B);if(!!V)return this._convertCompletionItem(V,I)}releaseCompletionItems(I){this._disposables.get(I)?.dispose(),this._disposables.delete(I),this._cache.delete(I)}_convertCompletionItem(I,B,H,V){const se=this._disposables.get(B[0]);if(!se)throw Error("DisposableStore is missing...");const de={x:B,a:I.label,b:I.kind!==void 0?b.CompletionItemKind.from(I.kind):void 0,n:I.tags&&I.tags.map(b.CompletionItemTag.from),c:I.detail,d:typeof I.documentation=="undefined"?void 0:b.MarkdownString.fromStrict(I.documentation),e:I.sortText!==I.label?I.sortText:void 0,f:I.filterText!==I.label?I.filterText:void 0,g:I.preselect||void 0,i:I.keepWhitespace?1:0,k:I.commitCharacters,l:I.additionalTextEdits&&I.additionalTextEdits.map(b.TextEdit.from),m:this._commands.toInternal(I.command,se)};I.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),de.h=I.textEdit.newText):typeof I.insertText=="string"?de.h=I.insertText:I.insertText instanceof L.SnippetString&&(de.h=I.insertText.value,de.i|=4);let J;return I.textEdit?J=I.textEdit.range:I.range&&(J=I.range),L.Range.isRange(J)?de.j=b.Range.from(J):J&&(!H?.isEqual(J.inserting)||!V?.isEqual(J.replacing))&&(de.j={insert:b.Range.from(J.inserting),replace:b.Range.from(J.replacing)}),de}}class te{async provideInlineCompletions(I,B,H,V){}disposeCompletions(I){}handleDidShowCompletionItem(I,B){}}class Ee extends te{constructor(I,B,H,V){super();this._extension=I,this._documents=B,this._provider=H,this._commands=V,this._references=new ee,this._isAdditionsProposedApiEnabled=(0,w.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[D.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[D.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,w.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(I,B,H,V){const se=this._documents.getDocument(I),de=b.Position.to(B),J=await this._provider.provideInlineCompletionItems(se,de,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:b.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[H.triggerKind]},V);if(!J||V.isCancellationRequested)return;const pe=Array.isArray(J)?J:J.items,ge=this._isAdditionsProposedApiEnabled?Array.isArray(J)?[]:J.commands||[]:[];let Ne;return{pid:this._references.createReferenceId({dispose(){Ne?.dispose()},items:pe}),items:pe.map((Je,Ge)=>{let Te;Je.command&&(Ne||(Ne=new f.DisposableStore),Te=this._commands.toInternal(Je.command,Ne));const rt=Je.insertText;return{insertText:typeof rt=="string"?rt:{snippet:rt.value},filterText:Je.filterText,range:Je.range?b.Range.from(Je.range):void 0,command:Te,idx:Ge,completeBracketPairs:this._isAdditionsProposedApiEnabled?Je.completeBracketPairs:!1}}),commands:ge.map(Je=>(Ne||(Ne=new f.DisposableStore),this._commands.toInternal(Je,Ne)))}}disposeCompletions(I){this._references.disposeReferenceId(I)?.dispose()}handleDidShowCompletionItem(I,B){const H=this._references.get(I)?.items[B];H&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(H)}}class be extends te{constructor(I,B,H,V){super();this.extension=I,this._documents=B,this._provider=H,this._commands=V,this._references=new ee,this.isAdditionProposedApiEnabled=(0,w.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[D.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKindNew.Automatic,[D.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(I,B,H,V){const se=this._documents.getDocument(I),de=b.Position.to(B),J=await this._provider.provideInlineCompletionItems(se,de,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:b.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[H.triggerKind]},V);if(!J||V.isCancellationRequested)return;const pe=Array.isArray(J)?J:J.items,ge=Array.isArray(J)?[]:J.commands||[];let Ne;return{pid:this._references.createReferenceId({dispose(){Ne?.dispose()},items:pe}),items:pe.map((Je,Ge)=>{let Te;Je.command&&(Ne||(Ne=new f.DisposableStore),Te=this._commands.toInternal(Je.command,Ne));const rt=Je.insertText;return{insertText:typeof rt=="string"?rt:{snippet:rt.value},filterText:Je.filterText,range:Je.range?b.Range.from(Je.range):void 0,command:Te,idx:Ge,completeBracketPairs:this.isAdditionProposedApiEnabled?Je.completeBracketPairs:!1}}),commands:ge.map(Je=>(Ne||(Ne=new f.DisposableStore),this._commands.toInternal(Je,Ne)))}}disposeCompletions(I){this._references.disposeReferenceId(I)?.dispose()}handleDidShowCompletionItem(I,B){const H=this._references.get(I)?.items[B];H&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(H)}}class ee{constructor(){this._references=new Map,this._idPool=1}createReferenceId(I){const B=this._idPool++;return this._references.set(B,I),B}disposeReferenceId(I){const B=this._references.get(I);return this._references.delete(I),B}get(I){return this._references.get(I)}}class ve{constructor(I,B){this._documents=I,this._provider=B,this._cache=new o.Cache("SignatureHelp")}async provideSignatureHelp(I,B,H,V){const se=this._documents.getDocument(I),de=b.Position.to(B),J=this.reviveContext(H),pe=await this._provider.provideSignatureHelp(se,de,V,J);if(pe){const ge=this._cache.add([pe]);return{...b.SignatureHelp.from(pe),id:ge}}}reviveContext(I){let B;if(I.activeSignatureHelp){const H=b.SignatureHelp.to(I.activeSignatureHelp),V=this._cache.get(I.activeSignatureHelp.id,0);V?(B=V,B.activeSignature=H.activeSignature,B.activeParameter=H.activeParameter):B=H}return{...I,activeSignatureHelp:B}}releaseSignatureHelp(I){this._cache.delete(I)}}class Ae{constructor(I,B,H,V,se){this._documents=I,this._commands=B,this._provider=H,this._logService=V,this._extension=se,this._cache=new o.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(I,B,H){const V=this._documents.getDocument(I),se=b.Range.to(B),de=await this._provider.provideInlayHints(V,se,H);if(!Array.isArray(de)||de.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${B}`);return}if(H.isCancellationRequested)return;const J=this._cache.add(de);this._disposables.set(J,new f.DisposableStore);const pe={hints:[],cacheId:J};for(let ge=0;ge<de.length;ge++)this._isValidInlayHint(de[ge],se)&&pe.hints.push(this._convertInlayHint(de[ge],[J,ge]));return this._logService.trace(`[InlayHints] ${pe.hints.length} inlay hints from '${this._extension.identifier.value}' for ${B}`),pe}async resolveInlayHint(I,B){if(typeof this._provider.resolveInlayHint!="function")return;const H=this._cache.get(...I);if(!H)return;const V=await this._provider.resolveInlayHint(H,B);if(!!V&&!!this._isValidInlayHint(V))return this._convertInlayHint(V,I)}releaseHints(I){this._disposables.get(I)?.dispose(),this._disposables.delete(I),this._cache.delete(I)}_isValidInlayHint(I,B){return I.label.length===0||Array.isArray(I.label)&&I.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",I),!1):!(B&&!B.contains(I.position))}_convertInlayHint(I,B){const H=this._disposables.get(B[0]);if(!H)throw Error("DisposableStore is missing...");const V={label:"",cacheId:B,tooltip:b.MarkdownString.fromStrict(I.tooltip),position:b.Position.from(I.position),textEdits:I.textEdits&&I.textEdits.map(b.TextEdit.from),kind:I.kind&&b.InlayHintKind.from(I.kind),paddingLeft:I.paddingLeft,paddingRight:I.paddingRight};return typeof I.label=="string"?V.label=I.label:V.label=I.label.map(se=>{const de={label:se.value};return de.tooltip=b.MarkdownString.fromStrict(se.tooltip),L.Location.isLocation(se.location)&&(de.location=b.location.from(se.location)),se.command&&(de.command=this._commands.toInternal(se.command,H)),de}),V}}class Fe{constructor(I,B){this._documents=I,this._provider=B,this._cache=new o.Cache("DocumentLink")}async provideLinks(I,B){const H=this._documents.getDocument(I),V=await this._provider.provideDocumentLinks(H,B);if(!(!Array.isArray(V)||V.length===0)&&!B.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:V.filter(Fe._validateLink).map(b.DocumentLink.from)};{const se=this._cache.add(V),de={links:[],cacheId:se};for(let J=0;J<V.length;J++){if(!Fe._validateLink(V[J]))continue;const pe=b.DocumentLink.from(V[J]);pe.cacheId=[se,J],de.links.push(pe)}return de}}}static _validateLink(I){return I.target&&I.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(I,B){if(typeof this._provider.resolveDocumentLink!="function")return;const H=this._cache.get(...I);if(!H)return;const V=await this._provider.resolveDocumentLink(H,B);if(!(!V||!Fe._validateLink(V)))return b.DocumentLink.from(V)}releaseLinks(I){this._cache.delete(I)}}class $e{constructor(I,B){this._documents=I,this._provider=B}async provideColors(I,B){const H=this._documents.getDocument(I),V=await this._provider.provideDocumentColors(H,B);return Array.isArray(V)?V.map(de=>({color:b.Color.from(de.color),range:b.Range.from(de.range)})):[]}async provideColorPresentations(I,B,H){const V=this._documents.getDocument(I),se=b.Range.to(B.range),de=b.Color.to(B.color),J=await this._provider.provideColorPresentations(de,{document:V,range:se},H);if(!!Array.isArray(J))return J.map(b.ColorPresentation.from)}}class Qe{constructor(I,B){this._documents=I,this._provider=B}async provideFoldingRanges(I,B,H){const V=this._documents.getDocument(I),se=await this._provider.provideFoldingRanges(V,B,H);if(!!Array.isArray(se))return se.map(b.FoldingRange.from)}}class Ie{constructor(I,B,H){this._documents=I,this._provider=B,this._logService=H}async provideSelectionRanges(I,B,H){const V=this._documents.getDocument(I),se=B.map(b.Position.to),de=await this._provider.provideSelectionRanges(V,se,H);if(!(0,O.isNonEmptyArray)(de))return[];if(de.length!==se.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const J=[];for(let pe=0;pe<se.length;pe++){const ge=[];J.push(ge);let Ne=se[pe],Be=de[pe];for(;;){if(!Be.range.contains(Ne))throw new Error("INVALID selection range, must contain the previous range");if(ge.push(b.SelectionRange.from(Be)),!Be.parent)break;Ne=Be.range,Be=Be.parent}}return J}}class Se{constructor(I,B){this._documents=I,this._provider=B,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(I,B,H){const V=this._documents.getDocument(I),se=b.Position.to(B),de=await this._provider.prepareCallHierarchy(V,se,H);if(!de)return;const J=this._idPool.nextId();return this._cache.set(J,new Map),Array.isArray(de)?de.map(pe=>this._cacheAndConvertItem(J,pe)):[this._cacheAndConvertItem(J,de)]}async provideCallsTo(I,B,H){const V=this._itemFromCache(I,B);if(!V)throw new Error("missing call hierarchy item");const se=await this._provider.provideCallHierarchyIncomingCalls(V,H);if(!!se)return se.map(de=>({from:this._cacheAndConvertItem(I,de.from),fromRanges:de.fromRanges.map(J=>b.Range.from(J))}))}async provideCallsFrom(I,B,H){const V=this._itemFromCache(I,B);if(!V)throw new Error("missing call hierarchy item");const se=await this._provider.provideCallHierarchyOutgoingCalls(V,H);if(!!se)return se.map(de=>({to:this._cacheAndConvertItem(I,de.to),fromRanges:de.fromRanges.map(J=>b.Range.from(J))}))}releaseSession(I){this._cache.delete(I)}_cacheAndConvertItem(I,B){const H=this._cache.get(I),V=b.CallHierarchyItem.from(B,I,H.size.toString(36));return H.set(V._itemId,B),V}_itemFromCache(I,B){return this._cache.get(I)?.get(B)}}class ke{constructor(I,B){this._documents=I,this._provider=B,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(I,B,H){const V=this._documents.getDocument(I),se=b.Position.to(B),de=await this._provider.prepareTypeHierarchy(V,se,H);if(!de)return;const J=this._idPool.nextId();return this._cache.set(J,new Map),Array.isArray(de)?de.map(pe=>this._cacheAndConvertItem(J,pe)):[this._cacheAndConvertItem(J,de)]}async provideSupertypes(I,B,H){const V=this._itemFromCache(I,B);if(!V)throw new Error("missing type hierarchy item");const se=await this._provider.provideTypeHierarchySupertypes(V,H);if(!!se)return se.map(de=>this._cacheAndConvertItem(I,de))}async provideSubtypes(I,B,H){const V=this._itemFromCache(I,B);if(!V)throw new Error("missing type hierarchy item");const se=await this._provider.provideTypeHierarchySubtypes(V,H);if(!!se)return se.map(de=>this._cacheAndConvertItem(I,de))}releaseSession(I){this._cache.delete(I)}_cacheAndConvertItem(I,B){const H=this._cache.get(I),V=b.TypeHierarchyItem.from(B,I,H.size.toString(36));return H.set(V._itemId,B),V}_itemFromCache(I,B){return this._cache.get(I)?.get(B)}}class ae{constructor(I,B,H,V){this._proxy=I,this._documents=B,this._provider=H,this._handle=V}async provideDocumentOnDropEdits(I,B,H,V,se){const de=this._documents.getDocument(B),J=b.Position.to(H),pe=b.DataTransfer.toDataTransfer(V,async Ne=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,I,Ne)).buffer),ge=await this._provider.provideDocumentDropEdits(de,J,pe,se);if(!!ge)return{insertText:typeof ge.insertText=="string"?ge.insertText:{snippet:ge.insertText.value},additionalEdit:ge.additionalEdit?b.WorkspaceEdit.from(ge.additionalEdit,void 0,!0):void 0}}}class le{constructor(I,B){this.adapter=I,this.extension=B}}class G{constructor(I,B,H,V,se,de,J){this._adapter=new Map,this._uriTransformer=B,this._proxy=I.getProxy(k.MainContext.MainThreadLanguageFeatures),this._documents=H,this._commands=V,this._diagnostics=se,this._logService=de,this._apiDeprecation=J}_transformDocumentSelector(I){return b.DocumentSelector.from(I,this._uriTransformer)}_createDisposable(I){return new L.Disposable(()=>{this._adapter.delete(I),this._proxy.$unregister(I)})}_nextHandle(){return G._handlePool++}async _withAdapter(I,B,H,V,se,de=!1){const J=this._adapter.get(I);if(!J||!(J.adapter instanceof B))return V;const pe=Date.now();de||this._logService.trace(`[${J.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const ge=H(J.adapter,J.extension);return Promise.resolve(ge).catch(Ne=>{(0,R.isCancellationError)(Ne)||(this._logService.error(`[${J.extension.identifier.value}] provider FAILED`),this._logService.error(Ne))}).finally(()=>{de||this._logService.trace(`[${J.extension.identifier.value}] provider DONE after ${Date.now()-pe}ms`)}),T.CancellationToken.isCancellationToken(se)?(0,c.raceCancellationError)(ge,se):ge}_addNewAdapter(I,B){const H=this._nextHandle();return this._adapter.set(H,new le(I,B)),H}static _extLabel(I){return I.displayName||I.name}registerDocumentSymbolProvider(I,B,H,V){const se=this._addNewAdapter(new s(this._documents,H),I),de=V&&V.label||G._extLabel(I);return this._proxy.$registerDocumentSymbolProvider(se,this._transformDocumentSelector(B),de),this._createDisposable(se)}$provideDocumentSymbols(I,B,H){return this._withAdapter(I,s,V=>V.provideDocumentSymbols(a.URI.revive(B),H),void 0,H)}registerCodeLensProvider(I,B,H){const V=this._nextHandle(),se=typeof H.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(V,new le(new u(this._documents,this._commands.converter,H),I)),this._proxy.$registerCodeLensSupport(V,this._transformDocumentSelector(B),se);let de=this._createDisposable(V);if(se!==void 0){const J=H.onDidChangeCodeLenses(pe=>this._proxy.$emitCodeLensEvent(se));de=L.Disposable.from(de,J)}return de}$provideCodeLenses(I,B,H){return this._withAdapter(I,u,V=>V.provideCodeLenses(a.URI.revive(B),H),void 0,H)}$resolveCodeLens(I,B,H){return this._withAdapter(I,u,V=>V.resolveCodeLens(B,H),void 0,void 0)}$releaseCodeLenses(I,B){this._withAdapter(I,u,H=>Promise.resolve(H.releaseCodeLenses(B)),void 0,void 0)}registerDefinitionProvider(I,B,H){const V=this._addNewAdapter(new i(this._documents,H),I);return this._proxy.$registerDefinitionSupport(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideDefinition(I,B,H,V){return this._withAdapter(I,i,se=>se.provideDefinition(a.URI.revive(B),H,V),[],V)}registerDeclarationProvider(I,B,H){const V=this._addNewAdapter(new r(this._documents,H),I);return this._proxy.$registerDeclarationSupport(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideDeclaration(I,B,H,V){return this._withAdapter(I,r,se=>se.provideDeclaration(a.URI.revive(B),H,V),[],V)}registerImplementationProvider(I,B,H){const V=this._addNewAdapter(new t(this._documents,H),I);return this._proxy.$registerImplementationSupport(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideImplementation(I,B,H,V){return this._withAdapter(I,t,se=>se.provideImplementation(a.URI.revive(B),H,V),[],V)}registerTypeDefinitionProvider(I,B,H){const V=this._addNewAdapter(new l(this._documents,H),I);return this._proxy.$registerTypeDefinitionSupport(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideTypeDefinition(I,B,H,V){return this._withAdapter(I,l,se=>se.provideTypeDefinition(a.URI.revive(B),H,V),[],V)}registerHoverProvider(I,B,H,V){const se=this._addNewAdapter(new _(this._documents,H),I);return this._proxy.$registerHoverProvider(se,this._transformDocumentSelector(B)),this._createDisposable(se)}$provideHover(I,B,H,V){return this._withAdapter(I,_,se=>se.provideHover(a.URI.revive(B),H,V),void 0,V)}registerEvaluatableExpressionProvider(I,B,H,V){const se=this._addNewAdapter(new g(this._documents,H),I);return this._proxy.$registerEvaluatableExpressionProvider(se,this._transformDocumentSelector(B)),this._createDisposable(se)}$provideEvaluatableExpression(I,B,H,V){return this._withAdapter(I,g,se=>se.provideEvaluatableExpression(a.URI.revive(B),H,V),void 0,V)}registerInlineValuesProvider(I,B,H,V){const se=typeof H.onDidChangeInlineValues=="function"?this._nextHandle():void 0,de=this._addNewAdapter(new C(this._documents,H),I);this._proxy.$registerInlineValuesProvider(de,this._transformDocumentSelector(B),se);let J=this._createDisposable(de);if(se!==void 0){const pe=H.onDidChangeInlineValues(ge=>this._proxy.$emitInlineValuesEvent(se));J=L.Disposable.from(J,pe)}return J}$provideInlineValues(I,B,H,V,se){return this._withAdapter(I,C,de=>de.provideInlineValues(a.URI.revive(B),H,V,se),void 0,se)}registerDocumentHighlightProvider(I,B,H){const V=this._addNewAdapter(new U(this._documents,H),I);return this._proxy.$registerDocumentHighlightProvider(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideDocumentHighlights(I,B,H,V){return this._withAdapter(I,U,se=>se.provideDocumentHighlights(a.URI.revive(B),H,V),void 0,V)}registerLinkedEditingRangeProvider(I,B,H){const V=this._addNewAdapter(new W(this._documents,H),I);return this._proxy.$registerLinkedEditingRangeProvider(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideLinkedEditingRanges(I,B,H,V){return this._withAdapter(I,W,async se=>{const de=await se.provideLinkedEditingRanges(a.URI.revive(B),H,V);if(de)return{ranges:de.ranges,wordPattern:de.wordPattern?G._serializeRegExp(de.wordPattern):void 0}},void 0,V)}registerReferenceProvider(I,B,H){const V=this._addNewAdapter(new M(this._documents,H),I);return this._proxy.$registerReferenceSupport(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideReferences(I,B,H,V,se){return this._withAdapter(I,M,de=>de.provideReferences(a.URI.revive(B),H,V,se),void 0,se)}registerCodeActionProvider(I,B,H,V){const se=new f.DisposableStore,de=this._addNewAdapter(new S(this._documents,this._commands.converter,this._diagnostics,H,this._logService,I,this._apiDeprecation),I);return this._proxy.$registerQuickFixSupport(de,this._transformDocumentSelector(B),{providedKinds:V?.providedCodeActionKinds?.map(J=>J.value),documentation:V?.documentation?.map(J=>({kind:J.kind.value,command:this._commands.converter.toInternal(J.command,se)}))},G._extLabel(I),Boolean(H.resolveCodeAction)),se.add(this._createDisposable(de)),se}$provideCodeActions(I,B,H,V,se){return this._withAdapter(I,S,de=>de.provideCodeActions(a.URI.revive(B),H,V,se),void 0,se)}$resolveCodeAction(I,B,H){return this._withAdapter(I,S,V=>V.resolveCodeAction(B,H),void 0,void 0)}$releaseCodeActions(I,B){this._withAdapter(I,S,H=>Promise.resolve(H.releaseCodeActions(B)),void 0,void 0)}registerDocumentFormattingEditProvider(I,B,H){const V=this._addNewAdapter(new $(this._documents,H),I);return this._proxy.$registerDocumentFormattingSupport(V,this._transformDocumentSelector(B),I.identifier,I.displayName||I.name),this._createDisposable(V)}$provideDocumentFormattingEdits(I,B,H,V){return this._withAdapter(I,$,se=>se.provideDocumentFormattingEdits(a.URI.revive(B),H,V),void 0,V)}registerDocumentRangeFormattingEditProvider(I,B,H){const V=this._addNewAdapter(new F(this._documents,H),I);return this._proxy.$registerRangeFormattingSupport(V,this._transformDocumentSelector(B),I.identifier,I.displayName||I.name),this._createDisposable(V)}$provideDocumentRangeFormattingEdits(I,B,H,V,se){return this._withAdapter(I,F,de=>de.provideDocumentRangeFormattingEdits(a.URI.revive(B),H,V,se),void 0,se)}registerOnTypeFormattingEditProvider(I,B,H,V){const se=this._addNewAdapter(new q(this._documents,H),I);return this._proxy.$registerOnTypeFormattingSupport(se,this._transformDocumentSelector(B),V,I.identifier),this._createDisposable(se)}$provideOnTypeFormattingEdits(I,B,H,V,se,de){return this._withAdapter(I,q,J=>J.provideOnTypeFormattingEdits(a.URI.revive(B),H,V,se,de),void 0,de)}registerWorkspaceSymbolProvider(I,B){const H=this._addNewAdapter(new ie(B,this._logService),I);return this._proxy.$registerNavigateTypeSupport(H,typeof B.resolveWorkspaceSymbol=="function"),this._createDisposable(H)}$provideWorkspaceSymbols(I,B,H){return this._withAdapter(I,ie,V=>V.provideWorkspaceSymbols(B,H),{symbols:[]},H)}$resolveWorkspaceSymbol(I,B,H){return this._withAdapter(I,ie,V=>V.resolveWorkspaceSymbol(B,H),void 0,void 0)}$releaseWorkspaceSymbols(I,B){this._withAdapter(I,ie,H=>H.releaseWorkspaceSymbols(B),void 0,void 0)}registerRenameProvider(I,B,H){const V=this._addNewAdapter(new A(this._documents,H,this._logService),I);return this._proxy.$registerRenameSupport(V,this._transformDocumentSelector(B),A.supportsResolving(H)),this._createDisposable(V)}$provideRenameEdits(I,B,H,V,se){return this._withAdapter(I,A,de=>de.provideRenameEdits(a.URI.revive(B),H,V,se),void 0,se)}$resolveRenameLocation(I,B,H,V){return this._withAdapter(I,A,se=>se.resolveRenameLocation(a.URI.revive(B),H,V),void 0,V)}registerDocumentSemanticTokensProvider(I,B,H,V){const se=this._addNewAdapter(new ce(this._documents,H),I),de=typeof H.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(se,this._transformDocumentSelector(B),V,de);let J=this._createDisposable(se);if(de){const pe=H.onDidChangeSemanticTokens(ge=>this._proxy.$emitDocumentSemanticTokensEvent(de));J=L.Disposable.from(J,pe)}return J}$provideDocumentSemanticTokens(I,B,H,V){return this._withAdapter(I,ce,se=>se.provideDocumentSemanticTokens(a.URI.revive(B),H,V),null,V)}$releaseDocumentSemanticTokens(I,B){this._withAdapter(I,ce,H=>H.releaseDocumentSemanticColoring(B),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(I,B,H,V){const se=this._addNewAdapter(new oe(this._documents,H),I);return this._proxy.$registerDocumentRangeSemanticTokensProvider(se,this._transformDocumentSelector(B),V),this._createDisposable(se)}$provideDocumentRangeSemanticTokens(I,B,H,V){return this._withAdapter(I,oe,se=>se.provideDocumentRangeSemanticTokens(a.URI.revive(B),H,V),null,V)}registerCompletionItemProvider(I,B,H,V){const se=this._addNewAdapter(new ue(this._documents,this._commands.converter,H,this._apiDeprecation,I),I);return this._proxy.$registerCompletionsProvider(se,this._transformDocumentSelector(B),V,ue.supportsResolving(H),`${I.identifier.value}(${V.join("")})`),this._createDisposable(se)}$provideCompletionItems(I,B,H,V,se){return this._withAdapter(I,ue,de=>de.provideCompletionItems(a.URI.revive(B),H,V,se),void 0,se)}$resolveCompletionItem(I,B,H){return this._withAdapter(I,ue,V=>V.resolveCompletionItem(B,H),void 0,H)}$releaseCompletionItems(I,B){this._withAdapter(I,ue,H=>H.releaseCompletionItems(B),void 0,void 0)}registerInlineCompletionsProvider(I,B,H){const V=new Ee(I,this._documents,H,this._commands.converter),se=this._addNewAdapter(V,I);return this._proxy.$registerInlineCompletionsSupport(se,this._transformDocumentSelector(B),V.supportsHandleDidShowCompletionItem),this._createDisposable(se)}registerInlineCompletionsProviderNew(I,B,H){const V=this._addNewAdapter(new be(I,this._documents,H,this._commands.converter),I);return this._proxy.$registerInlineCompletionsSupport(V,this._transformDocumentSelector(B),!0),this._createDisposable(V)}$provideInlineCompletions(I,B,H,V,se){return this._withAdapter(I,te,de=>de.provideInlineCompletions(a.URI.revive(B),H,V,se),void 0,se)}$handleInlineCompletionDidShow(I,B,H){this._withAdapter(I,te,async V=>{V.handleDidShowCompletionItem(B,H)},void 0,void 0)}$freeInlineCompletionsList(I,B){this._withAdapter(I,te,async H=>{H.disposeCompletions(B)},void 0,void 0)}registerSignatureHelpProvider(I,B,H,V){const se=Array.isArray(V)?{triggerCharacters:V,retriggerCharacters:[]}:V,de=this._addNewAdapter(new ve(this._documents,H),I);return this._proxy.$registerSignatureHelpProvider(de,this._transformDocumentSelector(B),se),this._createDisposable(de)}$provideSignatureHelp(I,B,H,V,se){return this._withAdapter(I,ve,de=>de.provideSignatureHelp(a.URI.revive(B),H,V,se),void 0,se)}$releaseSignatureHelp(I,B){this._withAdapter(I,ve,H=>H.releaseSignatureHelp(B),void 0,void 0)}registerInlayHintsProvider(I,B,H){const V=typeof H.onDidChangeInlayHints=="function"?this._nextHandle():void 0,se=this._addNewAdapter(new Ae(this._documents,this._commands.converter,H,this._logService,I),I);this._proxy.$registerInlayHintsProvider(se,this._transformDocumentSelector(B),typeof H.resolveInlayHint=="function",V,G._extLabel(I));let de=this._createDisposable(se);if(V!==void 0){const J=H.onDidChangeInlayHints(pe=>this._proxy.$emitInlayHintsEvent(V));de=L.Disposable.from(de,J)}return de}$provideInlayHints(I,B,H,V){return this._withAdapter(I,Ae,se=>se.provideInlayHints(a.URI.revive(B),H,V),void 0,V)}$resolveInlayHint(I,B,H){return this._withAdapter(I,Ae,V=>V.resolveInlayHint(B,H),void 0,H)}$releaseInlayHints(I,B){this._withAdapter(I,Ae,H=>H.releaseHints(B),void 0,void 0)}registerDocumentLinkProvider(I,B,H){const V=this._addNewAdapter(new Fe(this._documents,H),I);return this._proxy.$registerDocumentLinkProvider(V,this._transformDocumentSelector(B),typeof H.resolveDocumentLink=="function"),this._createDisposable(V)}$provideDocumentLinks(I,B,H){return this._withAdapter(I,Fe,V=>V.provideLinks(a.URI.revive(B),H),void 0,H,B.scheme==="output")}$resolveDocumentLink(I,B,H){return this._withAdapter(I,Fe,V=>V.resolveLink(B,H),void 0,void 0,!0)}$releaseDocumentLinks(I,B){this._withAdapter(I,Fe,H=>H.releaseLinks(B),void 0,void 0,!0)}registerColorProvider(I,B,H){const V=this._addNewAdapter(new $e(this._documents,H),I);return this._proxy.$registerDocumentColorProvider(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideDocumentColors(I,B,H){return this._withAdapter(I,$e,V=>V.provideColors(a.URI.revive(B),H),[],H)}$provideColorPresentations(I,B,H,V){return this._withAdapter(I,$e,se=>se.provideColorPresentations(a.URI.revive(B),H,V),void 0,V)}registerFoldingRangeProvider(I,B,H){const V=this._nextHandle(),se=typeof H.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(V,new le(new Qe(this._documents,H),I)),this._proxy.$registerFoldingRangeProvider(V,this._transformDocumentSelector(B),se);let de=this._createDisposable(V);if(se!==void 0){const J=H.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(se));de=L.Disposable.from(de,J)}return de}$provideFoldingRanges(I,B,H,V){return this._withAdapter(I,Qe,se=>se.provideFoldingRanges(a.URI.revive(B),H,V),void 0,V)}registerSelectionRangeProvider(I,B,H){const V=this._addNewAdapter(new Ie(this._documents,H,this._logService),I);return this._proxy.$registerSelectionRangeProvider(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideSelectionRanges(I,B,H,V){return this._withAdapter(I,Ie,se=>se.provideSelectionRanges(a.URI.revive(B),H,V),[],V)}registerCallHierarchyProvider(I,B,H){const V=this._addNewAdapter(new Se(this._documents,H),I);return this._proxy.$registerCallHierarchyProvider(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$prepareCallHierarchy(I,B,H,V){return this._withAdapter(I,Se,se=>Promise.resolve(se.prepareSession(a.URI.revive(B),H,V)),void 0,V)}$provideCallHierarchyIncomingCalls(I,B,H,V){return this._withAdapter(I,Se,se=>se.provideCallsTo(B,H,V),void 0,V)}$provideCallHierarchyOutgoingCalls(I,B,H,V){return this._withAdapter(I,Se,se=>se.provideCallsFrom(B,H,V),void 0,V)}$releaseCallHierarchy(I,B){this._withAdapter(I,Se,H=>Promise.resolve(H.releaseSession(B)),void 0,void 0)}registerTypeHierarchyProvider(I,B,H){const V=this._addNewAdapter(new ke(this._documents,H),I);return this._proxy.$registerTypeHierarchyProvider(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$prepareTypeHierarchy(I,B,H,V){return this._withAdapter(I,ke,se=>Promise.resolve(se.prepareSession(a.URI.revive(B),H,V)),void 0,V)}$provideTypeHierarchySupertypes(I,B,H,V){return this._withAdapter(I,ke,se=>se.provideSupertypes(B,H,V),void 0,V)}$provideTypeHierarchySubtypes(I,B,H,V){return this._withAdapter(I,ke,se=>se.provideSubtypes(B,H,V),void 0,V)}$releaseTypeHierarchy(I,B){this._withAdapter(I,ke,H=>Promise.resolve(H.releaseSession(B)),void 0,void 0)}registerDocumentOnDropEditProvider(I,B,H){const V=this._nextHandle();return this._adapter.set(V,new le(new ae(this._proxy,this._documents,H,V),I)),this._proxy.$registerDocumentOnDropEditProvider(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideDocumentOnDropEdits(I,B,H,V,se,de){return this._withAdapter(I,ae,J=>Promise.resolve(J.provideDocumentOnDropEdits(B,a.URI.revive(H),V,se,de)),void 0,void 0)}registerDocumentPasteEditProvider(I,B,H,V){const se=this._nextHandle();return this._adapter.set(se,new le(new z(this._proxy,this._documents,H,se),I)),this._proxy.$registerPasteEditProvider(se,this._transformDocumentSelector(B),!!H.prepareDocumentPaste,V.pasteMimeTypes),this._createDisposable(se)}$prepareDocumentPaste(I,B,H,V,se){return this._withAdapter(I,z,de=>de.prepareDocumentPaste(a.URI.revive(B),H,V,se),void 0,se)}$providePasteEdits(I,B,H,V,se,de){return this._withAdapter(I,z,J=>J.providePasteEdits(B,a.URI.revive(H),V,se,de),void 0,de)}static _serializeRegExp(I){return{pattern:I.source,flags:(0,E.regExpFlags)(I)}}static _serializeIndentationRule(I){return{decreaseIndentPattern:G._serializeRegExp(I.decreaseIndentPattern),increaseIndentPattern:G._serializeRegExp(I.increaseIndentPattern),indentNextLinePattern:I.indentNextLinePattern?G._serializeRegExp(I.indentNextLinePattern):void 0,unIndentedLinePattern:I.unIndentedLinePattern?G._serializeRegExp(I.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(I){return{beforeText:G._serializeRegExp(I.beforeText),afterText:I.afterText?G._serializeRegExp(I.afterText):void 0,previousLineText:I.previousLineText?G._serializeRegExp(I.previousLineText):void 0,action:I.action}}static _serializeOnEnterRules(I){return I.map(G._serializeOnEnterRule)}setLanguageConfiguration(I,B,H){const{wordPattern:V}=H;if(V&&(0,E.regExpLeadsToEndlessLoop)(V))throw new Error(`Invalid language configuration: wordPattern '${V}' is not allowed to match the empty string.`);V?this._documents.setWordDefinitionFor(B,V):this._documents.setWordDefinitionFor(B,void 0),H.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",I,"Do not use."),H.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",I,"Do not use.");const se=this._nextHandle(),de={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?G._serializeRegExp(H.wordPattern):void 0,indentationRules:H.indentationRules?G._serializeIndentationRule(H.indentationRules):void 0,onEnterRules:H.onEnterRules?G._serializeOnEnterRules(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport};return this._proxy.$setLanguageConfiguration(se,B,de),this._createDisposable(se)}$setWordDefinitions(I){for(const B of I)this._documents.setWordDefinitionFor(B.languageId,new RegExp(B.regexSource,B.regexFlags))}}e.ExtHostLanguageFeatures=G,G._handlePool=0}),define(ye[204],De([1,0,4,8,6,29,14,7]),function(ne,e,a,p,b,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class E{constructor(O,y,m,T){this._documents=y,this._commands=m,this._uriTransformer=T,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=O.getProxy(a.MainContext.MainThreadLanguages)}$acceptLanguageIds(O){this._languageIds=O}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(O,y){await this._proxy.$changeLanguage(O,y);const m=this._documents.getDocumentData(O);if(!m)throw new Error(`document '${O.toString()}' NOT found`);return m.document}async tokenAtPosition(O,y){const m=O.version,T=p.Position.from(y),f=await this._proxy.$tokensAtPosition(O.uri,T),h={type:b.StandardTokenType.Other,range:O.getWordRangeAtPosition(y)??new b.Range(y.line,y.character,y.line,y.character)};if(!f)return h;const d={range:p.Range.to(f.range),type:p.TokenType.to(f.type)};return!d.range.contains(y)||m!==O.version?h:d}createLanguageStatusItem(O,y,m){const T=this._handlePool++,f=this._proxy,h=this._ids,d=`${O.identifier.value}/${y}`;if(h.has(d))throw new Error(`LanguageStatusItem with id '${y}' ALREADY exists`);h.add(d);const o={selector:m,id:y,name:O.displayName??O.name,severity:b.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let v;const R=new k.DisposableStore,c=()=>{v?.dispose(),v=(0,D.disposableTimeout)(()=>{R.clear(),this._proxy.$setLanguageStatus(T,{id:d,name:o.name??O.displayName??O.name,source:O.displayName??O.name,selector:p.DocumentSelector.from(o.selector,this._uriTransformer),label:o.text,detail:o.detail??"",severity:o.severity===b.LanguageStatusSeverity.Error?L.default.Error:o.severity===b.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:o.command&&this._commands.toInternal(o.command,R),accessibilityInfo:o.accessibilityInformation,busy:o.busy})},0)},w={dispose(){R.dispose(),v?.dispose(),f.$removeLanguageStatus(T),h.delete(d)},get id(){return o.id},get name(){return o.name},set name(s){o.name=s,c()},get selector(){return o.selector},set selector(s){o.selector=s,c()},get text(){return o.text},set text(s){o.text=s,c()},get detail(){return o.detail},set detail(s){o.detail=s,c()},get severity(){return o.severity},set severity(s){o.severity=s,c()},get accessibilityInformation(){return o.accessibilityInformation},set accessibilityInformation(s){o.accessibilityInformation=s,c()},get command(){return o.command},set command(s){o.command=s,c()},get busy(){return o.busy},set busy(s){o.busy=s,c()}};return c(),w}}e.ExtHostLanguages=E}),define(ye[205],De([1,0,15,4,28,13,5]),function(ne,e,a,p,b,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends a.AbstractLoggerService{constructor(O,y){const m=new D.Emitter;super(y.logLevel,m.event);this._proxy=O.getProxy(p.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(m)}$setLevel(O){this._onDidChangeLogLevel.fire(O)}doCreateLogger(O,y,m){return new E(this._proxy,O,y,m)}};k=ze([xe(0,L.IExtHostRpcService),xe(1,b.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class E extends a.AbstractMessageLogger{constructor(O,y,m,T){super(T?.always);this.proxy=O,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(m),this.proxy.$createLogger(y,T).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(O,y){const m=[[O,y]];this.isLoggerCreated?this.doLog(m):this.buffer.push(...m)}doLog(O){this.proxy.$log(this.file,O)}}}),define(ye[206],De([1,0,4,15,24]),function(ne,e,a,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function L(k){return k&&k.title}let D=class{constructor(E,P){this._logService=P,this._proxy=E.getProxy(a.MainContext.MainThreadMessageService)}showMessage(E,P,O,y,m){const T={source:{identifier:E.identifier,label:E.displayName||E.name}};let f;typeof y=="string"||L(y)?f=[y,...m]:(T.modal=y?.modal,T.useCustom=y?.useCustom,T.detail=y?.detail,f=m),T.useCustom&&(0,b.checkProposedApiEnabled)(E,"resolvers");const h=[];for(let d=0;d<f.length;d++){const o=f[d];if(typeof o=="string")h.push({title:o,handle:d,isCloseAffordance:!1});else if(typeof o=="object"){const{title:v,isCloseAffordance:R}=o;h.push({title:v,isCloseAffordance:!!R,handle:d})}else this._logService.warn("Invalid message item:",o)}return this._proxy.$showMessage(P,O,T,h).then(d=>{if(typeof d=="number")return f[d]})}};D=ze([xe(1,p.ILogService)],D),e.ExtHostMessageService=D}),define(ye[207],De([1,0,23,5,96,7,25,9,10,2,61,4,36,8,6,40,175,91]),function(ne,e,a,p,b,L,D,k,E,P,O,y,m,T,f,h,d,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class v{constructor(c,w,s,u,n){this._textDocumentsAndEditors=s,this._textDocuments=u,this._extensionStoragePaths=n,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new D.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new p.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new p.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new p.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new p.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new O.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=c.getProxy(y.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=c.getProxy(y.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=c.getProxy(y.MainContext.MainThreadNotebookEditors),this._commandsConverter=w.converter,w.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===12){const r=i.notebookEditor?.notebookUri,t=i.cell.handle,_=this._documents.get(r)?.getCell(t);if(_)return _.apiCell}return i}}),v._registerApiCommands(w)}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(c=>c.apiEditor)}getEditorById(c){const w=this._editors.get(c);if(!w)throw new Error(`unknown text editor: ${c}. known editors: ${[...this._editors.keys()]} `);return w}getIdByEditor(c){for(const[w,s]of this._editors)if(s.apiEditor===c)return w}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(c,w){const s=this._documents.get(c);if(!s&&!w)throw new Error(`NO notebook document for '${c}'`);return s}_getProviderData(c){const w=this._notebookContentProviders.get(c);if(!w)throw new Error(`NO provider for '${c}'`);return w}registerNotebookContentProvider(c,w,s,u,n){if((0,k.isFalsyOrWhitespace)(w))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(w))throw new Error(`Notebook provider for '${w}' already registered`);this._notebookContentProviders.set(w,{extension:c,provider:s});let i;return s.onDidChangeNotebookContentOptions&&(i=s.onDidChangeNotebookContentOptions(()=>{const r=T.NotebookDocumentContentOptions.from(s.options);this._notebookProxy.$updateNotebookProviderOptions(w,r)})),this._notebookProxy.$registerNotebookProvider({id:c.identifier,location:c.extensionLocation},w,T.NotebookDocumentContentOptions.from(u),v._convertNotebookRegistrationData(c,n)),new f.Disposable(()=>{i?.dispose(),this._notebookContentProviders.delete(w),this._notebookProxy.$unregisterNotebookProvider(w)})}static _convertNotebookRegistrationData(c,w){if(!w)return;const s=w.filenamePattern.map(u=>T.NotebookExclusiveDocumentPattern.from(u)).filter(u=>u!==void 0);if(w.filenamePattern&&!s){console.warn(`Notebook content provider view options file name pattern is invalid ${w.filenamePattern}`);return}return{extension:c.identifier,providerDisplayName:c.displayName||c.name,displayName:w.displayName,filenamePattern:s,exclusive:w.exclusive||!1}}registerNotebookCellStatusBarItemProvider(c,w,s){const u=v._notebookStatusBarItemProviderHandlePool++,n=typeof s.onDidChangeCellStatusBarItems=="function"?v._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(u,s),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(u,n,w);let i;return n!==void 0&&(i=s.onDidChangeCellStatusBarItems(r=>this._notebookProxy.$emitCellStatusBarEvent(n))),new f.Disposable(()=>{this._notebookStatusBarItemProviders.delete(u),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(u,n),i?.dispose()})}async createNotebookDocument(c){const w=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:c.viewType,content:c.content&&T.NotebookData.from(c.content)});return P.URI.revive(w)}async openNotebookDocument(c){const w=this._documents.get(c);if(w)return w.apiNotebook;const s=await this._notebookDocumentsProxy.$tryOpenNotebook(c),u=this._documents.get(P.URI.revive(s));return(0,E.assertIsDefined)(u?.apiNotebook)}async showNotebookDocument(c,w){P.URI.isUri(c)&&(c=await this.openNotebookDocument(c));let s;typeof w=="object"?s={position:T.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selections:w.selections&&w.selections.map(T.NotebookRange.from),pinned:typeof w.preview=="boolean"?!w.preview:void 0}:s={preserveFocus:!1};const u=await this._notebookEditorsProxy.$tryShowNotebookDocument(c.uri,c.notebookType,s),n=u&&this._editors.get(u)?.apiEditor;if(n)return n;throw u?new Error(`Could NOT open editor for "${c.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${c.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(c,w,s,u){const n=this._notebookStatusBarItemProviders.get(c),i=P.URI.revive(w),r=this._documents.get(i);if(!r||!n)return;const t=r.getCellFromIndex(s);if(!t)return;const l=await n.provideCellStatusBarItems(t.apiCell,u);if(!l)return;const _=new L.DisposableStore,g=this._statusBarCache.add([_]),U=(Array.isArray(l)?l:[l]).map(W=>T.NotebookStatusBarItem.from(W,this._commandsConverter,_));return{cacheId:g,items:U}}$releaseNotebookCellStatusBarItems(c){this._statusBarCache.delete(c)}registerNotebookSerializer(c,w,s,u,n){if((0,k.isFalsyOrWhitespace)(w))throw new Error("viewType cannot be empty or just whitespace");const i=this._handlePool++;return this._notebookSerializer.set(i,s),this._notebookProxy.$registerNotebookSerializer(i,{id:c.identifier,location:c.extensionLocation},w,T.NotebookDocumentContentOptions.from(u),v._convertNotebookRegistrationData(c,n)),(0,L.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(i)})}async $dataToNotebook(c,w,s){const u=this._notebookSerializer.get(c);if(!u)throw new Error("NO serializer found");const n=await u.deserializeNotebook(w.buffer,s);return new h.SerializableObjectWithBuffers(T.NotebookData.from(n))}async $notebookToData(c,w,s){const u=this._notebookSerializer.get(c);if(!u)throw new Error("NO serializer found");const n=await u.serializeNotebook(T.NotebookData.to(w.value),s);return a.VSBuffer.wrap(n)}async $openNotebook(c,w,s,u,n){const{provider:i}=this._getProviderData(c),r=await i.openNotebook(P.URI.revive(w),{backupId:s,untitledDocumentData:u?.buffer},n);return new h.SerializableObjectWithBuffers({metadata:r.metadata??Object.create(null),cells:r.cells.map(T.NotebookCellData.from)})}async $saveNotebook(c,w,s){const u=this.getNotebookDocument(P.URI.revive(w)),{provider:n}=this._getProviderData(c);return await n.saveNotebook(u.apiNotebook,s),!0}async $saveNotebookAs(c,w,s,u){const n=this.getNotebookDocument(P.URI.revive(w)),{provider:i}=this._getProviderData(c);return await i.saveNotebookAs(P.URI.revive(s),n.apiNotebook,u),!0}async $backupNotebook(c,w,s){const u=this.getNotebookDocument(P.URI.revive(w)),n=this._getProviderData(c),i=this._extensionStoragePaths.workspaceValue(n.extension)??this._extensionStoragePaths.globalValue(n.extension),r=String((0,b.hash)([u.uri.toString(),this._backupIdPool++])),t=P.URI.joinPath(i,r),l=await n.provider.backupNotebook(u.apiNotebook,{destination:t},s);return u.updateBackup(l),l.id}_createExtHostEditor(c,w,s){if(this._editors.has(w))throw new Error(`editor with id ALREADY EXSIST: ${w}`);const u=new o.ExtHostNotebookEditor(w,this._notebookEditorsProxy,c,s.visibleRanges.map(T.NotebookRange.to),s.selections.map(T.NotebookRange.to),typeof s.viewColumn=="number"?T.ViewColumn.to(s.viewColumn):void 0);this._editors.set(w,u)}$acceptDocumentAndEditorsDelta(c){if(c.value.removedDocuments)for(const s of c.value.removedDocuments){const u=P.URI.revive(s),n=this._documents.get(u);n&&(n.dispose(),this._documents.delete(u),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:n.apiNotebook.getCells().map(i=>i.document.uri)}),this._onDidCloseNotebookDocument.fire(n.apiNotebook));for(const i of this._editors.values())i.notebookData.uri.toString()===u.toString()&&this._editors.delete(i.id)}if(c.value.addedDocuments){const s=[];for(const u of c.value.addedDocuments){const n=P.URI.revive(u.uri);if(this._documents.has(n))throw new Error(`adding EXISTING notebook ${n} `);const i=new d.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,n,u);s.push(...u.cells.map(r=>d.ExtHostCell.asModelAddData(i.apiNotebook,r))),this._documents.get(n)?.dispose(),this._documents.set(n,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:s}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(c.value.addedEditors)for(const s of c.value.addedEditors){if(this._editors.has(s.id))return;const u=P.URI.revive(s.documentUri),n=this._documents.get(u);n&&this._createExtHostEditor(n,s.id,s)}const w=[];if(c.value.removedEditors)for(const s of c.value.removedEditors){const u=this._editors.get(s);u&&(this._editors.delete(s),this._activeNotebookEditor?.id===u.id&&(this._activeNotebookEditor=void 0),w.push(u))}if(c.value.visibleEditors){this._visibleNotebookEditors=c.value.visibleEditors.map(u=>this._editors.get(u)).filter(u=>!!u);const s=new Set;this._visibleNotebookEditors.forEach(u=>s.add(u.id));for(const u of this._editors.values()){const n=s.has(u.id);u._acceptVisibility(n)}this._visibleNotebookEditors=[...this._editors.values()].map(u=>u).filter(u=>u.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}c.value.newActiveEditor===null?this._activeNotebookEditor=void 0:c.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(c.value.newActiveEditor)),c.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(c){const w=m.ApiCommandArgument.String.with("notebookType","A notebook type"),s=new m.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[w,new m.ApiCommandArgument("data","Bytes to convert to data",n=>n instanceof Uint8Array,n=>a.VSBuffer.wrap(n))],new m.ApiCommandResult("Notebook Data",n=>T.NotebookData.to(n.value))),u=new m.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[w,new m.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",n=>!0,n=>new h.SerializableObjectWithBuffers(T.NotebookData.from(n)))],new m.ApiCommandResult("Bytes",n=>n.buffer));c.registerApiCommand(s),c.registerApiCommand(u)}}e.ExtHostNotebookController=v,v._notebookStatusBarItemProviderHandlePool=0}),define(ye[208],De([1,0,16,14,20,5,7,25,2,27,15,4,36,8,6,64,169,24,40]),function(ne,e,a,p,b,L,D,k,E,P,O,y,m,T,f,h,d,o,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let R=class{constructor(i,r,t,l,_){this._initData=r,this._extHostNotebook=t,this._commands=l,this._logService=_,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=i.getProxy(y.MainContext.MainThreadNotebookKernels);const g=new m.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new m.ApiCommandArgument("options","Select kernel options",C=>!0,C=>{if(C&&"notebookEditor"in C&&"id"in C){const U=this._extHostNotebook.getIdByEditor(C.notebookEditor);return{id:C.id,extension:C.extension,notebookEditorId:U}}else if(C&&"notebookEditor"in C){const U=this._extHostNotebook.getIdByEditor(C.notebookEditor);if(U===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${C.notebookEditor.document.uri.toString()}`);return{notebookEditorId:U}}return C})],m.ApiCommandResult.Void);this._commands.registerApiCommand(g)}createNotebookController(i,r,t,l,_,g){for(const ue of this._kernelData.values())if(ue.controller.id===r&&P.ExtensionIdentifier.equals(i.identifier,ue.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const C=this._handlePool++,U=this;this._logService.trace(`NotebookController[${C}], CREATED by ${i.identifier.value}, ${r}`);const W=()=>console.warn(`NO execute handler from notebook controller '${F.id}' of extension: '${i.identifier}'`);let M=!1;const S=new D.DisposableStore,z=new L.Emitter,$=new L.Emitter,F={id:u(i.identifier,r),notebookType:t,extensionId:i.identifier,extensionLocation:i.extensionLocation,label:l||i.identifier.value,preloads:g?g.map(T.NotebookRendererScript.from):[]};let q=_??W,ie;this._proxy.$addKernel(C,F).catch(ue=>{console.log(ue),M=!0});let A=0;const Z=()=>{if(M)return;const ue=++A;Promise.resolve().then(()=>{ue===A&&this._proxy.$updateKernel(C,F)})},ce=new k.ResourceMap,oe={get id(){return r},get notebookType(){return F.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return F.label},set label(ue){F.label=ue??i.displayName??i.name,Z()},get detail(){return F.detail??""},set detail(ue){F.detail=ue,Z()},get description(){return F.description??""},set description(ue){F.description=ue,Z()},get kind(){return(0,o.checkProposedApiEnabled)(i,"notebookControllerKind"),F.kind??""},set kind(ue){(0,o.checkProposedApiEnabled)(i,"notebookControllerKind"),F.kind=ue,Z()},get supportedLanguages(){return F.supportedLanguages},set supportedLanguages(ue){F.supportedLanguages=ue,Z()},get supportsExecutionOrder(){return F.supportsExecutionOrder??!1},set supportsExecutionOrder(ue){F.supportsExecutionOrder=ue,Z()},get rendererScripts(){return F.preloads?F.preloads.map(T.NotebookRendererScript.to):[]},get executeHandler(){return q},set executeHandler(ue){q=ue??W},get interruptHandler(){return ie},set interruptHandler(ue){ie=ue,F.supportsInterrupt=Boolean(ue),Z()},createNotebookCellExecution(ue){if(M)throw new Error("notebook controller is DISPOSED");if(!ce.has(ue.notebook.uri))throw U._logService.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(te=>te.toString())),new Error(`notebook controller is NOT associated to notebook: ${ue.notebook.uri.toString()}`);return U._createNotebookCellExecution(ue,u(i.identifier,this.id))},dispose:()=>{M||(this._logService.trace(`NotebookController[${C}], DISPOSED`),M=!0,this._kernelData.delete(C),S.dispose(),z.dispose(),$.dispose(),this._proxy.$removeKernel(C))},updateNotebookAffinity(ue,te){U._proxy.$updateNotebookPriority(C,ue.uri,te)},onDidReceiveMessage:$.event,postMessage(ue,te){return(0,o.checkProposedApiEnabled)(i,"notebookMessaging"),U._proxy.$postMessage(C,te&&U._extHostNotebook.getIdByEditor(te),ue)},asWebviewUri(ue){return(0,o.checkProposedApiEnabled)(i,"notebookMessaging"),(0,h.asWebviewUri)(ue,U._initData.remote)}};return this._kernelData.set(C,{extensionId:i.identifier,controller:oe,onDidReceiveMessage:$,onDidChangeSelection:z,associatedNotebooks:ce}),oe}getIdByController(i){for(const[r,t]of this._kernelData)if(t.controller===i)return u(t.extensionId,i.id);return null}$acceptNotebookAssociation(i,r,t){const l=this._kernelData.get(i);if(l){const _=this._extHostNotebook.getNotebookDocument(E.URI.revive(r));t?l.associatedNotebooks.set(_.uri,!0):l.associatedNotebooks.delete(_.uri),this._logService.trace(`NotebookController[${i}] ASSOCIATE notebook`,_.uri.toString(),t),l.onDidChangeSelection.fire({selected:t,notebook:_.apiNotebook})}}async $executeCells(i,r,t){const l=this._kernelData.get(i);if(!l)return;const _=this._extHostNotebook.getNotebookDocument(E.URI.revive(r)),g=[];for(const C of t){const U=_.getCell(C);U&&g.push(U.apiCell)}try{this._logService.trace(`NotebookController[${i}] EXECUTE cells`,_.uri.toString(),g.length),await l.controller.executeHandler.call(l.controller,g,_.apiNotebook,l.controller)}catch(C){this._logService.error(`NotebookController[${i}] execute cells FAILED`,C),console.error(C)}}async $cancelCells(i,r,t){const l=this._kernelData.get(i);if(!l)return;const _=this._extHostNotebook.getNotebookDocument(E.URI.revive(r));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,_.apiNotebook);else for(const g of t){const C=_.getCell(g);C&&this._activeExecutions.get(C.uri)?.cancel()}}$acceptKernelMessageFromRenderer(i,r,t){const l=this._kernelData.get(i);if(!l)return;const _=this._extHostNotebook.getEditorById(r);l.onDidReceiveMessage.fire(Object.freeze({editor:_.apiEditor,message:t}))}$cellExecutionChanged(i,r,t){const _=this._extHostNotebook.getNotebookDocument(E.URI.revive(i)).getCell(r);if(_){const g=t?T.NotebookCellExecutionState.to(t):f.NotebookCellExecutionState.Idle;g!==void 0&&this._onDidChangeCellExecutionState.fire({cell:_.apiCell,state:g})}}_createNotebookCellExecution(i,r){if(i.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const l=this._extHostNotebook.getNotebookDocument(i.notebook.uri).getCellFromApiCell(i);if(!l)throw new Error("invalid cell");if(this._activeExecutions.has(l.uri))throw new Error(`duplicate execution for ${l.uri}`);const _=new w(r,l,this._proxy);this._activeExecutions.set(l.uri,_);const g=_.onDidChangeState(()=>{_.state===c.Resolved&&(_.dispose(),g.dispose(),this._activeExecutions.delete(l.uri))});return _.asApiObject()}};R=ze([xe(4,O.ILogService)],R),e.ExtHostNotebookKernels=R;var c;(function(n){n[n.Init=0]="Init",n[n.Started=1]="Started",n[n.Resolved=2]="Resolved"})(c||(c={}));class w extends D.Disposable{constructor(i,r,t){super();this._cell=r,this._proxy=t,this._handle=w.HANDLE++,this._onDidChangeState=new L.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=c.Init,this._tokenSource=this._register(new b.CancellationTokenSource),this._collector=new s(10,l=>this.update(l)),this._executionOrder=r.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,i,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(i){await this._collector.addItem(i)}async update(i){const r=Array.isArray(i)?i:[i];return this._proxy.$updateExecution(this._handle,new v.SerializableObjectWithBuffers(r))}verifyStateForOutput(){if(this._state===c.Init)throw new Error("Must call start before modifying cell output");if(this._state===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(i){let r=this._cell;if(i&&(r=this._cell.notebook.getCellFromApiCell(i)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(i){return i.map(r=>{const t=f.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return t===r.items?T.NotebookCellOutput.from(r):T.NotebookCellOutput.from({items:t,id:r.id,metadata:r.metadata})})}async updateOutputs(i,r,t){const l=this.cellIndexToHandle(r),_=this.validateAndConvertOutputs((0,a.asArray)(i));return this.updateSoon({editType:d.CellExecutionUpdateType.Output,cellHandle:l,append:t,outputs:_})}async updateOutputItems(i,r,t){return i=f.NotebookCellOutput.ensureUniqueMimeTypes((0,a.asArray)(i),!0),this.updateSoon({editType:d.CellExecutionUpdateType.OutputItems,items:i.map(T.NotebookCellOutputItem.from),outputId:r.id,append:t})}asApiObject(){const i=this;return Object.freeze({get token(){return i._tokenSource.token},get cell(){return i._cell.apiCell},get executionOrder(){return i._executionOrder},set executionOrder(t){i._executionOrder=t,i.update([{editType:d.CellExecutionUpdateType.ExecutionState,executionOrder:i._executionOrder}])},start(t){if(i._state===c.Resolved||i._state===c.Started)throw new Error("Cannot call start again");i._state=c.Started,i._onDidChangeState.fire(),i.update({editType:d.CellExecutionUpdateType.ExecutionState,runStartTime:t})},end(t,l){if(i._state===c.Resolved)throw new Error("Cannot call resolve twice");i._state=c.Resolved,i._onDidChangeState.fire(),i._collector.flush(),i._proxy.$completeExecution(i._handle,new v.SerializableObjectWithBuffers({runEndTime:l,lastRunSuccess:t}))},clearOutput(t){return i.verifyStateForOutput(),i.updateOutputs([],t,!1)},appendOutput(t,l){return i.verifyStateForOutput(),i.updateOutputs(t,l,!0)},replaceOutput(t,l){return i.verifyStateForOutput(),i.updateOutputs(t,l,!1)},appendOutputItems(t,l){return i.verifyStateForOutput(),i.updateOutputItems(t,l,!0)},replaceOutputItems(t,l){return i.verifyStateForOutput(),i.updateOutputItems(t,l,!1)}})}}w.HANDLE=0;class s{constructor(i,r){this.delay=i,this.callback=r,this.batch=[],this.startedTimer=Date.now()}addItem(i){return this.batch.push(i),this.currentDeferred||(this.currentDeferred=new p.DeferredPromise,this.startedTimer=Date.now(),(0,p.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const i=this.currentDeferred;this.currentDeferred=void 0;const r=this.batch;return this.batch=[],this.callback(r).finally(()=>i.complete())}}function u(n,i){return`${n.value}/${i}`}e.createKernelId=u}),define(ye[209],De([1,0,5,4,91]),function(ne,e,a,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class L{constructor(k,E){this._extHostNotebook=E,this._rendererMessageEmitters=new Map,this.proxy=k.getProxy(p.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(k,E,P){const O=this._extHostNotebook.getEditorById(k);this._rendererMessageEmitters.get(E)?.fire({editor:O.apiEditor,message:P})}createRendererMessaging(k,E){if(!k.contributes?.notebookRenderer?.some(O=>O.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(O,y,m)=>this.getOrCreateEmitterFor(E).event(O,y,m),postMessage:(O,y)=>{b.ExtHostNotebookEditor.apiEditorsToExtHost.has(O)&&([O,y]=[y,O]);const m=y&&b.ExtHostNotebookEditor.apiEditorsToExtHost.get(y);return this.proxy.$postMessage(m?.id,E,O)}}}getOrCreateEmitterFor(k){let E=this._rendererMessageEmitters.get(k);return E||(E=new a.Emitter({onLastListenerRemove:()=>{E?.dispose(),this._rendererMessageEmitters.delete(k)}}),this._rendererMessageEmitters.set(k,E),E)}}e.ExtHostNotebookRenderers=L}),define(ye[210],De([1,0,20,5,7,4,2,6,11,16,29,60]),function(ne,e,a,p,b,L,D,k,E,P,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(T,f,h){const d=T.getProxy(L.MainContext.MainThreadQuickOpen);class o{constructor(r,t){this._sessions=new Map,this._instances=0,this._workspace=r,this._commands=t}showQuickPick(r,t,l=a.CancellationToken.None){this._onDidSelectItem=void 0;const _=Promise.resolve(r),g=++this._instances,C=d.$show(g,{title:t?.title,placeHolder:t?.placeHolder,matchOnDescription:t?.matchOnDescription,matchOnDetail:t?.matchOnDetail,ignoreFocusLost:t?.ignoreFocusOut,canPickMany:t?.canPickMany},l),U={},W=C.then(()=>U);return Promise.race([W,_]).then(M=>{if(M!==U)return _.then(S=>{const z=[];for(let $=0;$<S.length;$++){const F=S[$];typeof F=="string"?z.push({label:F,handle:$}):F.kind===k.QuickPickItemKind.Separator?z.push({type:"separator",label:F.label}):z.push({label:F.label,description:F.description,detail:F.detail,picked:F.picked,alwaysShow:F.alwaysShow,handle:$})}return t&&typeof t.onDidSelectItem=="function"&&(this._onDidSelectItem=$=>{t.onDidSelectItem(S[$])}),d.$setItems(g,z),C.then($=>{if(typeof $=="number")return S[$];if(Array.isArray($))return $.map(F=>S[F])})})}).then(void 0,M=>{if(!(0,E.isCancellationError)(M))return d.$setError(g,M),Promise.reject(M)})}$onItemSelected(r){this._onDidSelectItem?.(r)}showInput(r,t=a.CancellationToken.None){return this._validateInput=r?.validateInput,d.$input(r,typeof this._validateInput=="function",t).then(void 0,l=>{if(!(0,E.isCancellationError)(l))return Promise.reject(l)})}async $validateInput(r){if(!this._validateInput)return;const t=await this._validateInput(r);if(!t||typeof t=="string")return t;let l;switch(t.severity){case k.InputBoxValidationSeverity.Info:l=O.default.Info;break;case k.InputBoxValidationSeverity.Warning:l=O.default.Warning;break;case k.InputBoxValidationSeverity.Error:l=O.default.Error;break;default:l=t.message?O.default.Error:O.default.Ignore;break}return{content:t.message,severity:l}}async showWorkspaceFolderPick(r,t=a.CancellationToken.None){const l=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!l)return;const _=await this._workspace.getWorkspaceFolders2();if(!!_)return _.find(g=>g.uri.toString()===l.uri.toString())}createQuickPick(r){const t=new u(r,()=>this._sessions.delete(t._id));return this._sessions.set(t._id,t),t}createInputBox(r){const t=new n(r,()=>this._sessions.delete(t._id));return this._sessions.set(t._id,t),t}$onDidChangeValue(r,t){this._sessions.get(r)?._fireDidChangeValue(t)}$onDidAccept(r){this._sessions.get(r)?._fireDidAccept()}$onDidChangeActive(r,t){const l=this._sessions.get(r);l instanceof u&&l._fireDidChangeActive(t)}$onDidChangeSelection(r,t){const l=this._sessions.get(r);l instanceof u&&l._fireDidChangeSelection(t)}$onDidTriggerButton(r,t){this._sessions.get(r)?._fireDidTriggerButton(t)}$onDidTriggerItemButton(r,t,l){const _=this._sessions.get(r);_ instanceof u&&_._fireDidTriggerItemButton(t,l)}$onDidHide(r){this._sessions.get(r)?._fireDidHide()}}class v{constructor(r,t){this._extensionId=r,this._onDidDispose=t,this._id=u._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new p.Emitter,this._onDidChangeValueEmitter=new p.Emitter,this._onDidTriggerButtonEmitter=new p.Emitter,this._onDidHideEmitter=new p.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(r){this._title=r,this.update({title:r})}get step(){return this._steps}set step(r){this._steps=r,this.update({step:r})}get totalSteps(){return this._totalSteps}set totalSteps(r){this._totalSteps=r,this.update({totalSteps:r})}get enabled(){return this._enabled}set enabled(r){this._enabled=r,this.update({enabled:r})}get busy(){return this._busy}set busy(r){this._busy=r,this.update({busy:r})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(r){this._ignoreFocusOut=r,this.update({ignoreFocusOut:r})}get value(){return this._value}set value(r){this._value=r,this.update({value:r})}get placeholder(){return this._placeholder}set placeholder(r){this._placeholder=r,this.update({placeholder:r})}get buttons(){return this._buttons}set buttons(r){this._buttons=r.slice(),this._handlesToButtons.clear(),r.forEach((t,l)=>{const _=t===k.QuickInputButtons.Back?-1:l;this._handlesToButtons.set(_,t)}),this.update({buttons:r.map((t,l)=>({...s(t),tooltip:t.tooltip,handle:t===k.QuickInputButtons.Back?-1:l}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(r){this._value=r,this._onDidChangeValueEmitter.fire(r)}_fireDidTriggerButton(r){const t=this._handlesToButtons.get(r);t&&this._onDidTriggerButtonEmitter.fire(t)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,b.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),d.$dispose(this._id))}update(r){if(!this._disposed){for(const t of Object.keys(r)){const l=r[t];this._pendingUpdate[t]=l===void 0?null:l}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){d.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}v._nextId=1;function R(i){if(i instanceof k.ThemeIcon)return{id:i.id};const r=w(i),t=c(i);return{dark:typeof r=="string"?D.URI.file(r):r,light:typeof t=="string"?D.URI.file(t):t}}function c(i){return typeof i=="object"&&"light"in i?i.light:i}function w(i){return typeof i=="object"&&"dark"in i?i.dark:i}function s(i){const r=R(i.iconPath);let t,l;return"id"in r?l=y.ThemeIcon.asClassName(r):t=r,{iconPath:t,iconClass:l}}class u extends v{constructor(r,t){super(r.identifier,t);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new p.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new p.Emitter,this._onDidTriggerItemButtonEmitter=new p.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(r){this._items=r.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),r.forEach((l,_)=>{this._handlesToItems.set(_,l),this._itemsToHandles.set(l,_)});const t=[];for(let l=0;l<r.length;l++){const _=r[l];_.kind===k.QuickPickItemKind.Separator?t.push({type:"separator",label:_.label}):t.push({handle:l,label:_.label,description:_.description,detail:_.detail,picked:_.picked,alwaysShow:_.alwaysShow,buttons:_.buttons?.map((g,C)=>({...s(g),tooltip:g.tooltip,handle:C}))})}this.update({items:t})}get canSelectMany(){return this._canSelectMany}set canSelectMany(r){this._canSelectMany=r,this.update({canSelectMany:r})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(r){this._matchOnDescription=r,this.update({matchOnDescription:r})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(r){this._matchOnDetail=r,this.update({matchOnDetail:r})}get sortByLabel(){return this._sortByLabel}set sortByLabel(r){this._sortByLabel=r,this.update({sortByLabel:r})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(r){this._keepScrollPosition=r,this.update({keepScrollPosition:r})}get activeItems(){return this._activeItems}set activeItems(r){this._activeItems=r.filter(t=>this._itemsToHandles.has(t)),this.update({activeItems:this._activeItems.map(t=>this._itemsToHandles.get(t))})}get selectedItems(){return this._selectedItems}set selectedItems(r){this._selectedItems=r.filter(t=>this._itemsToHandles.has(t)),this.update({selectedItems:this._selectedItems.map(t=>this._itemsToHandles.get(t))})}_fireDidChangeActive(r){const t=(0,P.coalesce)(r.map(l=>this._handlesToItems.get(l)));this._activeItems=t,this._onDidChangeActiveEmitter.fire(t)}_fireDidChangeSelection(r){const t=(0,P.coalesce)(r.map(l=>this._handlesToItems.get(l)));this._selectedItems=t,this._onDidChangeSelectionEmitter.fire(t)}_fireDidTriggerItemButton(r,t){const l=this._handlesToItems.get(r);if(!l||!l.buttons||!l.buttons.length)return;const _=l.buttons[t];_&&this._onDidTriggerItemButtonEmitter.fire({button:_,item:l})}}class n extends v{constructor(r,t){super(r.identifier,t);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(r){this._password=r,this.update({password:r})}get prompt(){return this._prompt}set prompt(r){this._prompt=r,this.update({prompt:r})}get validationMessage(){return this._validationMessage}set validationMessage(r){this._validationMessage=r,r?typeof r=="string"?this.update({validationMessage:r,severity:O.default.Error}):this.update({validationMessage:r.message,severity:r.severity??O.default.Error}):this.update({validationMessage:void 0,severity:O.default.Ignore})}}return new o(f,h)}e.createExtHostQuickOpen=m});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,a,p,b){if(p==="m")throw new TypeError("Private method is not writable");if(p==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return p==="a"?b.call(ne,a):b?b.value=a:e.set(ne,a),a},Oe=this&&this.__classPrivateFieldGet||function(ne,e,a,p){if(a==="a"&&!p)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!p:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?p:a==="a"?p.call(ne):p?p.value:e.get(ne)};define(ye[211],De([1,0,2,5,54,7,14,4,16,117,15,27,60,8,24]),function(ne,e,a,p,b,L,D,k,E,P,O,y,m,T,f){"use strict";var h,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function o(_){if(_)return typeof _.iconPath=="string"?a.URI.file(_.iconPath):a.URI.isUri(_.iconPath)||m.ThemeIcon.isThemeIcon(_.iconPath)?_.iconPath:void 0}function v(_,g){if(!_.iconPath&&!g.iconPath)return 0;if(_.iconPath){if(!g.iconPath)return 1}else return-1;const C=typeof _.iconPath=="string"?_.iconPath:a.URI.isUri(_.iconPath)?_.iconPath.fsPath:_.iconPath.id,U=typeof g.iconPath=="string"?g.iconPath:a.URI.isUri(g.iconPath)?g.iconPath.fsPath:g.iconPath.id;return(0,P.comparePaths)(C,U)}function R(_,g){let C=0;if(_.strikeThrough!==g.strikeThrough)return _.strikeThrough?1:-1;if(_.faded!==g.faded)return _.faded?1:-1;if(_.tooltip!==g.tooltip)return(_.tooltip||"").localeCompare(g.tooltip||"");if(C=v(_,g),C!==0)return C;if(_.light&&g.light)C=v(_.light,g.light);else{if(_.light)return 1;if(g.light)return-1}if(C!==0)return C;if(_.dark&&g.dark)C=v(_.dark,g.dark);else{if(_.dark)return 1;if(g.dark)return-1}return C}function c(_,g){if(_.command!==g.command)return _.command<g.command?-1:1;if(_.title!==g.title)return _.title<g.title?-1:1;if(_.tooltip!==g.tooltip){if(_.tooltip!==void 0&&g.tooltip!==void 0)return _.tooltip<g.tooltip?-1:1;if(_.tooltip!==void 0)return 1;if(g.tooltip!==void 0)return-1}if(_.arguments===g.arguments)return 0;if(_.arguments)if(g.arguments){if(_.arguments.length!==g.arguments.length)return _.arguments.length-g.arguments.length}else return 1;else return-1;for(let C=0;C<_.arguments.length;C++){const U=_.arguments[C],W=g.arguments[C];if(U!==W)return U<W?-1:1}return 0}function w(_,g){let C=(0,P.comparePaths)(_.resourceUri.fsPath,g.resourceUri.fsPath,!0);if(C!==0)return C;if(_.command&&g.command)C=c(_.command,g.command);else{if(_.command)return 1;if(g.command)return-1}if(C!==0)return C;if(_.decorations&&g.decorations)C=R(_.decorations,g.decorations);else{if(_.decorations)return 1;if(g.decorations)return-1}return C}function s(_,g){for(let C=0;C<_.length;C++)if(_[C]!==g[C])return!1;return!0}function u(_,g){return _.command===g.command&&_.title===g.title&&_.tooltip===g.tooltip&&(_.arguments&&g.arguments?s(_.arguments,g.arguments):_.arguments===g.arguments)}function n(_,g){return(0,E.equals)(_,g,u)}class i{constructor(g,C,U){this._extension=g,this._sourceControlHandle=U,h.set(this,void 0),this._value="",this._onDidChange=new p.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,Ye(this,h,C,"f")}get value(){return this._value}set value(g){g=g??"",Oe(this,h,"f").$setInputBoxValue(this._sourceControlHandle,g),this.updateValue(g)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(g){Oe(this,h,"f").$setInputBoxPlaceholder(this._sourceControlHandle,g),this._placeholder=g}get validateInput(){return(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(g){if((0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),g&&typeof g!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=g,Oe(this,h,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!g)}get enabled(){return this._enabled}set enabled(g){g=!!g,this._enabled!==g&&(this._enabled=g,Oe(this,h,"f").$setInputBoxEnablement(this._sourceControlHandle,g))}get visible(){return this._visible}set visible(g){g=!!g,this._visible!==g&&(this._visible=g,Oe(this,h,"f").$setInputBoxVisibility(this._sourceControlHandle,g))}showValidationMessage(g,C){(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),Oe(this,h,"f").$showValidationMessage(this._sourceControlHandle,g,C)}$onInputBoxValueChange(g){this.updateValue(g)}updateValue(g){this._value=g,this._onDidChange.fire(g)}}e.ExtHostSCMInputBox=i,h=new WeakMap;class r{constructor(g,C,U,W,M){this._proxy=g,this._commands=C,this._sourceControlHandle=U,this._id=W,this._label=M,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new p.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new p.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(g){this._label=g,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,g)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(g){this._hideWhenEmpty=g,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(g){this._resourceStates=[...g],this._onDidUpdateResourceStates.fire()}getResourceState(g){return this._resourceStatesMap.get(g)}$executeResourceCommand(g,C){const U=this._resourceStatesCommandsMap.get(g);return U?(0,D.asPromise)(()=>this._commands.executeCommand(U.command,...U.arguments||[],C)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const g=[...this._resourceStates].sort(w),U=(0,E.sortedDiff)(this._resourceSnapshot,g,w).map(S=>{const z=S.toInsert.map($=>{const F=this._resourceHandlePool++;this._resourceStatesMap.set(F,$);const q=$.resourceUri;let ie;if($.command)if($.command.command==="vscode.open"||$.command.command==="vscode.diff"){const ve=new L.DisposableStore;ie=this._commands.converter.toInternal($.command,ve),this._resourceStatesDisposablesMap.set(F,ve)}else this._resourceStatesCommandsMap.set(F,$.command);const A=o($.decorations),Z=$.decorations&&o($.decorations.light)||A,ce=$.decorations&&o($.decorations.dark)||A,oe=[Z,ce],ue=$.decorations&&$.decorations.tooltip||"",te=$.decorations&&!!$.decorations.strikeThrough,Ee=$.decorations&&!!$.decorations.faded,be=$.contextValue||"";return{rawResource:[F,q,oe,ue,te,Ee,be,ie],handle:F}});return{start:S.start,deleteCount:S.deleteCount,toInsert:z}}),W=U.map(({start:S,deleteCount:z,toInsert:$})=>[S,z,$.map(F=>F.rawResource)]),M=U.reverse();for(const{start:S,deleteCount:z,toInsert:$}of M){const F=$.map(ie=>ie.handle),q=this._handlesSnapshot.splice(S,z,...F);for(const ie of q)this._resourceStatesMap.delete(ie),this._resourceStatesCommandsMap.delete(ie),this._resourceStatesDisposablesMap.get(ie)?.dispose(),this._resourceStatesDisposablesMap.delete(ie)}return this._resourceSnapshot=g,W}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class t{constructor(g,C,U,W,M,S){this._extension=g,this._commands=U,this._id=W,this._label=M,this._rootUri=S,d.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new L.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new L.MutableDisposable,this._statusBarDisposables=new L.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new p.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=t._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Ye(this,d,C,"f"),this._inputBox=new i(g,Oe(this,d,"f"),this.handle),Oe(this,d,"f").$registerSourceControl(this.handle,W,M,S)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(g){this._count!==g&&(this._count=g,Oe(this,d,"f").$updateSourceControl(this.handle,{count:g}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(g){this._quickDiffProvider=g,Oe(this,d,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!g})}get commitTemplate(){return this._commitTemplate}set commitTemplate(g){g!==this._commitTemplate&&(this._commitTemplate=g,Oe(this,d,"f").$updateSourceControl(this.handle,{commitTemplate:g}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(g){this._acceptInputDisposables.value=new L.DisposableStore,this._acceptInputCommand=g;const C=this._commands.converter.toInternal(g,this._acceptInputDisposables.value);Oe(this,d,"f").$updateSourceControl(this.handle,{acceptInputCommand:C})}get actionButton(){return(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(g){(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new L.DisposableStore,this._actionButton=g;const C=g!==void 0?{command:this._commands.converter.toInternal(g.command,this._actionButtonDisposables.value),secondaryCommands:g.secondaryCommands?.map(U=>U.map(W=>this._commands.converter.toInternal(W,this._actionButtonDisposables.value))),description:g.description,enabled:g.enabled}:void 0;Oe(this,d,"f").$updateSourceControl(this.handle,{actionButton:C??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(g){if(this._statusBarCommands&&g&&n(this._statusBarCommands,g))return;this._statusBarDisposables.value=new L.DisposableStore,this._statusBarCommands=g;const C=(g||[]).map(U=>this._commands.converter.toInternal(U,this._statusBarDisposables.value));Oe(this,d,"f").$updateSourceControl(this.handle,{statusBarCommands:C})}get selected(){return this._selected}createResourceGroup(g,C){const U=new r(Oe(this,d,"f"),this._commands,this.handle,g,C),W=p.Event.once(U.onDidDispose)(()=>this.createdResourceGroups.delete(U));return this.createdResourceGroups.set(U,W),this.eventuallyAddResourceGroups(),U}eventuallyAddResourceGroups(){const g=[],C=[];for(const[U,W]of this.createdResourceGroups){W.dispose();const M=U.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(U),this.eventuallyUpdateResourceStates()});p.Event.once(U.onDidDispose)(()=>{this.updatedResourceGroups.delete(U),M.dispose(),this._groups.delete(U.handle),Oe(this,d,"f").$unregisterGroup(this.handle,U.handle)}),g.push([U.handle,U.id,U.label,U.features]);const S=U._takeResourceStateSnapshot();S.length>0&&C.push([U.handle,S]),this._groups.set(U.handle,U)}Oe(this,d,"f").$registerGroups(this.handle,g,C),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const g=[];this.updatedResourceGroups.forEach(C=>{const U=C._takeResourceStateSnapshot();U.length!==0&&g.push([C.handle,U])}),g.length>0&&Oe(this,d,"f").$spliceResourceStates(this.handle,g),this.updatedResourceGroups.clear()}getResourceGroup(g){return this._groups.get(g)}setSelectionState(g){this._selected=g,this._onDidChangeSelection.fire(g)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(g=>g.dispose()),Oe(this,d,"f").$unregisterSourceControl(this.handle)}}d=new WeakMap,t._handlePool=0,ze([(0,b.debounce)(100)],t.prototype,"eventuallyAddResourceGroups",null),ze([(0,b.debounce)(100)],t.prototype,"eventuallyUpdateResourceStates",null);let l=class Yi{constructor(g,C,U){this._commands=C,this.logService=U,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new p.Emitter,this._proxy=g.getProxy(k.MainContext.MainThreadSCM),this._telemetry=g.getProxy(k.MainContext.MainThreadTelemetry),C.registerArgumentProcessor({processArgument:W=>{if(W&&W.$mid===3){const M=this._sourceControls.get(W.sourceControlHandle);if(!M)return W;const S=M.getResourceGroup(W.groupHandle);return S?S.getResourceState(W.handle):W}else if(W&&W.$mid===4){const M=this._sourceControls.get(W.sourceControlHandle);return M?M.getResourceGroup(W.groupHandle):W}else if(W&&W.$mid===5){const M=this._sourceControls.get(W.handle);return M||W}return W}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(g,C,U,W){this.logService.trace("ExtHostSCM#createSourceControl",g.identifier.value,C,U,W),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:g.identifier.value});const M=Yi._handlePool++,S=new t(g,this._proxy,this._commands,C,U,W);this._sourceControls.set(M,S);const z=this._sourceControlsByExtension.get(y.ExtensionIdentifier.toKey(g.identifier))||[];return z.push(S),this._sourceControlsByExtension.set(y.ExtensionIdentifier.toKey(g.identifier),z),S}getLastInputBox(g){this.logService.trace("ExtHostSCM#getLastInputBox",g.identifier.value);const C=this._sourceControlsByExtension.get(y.ExtensionIdentifier.toKey(g.identifier)),U=C&&C[C.length-1];return U&&U.inputBox}$provideOriginalResource(g,C,U){const W=a.URI.revive(C);this.logService.trace("ExtHostSCM#$provideOriginalResource",g,W.toString());const M=this._sourceControls.get(g);return!M||!M.quickDiffProvider||!M.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,D.asPromise)(()=>M.quickDiffProvider.provideOriginalResource(W,U)).then(S=>S||null)}$onInputBoxValueChange(g,C){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",g);const U=this._sourceControls.get(g);return U&&U.inputBox.$onInputBoxValueChange(C),Promise.resolve(void 0)}$executeResourceCommand(g,C,U,W){this.logService.trace("ExtHostSCM#$executeResourceCommand",g,C,U);const M=this._sourceControls.get(g);if(!M)return Promise.resolve(void 0);const S=M.getResourceGroup(C);return S?S.$executeResourceCommand(U,W):Promise.resolve(void 0)}$validateInput(g,C,U){this.logService.trace("ExtHostSCM#$validateInput",g);const W=this._sourceControls.get(g);return!W||!W.inputBox.validateInput?Promise.resolve(void 0):(0,D.asPromise)(()=>W.inputBox.validateInput(C,U)).then(M=>{if(!M)return Promise.resolve(void 0);const S=T.MarkdownString.fromStrict(M.message);return S?Promise.resolve([S,M.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(g){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",g),g!==void 0&&this._sourceControls.get(g)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=g,Promise.resolve(void 0)}};l._handlePool=0,l=ze([xe(2,O.ILogService)],l),e.ExtHostSCM=l});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,a,p,b){if(p==="m")throw new TypeError("Private method is not writable");if(p==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return p==="a"?b.call(ne,a):b?b.value=a:e.set(ne,a),a},Oe=this&&this.__classPrivateFieldGet||function(ne,e,a,p){if(a==="a"&&!p)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!p:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?p:a==="a"?p.call(ne):p?p.value:e.get(ne)};define(ye[212],De([1,0,6,4,132,7,8,10]),function(ne,e,a,p,b,L,D,k){"use strict";var E,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class O{constructor(f,h,d,o,v=a.StatusBarAlignment.Left,R){E.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new L.DisposableStore,Ye(this,E,f,"f"),Ye(this,P,h,"f"),this._entryId=O.ID_GEN++,this._extension=d,this._id=o,this._alignment=v,this._priority=this.validatePriority(R)}validatePriority(f){if(!!(0,k.isNumber)(f))return f===Number.POSITIVE_INFINITY?Number.MAX_VALUE:f===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:f}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set name(f){this._name=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!O.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){this._command?.fromApi!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:Oe(this,P,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:Oe(this,P,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Oe(this,E,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let f;this._extension?this._id?f=`${this._extension.identifier.value}.${this._id}`:f=this._extension.identifier.value:f=this._id;let h;this._name?h=this._name:h=(0,b.localize)(0,null,this._extension.displayName||this._extension.name);let d=this._color;this._backgroundColor&&(d=O.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const o=D.MarkdownString.fromStrict(this._tooltip);Oe(this,E,"f").$setEntry(this._entryId,f,h,this._text,o,this._command?.internal,d,this._backgroundColor,this._alignment===a.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=O,E=new WeakMap,P=new WeakMap,O.ID_GEN=0,O.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new a.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new a.ThemeColor("statusBarItem.warningForeground")]]);class y{constructor(f){this._messages=[],this._item=f.createStatusBarEntry(void 0,"status.extensionMessage",a.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,b.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const h={message:f};return this._messages.unshift(h),this._update(),new a.Disposable(()=>{const d=this._messages.indexOf(h);d>=0&&(this._messages.splice(d,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class m{constructor(f,h){this._proxy=f.getProxy(p.MainContext.MainThreadStatusBar),this._commands=h,this._statusMessage=new y(this)}createStatusBarEntry(f,h,d,o){return new O(this._proxy,this._commands,f,h,d,o)}setStatusBarMessage(f,h){const d=this._statusMessage.setMessage(f);let o;return typeof h=="number"?o=setTimeout(()=>d.dispose(),h):typeof h!="undefined"&&h.then(()=>d.dispose(),()=>d.dispose()),new a.Disposable(()=>{d.dispose(),clearTimeout(o)})}}e.ExtHostStatusBar=m}),define(ye[69],De([1,0,4,5,3]),function(ne,e,a,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class L{constructor(k){this._onDidChangeStorage=new p.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(a.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,E){this._proxy.$registerExtensionStorageKeysToSync(k,E)}initializeExtensionStorage(k,E,P){return this._proxy.$initializeExtensionStorage(k,E).then(O=>O||P)}setValue(k,E,P){return this._proxy.$setValue(k,E,P)}$acceptValue(k,E,P){this._onDidChangeStorage.fire({shared:k,key:E,value:P})}}e.ExtHostStorage=L,e.IExtHostStorage=(0,b.createDecorator)("IExtHostStorage")}),define(ye[70],De([1,0,3,28,15,51,2]),function(ne,e,a,p,b,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,a.createDecorator)("IExtensionStoragePaths");let k=class{constructor(P,O,y){this._logService=O,this._extHostFileSystem=y,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(m=>this._value=m)}async _getWorkspaceStorageURI(P){return D.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,O=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(O),this._logService.trace("[ExtHostStorage] storage dir already exists",O),O}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",O),await this._extHostFileSystem.value.createDirectory(O),await this._extHostFileSystem.value.writeFile(D.URI.joinPath(O,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:D.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),O}catch(y){this._logService.error("[ExtHostStorage]",y);return}}workspaceValue(P){if(this._value)return D.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return D.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};k=ze([xe(0,p.IExtHostInitDataService),xe(1,b.ILogService),xe(2,L.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(ye[97],De([1,0,3,4,13]),function(ne,e,a,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTelemetryLogService=e.IExtHostTelemetryLogService=void 0,e.IExtHostTelemetryLogService=(0,a.createDecorator)("IExtHostTelemetryLogService");let L=class{constructor(k){this._telemetryShape=k.getProxy(p.MainContext.MainThreadTelemetry)}logToTelemetryOutputChannel(k,E,P){this._telemetryShape.$logTelemetryToOutputChannel(`${k.identifier.value}/${E}`,P)}};L=ze([xe(0,b.IExtHostRpcService)],L),e.ExtHostTelemetryLogService=L}),define(ye[52],De([1,0,5,4,3,2,13,7,6,133,11,170,20,42,154,60,10,14]),function(ne,e,a,p,b,L,D,k,E,P,O,y,m,T,f,h,d,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,b.createDecorator)("IExtHostTerminalService");class v{constructor(t,l,_,g){this._proxy=t,this._id=l,this._creationOptions=_,this._name=g,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(U=>this._pidPromiseComplete=U);const C=this;this.value={get name(){return C._name||""},get processId(){return C._pidPromise},get creationOptions(){return C._creationOptions},get exitStatus(){return C._exitStatus},get state(){return C._state},sendText(U,W=!0){C._checkDisposed(),C._proxy.$sendText(C._id,U,W)},show(U){C._checkDisposed(),C._proxy.$show(C._id,U)},hide(){C._checkDisposed(),C._proxy.$hide(C._id)},dispose(){C._disposed||(C._disposed=!0,C._proxy.$dispose(C._id))},get dimensions(){if(!(C._cols===void 0||C._rows===void 0))return{columns:C._cols,rows:C._rows}}}}async create(t,l){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:t.name,shellPath:(0,d.withNullAsUndefined)(t.shellPath),shellArgs:(0,d.withNullAsUndefined)(t.shellArgs),cwd:(0,d.withNullAsUndefined)(t.cwd),env:(0,d.withNullAsUndefined)(t.env),icon:(0,d.withNullAsUndefined)(n(t.iconPath)),color:h.ThemeColor.isThemeColor(t.color)?t.color.id:void 0,initialText:(0,d.withNullAsUndefined)(t.message),strictEnv:(0,d.withNullAsUndefined)(t.strictEnv),hideFromUser:(0,d.withNullAsUndefined)(t.hideFromUser),isFeatureTerminal:(0,d.withNullAsUndefined)(l?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,d.withNullAsUndefined)(l?.useShellEnvironment),location:l?.location||this._serializeParentTerminal(t.location,l?.resolvedExtHostIdentifier),isTransient:(0,d.withNullAsUndefined)(t.isTransient)})}async createExtensionTerminal(t,l,_,g){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:_,color:h.ThemeColor.isThemeColor(g)?g.id:void 0,location:this._serializeParentTerminal(t,l),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(t,l){return typeof t=="object"?"parentTerminal"in t&&t.parentTerminal&&l?{parentTerminal:l}:"viewColumn"in t?{viewColumn:t.viewColumn,preserveFocus:t.preserveFocus}:void 0:t}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitStatus(t,l){this._exitStatus=Object.freeze({code:t,reason:l})}setDimensions(t,l){return t===this._cols&&l===this._rows||t===0||l===0?!1:(this._cols=t,this._rows=l,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(l=>{l!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=v;class R{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new a.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new a.Emitter,this._onDidChangeProperty=new a.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new a.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(t){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${t}`)}updateProperty(t,l){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${t}, value: ${l}`)}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput?.(t)}resize(t,l){this._pty.setDimensions?.({columns:t,rows:l})}async processBinary(t){}acknowledgeDataEvent(t){}async setUnicodeVersion(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(l=>this._onProcessData.fire(l)),this._pty.onDidClose?.((l=void 0)=>{this._onProcessExit.fire(l===void 0?void 0:l)}),this._pty.onDidOverrideDimensions?.(l=>{l&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:l.columns,rows:l.rows}})}),this._pty.onDidChangeName?.(l=>{this._onDidChangeProperty.fire({type:"title",value:l})}),this._pty.open(t||void 0),t&&this._pty.setDimensions?.(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=R;let c=1,w=class extends k.Disposable{constructor(t,l){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new a.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new a.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new a.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new a.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new a.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=l.getProxy(p.MainContext.MainThreadTerminalService),this._bufferer=new f.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new a.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[_,g]of this._terminalProcesses)g.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(t,l){const _=new v(this._proxy,(0,T.generateUuid)(),t,t.name),g=new R(t.pty);return _.createExtensionTerminal(t.location,this._serializeParentTerminal(t,l).resolvedExtHostIdentifier,n(t.iconPath),i(t.color)).then(C=>{const U=this._setupExtHostProcessListeners(C,g);this._terminalProcessDisposables[C]=U}),this._terminals.push(_),_.value}_serializeParentTerminal(t,l){if(l=l||{},t.location&&typeof t.location=="object"&&"parentTerminal"in t.location){const _=t.location.parentTerminal;if(_){const g=this._terminals.find(C=>C.value===_);g&&(l.resolvedExtHostIdentifier=g._id)}}else t.location&&typeof t.location!="object"?l.location=t.location:l.location&&typeof l.location=="object"&&"splitActiveTerminal"in l.location&&(l.location={splitActiveTerminal:!0});return l}attachPtyToTerminal(t,l){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const g=new R(l),C=this._setupExtHostProcessListeners(t,g);this._terminalProcessDisposables[t]=C}async $acceptActiveTerminalChanged(t){const l=this._activeTerminal;if(t===null){this._activeTerminal=void 0,l!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const _=this._getTerminalById(t);_&&(this._activeTerminal=_,l!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,l){const _=this._getTerminalById(t);_&&this._onDidWriteTerminalData.fire({terminal:_.value,data:l})}async $acceptTerminalDimensions(t,l,_){const g=this._getTerminalById(t);g&&g.setDimensions(l,_)&&this._onDidChangeTerminalDimensions.fire({terminal:g.value,dimensions:g.value.dimensions})}async $acceptTerminalMaximumDimensions(t,l,_){this._terminalProcesses.get(t)?.resize(l,_)}async $acceptTerminalTitleChange(t,l){const _=this._getTerminalById(t);_&&(_.name=l)}async $acceptTerminalClosed(t,l,_){const g=this._getTerminalObjectIndexById(this._terminals,t);if(g!==null){const C=this._terminals.splice(g,1)[0];C.setExitStatus(l,_),this._onDidCloseTerminal.fire(C.value)}}$acceptTerminalOpened(t,l,_,g){if(l){const W=this._getTerminalObjectIndexById(this._terminals,l);if(W!==null){this._terminals[W]._id=t,this._onDidOpenTerminal.fire(this.terminals[W]),this._terminals[W].isOpen=!0;return}}const C={name:g.name,shellPath:g.executable,shellArgs:g.args,cwd:typeof g.cwd=="string"?g.cwd:L.URI.revive(g.cwd),env:g.env,hideFromUser:g.hideFromUser},U=new v(this._proxy,t,C,_);this._terminals.push(U),this._onDidOpenTerminal.fire(U.value),U.isOpen=!0}async $acceptTerminalProcessId(t,l){this._getTerminalById(t)?._setProcessId(l)}async $startExtensionTerminal(t,l){const _=this._getTerminalById(t);if(!_)return{message:(0,P.localize)(0,null,t)};_.isOpen||await new Promise(C=>{const U=this.onDidOpenTerminal(async W=>{W===_.value&&(U.dispose(),C())})});const g=this._terminalProcesses.get(t);g?g.startSendingEvents(l):this._extensionTerminalAwaitingStart[t]={initialDimensions:l}}_setupExtHostProcessListeners(t,l){const _=new k.DisposableStore;_.add(l.onProcessReady(C=>this._proxy.$sendProcessReady(t,C.pid,C.cwd))),_.add(l.onDidChangeProperty(C=>this._proxy.$sendProcessProperty(t,C))),this._bufferer.startBuffering(t,l.onProcessData),_.add(l.onProcessExit(C=>this._onProcessExit(t,C))),this._terminalProcesses.set(t,l);const g=this._extensionTerminalAwaitingStart[t];return g&&l instanceof R&&(l.startSendingEvents(g.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),_}$acceptProcessAckDataEvent(t,l){this._terminalProcesses.get(t)?.acknowledgeDataEvent(l)}$acceptProcessInput(t,l){this._terminalProcesses.get(t)?.input(l)}$acceptTerminalInteraction(t){const l=this._getTerminalById(t);l?.setInteractedWith()&&this._onDidChangeTerminalState.fire(l.value)}$acceptProcessResize(t,l,_){try{this._terminalProcesses.get(t)?.resize(l,_)}catch(g){if(g.code!=="EPIPE"&&g.code!=="ERR_IPC_CHANNEL_CLOSED")throw g}}$acceptProcessShutdown(t,l){this._terminalProcesses.get(t)?.shutdown(l)}$acceptProcessRequestInitialCwd(t){this._terminalProcesses.get(t)?.getInitialCwd().then(l=>this._proxy.$sendProcessProperty(t,{type:"initialCwd",value:l}))}$acceptProcessRequestCwd(t){this._terminalProcesses.get(t)?.getCwd().then(l=>this._proxy.$sendProcessProperty(t,{type:"cwd",value:l}))}$acceptProcessRequestLatency(t){return Promise.resolve(t)}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new E.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(t,l,_){if(this._profileProviders.has(l))throw new Error(`Terminal profile provider "${l}" already registered`);return this._profileProviders.set(l,_),this._proxy.$registerProfileProvider(l,t.identifier.value),new E.Disposable(()=>{this._profileProviders.delete(l),this._proxy.$unregisterProfileProvider(l)})}async $createContributedProfileTerminal(t,l){const _=new m.CancellationTokenSource().token;let g=await this._profileProviders.get(t)?.provideTerminalProfile(_);if(!_.isCancellationRequested){if(g&&!("options"in g)&&(g={options:g}),!g||!("options"in g))throw new Error(`No terminal profile options provided for id "${t}"`);if("pty"in g.options){this.createExtensionTerminal(g.options,l);return}this.createTerminalFromOptions(g.options,l)}}async $provideLinks(t,l){const _=this._getTerminalById(t);if(!_)return[];this._terminalLinkCache.delete(t),this._terminalLinkCancellationSource.get(t)?.dispose(!0);const C=new m.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,C);const U=[],W={terminal:_.value,line:l},M=[];for(const $ of this._linkProviders)M.push(o.Promises.withAsyncBody(async F=>{C.token.onCancellationRequested(()=>F({provider:$,links:[]}));const q=await $.provideTerminalLinks(W,C.token)||[];C.token.isCancellationRequested||F({provider:$,links:q})}));const S=await Promise.all(M);if(C.token.isCancellationRequested)return[];const z=new Map;for(const $ of S)$&&$.links.length>0&&U.push(...$.links.map(F=>{const q={id:c++,startIndex:F.startIndex,length:F.length,label:F.tooltip};return z.set(q.id,{provider:$.provider,link:F}),q}));return this._terminalLinkCache.set(t,z),U}$activateLink(t,l){const _=this._terminalLinkCache.get(t)?.get(l);!_||_.provider.handleTerminalLink(_.link)}_onProcessExit(t,l){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const _=this._terminalProcessDisposables[t];_&&(_.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,l)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,l){const _=this._getTerminalObjectIndexById(t,l);return _!==null?t[_]:null}_getTerminalObjectIndexById(t,l){let _=null;return t.some((g,C)=>g._id===l?(_=C,!0):!1),_}getEnvironmentVariableCollection(t){let l=this._environmentVariableCollections.get(t.identifier.value);return l||(l=new s,this._setEnvironmentVariableCollection(t.identifier.value,l)),l}_syncEnvironmentVariableCollection(t,l){const _=(0,y.serializeEnvironmentVariableCollection)(l.map);this._proxy.$setEnvironmentVariableCollection(t,l.persistent,_.length===0?void 0:_)}$initEnvironmentVariableCollections(t){t.forEach(l=>{const _=l[0],g=new s(l[1]);this._setEnvironmentVariableCollection(_,g)})}$acceptDefaultProfile(t,l){this._defaultProfile=t,this._defaultAutomationProfile=l}_setEnvironmentVariableCollection(t,l){this._environmentVariableCollections.set(t,l),l.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,l)})}};w=ze([xe(1,D.IExtHostRpcService)],w),e.BaseExtHostTerminalService=w;class s{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new a.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,l){this._setIfDiffers(t,{value:l,type:E.EnvironmentVariableMutatorType.Replace})}append(t,l){this._setIfDiffers(t,{value:l,type:E.EnvironmentVariableMutatorType.Append})}prepend(t,l){this._setIfDiffers(t,{value:l,type:E.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,l){const _=this.map.get(t);(!_||_.value!==l.value||_.type!==l.type)&&(this.map.set(t,l),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,l){this.map.forEach((_,g)=>t.call(l,g,_,this))}[Symbol.iterator](){return this.map.entries()}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=s;let u=class extends w{constructor(t){super(!1,t)}createTerminal(t,l,_){throw new O.NotSupportedError}createTerminalFromOptions(t,l){throw new O.NotSupportedError}};u=ze([xe(0,D.IExtHostRpcService)],u),e.WorkerExtHostTerminalService=u;function n(r){if(!(!r||typeof r=="string"))return"id"in r?{id:r.id,color:r.color}:r}function i(r){return h.ThemeColor.isThemeColor(r)?r:void 0}});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,a,p,b){if(p==="m")throw new TypeError("Private method is not writable");if(p==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return p==="a"?b.call(ne,a):b?b.value=a:e.set(ne,a),a},Oe=this&&this.__classPrivateFieldGet||function(ne,e,a,p){if(a==="a"&&!p)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!p:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?p:a==="a"?p.call(ne):p?p.value:e.get(ne)};define(ye[213],De([1,0,16,23,20,5,173,96,7,26,10,42,4,13,92,8,6,46,65,47]),function(ne,e,a,p,b,L,D,k,E,P,O,y,m,T,f,h,d,o,v,R){"use strict";var c,w;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let s=class{constructor(M,S){this.resultsChangedEmitter=new L.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=M.getProxy(m.MainContext.MainThreadTesting),this.observer=new g(this.proxy),this.runTracker=new n(this.proxy),S.registerArgumentProcessor({processArgument:z=>z?.$mid===13?(0,f.toItemFromContext)(z):z})}createTestController(M,S,z){if(this.controllers.has(M))throw new Error(`Attempt to insert a duplicate controller with ID "${M}"`);const $=new E.DisposableStore,F=$.add(new f.ExtHostTestItemCollection(M,S));F.root.label=S;const q=new Map,ie=this.proxy,A={items:F.root.children,get label(){return S},set label(ce){S=ce,F.root.label=ce,ie.$updateController(M,{label:S})},get refreshHandler(){return z},set refreshHandler(ce){z=ce,ie.$updateController(M,{canRefresh:!!ce})},get id(){return M},createRunProfile:(ce,oe,ue,te,Ee)=>{let be=(0,k.hash)(ce);for(;q.has(be);)be++;return new C(this.proxy,q,M,be,ce,oe,ue,te,Ee)},createTestItem(ce,oe,ue){return new f.TestItemImpl(M,ce,oe,ue)},createTestRun:(ce,oe,ue=!0)=>this.runTracker.createTestRun(M,F,ce,oe,ue),set resolveHandler(ce){F.resolveHandler=ce},get resolveHandler(){return F.resolveHandler},dispose:()=>{$.dispose()}};ie.$registerTestController(M,S,!!z),$.add((0,E.toDisposable)(()=>ie.$unregisterTestController(M)));const Z={controller:A,collection:F,profiles:q};return this.controllers.set(M,Z),$.add((0,E.toDisposable)(()=>this.controllers.delete(M))),$.add(F.onDidGenerateDiff(ce=>ie.$publishDiff(M,ce.map(R.TestsDiffOp.serialize)))),A}createTestObserver(){return this.observer.checkout()}async runTests(M,S=b.CancellationToken.None){const z=i(M);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const $=this.controllers.get(z.controllerId);if(!$)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:M.include?.map(F=>o.TestId.fromExtHostTestItem(F,$.collection.root.id).toString())??[$.collection.root.id],profileGroup:U[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:M.exclude?.map(F=>F.id)},S)}$provideFileCoverage(M,S,z){return(0,a.mapFind)(this.runTracker.trackers,F=>F.id===M?F.getCoverage(S):void 0)?.provideFileCoverage(z)??Promise.resolve([])}$resolveFileCoverage(M,S,z,$){return(0,a.mapFind)(this.runTracker.trackers,q=>q.id===M?q.getCoverage(S):void 0)?.resolveFileCoverage(z,$)??Promise.resolve([])}$configureRunProfile(M,S){this.controllers.get(M)?.profiles.get(S)?.configureHandler?.()}async $refreshTests(M,S){await this.controllers.get(M)?.controller.refreshHandler?.(S)}$publishTestResults(M){this.results=Object.freeze(M.map(S=>(0,P.deepFreeze)(h.TestResults.to(S))).concat(this.results).sort((S,z)=>z.completedAt-S.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(M,S){const z=this.controllers.get(o.TestId.fromString(M).controllerId)?.collection;z&&(await z.expand(M,S<0?1/0:S),z.flushDiff())}$acceptDiff(M){this.observer.applyDiff(M.map(R.TestsDiffOp.deserialize))}async $runControllerTests(M,S){return Promise.all(M.map(z=>this.runControllerTestRequest(z,S)))}async runControllerTestRequest(M,S){const z=this.controllers.get(M.controllerId);if(!z)return{};const{collection:$,profiles:F}=z,q=F.get(M.profileId);if(!q)return{};const ie=M.testIds.map(oe=>$.tree.get(oe)).filter(O.isDefined),A=M.excludeExtIds.map(oe=>z.collection.tree.get(oe)).filter(O.isDefined).filter(oe=>ie.some(ue=>ue.fullId.compare(oe.fullId)===2));if(!ie.length)return{};const Z=new d.TestRunRequest(ie.some(oe=>oe.actual instanceof f.TestItemRootImpl)?void 0:ie.map(oe=>oe.actual),A.map(oe=>oe.actual),q),ce=this.runTracker.prepareForMainThreadTestRun(Z,r.fromInternal(M,z.collection),S);try{return await q.runHandler(Z,S),{}}catch(oe){return{error:String(oe)}}finally{ce.isRunning&&!S.isCancellationRequested&&await L.Event.toPromise(ce.onEnd),ce.dispose()}}$cancelExtensionTestRun(M){M===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(M)}};s=ze([xe(0,T.IExtHostRpcService)],s),e.ExtHostTesting=s;class u extends E.Disposable{constructor(M,S,z){super();this.dto=M,this.proxy=S,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new L.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new b.CancellationTokenSource(z)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:$}of this.tasks.values())$.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(M){return this.tasks.get(M)?.coverage}createRun(M){const S=this.dto.id,z=this.dto.controllerId,$=(0,y.generateUuid)(),F=new t(this.proxy,S,$),q=ce=>(oe,...ue)=>{if(A){console.warn(`Setting the state of test "${oe.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(oe)||(this.ensureTestIsKnown(oe),ce(oe,...ue))},ie=(ce,oe)=>{const ue=oe instanceof Array?oe.map(h.TestMessage.from):[h.TestMessage.from(oe)];if(ce.uri&&ce.range){const te={range:h.Range.from(ce.range),uri:ce.uri};for(const Ee of ue)Ee.location=Ee.location||te}this.proxy.$appendTestMessagesInRun(S,$,o.TestId.fromExtHostTestItem(ce,z).toString(),ue)};let A=!1;const Z={isPersisted:this.dto.isPersisted,token:this.cts.token,name:M,get coverageProvider(){return F.coverageProvider},set coverageProvider(ce){F.coverageProvider=ce},enqueued:q(ce=>{this.proxy.$updateTestStateInRun(S,$,o.TestId.fromExtHostTestItem(ce,z).toString(),1)}),skipped:q(ce=>{this.proxy.$updateTestStateInRun(S,$,o.TestId.fromExtHostTestItem(ce,z).toString(),5)}),started:q(ce=>{this.proxy.$updateTestStateInRun(S,$,o.TestId.fromExtHostTestItem(ce,z).toString(),2)}),errored:q((ce,oe,ue)=>{ie(ce,oe),this.proxy.$updateTestStateInRun(S,$,o.TestId.fromExtHostTestItem(ce,z).toString(),6,ue)}),failed:q((ce,oe,ue)=>{ie(ce,oe),this.proxy.$updateTestStateInRun(S,$,o.TestId.fromExtHostTestItem(ce,z).toString(),4,ue)}),passed:q((ce,oe)=>{this.proxy.$updateTestStateInRun(S,$,o.TestId.fromExtHostTestItem(ce,this.dto.controllerId).toString(),3,oe)}),appendOutput:(ce,oe,ue)=>{A||(ue&&(this.dto.isIncluded(ue)?this.ensureTestIsKnown(ue):ue=void 0),this.proxy.$appendOutputToRun(S,$,p.VSBuffer.fromString(ce),oe&&h.location.from(oe),ue&&o.TestId.fromExtHostTestItem(ue,z).toString()))},end:()=>{A||(A=!0,this.proxy.$finishedTestRunTask(S,$),this.tasks.delete($),this.isRunning||this.dispose())}};return this.tasks.set($,{run:Z,coverage:F}),this.proxy.$startedTestRunTask(S,{id:$,name:M,running:!0}),Z}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(M){if(!(M instanceof f.TestItemImpl))throw new v.InvalidTestItemError(M.id);if(this.sharedTestIds.has(o.TestId.fromExtHostTestItem(M,this.dto.controllerId).toString()))return;const S=[],z=this.dto.colllection.root;for(;;){const $=h.TestItem.from(M);if(S.unshift($),this.sharedTestIds.has($.extId)||(this.sharedTestIds.add($.extId),M===z))break;M=M.parent||z}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,S)}}class n{constructor(M){this.proxy=M,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(M,S,z){return this.getTracker(M,S,z)}cancelRunById(M){for(const S of this.tracked.values())if(S.id===M){S.dispose();return}}cancelAllRuns(){for(const M of this.tracked.values())M.dispose()}createTestRun(M,S,z,$,F){const q=this.tracked.get(z);if(q)return q.createRun($);const ie=r.fromPublic(M,S,z,F),A=i(z);this.proxy.$startedExtensionTestRun({controllerId:M,profile:A&&{group:U[A.kind],id:A.profileId},exclude:z.exclude?.map(ce=>o.TestId.fromExtHostTestItem(ce,S.root.id).toString())??[],id:ie.id,include:z.include?.map(ce=>o.TestId.fromExtHostTestItem(ce,S.root.id).toString())??[S.root.id],persist:F});const Z=this.getTracker(z,ie);return Z.onEnd(()=>this.proxy.$finishedExtensionTestRun(ie.id)),Z.createRun($)}getTracker(M,S,z){const $=new u(S,this.proxy,z);return this.tracked.set(M,$),$.onEnd(()=>this.tracked.delete(M)),$}}e.TestRunCoordinator=n;const i=W=>{if(!!W.profile){if(!(W.profile instanceof C))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return W.profile}};class r{constructor(M,S,z,$,F,q){this.controllerId=M,this.id=S,this.isPersisted=F,this.colllection=q,this.includePrefix=z.map(ie=>ie+"\0"),this.excludePrefix=$.map(ie=>ie+"\0")}static fromPublic(M,S,z,$){return new r(M,(0,y.generateUuid)(),z.include?.map(F=>o.TestId.fromExtHostTestItem(F,M).toString())??[M],z.exclude?.map(F=>o.TestId.fromExtHostTestItem(F,M).toString())??[],$,S)}static fromInternal(M,S){return new r(M.controllerId,M.runId,M.testIds,M.excludeExtIds,!0,S)}isIncluded(M){const S=o.TestId.fromExtHostTestItem(M,this.controllerId).toString()+"\0";for(const z of this.excludePrefix)if(S===z||S.startsWith(z))return!1;for(const z of this.includePrefix)if(S===z||S.startsWith(z))return!0;return!1}}e.TestRunDto=r;class t{constructor(M,S,z){this.proxy=M,this.runId=S,this.taskId=z}set coverageProvider(M){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!M||(this._coverageProvider=M,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(M){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(M))());try{return(await this.fileCoverage)?.map(h.TestCoverage.fromFile)??[]}catch(S){throw this.fileCoverage=void 0,S}}async resolveFileCoverage(M,S){const z=await this.fileCoverage;let $=z?.[M];return!this._coverageProvider||!z||!$?[]:($.detailedCoverage||($=z[M]=await this._coverageProvider.resolveFileCoverage?.($,S)??$),$.detailedCoverage?.map(h.TestCoverage.fromDetailed)??[])}}class l extends R.IncrementalChangeCollector{constructor(M){super();this.emitter=M,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(M){this.added.add(M)}update(M){Object.assign(M.revived,h.TestItem.toPlain(M.item)),this.added.has(M)||this.updated.add(M)}remove(M){if(this.added.has(M)){this.added.delete(M);return}if(this.updated.delete(M),M.parent&&this.alreadyRemoved.has(M.parent)){this.alreadyRemoved.add(M.item.extId);return}this.removed.add(M)}getChangeEvent(){const{added:M,updated:S,removed:z}=this;return{get added(){return[...M].map($=>$.revived)},get updated(){return[...S].map($=>$.revived)},get removed(){return[...z].map($=>$.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class _ extends R.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new L.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(M){return this.items.get(M)}getMirroredTestDataByReference(M){return this.items.get(M.id)}createItem(M,S){return{...M,revived:h.TestItem.toPlain(M.item),depth:S?S.depth+1:0,children:new Set}}createChangeCollector(){return new l(this.changeEmitter)}}e.MirroredTestCollection=_;class g{constructor(M){this.proxy=M}checkout(){this.current||(this.current=this.createObserverData());const M=this.current;return M.observers++,{onDidChangeTest:M.tests.onDidChangeTests,get tests(){return[...M.tests.rootTests].map(S=>S.revived)},dispose:(0,D.once)(()=>{--M.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(M){return this.current?.tests.getMirroredTestDataByReference(M)}applyDiff(M){this.current?.tests.apply(M)}createObserverData(){const M=new _;return this.proxy.$subscribeToDiffs(),{observers:0,tests:M}}}class C{constructor(M,S,z,$,F,q,ie,A=!1,Z=void 0){this.controllerId=z,this.profileId=$,this._label=F,this.kind=q,this.runHandler=ie,this._isDefault=A,this._tag=Z,c.set(this,void 0),w.set(this,void 0),Ye(this,c,M,"f"),Ye(this,w,S,"f"),S.set($,this);const ce=U[q];if(typeof ce!="number")throw new Error(`Unknown TestRunProfile.group ${q}`);Oe(this,c,"f").$publishTestRunProfile({profileId:$,controllerId:z,tag:Z?h.TestTag.namespace(this.controllerId,Z.id):null,label:F,group:ce,isDefault:A,hasConfigurationHandler:!1})}get label(){return this._label}set label(M){M!==this._label&&(this._label=M,Oe(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:M}))}get isDefault(){return this._isDefault}set isDefault(M){M!==this._isDefault&&(this._isDefault=M,Oe(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:M}))}get tag(){return this._tag}set tag(M){M?.id!==this._tag?.id&&(this._tag=M,Oe(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:M?h.TestTag.namespace(this.controllerId,M.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(M){M!==this._configureHandler&&(this._configureHandler=M,Oe(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!M}))}dispose(){Oe(this,w,"f")?.delete(this.profileId)&&(Ye(this,w,void 0,"f"),Oe(this,c,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=C,c=new WeakMap,w=new WeakMap;const U={[d.TestRunProfileKind.Coverage]:8,[d.TestRunProfileKind.Debug]:4,[d.TestRunProfileKind.Run]:2}}),define(ye[214],De([1,0,16,5,4,93,8,6]),function(ne,e,a,p,b,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class E{constructor(O,y){this._extHostDocumentsAndEditors=y,this._onDidChangeTextEditorSelection=new p.Emitter,this._onDidChangeTextEditorOptions=new p.Emitter,this._onDidChangeTextEditorVisibleRanges=new p.Emitter,this._onDidChangeTextEditorViewColumn=new p.Emitter,this._onDidChangeActiveTextEditor=new p.Emitter,this._onDidChangeVisibleTextEditors=new p.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=O.getProxy(b.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(m=>this._onDidChangeVisibleTextEditors.fire(m)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(m=>this._onDidChangeActiveTextEditor.fire(m))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(O){const y=this._extHostDocumentsAndEditors.allEditors();return O?y:y.map(m=>m.value)}async showTextDocument(O,y,m){let T;typeof y=="number"?T={position:D.ViewColumn.from(y),preserveFocus:m}:typeof y=="object"?T={position:D.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selection:typeof y.selection=="object"?D.Range.from(y.selection):void 0,pinned:typeof y.preview=="boolean"?!y.preview:void 0}:T={preserveFocus:!1};const f=await this._proxy.$tryShowTextDocument(O.uri,T),h=f&&this._extHostDocumentsAndEditors.getEditor(f);if(h)return h.value;throw f?new Error(`Could NOT open editor for "${O.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${O.uri.toString()}".`)}createTextEditorDecorationType(O,y){return new L.TextEditorDecorationType(this._proxy,O,y).value}$acceptEditorPropertiesChanged(O,y){const m=this._extHostDocumentsAndEditors.getEditor(O);if(!m)throw new Error("unknown text editor");if(y.options&&m._acceptOptions(y.options),y.selections){const T=y.selections.selections.map(D.Selection.to);m._acceptSelections(T)}if(y.visibleRanges){const T=a.coalesce(y.visibleRanges.map(D.Range.to));m._acceptVisibleRanges(T)}if(y.options&&this._onDidChangeTextEditorOptions.fire({textEditor:m.value,options:{...y.options,lineNumbers:D.TextEditorLineNumbersStyle.to(y.options.lineNumbers)}}),y.selections){const T=k.TextEditorSelectionChangeKind.fromValue(y.selections.source),f=y.selections.selections.map(D.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:m.value,selections:f,kind:T})}if(y.visibleRanges){const T=a.coalesce(y.visibleRanges.map(D.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:m.value,visibleRanges:T})}}$acceptEditorPositionData(O){for(const y in O){const m=this._extHostDocumentsAndEditors.getEditor(y);if(!m)throw new Error("Unknown text editor");const T=D.ViewColumn.to(O[y]);m.value.viewColumn!==T&&(m._acceptViewColumn(T),this._onDidChangeTextEditorViewColumn.fire({textEditor:m.value,viewColumn:T}))}}getDiffInformation(O){return Promise.resolve(this._proxy.$getDiffInformation(O))}}e.ExtHostEditors=E}),define(ye[215],De([1,0,2,3,4,7,6,8,10]),function(ne,e,a,p,b,L,D,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,p.createDecorator)("IExtHostTimeline");class P{constructor(m,T){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=m.getProxy(b.MainContext.MainThreadTimeline),T.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===11){const h=f.uri===void 0?void 0:a.URI.revive(f.uri);return this._itemsBySourceAndUriMap.get(f.source)?.get(O(h))?.get(f.handle)}return f}})}async $getTimeline(m,T,f,h){return this._providers.get(m)?.provideTimeline(a.URI.revive(T),f,h)}registerTimelineProvider(m,T,f,h){const d=new L.DisposableStore,o=this.convertTimelineItem(T.id,h,d).bind(this);let v;T.onDidChange&&(v=T.onDidChange(c=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...c,id:T.id}),this));const R=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...T,scheme:m,onDidChange:void 0,async provideTimeline(c,w,s){w?.resetCache&&(d.clear(),R.get(T.id)?.clear());const u=await T.provideTimeline(c,w,s);if(u==null)return;const n=o(c,w);return{...u,source:T.id,items:u.items.map(n)}},dispose(){for(const c of R.values())c.get(T.id)?.clear();v?.dispose(),d.dispose()}})}convertTimelineItem(m,T,f){return(h,d)=>{let o;if(d?.cacheResults){let v=this._itemsBySourceAndUriMap.get(m);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(m,v));const R=O(h);o=v.get(R),o===void 0&&(o=new Map,v.set(R,o))}return v=>{const{iconPath:R,...c}=v,w=`${m}|${v.id??v.timestamp}`;o?.set(w,v);let s,u,n;v.iconPath&&(R instanceof D.ThemeIcon?n={id:R.id,color:R.color}:a.URI.isUri(R)?(s=R,u=R):{light:s,dark:u}=R);let i;return D.MarkdownString.isMarkdownString(c.tooltip)?i=k.MarkdownString.from(c.tooltip):(0,E.isString)(c.tooltip)?i=c.tooltip:D.MarkdownString.isMarkdownString(c.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),i=k.MarkdownString.from(c.detail)):(0,E.isString)(c.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),i=c.detail),{...c,id:c.id??void 0,handle:w,source:m,command:v.command?T.toInternal(v.command,f):void 0,icon:s,iconDark:u,themeIcon:n,tooltip:i,accessibilityInformation:v.accessibilityInformation}}}}registerTimelineProviderCore(m){if(this._providers.get(m.id))throw new Error(`Timeline Provider ${m.id} already exists.`);return this._proxy.$registerTimelineProvider({id:m.id,label:m.label,scheme:m.scheme}),this._providers.set(m.id,m),(0,L.toDisposable)(()=>{for(const f of this._itemsBySourceAndUriMap.values())f.get(m.id)?.clear();this._providers.delete(m.id),this._proxy.$unregisterTimelineProvider(m.id),m.dispose()})}}e.ExtHostTimeline=P;function O(y){return y?.toString()}}),define(ye[216],De([1,0,7,12,2,4]),function(ne,e,a,p,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class D{constructor(E){this._openers=new Map,this._proxy=E.getProxy(L.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(E,P,O,y){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const m=y.schemes.find(T=>!D.supportedSchemes.has(T));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,O),this._proxy.$registerUriOpener(P,y.schemes,E,y.label),(0,a.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(E,P,O){const y=this._openers.get(E);if(!y)throw new Error(`Unknown opener with id: ${E}`);const m=b.URI.revive(P);return y.canOpenExternalUri(m,O)}async $openUri(E,P,O){const y=this._openers.get(E);if(!y)throw new Error(`Unknown opener id: '${E}'`);return y.openExternalUri(b.URI.revive(P.resolvedUri),{sourceUri:b.URI.revive(P.sourceUri)},O)}}e.ExtHostUriOpeners=D,D.supportedSchemes=new Set([p.Schemas.http,p.Schemas.https])}),define(ye[217],De([1,0,4,2,7,11,27]),function(ne,e,a,p,b,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(a.MainContext.MainThreadUrls)}registerUriHandler(P,O){if(this.handles.has(D.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const y=k.HandlePool++;return this.handles.add(D.ExtensionIdentifier.toKey(P)),this.handlers.set(y,O),this._proxy.$registerUriHandler(y,P),(0,b.toDisposable)(()=>{this.handles.delete(D.ExtensionIdentifier.toKey(P)),this.handlers.delete(y),this._proxy.$unregisterUriHandler(y)})}$handleExternalUri(P,O){const y=this.handlers.get(P);if(!y)return Promise.resolve(void 0);try{y.handleUri(p.URI.revive(O))}catch(m){(0,L.onUnexpectedError)(m)}return Promise.resolve(void 0)}async createAppUri(P){return p.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=k,k.HandlePool=0});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,a,p,b){if(p==="m")throw new TypeError("Private method is not writable");if(p==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return p==="a"?b.call(ne,a):b?b.value=a:e.set(ne,a),a},Oe=this&&this.__classPrivateFieldGet||function(ne,e,a,p){if(a==="a"&&!p)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!p:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?p:a==="a"?p.call(ne):p?p.value:e.get(ne)};define(ye[53],De([1,0,5,12,2,145,162,64,4]),function(ne,e,a,p,b,L,D,k,E){"use strict";var P,O,y,m,T,f,h,d,o,v,R,c;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class w{constructor(_,g,C,U,W,M,S){P.set(this,void 0),O.set(this,void 0),y.set(this,void 0),m.set(this,void 0),T.set(this,void 0),f.set(this,void 0),h.set(this,""),d.set(this,void 0),o.set(this,!1),v.set(this,!1),R.set(this,!1),this._onMessageEmitter=new a.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,c.set(this,new a.Emitter),this._onDidDispose=Oe(this,c,"f").event,Ye(this,P,_,"f"),Ye(this,O,g,"f"),Ye(this,d,C,"f"),Ye(this,m,U,"f"),Ye(this,T,W,"f"),Ye(this,f,M,"f"),Ye(this,R,s(M),"f"),Ye(this,y,S,"f")}dispose(){Ye(this,o,!0,"f"),Oe(this,c,"f").fire(),Oe(this,c,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(_){return Ye(this,v,!0,"f"),(0,k.asWebviewUri)(_,Oe(this,m,"f"))}get cspSource(){const _=Oe(this,f,"f").extensionLocation;if(_.scheme===p.Schemas.https||_.scheme===p.Schemas.http){let g=_.toString();return g.endsWith("/")||(g+="/"),g+" "+k.webviewGenericCspSource}return k.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Oe(this,h,"f")}set html(_){this.assertNotDisposed(),Oe(this,h,"f")!==_&&(Ye(this,h,_,"f"),!Oe(this,v,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(_)&&(Ye(this,v,!0,"f"),Oe(this,y,"f").report("Webview vscode-resource: uris",Oe(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,O,"f").$setHtml(Oe(this,P,"f"),_))}get options(){return this.assertNotDisposed(),Oe(this,d,"f")}set options(_){this.assertNotDisposed(),Oe(this,O,"f").$setOptions(Oe(this,P,"f"),i(Oe(this,f,"f"),Oe(this,T,"f"),_)),Ye(this,d,_,"f")}async postMessage(_){if(Oe(this,o,"f"))return!1;const g=(0,D.serializeWebviewMessage)(_,{serializeBuffersForPostMessage:Oe(this,R,"f")});return Oe(this,O,"f").$postMessage(Oe(this,P,"f"),g.message,...g.buffers)}assertNotDisposed(){if(Oe(this,o,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=w,P=new WeakMap,O=new WeakMap,y=new WeakMap,m=new WeakMap,T=new WeakMap,f=new WeakMap,h=new WeakMap,d=new WeakMap,o=new WeakMap,v=new WeakMap,R=new WeakMap,c=new WeakMap;function s(l){try{const _=(0,L.normalizeVersion)((0,L.parseVersion)(l.engines.vscode));return!!_&&_.majorBase>=1&&_.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=s;class u{constructor(_,g,C,U,W){this.remoteInfo=g,this.workspace=C,this._logService=U,this._deprecationService=W,this._webviews=new Map,this._webviewProxy=_.getProxy(E.MainContext.MainThreadWebviews)}$onMessage(_,g,C){const U=this.getWebview(_);if(U){const{message:W}=(0,D.deserializeWebviewMessage)(g,C.value);U._onMessageEmitter.fire(W)}}$onMissingCsp(_,g){this._logService.warn(`${g} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(_,g,C){const U=new w(_,this._webviewProxy,r(g),this.remoteInfo,this.workspace,C,this._deprecationService);return this._webviews.set(_,U),U._onDidDispose(()=>{this._webviews.delete(_)}),U}deleteWebview(_){this._webviews.delete(_)}getWebview(_){return this._webviews.get(_)}}e.ExtHostWebviews=u;function n(l){return{id:l.identifier,location:l.extensionLocation}}e.toExtensionData=n;function i(l,_,g){return{enableCommandUris:g.enableCommandUris,enableScripts:g.enableScripts,enableForms:g.enableForms,portMapping:g.portMapping,localResourceRoots:g.localResourceRoots||t(l,_)}}e.serializeWebviewOptions=i;function r(l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots?.map(_=>b.URI.from(_))}}e.reviveOptions=r;function t(l,_){return[...(_?.getWorkspaceFolders()||[]).map(g=>g.uri),l.extensionLocation]}}),define(ye[218],De([1,0,20,96,7,12,22,2,8,53,61,4,6]),function(ne,e,a,p,b,L,D,k,E,P,O,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class T{constructor(s,u){this.document=s,this._storagePath=u,this._backupCounter=1,this._edits=new O.Cache("custom documents")}addEdit(s){return this._edits.add([s])}async undo(s,u){await this.getEdit(s).undo(),u||this.disposeBackup()}async redo(s,u){await this.getEdit(s).redo(),u||this.disposeBackup()}disposeEdits(s){for(const u of s)this._edits.delete(u)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const s=c(this.document.uri)+this._backupCounter++;return(0,D.joinPath)(this._storagePath,s)}updateBackup(s){this._backup?.delete(),this._backup=s}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(s){const u=this._edits.get(s,0);if(!u)throw new Error("No edit found");return u}}class f{constructor(){this._documents=new Map}get(s,u){return this._documents.get(this.key(s,u))}add(s,u,n){const i=this.key(s,u.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${s} resource:${u.uri}`);const r=new T(u,n);return this._documents.set(i,r),r}delete(s,u){const n=this.key(s,u.uri);this._documents.delete(n)}key(s,u){return`${s}@@@${u}`}}var h;(function(w){w[w.Text=0]="Text",w[w.Custom=1]="Custom"})(h||(h={}));class d{constructor(){this._providers=new Map}addTextProvider(s,u,n){return this.add(0,s,u,n)}addCustomProvider(s,u,n){return this.add(1,s,u,n)}get(s){return this._providers.get(s)}add(s,u,n,i){if(this._providers.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this._providers.set(u,{type:s,extension:n,provider:i}),new m.Disposable(()=>this._providers.delete(u))}}class o{constructor(s,u,n,i,r){this._extHostDocuments=u,this._extensionStoragePaths=n,this._extHostWebview=i,this._extHostWebviewPanels=r,this._editorProviders=new d,this._documents=new f,this._proxy=s.getProxy(y.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(s,u,n,i){const r=new b.DisposableStore;return v(n)?(r.add(this._editorProviders.addTextProvider(u,s,n)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(s),u,i.webviewOptions||{},{supportsMove:!!n.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(s))):(r.add(this._editorProviders.addCustomProvider(u,s,n)),this.supportEditing(n)&&r.add(n.onDidChangeCustomDocument(t=>{const l=this.getCustomDocumentEntry(u,t.document.uri);if(R(t)){const _=l.addEdit(t);this._proxy.$onDidEdit(t.document.uri,u,_,t.label)}else this._proxy.$onContentChange(t.document.uri,u)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(s),u,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(s))),m.Disposable.from(r,new m.Disposable(()=>{this._proxy.$unregisterEditorProvider(u)}))}async $createCustomDocument(s,u,n,i,r){const t=this._editorProviders.get(u);if(!t)throw new Error(`No provider found for '${u}'`);if(t.type!==1)throw new Error(`Invalid provide type for '${u}'`);const l=k.URI.revive(s),_=await t.provider.openCustomDocument(l,{backupId:n,untitledDocumentData:i?.buffer},r);let g;return this.supportEditing(t.provider)&&this._extensionStoragePaths&&(g=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension)),this._documents.add(u,_,g),{editable:this.supportEditing(t.provider)}}async $disposeCustomDocument(s,u){const n=this._editorProviders.get(u);if(!n)throw new Error(`No provider found for '${u}'`);if(n.type!==1)throw new Error(`Invalid provider type for '${u}'`);const i=k.URI.revive(s),{document:r}=this.getCustomDocumentEntry(u,i);this._documents.delete(u,r),r.dispose()}async $resolveWebviewEditor(s,u,n,i,r,t){const l=this._editorProviders.get(n);if(!l)throw new Error(`No provider found for '${n}'`);const _=E.ViewColumn.to(r),g=this._extHostWebview.createNewWebview(u,i.webviewOptions,l.extension),C=this._extHostWebviewPanels.createNewWebviewPanel(u,n,i.title,_,i.panelOptions,g,!0),U=k.URI.revive(s);switch(l.type){case 1:{const{document:W}=this.getCustomDocumentEntry(n,U);return l.provider.resolveCustomEditor(W,C,t)}case 0:{const W=this._extHostDocuments.getDocument(U);return l.provider.resolveCustomTextEditor(W,C,t)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,u,n){this.getCustomDocumentEntry(u,s).disposeEdits(n)}async $onMoveCustomEditor(s,u,n){const i=this._editorProviders.get(n);if(!i)throw new Error(`No provider found for '${n}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${n}'`);const r=this._extHostWebviewPanels.getWebviewPanel(s);if(!r)throw new Error("No webview found");const t=k.URI.revive(u),l=this._extHostDocuments.getDocument(t);await i.provider.moveCustomTextEditor(l,r,a.CancellationToken.None)}async $undo(s,u,n,i){return this.getCustomDocumentEntry(u,s).undo(n,i)}async $redo(s,u,n,i){return this.getCustomDocumentEntry(u,s).redo(n,i)}async $revert(s,u,n){const i=this.getCustomDocumentEntry(u,s);await this.getCustomEditorProvider(u).revertCustomDocument(i.document,n),i.disposeBackup()}async $onSave(s,u,n){const i=this.getCustomDocumentEntry(u,s);await this.getCustomEditorProvider(u).saveCustomDocument(i.document,n),i.disposeBackup()}async $onSaveAs(s,u,n,i){const r=this.getCustomDocumentEntry(u,s);return this.getCustomEditorProvider(u).saveCustomDocumentAs(r.document,k.URI.revive(n),i)}async $backup(s,u,n){const i=this.getCustomDocumentEntry(u,s),t=await this.getCustomEditorProvider(u).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},n);return i.updateBackup(t),t.id}getCustomDocumentEntry(s,u){const n=this._documents.get(s,k.URI.revive(u));if(!n)throw new Error("No custom document found");return n}getCustomEditorProvider(s){const n=this._editorProviders.get(s)?.provider;if(!n||!this.supportEditing(n))throw new Error("Custom document is not editable");return n}supportEditing(s){return!!s.onDidChangeCustomDocument}}e.ExtHostCustomEditors=o;function v(w){return typeof w.resolveCustomTextEditor=="function"}function R(w){return typeof w.undo=="function"&&typeof w.redo=="function"}function c(w){const s=w.scheme===L.Schemas.file||w.scheme===L.Schemas.untitled?w.fsPath:w.toString();return(0,p.hash)(s)+""}});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,a,p,b){if(p==="m")throw new TypeError("Private method is not writable");if(p==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return p==="a"?b.call(ne,a):b?b.value=a:e.set(ne,a),a},Oe=this&&this.__classPrivateFieldGet||function(ne,e,a,p){if(a==="a"&&!p)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!p:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?p:a==="a"?p.call(ne):p?p.value:e.get(ne)};define(ye[219],De([1,0,5,7,2,42,8,53,4,6]),function(ne,e,a,p,b,L,D,k,E,P){"use strict";var O,y,m,T,f,h,d,o,v,R,c,w,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class u extends p.Disposable{constructor(t,l,_,g){super();O.set(this,void 0),y.set(this,void 0),m.set(this,void 0),T.set(this,void 0),f.set(this,void 0),h.set(this,void 0),d.set(this,void 0),o.set(this,void 0),v.set(this,!0),R.set(this,void 0),c.set(this,!1),w.set(this,this._register(new a.Emitter)),this.onDidDispose=Oe(this,w,"f").event,s.set(this,this._register(new a.Emitter)),this.onDidChangeViewState=Oe(this,s,"f").event,Ye(this,O,t,"f"),Ye(this,y,l,"f"),Ye(this,T,_,"f"),Ye(this,m,g.viewType,"f"),Ye(this,f,g.panelOptions,"f"),Ye(this,o,g.viewColumn,"f"),Ye(this,h,g.title,"f"),Ye(this,R,g.active,"f")}dispose(){Oe(this,c,"f")||(Ye(this,c,!0,"f"),Oe(this,w,"f").fire(),Oe(this,y,"f").$disposeWebview(Oe(this,O,"f")),Oe(this,T,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Oe(this,T,"f")}get viewType(){return this.assertNotDisposed(),Oe(this,m,"f")}get title(){return this.assertNotDisposed(),Oe(this,h,"f")}set title(t){this.assertNotDisposed(),Oe(this,h,"f")!==t&&(Ye(this,h,t,"f"),Oe(this,y,"f").$setTitle(Oe(this,O,"f"),t))}get iconPath(){return this.assertNotDisposed(),Oe(this,d,"f")}set iconPath(t){this.assertNotDisposed(),Oe(this,d,"f")!==t&&(Ye(this,d,t,"f"),Oe(this,y,"f").$setIconPath(Oe(this,O,"f"),b.URI.isUri(t)?{light:t,dark:t}:t))}get options(){return Oe(this,f,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Oe(this,o,"f")=="number"&&Oe(this,o,"f")<0))return Oe(this,o,"f")}get active(){return this.assertNotDisposed(),Oe(this,R,"f")}get visible(){return this.assertNotDisposed(),Oe(this,v,"f")}_updateViewState(t){Oe(this,c,"f")||(this.active!==t.active||this.visible!==t.visible||this.viewColumn!==t.viewColumn)&&(Ye(this,R,t.active,"f"),Ye(this,v,t.visible,"f"),Ye(this,o,t.viewColumn,"f"),Oe(this,s,"f").fire({webviewPanel:this}))}reveal(t,l){this.assertNotDisposed(),Oe(this,y,"f").$reveal(Oe(this,O,"f"),{viewColumn:typeof t=="undefined"?void 0:D.ViewColumn.from(t),preserveFocus:!!l})}assertNotDisposed(){if(Oe(this,c,"f"))throw new Error("Webview is disposed")}}O=new WeakMap,y=new WeakMap,m=new WeakMap,T=new WeakMap,f=new WeakMap,h=new WeakMap,d=new WeakMap,o=new WeakMap,v=new WeakMap,R=new WeakMap,c=new WeakMap,w=new WeakMap,s=new WeakMap;class n{constructor(t,l,_){this.webviews=l,this.workspace=_,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=t.getProxy(E.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,L.generateUuid)()}createWebviewPanel(t,l,_,g,C={}){const U=typeof g=="object"?g.viewColumn:g,W={viewColumn:D.ViewColumn.from(U),preserveFocus:typeof g=="object"&&!!g.preserveFocus},M=(0,k.shouldSerializeBuffersForPostMessage)(t),S=n.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(t),S,l,{title:_,panelOptions:i(C),webviewOptions:(0,k.serializeWebviewOptions)(t,this.workspace,C),serializeBuffersForPostMessage:M},W);const z=this.webviews.createNewWebview(S,C,t);return this.createNewWebviewPanel(S,l,_,U,C,z,!0)}$onDidChangeWebviewPanelViewStates(t){const l=Object.keys(t);l.sort((_,g)=>{const C=t[_],U=t[g];return C.active?1:U.active?-1:+C.visible-+U.visible});for(const _ of l){const g=this.getWebviewPanel(_);if(!g)continue;const C=t[_];g._updateViewState({active:C.active,visible:C.visible,viewColumn:D.ViewColumn.to(C.position)})}}async $onDidDisposeWebviewPanel(t){this.getWebviewPanel(t)?.dispose(),this._webviewPanels.delete(t),this.webviews.deleteWebview(t)}registerWebviewPanelSerializer(t,l,_){if(this._serializers.has(l))throw new Error(`Serializer for '${l}' already registered`);return this._serializers.set(l,{serializer:_,extension:t}),this._proxy.$registerSerializer(l,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(t)}),new P.Disposable(()=>{this._serializers.delete(l),this._proxy.$unregisterSerializer(l)})}async $deserializeWebviewPanel(t,l,_,g){const C=this._serializers.get(l);if(!C)throw new Error(`No serializer found for '${l}'`);const{serializer:U,extension:W}=C,M=this.webviews.createNewWebview(t,_.webviewOptions,W),S=this.createNewWebviewPanel(t,l,_.title,g,_.panelOptions,M,_.active);await U.deserializeWebviewPanel(S,_.state)}createNewWebviewPanel(t,l,_,g,C,U,W){const M=new u(t,this._proxy,U,{viewType:l,title:_,viewColumn:g,panelOptions:C,active:W});return this._webviewPanels.set(t,M),M}getWebviewPanel(t){return this._webviewPanels.get(t)}}e.ExtHostWebviewPanels=n;function i(r){return{enableFindWidget:r.enableFindWidget,retainContextWhenHidden:r.retainContextWhenHidden}}});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,a,p,b){if(p==="m")throw new TypeError("Private method is not writable");if(p==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return p==="a"?b.call(ne,a):b?b.value=a:e.set(ne,a),a},Oe=this&&this.__classPrivateFieldGet||function(ne,e,a,p){if(a==="a"&&!p)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!p:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?p:a==="a"?p.call(ne):p?p.value:e.get(ne)};define(ye[220],De([1,0,5,7,53,24,8,4,6]),function(ne,e,a,p,b,L,D,k,E){"use strict";var P,O,y,m,T,f,h,d,o,v,R,c;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends p.Disposable{constructor(n,i,r,t,l,_,g){super();P.set(this,void 0),O.set(this,void 0),y.set(this,void 0),m.set(this,void 0),T.set(this,void 0),f.set(this,!1),h.set(this,void 0),d.set(this,void 0),o.set(this,void 0),v.set(this,void 0),R.set(this,this._register(new a.Emitter)),this.onDidChangeVisibility=Oe(this,R,"f").event,c.set(this,this._register(new a.Emitter)),this.onDidDispose=Oe(this,c,"f").event,Ye(this,y,r,"f"),Ye(this,d,t,"f"),Ye(this,P,n,"f"),Ye(this,O,i,"f"),Ye(this,m,l,"f"),Ye(this,T,_,"f"),Ye(this,h,g,"f")}dispose(){Oe(this,f,"f")||(Ye(this,f,!0,"f"),Oe(this,c,"f").fire(),Oe(this,m,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Oe(this,d,"f")}set title(n){this.assertNotDisposed(),Oe(this,d,"f")!==n&&(Ye(this,d,n,"f"),Oe(this,O,"f").$setWebviewViewTitle(Oe(this,P,"f"),n))}get description(){return this.assertNotDisposed(),Oe(this,o,"f")}set description(n){this.assertNotDisposed(),Oe(this,o,"f")!==n&&(Ye(this,o,n,"f"),Oe(this,O,"f").$setWebviewViewDescription(Oe(this,P,"f"),n))}get visible(){return Oe(this,h,"f")}get webview(){return Oe(this,m,"f")}get viewType(){return Oe(this,y,"f")}_setVisible(n){n===Oe(this,h,"f")||Oe(this,f,"f")||(Ye(this,h,n,"f"),Oe(this,R,"f").fire())}get badge(){return this.assertNotDisposed(),(0,L.checkProposedApiEnabled)(Oe(this,T,"f"),"badges"),Oe(this,v,"f")}set badge(n){this.assertNotDisposed(),(0,L.checkProposedApiEnabled)(Oe(this,T,"f"),"badges"),!(n?.value===Oe(this,v,"f")?.value&&n?.tooltip===Oe(this,v,"f")?.tooltip)&&(Ye(this,v,D.ViewBadge.from(n),"f"),Oe(this,O,"f").$setWebviewViewBadge(Oe(this,P,"f"),n))}show(n){this.assertNotDisposed(),Oe(this,O,"f").$show(Oe(this,P,"f"),!!n)}assertNotDisposed(){if(Oe(this,f,"f"))throw new Error("Webview is disposed")}}P=new WeakMap,O=new WeakMap,y=new WeakMap,m=new WeakMap,T=new WeakMap,f=new WeakMap,h=new WeakMap,d=new WeakMap,o=new WeakMap,v=new WeakMap,R=new WeakMap,c=new WeakMap;class s{constructor(n,i){this._extHostWebview=i,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=n.getProxy(k.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(n,i,r,t){if(this._viewProviders.has(i))throw new Error(`View provider for '${i}' already registered`);return this._viewProviders.set(i,{provider:r,extension:n}),this._proxy.$registerWebviewViewProvider((0,b.toExtensionData)(n),i,{retainContextWhenHidden:t?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,b.shouldSerializeBuffersForPostMessage)(n)}),new E.Disposable(()=>{this._viewProviders.delete(i),this._proxy.$unregisterWebviewViewProvider(i)})}async $resolveWebviewView(n,i,r,t,l){const _=this._viewProviders.get(i);if(!_)throw new Error(`No view provider found for '${i}'`);const{provider:g,extension:C}=_,U=this._extHostWebview.createNewWebview(n,{},C),W=new w(n,this._proxy,i,r,U,C,!0);this._webviewViews.set(n,W),await g.resolveWebviewView(W,{state:t},l)}async $onDidChangeWebviewViewVisibility(n,i){this.getWebviewView(n)._setVisible(i)}async $disposeWebviewView(n){const i=this.getWebviewView(n);this._webviewViews.delete(n),i.dispose(),this._extHostWebview.deleteWebview(n)}getWebviewView(n){const i=this._webviewViews.get(n);if(!i)throw new Error("No webview found");return i}}e.ExtHostWebviewViews=s}),define(ye[98],De([1,0,5,4,2,12,9,3,13]),function(ne,e,a,p,b,L,D,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class Ji{constructor(y){this._onDidChangeWindowState=new a.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Ji.InitialState,this._proxy=y.getProxy(p.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(m=>this.$onDidChangeWindowFocus(m))}get state(){return this._state}$onDidChangeWindowFocus(y){y!==this._state.focused&&(this._state={...this._state,focused:y},this._onDidChangeWindowState.fire(this._state))}openUri(y,m){let T;if(typeof y=="string"){T=y;try{y=b.URI.parse(y)}catch{return Promise.reject(`Invalid uri - '${y}'`)}}return(0,D.isFalsyOrWhitespace)(y.scheme)?Promise.reject("Invalid scheme - cannot be empty"):y.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${y.scheme}'`):this._proxy.$openUri(y,T,m)}async asExternalUri(y,m){if((0,D.isFalsyOrWhitespace)(y.scheme))return Promise.reject("Invalid scheme - cannot be empty");const T=await this._proxy.$asExternalUri(y,m);return b.URI.from(T)}};P.InitialState={focused:!0},P=ze([xe(0,E.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(ye[221],De([1,0,192,28,13]),function(ne,e,a,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let L=class extends a.AbstractExtHostConsoleForwarder{constructor(k,E){super(k,E)}_nativeConsoleLogMessage(k,E,P){E.apply(console,P)}};L=ze([xe(0,b.IExtHostRpcService),xe(1,p.IExtHostInitDataService)],L),e.ExtHostConsoleForwarder=L}),define(ye[222],De([1,0,14,23,20,11,5,7,118,186,40]),function(ne,e,a,p,b,L,D,k,E,P,O){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function m(C,U){try{return JSON.stringify(C,U)}catch{return"null"}}const T="$$ref$$",f={[T]:-1};class h{constructor(U,W){this.jsonString=U,this.referencedBuffers=W}}function d(C,U=null,W=!1){const M=[];return{jsonString:(W?m:JSON.stringify)(C,(z,$)=>{if(typeof $=="undefined")return f;if(typeof $=="object"){if($ instanceof p.VSBuffer){const F=M.push($)-1;return{[T]:F}}if(U)return U(z,$)}return $}),referencedBuffers:M}}e.stringifyJsonWithBufferRefs=d;function o(C,U,W){return JSON.parse(C,(M,S)=>{if(S){const z=S[T];if(typeof z=="number")return U[z];if(W&&S.$mid===1)return W.transformIncoming(S)}return S})}e.parseJsonAndRestoreBufferRefs=o;function v(C,U){return JSON.stringify(C,U)}function R(C){return C?(U,W)=>W&&W.$mid===1?C.transformOutgoing(W):W:null}var c;(function(C){C[C.LocalSide=0]="LocalSide",C[C.OtherSide=1]="OtherSide"})(c=e.RequestInitiator||(e.RequestInitiator={}));var w;(function(C){C[C.Responsive=0]="Responsive",C[C.Unresponsive=1]="Unresponsive"})(w=e.ResponsiveState||(e.ResponsiveState={}));const s=()=>{},u=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class i extends k.Disposable{constructor(U,W=null,M=null){super();this[y]=!0,this._onDidChangeResponsiveState=this._register(new D.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=U,this._logger=W,this._uriTransformer=M,this._uriReplacer=R(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let S=0,z=O.ProxyIdentifier.count;S<z;S++)this._locals[S]=null,this._proxies[S]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new a.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(S=>this._receiveOneMessage(S))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(U=>{this._pendingRPCReplies[U].resolveErr(L.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(U){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(U){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(U){this._responsiveState!==U&&(this._responsiveState=U,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(U){return this._uriTransformer?(0,E.transformIncomingURIs)(U,this._uriTransformer):U}getProxy(U){const{nid:W,sid:M}=U;return this._proxies[W]||(this._proxies[W]=this._createProxy(W,M)),this._proxies[W]}_createProxy(U,W){const M={get:(S,z)=>(typeof z=="string"&&!S[z]&&z.charCodeAt(0)===36&&(S[z]=(...$)=>this._remoteCall(U,z,$)),z===n?W:S[z])};return new Proxy(Object.create(null),M)}set(U,W){return this._locals[U.nid]=W,W}assertRegistered(U){for(let W=0,M=U.length;W<M;W++){const S=U[W];if(!this._locals[S.nid])throw new Error(`Missing proxy instance ${S.sid}`)}}_receiveOneMessage(U){if(this._isDisposed)return;const W=U.byteLength,M=r.read(U,0),S=M.readUInt8(),z=M.readUInt32();switch(S){case 1:case 2:{let{rpcId:$,method:F,args:q}=l.deserializeRequestJSONArgs(M);this._uriTransformer&&(q=(0,E.transformIncomingURIs)(q,this._uriTransformer)),this._receiveRequest(W,z,$,F,q,S===2);break}case 3:case 4:{let{rpcId:$,method:F,args:q}=l.deserializeRequestMixedArgs(M);this._uriTransformer&&(q=(0,E.transformIncomingURIs)(q,this._uriTransformer)),this._receiveRequest(W,z,$,F,q,S===4);break}case 5:{this._logger?.logIncoming(W,z,0,"ack"),this._onDidReceiveAcknowledge(z);break}case 6:{this._receiveCancel(W,z);break}case 7:{this._receiveReply(W,z,void 0);break}case 9:{let $=l.deserializeReplyOKJSON(M);this._uriTransformer&&($=(0,E.transformIncomingURIs)($,this._uriTransformer)),this._receiveReply(W,z,$);break}case 10:{const $=l.deserializeReplyOKJSONWithBuffers(M,this._uriTransformer);this._receiveReply(W,z,$);break}case 8:{const $=l.deserializeReplyOKVSBuffer(M);this._receiveReply(W,z,$);break}case 11:{let $=l.deserializeReplyErrError(M);this._uriTransformer&&($=(0,E.transformIncomingURIs)($,this._uriTransformer)),this._receiveReplyErr(W,z,$);break}case 12:{this._receiveReplyErr(W,z,void 0);break}default:console.error("received unexpected message"),console.error(U)}}_receiveRequest(U,W,M,S,z,$){this._logger?.logIncoming(U,W,1,`receiveRequest ${(0,O.getStringIdentifierForProxy)(M)}.${S}(`,z);const F=String(W);let q,ie;if($){const Z=new b.CancellationTokenSource;z.push(Z.token),q=this._invokeHandler(M,S,z),ie=()=>Z.cancel()}else q=this._invokeHandler(M,S,z),ie=s;this._cancelInvokedHandlers[F]=ie;const A=l.serializeAcknowledged(W);this._logger?.logOutgoing(A.byteLength,W,1,"ack"),this._protocol.send(A),q.then(Z=>{delete this._cancelInvokedHandlers[F];const ce=l.serializeReplyOK(W,Z,this._uriReplacer);this._logger?.logOutgoing(ce.byteLength,W,1,"reply:",Z),this._protocol.send(ce)},Z=>{delete this._cancelInvokedHandlers[F];const ce=l.serializeReplyErr(W,Z);this._logger?.logOutgoing(ce.byteLength,W,1,"replyErr:",Z),this._protocol.send(ce)})}_receiveCancel(U,W){this._logger?.logIncoming(U,W,1,"receiveCancel");const M=String(W);this._cancelInvokedHandlers[M]?.()}_receiveReply(U,W,M){this._logger?.logIncoming(U,W,0,"receiveReply:",M);const S=String(W);if(!this._pendingRPCReplies.hasOwnProperty(S))return;const z=this._pendingRPCReplies[S];delete this._pendingRPCReplies[S],z.resolveOk(M)}_receiveReplyErr(U,W,M){this._logger?.logIncoming(U,W,0,"receiveReplyErr:",M);const S=String(W);if(!this._pendingRPCReplies.hasOwnProperty(S))return;const z=this._pendingRPCReplies[S];delete this._pendingRPCReplies[S];let $;M&&(M.$isError?($=new Error,$.name=M.name,$.message=M.message,$.stack=M.stack):$=M),z.resolveErr($)}_invokeHandler(U,W,M){try{return Promise.resolve(this._doInvokeHandler(U,W,M))}catch(S){return Promise.reject(S)}}_doInvokeHandler(U,W,M){const S=this._locals[U];if(!S)throw new Error("Unknown actor "+(0,O.getStringIdentifierForProxy)(U));const z=S[W];if(typeof z!="function")throw new Error("Unknown method "+W+" on actor "+(0,O.getStringIdentifierForProxy)(U));return z.apply(S,M)}_remoteCall(U,W,M){if(this._isDisposed)return new P.CanceledLazyPromise;let S=null;if(M.length>0&&b.CancellationToken.isCancellationToken(M[M.length-1])&&(S=M.pop()),S&&S.isCancellationRequested)return Promise.reject(L.canceled());const z=l.serializeRequestArguments(M,this._uriReplacer),$=++this._lastMessageId,F=String($),q=new P.LazyPromise;S&&S.onCancellationRequested(()=>{const A=l.serializeCancel($);this._logger?.logOutgoing(A.byteLength,$,0,"cancel"),this._protocol.send(l.serializeCancel($))}),this._pendingRPCReplies[F]=q,this._onWillSendRequest($);const ie=l.serializeRequest($,U,W,z,!!S);return this._logger?.logOutgoing(ie.byteLength,$,0,`request: ${(0,O.getStringIdentifierForProxy)(U)}.${W}(`,M),this._protocol.send(ie),q}}e.RPCProtocol=i,y=u,i.UNRESPONSIVE_TIME=3*1e3;class r{constructor(U,W){this._buff=U,this._offset=W}static alloc(U,W,M){const S=new r(p.VSBuffer.alloc(M+1+4),0);return S.writeUInt8(U),S.writeUInt32(W),S}static read(U,W){return new r(U,W)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(U){this._buff.writeUInt8(U,this._offset),this._offset+=1}readUInt8(){const U=this._buff.readUInt8(this._offset);return this._offset+=1,U}writeUInt32(U){this._buff.writeUInt32BE(U,this._offset),this._offset+=4}readUInt32(){const U=this._buff.readUInt32BE(this._offset);return this._offset+=4,U}static sizeShortString(U){return 1+U.byteLength}writeShortString(U){this._buff.writeUInt8(U.byteLength,this._offset),this._offset+=1,this._buff.set(U,this._offset),this._offset+=U.byteLength}readShortString(){const U=this._buff.readUInt8(this._offset);this._offset+=1;const M=this._buff.slice(this._offset,this._offset+U).toString();return this._offset+=U,M}static sizeLongString(U){return 4+U.byteLength}writeLongString(U){this._buff.writeUInt32BE(U.byteLength,this._offset),this._offset+=4,this._buff.set(U,this._offset),this._offset+=U.byteLength}readLongString(){const U=this._buff.readUInt32BE(this._offset);this._offset+=4;const M=this._buff.slice(this._offset,this._offset+U).toString();return this._offset+=U,M}writeBuffer(U){this._buff.writeUInt32BE(U.byteLength,this._offset),this._offset+=4,this._buff.set(U,this._offset),this._offset+=U.byteLength}static sizeVSBuffer(U){return 4+U.byteLength}writeVSBuffer(U){this._buff.writeUInt32BE(U.byteLength,this._offset),this._offset+=4,this._buff.set(U,this._offset),this._offset+=U.byteLength}readVSBuffer(){const U=this._buff.readUInt32BE(this._offset);this._offset+=4;const W=this._buff.slice(this._offset,this._offset+U);return this._offset+=U,W}static sizeMixedArray(U){let W=0;W+=1;for(let M=0,S=U.length;M<S;M++){const z=U[M];switch(W+=1,z.type){case 1:W+=this.sizeLongString(z.value);break;case 2:W+=this.sizeVSBuffer(z.value);break;case 3:W+=this.sizeUInt32,W+=this.sizeLongString(z.value);for(let $=0;$<z.buffers.length;++$)W+=this.sizeVSBuffer(z.buffers[$]);break;case 4:break}}return W}writeMixedArray(U){this._buff.writeUInt8(U.length,this._offset),this._offset+=1;for(let W=0,M=U.length;W<M;W++){const S=U[W];switch(S.type){case 1:this.writeUInt8(1),this.writeLongString(S.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(S.value);break;case 3:this.writeUInt8(3),this.writeUInt32(S.buffers.length),this.writeLongString(S.value);for(let z=0;z<S.buffers.length;++z)this.writeBuffer(S.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const U=this._buff.readUInt8(this._offset);this._offset+=1;const W=new Array(U);for(let M=0;M<U;M++)switch(this.readUInt8()){case 1:W[M]=this.readLongString();break;case 2:W[M]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),$=this.readLongString(),F=[];for(let q=0;q<z;++q)F.push(this.readVSBuffer());W[M]=new O.SerializableObjectWithBuffers(o($,F,null));break}case 4:W[M]=void 0;break}return W}}r.sizeUInt32=4;var t;(function(C){C[C.Simple=0]="Simple",C[C.Mixed=1]="Mixed"})(t||(t={}));class l{static _useMixedArgSerialization(U){for(let W=0,M=U.length;W<M;W++)if(U[W]instanceof p.VSBuffer||U[W]instanceof O.SerializableObjectWithBuffers||typeof U[W]=="undefined")return!0;return!1}static serializeRequestArguments(U,W){if(this._useMixedArgSerialization(U)){const M=[];for(let S=0,z=U.length;S<z;S++){const $=U[S];if($ instanceof p.VSBuffer)M[S]={type:2,value:$};else if(typeof $=="undefined")M[S]={type:4};else if($ instanceof O.SerializableObjectWithBuffers){const{jsonString:F,referencedBuffers:q}=d($.value,W);M[S]={type:3,value:p.VSBuffer.fromString(F),buffers:q}}else M[S]={type:1,value:p.VSBuffer.fromString(v($,W))}}return{type:1,args:M}}return{type:0,args:v(U,W)}}static serializeRequest(U,W,M,S,z){switch(S.type){case 0:return this._requestJSONArgs(U,W,M,S.args,z);case 1:return this._requestMixedArgs(U,W,M,S.args,z)}}static _requestJSONArgs(U,W,M,S,z){const $=p.VSBuffer.fromString(M),F=p.VSBuffer.fromString(S);let q=0;q+=r.sizeUInt8(),q+=r.sizeShortString($),q+=r.sizeLongString(F);const ie=r.alloc(z?2:1,U,q);return ie.writeUInt8(W),ie.writeShortString($),ie.writeLongString(F),ie.buffer}static deserializeRequestJSONArgs(U){const W=U.readUInt8(),M=U.readShortString(),S=U.readLongString();return{rpcId:W,method:M,args:JSON.parse(S)}}static _requestMixedArgs(U,W,M,S,z){const $=p.VSBuffer.fromString(M);let F=0;F+=r.sizeUInt8(),F+=r.sizeShortString($),F+=r.sizeMixedArray(S);const q=r.alloc(z?4:3,U,F);return q.writeUInt8(W),q.writeShortString($),q.writeMixedArray(S),q.buffer}static deserializeRequestMixedArgs(U){const W=U.readUInt8(),M=U.readShortString(),S=U.readMixedArray(),z=new Array(S.length);for(let $=0,F=S.length;$<F;$++){const q=S[$];typeof q=="string"?z[$]=JSON.parse(q):z[$]=q}return{rpcId:W,method:M,args:z}}static serializeAcknowledged(U){return r.alloc(5,U,0).buffer}static serializeCancel(U){return r.alloc(6,U,0).buffer}static serializeReplyOK(U,W,M){if(typeof W=="undefined")return this._serializeReplyOKEmpty(U);if(W instanceof p.VSBuffer)return this._serializeReplyOKVSBuffer(U,W);if(W instanceof O.SerializableObjectWithBuffers){const{jsonString:S,referencedBuffers:z}=d(W.value,M,!0);return this._serializeReplyOKJSONWithBuffers(U,S,z)}else return this._serializeReplyOKJSON(U,m(W,M))}static _serializeReplyOKEmpty(U){return r.alloc(7,U,0).buffer}static _serializeReplyOKVSBuffer(U,W){let M=0;M+=r.sizeVSBuffer(W);const S=r.alloc(8,U,M);return S.writeVSBuffer(W),S.buffer}static deserializeReplyOKVSBuffer(U){return U.readVSBuffer()}static _serializeReplyOKJSON(U,W){const M=p.VSBuffer.fromString(W);let S=0;S+=r.sizeLongString(M);const z=r.alloc(9,U,S);return z.writeLongString(M),z.buffer}static _serializeReplyOKJSONWithBuffers(U,W,M){const S=p.VSBuffer.fromString(W);let z=0;z+=r.sizeUInt32,z+=r.sizeLongString(S);for(const F of M)z+=r.sizeVSBuffer(F);const $=r.alloc(10,U,z);$.writeUInt32(M.length),$.writeLongString(S);for(const F of M)$.writeBuffer(F);return $.buffer}static deserializeReplyOKJSON(U){const W=U.readLongString();return JSON.parse(W)}static deserializeReplyOKJSONWithBuffers(U,W){const M=U.readUInt32(),S=U.readLongString(),z=[];for(let $=0;$<M;++$)z.push(U.readVSBuffer());return new O.SerializableObjectWithBuffers(o(S,z,W))}static serializeReplyErr(U,W){const M=W?m(L.transformErrorForSerialization(W),null):void 0;if(typeof M!="string")return this._serializeReplyErrEmpty(U);const S=p.VSBuffer.fromString(M);let z=0;z+=r.sizeLongString(S);const $=r.alloc(11,U,z);return $.writeLongString(S),$.buffer}static deserializeReplyErrError(U){const W=U.readLongString();return JSON.parse(W)}static _serializeReplyErrEmpty(U){return r.alloc(12,U,0).buffer}}var _;(function(C){C[C.RequestJSONArgs=1]="RequestJSONArgs",C[C.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",C[C.RequestMixedArgs=3]="RequestMixedArgs",C[C.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",C[C.Acknowledged=5]="Acknowledged",C[C.Cancel=6]="Cancel",C[C.ReplyOKEmpty=7]="ReplyOKEmpty",C[C.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",C[C.ReplyOKJSON=9]="ReplyOKJSON",C[C.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",C[C.ReplyErrError=11]="ReplyErrError",C[C.ReplyErrEmpty=12]="ReplyErrEmpty"})(_||(_={}));var g;(function(C){C[C.String=1]="String",C[C.VSBuffer=2]="VSBuffer",C[C.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",C[C.Undefined=4]="Undefined"})(g||(g={}))}),define(ye[223],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const a=function(L){const D=k=>{self.removeEventListener("message",D);const E=k.data;Object.defineProperties(self,{postMessage:{value(P,O){E.postMessage(P,O)}},onmessage:{get(){return E.onmessage},set(P){E.onmessage=P}}}),E.addEventListener("message",P=>{self.dispatchEvent(new MessageEvent("message",{data:P.data}))}),E.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(L)};self.addEventListener("message",D)}.toString();class p extends EventTarget{constructor(L,D,k){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const E=`((${a})('${D}'))`,P=new Blob([E],{type:"application/javascript"}),O=URL.createObjectURL(P),y=new MessageChannel,m=O,T={type:"_newWorker",id:m,port:y.port2,url:O,options:k};L(T,[y.port2]),this.postMessage=y.port1.postMessage.bind(y.port1),this.terminate=()=>{L({type:"_terminateWorker",id:m}),URL.revokeObjectURL(O),y.port1.close(),y.port2.close()},Object.defineProperties(this,{onmessage:{get(){return y.port1.onmessage},set(f){y.port1.onmessage=f}},onmessageerror:{get(){return y.port1.onmessageerror},set(f){y.port1.onmessageerror=f}}}),y.port1.addEventListener("messageerror",f=>{const h=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(h)}),y.port1.addEventListener("message",f=>{const h=new MessageEvent("message",{data:f.data});this.dispatchEvent(h)}),y.port1.start()}}e.NestedWorker=p}),define(ye[224],De([1,0,5,30,38,3,39,11,14]),function(ne,e,a,p,b,L,D,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new b.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new b.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new b.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,L.createDecorator)(e.OUTPUT_SERVICE_ID);var P;(function(T){T[T.Append=1]="Append",T[T.Replace=2]="Replace",T[T.Clear=3]="Clear"})(P=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class O{constructor(){this.channels=new Map,this._onDidRegisterChannel=new a.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new a.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(f){this.channels.has(f.id)||(this.channels.set(f.id,f),this._onDidRegisterChannel.fire(f.id))}getChannels(){const f=[];return this.channels.forEach(h=>f.push(h)),f}getChannel(f){return this.channels.get(f)}removeChannel(f){this.channels.delete(f),this._onDidRemoveChannel.fire(f)}}p.Registry.add(e.Extensions.OutputChannels,new O);function y(T,f,h,d,o){return(0,E.createCancelablePromise)(async v=>{await(0,D.whenProviderRegistered)(h,d);const R=p.Registry.as(e.Extensions.OutputChannels);try{await m(h,1,d,o,v),R.registerChannel({id:T,label:f,file:h,log:!0})}catch(c){(0,k.isCancellationError)(c)||o.error("Error while registering log channel",h.toString(),(0,k.getErrorMessage)(c))}})}e.registerLogChannel=y;async function m(T,f,h,d,o){if(!await h.exists(T)){if(o.isCancellationRequested)throw new k.CancellationError;if(f>10)throw new Error("Timed out while waiting for file to be created");d.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",T.toString()),await(0,E.timeout)(1e3,o),await m(T,f+1,h,d,o)}}}),define(ye[99],De([1,0,4,7,3,13,15,224,51,28,35,112,23,10]),function(ne,e,a,p,b,L,D,k,E,P,O,y,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class f extends p.Disposable{constructor(o,v,R,c){super();this.id=o,this.name=v,this.logger=R,this.proxy=c,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(o){this.append(o+`
`)}append(o){this.write(o),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Append))}clear(){const o=this.offset;this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Clear,o)}replace(o){const v=this.offset;this.write(o),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Replace,v),this.visible&&this.logger.flush()}show(o,v){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof o=="boolean"?o:v))}hide(){this.proxy.$close(this.id)}write(o){this.offset+=m.VSBuffer.fromString(o).byteLength,this.logger.info(o)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=f;let h=class{constructor(o,v,R,c,w){this.extHostFileSystem=R,this.extHostFileSystemInfo=c,this.loggerService=w,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=o.getProxy(a.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(v.logsLocation,`output_logging_${(0,y.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(o){this.visibleChannelId=o;for(const[v,R]of this.channels)R.visible=v===this.visibleChannelId}createOutputChannel(o,v,R){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");if((0,T.isString)(v)&&!v.trim())throw new Error("illegal argument `languageId`. must not be empty");const c=this.doCreateOutputChannel(o,v,R);return c.then(w=>{this.channels.set(w.id,w),w.visible=w.id===this.visibleChannelId}),this.createExtHostOutputChannel(o,c)}async doCreateOutputChannel(o,v,R){const c=await this.createOutputDirectory(),w=this.extHostFileSystemInfo.extUri.joinPath(c,`${this.namePool++}-${o.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),s=this.loggerService.createLogger(w,{always:!0,donotRotate:!0,donotUseFormatters:!0}),u=await this.proxy.$register(o,!1,w,v,R.identifier.value);return new f(u,o,s,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(o,v){let R=!1;const c=()=>{if(R)throw new Error("Channel has been closed")};return{get name(){return o},append(w){c(),v.then(s=>s.append(w))},appendLine(w){c(),v.then(s=>s.appendLine(w))},clear(){c(),v.then(w=>w.clear())},replace(w){c(),v.then(s=>s.replace(w))},show(w,s){c(),v.then(u=>u.show(w,s))},hide(){c(),v.then(w=>w.hide())},dispose(){R=!0,v.then(w=>w.dispose())}}}};h=ze([xe(0,L.IExtHostRpcService),xe(1,P.IExtHostInitDataService),xe(2,E.IExtHostConsumerFileSystem),xe(3,O.IExtHostFileSystemInfo),xe(4,D.ILoggerService)],h),e.ExtHostOutputService=h,e.IExtHostOutputService=(0,b.createDecorator)("IExtHostOutputService")}),define(ye[225],De([1,0,3]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,a.createDecorator)("remoteAgentService")}),define(ye[226],De([1,0,37,12,19,21,22,2,3,157,45,178,225]),function(ne,e,a,p,b,L,D,k,E,P,O,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,E.createDecorator)("pathService");let T=class Zi{constructor(h,d,o,v){this.localUserHome=h,this.remoteAgentService=d,this.environmentService=o,this.contextService=v,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||L.OS)(),this.resolveUserHome=(async()=>{const R=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=R?.userHome??h})()}hasValidBasename(h,d,o){return typeof d=="string"||typeof d=="undefined"?this.resolveOS.then(v=>this.doHasValidBasename(h,v,d)):this.doHasValidBasename(h,d,o)}doHasValidBasename(h,d,o){return h.scheme===p.Schemas.file||h.scheme===p.Schemas.vscodeRemote?(0,a.isValidBasename)(o??(0,D.basename)(h),d===1):!0}get defaultUriScheme(){return Zi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(h,d){if(h.remoteAuthority)return p.Schemas.vscodeRemote;const o=(0,P.getVirtualWorkspaceScheme)(d.getWorkspace());if(o)return o;const v=d.getWorkspace().folders[0];if(v)return v.uri.scheme;const R=d.getWorkspace().configuration;return R?R.scheme:p.Schemas.file}userHome(h){return h?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(h=>h===1?b.win32:b.posix)}async fileURI(h){let d="";if(await this.resolveOS===1&&(h=h.replace(/\\/g,"/")),h[0]==="/"&&h[1]==="/"){const v=h.indexOf("/",2);v===-1?(d=h.substring(2),h="/"):(d=h.substring(2,v),h=h.substring(v)||"/")}return k.URI.from({scheme:p.Schemas.file,authority:d,path:h,query:"",fragment:""})}};T=ze([xe(1,m.IRemoteAgentService),xe(2,y.IWorkbenchEnvironmentService),xe(3,O.IWorkspaceContextService)],T),e.AbstractPathService=T}),define(ye[100],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class a{constructor(D,k){this.line=D,this.character=k}isBefore(D){return!1}isBeforeOrEqual(D){return!1}isAfter(D){return!1}isAfterOrEqual(D){return!1}isEqual(D){return!1}compareTo(D){return 0}translate(D,k){return new a(0,0)}with(D){return new a(0,0)}}e.Position=a;class p{constructor(D,k,E,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new a(D,k),this.end=new a(E,P)}contains(D){return!1}isEqual(D){return!1}intersection(D){}union(D){return new p(0,0,0,0)}with(D){return new p(0,0,0,0)}}e.Range=p;var b;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(b=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ye[41],De([1,0,16,34,26,37,9,3,19,11,100,14]),function(ne,e,a,p,b,L,D,k,E,P,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return O.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const m="\u27EA ",T=" characters skipped \u27EB",f=(m.length+T.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var h;(function(oe){oe[oe.file=0]="file",oe[oe.text=1]="text"})(h=e.SearchProviderType||(e.SearchProviderType={}));var d;(function(oe){oe[oe.File=1]="File",oe[oe.Text=2]="Text"})(d=e.QueryType||(e.QueryType={}));function o(oe){return!!oe.preview}e.resultIsMatch=o;function v(oe){return!!oe.resource}e.isFileMatch=v;function R(oe){return!!oe.message}e.isProgressMessage=R;var c;(function(oe){oe[oe.Normal=0]="Normal",oe[oe.NewSearchStarted=1]="NewSearchStarted"})(c=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class w{constructor(ue){this.resource=ue,this.results=[]}}e.FileMatch=w;class s{constructor(ue,te,Ee){this.ranges=te;const be=Array.isArray(te)?te:[te];if(Ee&&Ee.matchLines===1&&u(be)){ue=(0,D.getNLines)(ue,Ee.matchLines);let ee="",ve=0,Ae=0;const Fe=Math.floor(Ee.charsPerLine/5),$e=[];for(const Qe of be){const Ie=Math.max(Qe.startColumn-Fe,0),Se=Qe.startColumn+Ee.charsPerLine;if(Ie>Ae+Fe+f){const ke=m+(Ie-Ae)+T;ee+=ke+ue.slice(Ie,Se),ve+=Ie-(Ae+ke.length)}else ee+=ue.slice(Ae,Se);$e.push(new i(0,Qe.startColumn-ve,Qe.endColumn-ve)),Ae=Se}this.preview={text:ee,matches:Array.isArray(this.ranges)?$e:$e[0]}}else{const ee=Array.isArray(te)?te[0].startLineNumber:te.startLineNumber;this.preview={text:ue,matches:(0,a.mapArrayOrNot)(te,ve=>new n(ve.startLineNumber-ee,ve.startColumn,ve.endLineNumber-ee,ve.endColumn))}}}}e.TextSearchMatch=s;function u(oe){const ue=oe[0].startLineNumber;for(const te of oe)if(te.startLineNumber!==ue||te.endLineNumber!==ue)return!1;return!0}class n{constructor(ue,te,Ee,be){this.startLineNumber=ue,this.startColumn=te,this.endLineNumber=Ee,this.endColumn=be}}e.SearchRange=n;class i extends n{constructor(ue,te,Ee){super(ue,te,ue,Ee)}}e.OneLineRange=i;var r;(function(oe){oe.Default="default",oe.FileNames="fileNames",oe.Type="type",oe.Modified="modified",oe.CountDescending="countDescending",oe.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function t(oe,ue=!0){const te=oe&&oe.files&&oe.files.exclude,Ee=ue&&oe&&oe.search&&oe.search.exclude;if(!te&&!Ee)return;if(!te||!Ee)return te||Ee;let be=Object.create(null);return be=b.mixin(be,b.deepClone(te)),be=b.mixin(be,b.deepClone(Ee),!0),be}e.getExcludes=t;function l(oe,ue){return oe.excludePattern&&p.match(oe.excludePattern,ue)?!1:oe.includePattern||oe.usingSearchPaths?oe.includePattern&&p.match(oe.includePattern,ue)?!0:oe.usingSearchPaths?!!oe.folderQueries&&oe.folderQueries.some(te=>{const Ee=te.folder.fsPath;if(L.isEqualOrParent(ue,Ee)){const be=E.relative(Ee,ue);return!te.includePattern||!!p.match(te.includePattern,be)}else return!1}):!1:!0}e.pathIncludedInQuery=l;var _;(function(oe){oe[oe.unknownEncoding=1]="unknownEncoding",oe[oe.regexParseError=2]="regexParseError",oe[oe.globParseError=3]="globParseError",oe[oe.invalidLiteral=4]="invalidLiteral",oe[oe.rgProcessError=5]="rgProcessError",oe[oe.other=6]="other",oe[oe.canceled=7]="canceled"})(_=e.SearchErrorCode||(e.SearchErrorCode={}));class g extends Error{constructor(ue,te){super(ue);this.code=te}}e.SearchError=g;function C(oe){const ue=oe.message;if((0,P.isCancellationError)(oe))return new g(ue,_.canceled);try{const te=JSON.parse(ue);return new g(te.message,te.code)}catch{return new g(ue,_.other)}}e.deserializeSearchError=C;function U(oe){const ue={message:oe.message,code:oe.code};return new Error(JSON.stringify(ue))}e.serializeSearchError=U;function W(oe){return oe.type==="error"?!0:oe.type==="success"}e.isSerializedSearchComplete=W;function M(oe){return oe.type==="success"}e.isSerializedSearchSuccess=M;function S(oe){return!!oe.path}e.isSerializedFileMatch=S;function z(oe,ue){const te=oe.searchPath?oe.searchPath:oe.relativePath;return(0,D.fuzzyContains)(te,ue)}e.isFilePatternMatch=z;class ${constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=$;function F(oe,ue){const te={...oe||{},...ue||{}};return Object.keys(te).filter(Ee=>{const be=te[Ee];return typeof be=="boolean"&&be})}e.resolvePatternsForProvider=F;class q{constructor(ue,te){this._parsedIncludeExpression=null,this._excludeExpression={...ue.excludePattern||{},...te.excludePattern||{}},this._parsedExcludeExpression=p.parse(this._excludeExpression);let Ee=ue.includePattern;te.includePattern&&(Ee?Ee={...Ee,...te.includePattern}:Ee=te.includePattern),Ee&&(this._parsedIncludeExpression=p.parse(Ee))}matchesExcludesSync(ue,te,Ee){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ue,te,Ee))}includedInQuerySync(ue,te,Ee){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ue,te,Ee)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ue,te,Ee))}includedInQuery(ue,te,Ee){const be=this._parsedExcludeExpression(ue,te,Ee),ee=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ue,te,Ee):!0;return(0,y.isThenable)(be)?be.then(ve=>ve?!1:ee()):ee()}hasSiblingExcludeClauses(){return ie(this._excludeExpression)}}e.QueryGlobTester=q;function ie(oe){for(const ue in oe)if(typeof oe[ue]!="boolean")return!0;return!1}function A(oe){if(!oe)return;let ue;return te=>(ue||(ue=(oe()||Promise.resolve([])).then(Ee=>Ee?ce(Ee):{})),ue.then(Ee=>!!Ee[te]))}e.hasSiblingPromiseFn=A;function Z(oe){if(!oe)return;let ue;return te=>{if(!ue){const Ee=oe();ue=Ee?ce(Ee):{}}return!!ue[te]}}e.hasSiblingFn=Z;function ce(oe){const ue={};for(const te of oe)ue[te]=!0;return ue}}),define(ye[31],De([1,0,16,14,20,5,25,12,107,22,9,10,2,135,3,15,149,45,35,28,13,8,6,41,4]),function(ne,e,a,p,b,L,D,k,E,P,O,y,m,T,f,h,d,o,v,R,c,w,s,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function i(W,M,S){return new P.ExtUri(z=>_(z,S)).isEqual(W,M)}function r(W,M,S){return i(W.uri,M.uri,S)?0:(0,O.compare)(W.uri.toString(),M.uri.toString())}function t(W,M,S){return W.index!==M.index?W.index<M.index?-1:1:i(W.uri,M.uri,S)?(0,O.compare)(W.name,M.name):(0,O.compare)(W.uri.toString(),M.uri.toString())}function l(W,M,S,z){const $=W.slice(0).sort((q,ie)=>S(q,ie,z)),F=M.slice(0).sort((q,ie)=>S(q,ie,z));return(0,a.delta)($,F,(q,ie)=>S(q,ie,z))}function _(W,M){const S=M.getCapabilities(W.scheme);return!(S&&S&1024)}class g extends o.Workspace{constructor(M,S,z,$,F,q,ie){super(M,z.map(A=>new o.WorkspaceFolder(A)),$,F,ie);this._name=S,this._isUntitled=q,this._workspaceFolders=[],this._structure=D.TernarySearchTree.forUris(ie),z.forEach(A=>{this._workspaceFolders.push(A),this._structure.set(A.uri,A)})}static toExtHostWorkspace(M,S,z,$){if(!M)return{workspace:null,added:[],removed:[]};const{id:F,name:q,folders:ie,configuration:A,transient:Z,isUntitled:ce}=M,oe=[],ue=S;S?ie.forEach((ee,ve)=>{const Ae=m.URI.revive(ee.uri),Fe=g._findFolder(z||S,Ae,$);Fe?(Fe.name=ee.name,Fe.index=ee.index,oe.push(Fe)):oe.push({uri:Ae,name:ee.name,index:ve})}):oe.push(...ie.map(({uri:ee,name:ve,index:Ae})=>({uri:m.URI.revive(ee),name:ve,index:Ae}))),oe.sort((ee,ve)=>ee.index<ve.index?-1:1);const te=new g(F,q,oe,!!Z,A?m.URI.revive(A):null,!!ce,ee=>_(ee,$)),{added:Ee,removed:be}=l(ue?ue.workspaceFolders:[],te.workspaceFolders,r,$);return{workspace:te,added:Ee,removed:be}}static _findFolder(M,S,z){for(let $=0;$<M.folders.length;$++){const F=M.workspaceFolders[$];if(i(F.uri,S,z))return F}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(M,S){return S&&this._structure.get(M)&&(M=(0,P.dirname)(M)),this._structure.findSubstr(M)}resolveWorkspaceFolder(M){return this._structure.get(M)}}let C=class{constructor(M,S,z,$){this._onDidChangeWorkspace=new L.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new L.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=$,this._extHostFileSystemInfo=z,this._requestIdProvider=new E.Counter,this._barrier=new p.Barrier,this._proxy=M.getProxy(n.MainContext.MainThreadWorkspace),this._messageService=M.getProxy(n.MainContext.MainThreadMessageService);const F=S.workspace;this._confirmedWorkspace=F?new g(F.id,F.name,[],!!F.transient,F.configuration?m.URI.revive(F.configuration):null,!!F.isUntitled,q=>_(q,z)):void 0}$initializeWorkspace(M,S){this._trusted=S,this.$acceptWorkspaceData(M),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?m.URI.from({scheme:k.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(M,S,z,...$){const F=[];if(Array.isArray($)&&$.forEach(ce=>{m.URI.isUri(ce.uri)&&!F.some(oe=>i(oe.uri,ce.uri,this._extHostFileSystemInfo))&&F.push({uri:ce.uri,name:ce.name||(0,P.basenameOrAuthority)(ce.uri)})}),this._unconfirmedWorkspace||[S,z].some(ce=>typeof ce!="number"||ce<0)||z===0&&F.length===0)return!1;const q=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(S+z>q.length)return!1;const ie=q.slice(0);ie.splice(S,z,...F.map(ce=>({uri:ce.uri,name:ce.name||(0,P.basenameOrAuthority)(ce.uri),index:void 0})));for(let ce=0;ce<ie.length;ce++){const oe=ie[ce];if(ie.some((ue,te)=>te!==ce&&i(oe.uri,ue.uri,this._extHostFileSystemInfo)))return!1}ie.forEach((ce,oe)=>ce.index=oe);const{added:A,removed:Z}=l(q,ie,t,this._extHostFileSystemInfo);if(A.length===0&&Z.length===0)return!1;if(this._proxy){const ce=M.displayName||M.name;this._proxy.$updateWorkspaceFolders(ce,S,z,F).then(void 0,oe=>{this._unconfirmedWorkspace=void 0;const ue={source:{identifier:M.identifier,label:M.displayName||M.name}};this._messageService.$showMessage(d.Severity.Error,(0,T.localize)(0,null,ce,oe.toString()),ue,[])})}return this.trySetWorkspaceFolders(ie),!0}getWorkspaceFolder(M,S){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(M,S)}async getWorkspaceFolder2(M,S){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(M,S)}async resolveWorkspaceFolder(M){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(M)}getPath(){if(!this._actualWorkspace)return;const{folders:M}=this._actualWorkspace;if(M.length!==0)return M[0].uri.fsPath}getRelativePath(M,S){let z,$="";if(typeof M=="string"?(z=m.URI.file(M),$=M):typeof M!="undefined"&&(z=M,$=M.fsPath),!z)return $;const F=this.getWorkspaceFolder(z,!0);if(!F)return $;typeof S=="undefined"&&this._actualWorkspace&&(S=this._actualWorkspace.folders.length>1);let q=(0,P.relativePath)(F.uri,z);return S&&F.name&&(q=`${F.name}/${q}`),q}trySetWorkspaceFolders(M){this._actualWorkspace&&(this._unconfirmedWorkspace=g.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:M,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(M){const{workspace:S,added:z,removed:$}=g.toExtHostWorkspace(M,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=S||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:z,removed:$}))}findFiles(M,S,z,$,F=b.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${$.value}, entryPoint: findFiles`);let q;if(S===null?q=!1:S&&(typeof S=="string"?q=S:q=S.pattern),F&&F.isCancellationRequested)return Promise.resolve([]);const{includePattern:ie,folder:A}=U(w.GlobPattern.from(M));return this._proxy.$startFileSearch((0,y.withUndefinedAsNull)(ie),(0,y.withUndefinedAsNull)(A),(0,y.withUndefinedAsNull)(q),(0,y.withUndefinedAsNull)(z),F).then(Z=>Array.isArray(Z)?Z.map(ce=>m.URI.revive(ce)):[])}async findTextInFiles(M,S,z,$,F=b.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${$.value}, entryPoint: findTextInFiles`);const q=this._requestIdProvider.getNext(),ie=typeof S.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:S.previewOptions,{includePattern:A,folder:Z}=U(w.GlobPattern.from(S.include)),ce=typeof S.exclude=="string"?S.exclude:S.exclude?S.exclude.pattern:void 0,oe={ignoreSymlinks:typeof S.followSymlinks=="boolean"?!S.followSymlinks:void 0,disregardIgnoreFiles:typeof S.useIgnoreFiles=="boolean"?!S.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof S.useGlobalIgnoreFiles=="boolean"?!S.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof S.useParentIgnoreFiles=="boolean"?!S.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof S.useDefaultExcludes=="boolean"?!S.useDefaultExcludes:!0,fileEncoding:S.encoding,maxResults:S.maxResults,previewOptions:ie,afterContext:S.afterContext,beforeContext:S.beforeContext,includePattern:A,excludePattern:ce},ue=!1;if(this._activeSearchCallbacks[q]=te=>{if(ue)return;const Ee=m.URI.revive(te.resource);te.results.forEach(be=>{(0,u.resultIsMatch)(be)?z({uri:Ee,preview:{text:be.preview.text,matches:(0,a.mapArrayOrNot)(be.preview.matches,ee=>new s.Range(ee.startLineNumber,ee.startColumn,ee.endLineNumber,ee.endColumn))},ranges:(0,a.mapArrayOrNot)(be.ranges,ee=>new s.Range(ee.startLineNumber,ee.startColumn,ee.endLineNumber,ee.endColumn))}):z({uri:Ee,text:be.text,lineNumber:be.lineNumber})})},F.isCancellationRequested)return{};try{const te=await this._proxy.$startTextSearch(M,(0,y.withUndefinedAsNull)(Z),oe,q,F);return delete this._activeSearchCallbacks[q],te||{}}catch(te){throw delete this._activeSearchCallbacks[q],te}}$handleTextSearchResult(M,S){this._activeSearchCallbacks[S]?.(M)}saveAll(M){return this._proxy.$saveAll(M)}resolveProxy(M){return this._proxy.$resolveProxy(M)}get trusted(){return this._trusted}requestWorkspaceTrust(M){return this._proxy.$requestWorkspaceTrust(M)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};C=ze([xe(0,c.IExtHostRpcService),xe(1,R.IExtHostInitDataService),xe(2,v.IExtHostFileSystemInfo),xe(3,h.ILogService)],C),e.ExtHostWorkspace=C,e.IExtHostWorkspace=(0,f.createDecorator)("IExtHostWorkspace");function U(W){let M,S;return W&&(typeof W=="string"?M=W:(M=W.pattern,S=m.URI.revive(W.baseUri))),{includePattern:M,folder:S}}}),define(ye[32],De([1,0,26,5,31,4,6,152,83,10,14,3,13,15,2]),function(ne,e,a,p,b,L,D,k,E,P,O,y,m,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function h(u,n){if(n){const i=n.split(".");let r=u;for(let t=0;r&&t<i.length;t++)r=r[i[t]];return r}}function d(u){return u instanceof f.URI}function o(u){return u&&u.uri instanceof f.URI&&u.languageId&&typeof u.languageId=="string"}function v(u){return u&&!u.uri&&u.languageId&&typeof u.languageId=="string"}function R(u){return u&&u.uri instanceof f.URI&&(!u.name||typeof u.name=="string")&&(!u.index||typeof u.index=="number")}function c(u){if(d(u))return{resource:u};if(o(u))return{resource:u.uri,overrideIdentifier:u.languageId};if(v(u))return{overrideIdentifier:u.languageId};if(R(u))return{resource:u.uri};if(u===null)return{resource:null}}let w=class{constructor(n,i,r){this._proxy=n.getProxy(L.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=r,this._barrier=new O.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(n=>this._actual)}$initializeConfiguration(n){this._actual=new s(this._proxy,this._extHostWorkspace,n,this._logService),this._barrier.open()}$acceptConfigurationChanged(n,i){this.getConfigProvider().then(r=>r.$acceptConfigurationChanged(n,i))}};w=ze([xe(0,m.IExtHostRpcService),xe(1,b.IExtHostWorkspace),xe(2,T.ILogService)],w),e.ExtHostConfiguration=w;class s{constructor(n,i,r,t){this._onDidChangeConfiguration=new p.Emitter,this._proxy=n,this._logService=t,this._extHostWorkspace=i,this._configuration=k.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(n,i){const r={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,r))}getConfiguration(n,i,r){const t=c(i)||{},l=this._toReadonlyValue(n?h(this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace),n):this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace));n&&this._validateConfigurationAccess(n,t,r?.identifier);function _(C){if(C==null)return null;if(typeof C=="boolean")return C?2:5;switch(C){case D.ConfigurationTarget.Global:return 2;case D.ConfigurationTarget.Workspace:return 5;case D.ConfigurationTarget.WorkspaceFolder:return 6}}const g={has(C){return typeof h(l,C)!="undefined"},get:(C,U)=>{this._validateConfigurationAccess(n?`${n}.${C}`:C,t,r?.identifier);let W=h(l,C);if(typeof W=="undefined")W=U;else{let M;const S=(z,$)=>{let F;const q=()=>{M=M||(0,a.deepClone)(l),F=F||h(M,$)};return(0,P.isObject)(z)?new Proxy(z,{get:(ie,A)=>{if(typeof A=="string"&&A.toLowerCase()==="tojson")return q(),()=>F;if(M)return F=F||h(M,$),F[A];const Z=ie[A];return typeof A=="string"?S(Z,`${$}.${A}`):Z},set:(ie,A,Z)=>(q(),F&&(F[A]=Z),!0),deleteProperty:(ie,A)=>(q(),F&&delete F[A],!0),defineProperty:(ie,A,Z)=>(q(),F&&Object.defineProperty(F,A,Z),!0)}):z};W=S(W,C)}return W},update:(C,U,W,M)=>{C=n?`${n}.${C}`:C;const S=_(W);return U!==void 0?this._proxy.$updateConfigurationOption(S,C,U,t,M):this._proxy.$removeConfigurationOption(S,C,t,M)},inspect:C=>{C=n?`${n}.${C}`:C;const U=(0,a.deepClone)(this._configuration.inspect(C,t,this._extHostWorkspace.workspace));if(U)return{key:C,defaultValue:U.policy?.value??U.default?.value,globalValue:U.user?.value??U.application?.value,workspaceValue:U.workspace?.value,workspaceFolderValue:U.workspaceFolder?.value,defaultLanguageValue:U.default?.override,globalLanguageValue:U.user?.override??U.application?.override,workspaceLanguageValue:U.workspace?.override,workspaceFolderLanguageValue:U.workspaceFolder?.override,languageIds:U.overrideIdentifiers}}};return typeof l=="object"&&(0,a.mixin)(g,l,!1),Object.freeze(g)}_toReadonlyValue(n){const i=r=>(0,P.isObject)(r)?new Proxy(r,{get:(t,l)=>i(t[l]),set:(t,l,_)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(l)}' of object`)},deleteProperty:(t,l)=>{throw new Error(`TypeError: Cannot delete read only property '${String(l)}' of object`)},defineProperty:(t,l)=>{throw new Error(`TypeError: Cannot define property '${String(l)}' for a readonly object`)},setPrototypeOf:t=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):r;return i(n)}_validateConfigurationAccess(n,i,r){const t=E.OVERRIDE_PROPERTY_REGEX.test(n)?4:this._configurationScopes.get(n),l=r?`[${r.value}] `:"";if(t===4){typeof i?.resource=="undefined"&&this._logService.warn(`${l}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(t===3){i?.resource&&this._logService.warn(`${l}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(n,i){const r=new k.ConfigurationChangeEvent(n,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(t,l)=>r.affectsConfiguration(t,c(l))})}_toMap(n){return n.reduce((i,r)=>(i.set(r[0],r[1]),i),new Map)}}e.ExtHostConfigProvider=s,e.IExtHostConfiguration=(0,y.createDecorator)("IExtHostConfiguration")});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,a,p,b){if(p==="m")throw new TypeError("Private method is not writable");if(p==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return p==="a"?b.call(ne,a):b?b.value=a:e.set(ne,a),a},Oe=this&&this.__classPrivateFieldGet||function(ne,e,a,p){if(a==="a"&&!p)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!p:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?p:a==="a"?p.call(ne):p?p.value:e.get(ne)};define(ye[101],De([1,0,2,14,5,4,6,31,49,32,20,52,13,28,3,12,21,15,68,185,11]),function(ne,e,a,p,b,L,D,k,E,P,O,y,m,T,f,h,d,o,v,R,c){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var s;(function($){function F(ie){if(ie!=null)return ie}$.from=F;function q(ie){if(ie!=null)return ie}$.to=q})(s=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var u;(function($){function F(ie){if(ie!=null)return ie}$.from=F;function q(ie){if(ie!=null)return ie}$.to=q})(u=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var n;(function($){function F(ie){if(ie!=null)return ie}$.from=F;function q(ie){if(ie!=null)return ie}$.to=q})(n=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function($){function F(A){if(A){const Z=A;return Z&&!!Z.process}else return!1}$.is=F;function q(A){if(A==null)return;const Z={process:A.process,args:A.args};return A.options&&(Z.options=n.from(A.options)),Z}$.from=q;function ie(A){if(A!=null)return new D.ProcessExecution(A.process,A.args,A.options)}$.to=ie})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var r;(function($){function F(ie){if(ie!=null)return ie}$.from=F;function q(ie){if(ie!=null)return ie}$.to=q})(r=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var t;(function($){function F(A){if(A){const Z=A;return Z&&(!!Z.commandLine||!!Z.command)}else return!1}$.is=F;function q(A){if(A==null)return;const Z={};return A.commandLine!==void 0?Z.commandLine=A.commandLine:(Z.command=A.command,Z.args=A.args),A.options&&(Z.options=r.from(A.options)),Z}$.from=q;function ie(A){if(!(A==null||A.command===void 0&&A.commandLine===void 0))return A.commandLine?new D.ShellExecution(A.commandLine,A.options):new D.ShellExecution(A.command,A.args?A.args:[],A.options)}$.to=ie})(t=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var l;(function($){function F(A){if(A){const Z=A;return Z&&Z.customExecution==="customExecution"}else return!1}$.is=F;function q(A){return{customExecution:"customExecution"}}$.from=q;function ie(A,Z){return Z.get(A)}$.to=ie})(l=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var _;(function($){function F(q,ie){let A;return q.scope!==void 0&&typeof q.scope!="number"?A=q.scope.uri:q.scope!==void 0&&typeof q.scope=="number"&&(q.scope===D.TaskScope.Workspace&&ie&&ie.workspaceFile?A=ie.workspaceFile:A=R.USER_TASKS_GROUP_KEY),{id:q._id,workspaceFolder:A}}$.from=F})(_=e.TaskHandleDTO||(e.TaskHandleDTO={}));var g;(function($){function F(q){if(q!=null)return{_id:q.id,isDefault:q.isDefault}}$.from=F})(g=e.TaskGroupDTO||(e.TaskGroupDTO={}));var C;(function($){function F(A,Z){if(A==null)return[];const ce=[];for(const oe of A){const ue=q(oe,Z);ue&&ce.push(ue)}return ce}$.fromMany=F;function q(A,Z){if(A==null)return;let ce;A.execution instanceof D.ProcessExecution?ce=i.from(A.execution):A.execution instanceof D.ShellExecution?ce=t.from(A.execution):A.execution&&A.execution instanceof D.CustomExecution&&(ce=l.from(A.execution));const oe=s.from(A.definition);let ue;return A.scope?typeof A.scope=="number"?ue=A.scope:ue=A.scope.uri:ue=D.TaskScope.Workspace,!oe||!ue?void 0:{_id:A._id,definition:oe,name:A.name,source:{extensionId:Z.identifier.value,label:A.source,scope:ue},execution:ce,isBackground:A.isBackground,group:g.from(A.group),presentationOptions:u.from(A.presentationOptions),problemMatchers:A.problemMatchers,hasDefinedMatchers:A.hasDefinedMatchers,runOptions:A.runOptions?A.runOptions:{reevaluateOnRerun:!0},detail:A.detail}}$.from=q;async function ie(A,Z,ce){if(A==null)return;let oe;i.is(A.execution)?oe=i.to(A.execution):t.is(A.execution)?oe=t.to(A.execution):l.is(A.execution)&&(oe=l.to(A._id,ce));const ue=s.to(A.definition);let te;if(A.source&&(A.source.scope!==void 0?typeof A.source.scope=="number"?te=A.source.scope:te=await Z.resolveWorkspaceFolder(a.URI.revive(A.source.scope)):te=D.TaskScope.Workspace),!ue||!te)return;const Ee=new D.Task(ue,te,A.name,A.source.label,oe,A.problemMatchers);return A.isBackground!==void 0&&(Ee.isBackground=A.isBackground),A.group!==void 0&&(Ee.group=D.TaskGroup.from(A.group._id),Ee.group&&A.group.isDefault&&(Ee.group=new D.TaskGroup(Ee.group.id,Ee.group.label),A.group.isDefault===!0&&(Ee.group.isDefault=A.group.isDefault))),A.presentationOptions&&(Ee.presentationOptions=u.to(A.presentationOptions)),A._id&&(Ee._id=A._id),A.detail&&(Ee.detail=A.detail),Ee}$.to=ie})(C=e.TaskDTO||(e.TaskDTO={}));var U;(function($){function F(ie){return ie}$.from=F;function q(ie){if(!!ie)return Object.assign(Object.create(null),ie)}$.to=q})(U=e.TaskFilterDTO||(e.TaskFilterDTO={}));class W{constructor(F,q,ie){this._id=q,this._task=ie,w.set(this,void 0),Ye(this,w,F,"f")}get task(){return this._task}terminate(){Oe(this,w,"f").terminateTask(this)}fireDidStartProcess(F){}fireDidEndProcess(F){}}w=new WeakMap;var M;(function($){function F(q){return{id:q._id,task:void 0}}$.from=F})(M=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let S=class{constructor(F,q,ie,A,Z,ce,oe,ue){this._onDidExecuteTask=new b.Emitter,this._onDidTerminateTask=new b.Emitter,this._onDidTaskProcessStarted=new b.Emitter,this._onDidTaskProcessEnded=new b.Emitter,this._proxy=F.getProxy(L.MainContext.MainThreadTask),this._workspaceProvider=ie,this._editorService=A,this._configurationService=Z,this._terminalService=ce,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=oe,this._deprecationService=ue,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(F,q,ie){if(!ie)return new D.Disposable(()=>{});const A=this.nextHandle();return this._handlers.set(A,{type:q,provider:ie,extension:F}),this._proxy.$registerTaskProvider(A,q),new D.Disposable(()=>{this._handlers.delete(A),this._proxy.$unregisterTaskProvider(A)})}registerTaskSystem(F,q){this._proxy.$registerTaskSystem(F,q)}fetchTasks(F){return this._proxy.$fetchTasks(U.from(F)).then(async q=>{const ie=[];for(const A of q){const Z=await C.to(A,this._workspaceProvider,this._providedCustomExecutions2);Z&&ie.push(Z)}return ie})}get taskExecutions(){const F=[];return this._taskExecutions.forEach(q=>F.push(q)),F}terminateTask(F){if(!(F instanceof W))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(F._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(F,q,ie){const A=this._providedCustomExecutions2.get(F.id);A&&(this._activeCustomExecutions2.set(F.id,A),this._terminalService.attachPtyToTerminal(q,await A.callback(ie))),this._lastStartedTask=F.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(F)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(F){const q=await this.getTaskExecution(F);this._taskExecutionPromises.delete(F.id),this._taskExecutions.delete(F.id),this.customExecutionComplete(F),this._onDidTerminateTask.fire({execution:q})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(F){const q=await this.getTaskExecution(F.id);this._onDidTaskProcessStarted.fire({execution:q,processId:F.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(F){const q=await this.getTaskExecution(F.id);this._onDidTaskProcessEnded.fire({execution:q,exitCode:F.exitCode})}$provideTasks(F,q){const ie=this._handlers.get(F);if(!ie)return Promise.reject(new Error("no handler found"));const A=[],Z=(0,p.asPromise)(()=>ie.provider.provideTasks(O.CancellationToken.None)).then(ce=>this.provideTasksInternal(q,A,ie,ce));return new Promise(ce=>{Z.then(oe=>{Promise.all(A).then(()=>{ce(oe)})})})}async $resolveTask(F,q){const ie=this._handlers.get(F);if(!ie)return Promise.reject(new Error("no handler found"));if(q.definition.type!==ie.type)throw new Error(`Unexpected: Task of type [${q.definition.type}] cannot be resolved by provider of type [${ie.type}].`);const A=await C.to(q,this._workspaceProvider,this._providedCustomExecutions2);if(!A)throw new Error("Unexpected: Task cannot be resolved.");const Z=await ie.provider.resolveTask(A,O.CancellationToken.None);if(!Z)return;this.checkDeprecation(Z,ie);const ce=C.from(Z,ie.extension);if(!ce)throw new Error("Unexpected: Task cannot be resolved.");if(Z.definition!==A.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return l.is(ce.execution)&&await this.addCustomExecution(ce,Z,!0),await this.resolveTaskInternal(ce)}nextHandle(){return this._handleCounter++}async addCustomExecution(F,q,ie){const A=await this._proxy.$createTaskId(F);!ie&&!this._providedCustomExecutions2.has(A)&&(this._notProvidedCustomExecutions.add(A),this._activeCustomExecutions2.set(A,q.execution)),this._providedCustomExecutions2.set(A,q.execution)}async getTaskExecution(F,q){if(typeof F=="string"){const Z=this._taskExecutionPromises.get(F);if(!Z)throw new Error("Unexpected: The specified task is missing an execution");return Z}const ie=this._taskExecutionPromises.get(F.id);if(ie)return ie;const A=new Promise((Z,ce)=>{function oe(ue,te,Ee){Ee?Z(new W(ue,te.id,Ee)):ce("Unexpected: Task does not exist.")}q?oe(this,F,q):C.to(F.task,this._workspaceProvider,this._providedCustomExecutions2).then(ue=>oe(this,F,ue))});return this._taskExecutionPromises.set(F.id,A),A.then(Z=>(this._taskExecutions.set(F.id,Z),Z),Z=>Promise.reject(Z))}checkDeprecation(F,q){F._deprecated&&this._deprecationService.report("Task.constructor",q.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(F){this._activeCustomExecutions2.get(F.id)&&this._activeCustomExecutions2.delete(F.id),this._notProvidedCustomExecutions.has(F.id)&&this._lastStartedTask!==F.id&&(this._providedCustomExecutions2.delete(F.id),this._notProvidedCustomExecutions.delete(F.id));const ie=this._notProvidedCustomExecutions.values();let A=ie.next();for(;!A.done;)!this._activeCustomExecutions2.has(A.value)&&this._lastStartedTask!==A.value&&(this._providedCustomExecutions2.delete(A.value),this._notProvidedCustomExecutions.delete(A.value)),A=ie.next()}};S=ze([xe(0,m.IExtHostRpcService),xe(1,T.IExtHostInitDataService),xe(2,k.IExtHostWorkspace),xe(3,E.IExtHostDocumentsAndEditors),xe(4,P.IExtHostConfiguration),xe(5,y.IExtHostTerminalService),xe(6,o.ILogService),xe(7,v.IExtHostApiDeprecationService)],S),e.ExtHostTaskBase=S;let z=class extends S{constructor(F,q,ie,A,Z,ce,oe,ue){super(F,q,ie,A,Z,ce,oe,ue);this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:d.PlatformToString(0)})}async executeTask(F,q){if(!q.execution)throw new Error("Tasks to execute must include an execution");const ie=C.from(q,F);if(ie===void 0)throw new Error("Task is not valid");if(l.is(ie.execution))await this.addCustomExecution(ie,q,!1);else throw new c.NotSupportedError;const A=await this.getTaskExecution(await this._proxy.$getTaskExecution(ie),q);return this._proxy.$executeTask(ie).catch(Z=>{throw new Error(Z)}),A}provideTasksInternal(F,q,ie,A){const Z=[];if(A)for(const ce of A){this.checkDeprecation(ce,ie),(!ce.definition||!F[ce.definition.type])&&this._logService.warn(`The task [${ce.source}, ${ce.name}] uses an undefined task type. The task will be ignored in the future.`);const oe=C.from(ce,ie.extension);oe&&l.is(oe.execution)?(Z.push(oe),q.push(this.addCustomExecution(oe,ce,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:Z,extension:ie.extension}}async resolveTaskInternal(F){if(l.is(F.execution))return F;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(F,q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(F,q,ie){}};z=ze([xe(0,m.IExtHostRpcService),xe(1,T.IExtHostInitDataService),xe(2,k.IExtHostWorkspace),xe(3,E.IExtHostDocumentsAndEditors),xe(4,P.IExtHostConfiguration),xe(5,y.IExtHostTerminalService),xe(6,o.ILogService),xe(7,v.IExtHostApiDeprecationService)],z),e.WorkerExtHostTask=z,e.IExtHostTask=(0,f.createDecorator)("IExtHostTask")}),define(ye[227],De([1,0,19,20,43,34,22,203,41]),function(ne,e,a,p,b,L,D,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(m,T,f){this.config=m,this.provider=T,this.sessionToken=f,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=m.filePattern,this.includePattern=m.includePattern&&L.parse(m.includePattern),this.maxResults=m.maxResults||void 0,this.exists=m.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=m.excludePattern&&L.parse(m.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(m=>m.cancel()),this.activeCancellationTokens=new Set}search(m){const T=this.config.folderQueries||[];return new Promise((f,h)=>{const d=o=>{this.resultCount++,m(o)};if(this.isCanceled)return f({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(o=>{const v=o.toString(),R=a.basename(v);this.globalExcludePattern&&this.globalExcludePattern(v,R)||this.matchFile(d,{base:o,basename:R})}),Promise.all(T.map(o=>this.searchInFolder(o,d))).then(o=>{f({limitHit:this.isLimitHit,stats:o[0]||void 0})},o=>{h(new Error((0,b.toErrorMessage)(o)))})})}async searchInFolder(m,T){const f=new p.CancellationTokenSource,h=this.getSearchOptionsForFolder(m),d=this.initDirectoryTree(),o=new E.QueryGlobTester(this.config,m),v=!o.hasSiblingExcludeClauses();let R;try{this.activeCancellationTokens.add(f),R=k.StopWatch.create();const c=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},h,f.token),w=R.elapsed(),s=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(c&&c.forEach(u=>{const n=a.posix.relative(m.folder.path,u.path);if(v){const i=a.basename(u.path);this.matchFile(T,{base:m.folder,relativePath:n,basename:i});return}this.addDirectoryEntries(d,m.folder,n,T)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(d,o,T),{providerTime:w,postProcessTime:s.elapsed()})}finally{f.dispose(),this.activeCancellationTokens.delete(f)}}getSearchOptionsForFolder(m){const T=(0,E.resolvePatternsForProvider)(this.config.includePattern,m.includePattern),f=(0,E.resolvePatternsForProvider)(this.config.excludePattern,m.excludePattern);return{folder:m.folder,excludes:f,includes:T,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}addDirectoryEntries({pathToEntries:m},T,f,h){if(f===this.filePattern){const o=a.basename(this.filePattern);this.matchFile(h,{base:T,relativePath:this.filePattern,basename:o})}function d(o){const v=a.basename(o),R=a.dirname(o);let c=m[R];c||(c=m[R]=[],d(R)),c.push({base:T,relativePath:o,basename:v})}d(f)}matchDirectoryTree({rootEntries:m,pathToEntries:T},f,h){const d=this,o=this.filePattern;function v(R){const c=(0,E.hasSiblingFn)(()=>R.map(w=>w.basename));for(let w=0,s=R.length;w<s;w++){const u=R[w],{relativePath:n,basename:i}=u;if(f.matchesExcludesSync(n,i,o!==i?c:void 0))continue;const r=T[n];if(r)v(r);else{if(n===o)continue;d.matchFile(h,u)}if(d.isLimitHit)break}}v(m)}matchFile(m,T){(!this.includePattern||T.relativePath&&this.includePattern(T.relativePath,T.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||m(T))}}class O{constructor(){this.sessions=new Map}fileSearch(m,T,f,h){const d=this.getSessionTokenSource(m.cacheKey),o=new P(m,T,d&&d.token);let v=0;const R=c=>{v+=c.length,f(c.map(w=>this.rawMatchToSearchItem(w)))};return this.doSearch(o,O.BATCH_SIZE,R,h).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:v,detailStats:c.stats}}))}clearCache(m){this.getSessionTokenSource(m)?.cancel()}getSessionTokenSource(m){if(!!m)return this.sessions.has(m)||this.sessions.set(m,new p.CancellationTokenSource),this.sessions.get(m)}rawMatchToSearchItem(m){return m.relativePath?{resource:D.joinPath(m.base,m.relativePath)}:{resource:m.base}}doSearch(m,T,f,h){h.onCancellationRequested(()=>{m.cancel()});const d=v=>{v&&(o.push(v),T>0&&o.length>=T&&(f(o),o=[]))};let o=[];return m.search(d).then(v=>(o.length&&f(o),v),v=>(o.length&&f(o),Promise.reject(v)))}}e.FileSearchManager=O,O.BATCH_SIZE=512}),define(ye[228],De([1,0,16,72,34,76,25,12,19,22,9,10,2,245,143,57,15,45,90,226,41]),function(ne,e,a,p,b,L,D,k,E,P,O,y,m,T,f,h,d,o,v,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let w=class{constructor(g,C,U,W,M){this.configurationService=g,this.workspaceContextService=C,this.editorGroupsService=U,this.logService=W,this.pathService=M}text(g,C,U={}){g=this.getContentPattern(g,U);const W=this.configurationService.getValue(),M=C&&C.some(z=>!this.configurationService.getValue({resource:z}).search.useRipgrep);return{...this.commonQuery(C?.map(o.toWorkspaceFolder),U),type:2,contentPattern:g,previewOptions:U.previewOptions,maxFileSize:U.maxFileSize,usePCRE2:W.search.usePCRE2||M||!1,beforeContext:U.beforeContext,afterContext:U.afterContext,userDisabledExcludesAndIgnoreFiles:U.disregardExcludeSettings&&U.disregardIgnoreFiles}}getContentPattern(g,C){const U=this.configurationService.getValue();g.isRegExp&&(g.pattern=g.pattern.replace(/\r?\n/g,"\\n"));const W={...g,wordSeparators:U.editor.wordSeparators};return this.isCaseSensitive(g,C)&&(W.isCaseSensitive=!0),this.isMultiline(g)&&(W.isMultiline=!0),W}file(g,C={}){return{...this.commonQuery(g,C),type:1,filePattern:C.filePattern?C.filePattern.trim():C.filePattern,exists:C.exists,sortByScore:C.sortByScore,cacheKey:C.cacheKey}}handleIncludeExclude(g,C){return g?(g=Array.isArray(g)?g.map(r):r(g),C?this.parseSearchPaths(g):{pattern:u(...Array.isArray(g)?g:[g])}):{}}commonQuery(g=[],C={}){const U=this.handleIncludeExclude(C.includePattern,C.expandPatterns),W=this.handleIncludeExclude(C.excludePattern,C.expandPatterns),M=g.length>1,S=(U.searchPaths&&U.searchPaths.length?U.searchPaths.map(F=>this.getFolderQueryForSearchPath(F,C,W)):g.map(F=>this.getFolderQueryForRoot(F,C,W,M))).filter(F=>!!F),z={_reason:C._reason,folderQueries:S,usingSearchPaths:!!(U.searchPaths&&U.searchPaths.length),extraFileResources:C.extraFileResources,excludePattern:W.pattern,includePattern:U.pattern,onlyOpenEditors:C.onlyOpenEditors,maxResults:C.maxResults};if(C.onlyOpenEditors){const F=a.coalesce(a.flatten(this.editorGroupsService.groups.map(A=>A.editors.map(Z=>Z.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const q=F.filter(A=>(0,c.pathIncludedInQuery)(z,A.fsPath)),ie=this.commonQueryFromFileList(q);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ie)),{...z,...ie}}const $=C.extraFileResources&&C.extraFileResources.filter(F=>(0,c.pathIncludedInQuery)(z,F.fsPath));return z.extraFileResources=$&&$.length?$:void 0,z}commonQueryFromFileList(g){const C=[],U=new D.ResourceMap,W={};let M=!1;return g.forEach(S=>{if(S.scheme===k.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(S)){const $=this.workspaceContextService.getWorkspaceFolder(S)?.uri??S.with({path:E.dirname(S.fsPath)});let F=U.get($);F||(M=!0,F={folder:$,includePattern:{}},C.push(F),U.set($,F));const q=E.relative($.fsPath,S.fsPath);(0,y.assertIsDefined)(F.includePattern)[q.replace(/\\/g,"/")]=!0}else S.fsPath&&(M=!0,W[S.fsPath]=!0)}),{folderQueries:C,includePattern:W,usingSearchPaths:!0,excludePattern:M?void 0:{"**/*":!0}}}isCaseSensitive(g,C){if(C.isSmartCase){if(g.isRegExp){if(O.containsUppercaseCharacter(g.pattern,!0))return!0}else if(O.containsUppercaseCharacter(g.pattern))return!0}return!!g.isCaseSensitive}isMultiline(g){return g.isMultiline||g.isRegExp&&(0,T.isMultilineRegexSource)(g.pattern)||g.pattern.indexOf(`
`)>=0?!0:!!g.isMultiline}parseSearchPaths(g){const C=ie=>E.isAbsolute(ie)||/^\.\.?([\/\\]|$)/.test(ie),W=(Array.isArray(g)?g:n(g)).map(ie=>{const A=this.pathService.resolvedUserHome;return A?(0,L.untildify)(ie,A.scheme===k.Schemas.file?A.fsPath:A.path):ie}),M=p.groupBy(W,ie=>C(ie)?"searchPaths":"exprSegments"),S=(M.exprSegments||[]).map(ie=>O.rtrim(ie,"/")).map(ie=>O.rtrim(ie,"\\")).map(ie=>(ie[0]==="."&&(ie="*"+ie),i(ie))),z={},$=this.expandSearchPathPatterns(M.searchPaths||[]);$&&$.length&&(z.searchPaths=$);const F=a.flatten(S),q=u(...F);return q&&(z.pattern=q),z}getExcludesForFolder(g,C){return C.disregardExcludeSettings?void 0:(0,c.getExcludes)(g,!C.disregardSearchExcludeSettings)}expandSearchPathPatterns(g){if(!g||!g.length)return[];const C=a.flatten(g.map(W=>{let{pathPortion:M,globPortion:S}=s(W);S&&(S=t(S));const z=this.expandOneSearchPath(M);return a.flatten(z.map($=>this.resolveOneSearchPathPattern($,S)))})),U=new Map;return C.forEach(W=>{const M=W.searchPath.toString(),S=U.get(M);S?W.pattern&&(S.pattern=S.pattern||{},S.pattern[W.pattern]=!0):U.set(M,{searchPath:W.searchPath,pattern:W.pattern?u(W.pattern):void 0})}),Array.from(U.values())}expandOneSearchPath(g){if(E.isAbsolute(g)){const C=this.workspaceContextService.getWorkspace().folders;return C[0]&&C[0].uri.scheme!==k.Schemas.file?[{searchPath:C[0].uri.with({path:g})}]:[{searchPath:m.URI.file(E.normalize(g))}]}if(this.workspaceContextService.getWorkbenchState()===2){const C=this.workspaceContextService.getWorkspace().folders[0].uri;if(g=r(g),g.startsWith("../")||g===".."){const W=E.posix.resolve(C.path,g);return[{searchPath:C.with({path:W})}]}const U=t(g);return[{searchPath:C,pattern:U}]}else{if(g==="./"||g===".\\")return[];{const C=g.replace(/^\.[\/\\]/,""),W=this.workspaceContextService.getWorkspace().folders.map(M=>{const S=C.match(new RegExp(`^${O.escapeRegExpCharacters(M.name)}(?:/(.*)|$)`));return S?{match:S,folder:M}:null}).filter(y.isDefined);if(W.length)return W.map(M=>{const S=M.match[1];return{searchPath:M.folder.uri,pattern:S&&t(S)}});{const M=g.match(/\.[\/\\](.+)[\/\\]?/),S=M?M[1]:g,z=f.localize(0,null,S);throw new Error(z)}}}}resolveOneSearchPathPattern(g,C){const U=g.pattern&&C?`${g.pattern}/${C}`:g.pattern||C,W=[{searchPath:g.searchPath,pattern:U}];return U&&!U.endsWith("**")&&W.push({searchPath:g.searchPath,pattern:U+"/**"}),W}getFolderQueryForSearchPath(g,C,U){const W=this.getFolderQueryForRoot((0,o.toWorkspaceFolder)(g.searchPath),C,U,!1);return W?{...W,includePattern:g.pattern}:null}getFolderQueryForRoot(g,C,U,W){let M;const S=m.URI.isUri(g)?g:g.uri;if(U.searchPaths){const ie=U.searchPaths.filter(A=>(0,P.isEqual)(A.searchPath,S))[0];if(ie&&!ie.pattern)return null;ie&&(M=ie.pattern)}const z=this.configurationService.getValue({resource:S}),F={...this.getExcludesForFolder(z,C)||{},...M||{}},q=m.URI.isUri(g)?(0,P.basename)(g):g.name;return{folder:S,folderName:W?q:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof C.disregardIgnoreFiles=="boolean"?C.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof C.disregardGlobalIgnoreFiles=="boolean"?C.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof C.disregardParentIgnoreFiles=="boolean"?C.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof C.ignoreSymlinks=="boolean"?C.ignoreSymlinks:!z.search.followSymlinks}}};w=ze([xe(0,h.IConfigurationService),xe(1,o.IWorkspaceContextService),xe(2,v.IEditorGroupsService),xe(3,d.ILogService),xe(4,R.IPathService)],w),e.QueryBuilder=w;function s(_){const g=_.match(/[\*\{\}\(\)\[\]\?]/);if(g){const C=g.index,U=_.substr(0,C).match(/[/|\\][^/\\]*$/);if(U){let W=_.substr(0,U.index);return W.match(/[/\\]/)||(W+="/"),{pathPortion:W,globPortion:_.substr((U.index||0)+1)}}}return{pathPortion:_}}function u(..._){return _.length?_.reduce((g,C)=>(g[C]=!0,g),Object.create(null)):void 0}function n(_){return b.splitGlobAware(_,",").map(g=>g.trim()).filter(g=>!!g.length)}function i(_){return[`**/${_}/**`,`**/${_}`].map(C=>C.replace(/\*\*\/\*\*/g,"**"))}function r(_){return _.replace(/\\/g,"/")}function t(_){return r(_).replace(/^\.\//,"").replace(/\/+$/g,"")}function l(_,g){_=a.distinct(_,W=>W.toString());const C=[],U=g.getWorkspace();return _&&_.forEach(W=>{let M;if(g.getWorkbenchState()===2)M=(0,P.relativePath)(U.folders[0].uri,W),M&&M!=="."&&(M="./"+M);else{const S=g.getWorkspaceFolder(W);if(S){const z=S.name;if(U.folders.filter(F=>F.name===z).length===1){const F=(0,P.relativePath)(S.uri,W);F===""?M=`./${S.name}`:M=`./${S.name}/${F}`}else M=W.fsPath}}M&&C.push(M)}),C}e.resolveResourcesForSearchIncludes=l}),define(ye[229],De([1,0,22,2,20,11,3,228,41,45]),function(ne,e,a,p,b,L,D,k,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const O=7e3;function y(h,d){const o=d.activationEvents;if(!o)return Promise.resolve(void 0);const v=[],R=[];for(const i of o)if(/^workspaceContains:/.test(i)){const r=i.substr("workspaceContains:".length);r.indexOf("*")>=0||r.indexOf("?")>=0||h.forceUsingSearch?R.push(r):v.push(r)}if(v.length===0&&R.length===0)return Promise.resolve(void 0);let c;const w=new Promise((i,r)=>{c=i}),s=i=>c({activationEvent:i}),u=Promise.all(v.map(i=>m(h,i,s))).then(()=>{}),n=T(h,d.identifier,R,s);return Promise.all([u,n]).then(()=>{c(void 0)}),w}e.checkActivateWorkspaceContainsExtension=y;async function m(h,d,o){for(const v of h.folders)if(await h.exists(a.joinPath(p.URI.revive(v),d))){o(`workspaceContains:${d}`);return}}async function T(h,d,o,v){if(o.length===0)return Promise.resolve(void 0);const R=new b.CancellationTokenSource,c=h.checkExists(h.folders,o,R.token),w=setTimeout(async()=>{R.cancel(),h.logService.info(`Not activating extension '${d.value}': Timed out while searching for 'workspaceContains' pattern ${o.join(",")}`)},O);let s=!1;try{s=await c}catch(u){L.isCancellationError(u)||L.onUnexpectedError(u)}R.dispose(),clearTimeout(w),s&&v(`workspaceContains:${o.join(",")}`)}function f(h,d,o,v){const R=h.get(D.IInstantiationService),c=h.get(E.ISearchService),s=R.createInstance(k.QueryBuilder).file(d.map(u=>(0,P.toWorkspaceFolder)(p.URI.revive(u))),{_reason:"checkExists",includePattern:o,exists:!0});return c.fileSearch(s,v).then(u=>!!u.limitHit,u=>L.isCancellationError(u)?!1:Promise.reject(u))}e.checkGlobFileExists=f});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,a,p,b){if(p==="m")throw new TypeError("Private method is not writable");if(p==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return p==="a"?b.call(ne,a):b?b.value=a:e.set(ne,a),a},Oe=this&&this.__classPrivateFieldGet||function(ne,e,a,p){if(a==="a"&&!p)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!p:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?p:a==="a"?p.call(ne):p?p.value:e.get(ne)};define(ye[33],De([1,0,130,19,71,22,14,7,25,2,15,4,32,180,69,31,24,179,11,27,23,158,6,84,3,28,70,13,58,62,52,5,229,67,160,12]),function(ne,e,a,p,b,L,D,k,E,P,O,y,m,T,f,h,d,o,v,R,c,w,s,u,n,i,r,t,l,_,g,C,U,W,M,S){"use strict";var z,$,F;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,n.createDecorator)("IHostUtils");let q=class Ti extends k.Disposable{constructor(te,Ee,be,ee,ve,Ae,Fe,$e,Qe,Ie){super();this._onDidChangeRemoteConnectionData=this._register(new C.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=Ee,this._extHostContext=be,this._initData=Fe,this._extHostWorkspace=ee,this._extHostConfiguration=ve,this._logService=Ae,this._extHostTunnelService=Qe,this._extHostTerminalService=Ie,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(y.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(y.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(y.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new D.Barrier,this._readyToStartExtensionHost=new D.Barrier,this._readyToRunExtensions=new D.Barrier,this._eagerExtensionsActivated=new D.Barrier,this._globalRegistry=new o.ExtensionDescriptionRegistry(this._initData.allExtensions);const Se=(0,d.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new o.ExtensionDescriptionRegistry(Z(this._globalRegistry,Se)),this._storage=new f.ExtHostStorage(this._extHostContext),this._secretState=new W.ExtHostSecretState(this._extHostContext),this._storagePath=$e,this._instaService=te.createChild(new l.ServiceCollection([f.IExtHostStorage,this._storage],[W.IExtHostSecretState,this._secretState]));let ke=[],ae=[];this._initData.remote.isRemote&&(ke=this._initData.allExtensions.filter(G=>!G.main&&!G.browser).map(G=>G.identifier),ae=this._initData.allExtensions.filter(G=>!Se.has(R.ExtensionIdentifier.toKey(G.identifier.value))).filter(G=>(G.main||G.browser)&&G.api==="none").map(G=>G.identifier));const le=(0,d.extensionIdentifiersArrayToSet)(ae);this._activator=this._register(new T.ExtensionsActivator(this._myRegistry,ke,ae,{onExtensionActivationError:(G,Q,I)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(G,v.transformErrorForSerialization(Q),I)},actualActivateExtension:async(G,Q)=>{if(le.has(R.ExtensionIdentifier.toKey(G)))return await this._mainThreadExtensionsProxy.$activateExtension(G,Q),new T.HostExtension;const I=this._myRegistry.getExtensionDescription(G);return this._activateExtension(I,Q)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),b.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(te){v.onUnexpectedError(te)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let te=[];try{te=this._myRegistry.getAllExtensionDescriptions().map(ve=>ve.identifier).filter(ve=>this.isActivated(ve)).map(ve=>this._deactivate(ve))}catch{}await Promise.all(te)}terminate(te,Ee=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${te}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),v.setUnexpectedErrorHandler(ee=>{this._logService.error(ee)}),this._extHostContext.dispose();const be=this._deactivateAll();Promise.race([(0,D.timeout)(5e3),be]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${Ee}`):this._logService.info(`Extension host exiting with code ${Ee}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(Ee)})}isActivated(te){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(te):!1}async getExtension(te){const Ee=await this._mainThreadExtensionsProxy.$getExtension(te);let be;if(Ee?.browserNlsBundleUris){be={};for(const ee of Object.keys(Ee.browserNlsBundleUris))be[ee]=P.URI.revive(Ee.browserNlsBundleUris[ee])}return Ee&&{...Ee,identifier:new R.ExtensionIdentifier(Ee.identifier.value),extensionLocation:P.URI.revive(Ee.extensionLocation),browserNlsBundleUris:be}}_activateByEvent(te,Ee){return this._activator.activateByEvent(te,Ee)}_activateById(te,Ee){return this._activator.activateById(te,Ee)}activateByIdWithErrors(te,Ee){return this._activateById(te,Ee).then(()=>{const be=this._activator.getActivatedExtension(te);if(be.activationFailed)return Promise.reject(be.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(te=>this._myRegistry)}getExtensionExports(te){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(te).exports:null}async _realPathExtensionUri(te){if(te.scheme!==S.Schemas.file)return te;const Ee=await this._hostUtils.realpath(te.fsPath);return P.URI.file(Ee)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(te=>new oe(te))),this._extensionPathIndex}async _createExtensionPathIndex(te){const Ee=E.TernarySearchTree.forUris(be=>L.extUriBiasedIgnorePathCase.ignorePathCasing(be));return await Promise.all(te.map(async be=>{if(this._getEntryPoint(be)){const ee=await this._realPathExtensionUri(be.extensionLocation);Ee.set(ee,be)}})),Ee}_deactivate(te){let Ee=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(te))return Ee;const be=this._activator.getActivatedExtension(te);if(!be)return Ee;try{typeof be.module.deactivate=="function"&&(Ee=Promise.resolve(be.module.deactivate()).then(void 0,ee=>(this._logService.error(ee),Promise.resolve(void 0))))}catch(ee){this._logService.error(`An error occurred when deactivating the extension '${te.value}':`),this._logService.error(ee)}try{(0,k.dispose)(be.subscriptions)}catch(ee){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${te.value}':`),this._logService.error(ee)}return Ee}async _activateExtension(te,Ee){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(te.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(te.identifier),this._doActivateExtension(te,Ee).then(be=>{const ee=be.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(te.identifier,ee.codeLoadingTime,ee.activateCallTime,ee.activateResolvedTime,Ee),this._logExtensionActivationTimes(te,Ee,"success",ee),be},be=>{throw this._logExtensionActivationTimes(te,Ee,"failure"),be})}_logExtensionActivationTimes(te,Ee,be,ee){const ve=ie(te,Ee);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ve,...ee||{},outcome:be})}_doActivateExtension(te,Ee){const be=ie(te,Ee);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",be);const ee=this._getEntryPoint(te);if(!ee)return Promise.resolve(new T.EmptyExtension(T.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${te.identifier.value}, startup: ${Ee.startup}, activationEvent: '${Ee.activationEvent}'${te.identifier.value!==Ee.extensionId.value?`, root cause: ${Ee.extensionId.value}`:""}`),this._logService.flush();const ve=new T.ExtensionActivationTimesBuilder(Ee.startup);return Promise.all([this._loadCommonJSModule(te,(0,L.joinPath)(te.extensionLocation,ee),ve),this._loadExtensionContext(te)]).then(Ae=>(b.mark(`code/extHost/willActivateExtension/${te.identifier.value}`),Ti._callActivate(this._logService,te.identifier,Ae[0],Ae[1],ve))).then(Ae=>(b.mark(`code/extHost/didActivateExtension/${te.identifier.value}`),Ae))}_loadExtensionContext(te){const Ee=new w.ExtensionGlobalMemento(te,this._storage),be=new w.ExtensionMemento(te.identifier.value,!1,this._storage),ee=new M.ExtensionSecrets(te,this._secretState),ve=te.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?s.ExtensionMode.Test:s.ExtensionMode.Development:s.ExtensionMode.Production,Ae=this._initData.remote.isRemote?s.ExtensionKind.Workspace:s.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${te.identifier.value}`),Promise.all([Ee.whenReady,be.whenReady,this._storagePath.whenReady]).then(()=>{const Fe=this;let $e,Qe;const Ie=(0,d.isProposedApiEnabled)(te,"ipc")?this._initData.messagePorts?.get(R.ExtensionIdentifier.toKey(te.identifier)):void 0;return Object.freeze({globalState:Ee,workspaceState:be,secrets:ee,subscriptions:[],get extensionUri(){return te.extensionLocation},get extensionPath(){return te.extensionLocation.fsPath},asAbsolutePath(Se){return p.join(te.extensionLocation.fsPath,Se)},get storagePath(){return Fe._storagePath.workspaceValue(te)?.fsPath},get globalStoragePath(){return Fe._storagePath.globalValue(te).fsPath},get logPath(){return p.join(Fe._initData.logsLocation.fsPath,te.identifier.value)},get logUri(){return P.URI.joinPath(Fe._initData.logsLocation,te.identifier.value)},get storageUri(){return Fe._storagePath.workspaceValue(te)},get globalStorageUri(){return Fe._storagePath.globalValue(te)},get extensionMode(){return ve},get extension(){return $e===void 0&&($e=new A(Fe,te.identifier,te,Ae,!1)),$e},get extensionRuntime(){return(0,d.checkProposedApiEnabled)(te,"extensionRuntime"),Fe.extensionRuntime},get environmentVariableCollection(){return Fe._extHostTerminalService.getEnvironmentVariableCollection(te)},get messagePassingProtocol(){if(!Qe){if(!Ie)return;const Se=C.Event.buffer(C.Event.fromDOMEventEmitter(Ie,"message",ke=>ke.data));Ie.start(),Qe={onDidReceiveMessage:Se,postMessage:Ie.postMessage.bind(Ie)}}return Qe}})})}static _callActivate(te,Ee,be,ee,ve){return be=be||{activate:void 0,deactivate:void 0},this._callActivateOptional(te,Ee,be,ee,ve).then(Ae=>new T.ActivatedExtension(!1,null,ve.build(),be,Ae,ee.subscriptions))}static _callActivateOptional(te,Ee,be,ee,ve){if(typeof be.activate=="function")try{ve.activateCallStart(),te.trace(`ExtensionService#_callActivateOptional ${Ee.value}`);const Ae=typeof global=="object"?global:self,Fe=be.activate.apply(Ae,[ee]);return ve.activateCallStop(),ve.activateResolveStart(),Promise.resolve(Fe).then($e=>(ve.activateResolveStop(),$e))}catch(Ae){return Promise.reject(Ae)}else return Promise.resolve(be)}_activateOneStartupFinished(te,Ee){this._activateById(te.identifier,{startup:!1,extensionId:te.identifier,activationEvent:Ee}).then(void 0,be=>{this._logService.error(be)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(b.getMarks());for(const te of this._myRegistry.getAllExtensionDescriptions())if(te.activationEvents)for(const Ee of te.activationEvents)Ee==="onStartupFinished"&&this._activateOneStartupFinished(te,Ee)}_handleEagerExtensions(){const te=this._activateByEvent("*",!0).then(void 0,ve=>{this._logService.error(ve)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ve=>this._handleWorkspaceContainsEagerExtensions(ve.added)));const Ee=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],be=this._handleWorkspaceContainsEagerExtensions(Ee),ee=Promise.all([te,be]).then(()=>{});return Promise.race([ee,(0,D.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ee}_handleWorkspaceContainsEagerExtensions(te){return te.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(Ee=>this._handleWorkspaceContainsEagerExtension(te,Ee))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(te,Ee){if(this.isActivated(Ee.identifier))return;const be=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ee={logService:this._logService,folders:te.map(Ae=>Ae.uri),forceUsingSearch:be,exists:Ae=>this._hostUtils.exists(Ae.fsPath),checkExists:(Ae,Fe,$e)=>this._mainThreadWorkspaceProxy.$checkExists(Ae,Fe,$e)},ve=await(0,U.checkActivateWorkspaceContainsExtension)(ee,Ee);if(!!ve)return this._activateById(Ee.identifier,{startup:!0,extensionId:Ee.identifier,activationEvent:ve.activationEvent}).then(void 0,Ae=>this._logService.error(Ae))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(te){throw console.error(te),te}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:te,extensionTestsLocationURI:Ee}=this._initData.environment;if(!te||!Ee)throw new Error(a.localize(0,null));const be=await this._loadCommonJSModule(null,Ee,new T.ExtensionActivationTimesBuilder(!1));if(!be||typeof be.run!="function")throw new Error(a.localize(1,null,Ee.toString()));return new Promise((ee,ve)=>{const Ae=(Qe,Ie)=>{Qe?ve(Qe):ee(typeof Ie=="number"&&Ie>0?1:0)},Fe=(0,L.originalFSPath)(Ee),$e=be.run(Fe,Ae);$e&&$e.then&&$e.then(()=>{ee(0)}).catch(Qe=>{ve(Qe instanceof Error&&Qe.stack?Qe.stack:String(Qe))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(te,Ee){return this._resolvers[te]=Ee,(0,k.toDisposable)(()=>{delete this._resolvers[te]})}async _activateAndGetResolver(te){const Ee=te.indexOf("+");if(Ee===-1)throw new Error("Not an authority that can be resolved!");const be=te.substr(0,Ee);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${be}`,!1),{authorityPrefix:be,resolver:this._resolvers[be]}}async $resolveAuthority(te,Ee){this._logService.info(`$resolveAuthority invoked for authority (${ce(te)})`);const{authorityPrefix:be,resolver:ee}=await this._activateAndGetResolver(te);if(!ee)return{type:"error",error:{code:u.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${be}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(ee)),b.mark(`code/extHost/willResolveAuthority/${be}`);const ve=await ee.resolve(te,{resolveAttempt:Ee});b.mark(`code/extHost/didResolveAuthorityOK/${be}`);const Ae={authority:te,host:ve.host,port:ve.port,connectionToken:ve.connectionToken},Fe={extensionHostEnv:ve.extensionHostEnv,isTrusted:ve.isTrusted,authenticationSession:ve.authenticationSessionForInitializingExtensions?{id:ve.authenticationSessionForInitializingExtensions.id,providerId:ve.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Ae,options:Fe,tunnelInformation:{environmentTunnels:ve.environmentTunnels,features:ve.tunnelFeatures}}}}catch(ve){if(b.mark(`code/extHost/didResolveAuthorityError/${be}`),ve instanceof s.RemoteAuthorityResolverError)return{type:"error",error:{code:ve._code,message:ve._message,detail:ve._detail}};throw ve}}async $getCanonicalURI(te,Ee){this._logService.info(`$getCanonicalURI invoked for authority (${ce(te)})`);const{resolver:be}=await this._activateAndGetResolver(te);if(!be)return null;const ee=P.URI.revive(Ee);if(typeof be.getCanonicalURI=="undefined")return ee;const ve=await(0,D.asPromise)(()=>be.getCanonicalURI(ee));return ve||ee}static _applyExtensionsDelta(te,Ee,be){const ee=new o.ExtensionDescriptionRegistry(te.getAllExtensionDescriptions());ee.deltaExtensions(be.toAdd,be.toRemove);const ve=(0,d.extensionIdentifiersArrayToSet)(Ee.getAllExtensionDescriptions().map(Fe=>Fe.identifier));for(const Fe of be.myToRemove)ve.delete(R.ExtensionIdentifier.toKey(Fe));for(const Fe of be.myToAdd)ve.add(R.ExtensionIdentifier.toKey(Fe));const Ae=Z(ee,ve);return{globalRegistry:ee,myExtensions:Ae}}$startExtensionHost(te){te.toAdd.forEach(ee=>ee.extensionLocation=P.URI.revive(ee.extensionLocation));const{globalRegistry:Ee,myExtensions:be}=Ti._applyExtensionsDelta(this._globalRegistry,this._myRegistry,te);return this._globalRegistry.set(Ee.getAllExtensionDescriptions()),this._myRegistry.set(be),this._startExtensionHost()}$activateByEvent(te,Ee){return Ee===1?this._activateByEvent(te,!1):this._readyToRunExtensions.wait().then(be=>this._activateByEvent(te,!1))}async $activate(te,Ee){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(te)?(await this._activateById(te,Ee),!0):!1}async $deltaExtensions(te){te.toAdd.forEach(Ae=>Ae.extensionLocation=P.URI.revive(Ae.extensionLocation));const{globalRegistry:Ee,myExtensions:be}=Ti._applyExtensionsDelta(this._globalRegistry,this._myRegistry,te),ee=await this._createExtensionPathIndex(be);return(await this.getExtensionPathIndex()).setSearchTree(ee),this._globalRegistry.set(Ee.getAllExtensionDescriptions()),this._myRegistry.set(be),Promise.resolve(void 0)}async $test_latency(te){return te}async $test_up(te){return te.byteLength}async $test_down(te){const Ee=c.VSBuffer.alloc(te),be=Math.random()%256;for(let ee=0;ee<te;ee++)Ee.writeUInt8(be,ee);return Ee}async $updateRemoteConnectionData(te){this._remoteConnectionData=te,this._onDidChangeRemoteConnectionData.fire()}};q=ze([xe(0,n.IInstantiationService),xe(1,e.IHostUtils),xe(2,t.IExtHostRpcService),xe(3,h.IExtHostWorkspace),xe(4,m.IExtHostConfiguration),xe(5,O.ILogService),xe(6,i.IExtHostInitDataService),xe(7,r.IExtensionStoragePaths),xe(8,_.IExtHostTunnelService),xe(9,g.IExtHostTerminalService)],q),e.AbstractExtHostExtensionService=q;function ie(ue,te){return{id:ue.identifier.value,name:ue.name,extensionVersion:ue.version,publisherDisplayName:ue.publisher,activationEvents:ue.activationEvents?ue.activationEvents.join(","):null,isBuiltin:ue.isBuiltin,reason:te.activationEvent,reasonId:te.extensionId.value}}e.IExtHostExtensionService=(0,n.createDecorator)("IExtHostExtensionService");class A{constructor(te,Ee,be,ee,ve){z.set(this,void 0),$.set(this,void 0),F.set(this,void 0),Ye(this,z,te,"f"),Ye(this,$,Ee,"f"),Ye(this,F,be.identifier,"f"),this.id=be.identifier.value,this.extensionUri=be.extensionLocation,this.extensionPath=p.normalize((0,L.originalFSPath)(be.extensionLocation)),this.packageJSON=be,this.extensionKind=ee,this.isFromDifferentExtensionHost=ve}get isActive(){return Oe(this,z,"f").isActivated(Oe(this,F,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Oe(this,z,"f").getExtensionExports(Oe(this,F,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Oe(this,z,"f").activateByIdWithErrors(Oe(this,F,"f"),{startup:!1,extensionId:Oe(this,$,"f"),activationEvent:"api"}),this.exports}}e.Extension=A,z=new WeakMap,$=new WeakMap,F=new WeakMap;function Z(ue,te){return ue.getAllExtensionDescriptions().filter(Ee=>te.has(R.ExtensionIdentifier.toKey(Ee.identifier)))}function ce(ue){const te=ue.indexOf("+");return te===-1?ue:ue.substring(0,te)}class oe{constructor(te){this._searchTree=te}setSearchTree(te){this._searchTree=te}findSubstr(te){return this._searchTree.findSubstr(te)}forEach(te){return this._searchTree.forEach(te)}}e.ExtensionPaths=oe}),define(ye[230],De([1,0,71,2,4,32,24,27,13,28,3,33,59,15,9]),function(ne,e,a,p,b,L,D,k,E,P,O,y,m,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let h=class{constructor(w,s,u,n,i,r,t){this._apiFactory=w,this._extensionRegistry=s,this._instaService=u,this._extHostConfiguration=n,this._extHostExtensionService=i,this._initData=r,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),a.mark("code/extHost/willWaitForConfig");const w=await this._extHostConfiguration.getConfigProvider();a.mark("code/extHost/didWaitForConfig");const s=await this._extHostExtensionService.getExtensionPathIndex();this.register(new o(this._apiFactory,s,this._extensionRegistry,w,this._logService)),this.register(this._instaService.createInstance(v,s)),this.register(this._instaService.createInstance(d)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(R,s,this._initData.environment.appUriScheme))}register(w){if("nodeModuleName"in w)if(Array.isArray(w.nodeModuleName))for(const s of w.nodeModuleName)this._factories.set(s,w);else this._factories.set(w.nodeModuleName,w);typeof w.alternativeModuleName=="function"&&this._alternatives.push(s=>w.alternativeModuleName(s))}};h=ze([xe(2,O.IInstantiationService),xe(3,L.IExtHostConfiguration),xe(4,y.IExtHostExtensionService),xe(5,P.IExtHostInitDataService),xe(6,T.ILogService)],h),e.RequireInterceptor=h;let d=class Xi{constructor(w){if(w.environment.appRoot&&Xi.aliased.size){const s=(0,f.escapeRegExpCharacters)(this.forceForwardSlashes(w.environment.appRoot.fsPath)),u="[a-z0-9_.-]",n=`@${u}+\\/${u}+|${u}+`,i="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${s}/${i}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(w){if(!this.re)return;const s=this.re.exec(this.forceForwardSlashes(w));if(!s)return;const[,u,n,i]=s,r=Xi.aliased.get(n);if(r!==void 0)return console.warn(`${n} as been renamed to ${r}, please update your imports`),u+r+i}forceForwardSlashes(w){return w.replace(/\\/g,"/")}};d.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),d=ze([xe(0,P.IExtHostInitDataService)],d);class o{constructor(w,s,u,n,i){this._apiFactory=w,this._extensionPaths=s,this._extensionRegistry=u,this._configProvider=n,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(w,s){const u=this._extensionPaths.findSubstr(s);if(u){let n=this._extApiImpl.get(k.ExtensionIdentifier.toKey(u.identifier));return n||(n=this._apiFactory(u,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(u.identifier),n)),n}if(!this._defaultApiImpl){let n="";this._extensionPaths.forEach((i,r)=>n+=`	${r} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${n}`),this._defaultApiImpl=this._apiFactory(D.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let v=class{constructor(w,s,u){this._extensionPaths=w,this.nodeModuleName="keytar",this._mainThreadTelemetry=s.getProxy(b.MainContext.MainThreadTelemetry);const{environment:n}=u,i=s.getProxy(b.MainContext.MainThreadKeytar);if(n.appRoot){let r=n.appRoot.fsPath;m.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,t)=>i.$getPassword(r,t),setPassword:(r,t,l)=>i.$setPassword(r,t,l),deletePassword:(r,t)=>i.$deletePassword(r,t),findPassword:r=>i.$findPassword(r),findCredentials(r){return i.$findCredentials(r)}}}load(w,s){const u=this._extensionPaths.findSubstr(s);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:u?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(w){const s=w.length;if(s<=7||!this.alternativeNames)return;const u=s-7;if((w.charAt(u)==="/"||w.charAt(u)==="\\")&&w.endsWith("keytar")&&(w=w.replace(/\\/g,"/"),this.alternativeNames.has(w)))return"keytar"}};v=ze([xe(1,E.IExtHostRpcService),xe(2,P.IExtHostInitDataService)],v);let R=class{constructor(w,s,u){this._extensionPaths=w,this._appUriScheme=s,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=u.getProxy(b.MainContext.MainThreadTelemetry);const n=u.getProxy(b.MainContext.MainThreadWindow);this._impl=(i,r)=>{const t=p.URI.parse(i);return r?this.callOriginal(i,r):t.scheme==="http"||t.scheme==="https"?n.$openUri(t,i,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?n.$openUri(t,i,{}):this.callOriginal(i,r)}}load(w,s,u){const n=this._extensionPaths.findSubstr(s);return n&&(this._extensionId=n.identifier.value,this.sendShimmingTelemetry()),this._original=u(w),this._impl}callOriginal(w,s){return this.sendNoForwardTelemetry(),this._original(w,s)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};R=ze([xe(2,E.IExtHostRpcService)],R)}),define(ye[102],De([1,0,197,7,19,59,3,49,50,33,6,31,171,32]),function(ne,e,a,p,b,L,D,k,E,P,O,y,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,D.createDecorator)("IExtHostVariableResolverProvider");class f extends m.AbstractVariableResolverService{constructor(o,v,R,c,w,s,u){function n(){if(R){const i=R.activeEditor();if(i)return i.document.uri;const r=c.tabGroups.all.find(t=>t.isActive)?.activeTab;if(r!==void 0){if(r.input instanceof O.TextDiffTabInput||r.input instanceof O.NotebookDiffEditorTabInput)return r.input.modified;if(r.input instanceof O.TextTabInput||r.input instanceof O.NotebookEditorTabInput||r.input instanceof O.CustomEditorTabInput)return r.input.uri}}}super({getFolderUri:i=>{const r=s.folders.filter(t=>t.name===i);if(r&&r.length>0)return r[0].uri},getWorkspaceFolderCount:()=>s.folders.length,getConfigurationValue:(i,r)=>w.getConfiguration(void 0,i).get(r),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const i=n();if(i)return b.normalize(i.fsPath)},getWorkspaceFolderPathForFile:()=>{if(v){const i=n();if(i){const r=v.getWorkspaceFolder(i);if(r)return b.normalize(r.uri.fsPath)}}},getSelectedText:()=>{if(R){const i=R.activeEditor();if(i&&!i.selection.isEmpty)return i.document.getText(i.selection)}},getLineNumber:()=>{if(R){const i=R.activeEditor();if(i)return String(i.selection.end.line+1)}},getExtension:i=>o.getExtension(i)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(L.env))}}let h=class extends p.Disposable{constructor(o,v,R,c,w){super();this.extensionService=o,this.workspaceService=v,this.editorService=R,this.configurationService=c,this.editorTabs=w,this._resolver=new a.Lazy(async()=>{const s=await this.configurationService.getConfigProvider(),n={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async i=>{n.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new f(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,s,n,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};h=ze([xe(0,P.IExtHostExtensionService),xe(1,y.IExtHostWorkspace),xe(2,k.IExtHostDocumentsAndEditors),xe(3,T.IExtHostConfiguration),xe(4,E.IExtHostEditorTabs)],h),e.ExtHostVariableResolverProviderService=h}),define(ye[103],De([1,0,14,5,10,2,3,4,50,33,13,6,31,165,167,32,102]),function(ne,e,a,p,b,L,D,k,E,P,O,y,m,T,f,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,D.createDecorator)("IExtHostDebugService");let o=class{constructor(n,i,r,t,l,_){this._workspaceService=i,this._extensionService=r,this._configurationService=t,this._editorTabs=l,this._variableResolver=_,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new p.Emitter,this._onDidTerminateDebugSession=new p.Emitter,this._onDidChangeActiveDebugSession=new p.Emitter,this._onDidReceiveDebugSessionCustomEvent=new p.Emitter,this._debugServiceProxy=n.getProxy(k.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new p.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new R(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(g=>{g.onDidChange(C=>{this.registerAllDebugTypes(g)}),this.registerAllDebugTypes(g)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(n,i){const r=n;if(typeof r.sourceReference=="number"&&r.sourceReference>0){let t=`debug:${encodeURIComponent(r.path||"")}`,l="?";return i&&(t+=`${l}session=${encodeURIComponent(i.id)}`,l="&"),t+=`${l}ref=${r.sourceReference}`,L.URI.parse(t)}else{if(r.path)return L.URI.file(r.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(n){const i=[];for(const r of n.getAllExtensionDescriptions())if(r.contributes){const t=r.contributes.debuggers;if(t&&t.length>0)for(const l of t)(0,f.isDebuggerMainContribution)(l)&&i.push(l.type)}this._debugServiceProxy.$registerDebugTypes(i)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const n=[];return this._breakpoints.forEach(i=>n.push(i)),n}addBreakpoints(n){this.startBreakpoints();const i=n.filter(l=>{const _=l.id;return this._breakpoints.has(_)?!1:(this._breakpoints.set(_,l),!0)});this.fireBreakpointChanges(i,[],[]);const r=[],t=new Map;for(const l of i)if(l instanceof y.SourceBreakpoint){let _=t.get(l.location.uri.toString());_||(_={type:"sourceMulti",uri:l.location.uri,lines:[]},t.set(l.location.uri.toString(),_),r.push(_)),_.lines.push({id:l.id,enabled:l.enabled,condition:l.condition,hitCondition:l.hitCondition,logMessage:l.logMessage,line:l.location.range.start.line,character:l.location.range.start.character})}else l instanceof y.FunctionBreakpoint&&r.push({type:"function",id:l.id,enabled:l.enabled,hitCondition:l.hitCondition,logMessage:l.logMessage,condition:l.condition,functionName:l.functionName});return this._debugServiceProxy.$registerBreakpoints(r)}removeBreakpoints(n){this.startBreakpoints();const i=n.filter(_=>this._breakpoints.delete(_.id));this.fireBreakpointChanges([],i,[]);const r=i.filter(_=>_ instanceof y.SourceBreakpoint).map(_=>_.id),t=i.filter(_=>_ instanceof y.FunctionBreakpoint).map(_=>_.id),l=i.filter(_=>_ instanceof y.DataBreakpoint).map(_=>_.id);return this._debugServiceProxy.$unregisterBreakpoints(r,t,l)}startDebugging(n,i,r){return this._debugServiceProxy.$startDebugging(n?n.uri:void 0,i,{parentSessionID:r.parentSession?r.parentSession.id:void 0,lifecycleManagedByParent:r.lifecycleManagedByParent,repl:r.consoleMode===y.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:r.noDebug,compact:r.compact,debugUI:r.debugUI,suppressSaveBeforeStart:r.suppressSaveBeforeStart})}stopDebugging(n){return this._debugServiceProxy.$stopDebugging(n?n.id:void 0)}registerDebugConfigurationProvider(n,i,r){if(!i)return new y.Disposable(()=>{});const t=this._configProviderHandleCounter++;return this._configProviders.push({type:n,handle:t,provider:i}),this._debugServiceProxy.$registerDebugConfigurationProvider(n,r,!!i.provideDebugConfigurations,!!i.resolveDebugConfiguration,!!i.resolveDebugConfigurationWithSubstitutedVariables,t),new y.Disposable(()=>{this._configProviders=this._configProviders.filter(l=>l.provider!==i),this._debugServiceProxy.$unregisterDebugConfigurationProvider(t)})}registerDebugAdapterDescriptorFactory(n,i,r){if(!r)return new y.Disposable(()=>{});if(!this.definesDebugType(n,i))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${i}' debugger.`);if(this.getAdapterDescriptorFactoryByType(i))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const t=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:i,handle:t,factory:r}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(i,t),new y.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(l=>l.factory!==r),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(t)})}registerDebugAdapterTrackerFactory(n,i){if(!i)return new y.Disposable(()=>{});const r=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:n,handle:r,factory:i}),new y.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(t=>t.factory!==i)})}async $runInTerminal(n,i){return Promise.resolve(void 0)}async $substituteVariables(n,i){let r;const t=await this.getFolder(n);return t&&(r={uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(r,i)}createDebugAdapter(n,i){if(n.type==="implementation")return new w(n.implementation)}createSignService(){}async $startDASession(n,i){const r=this,t=await this.getSession(i);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(t.type),t).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${t.type}' (extension might have failed to activate)`);const _=this.convertToDto(l),g=this.createDebugAdapter(_,t);if(!g)throw new Error(`Couldn't create a debug adapter for type '${t.type}'.`);const C=g;return this._debugAdapters.set(n,C),this.getDebugAdapterTrackers(t).then(U=>(U&&this._debugAdaptersTrackers.set(n,U),C.onMessage(async W=>{if(W.type==="request"&&W.command==="handshake"){const M=W,S={type:"response",seq:0,command:M.command,request_seq:M.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const z=await this._signService.sign(M.arguments.value);S.body={signature:z},C.sendResponse(S)}else throw new Error("no signer")}catch(z){S.success=!1,S.message=z.message,C.sendResponse(S)}}else U&&U.onDidSendMessage&&U.onDidSendMessage(W),W=(0,f.convertToVSCPaths)(W,!0),r._debugServiceProxy.$acceptDAMessage(n,W)}),C.onError(W=>{U&&U.onError&&U.onError(W),this._debugServiceProxy.$acceptDAError(n,W.name,W.message,W.stack)}),C.onExit(W=>{U&&U.onExit&&U.onExit((0,b.withNullAsUndefined)(W),void 0),this._debugServiceProxy.$acceptDAExit(n,(0,b.withNullAsUndefined)(W),void 0)}),U&&U.onWillStartSession&&U.onWillStartSession(),C.startSession()))})}$sendDAMessage(n,i){i=(0,f.convertToDAPaths)(i,!1);const r=this._debugAdaptersTrackers.get(n);r&&r.onWillReceiveMessage&&r.onWillReceiveMessage(i),this._debugAdapters.get(n)?.sendMessage(i)}$stopDASession(n){const i=this._debugAdaptersTrackers.get(n);this._debugAdaptersTrackers.delete(n),i&&i.onWillStopSession&&i.onWillStopSession();const r=this._debugAdapters.get(n);return this._debugAdapters.delete(n),r?r.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(n){const i=[],r=[],t=[];if(n.added)for(const l of n.added){const _=l.id;if(_&&!this._breakpoints.has(_)){let g;if(l.type==="function")g=new y.FunctionBreakpoint(l.functionName,l.enabled,l.condition,l.hitCondition,l.logMessage);else if(l.type==="data")g=new y.DataBreakpoint(l.label,l.dataId,l.canPersist,l.enabled,l.hitCondition,l.condition,l.logMessage);else{const C=L.URI.revive(l.uri);g=new y.SourceBreakpoint(new y.Location(C,new y.Position(l.line,l.character)),l.enabled,l.condition,l.hitCondition,l.logMessage)}g._id=_,this._breakpoints.set(_,g),i.push(g)}}if(n.removed)for(const l of n.removed){const _=this._breakpoints.get(l);_&&(this._breakpoints.delete(l),r.push(_))}if(n.changed){for(const l of n.changed)if(l.id){const _=this._breakpoints.get(l.id);if(_){if(_ instanceof y.FunctionBreakpoint&&l.type==="function"){const g=_;g.enabled=l.enabled,g.condition=l.condition,g.hitCondition=l.hitCondition,g.logMessage=l.logMessage,g.functionName=l.functionName}else if(_ instanceof y.SourceBreakpoint&&l.type==="source"){const g=_;g.enabled=l.enabled,g.condition=l.condition,g.hitCondition=l.hitCondition,g.logMessage=l.logMessage,g.location=new y.Location(L.URI.revive(l.uri),new y.Position(l.line,l.character))}t.push(_)}}}this.fireBreakpointChanges(i,r,t)}$provideDebugConfigurations(n,i,r){return(0,a.asPromise)(async()=>{const t=this.getConfigProviderByHandle(n);if(!t)throw new Error("no DebugConfigurationProvider found");if(!t.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const l=await this.getFolder(i);return t.provideDebugConfigurations(l,r)}).then(t=>{if(!t)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return t})}$resolveDebugConfiguration(n,i,r,t){return(0,a.asPromise)(async()=>{const l=this.getConfigProviderByHandle(n);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const _=await this.getFolder(i);return l.resolveDebugConfiguration(_,r,t)})}$resolveDebugConfigurationWithSubstitutedVariables(n,i,r,t){return(0,a.asPromise)(async()=>{const l=this.getConfigProviderByHandle(n);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const _=await this.getFolder(i);return l.resolveDebugConfigurationWithSubstitutedVariables(_,r,t)})}async $provideDebugAdapter(n,i){const r=this.getAdapterDescriptorFactoryByHandle(n);if(!r)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const t=await this.getSession(i);return this.getAdapterDescriptor(r,t).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${t.type}'`);return this.convertToDto(l)})}async $acceptDebugSessionStarted(n){const i=await this.getSession(n);this._onDidStartDebugSession.fire(i)}async $acceptDebugSessionTerminated(n){const i=await this.getSession(n);i&&(this._onDidTerminateDebugSession.fire(i),this._debugSessions.delete(i.id))}async $acceptDebugSessionActiveChanged(n){this._activeDebugSession=n?await this.getSession(n):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(n,i){(await this.getSession(n))?._acceptNameChanged(i)}async $acceptDebugSessionCustomEvent(n,i){const t={session:await this.getSession(n),event:i.event,body:i.body};this._onDidReceiveDebugSessionCustomEvent.fire(t)}convertToDto(n){if(n instanceof y.DebugAdapterExecutable)return{type:"executable",command:n.command,args:n.args,options:n.options};if(n instanceof y.DebugAdapterServer)return{type:"server",port:n.port,host:n.host};if(n instanceof y.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:n.path};if(n instanceof y.DebugAdapterInlineImplementation)return{type:"implementation",implementation:n.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(n){const i=this._adapterFactories.filter(r=>r.type===n);if(i.length>0)return i[0].factory}getAdapterDescriptorFactoryByHandle(n){const i=this._adapterFactories.filter(r=>r.handle===n);if(i.length>0)return i[0].factory}getConfigProviderByHandle(n){const i=this._configProviders.filter(r=>r.handle===n);if(i.length>0)return i[0].provider}definesDebugType(n,i){if(n.contributes){const r=n.contributes.debuggers;if(r&&r.length>0){for(const t of r)if(t.label&&t.type&&t.type===i)return!0}}return!1}getDebugAdapterTrackers(n){const r=n.configuration.type,t=this._trackerFactories.filter(l=>l.type===r||l.type==="*").map(l=>(0,a.asPromise)(()=>l.factory.createDebugAdapterTracker(n)).then(_=>_,_=>null));return Promise.race([Promise.all(t).then(l=>{const _=l.filter(g=>!!g);if(_.length>0)return new c(_)}),new Promise((l,_)=>{const g=setTimeout(()=>{clearTimeout(g),_(new Error("timeout"))},1e3)})]).catch(l=>{})}async getAdapterDescriptor(n,i){const r=i.configuration.debugServer;if(typeof r=="number")return Promise.resolve(new y.DebugAdapterServer(r));if(n){const l=await this._extensionService.getExtensionRegistry();return(0,a.asPromise)(()=>n.createDebugAdapterDescriptor(i,this.daExecutableFromPackage(i,l))).then(_=>{if(_)return _})}const t=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(i,t))}daExecutableFromPackage(n,i){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(n,i,r){(n.length>0||i.length>0||r.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:n,removed:i,changed:r}))}async getSession(n){if(n)if(typeof n=="string"){const i=this._debugSessions.get(n);if(i)return i}else{let i=this._debugSessions.get(n.id);if(!i){const r=await this.getFolder(n.folderUri),t=n.parent?this._debugSessions.get(n.parent):void 0;i=new v(this._debugServiceProxy,n.id,n.type,n.name,r,n.configuration,t),this._debugSessions.set(i.id,i),this._debugServiceProxy.$sessionCached(i.id)}return i}throw new Error("cannot find session")}getFolder(n){if(n){const i=L.URI.revive(n);return this._workspaceService.resolveWorkspaceFolder(i)}return Promise.resolve(void 0)}};o=ze([xe(0,O.IExtHostRpcService),xe(1,m.IExtHostWorkspace),xe(2,P.IExtHostExtensionService),xe(3,h.IExtHostConfiguration),xe(4,E.IExtHostEditorTabs),xe(5,d.IExtHostVariableResolverProvider)],o),e.ExtHostDebugServiceBase=o;class v{constructor(n,i,r,t,l,_,g){this._debugServiceProxy=n,this._id=i,this._type=r,this._name=t,this._workspaceFolder=l,this._configuration=_,this._parentSession=g}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(n){this._name=n,this._debugServiceProxy.$setDebugSessionName(this._id,n)}get parentSession(){return this._parentSession}_acceptNameChanged(n){this._name=n}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(n,i){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,n,i)}getDebugProtocolBreakpoint(n){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,n.id)}}e.ExtHostDebugSession=v;class R{constructor(n){this.value=Object.freeze({append(i){n.$appendDebugConsole(i)},appendLine(i){this.append(i+`
`)}})}}e.ExtHostDebugConsole=R;class c{constructor(n){this.trackers=n}onWillStartSession(){this.trackers.forEach(n=>n.onWillStartSession?n.onWillStartSession():void 0)}onWillReceiveMessage(n){this.trackers.forEach(i=>i.onWillReceiveMessage?i.onWillReceiveMessage(n):void 0)}onDidSendMessage(n){this.trackers.forEach(i=>i.onDidSendMessage?i.onDidSendMessage(n):void 0)}onWillStopSession(){this.trackers.forEach(n=>n.onWillStopSession?n.onWillStopSession():void 0)}onError(n){this.trackers.forEach(i=>i.onError?i.onError(n):void 0)}onExit(n,i){this.trackers.forEach(r=>r.onExit?r.onExit(n,i):void 0)}}class w extends T.AbstractDebugAdapter{constructor(n){super();this.implementation=n,n.onDidSendMessage(i=>{this.acceptMessage(i)})}startSession(){return Promise.resolve(void 0)}sendMessage(n){this.implementation.handleMessage(n)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let s=class extends o{constructor(n,i,r,t,l,_){super(n,i,r,t,l,_)}};s=ze([xe(0,O.IExtHostRpcService),xe(1,m.IExtHostWorkspace),xe(2,P.IExtHostExtensionService),xe(3,h.IExtHostConfiguration),xe(4,E.IExtHostEditorTabs),xe(5,d.IExtHostVariableResolverProvider)],s),e.WorkerExtHostDebugService=s}),define(ye[231],De([1,0,11,71,2,4,222,15,56,58,28,148,13,63,33]),function(ne,e,a,p,b,L,D,k,E,P,O,y,m,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class h{constructor(o,v,R,c,w){this._hostUtils=R,this._rpcProtocol=new D.RPCProtocol(o,null,c),v=h._transform(v,this._rpcProtocol);const s=new P.ServiceCollection(...(0,E.getSingletonServiceDescriptors)());s.set(O.IExtHostInitDataService,{_serviceBrand:void 0,...v,messagePorts:w}),s.set(m.IExtHostRpcService,new m.ExtHostRpcService(this._rpcProtocol)),s.set(T.IURITransformerService,new T.URITransformerService(c)),s.set(f.IHostUtils,R);const u=new y.InstantiationService(s,!0);this._logService=u.invokeFunction(t=>t.get(k.ILogService)),p.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",v),this._extensionService=u.invokeFunction(t=>t.get(f.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const n=new WeakMap;this._extensionService.getExtensionPathIndex().then(t=>{Error.prepareStackTrace=(l,_)=>{let g="",C,U;for(const W of _)g+=`
	at ${W.toString()}`,U=W.getFileName(),!C&&U&&(C=t.findSubstr(b.URI.file(U)));return n.set(l,C),`${l.name||"Error"}: ${l.message||""}${g}`}});const i=this._rpcProtocol.getProxy(L.MainContext.MainThreadExtensionService),r=this._rpcProtocol.getProxy(L.MainContext.MainThreadErrors);a.setUnexpectedErrorHandler(t=>{const l=a.transformErrorForSerialization(t),_=n.get(t);_?i.$onExtensionRuntimeError(_.identifier,l):r.$onUnexpectedError(l)})}async asBrowserUri(o){const v=this._rpcProtocol.getProxy(L.MainContext.MainThreadExtensionService);return b.URI.revive(await v.$asBrowserUri(o))}terminate(o){this._extensionService.terminate(o)}static _transform(o,v){o.allExtensions.forEach(c=>{c.extensionLocation=b.URI.revive(v.transformIncomingURIs(c.extensionLocation));const w={};c.browserNlsBundleUris&&(Object.keys(c.browserNlsBundleUris).forEach(s=>w[s]=b.URI.revive(v.transformIncomingURIs(c.browserNlsBundleUris[s]))),c.browserNlsBundleUris=w)}),o.environment.appRoot=b.URI.revive(v.transformIncomingURIs(o.environment.appRoot));const R=o.environment.extensionDevelopmentLocationURI;return R&&(o.environment.extensionDevelopmentLocationURI=R.map(c=>b.URI.revive(v.transformIncomingURIs(c)))),o.environment.extensionTestsLocationURI=b.URI.revive(v.transformIncomingURIs(o.environment.extensionTestsLocationURI)),o.environment.globalStorageHome=b.URI.revive(v.transformIncomingURIs(o.environment.globalStorageHome)),o.environment.workspaceStorageHome=b.URI.revive(v.transformIncomingURIs(o.environment.workspaceStorageHome)),o.logsLocation=b.URI.revive(v.transformIncomingURIs(o.logsLocation)),o.logFile=b.URI.revive(v.transformIncomingURIs(o.logFile)),o.workspace=v.transformIncomingURIs(o.workspace),o}}e.ExtensionHostMain=h}),define(ye[232],De([1,0,16,14,20,43,12,19,22,2,41]),function(ne,e,a,p,b,L,D,k,E,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class y{constructor(v,R,c,w){this.query=v,this.provider=R,this.fileUtils=c,this.processType=w,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(v,R){const c=this.query.folderQueries||[],w=new b.CancellationTokenSource;return R.onCancellationRequested(()=>w.cancel()),new Promise((s,u)=>{this.collector=new T(v);let n=!1;const i=(r,t)=>{if(!n&&!this.isLimitHit){const l=this.resultSize(r);h(r)&&typeof this.query.maxResults=="number"&&this.resultCount+l>this.query.maxResults&&(this.isLimitHit=!0,n=!0,w.cancel(),r=this.trimResultToSize(r,this.query.maxResults-this.resultCount));const _=this.resultSize(r);this.resultCount+=_,(_>0||!h(r))&&this.collector.add(r,t)}};Promise.all(c.map((r,t)=>this.searchInFolder(r,l=>i(l,t),w.token))).then(r=>{w.dispose(),this.collector.flush();const t=r.some(l=>!!l&&!!l.limitHit);s({limitHit:this.isLimitHit||t,messages:(0,a.flatten)(r.map(l=>l?.message?Array.isArray(l.message)?l.message:[l.message]:[])),stats:{type:this.processType}})},r=>{w.dispose();const t=(0,L.toErrorMessage)(r);u(new Error(t))})})}resultSize(v){return h(v)?Array.isArray(v.ranges)?v.ranges.length:1:0}trimResultToSize(v,R){const c=Array.isArray(v.ranges)?v.ranges:[v.ranges],w=Array.isArray(v.preview.matches)?v.preview.matches:[v.preview.matches];return{ranges:c.slice(0,R),preview:{matches:w.slice(0,R),text:v.preview.text},uri:v.uri}}async searchInFolder(v,R,c){const w=new O.QueryGlobTester(this.query,v),s=[],u={report:r=>{if(!this.validateProviderResult(r))return;const t=v.folder.scheme===D.Schemas.file?(0,O.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(E.dirname(r.uri))):void 0,l=E.relativePath(v.folder,r.uri);if(l){const _=w.includedInQuery(l,k.basename(l),t);(0,p.isThenable)(_)?s.push(_.then(g=>{g&&R(r)})):_&&R(r)}}},n=this.getSearchOptionsForFolder(v),i=await this.provider.provideTextSearchResults(m(this.query.contentPattern),n,u,c);return s.length&&await Promise.all(s),i}validateProviderResult(v){if(h(v)){if(Array.isArray(v.ranges)){if(!Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(v.preview.matches.length!==v.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(v){const R=(0,O.resolvePatternsForProvider)(this.query.includePattern,v.includePattern),c=(0,O.resolvePatternsForProvider)(this.query.excludePattern,v.excludePattern),w={folder:P.URI.from(v.folder),excludes:c,includes:R,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,encoding:v.fileEncoding&&this.fileUtils.toCanonicalName(v.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return w.usePCRE2=this.query.usePCRE2,w}}e.TextSearchManager=y;function m(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class T{constructor(v){this._onResult=v,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new d(512,R=>this.sendItems(R))}add(v,R){this._currentFileMatch&&(this._currentFolderIdx!==R||!E.isEqual(this._currentUri,v.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=R,this._currentFileMatch={resource:v.uri,results:[]}),this._currentFileMatch.results.push(f(v))}pushToCollector(){const v=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,v)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(v){this._onResult(v)}}e.TextSearchResultsCollector=T;function f(o){return h(o)?{preview:{matches:(0,a.mapArrayOrNot)(o.preview.matches,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character})),text:o.preview.text},ranges:(0,a.mapArrayOrNot)(o.ranges,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function h(o){return!!o.preview}e.extensionResultIsMatch=h;class d{constructor(v,R){this.maxBatchSize=v,this.cb=R,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(v,R){!v||this.addItemToBatch(v,R)}addItems(v,R){!v||this.addItemsToBatch(v,R)}addItemToBatch(v,R){this.batch.push(v),this.batchSize+=R,this.onUpdate()}addItemsToBatch(v,R){this.batch=this.batch.concat(v),this.batchSize+=R,this.onUpdate()}onUpdate(){this.totalNumberCompleted<d.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},d.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=d,d.TIMEOUT=4e3,d.START_BATCH_AFTER_COUNT=50}),define(ye[104],De([1,0,7,4,3,227,13,63,15,2,232]),function(ne,e,a,p,b,L,D,k,E,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,b.createDecorator)("IExtHostSearch");let y=class{constructor(h,d,o){this.extHostRpc=h,this._uriTransformer=d,this._logService=o,this._proxy=this.extHostRpc.getProxy(p.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new L.FileSearchManager}_transformScheme(h){return this._uriTransformer.transformOutgoingScheme(h)}registerTextSearchProvider(h,d){if(this._textSearchUsedSchemes.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this._textSearchUsedSchemes.add(h);const o=this._handlePool++;return this._textSearchProvider.set(o,d),this._proxy.$registerTextSearchProvider(o,this._transformScheme(h)),(0,a.toDisposable)(()=>{this._textSearchUsedSchemes.delete(h),this._textSearchProvider.delete(o),this._proxy.$unregisterProvider(o)})}registerFileSearchProvider(h,d){if(this._fileSearchUsedSchemes.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this._fileSearchUsedSchemes.add(h);const o=this._handlePool++;return this._fileSearchProvider.set(o,d),this._proxy.$registerFileSearchProvider(o,this._transformScheme(h)),(0,a.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(h),this._fileSearchProvider.delete(o),this._proxy.$unregisterProvider(o)})}$provideFileSearchResults(h,d,o,v){const R=m(o),c=this._fileSearchProvider.get(h);if(c)return this._fileSearchManager.fileSearch(R,c,w=>{this._proxy.$handleFileMatch(h,d,w.map(s=>s.resource))},v);throw new Error("unknown provider: "+h)}$clearCache(h){return this._fileSearchManager.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,d,o,v){const R=this._textSearchProvider.get(h);if(!R||!R.provideTextSearchResults)throw new Error(`Unknown provider ${h}`);const c=m(o);return this.createTextSearchManager(c,R).search(s=>this._proxy.$handleTextMatch(h,d,s),v)}$enableExtensionHostSearch(){}createTextSearchManager(h,d){return new O.TextSearchManager(h,d,{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}};y=ze([xe(0,D.IExtHostRpcService),xe(1,k.IURITransformerService),xe(2,E.ILogService)],y),e.ExtHostSearch=y;function m(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(T),extraFileResources:f.extraFileResources&&f.extraFileResources.map(h=>P.URI.revive(h))}}e.reviveQuery=m;function T(f){return{...f,folder:P.URI.revive(f.folder)}}}),define(ye[233],De([1,0,56,99,31,95,32,36,49,52,101,103,104,69,62,68,98,51,35,67,86,50,205,15,181,102,97]),function(ne,e,a,p,b,L,D,k,E,P,O,y,m,T,f,h,d,o,v,R,c,w,s,u,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(u.ILoggerService,s.ExtHostLoggerService),(0,a.registerSingleton)(u.ILogService,n.ExtHostLogService),(0,a.registerSingleton)(h.IExtHostApiDeprecationService,h.ExtHostApiDeprecationService),(0,a.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,a.registerSingleton)(D.IExtHostConfiguration,D.ExtHostConfiguration),(0,a.registerSingleton)(o.IExtHostConsumerFileSystem,o.ExtHostConsumerFileSystem),(0,a.registerSingleton)(y.IExtHostDebugService,y.WorkerExtHostDebugService),(0,a.registerSingleton)(L.IExtHostDecorations,L.ExtHostDecorations),(0,a.registerSingleton)(E.IExtHostDocumentsAndEditors,E.ExtHostDocumentsAndEditors),(0,a.registerSingleton)(v.IExtHostFileSystemInfo,v.ExtHostFileSystemInfo),(0,a.registerSingleton)(p.IExtHostOutputService,p.ExtHostOutputService),(0,a.registerSingleton)(m.IExtHostSearch,m.ExtHostSearch),(0,a.registerSingleton)(T.IExtHostStorage,T.ExtHostStorage),(0,a.registerSingleton)(O.IExtHostTask,O.WorkerExtHostTask),(0,a.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),(0,a.registerSingleton)(f.IExtHostTunnelService,f.ExtHostTunnelService),(0,a.registerSingleton)(d.IExtHostWindow,d.ExtHostWindow),(0,a.registerSingleton)(b.IExtHostWorkspace,b.ExtHostWorkspace),(0,a.registerSingleton)(R.IExtHostSecretState,R.ExtHostSecretState),(0,a.registerSingleton)(c.IExtHostTelemetry,c.ExtHostTelemetry),(0,a.registerSingleton)(r.IExtHostTelemetryLogService,r.ExtHostTelemetryLogService),(0,a.registerSingleton)(w.IExtHostEditorTabs,w.ExtHostEditorTabs),(0,a.registerSingleton)(i.IExtHostVariableResolverProvider,i.ExtHostVariableResolverProviderService)}),define(ye[234],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class a{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(b){if(b&&this._dragOperations.has(b)){const L=this._dragOperations.get(b);return this._dragOperations.delete(b),L}}addDragOperationTransfer(b,L){this._dragOperations.set(b,L)}getRenderedTreeElement(b){if(this._renderedElements.has(b))return this._renderedElements.get(b)}addRenderedTreeItemElement(b,L){this._renderedElements.set(b,L)}removeRenderedTreeItemElement(b){this._renderedElements.has(b)&&this._renderedElements.delete(b)}}e.TreeviewsService=a}),define(ye[235],De([1,0,134,6,22,2,5,7,14,6,10,16,8,20,234,24]),function(ne,e,a,p,b,L,D,k,E,P,O,y,m,T,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function d(R,c){if((0,O.isString)(R))return{label:R};if(R&&typeof R=="object"&&typeof R.label=="string"){let w;return Array.isArray(R.highlights)&&(w=R.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),w=w.length?w:void 0),{label:R.label,highlights:w}}}class o{constructor(c,w,s){this._proxy=c,this.commands=w,this.logService=s,this.treeViews=new Map,this.treeDragAndDropService=new f.TreeviewsService;function u(n){return n&&n.$treeViewId&&n.$treeItemHandle}w.registerArgumentProcessor({processArgument:n=>u(n)?this.convertArgument(n):Array.isArray(n)&&n.length>0?n.map(i=>u(i)?this.convertArgument(i):i):n})}registerTreeDataProvider(c,w,s){const u=this.createTreeView(c,{treeDataProvider:w},s);return{dispose:()=>u.dispose()}}createTreeView(c,w,s){if(!w||!w.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=w.dragAndDropController?.dropMimeTypes??[],n=w.dragAndDropController?.dragMimeTypes??[],i=!!w.dragAndDropController?.handleDrag,r=!!w.dragAndDropController?.handleDrop,t=this._proxy.$registerTreeViewDataProvider(c,{showCollapseAll:!!w.showCollapseAll,canSelectMany:!!w.canSelectMany,dropMimeTypes:u,dragMimeTypes:n,hasHandleDrag:i,hasHandleDrop:r}),l=this.createExtHostTreeView(c,w,s);return{get onDidCollapseElement(){return l.onDidCollapseElement},get onDidExpandElement(){return l.onDidExpandElement},get selection(){return l.selectedElements},get onDidChangeSelection(){return l.onDidChangeSelection},get visible(){return l.visible},get onDidChangeVisibility(){return l.onDidChangeVisibility},get message(){return l.message},set message(_){l.message=_},get title(){return l.title},set title(_){l.title=_},get description(){return l.description},set description(_){l.description=_},get badge(){return(0,h.checkProposedApiEnabled)(s,"badges"),l.badge},set badge(_){(0,h.checkProposedApiEnabled)(s,"badges"),l.badge=_},reveal:(_,g)=>l.reveal(_,g),dispose:async()=>{await t,this.treeViews.delete(c),l.dispose()}}}$getChildren(c,w){const s=this.treeViews.get(c);return s?s.getChildren(w):Promise.reject(new Error((0,a.localize)(0,null,c)))}async $handleDrop(c,w,s,u,n,i,r,t){const l=this.treeViews.get(c);if(!l)return Promise.reject(new Error((0,a.localize)(1,null,c)));const _=m.DataTransfer.toDataTransfer(s,async g=>(await this._proxy.$resolveDropFileData(c,w,g)).buffer);return r===c&&t&&await this.addAdditionalTransferItems(_,l,t,n,i),l.onDrop(_,u,n)}async addAdditionalTransferItems(c,w,s,u,n){const i=this.treeDragAndDropService.removeDragOperationTransfer(n);if(i)(await i)?.forEach((r,t)=>{r&&c.set(t,r)});else if(n&&w.handleDrag){const r=w.handleDrag(s,c,u);this.treeDragAndDropService.addDragOperationTransfer(n,r),await r}return c}async $handleDrag(c,w,s,u){const n=this.treeViews.get(c);if(!n)return Promise.reject(new Error((0,a.localize)(2,null,c)));const i=await this.addAdditionalTransferItems(new p.DataTransfer,n,w,u,s);if(!!i)return m.DataTransfer.toDataTransferDTO(i)}async $hasResolve(c){const w=this.treeViews.get(c);if(!w)throw new Error((0,a.localize)(3,null,c));return w.hasResolve}$resolve(c,w,s){const u=this.treeViews.get(c);if(!u)throw new Error((0,a.localize)(4,null,c));return u.resolveTreeItem(w,s)}$setExpanded(c,w,s){const u=this.treeViews.get(c);if(!u)throw new Error((0,a.localize)(5,null,c));u.setExpanded(w,s)}$setSelection(c,w){const s=this.treeViews.get(c);if(!s)throw new Error((0,a.localize)(6,null,c));s.setSelection(w)}$setVisible(c,w){const s=this.treeViews.get(c);if(!s)throw new Error((0,a.localize)(7,null,c));s.setVisible(w)}createExtHostTreeView(c,w,s){const u=new v(c,w,this._proxy,this.commands.converter,this.logService,s);return this.treeViews.set(c,u),u}convertArgument(c){const w=this.treeViews.get(c.$treeViewId);return w?w.getExtensionElement(c.$treeItemHandle):null}}e.ExtHostTreeViews=o;class v extends k.Disposable{constructor(c,w,s,u,n,i){super();if(this.viewId=c,this.proxy=s,this.commands=u,this.logService=n,this.extension=i,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new D.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new D.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new D.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new D.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new D.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new T.CancellationTokenSource,i.contributes&&i.contributes.views)for(const l in i.contributes.views)for(const _ of i.contributes.views[l])_.id===c&&(this._title=_.name);this.dataProvider=w.treeDataProvider,this.dndController=w.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(l=>this._onDidChangeData.fire({message:!1,element:l})));let r,t;this._register(D.Event.debounce(this._onDidChangeData.event,(l,_)=>(l||(l={message:!1,elements:[]}),_.element!==!1&&(r||(r=new Promise(g=>t=g),this.refreshPromise=this.refreshPromise.then(()=>r)),Array.isArray(_.element)?l.elements.push(..._.element):l.elements.push(_.element)),_.message&&(l.message=!0),l),200,!0)(({message:l,elements:_})=>{_.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const g=t;return r=null,this.refresh(_).then(()=>g())})),l&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(c=>this.getExtensionElement(c)).filter(c=>!(0,O.isUndefinedOrNull)(c))}async getChildren(c){const w=c?this.getExtensionElement(c):void 0;if(c&&!w)return this.logService.error(`No tree item with id '${c}' found.`),Promise.resolve([]);let s=this.getChildrenNodes(c);return s||(s=await this.fetchChildrenNodes(w)),s?s.map(u=>u.item):void 0}getExtensionElement(c){return this.elements.get(c)}reveal(c,w){w=w||{select:!0,focus:!1};const s=(0,O.isUndefinedOrNull)(w.select)?!0:w.select,u=(0,O.isUndefinedOrNull)(w.focus)?!1:w.focus,n=(0,O.isUndefinedOrNull)(w.expand)?!1:w.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):c?this.refreshPromise.then(()=>this.resolveUnknownParentChain(c)).then(i=>this.resolveTreeNode(c,i[i.length-1]).then(r=>this.proxy.$reveal(this.viewId,{item:r.item,parentChain:i.map(t=>t.item)},{select:s,focus:u,expand:n})),i=>this.logService.error(i)):this.proxy.$reveal(this.viewId,void 0,{select:s,focus:u,expand:n})}get message(){return this._message}set message(c){this._message=c,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(c){this._title=c,this.proxy.$setTitle(this.viewId,c,this._description)}get description(){return this._description}set description(c){this._description=c,this.proxy.$setTitle(this.viewId,this._title,c)}get badge(){return this._badge}set badge(c){this._badge?.value===c?.value&&this._badge?.tooltip===c?.tooltip||(this._badge=m.ViewBadge.from(c),this.proxy.$setBadge(this.viewId,c))}setExpanded(c,w){const s=this.getExtensionElement(c);s&&(w?this._onDidExpandElement.fire(Object.freeze({element:s})):this._onDidCollapseElement.fire(Object.freeze({element:s})))}setSelection(c){(0,y.equals)(this._selectedHandles,c)||(this._selectedHandles=c,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(c){c!==this._visible&&(this._visible=c,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(c,w,s){const u=[];for(const n of c){const i=this.getExtensionElement(n);i&&u.push(i)}if(!(!this.dndController?.handleDrag||u.length===0))return await this.dndController.handleDrag(u,w,s),w}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(c,w,s){const u=w?this.getExtensionElement(w):void 0;if(!(!u&&w||!this.dndController?.handleDrop))return(0,E.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(u,c,s):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(c,w){if(!this.dataProvider.resolveTreeItem)return;const s=this.elements.get(c);if(s){const u=this.nodes.get(s);if(u){const n=await this.dataProvider.resolveTreeItem(u.extensionItem,s,w)??u.extensionItem;return this.validateTreeItem(n),u.item.tooltip=this.getTooltip(n.tooltip),u.item.command=this.getCommand(u.disposableStore,n.command),u.item}}}resolveUnknownParentChain(c){return this.resolveParent(c).then(w=>w?this.resolveUnknownParentChain(w).then(s=>this.resolveTreeNode(w,s[s.length-1]).then(u=>(s.push(u),s))):Promise.resolve([]))}resolveParent(c){const w=this.nodes.get(c);return w?Promise.resolve(w.parent?this.elements.get(w.parent.item.handle):void 0):(0,E.asPromise)(()=>this.dataProvider.getParent(c))}resolveTreeNode(c,w){const s=this.nodes.get(c);return s?Promise.resolve(s):(0,E.asPromise)(()=>this.dataProvider.getTreeItem(c)).then(u=>this.createHandle(c,u,w,!0)).then(u=>this.getChildren(w?w.item.handle:void 0).then(()=>{const n=this.getExtensionElement(u);if(n){const i=this.nodes.get(n);if(i)return Promise.resolve(i)}throw new Error(`Cannot resolve tree item for element ${u}`)}))}getChildrenNodes(c){if(c){let w;if(typeof c=="string"){const s=this.getExtensionElement(c);w=s?this.nodes.get(s):void 0}else w=c;return w&&w.children||void 0}return this.roots}async fetchChildrenNodes(c){this.clearChildren(c);const w=new T.CancellationTokenSource(this._refreshCancellationSource.token);try{const s=c?this.nodes.get(c):void 0,u=await this.dataProvider.getChildren(c);if(w.token.isCancellationRequested)return;const n=await Promise.all((0,y.coalesce)(u||[]).map(async i=>{const r=await this.dataProvider.getTreeItem(i);return r&&!w.token.isCancellationRequested?this.createAndRegisterTreeNode(i,r,s):null}));return w.token.isCancellationRequested?void 0:(0,y.coalesce)(n)}finally{w.dispose()}}refresh(c){if(c.some(s=>!s))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new T.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const s=this.getHandlesToRefresh(c);if(s.length)return this.refreshHandles(s)}return Promise.resolve(void 0)}getHandlesToRefresh(c){const w=new Set,s=c.map(n=>this.nodes.get(n));for(const n of s)if(n&&!w.has(n.item.handle)){let i=n;for(;i&&i.parent&&s.findIndex(r=>i&&i.parent&&r&&r.item.handle===i.parent.item.handle)===-1;){const r=this.elements.get(i.parent.item.handle);i=r?this.nodes.get(r):void 0}i&&!i.parent&&w.add(n.item.handle)}const u=[];return w.forEach(n=>{const i=this.elements.get(n);if(i){const r=this.nodes.get(i);r&&(!r.parent||!w.has(r.parent.item.handle))&&u.push(n)}}),u}refreshHandles(c){const w={};return Promise.all(c.map(s=>this.refreshNode(s).then(u=>{u&&(w[s]=u.item)}))).then(()=>Object.keys(w).length?this.proxy.$refresh(this.viewId,w):void 0)}refreshNode(c){const w=this.getExtensionElement(c);if(w){const s=this.nodes.get(w);if(s)return this.clearChildren(w),(0,E.asPromise)(()=>this.dataProvider.getTreeItem(w)).then(u=>{if(u){const n=this.createTreeNode(w,u,s.parent);return this.updateNodeCache(w,n,s,s.parent),s.dispose(),n}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(c,w,s){const u=this.createTreeNode(c,w,s);if(w.id&&this.elements.has(u.item.handle))throw new Error((0,a.localize)(8,null,w.id));return this.addNodeToCache(c,u),this.addNodeToParentCache(u,s),u}getTooltip(c){return P.MarkdownString.isMarkdownString(c)?m.MarkdownString.from(c):c}getCommand(c,w){return w?{...this.commands.toInternal(w,c),originalId:w.command}:void 0}validateTreeItem(c){P.TreeItem.isTreeItem(c)||console.log(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(c,w,s){this.validateTreeItem(w);const u=new k.DisposableStore,n=this.createHandle(c,w,s),i=this.getLightIconPath(w);return{item:{handle:n,parentHandle:s?s.item.handle:void 0,label:d(w.label,this.extension),description:w.description,resourceUri:w.resourceUri,tooltip:this.getTooltip(w.tooltip),command:this.getCommand(u,w.command),contextValue:w.contextValue,icon:i,iconDark:this.getDarkIconPath(w)||i,themeIcon:this.getThemeIcon(w),collapsibleState:(0,O.isUndefinedOrNull)(w.collapsibleState)?P.TreeItemCollapsibleState.None:w.collapsibleState,accessibilityInformation:w.accessibilityInformation},extensionItem:w,parent:s,children:void 0,disposableStore:u,dispose(){u.dispose()}}}getThemeIcon(c){return c.iconPath instanceof P.ThemeIcon?c.iconPath:void 0}createHandle(c,{id:w,label:s,resourceUri:u},n,i){if(w)return`${v.ID_HANDLE_PREFIX}/${w}`;const r=d(s,this.extension),t=n?n.item.handle:v.LABEL_HANDLE_PREFIX;let l=r?r.label:u?(0,b.basename)(u):"";l=l.indexOf("/")!==-1?l.replace("/","//"):l;const _=this.nodes.has(c)?this.nodes.get(c).item.handle:void 0,g=this.getChildrenNodes(n)||[];let C,U=0;do{if(C=`${t}/${U}:${l}`,i||!this.elements.has(C)||_===C)break;U++}while(U<=g.length);return C}getLightIconPath(c){if(c.iconPath&&!(c.iconPath instanceof P.ThemeIcon))return typeof c.iconPath=="string"||L.URI.isUri(c.iconPath)?this.getIconPath(c.iconPath):this.getIconPath(c.iconPath.light)}getDarkIconPath(c){if(c.iconPath&&!(c.iconPath instanceof P.ThemeIcon)&&c.iconPath.dark)return this.getIconPath(c.iconPath.dark)}getIconPath(c){return L.URI.isUri(c)?c:L.URI.file(c)}addNodeToCache(c,w){this.elements.set(w.item.handle,c),this.nodes.set(c,w)}updateNodeCache(c,w,s,u){this.elements.delete(w.item.handle),this.nodes.delete(c),w.item.handle!==s.item.handle&&this.elements.delete(s.item.handle),this.addNodeToCache(c,w);const n=this.getChildrenNodes(u)||[],i=n.filter(r=>r.item.handle===s.item.handle)[0];i&&n.splice(n.indexOf(i),1,w)}addNodeToParentCache(c,w){w?(w.children||(w.children=[]),w.children.push(c)):(this.roots||(this.roots=[]),this.roots.push(c))}clearChildren(c){if(c){const w=this.nodes.get(c);if(w){if(w.children)for(const s of w.children){const u=this.elements.get(s.item.handle);u&&this.clear(u)}w.children=void 0}}else this.clearAll()}clear(c){const w=this.nodes.get(c);if(w){if(w.children)for(const s of w.children){const u=this.elements.get(s.item.handle);u&&this.clear(u)}this.nodes.delete(c),this.elements.delete(w.item.handle),w.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(c=>c.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}v.LABEL_HANDLE_PREFIX="0",v.ID_HANDLE_PREFIX="1"}),define(ye[236],De([1,0,20,11,5,29,2,121,246,110,119,39,4,94,190,189,36,191,32,193,194,195,174,196,49,33,198,199,202,204,206,99,177,210,211,212,69,52,214,235,8,6,217,53,98,31,164,201,85,95,101,103,104,15,63,13,28,207,161,62,68,187,215,70,51,220,218,219,188,35,213,216,67,50,86,208,100,209,12,81,176,159,200,7,24,166,9,97]),function(ne,e,a,p,b,L,D,k,E,P,O,y,m,T,f,h,d,o,v,R,c,w,s,u,n,i,r,t,l,_,g,C,U,W,M,S,z,$,F,q,ie,A,Z,ce,oe,ue,te,Ee,be,ee,ve,Ae,Fe,$e,Qe,Ie,Se,ke,ae,le,G,Q,I,B,H,V,se,de,J,pe,ge,Ne,Be,Je,Ge,Te,rt,K,X,fe,Ue,He,Ze,qe,We,nt,ot,ht){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function kt(it){const dt=it.get(Se.IExtHostInitDataService),Ot=it.get(pe.IExtHostFileSystemInfo),Wt=it.get(H.IExtHostConsumerFileSystem),Dt=it.get(i.IExtHostExtensionService),ft=it.get(ue.IExtHostWorkspace),Ct=it.get(Ge.IExtHostTelemetry),Lt=it.get(v.IExtHostConfiguration),Ft=it.get(Qe.IURITransformerService),Ve=it.get(Ie.IExtHostRpcService),Nt=it.get(z.IExtHostStorage),Rt=it.get(B.IExtensionStoragePaths),Ut=it.get($e.ILoggerService),vt=it.get($e.ILogService),we=it.get(le.IExtHostTunnelService),Ce=it.get(ht.IExtHostTelemetryLogService),me=it.get(G.IExtHostApiDeprecationService),j=it.get(oe.IExtHostWindow),Pe=it.get(Be.IExtHostSecretState),Le=it.get(Je.IExtHostEditorTabs);Ve.set(m.ExtHostContext.ExtHostFileSystemInfo,Ot),Ve.set(m.ExtHostContext.ExtHostLogLevelServiceShape,Ut),Ve.set(m.ExtHostContext.ExtHostWorkspace,ft),Ve.set(m.ExtHostContext.ExtHostConfiguration,Lt),Ve.set(m.ExtHostContext.ExtHostExtensionService,Dt),Ve.set(m.ExtHostContext.ExtHostStorage,Nt),Ve.set(m.ExtHostContext.ExtHostTunnelService,we),Ve.set(m.ExtHostContext.ExtHostWindow,j),Ve.set(m.ExtHostContext.ExtHostSecretState,Pe),Ve.set(m.ExtHostContext.ExtHostTelemetry,Ct),Ve.set(m.ExtHostContext.ExtHostEditorTabs,Le);const tt=Ve.set(m.ExtHostContext.ExtHostDecorations,it.get(ee.IExtHostDecorations)),Xe=Ve.set(m.ExtHostContext.ExtHostDocumentsAndEditors,it.get(n.IExtHostDocumentsAndEditors)),je=Ve.set(m.ExtHostContext.ExtHostCommands,it.get(d.IExtHostCommands)),ut=Ve.set(m.ExtHostContext.ExtHostTerminalService,it.get($.IExtHostTerminalService)),gt=Ve.set(m.ExtHostContext.ExtHostDebugService,it.get(Ae.IExtHostDebugService)),yt=Ve.set(m.ExtHostContext.ExtHostSearch,it.get(Fe.IExtHostSearch)),pt=Ve.set(m.ExtHostContext.ExtHostTask,it.get(ve.IExtHostTask)),_t=Ve.set(m.ExtHostContext.ExtHostOutputService,it.get(C.IExtHostOutputService)),Pt=Ve.set(m.ExtHostContext.ExtHostUrls,new Z.ExtHostUrls(Ve)),mt=Ve.set(m.ExtHostContext.ExtHostDocuments,new u.ExtHostDocuments(Ve,Xe)),Yt=Ve.set(m.ExtHostContext.ExtHostDocumentContentProviders,new w.ExtHostDocumentContentProvider(Ve,Xe,vt)),Jt=Ve.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new s.ExtHostDocumentSaveParticipant(vt,mt,Ve.getProxy(m.MainContext.MainThreadBulkEdits))),bt=Ve.set(m.ExtHostContext.ExtHostNotebook,new ke.ExtHostNotebookController(Ve,je,Xe,mt,Rt)),Ht=Ve.set(m.ExtHostContext.ExtHostNotebookDocuments,new He.ExtHostNotebookDocuments(bt)),Bt=Ve.set(m.ExtHostContext.ExtHostNotebookEditors,new Ue.ExtHostNotebookEditors(vt,bt)),oi=Ve.set(m.ExtHostContext.ExtHostNotebookKernels,new Te.ExtHostNotebookKernels(Ve,dt,bt,je,vt)),ki=Ve.set(m.ExtHostContext.ExtHostNotebookRenderers,new K.ExtHostNotebookRenderers(Ve,bt)),It=Ve.set(m.ExtHostContext.ExtHostEditors,new F.ExtHostEditors(Ve,Xe)),qt=Ve.set(m.ExtHostContext.ExtHostTreeViews,new q.ExtHostTreeViews(Ve.getProxy(m.MainContext.MainThreadTreeViews),je,vt)),mi=Ve.set(m.ExtHostContext.ExtHostEditorInsets,new te.ExtHostEditorInsets(Ve.getProxy(m.MainContext.MainThreadEditorInsets),It,dt.remote)),Zt=Ve.set(m.ExtHostContext.ExtHostDiagnostics,new R.ExtHostDiagnostics(Ve,vt,Ot)),ei=Ve.set(m.ExtHostContext.ExtHostLanguages,new _.ExtHostLanguages(Ve,mt,je.converter,Ft)),lt=Ve.set(m.ExtHostContext.ExtHostLanguageFeatures,new l.ExtHostLanguageFeatures(Ve,Ft,mt,je,Zt,vt,me)),gi=Ve.set(m.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(Ve,lt)),zt=Ve.set(m.ExtHostContext.ExtHostFileSystemEventService,new t.ExtHostFileSystemEventService(Ve,vt,Xe)),Kt=Ve.set(m.ExtHostContext.ExtHostQuickOpen,(0,W.createExtHostQuickOpen)(Ve,ft,je)),ai=Ve.set(m.ExtHostContext.ExtHostSCM,new M.ExtHostSCM(Ve,je,vt)),Pi=Ve.set(m.ExtHostContext.ExtHostComments,(0,o.createExtHostComments)(Ve,je,mt)),yi=Ve.set(m.ExtHostContext.ExtHostProgress,new U.ExtHostProgress(Ve.getProxy(m.MainContext.MainThreadProgress))),pi=Ve.set(m.ExtHostContext.ExtHosLabelService,new Ee.ExtHostLabelService(Ve)),ci=Ve.set(m.ExtHostContext.ExtHostTheming,new ae.ExtHostTheming(Ve)),ti=Ve.set(m.ExtHostContext.ExtHostAuthentication,new Q.ExtHostAuthentication(Ve)),vi=Ve.set(m.ExtHostContext.ExtHostTimeline,new I.ExtHostTimeline(Ve,je)),Ei=Ve.set(m.ExtHostContext.ExtHostWebviews,new ce.ExtHostWebviews(Ve,dt.remote,ft,vt,me)),ii=Ve.set(m.ExtHostContext.ExtHostWebviewPanels,new de.ExtHostWebviewPanels(Ve,Ei,ft)),bi=Ve.set(m.ExtHostContext.ExtHostCustomEditors,new se.ExtHostCustomEditors(Ve,mt,Rt,Ei,ii)),Ai=Ve.set(m.ExtHostContext.ExtHostWebviewViews,new V.ExtHostWebviewViews(Ve,Ei)),ni=Ve.set(m.ExtHostContext.ExtHostTesting,new ge.ExtHostTesting(Ve,je)),Ri=Ve.set(m.ExtHostContext.ExtHostUriOpeners,new Ne.ExtHostUriOpeners(Ve));Ve.set(m.ExtHostContext.ExtHostInteractive,new Ze.ExtHostInteractive(Ve,bt,Xe,je,vt));const Oi=Object.values(m.ExtHostContext);Ve.assertRegistered(Oi);const Fi=new J.ExtHostBulkEdits(Ve,Xe),Ni=new h.ExtHostClipboard(Ve),ri=new g.ExtHostMessageService(Ve,vt),li=new c.ExtHostDialogs(Ve),Di=new S.ExtHostStatusBar(Ve,je.converter);return f.ExtHostApiCommands.register(je),function(Me,Vt,si){const Et=function(){let re=!Me.isUnderDevelopment;function he(){re||(vt.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),re=!0)}return function Re(st){if(Array.isArray(st))st.forEach(Re);else if(typeof st=="string")he();else{const wt=st;typeof wt.scheme=="undefined"&&he(),typeof wt.exclusive=="boolean"&&(0,We.checkProposedApiEnabled)(Me,"documentFiltersExclusive")}return st}}(),Mi={getSession(re,he,Re){return ti.getSession(Me,re,he,Re)},async hasSession(re,he){return(0,We.checkProposedApiEnabled)(Me,"authSession"),!!await ti.getSession(Me,re,he,{silent:!0})},get onDidChangeSessions(){return ti.onDidChangeSessions},registerAuthenticationProvider(re,he,Re,st){return ti.registerAuthenticationProvider(re,he,Re,st)}},Li={registerCommand(re,he,Re){return je.registerCommand(!0,re,he,Re,void 0,Me)},registerTextEditorCommand(re,he,Re){return je.registerCommand(!0,re,(...st)=>{const wt=It.getActiveTextEditor();if(!wt){vt.warn("Cannot execute "+re+" because there is no active text editor.");return}return wt.edit(Tt=>{he.apply(Re,[wt,Tt,...st])}).then(Tt=>{Tt||vt.warn("Edits from command "+re+" were not applied.")},Tt=>{vt.warn("An error occurred while running command "+re,Tt)})},void 0,void 0,Me)},registerDiffInformationCommand:(re,he,Re)=>((0,We.checkProposedApiEnabled)(Me,"diffCommand"),je.registerCommand(!0,re,async(...st)=>{const wt=Xe.activeEditor(!0);if(!wt){vt.warn("Cannot execute "+re+" because there is no active text editor.");return}const Tt=await It.getDiffInformation(wt.id);he.apply(Re,[Tt,...st])},void 0,void 0,Me)),executeCommand(re,...he){return je.executeCommand(re,...he)},getCommands(re=!1){return je.getCommands(re)}},Ci={get machineId(){return dt.telemetryInfo.machineId},get sessionId(){return dt.telemetryInfo.sessionId},get language(){return dt.environment.appLanguage},get appName(){return dt.environment.appName},get appRoot(){return dt.environment.appRoot?.fsPath??""},get appHost(){return dt.environment.appHost},get uriScheme(){return dt.environment.appUriScheme},get clipboard(){return Ni.value},get shell(){return ut.getDefaultShell(!1)},get isTelemetryEnabled(){return Ct.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Ct.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,We.checkProposedApiEnabled)(Me,"telemetry"),Ct.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,We.checkProposedApiEnabled)(Me,"telemetry"),Ct.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const re=Date.now()-new Date(dt.telemetryInfo.firstSessionDate).getTime();return isNaN(re)?!1:re<1e3*60*60*24},openExternal(re,he){return j.openUri(re,{allowTunneling:!!dt.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(re){if(re.scheme===dt.environment.appUriScheme)return Pt.createAppUri(re);try{return await j.asExternalUri(re,{allowTunneling:!!dt.remote.authority})}catch(he){if((0,fe.matchesScheme)(re,X.Schemas.http)||(0,fe.matchesScheme)(re,X.Schemas.https))return re;throw he}},get remoteName(){return(0,be.getRemoteName)(dt.remote.authority)},get remoteAuthority(){return(0,We.checkProposedApiEnabled)(Me,"resolvers"),dt.remote.authority},get uiKind(){return dt.uiKind}};dt.environment.extensionTestsLocationURI||Object.freeze(Ci);const wi={createTestController(re,he,Re){return ni.createTestController(re,he,Re)},createTestObserver(){return(0,We.checkProposedApiEnabled)(Me,"testObserver"),ni.createTestObserver()},runTests(re){return(0,We.checkProposedApiEnabled)(Me,"testObserver"),ni.runTests(re)},get onDidChangeTestResults(){return(0,We.checkProposedApiEnabled)(Me,"testObserver"),ni.onResultsChanged},get testResults(){return(0,We.checkProposedApiEnabled)(Me,"testObserver"),ni.results}},ui=dt.remote.isRemote?A.ExtensionKind.Workspace:A.ExtensionKind.UI,xt={getExtension(re,he){(0,ot.equalsIgnoreCase)(re,"ms-vscode.references-view")&&(me.report("The extension 'ms-vscode.references-view' has been renamed.",Me,"Use 'vscode.references-view' instead."),re="vscode.references-view"),(0,We.isProposedApiEnabled)(Me,"extensionsAny")||(he=!1);const Re=Vt.mine.getExtensionDescription(re);if(Re)return new i.Extension(Dt,Me.identifier,Re,ui,!1);if(he){const st=Vt.all.getExtensionDescription(re);if(st)return new i.Extension(Dt,Me.identifier,st,ui,!0)}},get all(){const re=[];for(const he of Vt.mine.getAllExtensionDescriptions())re.push(new i.Extension(Dt,Me.identifier,he,ui,!1));return re},get allAcrossExtensionHosts(){(0,We.checkProposedApiEnabled)(Me,"extensionsAny");const re=new We.ExtensionIdentifierSet(Vt.mine.getAllExtensionDescriptions().map(Re=>Re.identifier)),he=[];for(const Re of Vt.all.getAllExtensionDescriptions()){const st=!re.has(Re.identifier);he.push(new i.Extension(Dt,Me.identifier,Re,ui,st))}return he},get onDidChange(){return(0,We.isProposedApiEnabled)(Me,"extensionsAny")?b.Event.any(Vt.mine.onDidChange,Vt.all.onDidChange):Vt.mine.onDidChange}},Gt={createDiagnosticCollection(re){return Zt.createDiagnosticCollection(Me.identifier,re)},get onDidChangeDiagnostics(){return Zt.onDidChangeDiagnostics},getDiagnostics:re=>Zt.getDiagnostics(re),getLanguages(){return ei.getLanguages()},setTextDocumentLanguage(re,he){return ei.changeLanguage(re.uri,he)},match(re,he){const Re=mt.getDocumentData(he.uri)?.notebook;return(0,O.score)(ie.LanguageSelector.from(re),he.uri,he.languageId,!0,Re?.uri,Re?.notebookType)},registerCodeActionsProvider(re,he,Re){return lt.registerCodeActionProvider(Me,Et(re),he,Re)},registerDocumentPasteEditProvider(re,he,Re){return(0,We.checkProposedApiEnabled)(Me,"documentPaste"),lt.registerDocumentPasteEditProvider(Me,Et(re),he,Re)},registerCodeLensProvider(re,he){return lt.registerCodeLensProvider(Me,Et(re),he)},registerDefinitionProvider(re,he){return lt.registerDefinitionProvider(Me,Et(re),he)},registerDeclarationProvider(re,he){return lt.registerDeclarationProvider(Me,Et(re),he)},registerImplementationProvider(re,he){return lt.registerImplementationProvider(Me,Et(re),he)},registerTypeDefinitionProvider(re,he){return lt.registerTypeDefinitionProvider(Me,Et(re),he)},registerHoverProvider(re,he){return lt.registerHoverProvider(Me,Et(re),he,Me.identifier)},registerEvaluatableExpressionProvider(re,he){return lt.registerEvaluatableExpressionProvider(Me,Et(re),he,Me.identifier)},registerInlineValuesProvider(re,he){return lt.registerInlineValuesProvider(Me,Et(re),he,Me.identifier)},registerDocumentHighlightProvider(re,he){return lt.registerDocumentHighlightProvider(Me,Et(re),he)},registerLinkedEditingRangeProvider(re,he){return lt.registerLinkedEditingRangeProvider(Me,Et(re),he)},registerReferenceProvider(re,he){return lt.registerReferenceProvider(Me,Et(re),he)},registerRenameProvider(re,he){return lt.registerRenameProvider(Me,Et(re),he)},registerDocumentSymbolProvider(re,he,Re){return lt.registerDocumentSymbolProvider(Me,Et(re),he,Re)},registerWorkspaceSymbolProvider(re){return lt.registerWorkspaceSymbolProvider(Me,re)},registerDocumentFormattingEditProvider(re,he){return lt.registerDocumentFormattingEditProvider(Me,Et(re),he)},registerDocumentRangeFormattingEditProvider(re,he){return lt.registerDocumentRangeFormattingEditProvider(Me,Et(re),he)},registerOnTypeFormattingEditProvider(re,he,Re,...st){return lt.registerOnTypeFormattingEditProvider(Me,Et(re),he,[Re].concat(st))},registerDocumentSemanticTokensProvider(re,he,Re){return lt.registerDocumentSemanticTokensProvider(Me,Et(re),he,Re)},registerDocumentRangeSemanticTokensProvider(re,he,Re){return lt.registerDocumentRangeSemanticTokensProvider(Me,Et(re),he,Re)},registerSignatureHelpProvider(re,he,Re,...st){return typeof Re=="object"?lt.registerSignatureHelpProvider(Me,Et(re),he,Re):lt.registerSignatureHelpProvider(Me,Et(re),he,typeof Re=="undefined"?[]:[Re,...st])},registerCompletionItemProvider(re,he,...Re){return lt.registerCompletionItemProvider(Me,Et(re),he,Re)},registerInlineCompletionItemProvider(re,he){return he.handleDidShowCompletionItem&&(0,We.checkProposedApiEnabled)(Me,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(Me,Et(re),he)},registerInlineCompletionItemProviderNew(re,he){if((0,We.checkProposedApiEnabled)(Me,"inlineCompletionsNew"),he.handleDidShowCompletionItem&&!(0,We.isProposedApiEnabled)(Me,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return lt.registerInlineCompletionsProviderNew(Me,Et(re),he)},registerDocumentLinkProvider(re,he){return lt.registerDocumentLinkProvider(Me,Et(re),he)},registerColorProvider(re,he){return lt.registerColorProvider(Me,Et(re),he)},registerFoldingRangeProvider(re,he){return lt.registerFoldingRangeProvider(Me,Et(re),he)},registerSelectionRangeProvider(re,he){return lt.registerSelectionRangeProvider(Me,re,he)},registerCallHierarchyProvider(re,he){return lt.registerCallHierarchyProvider(Me,re,he)},registerTypeHierarchyProvider(re,he){return lt.registerTypeHierarchyProvider(Me,re,he)},setLanguageConfiguration:(re,he)=>lt.setLanguageConfiguration(Me,re,he),getTokenInformationAtPosition(re,he){return(0,We.checkProposedApiEnabled)(Me,"tokenInformation"),ei.tokenAtPosition(re,he)},registerInlayHintsProvider(re,he){return lt.registerInlayHintsProvider(Me,re,he)},createLanguageStatusItem(re,he){return ei.createLanguageStatusItem(Me,re,he)},registerDocumentDropEditProvider(re,he){return lt.registerDocumentOnDropEditProvider(Me,re,he)}},Ui={get activeTextEditor(){return It.getActiveTextEditor()},get visibleTextEditors(){return It.getVisibleTextEditors()},get activeTerminal(){return ut.activeTerminal},get terminals(){return ut.terminals},async showTextDocument(re,he,Re){const st=await(D.URI.isUri(re)?Promise.resolve(Mt.openTextDocument(re)):Promise.resolve(re));return It.showTextDocument(st,he,Re)},createTextEditorDecorationType(re){return It.createTextEditorDecorationType(Me,re)},onDidChangeActiveTextEditor(re,he,Re){return It.onDidChangeActiveTextEditor(re,he,Re)},onDidChangeVisibleTextEditors(re,he,Re){return It.onDidChangeVisibleTextEditors(re,he,Re)},onDidChangeTextEditorSelection(re,he,Re){return It.onDidChangeTextEditorSelection(re,he,Re)},onDidChangeTextEditorOptions(re,he,Re){return It.onDidChangeTextEditorOptions(re,he,Re)},onDidChangeTextEditorVisibleRanges(re,he,Re){return It.onDidChangeTextEditorVisibleRanges(re,he,Re)},onDidChangeTextEditorViewColumn(re,he,Re){return It.onDidChangeTextEditorViewColumn(re,he,Re)},onDidCloseTerminal(re,he,Re){return ut.onDidCloseTerminal(re,he,Re)},onDidOpenTerminal(re,he,Re){return ut.onDidOpenTerminal(re,he,Re)},onDidChangeActiveTerminal(re,he,Re){return ut.onDidChangeActiveTerminal(re,he,Re)},onDidChangeTerminalDimensions(re,he,Re){return(0,We.checkProposedApiEnabled)(Me,"terminalDimensions"),ut.onDidChangeTerminalDimensions(re,he,Re)},onDidChangeTerminalState(re,he,Re){return ut.onDidChangeTerminalState(re,he,Re)},onDidWriteTerminalData(re,he,Re){return(0,We.checkProposedApiEnabled)(Me,"terminalDataWriteEvent"),ut.onDidWriteTerminalData(re,he,Re)},get state(){return j.state},onDidChangeWindowState(re,he,Re){return j.onDidChangeWindowState(re,he,Re)},showInformationMessage(re,...he){return ri.showMessage(Me,L.default.Info,re,he[0],he.slice(1))},showWarningMessage(re,...he){return ri.showMessage(Me,L.default.Warning,re,he[0],he.slice(1))},showErrorMessage(re,...he){return ri.showMessage(Me,L.default.Error,re,he[0],he.slice(1))},showQuickPick(re,he,Re){return Kt.showQuickPick(re,he,Re)},showWorkspaceFolderPick(re){return Kt.showWorkspaceFolderPick(re)},showInputBox(re,he){return Kt.showInput(re,he)},showOpenDialog(re){return li.showOpenDialog(re)},showSaveDialog(re){return li.showSaveDialog(re)},createStatusBarItem(re,he,Re){let st,wt,Tt;return typeof re=="string"?(st=re,wt=he,Tt=Re):(wt=re,Tt=he),Di.createStatusBarEntry(Me,st,wt,Tt)},setStatusBarMessage(re,he){return Di.setStatusBarMessage(re,he)},withScmProgress(re){return me.report("window.withScmProgress",Me,"Use 'withProgress' instead."),yi.withProgress(Me,{location:A.ProgressLocation.SourceControl},(he,Re)=>re({report(st){}}))},withProgress(re,he){return yi.withProgress(Me,re,he)},createOutputChannel(re,he){return _t.createOutputChannel(re,he,Me)},createWebviewPanel(re,he,Re,st){return ii.createWebviewPanel(Me,re,he,Re,st)},createWebviewTextEditorInset(re,he,Re,st){return(0,We.checkProposedApiEnabled)(Me,"editorInsets"),mi.createWebviewEditorInset(re,he,Re,st,Me)},createTerminal(re,he,Re){return typeof re=="object"?"pty"in re?ut.createExtensionTerminal(re):ut.createTerminalFromOptions(re):ut.createTerminal(re,he,Re)},registerTerminalLinkProvider(re){return ut.registerLinkProvider(re)},registerTerminalProfileProvider(re,he){return ut.registerProfileProvider(Me,re,he)},registerTreeDataProvider(re,he){return qt.registerTreeDataProvider(re,he,Me)},createTreeView(re,he){return qt.createTreeView(re,he,Me)},registerWebviewPanelSerializer:(re,he)=>ii.registerWebviewPanelSerializer(Me,re,he),registerCustomEditorProvider:(re,he,Re={})=>bi.registerCustomEditorProvider(Me,re,he,Re),registerFileDecorationProvider(re){return tt.registerFileDecorationProvider(re,Me.identifier)},registerUriHandler(re){return Pt.registerUriHandler(Me.identifier,re)},createQuickPick(){return Kt.createQuickPick(Me)},createInputBox(){return Kt.createInputBox(Me)},get activeColorTheme(){return ci.activeColorTheme},onDidChangeActiveColorTheme(re,he,Re){return ci.onDidChangeActiveColorTheme(re,he,Re)},registerWebviewViewProvider(re,he,Re){return Ai.registerWebviewViewProvider(Me,re,he,Re?.webviewOptions)},get activeNotebookEditor(){return bt.activeNotebookEditor},onDidChangeActiveNotebookEditor(re,he,Re){return bt.onDidChangeActiveNotebookEditor(re,he,Re)},get visibleNotebookEditors(){return bt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return bt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(re,he,Re){return Bt.onDidChangeNotebookEditorSelection(re,he,Re)},onDidChangeNotebookEditorVisibleRanges(re,he,Re){return Bt.onDidChangeNotebookEditorVisibleRanges(re,he,Re)},showNotebookDocument(re,he){return D.URI.isUri(re)&&me.report("window.showNotebookDocument(uri)",Me,"Please use 'workspace.openNotebookDocument' and 'window.showNotebookDocument'"),bt.showNotebookDocument(re,he)},registerExternalUriOpener(re,he,Re){return(0,We.checkProposedApiEnabled)(Me,"externalUriOpener"),Ri.registerExternalUriOpener(Me.identifier,re,he,Re)},get tabGroups(){return Le.tabGroups},logTelemetryToOutputChannel(re,he){(0,We.checkProposedApiEnabled)(Me,"telemetryLog"),Ce.logToTelemetryOutputChannel(Me,re,he)}},Mt={get rootPath(){return me.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(re){throw p.readonly()},getWorkspaceFolder(re){return ft.getWorkspaceFolder(re)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(re){throw p.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(re){throw p.readonly()},updateWorkspaceFolders:(re,he,...Re)=>ft.updateWorkspaceFolders(Me,re,he||0,...Re),onDidChangeWorkspaceFolders:function(re,he,Re){return ft.onDidChangeWorkspace(re,he,Re)},asRelativePath:(re,he)=>ft.getRelativePath(re,he),findFiles:(re,he,Re,st)=>ft.findFiles(re,he,Re,Me.identifier,st),findTextInFiles:(re,he,Re,st)=>{(0,We.checkProposedApiEnabled)(Me,"findTextInFiles");let wt,Tt;return typeof he=="object"?(wt=he,Tt=Re):(wt={},Tt=he,st=Re),ft.findTextInFiles(re,wt||{},Tt,Me.identifier,st)},saveAll:re=>ft.saveAll(re),applyEdit(re){return Fi.applyWorkspaceEdit(re,Me)},createFileSystemWatcher:(re,he,Re,st)=>zt.createFileSystemWatcher(ft,Me,re,he,Re,st),get textDocuments(){return mt.getAllDocumentData().map(re=>re.document)},set textDocuments(re){throw p.readonly()},openTextDocument(re){let he;const Re=re;if(typeof re=="string")he=Promise.resolve(D.URI.file(re));else if(D.URI.isUri(re))he=Promise.resolve(re);else if(!Re||typeof Re=="object")he=mt.createDocumentData(Re);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(st=>mt.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(re,he,Re)=>mt.onDidAddDocument(re,he,Re),onDidCloseTextDocument:(re,he,Re)=>mt.onDidRemoveDocument(re,he,Re),onDidChangeTextDocument:(re,he,Re)=>mt.onDidChangeDocument(re,he,Re),onDidSaveTextDocument:(re,he,Re)=>mt.onDidSaveDocument(re,he,Re),onWillSaveTextDocument:(re,he,Re)=>Jt.getOnWillSaveTextDocumentEvent(Me)(re,he,Re),get notebookDocuments(){return bt.notebookDocuments.map(re=>re.apiNotebook)},async openNotebookDocument(re,he){let Re;if(D.URI.isUri(re))Re=re,await bt.openNotebookDocument(re);else if(typeof re=="string")Re=D.URI.revive(await bt.createNotebookDocument({viewType:re,content:he}));else throw new Error("Invalid arguments");return bt.getNotebookDocument(Re).apiNotebook},onDidSaveNotebookDocument(re,he,Re){return Ht.onDidSaveNotebookDocument(re,he,Re)},onDidChangeNotebookDocument(re,he,Re){return Ht.onDidChangeNotebookDocument(re,he,Re)},get onDidOpenNotebookDocument(){return bt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return bt.onDidCloseNotebookDocument},registerNotebookSerializer(re,he,Re,st){return bt.registerNotebookSerializer(Me,re,he,Re,(0,We.isProposedApiEnabled)(Me,"notebookLiveShare")?st:void 0)},registerNotebookContentProvider:(re,he,Re,st)=>((0,We.checkProposedApiEnabled)(Me,"notebookContentProvider"),me.report("workspace.registerNotebookContentProvider",Me,"The notebookContentProvider API is not on track for finalization and will be removed."),bt.registerNotebookContentProvider(Me,re,he,Re,(0,We.isProposedApiEnabled)(Me,"notebookLiveShare")?st:void 0)),onDidChangeConfiguration:(re,he,Re)=>si.onDidChangeConfiguration(re,he,Re),getConfiguration(re,he){return he=arguments.length===1?void 0:he,si.getConfiguration(re,he,Me)},registerTextDocumentContentProvider(re,he){return Yt.registerTextDocumentContentProvider(re,he)},registerTaskProvider:(re,he)=>(me.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),pt.registerTaskProvider(Me,re,he)),registerFileSystemProvider(re,he,Re){return(0,qe.combinedDisposable)(gi.registerFileSystemProvider(Me,re,he,Re),Wt.addFileSystemProvider(re,he))},get fs(){return Wt.value},registerFileSearchProvider:(re,he)=>((0,We.checkProposedApiEnabled)(Me,"fileSearchProvider"),yt.registerFileSearchProvider(re,he)),registerTextSearchProvider:(re,he)=>((0,We.checkProposedApiEnabled)(Me,"textSearchProvider"),yt.registerTextSearchProvider(re,he)),registerRemoteAuthorityResolver:(re,he)=>((0,We.checkProposedApiEnabled)(Me,"resolvers"),Dt.registerRemoteAuthorityResolver(re,he)),registerResourceLabelFormatter:re=>((0,We.checkProposedApiEnabled)(Me,"resolvers"),pi.$registerResourceLabelFormatter(re)),onDidCreateFiles:(re,he,Re)=>zt.onDidCreateFile(re,he,Re),onDidDeleteFiles:(re,he,Re)=>zt.onDidDeleteFile(re,he,Re),onDidRenameFiles:(re,he,Re)=>zt.onDidRenameFile(re,he,Re),onWillCreateFiles:(re,he,Re)=>zt.getOnWillCreateFileEvent(Me)(re,he,Re),onWillDeleteFiles:(re,he,Re)=>zt.getOnWillDeleteFileEvent(Me)(re,he,Re),onWillRenameFiles:(re,he,Re)=>zt.getOnWillRenameFileEvent(Me)(re,he,Re),openTunnel:re=>((0,We.checkProposedApiEnabled)(Me,"resolvers"),we.openTunnel(Me,re).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,We.checkProposedApiEnabled)(Me,"resolvers"),we.getTunnels()},onDidChangeTunnels:(re,he,Re)=>((0,We.checkProposedApiEnabled)(Me,"resolvers"),we.onDidChangeTunnels(re,he,Re)),registerPortAttributesProvider:(re,he)=>((0,We.checkProposedApiEnabled)(Me,"portsAttributes"),we.registerPortsAttributesProvider(re,he)),registerTimelineProvider:(re,he)=>((0,We.checkProposedApiEnabled)(Me,"timeline"),vi.registerTimelineProvider(re,he,Me.identifier,je.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:re=>((0,We.checkProposedApiEnabled)(Me,"workspaceTrust"),ft.requestWorkspaceTrust(re)),onDidGrantWorkspaceTrust:(re,he,Re)=>ft.onDidGrantWorkspaceTrust(re,he,Re)},di={get inputBox(){return me.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),ai.getLastInputBox(Me)},createSourceControl(re,he,Re){return ai.createSourceControl(Me,re,he,Re)}},Bi={createCommentController(re,he){return Pi.createCommentController(Me,re,he)}},zi={get activeDebugSession(){return gt.activeDebugSession},get activeDebugConsole(){return gt.activeDebugConsole},get breakpoints(){return gt.breakpoints},onDidStartDebugSession(re,he,Re){return gt.onDidStartDebugSession(re,he,Re)},onDidTerminateDebugSession(re,he,Re){return gt.onDidTerminateDebugSession(re,he,Re)},onDidChangeActiveDebugSession(re,he,Re){return gt.onDidChangeActiveDebugSession(re,he,Re)},onDidReceiveDebugSessionCustomEvent(re,he,Re){return gt.onDidReceiveDebugSessionCustomEvent(re,he,Re)},onDidChangeBreakpoints(re,he,Re){return gt.onDidChangeBreakpoints(re,he,Re)},registerDebugConfigurationProvider(re,he,Re){return gt.registerDebugConfigurationProvider(re,he,Re||nt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(re,he){return gt.registerDebugAdapterDescriptorFactory(Me,re,he)},registerDebugAdapterTrackerFactory(re,he){return gt.registerDebugAdapterTrackerFactory(re,he)},startDebugging(re,he,Re){return!Re||typeof Re=="object"&&"configuration"in Re?gt.startDebugging(re,he,{parentSession:Re}):gt.startDebugging(re,he,Re||{})},stopDebugging(re){return gt.stopDebugging(re)},addBreakpoints(re){return gt.addBreakpoints(re)},removeBreakpoints(re){return gt.removeBreakpoints(re)},asDebugSourceUri(re,he){return gt.asDebugSourceUri(re,he)}},xi={registerTaskProvider:(re,he)=>pt.registerTaskProvider(Me,re,he),fetchTasks:re=>pt.fetchTasks(re),executeTask:re=>pt.executeTask(Me,re),get taskExecutions(){return pt.taskExecutions},onDidStartTask:(re,he,Re)=>pt.onDidStartTask(re,he,Re),onDidEndTask:(re,he,Re)=>pt.onDidEndTask(re,he,Re),onDidStartTaskProcess:(re,he,Re)=>pt.onDidStartTaskProcess(re,he,Re),onDidEndTaskProcess:(re,he,Re)=>pt.onDidEndTaskProcess(re,he,Re)},$i={createNotebookController(re,he,Re,st,wt){return oi.createNotebookController(Me,re,he,Re,st,(0,We.isProposedApiEnabled)(Me,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(re,he)=>bt.registerNotebookCellStatusBarItemProvider(Me,re,he),createRendererMessaging(re){return ki.createRendererMessaging(Me,re)},onDidChangeNotebookCellExecutionState(re,he,Re){return(0,We.checkProposedApiEnabled)(Me,"notebookCellExecutionState"),oi.onDidChangeNotebookCellExecutionState(re,he,Re)}};return{version:dt.version,authentication:Mi,commands:Li,comments:Bi,debug:zi,env:Ci,extensions:xt,languages:Gt,notebooks:$i,scm:di,tasks:xi,tests:wi,window:Ui,workspace:Mt,Breakpoint:A.Breakpoint,CallHierarchyIncomingCall:A.CallHierarchyIncomingCall,CallHierarchyItem:A.CallHierarchyItem,CallHierarchyOutgoingCall:A.CallHierarchyOutgoingCall,CancellationError:p.CancellationError,CancellationTokenSource:a.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:A.CodeAction,CodeActionKind:A.CodeActionKind,CodeActionTriggerKind:A.CodeActionTriggerKind,CodeLens:A.CodeLens,Color:A.Color,ColorInformation:A.ColorInformation,ColorPresentation:A.ColorPresentation,ColorThemeKind:A.ColorThemeKind,CommentMode:A.CommentMode,CommentThreadCollapsibleState:A.CommentThreadCollapsibleState,CommentThreadState:A.CommentThreadState,CompletionItem:A.CompletionItem,CompletionItemKind:A.CompletionItemKind,CompletionItemTag:A.CompletionItemTag,CompletionList:A.CompletionList,CompletionTriggerKind:A.CompletionTriggerKind,ConfigurationTarget:A.ConfigurationTarget,CustomExecution:A.CustomExecution,DebugAdapterExecutable:A.DebugAdapterExecutable,DebugAdapterInlineImplementation:A.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:A.DebugAdapterNamedPipeServer,DebugAdapterServer:A.DebugAdapterServer,DebugConfigurationProviderTriggerKind:nt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:A.DebugConsoleMode,DecorationRangeBehavior:A.DecorationRangeBehavior,Diagnostic:A.Diagnostic,DiagnosticRelatedInformation:A.DiagnosticRelatedInformation,DiagnosticSeverity:A.DiagnosticSeverity,DiagnosticTag:A.DiagnosticTag,Disposable:A.Disposable,DocumentHighlight:A.DocumentHighlight,DocumentHighlightKind:A.DocumentHighlightKind,DocumentLink:A.DocumentLink,DocumentSymbol:A.DocumentSymbol,EndOfLine:A.EndOfLine,EnvironmentVariableMutatorType:A.EnvironmentVariableMutatorType,EvaluatableExpression:A.EvaluatableExpression,InlineValueText:A.InlineValueText,InlineValueVariableLookup:A.InlineValueVariableLookup,InlineValueEvaluatableExpression:A.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:A.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:A.InlineCompletionTriggerKindNew,EventEmitter:b.Emitter,ExtensionKind:A.ExtensionKind,ExtensionMode:A.ExtensionMode,ExternalUriOpenerPriority:A.ExternalUriOpenerPriority,FileChangeType:A.FileChangeType,FileDecoration:A.FileDecoration,FileSystemError:A.FileSystemError,FileType:y.FileType,FilePermission:y.FilePermission,FoldingRange:A.FoldingRange,FoldingRangeKind:A.FoldingRangeKind,FunctionBreakpoint:A.FunctionBreakpoint,InlineCompletionItem:A.InlineSuggestion,InlineCompletionItemNew:A.InlineSuggestionNew,InlineCompletionList:A.InlineSuggestionList,InlineCompletionListNew:A.InlineSuggestionsNew,Hover:A.Hover,IndentAction:P.IndentAction,Location:A.Location,MarkdownString:A.MarkdownString,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:A.ParameterInformation,PortAutoForwardAction:A.PortAutoForwardAction,Position:A.Position,ProcessExecution:A.ProcessExecution,ProgressLocation:A.ProgressLocation,QuickInputButtons:A.QuickInputButtons,Range:A.Range,RelativePattern:A.RelativePattern,Selection:A.Selection,SelectionRange:A.SelectionRange,SemanticTokens:A.SemanticTokens,SemanticTokensBuilder:A.SemanticTokensBuilder,SemanticTokensEdit:A.SemanticTokensEdit,SemanticTokensEdits:A.SemanticTokensEdits,SemanticTokensLegend:A.SemanticTokensLegend,ShellExecution:A.ShellExecution,ShellQuoting:A.ShellQuoting,SignatureHelp:A.SignatureHelp,SignatureHelpTriggerKind:A.SignatureHelpTriggerKind,SignatureInformation:A.SignatureInformation,SnippetString:A.SnippetString,SourceBreakpoint:A.SourceBreakpoint,StandardTokenType:A.StandardTokenType,StatusBarAlignment:A.StatusBarAlignment,SymbolInformation:A.SymbolInformation,SymbolKind:A.SymbolKind,SymbolTag:A.SymbolTag,Task:A.Task,TaskGroup:A.TaskGroup,TaskPanelKind:A.TaskPanelKind,TaskRevealKind:A.TaskRevealKind,TaskScope:A.TaskScope,TerminalLink:A.TerminalLink,TerminalLocation:A.TerminalLocation,TerminalProfile:A.TerminalProfile,TextDocumentSaveReason:A.TextDocumentSaveReason,TextEdit:A.TextEdit,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:A.TextEditorLineNumbersStyle,TextEditorRevealType:A.TextEditorRevealType,TextEditorSelectionChangeKind:A.TextEditorSelectionChangeKind,TextDocumentChangeReason:A.TextDocumentChangeReason,ThemeColor:A.ThemeColor,ThemeIcon:A.ThemeIcon,TreeItem:A.TreeItem,TreeItemCollapsibleState:A.TreeItemCollapsibleState,TypeHierarchyItem:A.TypeHierarchyItem,UIKind:T.UIKind,Uri:D.URI,ViewColumn:A.ViewColumn,WorkspaceEdit:A.WorkspaceEdit,DocumentDropEdit:A.DocumentDropEdit,DocumentPasteEdit:A.DocumentPasteEdit,InlayHint:A.InlayHint,InlayHintLabelPart:A.InlayHintLabelPart,InlayHintKind:A.InlayHintKind,RemoteAuthorityResolverError:A.RemoteAuthorityResolverError,ResolvedAuthority:A.ResolvedAuthority,SourceControlInputBoxValidationType:A.SourceControlInputBoxValidationType,ExtensionRuntime:A.ExtensionRuntime,TimelineItem:A.TimelineItem,NotebookRange:A.NotebookRange,NotebookCellKind:A.NotebookCellKind,NotebookCellExecutionState:A.NotebookCellExecutionState,NotebookCellData:A.NotebookCellData,NotebookData:A.NotebookData,NotebookRendererScript:A.NotebookRendererScript,NotebookCellStatusBarAlignment:A.NotebookCellStatusBarAlignment,NotebookEditorRevealType:A.NotebookEditorRevealType,NotebookCellOutput:A.NotebookCellOutput,NotebookCellOutputItem:A.NotebookCellOutputItem,NotebookCellStatusBarItem:A.NotebookCellStatusBarItem,NotebookControllerAffinity:A.NotebookControllerAffinity,NotebookEdit:A.NotebookEdit,PortAttributes:A.PortAttributes,LinkedEditingRanges:A.LinkedEditingRanges,TestResultState:A.TestResultState,TestRunRequest:A.TestRunRequest,TestMessage:A.TestMessage,TestTag:A.TestTag,TestRunProfileKind:A.TestRunProfileKind,TextSearchCompleteMessageType:rt.TextSearchCompleteMessageType,DataTransfer:A.DataTransfer,DataTransferItem:A.DataTransferItem,CoveredCount:A.CoveredCount,FileCoverage:A.FileCoverage,StatementCoverage:A.StatementCoverage,BranchCoverage:A.BranchCoverage,FunctionCoverage:A.FunctionCoverage,WorkspaceTrustState:A.WorkspaceTrustState,LanguageStatusSeverity:A.LanguageStatusSeverity,QuickPickItemKind:A.QuickPickItemKind,InputBoxValidationSeverity:A.InputBoxValidationSeverity,TabInputText:A.TextTabInput,TabInputTextDiff:A.TextDiffTabInput,TabInputTextMerge:A.TextMergeTabInput,TabInputCustom:A.CustomEditorTabInput,TabInputNotebook:A.NotebookEditorTabInput,TabInputNotebookDiff:A.NotebookDiffEditorTabInput,TabInputWebview:A.WebviewEditorTabInput,TabInputTerminal:A.TerminalEditorTabInput,TabInputInteractiveWindow:A.InteractiveWindowInput,TerminalExitReason:A.TerminalExitReason}}}e.createApiFactoryAndRegisterActors=kt}),define(ye[237],De([1,0,236,33,2,230,6,14,221,21]),function(ne,e,a,p,b,L,D,k,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class O extends L.RequireInterceptor{_installInterceptor(){}getModule(f,h){for(const d of this._alternatives){const o=d(f);if(o){f=o;break}}if(this._factories.has(f))return this._factories.get(f).load(f,h,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class y extends p.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=D.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(E.ExtHostConsoleForwarder);const f=this._instaService.invokeFunction(a.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(O,f,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(f){return f.browser}async _loadCommonJSModule(f,h,d){h=h.with({path:m(h.path,".js")});const o=f?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const v=b.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(h)),R=await fetch(v.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),R.status!==200)throw new Error(R.statusText);const c=await R.text(),w=`${h.toString(!0)}#vscode-extension`,s=`${c}
//# sourceURL=${w}`;let u;try{u=new Function("module","exports","require",s)}catch(l){throw console.error(o?`Loading code for extension ${o} failed: ${l.message}`:`Loading code failed: ${l.message}`),console.error(`${h.toString(!0)}${typeof l.line=="number"?` line ${l.line}`:""}${typeof l.column=="number"?` column ${l.column}`:""}`),console.error(l),l}const n=await this.fetchTranslatedStrings(f),i={},r={exports:i},t=l=>{if(l==="vscode-nls-web-data")return n;const _=this._fakeModules.getModule(l,h);if(_===void 0)throw new Error(`Cannot load module '${l}'`);return _};try{return d.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),u(r,i,t),r.exports!==i?r.exports:i}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),d.codeLoadingStop()}}async $setRemoteEnvironment(f){}async _waitForDebuggerAttachment(f=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const h=Date.now()+f;for(;Date.now()<h&&!("__jsDebugIsReady"in globalThis);)await(0,k.timeout)(10)}async fetchTranslatedStrings(f){let h={};if(!f)return{};const d=P.Language.isDefaultVariant()?f.browserNlsBundleUris?.en:f.browserNlsBundleUris?.[P.Language.value()]??f.browserNlsBundleUris?.en;if(f&&d)try{const o=await fetch(d.toString(!0));if(!o.ok)throw new Error(await o.text());h=await o.json()}catch(o){try{console.error(`Failed to load translations for ${f.identifier.value} from ${d}: ${o.message}`);const v=f.browserNlsBundleUris?.en;if(v){const R=await fetch(v.toString(!0));if(!R.ok)throw new Error(await R.text());h=await R.json()}throw new Error("No English strings found")}catch(v){console.error(v)}}return h}}e.ExtHostExtensionService=y;function m(T,f){return T.endsWith(f)?T:T+f}}),define(ye[238],De([1,0,56,33,70,237]),function(ne,e,a,p,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(p.IExtHostExtensionService,L.ExtHostExtensionService),(0,a.registerSingleton)(b.IExtensionStoragePaths,b.ExtensionStoragePaths)}),define(ye[247],De([1,0,23,5,94,231,223,19,71,12,2,233,238]),function(ne,e,a,p,b,L,D,k,E,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const y=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const m=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function T(s){return/^(file|vscode-remote):/i.test(s)}const f=fetch.bind(self);function h(s){self.fetch=async function(u,n){return u instanceof Request||T(String(u))&&(u=(await s(O.URI.parse(String(u)))).toString(!0)),f(u,n)},self.XMLHttpRequest=class extends XMLHttpRequest{open(u,n,i,r,t){(async()=>{T(n.toString())&&(n=(await s(O.URI.parse(n.toString()))).toString(!0)),super.open(u,n,i??!0,r,t)})()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const s=self.Worker;Worker=function(u,n){if(/^file:/i.test(u.toString()))u=P.FileAccess.asBrowserUri(O.URI.parse(u.toString())).toString(!0);else if(/^vscode-remote:/i.test(u.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const r=`(${function(g){function C(M){return typeof M=="string"||M instanceof URL?String(M).replace(/^file:\/\//i,"vscode-file://vscode-app"):M}const U=fetch.bind(self);self.fetch=function(M,S){return M instanceof Request?U(M,S):U(C(M),S)},self.XMLHttpRequest=class extends XMLHttpRequest{open(M,S,z,$,F){return super.open(M,C(S),z??!0,$,F)}};const W=importScripts.bind(self);self.importScripts=(...M)=>{W(...M.map(C))},W(g)}.toString()}('${u}'))`;n=n||{},n.name=n.name||k.basename(u.toString());const t=new Blob([r],{type:"application/javascript"}),l=URL.createObjectURL(t);return new s(l,n)}}else self.Worker=class extends D.NestedWorker{constructor(s,u){super(m,s,{name:k.basename(s.toString()),...u})}};const d=new class{constructor(){this.pid=void 0}exit(s){y()}async exists(s){return!0}async realpath(s){return s}};class o{constructor(){const u=new MessageChannel,n=new p.Emitter;let i=!1;m(u.port2,[u.port2]),u.port1.onmessage=r=>{const{data:t}=r;if(!(t instanceof ArrayBuffer)){console.warn("UNKNOWN data received",t);return}const l=a.VSBuffer.wrap(new Uint8Array(t,0,t.byteLength));if((0,b.isMessageOfType)(l,2)){i=!0,R("received terminate message from renderer");return}n.fire(l)},this.protocol={onMessage:n.event,send:r=>{if(!i){const t=r.buffer.buffer.slice(r.buffer.byteOffset,r.buffer.byteOffset+r.buffer.byteLength);u.port1.postMessage(t,[t])}}}}}function v(s){return new Promise(u=>{const n=s.onMessage(i=>{n.dispose();const r=JSON.parse(i.toString());s.send((0,b.createMessageOfType)(0)),u({protocol:s,initData:r})});s.send((0,b.createMessageOfType)(1))})}let R=s=>y();function c(s){return!!s&&typeof s=="object"&&s.type==="vscode.init"&&s.data instanceof Map}function w(){E.mark("code/extHost/willConnectToRenderer");const s=new o;return{onmessage(u){!c(u)||v(s.protocol).then(n=>{E.mark("code/extHost/didWaitForInitData");const i=new L.ExtensionHostMain(n.protocol,n.initData,d,null,u.data);h(r=>i.asBrowserUri(r)),R=r=>i.terminate(r)})}}}e.create=w})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/core/vs/workbench/api/worker/extensionHostWorker.js.map
